1. Nlmix: A Program for Maximum Likelihood Estimation of the Nonlinear
   Mixed Effects Model with a Smooth Random Effects Density.

   Nlmix is a program to estimate the fixed parameters of the nonlinear 
   mixed effects model and the density of the random effects jointly by 
   maximum likelihood.  The density of the random effects is assumed to 
   be smooth but is otherwise unrestricted.  The method uses a series 
   expansion that follows from the smoothness assumption to represent the 
   density and quadrature to compute the likelihood.  Simulation from 
   this representation is easy and may be used as an alternative to 
   quadrature.  Standard algorithms are used for optimization.  Empirical 
   Bayes estimates of random coefficients are obtained by computing 
   posterior modes.  

   Copyright (C) 1991 by Marie Davidian & A. Ronald Gallant. 

   Permission to use, copy, modify, and distribute this software and its 
   documentation for any purpose and without fee is hereby granted, provided 
   that the above copyright notice appear in all copies and that both that 
   copyright notice and this permission notice appear in supporting 
   documentation.  

   This software is provided "as is" without any expressed or implied 
   warranty.  


2. The nlmix source code is in directory pub/arg/nlmix/code.


3. The Nlmix Users Guide, in PostScript, is file nlmix.ps in directory 
   pub/arg/nlmix/guide.  
   
4. Nlmix uses the optimizer NPSOL.  We have been granted permission to 
   distribute NPSOL code in connection with distribution of SNP, a program for 
   nonparametric time series analysis.  As nlmix is layered on top of the SNP 
   code, which is included in the distribution of nlmix, we may distribute in 
   connection with nlmix.  See directory pub/arg/nlmix/npsol  There is no charge 
   but your institution will be required to honor the license agreement.


5. There is a machine dependent parameter eps in the files gaussq.f, mcarlo.f, 
   normalh.f, plot.f, post.f, and quad.f that are set for an IEEE machine,
   such as a Sun SparcStation2, and will need to be changed for machines
   that do not use IEEE floats.
 

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     pstart.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine pstart(vec,lvec)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      real*8 vec
      real*8 zinc
      real*8 objf,objgrd,objmin

      integer*4 i,j
      integer*4 mode
      integer*4 izz

      real*8 pscale

      integer*4 pgrid

      parameter (pscale=2.d0)
      parameter (pgrid=5)

      dimension vec(lvec)
      dimension zinc(mM)
      dimension objgrd(mM)
      dimension izz(mM)

      if (lvec.ne.M) then
        write(3,3001)
        stop
      end if

      mode=0

      do i=1,M
        zinc(i)=pscale*dsqrt(Cz(i*(i+1)/2))/dfloat(pgrid)
      end do

      do i=1,M
        izz(i)=-pgrid
      end do
      izz(1)=izz(1)-1

      do j=1,(2*pgrid+1)**M

        do i=1,M
          if (izz(i).lt.pgrid) then
            izz(i)=izz(i)+1
            go to 10
          else
            izz(i)=-pgrid
          end if
        end do
10      continue

        do i=1,M
          z(i)=Ez(i)+dfloat(izz(i))*zinc(i)
        end do

        call post(mode,M,z,objf,objgrd,1)

        if (j.eq.1) then
          objmin=objf
          do i=1,M
            vec(i)=z(i)
          end do
        end if

        if (objf.lt.objmin) then
          objmin=objf
          do i=1,M
            vec(i)=z(i)
          end do
        end if

      end do

      return
3001  format(1x,'error, pstart, lvec doesn''t equal M')
9001  format(d30.18)
      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     quad.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine quad(mode,lvec,vec,objf,objgrd,nstate)
      implicit  real*8 (a-h,o-z)
      implicit  integer*4 (i-n)
      save

*     Global data

      include "global.f"

*     Local data

      real*8 objf,tmp
      real*8 vec,objgrd
      real*8 T,W,u,work
      real*8 endpts
      real*8 sum,sumdel
      real*8 fobs,factor
      real*8 h,hdel,P,PwA,Pwz,Eh,Ehdel
      real*8 R0
      real*8 weight

      integer*4 mode,lvec,nstate
      integer*4 i,j,ii,jj,isw
      integer*4 izz
      integer*4 lwork

*     Local parameters

      real*8 eps
      real*8 rootpi,root2

      integer*4 mT,mwork

      parameter (eps=1.d-300)
      parameter (rootpi=1.7724538509055160272d0)
      parameter (root2 =1.4142135623730950488d0)
      parameter (mT=130)
      parameter (mwork=500)

      dimension vec(lvec),objgrd(lvec)
      dimension sumdel(mtau+mtheta)
      dimension T(mT),W(mT),u(mM),work(mwork)
      dimension endpts(2)
      dimension izz(mM)
      dimension hdel(mtheta),PwA(mtheta),Pwz(mM),Ehdel(mtheta)
      dimension R0((mM*(mM+1))/2)

*     Error checks

      lwork=M
      if (lwork.gt.mwork) then
        write(3,3001) lwork
        stop
      end if

      lwork=2*ntermz
      if (lwork.gt.mwork) then
        write(3,3001) lwork
        stop
      end if

      lwork=npt
      if (lwork.gt.mwork) then
        write(3,3001) lwork
        stop
      end if

      if (npt.gt.mT) then
        write(3,3002) mT
        stop
      end if

*     Copy parameters NPSOL gets to see to vsav.

      j=0
      do i=1,lvsav
        if (ivec(i).eq.0) then
          j=j+1
          vsav(i)=vec(j)
        end if
      end do 

*     Make tau and theta agree with vsav.

      do i=1,ltau
        tau(i)=vsav(i)
      end do

      do i=1,ltheta
        theta(i)=vsav(ltau+i)
      end do

*     This is an identity to pass to EHYX instead of R.

      do j=1,M
      do i=1,j
        if (i.eq.j) then
          R0(j*(j-1)/2+i)=1.d0
        else
          R0(j*(j-1)/2+i)=0.d0
        end if
      end do
      end do

      if (doCvec.eq.1) then
        do i=1,lvec*lvec
          Cvec(i)=0.d0
        end do
      end if

*     Get Gauss-Hermite quadrature points.

      call gaussq(4,npt,0.d0,0.d0,0,endpts,work,T,W)

      do i=1,npt
        T(i)=root2*T(i)
      end do

      factor=1.d0/(rootpi**M)

*     Compute log likelihood objf and its gradient objgrd.

      fobs=dfloat(nobs)

      objf=0.d0

      do i=1,lvec
        objgrd(i)=0.d0
      end do

      do id=1,ncases

*     Integrate the d density with respect to the SNP density and
*     and store it in sum. 
*     Compute derivatives with respect to the parameters tau and 
*     theta and store them in sumdel.

        sum=0.d0

        do j=1,lvsav
          sumdel(j)=0.d0
        end do

        do i=1,M
          izz(i)=1
        end do
        izz(1)=izz(1)-1

        do j=1,npt**M

          do jj=1,M
            if (izz(jj).lt.npt) then
              izz(jj)=izz(jj)+1
              go to 10
            else
              izz(jj)=1
            end if
          end do
 10       continue

          do jj=1,M
            z(jj)=0.d0
          end do

          do jj=1,M
            u(jj)=T(izz(jj))
            do ii=1,jj
              z(ii)=z(ii)+theta(ibR+jj*(jj-1)/2+ii)*u(jj)
            end do
          end do

          isw=2
          call density(isw)

          call pzx(u,x,P,PwA,Pwz,theta(iaA),
     &      M,L,ntermz,ntermx,work)

          call ehyx(u,x,Eh,Ehdel,
     &      theta(iaA),theta(iaB0),theta(iaB),R0,
     &      M,L,ntermz,ntermx,Kz,Kx,
     &      work)

          h=factor*P/Eh

          do jj=1,lA
            hdel(ibA+jj)
     &        = factor*(PwA(ibA+jj)/Eh - (P/Eh**2)*Ehdel(ibA+jj))
          end do

          weight=1.d0
          do jj=1,M
            weight=weight*W(izz(jj))
          end do

          sum=sum+h*d*weight

          do jj=1,ltau
            sumdel(jj)=sumdel(jj)+h*dwtau(jj)*weight
          end do

          do jj=1,lA
            sumdel(ltau+ibA+jj)=sumdel(ltau+ibA+jj)
     &        + hdel(ibA+jj)*d*weight
          end do

          do jj=1,M
          do ii=1,jj
            sumdel(ltau+ibR+jj*(jj-1)/2+ii)
     &        = sumdel(ltau+ibR+jj*(jj-1)/2+ii)
     &         + h*dwz(ii)*T(izz(jj))*weight
          end do
          end do

        end do

        sum=sum+eps

        objf=objf-dlog(sum)/fobs

        tmp=sum*fobs

        j=0
        do i=1,lvsav
          if (ivec(i).eq.0) then
            j=j+1
            objgrd(j)=objgrd(j)-sumdel(i)/tmp
          end if
        end do

        if (doCvec.eq.1) then

          ii=0
          do i=1,lvsav
          if (ivec(i).eq.0) ii=ii+1
          jj=0
          do j=1,lvsav
          if (ivec(j).eq.0) jj=jj+1

            if ((ivec(i).eq.0).and.(ivec(j).eq.0)) then
              Cvec(lvec*(jj-1)+ii)=Cvec(lvec*(jj-1)+ii)
     &          + (sumdel(i)/sum)*(sumdel(j)/sum)
            end if

          end do
          end do

        end if
  
      end do

      return
3001  format(1x,'error, quad, increase mwork to at least',i5)
3002  format(1x,'error, quad, npt must be less than',i5)
      end

C.hr utility.f
C....*...1.........2.........3.........4.........5.........6.........7.*
C    
C     utility.f
C
C     Copyright (C) 1990.
C
C     A. Ronald Gallant & George E. Tauchen 
C     P.O. Box 5513, Raleigh NC 27650-5513, USA   
C
C     Permission to use, copy, modify, and distribute this
C     software and its documentation for any purpose and
C     without fee is hereby granted, provided that the
C     above copyright notice appear in all copies and that
C     both that copyright notice and this permission notice
C     appear in supporting documentation.
C
C     This software is provided "as is" without any
C     expressed or implied warranty.
C
C....*...1.........2.........3.........4.........5.........6.........7.*
C.hr BLOCK DATA
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     IF DGMPNT OR HEADER ARE COPIED FROM THIS SET OF ROUTINES,
C     BE SURE TO INCLUDE THIS BLOCK DATA PROGRAM IN THE COPY.
C     REMOVE THE COMMENTS IF THESE UTILITIES ARE USED WITH A ROUTINE
C     OTHER THAN NLSYS OR GMM.
      BLOCK DATA
      COMMON /ZLNSIZ/ LNSIZE
      DATA LNSIZE/79/
      END
C.hr DGMPNT
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMPNT   7/16/87
C
C     PURPOSE
C     PRINT A MATRIX.
C
C     USAGE
C     CALL DGMPNT(A,M,N)
C
C     ARGUMENTS
C     A - AN M BY N MATRIX STORED COLUMNWISE (STORAGE MODE 0).
C         REAL*8
C     M - NUMBER OF ROWS IN A
C         INTEGER*4
C     N - NUMBER OF COLUMNS IN A
C         INTEGER*4
C
C     COMMENT
C     THE DEFAULT LINESIZE IS 133, 132 PLUS CARRIAGE CONTROL CHARACTER.
C     THE USAGE:
C     COMMON /ZLNSIZ/ LNSIZE
C     LNSIZE=80
C     WILL CHANGE THE LINESIZE TO 80.  LINESIZES BETWEEN 72 AND 133 ARE
C     PERMITTED.
C
C     PROGRAMMER
C     DR. A. RONALD GALLANT
C     DEPARTMENT OF STATISTICS
C     NORTH CAROLINA STATE UNIVERSITY
C     RALEIGH, NORTH CAROLINA  27695-8203
C
C
      SUBROUTINE DGMPNT(A,M,N)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 START,STOP,OUT
      REAL*8 A(M,N),F
      CHARACTER*1 DIGIT(10),DUMMY(8),COL(9)
      CHARACTER*8 TYPE(14),FMT(13)
      CHARACTER*104 CFMT
      COMMON /ZLNSIZ/ LNSIZE
      EQUIVALENCE (FMT(1),DUMMY(1)),(FMT(1),CFMT)
      SAVE
      DATA FMT   /'(   X,  ',11*'        ','       )'/
      DATA DIGIT /'0','1','2','3','4','5','6','7','8','9'/
      DATA COL   /6*' ','C','O','L'/
      DATA TYPE  /',0PF12.1',',1PD12.4',',0PF12.8',',0PF12.7',
     &            ',0PF12.6',',0PF12.5',',0PF12.4',',0PF12.3',
     &            ',0PF12.2',',0PF12.1',',0PF12.0',',9A1,I3 ',
     &            ' 6X     ','''ROW'',I3'/
      OUT=3
      LNSIZ=LNSIZE
      IF((LNSIZE.LT.72).OR.(LNSIZE.GT.133)) LNSIZ=133
      MAXCOL=(LNSIZ-8)/12
      IF(N.LT.MAXCOL) MAXCOL=N
      IPAD=(LNSIZ-8-12*MAXCOL)/2+1
      IPAD10=IPAD/10
      IPAD1=IPAD-10*IPAD10
      DUMMY(3)=DIGIT(IPAD10+1)
      DUMMY(4)=DIGIT(IPAD1+1)
      START=1
11    STOP=START-1+MAXCOL
      IF(STOP.GT.N) STOP=N
      K=2
      DO 13 J=START,STOP
      K=K+1
13    FMT(K)=TYPE(12)
      FMT(2)=TYPE(13)
      WRITE(OUT,3001)
      WRITE(OUT,3001)
      WRITE(OUT,CFMT) (COL,J,J=START,STOP)
      WRITE(OUT,3001)
      FMT(2)=TYPE(14)
      DO 19 I=1,M
      K=2
      DO 18 J=START,STOP
      K=K+1
      FMT(K)=TYPE(2)
      F=DABS(A(I,J))
      IF(F.LT.1.D+8 ) FMT(K)=TYPE(11)
      IF(F.LT.1.D+5 ) FMT(K)=TYPE(10)
      IF(F.LT.1.D+4 ) FMT(K)=TYPE( 9)
      IF(F.LT.1.D+3 ) FMT(K)=TYPE( 8)
      IF(F.LT.1.D+2 ) FMT(K)=TYPE( 7)
      IF(F.LT.1.D+1 ) FMT(K)=TYPE( 6)
C     IF(F.LT.1.D+0 ) FMT(K)=TYPE( 6)
      IF(F.LT.1.D-1 ) FMT(K)=TYPE( 5)
      IF(F.LT.1.D-2 ) FMT(K)=TYPE( 3)
      IF(F.LT.1.D-4 ) FMT(K)=TYPE( 2)
      IF(F.LT.1.D-55) FMT(K)=TYPE( 1)
18    CONTINUE
19    WRITE(OUT,CFMT) I,(A(I,J),J=START,STOP)
      IF(STOP.EQ.N) RETURN
      START=STOP+1
      GO TO 11
3001  FORMAT(' ')
      END
C.hr HEADER
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     HEADER   7/16/87
C
C     PURPOSE
C     TITLE OUTPUT.
C
C     USAGE
C     CALL HEADER(TITLE)
C
C     ARGUMENTS
C     TITLE - A CHARACTER STRING ENCLOSED IN QUOTES.  THE LAST CHARACTER
C             MUST BE AN UNDERSCORE.  THE STRING IS MADE UP OF AN UN-
C             LIMITED NUMBER OF CONCATONATED LINES.  A LINE IS MADE UP
C             OF 0-68 CHARACTERS FOLLOWED BY A SLASH.
C
C     REMARK
C     AN EXAMPLE IS:
C     CALL HEADER('//LINE 1/LINE 2/LINE 3///_')
C
C     COMMENT
C     THE DEFAULT LINESIZE IS 133, 132 PLUS CARRIAGE CONTROL CHARACTER.
C     THE USAGE:
C     COMMON /ZLNSIZ/ LNSIZE
C     LNSIZE=80
C     WILL CHANGE THE LINESIZE TO 80.  LINESIZES BETWEEN 72 AND 133 ARE
C     PERMITTED.
C
C
      SUBROUTINE HEADER(TITLE)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /ZLNSIZ/ LNSIZE
      CHARACTER*1 DIGIT(10),LDUMMY(8)
      CHARACTER*1 TITLE(1),PRINT(68),SLASH,UNC,LTR,BLANK
      CHARACTER*4 DUMMY(18)
      CHARACTER*8 FMT1(11),FMT2(3),FMT3(3),RDUMMY
      CHARACTER*24 CFMT2,CFMT3
      CHARACTER*88 CFMT1
      EQUIVALENCE (FMT1(1),CFMT1),(FMT2(1),CFMT2),(FMT3,CFMT3)
      EQUIVALENCE (RDUMMY,LDUMMY(1)),(DUMMY(1),PRINT(1))
      SAVE
      DATA FMT1/'(1X,    ','X,70H***',8*'********','***  )  '/
      DATA FMT2/'(1X,    ','X,1H*,17','A4,1H*) '/
      DATA FMT3/'(1X,    ','X,1H*,68','X,1H*)  '/
      DATA DIGIT/'0','1','2','3','4','5','6','7','8','9'/
      DATA SLASH/'/'/,UNC/'_'/,BLANK/' '/
      IOUT=3
      LNSIZ=LNSIZE
      IF((LNSIZE.LT.72).OR.(LNSIZE.GT.133)) LNSIZ=133
      RDUMMY=FMT1(1)
      IPAD=(LNSIZ-72)/2+1
      IPAD10=IPAD/10
      IPAD1=IPAD-10*IPAD10
      LDUMMY(7)=DIGIT(IPAD10+1)
      LDUMMY(8)=DIGIT(IPAD1+1)
      FMT1(1)=RDUMMY
      FMT2(1)=RDUMMY
      FMT3(1)=RDUMMY
      WRITE(IOUT,3001)
      WRITE(IOUT,3001)
      WRITE(IOUT,CFMT1)
      M=0
      L=0
10    M=M+L
      L=0
      DO 20 I=1,69
      LTR=TITLE(M+I)
      IF((LTR.EQ.SLASH).OR.(LTR.EQ.UNC)) GO TO 25
20    L=I
25    IF((L.EQ.0).AND.(LTR.EQ.UNC)) GO TO 50
      IF(L.EQ.0) GO TO 60
      IPAD=(68-L)/2
      DO 30 I=1,68
30    PRINT(I)=BLANK
      DO 40 I=1,L
      JADDR=I+IPAD
40    PRINT(JADDR)=TITLE(M+I)
      WRITE(IOUT,CFMT2) (DUMMY(I),I=1,17)
      L=L+1
      LTR=TITLE(M+L+1)
      IF(LTR.EQ.UNC) GO TO 50
      GO TO 10
50    WRITE(IOUT,CFMT1)
      RETURN
60    WRITE(IOUT,CFMT3)
      L=L+1
      GO TO 10
3001  FORMAT(' ')
      END
C.hr SPACER
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     SPACER   5/10/73
C
C     PURPOSE
C     SPACE OUTPUT
C
C     USAGE
C     CALL SPACER(I)
C
C     ARGUMENT
C     I - NUMBER OF LINES TO BE SKIPPED.  IF I=0 THEN THE PRINTER IS
C         ADVACED TO A NEW PAGE.
C         INTEGER*4
C
C
      SUBROUTINE SPACER(I)
      IF(I.EQ.0) WRITE(3,301)
      IF(I/66.GT.0) WRITE(3,301)
      IF(I.LE.0) RETURN
      M=MOD(I,66)
      DO 10 J=1,M
10    WRITE(3,302)
      RETURN
301   FORMAT('1')
302   FORMAT(' ')
      END
C.hr DSWEEP
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DSWEEP   10/4/72
C
C     PURPOSE
C     INVERT A POSITIVE DEFINITE MATRIX IN PLACE BY A DIAGONAL SWEEP.
C
C     USAGE
C     CALL DSWEEP(A,N,EPS,IER)
C
C     ARGUMENTS
C     A   - SYMMETRIC POSITIVE DEFINITE N BY N MATRIX STORED COLUMNWISE
C           (STORAGE MODE OF 0).  ON RETURN CONTAINS THE INVERSE OF A
C           STORED COLUMNWISE.
C           REAL*8
C     N   - NUMBER OF ROWS AND COLUMNS OF A.
C           INTEGER
C     EPS - INPUT CONSTANT USED AS A RELATIVE TOLERANCE IN TESTING FOR
C           DEGENERATE RANK.  A REASONABLE VALUE FOR EPS IS 1.D-13.
C           REAL*8
C     IER - ERROR PARAMETER CODED AS FOLLOWS
C           IER=0  NO ERROR, RANK OF A IS N.
C           IER.GT.0  A IS SINGULAR, RANK OF A IS N-IER.
C           INTEGER
C
C     REMARK
C     IF IER.GT.0 THEN DSWEEP RETURNS A G-INVERSE.
C
C     REFERENCE
C     SCHATZOFF, M. ET AL.  EFFICIENT CALCULATION OF ALL POSSIBLE REG-
C     RESSIONS.  TECHNOMETRICS, 10. 769-79 (NOVEMBER 1968)
C
C     PROGRAMMER
C     DR. A. RONALD GALLANT
C     DEPARTMANT OF STATISTICS
C     NORTH CAROLINA STATE UNIVERSITY
C     RALEIGH, NORTH CAROLINA  27696-8203
C
C
C
      SUBROUTINE DSWEEP(A,N,EPS,IER)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 A(1)
      TOL=0.D0
      DO 5 I=1,N
      II=N*(I-1)+I
      TEST=A(II)
5     IF(TEST.GT.TOL) TOL=TEST
      TOL=TOL*EPS
      IER=0
      DO 50 K=1,N
      KK=N*(K-1)+K
      AKK=A(KK)
      IF(AKK.GT.TOL) GO TO 20
      DO 10 J=K,N
      KJ=N*(J-1)+K
10    A(KJ)=0.D0
      IF(K.EQ.1) GO TO 16
      KLESS1=K-1
      DO 15 I=1,KLESS1
      IK=KK-I
15    A(IK)=0.D0
16    IER=IER+1
      GO TO 50
20    D=1.D0/AKK
      DO 25 I=1,N
      DO 25 J=I,N
      IF((I.EQ.K).OR.(J.EQ.K)) GO TO 25
      IJ=N*(J-1)+I
      IF(I.LT.K) AIK=A(N*(K-1)+I)
      IF(I.GT.K) AIK=A(N*(I-1)+K)
      IF(K.LT.J) AKJ=A(N*(J-1)+K)
      IF(K.GT.J) AKJ=-A(N*(K-1)+J)
      A(IJ)=A(IJ)-AIK*AKJ*D
25    CONTINUE
      DO 30 J=K,N
      KJ=N*(J-1)+K
30    A(KJ)=A(KJ)*D
      IF(K.EQ.1) GO TO 36
      KLESS1=K-1
      DO 35 I=1,KLESS1
      IK=KK-I
35    A(IK)=-A(IK)*D
36    A(KK)=D
50    CONTINUE
      DO 55 I=1,N
      DO 55 J=I,N
      IF(I.EQ.J) GO TO 55
      IJ=N*(J-1)+I
      JI=N*(I-1)+J
      A(JI)=A(IJ)
55    CONTINUE
      RETURN
      END
C.hr DGMPRD
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMPRD  6/15/83
C
C     PURPOSE
C     MULTIPLY TWO MATRICES: R = A*B
C
C     USAGE
C     CALL DGMPRD(A,B,R,N,M,L)
C
C     ARGUMENTS
C     A - INPUT N BY M MATRIX STORED COLUMNWISE (STORAGE MODE 0)
C         REAL*8
C     B - INPUT M BY L MATRIX STORED COLUMNWISE (STORAGE MODE 0)
C         REAL*8
C     R - OUTPUT N BY L MATRIX STORED COLUMNWISE (STORAGE MODE 0)
C         REAL*8
C     N - NUMBER OF ROWS IN A
C         INTEGER*4
C     M - NUMBER OF COLUMNS IN A AND NUMBER OF ROWS IN A
C         INTEGER*4
C     L - NUMBER OF COLUMNS IN B
C         INTEGER*4
C
C     COMMENT
C     THE ROUTINE IS WRITTEN SO AS TO MINIMIZE THE NUMBER OF PAGE
C     FAULTS IN A VIRTUAL ENVIRONMENT.
C
      SUBROUTINE DGMPRD(A,B,R,N,M,L)
      REAL*8 A(1),B(1),R(1)
C     A(N,M),B(M,L),R(N,L)
      NL=N*L
      DO 10 I=1,NL
10    R(I)=0.D0
      DO 20 J=1,L
      DO 20 K=1,M
      DO 20 I=1,N
20    R(N*(J-1)+I)=R(N*(J-1)+I)+A(N*(K-1)+I)*B(M*(J-1)+K)
      RETURN
      END
C.hr DMCVT
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DMCVT    2/28/74
C
C     PURPOSE
C     CONVERT SYMMETRIC MATRICES FROM STORAGE MODE 0 TO MODE 1 OR FROM
C     STORAGE MODE 1 TO MODE 0.
C
C     USAGE
C     CALL DMCVT(A,R,N,MA,MR)
C
C     ARGUMENTS
C     A  - INPUT SYMMETRIC N BY N MATRIX STORED IN MODE MA.
C          REAL*8
C     R  - OUTPUT COPY OF A STORED IN MODE MR.
C          REAL*8
C     N  - ORDER OF A AND R.
C          INTEGER*4
C     MA - INPUT STORAGE MODE OF A.  MA MUST BE 0 OR 1 ONLY.
C          INTEGER*4
C     MR - INPUT STORAGE MODE OF R.  MR MUST BE 0 OR 1 ONLY.
C          INTEGER*4
C
C     REMARK
C     FOR IN-PLACE CONVERSTION THE USAGE IS:
C     CALL DMCVT(A,A,N,MA,MR)
C
C
C
      SUBROUTINE DMCVT(A,R,N,MA,MR)
      REAL*8 A(1),R(1)
      IF((MA.EQ.0).AND.(MR.EQ.0)) GO TO 40
      IF((MA.EQ.0).AND.(MR.EQ.1)) GO TO 10
      IF((MA.EQ.1).AND.(MR.EQ.0)) GO TO 20
      IF((MA.EQ.1).AND.(MR.EQ.1)) GO TO 50
      RETURN
C
C     CONVERT MODE 0  TO MODE 1
C
10    DO 15 J=1,N
      DO 15 I=1,J
15    R((J*(J-1))/2+I)=A(N*(J-1)+I)
      RETURN
C
C     CONVERT MODE 1 TO MODE 0
C
20    DO 25 JJ=1,N
      J=N-(JJ-1)
      DO 25 II=1,J
      I=J-(II-1)
25    R(N*(J-1)+I)=A((J*(J-1))/2+I)
      DO 30 J=1,N
      DO 30 I=1,J
30    R(N*(I-1)+J)=R(N*(J-1)+I)
      RETURN
C
C     COPY MODE 0 TO MODE 0
C
40    NN=N*N
      DO 45 I=1,NN
45    R(I)=A(I)
      RETURN
C
C     COPY MODE 1 TO MODE 1
C
50    NN=(N*(N-1))/2+N
      DO 55 I=1,NN
55    R(I)=A(I)
      RETURN
      END
C.hr DMFSD
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     SUBROUTINE DMFSD
C
C     PURPOSE
C     FACTOR A GIVEN SYMMETRIC POSITIVE DEFINITE MATRIX
C
C     USAGE
C     CALL DMFSD(A,N,EPS,IER)
C
C     ARGUMENTS
C     A   - UPPER TRIANGULAR PART OF GIVEN SYMMETRIC POSITIVE DEFINITE N
C           BY N MATRIX; ON RETURN, UPPER TRIANGULAR R, A=R'R.
C           REAL*8
C     N   - THE NUMBER OF ROWS (COLUMNS) IN GIVEN MATRIX
C           INTEGER*4
C     EPS - INPUT CONSTANT WHICH IS USED AS RELATIVE TOLERANCE FOR TEST
C           ON LOSS OF SIGNIFICANCE, A REASONABLE VALUE IS 1.D-13.
C           REAL*8
C     IER - ERROR PARAMETER, CODED AS FOLLOWS
C           IER=0  - NO ERROR
C           IER=-1 - NO RESULT BECAUSE OF WRONG INPUT PARAMETER N OR
C                    BECAUSE SOME RADICAND IS NON-POSITIVE (MATRIX A IS
C                    NOT POSITIVE DEFINITE, POSSIBLY DUE TO LOSS OF
C                    SIGNIFICANCE)
C           IER=K  - WARNING WHICH INDICATES LOSS OF SIGNIFICANCE.  THE
C                    RADICAND FORMED AT FACTORIZATION STEP K+1 WAS STILL
C                    POSITIVE BUT NO LONGER GREATER THAN
C                    ABS(EPS*A(K+1,K+1)
C
C     REMARK
C     THIS IS A COPY OF SSP ROUTINE DMFSD
C
      SUBROUTINE DMFSD(A,N,EPS,IER)
      DOUBLE PRECISION EPS,DPIV,DSUM
      DOUBLE PRECISION A(1)
      IF(N-1) 12,1,1
    1 IER=0
      KPIV=0
      DO 11 K=1,N
      KPIV=KPIV+K
      IND=KPIV
      LEND=K-1
      TOL=ABS(SNGL(EPS*A(KPIV)))
      DO 11 I=K,N
      DSUM=0.D0
      IF(LEND) 2,4,2
    2 DO 3 L=1,LEND
      LANF=KPIV-L
      LIND=IND-L
    3 DSUM=DSUM+A(LANF)*A(LIND)
    4 DSUM=A(IND)-DSUM
      IF(I-K) 10,5,10
    5 IF(SNGL(DSUM)-TOL) 6,6,9
    6 IF(DSUM) 12,12,7
    7 IF(IER) 8,8,9
    8 IER=K-1
    9 DPIV=DSQRT(DSUM)
      A(KPIV)=DPIV
      DPIV=1.D0/DPIV
      GO TO 11
   10 A(IND)=DSUM*DPIV
   11 IND=IND+I
      RETURN
   12 IER=-1
      RETURN
      END
C.hr FACTOR
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     FACTOR      12/20/87
C
C     PURPOSE
C     FACTOR A SYMMETRIC POSITIVE DEFINITE MATRIX A = RR' WHERE R IS
C     UPPER TRIANGULAR
C
C     USAGE
C     CALL FACTOR(A,DEL,M,EPS,IER)
C
C     ARGUMENTS
C     A   - ON INPUT CONTAINS THE UPPER TRIANGULAR PART OF A STORED
C           COLUMNWISE (STORAGE MODE 1).
C           ON OUTPUT CONTAINS THE UPPER TRIANGULAR PART OF R STORED
C           COLUMNWISE (STORAGE MODE 1).
C           THE (I,J) ELEMENT OF A IS IN PHYSICAL LOCATION J*(J-1)/2+I
C           WITH I.LE.J; THE TOTAL LENGTH IS M*(M+1)/2. THE SAME FOR R.
C           REAL*8,
C     DEL - ON OUTPUT CONTAINS THE JACOBIAN OF R WITH RESPECT TO A, AN
C           M*(M+1)/2 BY M*(M+1)/2 MATRIX STORED COLUMNWISE (STORAGE
C           MODE 0).  THE DERIVATIVE OF THE (I,J) ELEMENT OF R WITH
C           RESPECT TO THE (K,L) ELEMENT OF A WITH I.LE.J AND K.LE.L
C           IS IN CONCEPTUAL LOCATION (J*(J-1)/2+I,L*(L-1)/2+K) AND IN
C           PHYSICAL LOCATION (M*(M+1)/2)*(J*(J-1)/2+I-1)+L*(L-1)/2+K.
C           REAL*8
C     M   - INPUT, THE NUMBER OF ROWS (COLUMNS) IN A.
C           INTEGER*4
C     EPS - INPUT CONSTANT BETWEEN ZERO AND ONE WHICH IS USED AS
C           RELATIVE TOLERANCE FOR TEST ON LOSS OF SIGNIFICANCE, A
C           REASONABLE VALUE IS 1.D-13.
C           REAL*8
C     IER - OUTPUT ERROR PARAMETER, CODED AS FOLLOWS:
C           IER=0  - NO ERROR.
C           IER=-1 - NO RESULT BECAUSE OF WRONG INPUT PARAMETER M,EPS OR
C                    BECAUSE SOME RADICAND IS NOT POSITIVE (MATRIX A IS
C                    NOT POSITIVE DEFINITE, POSSIBLY DUE TO LOSS OF
C                    SIGNIFICANCE).
C           IER=J  - WARNING WHICH INDICATES LOSS OF SIGNIFICANCE.  THE
C                    RADICAND FORMED AT FACTORIZATION STEP J+1 WAS STILL
C                    POSITIVE BUT NO LONGER GREATER THAN
C                    DABS(EPS*A(J*(J+1)/2)).
C
C     NOTE
C     THE IMPLICIT LOWER PART OF A IS THE TRANSPOSE OF THE UPPER PART.
C     THE IMPLICIT LOWER PART OF R IS ZEROES BELOW THE DIAGONAL.
C
      SUBROUTINE FACTOR(A,DEL,M,EPS,IER)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 A(M*(M+1)/2),DEL(M*(M+1)/2,M*(M+1)/2)
C
      IF (M.LE.0) THEN
      IER=-1
      RETURN
      ENDIF
C
      IF ((EPS.LE.0).OR.(EPS.GE.1.D0)) THEN
      IER=-1
      RETURN
      ENDIF
C
      LA=M*(M+1)/2
C
C     PUT DEL TO THE IDENTITY
C
      DO 10 I=1,LA
      DO 10 J=1,LA
10    DEL(I,J)=0.D0
      DO 20 I=1,LA
20    DEL(I,I)=1.D0
C
C     FACTORIZE; THIS IS A CHOLESKY FACTORIZATION GOTTEN BY WORKING FROM
C     SOUTHEAST TO NORTHWEST TO GET AN UPPER TRIANGULAR MATRIX INSTEAD
C     OF THE TRADITIONAL LOWER TRIANGULAR MATRIX GOTTEN BY WORKING FROM
C     NORTHWEST TO SOUTHEAST.
C
      IER=0
      DO 100 J1=0,M-1
      J=M-J1
      JJ=J*(J+1)/2
C
C     TAKE THE SQUARE ROOT OF AJJ, PUT IT IN AJJ
C
      R=A(JJ)
      IF (R.GT.0.D0) THEN
      R=DSQRT(R)
      A(JJ)=R
      DO 30 L=1,M
      DO 30 K=1,L
      KL=L*(L-1)/2+K
30    DEL(JJ,KL)=(0.5D0/R)*DEL(JJ,KL)
      ELSE
      IER=-1
      RETURN
      ENDIF
C
C     WE ARE FINISHED IF JJ.EQ.1, EQUIVALENTLY IF J.EQ.1
C
      IF (JJ.EQ.1) RETURN
C
C     DIVIDE THE ELEMENTS OF THE COLUMN ABOVE AJJ BY AJJ
C
      DO 50 I=1,J-1
      A(J*(J-1)/2+I)=A(J*(J-1)/2+I)/R
      DO 40 L=1,M
      DO 40 K=1,L
      KL=L*(L-1)/2+K
40    DEL(J*(J-1)/2+I,KL)=DEL(J*(J-1)/2+I,KL)/R
     &                    -(A(J*(J-1)/2+I)/R)*DEL(JJ,KL)
50    CONTINUE
C
C     SWEEP THE NORTHEAST SUBMATRIX
C
      SAVE=A((J-1)*(J)/2)
      DO 70 J0=1,J-1
      DO 70 I0=1,J0
      IJ=J0*(J0-1)/2+I0
      A(IJ)=A(IJ)-A(J*(J-1)/2+I0)*A(J*(J-1)/2+J0)
      DO 60 L=1,M
      DO 60 K=1,L
      KL=L*(L-1)/2+K
60    DEL(IJ,KL)=DEL(IJ,KL)
     &           -A(J*(J-1)/2+I0)*DEL(J*(J-1)/2+J0,KL)
     &           -DEL(J*(J-1)/2+I0,KL)*A(J*(J-1)/2+J0)
70    CONTINUE
C
C     TOLERANCE CHECK
C
      IF(SAVE.LE.0) THEN
      IER=-1
      RETURN
      ENDIF
      IF(A((J-1)*(J)/2).LT.DABS(EPS*SAVE)) IER=J1
C
100   CONTINUE
C
      RETURN
      END
C.hr DGMABP
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMABP   8/20/73
C
C     PURPOSE
C     POSTMULTIPLY A BY THE TRANSPOSE OF B (R=AB').
C
C     USAGE
C     CALL DGMABP(A,B,R,N,M,L)
C
C     ARGUMENTS
C     A - INPUT N BY M MATRIX STORED COLUMNWISE (STORAGE MODE 0).
C         REAL*8
C     B - INPUT L BY M MATRIX STORED COLUMNWISE (STORAGE MODE 0).
C         REAL*8
C     R - OUTPUT N BY L MATRIX STORED COLUMNWISE (STORAGE MODE 0).
C         REAL*8
C     N - NUMBER OF ROWS OF A AND R.
C         INTEGER*4
C     M - NUMBER OF COLUMNS OF A AND B.
C         INTEGER*4
C     L - NUMBER OF ROWS OF B AND COLUMNS OF R.
C         INTEGER*4
C
C
      SUBROUTINE DGMABP(A,B,R,N,M,L)
      REAL*8 A(N,M),B(L,M),R(N,L)
      DO 10 I=1,N
      DO 10 J=1,L
      R(I,J)=0.D0
      DO 10 K=1,M
10    R(I,J)=R(I,J)+A(I,K)*B(J,K)
      RETURN
      END
C.hr DRINV
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     SUBROUTINE DRINV
C
C     PURPOSE
C     INVERT AN UPPPER TRIANGULAR MATRIX.
C
C     USAGE
C     CALL DRINV(A,N)
C
C     ARGUMENTS
C     A - AN N*(N+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF AN UPPER
C         TRIANGULAR MATRIX STORED COLUMNWISE (STORAGE MODE 1).
C         CONTAINS THE MATRIX TO BE INVERTED ON ENTRY AND THE INVERSE,
C         WHICH IS UPPER TRIANGULAR, ON RETURN; REAL*8
C     N - THE NUMBER OF ROWS AND COLUMNS IN A
C         INPUT, INTEGER*4
C
C     REMARK
C     THE ROUTINE ASSUMES THAT THE MATRIX TO BE INVERTED WAS RETURNED BY
C     DMFSD AND DOES NO ERROR CHECKING.  THE CODE WAS LIFTED FROM THE
C     MIDSECTION OF SSP ROUTINE DSINV
C
      SUBROUTINE DRINV(A,N)
      DIMENSION A(1)
      DOUBLE PRECISION A,DIN,WORK
    1 IPIV=N*(N+1)/2
      IND=IPIV
      DO 6 I=1,N
      DIN=1.D0/A(IPIV)
      A(IPIV)=DIN
      MIN=N
      KEND=I-1
      LANF=N-KEND
      IF(KEND) 5,5,2
    2 J=IND
      DO 4 K=1,KEND
      WORK=0.D0
      MIN=MIN-1
      LHOR=IPIV
      LVER=J
      DO 3 L=LANF,MIN
      LVER=LVER+1
      LHOR=LHOR+L
    3 WORK=WORK+A(LVER)*A(LHOR)
      A(J)=-WORK*DIN
    4 J=J-MIN
    5 IPIV=IPIV-MIN
    6 IND=IND-1
    9 RETURN
      END
C.hr DGMFAC
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMFAC      1/16/89 (Drew's twelfth birthday)
C
C     PURPOSE
C     FACTOR A SYMMETRIC, POSITIVE DEFINITE MATRIX AS A = RR' AND FACTOR
C     ITS INVERSE AS INV(A)=P'P WHERE R AND P ARE UPPER TRIANGULAR
C
C     USAGE
C     CALL DGMFAC(A,M,R,P,EPS,IER)
C
C     SUBROUTINES CALLED
C     DMFSD, DRINV
C
C     ARGUMENTS
C     A   - AN M BY M SYMMETRIC, POSITIVE DEFINITE MATRIX STORED
C           COLUMNWISE (STORAGE MODE 0).
C           INPUT, REAL*8
C     R   - FACTOR OF A, A=RR', AN M BY M MATRIX STORED COLUMNWISE
C           (STORAGE MODE 0).
C           OUTPUT, REAL*8
C     P   - FACTOR OF A INVERSE, INV(A)=P'P, AN M BY M MATRIX STORED
C           COLUMNWISE (STORAGE MODE 0).
C           OUTPUT, REAL*8
C     M   - THE NUMBER OF ROWS (COLUMNS) IN A.
C           INPUT, INTEGER*4
C     EPS - CONSTANT BETWEEN ZERO AND ONE WHICH IS USED AS RELATIVE
C           TOLERANCE FOR TEST ON LOSS OF SIGNIFICANCE, A REASONABLE
C           VALUE IS 1.D-13.
C           INPUT, REAL*8
C     IER - OUTPUT ERROR PARAMETER, CODED AS FOLLOWS:
C           IER=0  - NO ERROR.
C           IER=-1 - NO RESULT BECAUSE OF WRONG INPUT PARAMETER M,EPS OR
C                    BECAUSE SOME RADICAND IS NOT POSITIVE (MATRIX A IS
C                    NOT POSITIVE DEFINITE, POSSIBLY DUE TO LOSS OF
C                    SIGNIFICANCE).
C           IER=J  - WARNING WHICH INDICATES LOSS OF SIGNIFICANCE.  THE
C                    RADICAND FORMED AT FACTORIZATION STEP J+1 WAS STILL
C                    POSITIVE BUT NO LONGER GREATER THAN
C                    DABS(EPS*A(J*(J+1)/2)).
C
      SUBROUTINE DGMFAC(A,M,R,P,EPS,IER)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 A(1),R(1),P(1)
C
C     PERMUTE THE ROWS AND COLUMNS OF A AND STORE IN P IN STORAGE MODE 1
C     THE PERMUTAIONS ARE BECAUSE WE FACTOR AS UPPER TRAINGULAR INSTEAD
C     OF THE STANDARD LOWER TRIANGULAR CHOLESKY FACTORIZATION.
C
      DO 10 J=1,M
      JJ=M+1-J
      DO 10 I=J,M
      II=M+1-I
10    P(JJ*(JJ-1)/2+II)=A(M*(J-1)+I)
C
C     COMPUTE THE CHOLESKY FACTORIZATION
C
      CALL DMFSD(P,M,EPS,IER)
      IF (IER.LT.0) RETURN
C
C     UNDO THE PERMUTATIONS AND PUT THE FACTOR IN R IN STORAGE MODE 1
C
      DO 20 J=1,M
      JJ=M+1-J
      DO 20 I=1,J
      II=M+1-I
20    R(J*(J-1)/2+I)=P(II*(II-1)/2+JJ)
C
C     COPY R TO P AND INVERT P
C
      DO 30 I=1,M*(M+1)/2
30    P(I)=R(I)
      CALL DRINV(P,M)
C
C     R AND P ARE IN COMPRESSED FORM, STORAGE MODE 1.  EXPAND TO
C     STORAGE MODE 0
C
      DO 40 JJ=1,M
      J=M+1-JJ
      DO 40 II=JJ,M
      I=M+1-II
      R(M*(J-1)+I)=R(J*(J-1)/2+I)
40    P(M*(J-1)+I)=P(J*(J-1)/2+I)
C
      DO 50 J=1,M
      DO 50 I=J,M
      IF(I.NE.J) THEN
         R(M*(J-1)+I)=0.D0
         P(M*(J-1)+I)=0.D0
         ENDIF
50    CONTINUE
C
      RETURN
      END
C.hr DGMABA
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMABA  6/20/87 (ANNIVERSARY)
C
C     PURPOSE
C     COMPUTE THE QUADRATIC FORM: R = A'BA.
C
C     USAGE
C     CALL DGMABA(A,B,R,N,M)
C
C     ARGUMENTS
C     A - INPUT N BY M MATRIX STORED COLUMNWISE (STORAGE MODE 0)
C         REAL*8
C     B - INPUT N BY N MATRIX STORED COLUMNWISE (STORAGE MODE 0)
C         REAL*8
C     R - OUTPUT M BY M MATRIX STORED COLUMNWISE (STORAGE MODE 0)
C         REAL*8
C     N - NUMBER OF ROWS IN A
C         INTEGER*4
C     M - NUMBER OF COLUMNS IN A
C         INTEGER*4
C
      SUBROUTINE DGMABA(A,B,R,N,M)
      REAL*8 A(1),B(1),R(1),ACC
C     A(N,M),B(N,N),R(M,M)
      DO 20 JJ=1,M
      DO 20 II=1,JJ
      ACC=0.D0
      DO 10 J=1,N
      DO 10 I=1,N
10    ACC=ACC+A(N*(JJ-1)+I)*A(N*(II-1)+J)*B(N*(J-1)+I)
      R(M*(II-1)+JJ)=ACC
20    R(M*(JJ-1)+II)=ACC
      RETURN
      END
C.hr DGMTRA
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMTRA 8/23/73
C
C     PURPOSE
C     DOUBLE PRECISION VERSION OF SSP GMTRA
C
      SUBROUTINE DGMTRA(A,R,N,M)
      REAL*8 A(1),R(1)
      DO 10 I=1,N
      DO 10 J=1,M
 10   R((I-1)*M+J)=A((J-1)*N+I)
      RETURN
      END
C.hr DGMADD
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMADD  10/16/71
C
C     PURPOSE
C     DOUBLE PRECISION VERSION OF SSP GMADD
C
      SUBROUTINE DGMADD(A,B,R,N,M)
      REAL*8 A(1),B(1),R(1)
      NM=N*M
      DO 10 I=1,NM
10    R(I)=A(I)+B(I)
      RETURN
      END
C.hr DGMSUB
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DGMSUB  10/16/71
C
C     PURPOSE
C     DOUBLE PRECISION VERSION OF SSP GMSUB
C
      SUBROUTINE DGMSUB(A,B,R,M,N)
      REAL*8 A(1),B(1),R(1)
      NM=N*M
      DO 10 I=1,NM
10    R(I)=A(I)-B(I)
      RETURN
      END
C.hr DCOND2
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     DCOND2    5/15/74
C
C     PURPOSE
C     IMPROVE ACCURACY OF DSWEEP WHEN DIAGONAL ELEMENTS OF A ARE NOT OF
C     THE SAME ORDER OF MAGNITUDE.
C
C     USAGE
C     CALL DCOND2(A,N,S,0)
C     CALL DSWEEP(A,N,EPS,IER)
C     CALL DCOND2(A,N,S,1)
C
C     ARGUMENTS
C     A   - SYMMETRIC POSITIVE DEFINITE N BY N MATRIX STORED COLUMNWISE.
C           (STORAGE MODE 0)
C           REAL*8
C     N   - NUMBER OF ROWS AND COLUMNS OF A.  LENGTH OF S.
C           INTEGER*4
C     S   - WORK VECTOR OF LENGTH N.
C           REAL*8
C     ISW - INTEGER SWITCH.
C           INTEGER*4
C
C     REMARK
C     THE USAGE
C     CALL DCOND2(A,N,S,0)
C     WILL RETURN A CORRELATION MATRIX IN A AND THE STANDARD ERRORS IN
C     S WHEN A IS A VARIANCE-COVARIANCE MATRIX.
C
C
C
      SUBROUTINE DCOND2(A,N,S,ISW)
      REAL*8 A(N,N),S(N)
      IF(ISW.EQ.1) GO TO 20
      DO 10 I=1,N
10    S(I)=DSQRT(A(I,I))
20    DO 30 I=1,N
      DO 30 J=1,N
30    IF(S(I)*S(J).NE.0.D0)
     &A(I,J)=A(I,J)/(S(I)*S(J))
      RETURN
      END

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  mcsubs.f
*
*     mchpar   mcenvn   mcenv2   mcstor   mcmin    mcclos   mcopen
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE MCHPAR()

C***********************************************************************
C     MCHPAR  must define certain machine parameters as follows:
C
C     wmach(1)  = NBASE  = base of floating-point arithmetic.
C     wmach(2)  = NDIGIT = no. of base wmach(1) digits of precision.
C     wmach(3)  = EPS    = floating-point precision.
C     wmach(4)  = RTEPS  = sqrt(EPS).
C     wmach(5)  = RMIN   = smallest positive normalized floating-point
C                          number.
C     wmach(6)  = RTRMIN = sqrt(RMIN).
C     wmach(7)  = BIG    = a very large number that can be represented
C                          without overflow. BIG is equal to 1.0/SMALL,
C                          where SMALL is a small number for which the
C                          machine can evaluate  1.0/SMALL  without
C                          causing overflow.
C     wmach(8)  = RTBIG  = sqrt(BIG).
C     wmach(9)  = UNDFLW = 0 if underflow is not fatal, +ve otherwise.
C                          (not implemented in post-1982 versions).
C     wmach(10) = NIN    = standard file number of the input stream.
C     wmach(11) = NOUT   = standard file number of the output stream.
C***********************************************************************
      double precision   wmach
      common    /solmch/ wmach(15)
      save      /solmch/

      logical            first , hdwire
      integer            emin  , nbase , ndigit, nin   , nout

      double precision   base  , eps   , big   , rmin
      double precision   small , undflw
      external           mcenv2
      intrinsic          sqrt
      save               first
      data               first / .true. /


      if (first) then
         first = .false.

*        ---------------------------------------------------------------
*        Machine-dependent code.
*        1. Set UNDFLW, NIN, NOUT, HDWIRE as desired.
*        2. If  HDWIRE = .TRUE.  set the machine constants
*               NBASE, NDIGIT, EPS, RMIN, BIG
*           in-line.  Otherwise, they will be computed by MCENVN.
*        ---------------------------------------------------------------
         undflw = 0
*        nin    = 5
         nin    = 1
*        nout   = 6
         nout   = 3
*        hdwire = .false.
         hdwire = .true.

         if (hdwire) then

*           IEEE standard floating-point arithmetic.
*           (Rounded arithmetic is mandated).

            nbase  = 2
            ndigit = 52
            base   = nbase
            eps    = base**(- ndigit)
            rmin   = base**(- 126)
            big    = base**(+ 127)
         else
            call mcenvn( nbase, ndigit, eps, emin, rmin )
            small  = rmin*nbase**4
            big    = 1.0d0/small
         end if

         wmach( 1) = nbase
         wmach( 2) = ndigit
         wmach( 3) = eps
         wmach( 4) = sqrt( eps )
         wmach( 5) = rmin
         wmach( 6) = sqrt( rmin )
         wmach( 7) = big
         wmach( 8) = sqrt( big )
         wmach( 9) = undflw
         wmach(10) = nin
         wmach(11) = nout
      end if

      return

*     end of  mchpar.

      end
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine mcenvn( beta, t, eps, emin, rmin )
C     ------------------------------------------------------------------
C     Based on NAG Mark 1.0 release ENVIRN.
C
C     MCENVN returns the machine parameters given by:
C
C        BETA - INTEGER.
C               The base of the machine.
C
C        T    - INTEGER.
C               The number of ( BETA ) digits in the mantissa.
C
C        EPS  - REAL.
C               The smallest positive number such that
C
C                  fl( 1.0 - EPS ) .lt. 1.0,
C
C               where fl denotes the computed value.
C
C        EMIN - INTEGER.
C               The minimum exponent before (gradual) underflow occurs.
C
C        RMIN - REAL.
C               The smallest normalized number for the machine given by
C               BASE**( EMIN - 1 ), where BASE is the floating point
C               value of BETA.
C
C
C     The computation of EPS, EMIN and RMIN is based on a routine,
C     PARANOIA by W. Kahan of the University of California at Berkeley.
C
C
C     Nag Fortran 77 O( 1 ) basic linear algebra routine (ENVIRN).
C
C     -- Written on 2-June-1987.
C     Sven Hammarling, Mick Pont and Janet Welding, Nag Central Office.
C     Modified by PEG, 7-Aug-1990.
C     ------------------------------------------------------------------
      double precision   eps, rmin
      integer            beta, emin, t

      double precision   a, b, leps, lrmin, one, rbase, small, two, zero
      integer            gnmin, gpmin, i, lbeta, lemin, lt, ngnmin,
     *                   ngpmin, nout
      logical            first, iwarn, lrnd

      double precision   mcstor
      external           mcstor

      external           mcenv2, mcmin

      intrinsic          abs, max, min

      common    /sol1cm/ nout

      save               first, iwarn, lbeta, lemin, leps, lrmin, lt

      data               first/.true./, iwarn/.false./

      if (first) then
         first = .false.
         zero  = 0
         one   = 1
         two   = 2

*        LBETA, LT, LEPS, LEMIN and LRMIN are the local values of BETA,
*        T, EPS, EMIN and RMIN.
*
*        Throughout this routine we use the function MCSTOR to ensure
*        that relevant values are stored and not held in registers, or
*        are not affected by optimizers.
*
*        MCENV2 returns the parameters LBETA and LT. ( LRND is not used
*        here. )

         call mcenv2( lbeta, lt, lrnd )

*        Start to find EPS.

         b = lbeta
         if (lrnd) then
            leps = (b**(1-lt))/two
         else
            leps = b**(1-lt)
         end if

*        Computation of EPS complete. Now find EMIN.
*        Let a = + or - 1, and + or - (1 + base**(-3)).
*        Keep dividing a by BETA until (gradual) underflow occurs.
*        This is detected when we cannot recover the previous a.

         rbase = one/lbeta
         small = one
         do 20, i = 1, 3
            small = mcstor( small*rbase, zero )
   20    continue
         a     = mcstor( one, small )
         call mcmin ( ngpmin,  one, lbeta )
         call mcmin ( ngnmin, -one, lbeta )
         call mcmin ( gpmin ,    a, lbeta )
         call mcmin ( gnmin ,   -a, lbeta )

         if (ngpmin .eq. ngnmin  .and.  gpmin .eq. gnmin) then

            if (ngpmin .eq. gpmin) then
               lemin = ngpmin
*              ( Non twos-complement machines, no gradual underflow;
*              eg VAX )
            else if (gpmin-ngpmin .eq. 3) then
               lemin = ngpmin - 1 + lt
*              ( Non twos-complement machines, with gradual underflow;
*              eg IEEE standard followers )
            else
               lemin = min( ngpmin, gpmin )
*              ( A guess; no known machine )
               iwarn = .true.
            end if

         else if (ngpmin .eq. gpmin .and. ngnmin .eq. gnmin) then
            if (abs( ngpmin-ngnmin ) .eq. 1) then
               lemin = max( ngpmin, ngnmin )
*              ( Twos-complement machines, no gradual underflow;
*              eg Cyber 205 )
            else
               lemin = min( ngpmin, ngnmin )
*              ( A guess; no known machine )
               iwarn = .true.
            end if

         else if (abs(ngpmin-ngnmin) .eq. 1 .and. gpmin .eq. gnmin) then
            if (gpmin-min( ngpmin, ngnmin ) .eq. 3) then
               lemin = max( ngpmin, ngnmin ) - 1 + lt
*              ( Twos-complement machines with gradual underflow;
*              no known machine )
            else
               lemin = max( ngpmin, ngnmin )
*              ( A guess; no known machine )
               iwarn = .true.
            end if
         else
            lemin = min( ngpmin, ngnmin, gpmin, gnmin )
*           ( A guess; no known machine )
            iwarn = .true.
         end if
*        **
*        Comment out this IF block if Emin is ok
         if (iwarn) then
            first = .true.
            write (nout,fmt=99999) lemin
         end if
*        **

*        Finally compute RMIN by successive division by BETA.
*        We could compute RMIN as base**( EMIN - 1 ), but some machines
*        underflow during this computation.

         lrmin = 1
         do 40, i = 1, 1 - lemin
            lrmin = lrmin/lbeta
   40    continue
      end if

      beta  = lbeta
      t     = lt
      eps   = leps
      emin  = lemin
      rmin  = lrmin
      return

*     End of mcenvn (envirn).

99999 format( // ' WARNING. The value Emin may be incorrect:-  Emin = ',
     $           I8 / ' If, after inspection, the value Emin looks',
     $           ' acceptable please comment out ' / ' the IF block',
     $           ' as marked within the code of routine MCENVN,' /
     $           ' otherwise contact UCSD. ' / )
      end
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine mcenv2( beta, t, rnd )
C     ------------------------------------------------------------------
C     Based on NAG Mark 1.0 release ENVRON.
C
C     MCENV2 returns the machine parameters given by:
C
C        BETA - INTEGER.
C               The base of the machine.
C
C        T    - INTEGER.
C               The number of ( BETA ) digits in the mantissa.
C
C        RND  - LOGICAL.
C               Whether proper rounding ( RND = .TRUE. ) or chopping
C               ( RND = .FALSE. ) occurs in addition. This may not be a
C               reliable guide to the way in which the machine perfoms
C               its arithmetic.
C
C     The routine is based on the routine of the same name by Malcolm
C     and incorporates suggestions by Gentleman and Marovich. See
C
C        Malcolm M. A. (1972) Algorithms to reveal properties of
C           floating-point arithmetic. Comms. of the ACM, 15, 949-951.
C
C        Gentleman W. M. and Marovich S. B. (1974) More on algorithms
C           that reveal properties of floating point arithmetic units.
C           Comms. of the ACM, 17, 276-277.
C
C
C     Nag Fortran 77 O( 1 ) basic linear algebra routine (envron).
C
C     -- Written on 26-November-1984.
C     Sven Hammarling and Mick Pont, Nag Central Office.
C     Modified by PEG, 7-Aug-1990.
C     ------------------------------------------------------------------
      integer            beta, t
      logical            rnd

      double precision   a, b, c, c1, c2, f, one, qtr, sava
      integer            lbeta, lt
      logical            first, lrnd

      double precision   mcstor
      external           mcstor

      save               first, lbeta, lrnd, lt

      data               first/.true./


      if (first) then
         first = .false.
         one   = 1

*        LBETA, LT and LRND are the local values of BETA, T and RND.
*
*        Throughout this routine we use the function MCSTOR to ensure
*        that relevant values are stored and not held in registers, or
*        are not affected by optimizers.
*
*        Compute  a = 2.0**m  with the smallest positive integer m such
*        that
*
*           fl( a + 1.0 ) = a.

         a  = 1
         c  = 1

*       +       while( c .eq. one )loop
   20    if (c .eq. one) then
            a  = 2*a
            c  = mcstor( a, one )
            c  = mcstor( c, -a  )
            go to 20
         end if
*       +       end while

*        Now compute  b = 2.0**m  with the smallest positive integer m
*        such that
*
*           fl( a + b ) .gt. a.

         b  = 1
         c  = mcstor( a, b )

*       +       while( c .eq. a )loop
   40    if (c .eq. a) then
            b  = 2*b
            c  = mcstor( a, b )
            go to 40
         end if
*       +       end while

*        Now compute the base. a and b are neighbouring floating point
*        numbers in the interval ( beta**t, beta**( t + 1 ) ) and so
*        their difference is beta. Adding 0.25 to c is to ensure that it
*        is truncated to beta and not ( beta - 1 ).

         qtr   = one/4
         c     = mcstor( c, -a )
         lbeta = c + qtr

*        Now determine whether rounding or chopping occurs, by adding
*        a bit less than beta/2 and a bit more than beta/2 to a.

         b    = lbeta
         f    = mcstor( b/2, -b/100 )
         c1   = mcstor( f  ,  a     )
         f    = mcstor( b/2,  b/100 )
         c2   = mcstor( f  ,  a     )
         sava = a

*        Now find the mantissa, t. It should be the integer part of
*        log to the base beta of a, however it is safer to determine t
*        by powering. So we find t as the smallest positive integer
*        for which
*
*           fl( beta**t + 1.0 ) = 1.0.

         lt = 0
         a  = 1
         c  = 1

*        +       while( c .eq. one )loop
   60    if (c .eq. one) then
            lt  = lt + 1
            a   = a*lbeta
            c   = mcstor( a, one )
            c   = mcstor( c,  -a )
            go to 60
         end if
*        +       end while

         lrnd = c1 .eq. sava  .and.  c2 .ne. sava
      end if

      beta = lbeta
      t    = lt
      rnd  = lrnd

      return

*     End of mcenv2 (envron).

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      double precision function mcstor( a, b )
C     ------------------------------------------------------------------
C     Based on NAG Mark 1.0 release.
C
C     MCSTOR is intended to force A and B to be stored prior to doing the
C     addition of A and B. For use in situations where optimizers might
C     hold one of these in a register.
C
C
C     Nag Fortran 77 O( 1 ) basic linear algebra routine (mcstor).
C
C     -- Written on 28-November-1984.
C     Sven Hammarling, Nag Central Office.
C     ------------------------------------------------------------------
      double precision                a, b

      mcstor = a + b

      return

C     end of mcstor.

      end
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine mcmin ( emin, start, base )
C     ------------------------------------------------------------------
C     Based on NAG Mark 1.0 release.
C
C     Service routine for ENVIRN (mcenv2).
C
C
C     Nag Fortran 77 O( 1 ) basic linear algebra routine (getmin).
C
C     -- Written on 2-June-1987.
C     Mick Pont, Nag Central Office.
C     ------------------------------------------------------------------
      double precision   start
      integer            base, emin

      double precision   a, b1, b2, c1, c2, d1, d2, one, rbase, zero
      integer            i

      double precision   mcstor
      external           mcstor

      a     = start
      one   = 1
      rbase = one/base
      zero  = 0
      emin  = 1
      b1    = mcstor( a*rbase, zero )
      c1    = a
      c2    = a
      d1    = a
      d2    = a


   20 if ((c1 .eq. a)  .and.  (c2 .eq. a)  .and.
     $    (d1 .eq. a)  .and.  (d2 .eq. a)      ) then
         emin = emin - 1
         a    = b1
         b1   = mcstor(  a/base, zero )
         c1   = mcstor( b1*base, zero )
         d1   = zero
         do 40, i = 1, base
            d1 = d1 + b1
   40    continue
         b2   = mcstor(  a*rbase, zero )
         c2   = mcstor( b2/rbase, zero )
         d2   = zero
         do 60, i = 1, base
            d2 = d2 + b2
   60    continue
         go to 20
      end if

      return
      
*     End of mcmin (getmin).

      end
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine mcclos( lun )

C***********************************************************************
C     MCCLOS  closes the file with logical unit number LUN.
C
C***********************************************************************

      close ( lun )

*     end of mcclos.
      end
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine mcopen( lun )

C***********************************************************************
C     MCOPEN  opens the file with logical unit number LUN.
C
C***********************************************************************

      open( lun, status='unknown' )

*     end of mcopen.
      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  QRSUBS FORTRAN
*
*     DGEQR    DGEQRP   DGEAP    DGEAPQ
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE DGEQR ( M, N, A, LDA, ZETA, INFORM )
      INTEGER            M, N, LDA, INFORM
      DOUBLE PRECISION   A( LDA, * ), ZETA( * )
C
C  1. Purpose
C     =======
C
C  DGEQR  reduces the  m by n, m.ge.n, matrix A to upper triangular form
C  by means of orthogonal transformations.
C
C  2. Description
C     ===========
C
C  The m by n matrix A is factorized as
C
C     A = Q*( R )   when   m.gt.n,
C           ( 0 )
C
C     A = Q*R       when   m = n,
C
C  where  Q  is an  m by m  orthogonal matrix and  R  is an n by n upper
C  triangular matrix.
C
C  The  factorization  is  obtained  by  Householder's  method. The  kth
C  transformation matrix, Q( k ), which is used to introduce zeros  into
C  the kth column of A is given in the form
C
C     Q( k ) = ( I     0   ),
C              ( 0  T( k ) )
C
C  where
C
C     T( k ) = I - u( k )*u( k )',   u( k ) = ( zeta( k ) ),
C                                             (    z( k ) )
C
C  zeta( k )  is a scalar and  z( k )  is an  ( m - k )  element vector.
C  zeta( k )  and  z( k ) are chosen to annhilate the elements below the
C  triangular part of  A.
C
C  The vector  u( k )  is returned in the kth element of ZETA and in the
C  kth column of A, such that zeta( k ) is in ZETA( k ) and the elements
C  of z( k ) are in a( k + 1, k ), ..., a( m, k ). The elements of R are
C  returned in the upper triangular part of  A.
C
C  Q is given by
C
C     Q = ( Q( p )*Q( p - 1 )*...*Q( 1 ) )',
C
C  where p = min( n, m - 1 ).
C
C  3. Parameters
C     ==========
C
C  M      - INTEGER.
C
C           On entry, M must specify the number of rows of  A. M must be
C           at least  n.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C
C           On entry, N must specify the number of columns of  A. N must
C           be  at  least zero. When  N = 0  then an immediate return is
C           effected.
C
C           Unchanged on exit.
C
C  A      - 'real' array of DIMENSION ( LDA, n ).
C
C           Before entry, the leading  M by N  part of the array  A must
C           contain the matrix to be factorized.
C
C           On exit, the  N by N upper triangular part of A will contain
C           the  upper  triangular  matrix  R  and the  M by N  strictly
C           lower triangular part of  A  will  contain  details  of  the
C           factorization as described above.
C
C  LDA    - INTEGER.
C
C           On entry, LDA  must  specify  the  leading dimension of  the
C           array  A  as declared in the calling (sub) program. LDA must
C           be at least  m.
C
C           Unchanged on exit.
C
C  ZETA   - 'real' array of DIMENSION at least ( n ).
C
C           On  exit, ZETA( k )  contains the scalar  zeta( k )  for the
C           kth  transformation.  If  T( k ) = I  then   ZETA( k ) = 0.0
C           otherwise  ZETA( k )  contains  zeta( k ) as described above
C           and is always in the range ( 1.0, sqrt( 2.0 ) ).
C
C  INFORM - INTEGER.
C
C           On successful  exit  INFORM  will be zero, otherwise  INFORM
C           will  be set to unity indicating that an input parameter has
C           been  incorrectly  set. See  the  next section  for  further
C           details.
C
C  4. Diagnostic Information
C     ======================
C
C  INFORM = 1
C
C     One or more of the following conditions holds:
C
C        M   .lt. N
C        N   .lt. 0
C        LDA .lt. M
C
C  5. Further information
C     ===================
C
C  Following the use of this routine the operations
C
C     B := Q'*B   and   B := Q*B,
C
C  where  B  is an  m by k  matrix, can  be  performed  by calls to  the
C  auxiliary  linear  algebra routine  DGEAPQ. The  operation  B := Q'*B
C  can be obtained by the call:
C
C     INFORM = 0
C     CALL DGEAPQ( 'Transpose', 'Separate', M, N, A, LDA, ZETA,
C    $             K, B, LDB, WORK, INFORM )
C
C  and  B := Q*B  can be obtained by the call:
C
C     INFORM = 0
C     CALL DGEAPQ( 'No transpose', 'Separate', M, N, A, LDA, ZETA,
C    $             K, B, LDB, WORK, INFORM )
C
C  In  both  cases  WORK  must be a  k  element array  that  is used  as
C  workspace. If  B  is a one-dimensional array (single column) then the
C  parameter  LDB  can be replaced by  M. See routine DGEAPQ for further
C  details.
C
C  Operations involving the matrix  R  are performed by  the
C  Level 2 BLAS  routines  DTRMV  and DTRSV . Note that no test for near
C  singularity of R is incorporated in this routine or in routine  DTRSV
C  and  so it is  strongly recommended that the auxiliary linear algebra
C  routine  DUTCO  be called, prior to solving equations involving R, in
C  order  to determine whether  or not  R  is nearly singular. If  R  is
C  nearly  singular  then  the  auxiliary linear algebra  routine  DUTSV
C  can  be used to  determine  the  singular value decomposition  of  R.
C
C
C  Nag Fortran 77 Auxiliary linear algebra routine.
C
C  -- Written on 13-December-1984.
C     Sven Hammarling, Nag Central Office.
C
      EXTERNAL           DGEMV , DGER  , DGRFG
      INTRINSIC          MIN
      INTEGER            K     , LA
      DOUBLE PRECISION   TEMP
      DOUBLE PRECISION   ONE   ,         ZERO
      PARAMETER        ( ONE   = 1.0D+0, ZERO  = 0.0D+0 )

*     Check the input parameters.

      IF( N.EQ.0 )THEN
         INFORM = 0
         RETURN
      END IF
      IF( ( M.LT.N ).OR.( N.LT.0 ).OR.( LDA.LT.M ) )THEN
         INFORM = 1
         RETURN
      END IF

*     Perform the factorization.

      LA = LDA
      DO 20, K = 1, MIN( M - 1, N )

*        Use a Householder reflection to zero the kth column of A.
*        First set up the reflection.

         CALL DGRFG ( M - K, A( K, K ), A( K + 1, K ), 1, ZERO,
     $                ZETA( K ) )
         IF( ( ZETA( K ).GT.ZERO ).AND.( K.LT.N ) )THEN
            IF( ( K + 1 ).EQ.N )
     $         LA = M - K + 1
            TEMP      = A( K, K )
            A( K, K ) = ZETA( K )

*           We now perform the operation  A := Q( k )*A.

*           Let B denote the bottom ( m - k + 1 ) by ( n - k ) part
*           of A.

*           First form  work = B'*u. ( work is stored in the elements
*           ZETA( k + 1 ), ..., ZETA( n ). )

            CALL DGEMV ( 'Transpose', M - K + 1, N - K,
     $                   ONE, A( K, K + 1 ), LA, A( K, K ), 1,
     $                   ZERO, ZETA( K + 1 ), 1 )

*           Now form  B := B - u*work'.

            CALL DGER  ( M - K + 1, N - K, -ONE, A( K, K ), 1,
     $                   ZETA( K + 1 ), 1, A( K, K + 1 ), LA )

*           Restore beta.

            A( K, K ) = TEMP
         END IF
   20 CONTINUE

*     Store the final zeta when m.eq.n.

      IF( M.EQ.N )
     $   ZETA( N ) = ZERO

      INFORM = 0
      RETURN

*     End of DGEQR .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE DGEQRP( PIVOT, M, N, A, LDA, ZETA, PERM, WORK, INFORM )
      CHARACTER*1        PIVOT
      INTEGER            M, N, LDA, INFORM
      INTEGER            PERM( * )
      DOUBLE PRECISION   A( LDA, * ), ZETA( * ), WORK( * )

      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

C  1. Purpose
C     =======
C
C  DGEQRP reduces the  m by n matrix A to upper triangular form by means
C  of orthogonal transformations and column permutations.
C
C  2. Description
C     ===========
C
C  The m by n matrix A is factorized as
C
C     A = Q*( R )*P'      when   m.gt.n,
C           ( 0 )
C
C     A = Q*R*P'          when   m = n,
C
C     A = Q*( R  X )*P'   when   m.lt.n,
C
C  where  Q  is  an  m by m  orthogonal matrix, R  is a  min( m, n )  by
C  min( m, n )  upper triangular matrix and  P is an  n by n permutation
C  matrix.
C
C  The  factorization  is  obtained  by  Householder's  method. The  kth
C  transformation matrix, Q( k ),  which is used to introduce zeros into
C  the kth column of A is given in the form
C
C     Q( k ) = ( I     0   ),
C              ( 0  T( k ) )
C
C  where
C
C     T( k ) = I - u( k )*u( k )',   u( k ) = ( zeta( k ) ),
C                                             (    z( k ) )
C
C  zeta( k )  is a scalar and  z( k )  is an  ( m - k )  element vector.
C  zeta( k )  and  z( k ) are chosen to annhilate the elements below the
C  triangular part of  A.
C
C  The vector  u( k )  is returned in the kth element of ZETA and in the
C  kth column of A, such that zeta( k ) is in ZETA( k ) and the elements
C  of z( k ) are in a( k + 1, k ), ..., a( m, k ). The elements of R are
C  returned in the upper triangular part of A.
C
C  Q is given by
C
C     Q = ( Q( p )*Q( p - 1 )*...*Q( 1 ) )',
C
C  where p = min( m - 1, n ).
C
C  Two options are available for the column permutations. In either case
C  the column for which the  sub-diagonal elements are to be annihilated
C  at the  kth step is chosen from the remaining ( n - k + 1 )  columns.
C  The  particular column chosen as the pivot column is either that  for
C  which  the  unreduced  part  ( elements k onwards )  has the  largest
C  Euclidean  length, or  is that for  which the ratio of the  Euclidean
C  length  of the  unreduced part  to the  Euclidean length of the whole
C  column is a maximum.
C
C  3. Parameters
C     ==========
C
C  PIVOT  - CHARACTER*1.
C
C           On  entry, PIVOT  specifies  the  pivoting  strategy  to  be
C           performed as follows.
C
C           PIVOT = 'C' or 'c'
C
C              Column  interchanges  are  to be  incorporated  into  the
C              factorization, such that the  column whose unreduced part
C              has  maximum  Euclidean  length  is chosen  as the  pivot
C              column at each step.
C
C           PIVOT = 'S' or 's'
C
C              Scaled  column interchanges  are to be  incorporated into
C              the  factorization, such  that the  column for which  the
C              ratio  of the  Euclidean  length of the unreduced part of
C              the column to the original Euclidean length of the column
C              is a maximum is chosen as the  pivot column at each step.
C
C           Unchanged on exit.
C
C  M      - INTEGER.
C
C           On entry, M  must specify the number of rows of A. M must be
C           at  least  zero. When  M = 0  then  an  immediate return  is
C           effected.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C
C           On entry, N  must specify the number of columns of A. N must
C           be  at least zero. When  N = 0  then an immediate return  is
C           effected.
C
C           Unchanged on exit.
C
C  A      - 'real' array of DIMENSION ( LDA, n ).
C
C           Before entry, the leading  M by N  part of the array  A must
C           contain the matrix to be factorized.
C
C           On  exit, the  min( M, N ) by min( M, N )  upper  triangular
C           part of A will contain the upper triangular matrix R and the
C           M by min( M, N )  strictly lower triangular part of  A  will
C           contain details  of the  factorization  as  described above.
C           When m.lt.n then the remaining M by ( N - M ) part of A will
C           contain the matrix X.
C
C  LDA    - INTEGER.
C
C           On  entry, LDA  must  specify  the leading dimension of  the
C           array  A  as declared in the calling (sub) program. LDA must
C           be at least  m.
C
C           Unchanged on exit.
C
C  ZETA   - 'real' array of DIMENSION at least ( n ).
C
C           On exit, ZETA( k )  contains the scalar  zeta  for  the  kth
C           transformation. If T( k ) = I then ZETA( k) = 0.0, otherwise
C           ZETA( k )  contains the scalar  zeta( k ) as described above
C           and  is  always  in  the  range  ( 1.0, sqrt( 2.0 ) ).  When
C           n .gt. m  the  elements  ZETA( m + 1 ),  ZETA( m + 2 ), ...,
C           ZETA( n )  are used as internal workspace.
C
C  PERM   - INTEGER array of DIMENSION at least min( m, n ).
C
C           On exit, PERM  contains details of the permutation matrix P,
C           such  that  PERM( k ) = k  if no  column interchange occured
C           at  the  kth  step  and  PERM( k ) = j, ( k .lt. j .le. n ),
C           if  columns  k and j  were  interchanged at  the  kth  step.
C           Note  that, although  there are  min( m - 1, n )  orthogonal
C           transformations, there are min( m, n ) permutations.
C
C  WORK   - 'real' array of DIMENSION at least ( 2*n ).
C
C           Used as internal workspace.
C
C           On exit, WORK( j ), j = 1, 2, ..., n, contains the Euclidean
C           length  of the  jth  column  of the  permuted  matrix  A*P'.
C
C  INFORM - INTEGER.
C
C           On  successful exit, INFORM  will be zero, otherwise  INFORM
C           will  be set to unity indicating that an input parameter has
C           been  incorrectly supplied. See the next section for further
C           details.
C
C  4. Diagnostic Information
C     ======================
C
C  INFORM = 1
C
C     One or more of the following conditions holds:
C
C        PIVOT .ne. 'C' or 'c' or 'S' or 's'
C        M     .lt. 0
C        N     .lt. 0
C        LDA   .lt. M
C
C  5. Further information
C     ===================
C
C  Following the use of this routine the operations
C
C     B := Q'*B   and   B := Q*B,
C
C  where  B  is an  m by k  matrix, can  be  performed  by calls to  the
C  auxiliary  linear algebra  routine  DGEAPQ. The  operation  B := Q'*B
C  can be obtained by the call:
C
C     INFORM = 0
C     CALL DGEAPQ( 'Transpose', 'Separate', M, N, A, LDA, ZETA,
C    $             K, B, LDB, WORK, INFORM )
C
C  and  B := Q*B  can be obtained by the call:
C
C     INFORM = 0
C     CALL DGEAPQ( 'No transpose', 'Separate', M, N, A, LDA, ZETA,
C    $             K, B, LDB, WORK, INFORM )
C
C  In  both  cases  WORK  must be  a  k  element array  that is used  as
C  workspace. If B is a one-dimensional array ( single column ) then the
C  parameter  LDB  can be replaced by  M. See routine DGEAPQ for further
C  details.
C
C  Also following the use of this routine the operations
C
C     B := P'*B   and   B := P*B,
C
C  where B is an n by k matrix, and the operations
C
C     B := B*P    and   B := B*P',
C
C  where  B is a k by n  matrix, can  be performed by calls to the basic
C  linear  algebra  routine  DGEAP .  The  operation  B := P'*B  can  be
C  obtained by the call:
C
C     CALL DGEAP ( 'Left', 'Transpose', N, MIN( M, N ), PERM,
C    $             K, B, LDB )
C
C  the operation  B := P*B  can be obtained by the call:
C
C     CALL DGEAP ( 'Left', 'No transpose', N, MIN( M, N ), PERM,
C    $             K, B, LDB )
C
C  If  B is a one-dimensional array ( single column ) then the parameter
C  LDB  can be replaced by  N  in the above two calls.
C  The operation  B := B*P  can be obtained by the call:
C
C     CALL DGEAP ( 'Right', 'No transpose', K, MIN( M, N ), PERM,
C    $             M, B, LDB )
C
C  and  B := B*P'  can be obtained by the call:
C
C     CALL DGEAP ( 'Right', 'Transpose', K, MIN( M, N ), PERM,
C    $             M, B, LDB )
C
C  If  B is a one-dimensional array ( single column ) then the parameter
C  LDB  can be replaced by  K  in the above two calls.
C  See routine DGEAP for further details.
C
C  Operations involving  the matrix  R  are performed by  the
C  Level 2 BLAS  routines  DTRSV  and DTRMV.  Note that no test for near
C  singularity of  R is incorporated in this routine or in routine DTRSV
C  and  so it is  strongly recommended that the auxiliary linear algebra
C  routine  DUTCO  be called, prior to solving equations involving R, in
C  order  to determine whether  or not  R  is nearly singular. If  R  is
C  nearly  singular then  the  auxiliary  linear algebra  routine  DUTSV
C  can  be  used  to  determine  the  singular value decomposition of R.
C  Operations  involving  the  matrix  X  can also be  performed  by the
C  Level 2  BLAS  routines.  Matrices  of  the  form   ( R  X )  can  be
C  factorized as
C
C     ( R  X ) = ( T  0 )*S',
C
C  where  T is upper triangular and S is orthogonal, using the auxiliary
C  linear algebra routine  DUTRQ .
C
C
C  Nag Fortran 77 Auxiliary linear algebra routine.
C
C  -- Written on 13-December-1984.
C     Sven Hammarling, Nag Central Office.
C
      EXTERNAL           MCHPAR, DGEMV , DGER  , DGRFG , DNRM2 , DSWAP
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      INTEGER            J     , JMAX  , K     , LA
      DOUBLE PRECISION   EPS   , MAXNRM, NORM  , DNRM2 , TEMP  , TOL
      DOUBLE PRECISION   LAMDA
      PARAMETER        ( LAMDA = 1.0D-2 )
      DOUBLE PRECISION   ONE   ,         ZERO
      PARAMETER        ( ONE   = 1.0D+0, ZERO  = 0.0D+0 )

*     Check the input parameters.

      IF( MIN( M, N ).EQ.0 )THEN
         INFORM = 0
         RETURN
      END IF
      IF( ( ( PIVOT.NE.'C' ).AND.( PIVOT.NE.'c' ).AND.
     $      ( PIVOT.NE.'S' ).AND.( PIVOT.NE.'s' )      ).OR.
     $    ( M.LT.0 ).OR.( N.LT.0 ).OR.( LDA.LT.M )           )THEN
         INFORM = 1
         RETURN
      END IF

*     Compute eps and the initial column norms.

      CALL MCHPAR()
      EPS = WMACH( 3 )
      DO 10, J = 1, N
         WORK( J )     = DNRM2 ( M, A( 1, J ), 1 )
         WORK( J + N ) = WORK( J )
   10 CONTINUE

*     Perform the factorization. TOL is the tolerance for DGRFG .

      LA = LDA
      DO 50, K = 1, MIN( M, N )

*        Find the pivot column.

         MAXNRM = ZERO
         JMAX   = K
         DO 20, J = K, N
            IF( ( PIVOT.EQ.'C' ).OR.( PIVOT.EQ.'c' ) )THEN
               IF( WORK( J + N  ).GT.MAXNRM )THEN
                  MAXNRM = WORK( J + N )
                  JMAX   = J
               END IF
            ELSE IF( WORK( J ).GT.ZERO )THEN
               IF( ( WORK( J + N )/WORK( J ) ).GT.MAXNRM )THEN
                  MAXNRM = WORK( J + N )/WORK( J )
                  JMAX   = J
               END IF
            END IF
   20    CONTINUE
         PERM( K ) = JMAX
         IF( JMAX.GT.K )THEN
            CALL DSWAP ( M, A( 1, K ), 1, A( 1, JMAX ), 1 )
            TEMP             = WORK( K )
            WORK( K )        = WORK( JMAX )
            WORK( JMAX )     = TEMP
            WORK( JMAX + N ) = WORK( K + N )
            PERM( K )        = JMAX
         END IF
         TOL = EPS*WORK( K )
         IF( K.LT.M )THEN

*           Use a Householder reflection to zero the kth column of A.
*           First set up the reflection.

            CALL DGRFG ( M - K, A( K, K ), A( K + 1, K ), 1, TOL,
     $                   ZETA( K ) )
            IF( K.LT.N )THEN
               IF( ZETA( K ).GT.ZERO )THEN
                  IF( ( K + 1 ).EQ.N )
     $               LA = M - K + 1
                  TEMP      = A( K, K )
                  A( K, K ) = ZETA( K )

*                 We now perform the operation  A := Q( k )*A.

*                 Let B denote the bottom ( m - k + 1 ) by ( n - k )
*                 part of A.

*                 First form  work = B'*u. ( work is stored in the
*                 elements ZETA( k + 1 ), ..., ZETA( n ). )

                  CALL DGEMV ( 'Transpose', M - K + 1, N - K,
     $                         ONE, A( K, K + 1 ), LA, A( K, K ), 1,
     $                         ZERO, ZETA( K + 1 ), 1 )

*                 Now form  B := B - u*work'.

                  CALL DGER  ( M - K + 1, N - K, -ONE, A( K, K ), 1,
     $                         ZETA( K + 1 ), 1, A( K, K + 1 ), LA )

*                 Restore beta.

                  A( K, K ) = TEMP
               END IF

*              Update the unreduced column norms. Use the Linpack
*              criterion for when to recompute the norms, except that
*              we retain the original column lengths throughout and use
*              a smaller lamda.

               DO 40, J = K + 1, N
                  IF( WORK( J + N ).GT.ZERO )THEN
                     TEMP = ABS( A( K, J ) )/WORK( J + N )
                     TEMP = MAX( ( ONE + TEMP )*( ONE - TEMP ), ZERO )
                     NORM = TEMP
                     TEMP = ONE +
     $                      LAMDA*TEMP*( WORK( J + N )/WORK( J ) )**2
                     IF( TEMP.GT.ONE )THEN
                        WORK( J + N ) = WORK( J + N )*SQRT( NORM )
                     ELSE
                        WORK( J + N ) = DNRM2 ( M - K,
     $                                          A( K + 1, J ), 1 )
                     END IF
                  END IF
   40          CONTINUE
            END IF
         END IF
   50 CONTINUE

*     Store the final zeta when m.le.n.

      IF( M.LE.N )
     $   ZETA( M ) = ZERO

      INFORM = 0
      RETURN

*     End of DGEQRP.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE DGEAP ( SIDE, TRANS, M, N, PERM, K, B, LDB )
*     .. Scalar Arguments ..
      INTEGER            K, LDB, M, N
      CHARACTER*1        SIDE, TRANS
*     .. Array Arguments ..
      DOUBLE PRECISION   B( LDB, * )
      INTEGER            PERM( * )
*     ..
*
*  Purpose
*  =======
*
*  DGEAP  performs one of the transformations
*
*     B := P'*B   or   B := P*B,   where B is an m by k matrix,
*
*  or
*
*     B := B*P'   or   B := B*P,   where B is a k by m matrix,
*
*  P being an m by m permutation matrix of the form
*
*     P = P( 1, index( 1 ) )*P( 2, index( 2 ) )*...*P( n, index( n ) ),
*
*  where  P( i, index( i ) ) is the permutation matrix that interchanges
*  items i and index( i ). That is P( i, index( i ) ) is the unit matrix
*  with rows and columns  i and index( i )  interchanged.  Of course, if
*  index( i ) = i  then  P( i, index( i ) ) = I.
*
*  This routine  is intended for use in  conjunction with  Nag auxiliary
*  routines that  perform  interchange  operations,  such  as  pivoting.
*
*  Parameters
*  ==========
*
*  SIDE   - CHARACTER*1.
*  TRANS
*           On entry,  SIDE  ( Left-hand side, or Right-hand side )  and
*           TRANS  ( Transpose, or No transpose )  specify the operation
*           to be performed as follows.
*
*           SIDE = 'L' or 'l'   and   TRANS = 'T' or 't'
*
*              Perform the operation   B := P'*B.
*
*           SIDE = 'L' or 'l'   and   TRANS = 'N' or 'n'
*
*              Perform the operation   B := P*B.
*
*           SIDE = 'R' or 'r'   and   TRANS = 'T' or 't'
*
*              Perform the operation   B := B*P'.
*
*           SIDE = 'R' or 'r'   and   TRANS = 'N' or 'n'
*
*              Perform the operation   B := B*P.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*
*           On entry, M must specify the order of the permutation matrix
*           P.  M must be at least zero.  When  M = 0  then an immediate
*           return is effected.
*
*           Unchanged on exit.
*
*  N      - INTEGER.
*
*           On entry,  N must specify the value of n. N must be at least
*           zero.  When  N = 0  then an  immediate  return is  effected.
*
*           Unchanged on exit.
*
*  PERM   - INTEGER array of DIMENSION at least ( n ).
*
*           Before  entry,  PERM  must  contain the  n  indices  for the
*           permutation matrices. index( i ) must satisfy
*
*              1 .le. index( i ) .le. m.
*
*           It is usual for index( i ) to be at least i, but this is not
*           necessary for this routine.
*
*           Unchanged on exit.
*
*  K      - INTEGER.
*
*           On entry with  SIDE = 'L' or 'l',  K must specify the number
*           of columns of B and on entry with  SIDE = 'R' or 'r', K must
*           specify the  number of rows of B.  K must be at least  zero.
*           When  K = 0  then an immediate return is effected.
*
*           Unchanged on exit.
*
*  B      - DOUBLE PRECISION array of  DIMENSION  ( LDB, ncolb ),  where
*           ncolb = k   when   SIDE = 'L' or 'l'  and   ncolb = m   when
*           SIDE = 'R' or 'r'.
*
*           Before entry  with  SIDE = 'L' or 'l',  the  leading  M by K
*           part  of  the  array   B  must  contain  the  matrix  to  be
*           transformed  and  before entry with  SIDE = 'R' or 'r',  the
*           leading  K by M part of the array  B must contain the matrix
*           to  be  transformed.  On  exit,  B  is  overwritten  by  the
*           transformed matrix.
*
*  LDB    - INTEGER.
*
*           On entry,  LDB  must specify  the  leading dimension  of the
*           array  B  as declared  in the  calling  (sub) program.  When
*           SIDE = 'L' or 'l'   then  LDB  must  be  at  least  m,  when
*           SIDE = 'R' or 'r'   then  LDB  must  be  at  least  k.
*           Unchanged on exit.
*
*
*  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
*
*  -- Written on 13-January-1986.
*     Sven Hammarling, Nag Central Office.
*
*
*     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, J, L
      LOGICAL            LEFT, NULL, RIGHT, TRNSP
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     ..
*     .. Executable Statements ..
      IF( MIN( M, N, K ).EQ.0 )
     $   RETURN
      LEFT  = ( SIDE .EQ.'L' ).OR.( SIDE .EQ.'l' )
      RIGHT = ( SIDE .EQ.'R' ).OR.( SIDE .EQ.'r' )
      NULL  = ( TRANS.EQ.'N' ).OR.( TRANS.EQ.'n' )
      TRNSP = ( TRANS.EQ.'T' ).OR.( TRANS.EQ.'t' )
      IF( LEFT )THEN
         IF( TRNSP )THEN
            DO 20, I = 1, N
               IF( PERM( I ).NE.I )THEN
                  L = PERM( I )
                  DO 10, J = 1, K
                     TEMP      = B( I, J )
                     B( I, J ) = B( L, J )
                     B( L, J ) = TEMP
   10             CONTINUE
               END IF
   20       CONTINUE
         ELSE IF( NULL )THEN
            DO 40, I = N, 1, -1
               IF( PERM( I ).NE.I )THEN
                  L = PERM( I )
                  DO 30, J = 1, K
                     TEMP      = B( L, J )
                     B( L, J ) = B( I, J )
                     B( I, J ) = TEMP
   30             CONTINUE
               END IF
   40       CONTINUE
         END IF
      ELSE IF( RIGHT )THEN
         IF( TRNSP )THEN
            DO 60, J = 1, N
               IF( PERM( J ).NE.J )THEN
                  L = PERM( J )
                  DO 50, I = 1, K
                     TEMP      = B( I, J )
                     B( I, J ) = B( L, J )
                     B( L, J ) = TEMP
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE IF( NULL )THEN
            DO 80, J = N, 1, -1
               IF( PERM( J ).NE.J )THEN
                  L = PERM( J )
                  DO 70, I = 1, K
                     TEMP      = B( L, J )
                     B( L, J ) = B( I, J )
                     B( I, J ) = TEMP
   70             CONTINUE
               END IF
   80       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of DGEAP . ( F06QJF )
*
      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE DGEAPQ( TRANS, WHEREZ, M, N, A, LDA, ZETA,
     $                   NCOLB, B, LDB, WORK, INFORM )
      CHARACTER*1        TRANS, WHEREZ
      INTEGER            M, N, LDA, NCOLB, LDB, INFORM
      DOUBLE PRECISION   A( LDA, * ), ZETA( * ), B( LDB, * ), WORK( * )
C
C  1. Purpose
C     =======
C
C  DGEAPQ performs one of the transformations
C
C     B := Q'*B   or   B := Q*B,
C
C  where B is an m by ncolb matrix and Q is an m by m orthogonal matrix,
C  given as the product of  Householder transformation matrices, details
C  of  which are stored in the  m by n ( m.ge.n )  array  A  and, if the
C  parameter  WHEREZ = 'S' or 's', in the array ZETA.
C
C  This  routine is  intended for use following auxiliary linear algebra
C  routines such as  DGEQR , DGEHES and DSLTRI. ( See those routines for
C  example calls. )
C
C  2. Description
C     ===========
C
C  Q is assumed to be given by
C
C     Q = ( Q( p )*Q( p - 1 )*...*Q( 1 ) )',
C
C  Q( k ) being given in the form
C
C     Q( k ) = ( I     0   ),
C              ( 0  T( k ) )
C
C  where
C
C     T( k ) = I - u( k )*u( k )',   u( k ) = ( zeta( k ) ),
C                                             (    z( k ) )
C
C  zeta( k )  is a scalar and  z( k )  is an  ( m - k )  element vector.
C
C  z( k )  must  be  supplied  in  the  kth  column  of  A  in  elements
C  a( k + 1, k ), ..., a( m, k )  and  zeta( k ) must be supplied either
C  in  a( k, k )  or in  zeta( k ), depending upon the parameter WHEREZ.
C
C  To obtain Q explicitly B may be set to I and premultiplied by Q. This
C  is more efficient than obtaining Q'.
C
C  3. Parameters
C     ==========
C
C  TRANS  - CHARACTER*1.
C
C           On entry, TRANS  specifies the operation to be performed  as
C           follows.
C
C           TRANS = ' ' or 'N' or 'n'
C
C              Perform the operation  B := Q*B.
C
C           TRANS = 'T' or 't' or 'C' or 'c'
C
C              Perform the operation  B := Q'*B.
C
C           Unchanged on exit.
C
C  WHEREZ - CHARACTER*1.
C
C           On entry, WHEREZ specifies where the elements of zeta are to
C           be found as follows.
C
C           WHEREZ = 'I' or 'i'
C
C              The elements of zeta are in A.
C
C           WHEREZ = 'S' or 's'
C
C              The elements of zeta are separate from A, in ZETA.
C
C           Unchanged on exit.
C
C  M      - INTEGER.
C
C           On entry, M  must specify the number of rows of A. M must be
C           at least n.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C
C           On entry, N  must specify the number of columns of A. N must
C           be  at least zero. When  N = 0  then an immediate return  is
C           effected.
C
C           Unchanged on exit.
C
C  A      - 'real' array of DIMENSION ( LDA, n ).
C
C           Before entry, the leading  M by N  stricly lower  triangular
C           part of the array  A  must contain details of the matrix  Q.
C           In  addition, when  WHEREZ = 'I' or 'i'  then  the  diagonal
C           elements of A must contain the elements of zeta.
C
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C
C           On  entry, LDA  must specify  the leading dimension  of  the
C           array  A  as declared in the calling (sub) program. LDA must
C           be at least m.
C
C           Unchanged on exit.
C
C  ZETA   - 'real' array of DIMENSION at least min( m - 1, n ).
C
C           Before entry with  WHEREZ = 'S' or 's', the array  ZETA must
C           contain the elements of the vector  zeta.
C
C           When  WHEREZ = 'I' or 'i', the array ZETA is not referenced.
C
C           Unchanged on exit.
C
C  NCOLB  - INTEGER.
C
C           On  entry, NCOLB  must specify  the number of columns of  B.
C           NCOLB  must  be  at  least  zero.  When  NCOLB = 0  then  an
C           immediate return is effected.
C
C           Unchanged on exit.
C
C  B      - 'real' array of DIMENSION ( LDB, ncolb ).
C
C           Before entry, the leading  M by NCOLB  part of  the array  B
C           must  contain  the matrix to be  transformed.
C
C           On  exit,  B  is  overwritten  by  the  transformed  matrix.
C
C  LDB    - INTEGER.
C
C           On  entry, LDB  must specify  the  leading dimension of  the
C           array  B as declared in the calling (sub) program. LDB  must
C           be at least m.
C
C           Unchanged on exit.
C
C  WORK   - 'real' array of DIMENSION at least ( ncolb ).
C
C           Used as internal workspace.
C
C  INFORM - INTEGER.
C
C           On  successful exit  INFORM  will be zero, otherwise  INFORM
C           will  be set to unity indicating that an input parameter has
C           been  incorrectly  set. See  the  next  section  for further
C           details.
C
C  4. Diagnostic Information
C     ======================
C
C  INFORM = 1
C
C     One or more of the following conditions holds:
C
C        TRANS  .ne. ' ' or 'N' or 'n' or 'T' or 't' or 'C' or 'c'
C        WHEREZ .ne. 'I' or 'i' or 'S' or 's'
C        M      .lt. N
C        N      .lt. 0
C        LDA    .lt. M
C        NCOLB  .lt. 0
C        LDB    .lt. M
C
C
C  Nag Fortran 77 Auxiliary linear algebra routine.
C
C  -- Written on 15-November-1984.
C     Sven Hammarling, Nag Central Office.
C
      EXTERNAL           DGEMV , DGER
      INTRINSIC          MIN
      INTEGER            J     , K     , KK    , LB
      DOUBLE PRECISION   TEMP
      DOUBLE PRECISION   ONE   ,         ZERO
      PARAMETER        ( ONE   = 1.0D+0, ZERO  = 0.0D+0 )

*     Check the input parameters.

      IF( MIN( N, NCOLB ).EQ.0 )THEN
         INFORM = 0
         RETURN
      END IF
      IF( ( ( TRANS .NE.' ' ).AND.
     $      ( TRANS .NE.'N' ).AND.( TRANS .NE.'n' ).AND.
     $      ( TRANS .NE.'T' ).AND.( TRANS .NE.'t' ).AND.
     $      ( TRANS .NE.'C' ).AND.( TRANS .NE.'c' )      ).OR.
     $    ( ( WHEREZ.NE.'I' ).AND.( WHEREZ.NE.'i' ).AND.
     $      ( WHEREZ.NE.'S' ).AND.( WHEREZ.NE.'s' )      ).OR.
     $    ( M.LT.N ).OR.( N.LT.0 ).OR.( LDA.LT.M ).OR.
     $    ( NCOLB.LT.0 ).OR.( LDB.LT.M )                      )THEN
         INFORM = 1
         RETURN
      END IF

*     Perform the transformation.

      LB = LDB
      DO 20, KK = 1, MIN( M - 1, N )
         IF( ( TRANS.EQ.'T' ).OR.( TRANS.EQ.'t' ).OR.
     $       ( TRANS.EQ.'C' ).OR.( TRANS.EQ.'c' )     )THEN

*           Q'*B = Q( p )*...*Q( 2 )*Q( 1 )*B,     p = min( m - 1, n ).

            K = KK
         ELSE

*           Q*B  = Q( 1 )'*Q( 2 )'*...*Q( p )'*B,  p = min( m - 1, n ).
*           Note that  Q( k )' = Q( k ).

            K = MIN( N, M - 1 ) + 1 - KK
         END IF
         IF( ( WHEREZ.EQ.'S' ).OR.( WHEREZ.EQ.'s' ) )THEN
            TEMP      = A( K, K )
            A( K, K ) = ZETA( K )
         END IF

*        If ZETA( k ) is zero then Q( k ) = I and we can skip the kth
*        transformation.

         IF( A( K, K ).GT.ZERO )THEN
            IF( NCOLB.EQ.1 )
     $         LB = M - K + 1

*           Let C denote the bottom ( m - k + 1 ) by ncolb part of B.

*           First form  work = C'*u.

            DO 10, J = 1, NCOLB
               WORK( J ) = ZERO
   10       CONTINUE
            CALL DGEMV ( 'Transpose', M - K + 1, NCOLB,
     $                   ONE, B( K, 1 ), LB, A( K, K ), 1,
     $                   ZERO, WORK, 1 )

*           Now form  C := C - u*work'.

            CALL DGER  ( M - K + 1, NCOLB, -ONE, A( K, K ), 1,
     $                   WORK, 1, B( K, 1 ), LB )
         END IF

*        Restore the diagonal element of A.

         IF( ( WHEREZ.EQ.'S' ).OR.( WHEREZ.EQ.'s' ) )
     $      A( K, K ) = TEMP
   20 CONTINUE

      INFORM = 0
      RETURN

*     End of DGEAPQ.

      END

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     normal.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine normal(x,O,S,f,fwO,fwS)
      implicit real*8 (a-h,o-z) 
      implicit integer*4 (i-n)
      save
      real*8    x,O,S,f,fwO,fwS,pi,top,bot
      real*8    V,fwV,VwS
      parameter (pi=0.3141592653589793D+01)
      V=S**2
      VwS=2.d0*S
      top=dexp(-0.5d0*(x-O)**2/V)
      bot=dsqrt(2.d0*pi*V)
      f=top/bot
      fwO = top*((x-O)/V)/bot
      fwV = top*(0.5d0*(x-O)**2/(V*V))/bot 
     &      + (-top/(bot*bot))*(0.5d0/bot)*(2.d0*pi)
      fwS=fwV*VwS
      return
      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  CMSUBS FORTRAN
*
*     CMALF1   CMALF    CMCHK    CMPERM   CMPRT    CMQMUL   CMR1MD
*     CMRSWP   CMTSOL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMALF1( FIRSTV, NEGSTP, BIGALF, BIGBND, PNORM,
     $                   JADD1 , JADD2 , PALFA1, PALFA2,
     $                   ISTATE, N, LDA, NCTOTL,
     $                   ANORM, AP, AX, BL, BU, FEATOL, P, X )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            FIRSTV, NEGSTP
      INTEGER            ISTATE(NCTOTL)
      DOUBLE PRECISION   ANORM(*), AP(*), AX(*)
      DOUBLE PRECISION   BL(NCTOTL), BU(NCTOTL), FEATOL(NCTOTL),
     $                   P(N), X(N)

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      LOGICAL            CMDBG
      INTEGER            LCMDBG
      PARAMETER         (LCMDBG = 5)
      COMMON    /CMDEBG/ ICMDBG(LCMDBG), CMDBG

************************************************************************
*     CMALF1  finds steps PALFA1, PALFA2 such that
*        X + PALFA1*P  reaches a linear constraint that is currently not
*                      in the working set but is satisfied.
*        X + PALFA2*P  reaches a linear constraint that is currently not
*                      in the working set but is violated.
*     The constraints are perturbed by an amount FEATOL, so that PALFA1
*     is slightly larger than it should be,  and PALFA2 is slightly
*     smaller than it should be.  This gives some leeway later when the
*     exact steps are computed by CMALF.
*
*     Constraints in the working set are ignored  (ISTATE(j) .GE. 1).
*
*     If NEGSTP is true, the search direction will be taken to be  - P.
*
*
*     Values of ISTATE(j)....
*
*        - 2         - 1         0           1          2         3
*     a'x lt bl   a'x gt bu   a'x free   a'x = bl   a'x = bu   bl = bu
*
*     The values  -2  and  -1  do not occur once a feasible point has
*     been found.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original Fortran 66 version written  May 1980.
*     This version of CMALF1 dated 26-June-1986.
************************************************************************
      LOGICAL            LASTV
      INTRINSIC          ABS
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      IF (CMDBG  .AND.  ICMDBG(3) .GT. 0) WRITE (NOUT, 1100)
      LASTV  = .NOT. FIRSTV
      JADD1  = 0
      JADD2  = 0
      PALFA1 = BIGALF

      PALFA2 = ZERO
      IF (FIRSTV) PALFA2 = BIGALF

      DO 200 J = 1, NCTOTL
         JS = ISTATE(J)
         IF (JS .LE. 0) THEN
            IF (J .LE. N) THEN
               ATX    = X(J)
               ATP    = P(J)
               ROWNRM = ONE
            ELSE
               I      = J - N
               ATX    = AX(I)
               ATP    = AP(I)
               ROWNRM = ONE  +  ANORM(I)
            END IF
            IF (NEGSTP) ATP = - ATP

            IF ( ABS( ATP ) .LE. EPSPT9*ROWNRM*PNORM) THEN

*              This constraint appears to be constant along P.  It is
*              not used to compute the step.  Give the residual a value
*              that can be spotted in the debug output.

               RES = - ONE
            ELSE IF (ATP .LE. ZERO  .AND.  JS .NE. -2) THEN
*              ---------------------------------------------------------
*              a'x  is decreasing and the lower bound is not violated.
*              ---------------------------------------------------------
*              First test for smaller PALFA1.

               ABSATP = - ATP
               IF (BL(J) .GT. (-BIGBND)) THEN
                  RES    = ATX - BL(J) + FEATOL(J)
                  IF (BIGALF*ABSATP .GT. ABS( RES )) THEN
                     IF (PALFA1*ABSATP .GT. RES)  THEN
                        PALFA1 = RES / ABSATP
                        JADD1  = J
                     END IF
                  END IF
               END IF

               IF (JS .EQ. -1) THEN

*                 The upper bound is violated.  Test for either larger
*                 or smaller PALFA2, depending on the value of FIRSTV.

                  RES    = ATX - BU(J) - FEATOL(J)
                  IF (BIGALF*ABSATP .GT. ABS( RES )) THEN
                     IF (FIRSTV  .AND.  PALFA2*ABSATP .GT. RES  .OR.
     $                    LASTV  .AND.  PALFA2*ABSATP .LT. RES) THEN
                        PALFA2 = RES / ABSATP
                        JADD2  = J
                     END IF
                  END IF
               END IF
            ELSE IF (ATP .GT. ZERO  .AND.  JS .NE. -1) THEN
*              ---------------------------------------------------------
*              a'x  is increasing and the upper bound is not violated.
*              ---------------------------------------------------------
*              Test for smaller PALFA1.

               IF (BU(J) .LT. BIGBND) THEN
                  RES = BU(J) - ATX + FEATOL(J)
                  IF (BIGALF*ATP .GT. ABS( RES )) THEN
                     IF (PALFA1*ATP .GT. RES) THEN
                        PALFA1 = RES / ATP
                        JADD1  = J
                     END IF
                  END IF
               END IF

               IF (JS .EQ. -2) THEN

*                 The lower bound is violated.  Test for a new PALFA2.

                  RES  = BL(J) - ATX - FEATOL(J)
                  IF (BIGALF*ATP .GT. ABS( RES )) THEN
                     IF (FIRSTV  .AND.  PALFA2*ATP .GT. RES  .OR.
     $                    LASTV  .AND.  PALFA2*ATP .LT. RES) THEN
                        PALFA2 = RES / ATP
                        JADD2  = J
                     END IF
                  END IF
               END IF
            END IF

            IF (CMDBG  .AND.  ICMDBG(3) .GT. 0)
     $         WRITE (NOUT, 1200) J, JS, FEATOL(J), RES,
     $                            ATP, JADD1, PALFA1, JADD2, PALFA2
         END IF
  200 CONTINUE

      RETURN

 1100 FORMAT(/ '    J  JS         FEATOL        RES             AP',
     $         '     JADD1       PALFA1     JADD2       PALFA2' /)
 1200 FORMAT(I5, I4, 3G15.5, 2(I6, G17.7))

*     End of  CMALF1.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMALF ( FIRSTV, HITLOW, ISTATE, INFORM, JADD,
     $                   N, LDA, NCLIN, NCTOTL, NUMINF,
     $                   ALFA, PALFA, ATPHIT, BIGALF, BIGBND, PNORM,
     $                   ANORM, AP, AX, BL, BU, FEATOL, P, X )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            ISTATE(NCTOTL)
      DOUBLE PRECISION   ANORM(*), AP(*), AX(*),
     $                   BL(NCTOTL), BU(NCTOTL), FEATOL(NCTOTL),
     $                   P(N), X(N)
      LOGICAL            FIRSTV, HITLOW

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      LOGICAL            CMDBG
      INTEGER            LCMDBG
      PARAMETER         (LCMDBG = 5)
      COMMON    /CMDEBG/ ICMDBG(LCMDBG), CMDBG

************************************************************************
*  CMALF   finds a step ALFA such that the point x + ALFA*P reaches one
*  of the linear constraints (including bounds).  Two possible steps are
*  defined as follows...
*
*  ALFA1   is the maximum step that can be taken without violating
*          one of the linear constraints that is currently satisfied.
*  ALFA2   reaches a linear constraint that is currently violated.
*          Usually this will be the furthest such constraint along P,
*          but if FIRSTV = .TRUE. it will be the first one along P.
*          This is used only when the problem has been determined to be
*          infeasible, and the sum of infeasibilities are being
*          minimized.  (ALFA2  is not defined if NUMINF = 0.)
*
*  ALFA will usually be the minimum of ALFA1 and ALFA2.
*  ALFA could be negative (since we allow inactive constraints
*  to be violated by as much as FEATOL).  In such cases, a
*  third possible step is computed, to find the nearest satisfied
*  constraint (perturbed by FEATOL) along the direction  - P.
*  ALFA  will be reset to this step if it is shorter.  This is the
*  only case for which the final step  ALFA  does not move X exactly
*  onto a constraint (the one denoted by JADD).
*
*  Constraints in the working set are ignored  (ISTATE(j) ge 1).
*
*  JADD    denotes which linear constraint is reached.
*
*  HITLOW  indicates whether it is the lower or upper bound that
*          has restricted ALFA.
*
*  Values of ISTATE(j)....
*
*     - 2         - 1         0           1          2         3
*  a'x lt bl   a'x gt bu   a'x free   a'x = bl   a'x = bu   bl = bu
*
*  The values -2 and -1 do not occur once a feasible point has been
*  found.
*
*  Systems Optimization Laboratory, Stanford University.
*  Original Fortran 66 version written  May 1980.
*  This version of  CMALF  dated  10-June-1986.
************************************************************************
      LOGICAL            HLOW1, HLOW2, LASTV, NEGSTP, STEP2
      INTRINSIC          ABS, MIN
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      INFORM = 0

*     ------------------------------------------------------------------
*     First pass -- find steps to perturbed constraints, so that
*     PALFA1 will be slightly larger than the true step, and
*     PALFA2 will be slightly smaller than it should be.
*     In degenerate cases, this strategy gives us some freedom in the
*     second pass.  The general idea follows that described by P.M.J.
*     Harris, p.21 of Mathematical Programming 5, 1 (1973), 1--28.
*     ------------------------------------------------------------------

      NEGSTP = .FALSE.
      CALL CMALF1( FIRSTV, NEGSTP, BIGALF, BIGBND, PNORM,
     $             JADD1, JADD2, PALFA1, PALFA2,
     $             ISTATE, N, LDA, NCTOTL,
     $             ANORM, AP, AX, BL, BU, FEATOL, P, X )

      JSAVE1 = JADD1
      JSAVE2 = JADD2

*     ------------------------------------------------------------------
*     Second pass -- recompute step-lengths without perturbation.
*     Amongst constraints that are less than the perturbed steps,
*     choose the one (of each type) that makes the largest angle
*     with the search direction.
*     ------------------------------------------------------------------
      IF (CMDBG  .AND.  ICMDBG(3) .GT. 0) WRITE (NOUT, 1000)
      ALFA1  = BIGALF
      ALFA2  = ZERO
      IF (FIRSTV) ALFA2 = BIGALF

      APMAX1 = ZERO
      APMAX2 = ZERO
      ATP1   = ZERO
      ATP2   = ZERO
      HLOW1  = .FALSE.
      HLOW2  = .FALSE.
      LASTV  = .NOT. FIRSTV

      DO 400 J = 1, NCTOTL
         JS = ISTATE(J)
         IF (JS .LE. 0) THEN
            IF (J  .LE. N)  THEN
               ATX    = X(J)
               ATP    = P(J)
               ROWNRM = ONE
            ELSE
               I      = J - N
               ATX    = AX(I)
               ATP    = AP(I)
               ROWNRM = ANORM(I) + ONE
            END IF

            IF ( ABS( ATP ) .LE. EPSPT9*ROWNRM*PNORM) THEN

*              This constraint appears to be constant along P.  It is
*              not used to compute the step.  Give the residual a value
*              that can be spotted in the debug output.

               RES = - ONE
            ELSE IF (ATP .LE. ZERO  .AND.  JS .NE. -2) THEN
*              ---------------------------------------------------------
*              a'x  is decreasing.
*              ---------------------------------------------------------
*              The lower bound is satisfied.  Test for smaller ALFA1.

               ABSATP = - ATP
               IF (BL(J) .GT. (-BIGBND)) THEN
                  RES    = ATX - BL(J)
                  IF (PALFA1*ABSATP .GE. RES  .OR.  J .EQ. JSAVE1) THEN
                     IF (APMAX1*ROWNRM*PNORM .LT. ABSATP) THEN
                        APMAX1 = ABSATP / (ROWNRM*PNORM)
                        ALFA1  = RES / ABSATP
                        JADD1  = J
                        ATP1   = ATP
                        HLOW1  = .TRUE.
                     END IF
                  END IF
               END IF

               IF (JS. EQ. -1)  THEN

*                 The upper bound is violated.  Test for either a bigger
*                 or smaller ALFA2,  depending on the value of FIRSTV.

                  RES    = ATX - BU(J)
                  IF (     (FIRSTV  .AND.  PALFA2*ABSATP .GE. RES
     $                 .OR.  LASTV  .AND.  PALFA2*ABSATP .LE. RES)
     $                 .OR.  J .EQ.  JSAVE2) THEN
                     IF (APMAX2*ROWNRM*PNORM .LT. ABSATP) THEN
                        APMAX2 = ABSATP / (ROWNRM*PNORM)
                        IF      (ABSATP .GE. ONE          ) THEN
                           ALFA2 = RES / ABSATP
                        ELSE IF (RES    .LT. BIGALF*ABSATP) THEN
                           ALFA2 = RES / ABSATP
                        ELSE
                           ALFA2 = BIGALF
                        END IF
                        JADD2  = J
                        ATP2   = ATP
                        HLOW2  = .FALSE.
                     END IF
                  END IF
               END IF
            ELSE IF (ATP .GT. ZERO  .AND.  JS .NE.  -1)  THEN
*              ---------------------------------------------------------
*              a'x  is increasing and the upper bound is not violated.
*              ---------------------------------------------------------
*              Test for smaller ALFA1.

               IF (BU(J) .LT. BIGBND) THEN
                  RES = BU(J) - ATX
                  IF (PALFA1*ATP .GE. RES  .OR.  J .EQ. JSAVE1) THEN
                     IF (APMAX1*ROWNRM*PNORM .LT. ATP) THEN
                        APMAX1 = ATP / (ROWNRM*PNORM)
                        ALFA1  = RES / ATP
                        JADD1  = J
                        ATP1   = ATP
                        HLOW1  = .FALSE.
                     END IF
                  END IF
               END IF

               IF (JS .EQ. -2)  THEN

*                 The lower bound is violated.  Test for a new ALFA2.

                  RES    = BL(J) - ATX
                  IF (     (FIRSTV  .AND.  PALFA2*ATP .GE. RES
     $                 .OR.  LASTV  .AND.  PALFA2*ATP .LE. RES)
     $                 .OR.  J .EQ.  JSAVE2) THEN
                     IF (APMAX2*ROWNRM*PNORM .LT. ATP) THEN
                        APMAX2 = ATP / (ROWNRM*PNORM)
                        IF      (ATP .GE. ONE       ) THEN
                           ALFA2 = RES / ATP
                        ELSE IF (RES .LT. BIGALF*ATP) THEN
                           ALFA2 = RES / ATP
                        ELSE
                           ALFA2 = BIGALF
                        END IF
                        JADD2  = J
                        ATP2   = ATP
                        HLOW2  = .TRUE.
                     END IF
                  END IF
               END IF
            END IF

            IF (CMDBG  .AND.  ICMDBG(3) .GT. 0)
     $      WRITE (NOUT, 1200) J, JS, FEATOL(J), RES, ATP, JADD1,
     $                         ALFA1, JADD2, ALFA2
         END IF
  400 CONTINUE

*     ==================================================================
*     Determine ALFA, the step to be taken.
*     ==================================================================
*     In the infeasible case, check whether to take the step ALFA2
*     rather than ALFA1...

      STEP2 = NUMINF .GT. 0  .AND.  JADD2 .GT. 0

*     We do so if ALFA2 is less than ALFA1 or (if FIRSTV is false)
*     lies in the range  (ALFA1, PALFA1)  and has a smaller value of
*     ATP.

      STEP2 = STEP2 .AND. (ALFA2 .LT. ALFA1   .OR.   LASTV  .AND.
     $                     ALFA2 .LE. PALFA1  .AND.  APMAX2 .GE. APMAX1)

      IF (STEP2) THEN
         ALFA   = ALFA2
         PALFA  = PALFA2
         JADD   = JADD2
         ATPHIT = ATP2
         HITLOW = HLOW2
      ELSE
         ALFA   = ALFA1
         PALFA  = PALFA1
         JADD   = JADD1
         ATPHIT = ATP1
         HITLOW = HLOW1

*        If ALFA1 is negative, the constraint to be added (JADD)
*        remains unchanged, but ALFA may be shortened to the step
*        to the nearest perturbed satisfied constraint along  - P.

         NEGSTP = ALFA .LT. ZERO
         IF (NEGSTP) THEN
            CALL CMALF1( FIRSTV, NEGSTP, BIGALF, BIGBND, PNORM,
     $                   JADD1, JADD2, PALFA1, PALFA2,
     $                   ISTATE, N, LDA, NCTOTL,
     $                   ANORM, AP, AX, BL, BU, FEATOL, P, X )

            IF (CMDBG  .AND.  ICMDBG(1) .GT. 0)
     $         WRITE (NOUT, 9000) ALFA, PALFA1

            ALFA = - MIN( ABS( ALFA ), PALFA1 )
         END IF
      END IF

*     Test for undefined or infinite step.

      IF (JADD .EQ. 0) THEN
         ALFA   = BIGALF
         PALFA  = BIGALF
      END IF

      IF (ALFA .GE. BIGALF) INFORM = 3
      IF (CMDBG  .AND.  ICMDBG(1) .GT. 0  .AND.  INFORM .GT. 0)
     $   WRITE (NOUT, 9010) JADD, ALFA
      RETURN

 1000 FORMAT(/ ' CMALF  entered'
     $       / '    J  JS         FEATOL        RES             AP',
     $         '     JADD1        ALFA1     JADD2        ALFA2 '/)
 1200 FORMAT( I5, I4, 3G15.5, 2(I6, G17.7) )
 9000 FORMAT(/ ' //CMALF //  Negative step',
     $       / ' //CMALF //           ALFA          PALFA'
     $       / ' //CMALF //', 2G15.4 )
 9010 FORMAT(/ ' //CMALF //  Unbounded step.'
     $       / ' //CMALF //  JADD           ALFA'
     $       / ' //CMALF //  ', I4, G15.4 )

*     End of  CMALF .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMCHK ( NERROR, MSGLVL, LCRASH, USERKX,
     $                   LIWORK, LWORK, LITOTL, LWTOTL,
     $                   N, NCLIN, NCNLN,
     $                   ISTATE, KX, NAMED, NAMES, LENNAM,
     $                   BL, BU, X )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*8        NAMES(*)
      LOGICAL            NAMED, USERKX
      INTEGER            ISTATE(N+NCLIN+NCNLN), KX(N)
      DOUBLE PRECISION   BL(N+NCLIN+NCNLN), BU(N+NCLIN+NCNLN), X(N)

      COMMON    /SOL1CM/ NOUT

************************************************************************
*  CMCHK   checks the data input to various optimizers.
*
*  Systems Optimization Laboratory, Stanford University.
*  Original Fortran 66 version written 10-May-1980.
*  Fortran 77 version written  5-October-1984.
*  This version of CMCHK dated  10-Dec-89.       
************************************************************************
      LOGICAL            OK
      INTRINSIC          ABS
      PARAMETER        ( ZERO   =  0.0D+0 , ONE    =  1.0D+0 )

      CHARACTER*5        ID(3)
      DATA                ID(1)   ,  ID(2)   ,  ID(3)
     $                 / 'VARBL'  , 'LNCON'  , 'NLCON'   /

      NERROR = 0

*     ------------------------------------------------------------------
*     Check that there is enough workspace to solve the problem.
*     ------------------------------------------------------------------
      OK     = LITOTL .LE. LIWORK  .AND.  LWTOTL .LE. LWORK
      IF (.NOT. OK)  THEN
         WRITE (NOUT, 1100) LIWORK, LWORK, LITOTL, LWTOTL
         NERROR = NERROR + 1
         WRITE (NOUT, 1110)
      ELSE IF (MSGLVL .GT. 0)  THEN
         WRITE (NOUT, 1100) LIWORK, LWORK, LITOTL, LWTOTL
      END IF

      IF (USERKX) THEN
*        ---------------------------------------------------------------
*        Check for a valid KX.
*        ---------------------------------------------------------------
         IFAIL = 1
         CALL CMPERM( KX, 1, N, IFAIL )
         IF (IFAIL .NE. 0) THEN
            WRITE (NOUT, 1300)
            NERROR = NERROR + 1
         END IF
      END IF

*     ------------------------------------------------------------------
*     Check the bounds on all variables and constraints.
*     ------------------------------------------------------------------
      DO 200 J = 1, N+NCLIN+NCNLN
         B1     = BL(J)
         B2     = BU(J)
         OK     = B1 .LE. B2
         IF (.NOT. OK)  THEN
            NERROR = NERROR + 1
            IF (J .GT. N+NCLIN)  THEN
               K  = J - N - NCLIN
               L  = 3
            ELSE IF (J .GT. N)  THEN
               K  = J - N
               L  = 2
            ELSE
               K = J
               L = 1
            END IF
            IF (.NOT. NAMED) WRITE (NOUT, 1200) ID(L), K, B1, B2
            IF (      NAMED) WRITE (NOUT, 1210) NAMES(J), B1, B2
         END IF
  200 CONTINUE

*     ------------------------------------------------------------------
*     If warm start, check  ISTATE.
*     ------------------------------------------------------------------
      IF (LCRASH .EQ. 1) THEN         
         DO 420 J = 1, N+NCLIN+NCNLN
            IS     = ISTATE(J)
            OK     = IS .GE. (- 2)   .AND.   IS .LE. 4
            IF (.NOT. OK)  THEN
               NERROR = NERROR + 1
               WRITE (NOUT, 1500) J, IS
            END IF
  420    CONTINUE
      END IF

      RETURN

 1100 FORMAT(/ ' Workspace provided is     IW(', I8,
     $         '),  W(', I8, ').' /
     $         ' To solve problem we need  IW(', I8,
     $         '),  W(', I8, ').')
 1110 FORMAT(/ ' XXX  Not enough workspace to solve problem.')
 1200 FORMAT(/ ' XXX  The bounds on  ', A5, I3,
     $         '  are inconsistent.   BL =', G16.7, '   BU =', G16.7)
 1210 FORMAT(/ ' XXX  The bounds on  ', A8,
     $         '  are inconsistent.   BL =', G16.7, '   BU =', G16.7)
 1300 FORMAT(/ ' XXX  KX has not been supplied as a valid',
     $         '  permutation.' )
 1500 FORMAT(/ ' XXX  Component', I5, '  of  ISTATE  is out of',
     $         ' range...', I10)

*     End of  CMCHK .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMPERM( KX, M1, M2, IFAIL )

      INTEGER            IFAIL, M1, M2
      INTEGER            KX(M2)

      COMMON    /SOL1CM/ NOUT

************************************************************************
*     CMPERM checks that elements M1 to M2 of KX contain a valid
*     permutation of the integers M1 to M2. The contents of KX are
*     unchanged on exit.
*
*     SOL version of NAG Library routine M01ZBF.
*     Written by N.N.Maclaren, University of Cambridge.
*     This version of CMPERM dated 18-June-1986.
************************************************************************

      LOGICAL            CMDBG
      INTEGER            LCMDBG
      PARAMETER         (LCMDBG = 5)
      COMMON    /CMDEBG/ ICMDBG(LCMDBG), CMDBG

      INTEGER            I, IERR, J, K
      INTRINSIC          ABS

*     Check the parameters.

      IF (M2 .LT. 1  .OR.  M1 .LT. 1  .OR.  M1 .GT. M2) THEN
         IERR = 1
         IF (CMDBG  .AND.  ICMDBG(3) .GT. 0)
     $      WRITE (NOUT, FMT=1100) M1, M2
      ELSE
         IERR = 0

*        Check that KX is within range.

         DO 20 I = M1, M2
            J = KX(I)
            IF ((J .LT. M1) .OR. (J .GT. M2)) GO TO 100
            IF (I .NE. J) KX(I) = -J
   20    CONTINUE

*        Check that no value is repeated.

         DO 60 I = M1, M2
            K = - KX(I)
            IF (K .GE. 0) THEN
               J     = I
   40          KX(J) = K
               J     = K
               K     = - KX(J)
               IF (K .GT. 0) GO TO 40
               IF (J .NE. I) GO TO 120
            END IF
   60    CONTINUE
      END IF

*     Return

   80 IF (IERR .NE. 0) THEN
         IFAIL = IERR
      ELSE
         IFAIL = 0
      END IF
      RETURN
  100 IERR = 2
      WRITE (NOUT, FMT=1200) I, J
      GO TO 140
  120 IERR = 3
      WRITE (NOUT, FMT=1300) J

*     Restore KX.

  140 DO 160 I = M1, M2
         KX(I) = ABS(KX(I))
  160 CONTINUE
      GO TO 80

 1100 FORMAT(/ ' //CMPERM//  Illegal parameter values,'
     $       / ' //CMPERM//    M1    M1'
     $       / ' //CMPERM//', 2I6 )
 1200 FORMAT(/ ' XXX  KX(',I6,') contains an out-of-range value =', I16)
 1300 FORMAT(/ ' XXX  KX contains a duplicate value =',             I16)

*     End of CMPERM.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMPRT ( MSGLVL, NFREE, LDA,
     $                   N, NCLIN, NCNLN, NCTOTL, BIGBND,
     $                   NAMED, NAMES, LENNAM,
     $                   NACTIV, ISTATE, KACTIV, KX,
     $                   A, BL, BU, C, CLAMDA, RLAMDA, X )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*8        NAMES(*)
      LOGICAL            NAMED
      INTEGER            ISTATE(NCTOTL), KACTIV(N), KX(N)
      DOUBLE PRECISION   A(LDA,*), BL(NCTOTL), BU(NCTOTL), C(*),
     $                   CLAMDA(NCTOTL), RLAMDA(N), X(N)

      COMMON    /SOL1CM/ NOUT

      LOGICAL            CMDBG
      INTEGER            LCMDBG
      PARAMETER         (LCMDBG = 5)
      COMMON    /CMDEBG/ ICMDBG(LCMDBG), CMDBG

***********************************************************************
*  CMPRT   creates the expanded Lagrange multiplier vector CLAMDA.
*  If MSGLVL .EQ 1 or MSGLVL .GE. 10,  CMPRT prints  x,  A*x,
*  c(x),  their bounds, the multipliers, and the residuals (distance
*  to the nearer bound).
*  CMPRT is called by LSCORE and NPCORE just before exiting.
*
*  Systems Optimization Laboratory, Stanford University.
*  Original Fortran 77 version written  October 1984.
*  This version of  CMPRT  dated  10-June-1986.
***********************************************************************
      CHARACTER*2        LS, LSTATE(7)
      CHARACTER*5        ID(3), ID3
      CHARACTER*8        ID4
      EXTERNAL           DDOT
      INTRINSIC          ABS

      PARAMETER        ( ZERO  = 0.0D+0 )
      DATA               ID(1) / 'VARBL' /
      DATA               ID(2) / 'LNCON' /
      DATA               ID(3) / 'NLCON' /
      DATA               LSTATE(1) / '--' /, LSTATE(2) / '++' /
      DATA               LSTATE(3) / 'FR' /, LSTATE(4) / 'LL' /
      DATA               LSTATE(5) / 'UL' /, LSTATE(6) / 'EQ' /
      DATA               LSTATE(7) / 'TB' /


      NPLIN  = N     + NCLIN
      NZ     = NFREE - NACTIV

*     Expand multipliers for bounds, linear and nonlinear constraints
*     into the  CLAMDA  array.

      CALL DLOAD ( NCTOTL, ZERO, CLAMDA, 1 )
      NFIXED = N - NFREE
      DO 150 K = 1, NACTIV+NFIXED
         IF (K .LE. NACTIV) J = KACTIV(K) + N
         IF (K .GT. NACTIV) J = KX(NZ+K)
         CLAMDA(J) = RLAMDA(K)
  150 CONTINUE

      IF (MSGLVL .LT. 10  .AND.  MSGLVL .NE. 1) RETURN

      WRITE (NOUT, 1100)
      ID3 = ID(1)

      DO 500 J = 1, NCTOTL
         B1     = BL(J)
         B2     = BU(J)
         WLAM   = CLAMDA(J)
         IS     = ISTATE(J)
         LS     = LSTATE(IS + 3)
         IF (J .LE. N) THEN

*           Section 1 -- the variables  x.
*           ------------------------------
            K      = J
            V      = X(J)

         ELSE IF (J .LE. NPLIN) THEN

*           Section 2 -- the linear constraints  A*x.
*           -----------------------------------------
            IF (J .EQ. N + 1) THEN
               WRITE (NOUT, 1200)
               ID3 = ID(2)
            END IF

            K      = J - N
            V      = DDOT  ( N, A(K,1), LDA, X, 1 )
         ELSE

*           Section 3 -- the nonlinear constraints  c(x).
*           ---------------------------------------------

            IF (J .EQ. NPLIN + 1) THEN
               WRITE (NOUT, 1300)
               ID3 = ID(3)
            END IF

            K      = J - NPLIN
            V      = C(K)
         END IF

*        Print a line for the j-th variable or constraint.
*        -------------------------------------------------
         RES    = V - B1
         RES2   = B2 - V
         IF (ABS(RES) .GT. ABS(RES2)) RES = RES2
         IP     = 1
         IF (B1 .LE. ( - BIGBND )) IP = 2
         IF (B2 .GE.     BIGBND  ) IP = IP + 2
         IF (NAMED) THEN

            ID4 = NAMES(J)
            IF (IP .EQ. 1) THEN
               WRITE (NOUT, 2100) ID4,    LS, V, B1, B2, WLAM, RES
            ELSE IF (IP .EQ. 2) THEN
               WRITE (NOUT, 2200) ID4,    LS, V,     B2, WLAM, RES
            ELSE IF (IP .EQ. 3) THEN
               WRITE (NOUT, 2300) ID4,    LS, V, B1,     WLAM, RES
            ELSE
               WRITE (NOUT, 2400) ID4,    LS, V,         WLAM, RES
           END IF

         ELSE

            IF (IP .EQ. 1) THEN
               WRITE (NOUT, 3100) ID3, K, LS, V, B1, B2, WLAM, RES
            ELSE IF (IP .EQ. 2) THEN
               WRITE (NOUT, 3200) ID3, K, LS, V,     B2, WLAM, RES
            ELSE IF (IP .EQ. 3) THEN
               WRITE (NOUT, 3300) ID3, K, LS, V, B1,     WLAM, RES
            ELSE
               WRITE (NOUT, 3400) ID3, K, LS, V,         WLAM, RES
           END IF
         END IF
  500 CONTINUE
      RETURN

 1100 FORMAT(// ' Variable        State', 5X, ' Value',
     $   6X, ' Lower bound', 4X, ' Upper bound',
     $   '  Lagr multiplier', '     Residual' /)
 1200 FORMAT(// ' Linear constr   State', 5X, ' Value',
     $   6X, ' Lower bound', 4X, ' Upper bound',
     $   '  Lagr multiplier', '     Residual' /)
 1300 FORMAT(// ' Nonlnr constr   State', 5X, ' Value',
     $   6X, ' Lower bound', 4X, ' Upper bound',
     $   '  Lagr multiplier', '     Residual' /)
 2100 FORMAT(1X, A8, 10X, A2, 3G16.7, G16.7, G16.4)
 2200 FORMAT(1X, A8, 10X, A2, G16.7, 5X, ' None', 6X, G16.7,
     $   G16.7, G16.4)
 2300 FORMAT(1X, A8, 10X, A2, 2G16.7, 5X, ' None', 6X, G16.7, G16.4)
 2400 FORMAT(1X, A8, 10X, A2,  G16.7, 5X, ' None', 11X, ' None',
     $   6X, G16.7, G16.4)
 3100 FORMAT(1X, A5, I3, 10X, A2, 3G16.7, G16.7, G16.4)
 3200 FORMAT(1X, A5, I3, 10X, A2,  G16.7,
     $   5X, ' None', 6X, G16.7, G16.7, G16.4)
 3300 FORMAT(1X, A5, I3, 10X, A2, 2G16.7, 5X, ' None', 6X,
     $   G16.7, G16.4)
 3400 FORMAT(1X, A5, I3, 10X, A2,  G16.7,
     $   5X, ' None', 11X, ' None', 6X, G16.7, G16.4)

*     End of  CMPRT

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMR1MD( N, NU, NRANK, LDR, LENV, LENW,
     $                   R, U, V, W, C, S )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            N, NU, NRANK, LDR, LENV, LENW
      DOUBLE PRECISION   R(LDR,*), U(N,*), V(N), W(N)
      DOUBLE PRECISION   C(N), S(N)

C***********************************************************************
C     CMR1MD  modifies the  nrank*n  upper-triangular matrix  R  so that
C     Q*(R + v*w')  is upper triangular,  where  Q  is orthogonal,
C     v  and  w  are vectors, and the modified  R  overwrites the old.
C     Q  is the product of two sweeps of plane rotations (not stored).
C     If required,  the rotations are applied to the NU columns of
C     the matrix  U.
C
C     The matrix V*W' is an (LENV) by (LENW) matrix.
C     The vector V is overwritten.
C                                           
C     Systems Optimization Laboratory, Stanford University.
C     Original version   October  1984.
C     Level-2 matrix routines added 22-Apr-1988.
C     This version of  CMR1MD  dated 22-Apr-1988.
C***********************************************************************
      INTRINSIC          MIN

      J = MIN( LENV, NRANK )
      IF (NRANK .GT. 0) THEN
*        ---------------------------------------------------------------
*        Reduce  V to beta*e( j )  using a backward sweep of rotations
*        in planes (j-1, j), (j-2, j), ..., (1, j).
*        ---------------------------------------------------------------
         CALL F06FQF( 'Fixed', 'Backwards', J-1, V(J), V, 1, C, S )

*        ---------------------------------------------------------------
*        Apply the sequence of rotations to U.
*        ---------------------------------------------------------------
         IF (NU .GT. 0)
     $      CALL F06QXF( 'Left', 'Bottom', 'Backwards', J, NU,
     $                   1, J, C, S, U, N )

*        ---------------------------------------------------------------
*        Apply the sequence of rotations to R. This generates a spike in
*        the j-th row of R, which is stored in S.
*        ---------------------------------------------------------------
         CALL F06QWF( 'Left', N, 1, J, C, S, R, LDR )

*        ---------------------------------------------------------------
*        Form  beta*e(j)*w' + R.  This a spiked matrix, with a row
*        spike in row j.
*        ---------------------------------------------------------------
         CALL DAXPY( MIN( J-1, LENW ), V(J), W   , 1, S     , 1     )
         CALL DAXPY( LENW-J+1        , V(J), W(J), 1, R(J,J), LDR )

*        ---------------------------------------------------------------
*        Eliminate the spike using a forward sweep of rotations in
*        planes (1, j), (2, j), ..., (j-1, j).
*        ---------------------------------------------------------------
         CALL F06QSF( 'Left', N, 1, J, C, S, R, LDR )

*        ---------------------------------------------------------------
*        Apply the rotations to U.
*        ---------------------------------------------------------------
         IF (NU .GT. 0)
     $      CALL F06QXF( 'Left', 'Bottom', 'Forwards', J, NU,
     $                   1, J, C, S, U, N )
      END IF

      RETURN

*     End of  CMR1MD

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMRSWP( N, NU, NRANK, LDR, I, J, R, U, C, S )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION   R(LDR,*), U(N,*)
      DOUBLE PRECISION   C(N), S(N)

C***********************************************************************
C     CMRSWP  interchanges the  I-th  and  J-th  (I .LT. J)  columns of
C     an  NRANK*N  upper-trapezoidal matrix  R   and restores the
C     resulting matrix to upper-trapezoidal form using two sweeps of 
C     plane rotations applied on the left.  R is overwritten.  
C
C     If NU .GT. 0,  the rotations are applied to the  nu  columns of
C     the matrix  U.
C
C     Systems Optimization Laboratory, Stanford University.
C     Original version written 31-October-1984.
C     Level-2 matrix routines added 13-May-1988.
C     This version of  CMRSWP  dated  30-May-1988.
C***********************************************************************

      PARAMETER        ( ZERO = 0.0D+0 )
      INTRINSIC          MIN

*     Swap the elements of the i-th and j-th columns of R on, or above,
*     the main diagonal.

      CALL DSWAP( MIN(I,NRANK), R(1,I), 1, R(1,J), 1 )
      LENJ = MIN(J, NRANK)

      IF (LENJ .GT. I) THEN
*        ---------------------------------------------------------------
*        Reduce elements  r(i+1,j), ..., r(lenj,j)  to  beta*e(lenj)  
*        using a backward sweep in planes
*        (lenj-1,lenj), (lenj-2,lenj), ..., (i+1,lenj).
*        If required, apply the sequence of rotations to U.
*        ---------------------------------------------------------------
         CALL F06FQF( 'Fixed', 'Backwards', LENJ-I-1, R(LENJ,J),
     $                R(I+1,J), 1, C(I+1), S(I+1) )

         IF (NU.GT.0)
     $      CALL F06QXF( 'Left', 'Bottom', 'Backwards', N, NU, I+1,LENJ,
     $                   C, S, U, N )

*        Put zeros into the j-th column of R in positions corresponding 
*        to the sub-diagonals of the i-th column.

         S(I) = R(LENJ,J)
         CALL DLOAD ( LENJ-I, ZERO, R(I+1,J), 1 )

*        Apply the sequence of rotations to R.  This generates a spike 
*        in the lenj-th row of R, which is stored in S.

         CALL F06QWF( 'Left', N, I+1, LENJ, C, S, R, LDR )

*        Eliminate the spike using a forward sweep in planes
*        (i,lenj), (i+1,lenj), ..., (lenj-1,lenj).
*        If necessary, apply the sequence of rotations to U.

         CALL F06QSF( 'Left', N, I, LENJ, C, S, R, LDR )

         IF (NU.GT.0)
     $      CALL F06QXF( 'Left', 'Bottom', 'Forwards', LENJ, NU,
     $                   I, LENJ, C, S, U, N )
      END IF

      RETURN

*     End of  CMRSWP
                                
      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMTSOL( MODE, LDT, N, T, Y )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            MODE, LDT, N
      DOUBLE PRECISION   T(LDT,*), Y(N)

************************************************************************
*     CMTSOL  solves equations involving a reverse-triangular matrix  T
*     and a right-hand-side vector  y,  returning the solution in  y.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original Fortran 77 version written February-1985.
************************************************************************
      PARAMETER        ( ZERO = 0.0D+0 )

      N1 = N + 1
      IF (MODE .EQ. 1) THEN

*        Mode = 1  ---  Solve  T * y(new) = y(old).

         DO 100 J = 1, N
            JJ = N1 - J
            YJ = Y(J)/T(J,JJ)
            Y(J) = YJ
            L  = JJ - 1
            IF (L .GT. 0  .AND.  YJ .NE. ZERO)
     $      CALL DAXPY( L, (-YJ), T(J+1,JJ), 1, Y(J+1), 1 )
  100    CONTINUE
      ELSE

*        Mode = 2  ---  Solve  T' y(new) = y(old).

         DO 500 J = 1, N
            JJ = N1 - J
            YJ = Y(J)/T(JJ,J)
            Y(J) = YJ
            L  = JJ - 1
            IF (L .GT. 0  .AND.  YJ .NE. ZERO)
     $      CALL DAXPY( L, (-YJ), T(JJ,J+1), LDT, Y(J+1), 1 )
  500    CONTINUE
      END IF

*     Reverse the solution vector.

      IF (N .GT. 1) THEN
         L = N/2
         DO 800 J = 1, L
            JJ    = N1 - J
            YJ    = Y(J)
            Y(J)  = Y(JJ)
            Y(JJ) = YJ
  800    CONTINUE
      END IF

      RETURN

*     End of  CMTSOL.
                                                
      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CMQMUL( MODE, N, NZ, NFREE, LDZY, UNITQ,
     $                   KX, V, ZY, W )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            KX(N)
      DOUBLE PRECISION   V(N), ZY(LDZY,*), W(N)

************************************************************************
*     CMQMUL  transforms the vector  v  in various ways using the
*     matrix  Q = ( Z  Y )  defined by the input parameters.
*
*        MODE               result
*        ----               ------
*
*          1                v = Z v
*          2                v = Y v
*          3                v = Q v
*
*     On input,  v  is assumed to be ordered as  ( v(free)  v(fixed) ).
*     On output, v  is a full n-vector.
*
*
*          4                v = Z'v
*          5                v = Y'v
*          6                v = Q'v
*
*     On input,  v  is a full n-vector.
*     On output, v  is ordered as  ( v(free)  v(fixed) ).
*
*          7                v = Y'v
*          8                v = Q'v
*
*     On input,  v  is a full n-vector.
*     On output, v  is as in modes 5 and 6 except that v(fixed) is not
*     set.
*
*     Modes  1, 4, 7 and 8  do not involve  v(fixed).
*     Original F66 version  April 1983.
*     Fortran 77 version written  9-February-1985.
*     Level 2 BLAS added 10-June-1986.
*     This version of CMQMUL dated 10-June-1986.
************************************************************************
      EXTERNAL           DDOT
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      NFIXED = N - NFREE
      J1     = 1
      J2     = NFREE
      IF (MODE .EQ. 1  .OR.  MODE .EQ. 4) J2 = NZ
      IF (MODE .EQ. 2  .OR.  MODE .EQ. 5  .OR.  MODE .EQ. 7) J1 = NZ + 1
      LENV   = J2 - J1 + 1
      IF (MODE .LE. 3) THEN
*        ===============================================================
*        Mode = 1, 2  or  3.
*        ===============================================================

         IF (NFREE .GT. 0) CALL DLOAD ( NFREE, ZERO, W, 1 )

*        Copy  v(fixed)  into the end of  wrk.

         IF (MODE .GE. 2  .AND.  NFIXED .GT. 0)
     $      CALL DCOPY ( NFIXED, V(NFREE+1), 1, W(NFREE+1), 1 )

*        Set  W  =  relevant part of  ZY * V.

         IF (LENV .GT. 0)  THEN
            IF (UNITQ) THEN
               CALL DCOPY ( LENV, V(J1), 1, W(J1), 1 )
            ELSE
               CALL DGEMV ( 'N', NFREE, J2-J1+1, ONE, ZY(1,J1), LDZY,
     $                      V(J1), 1, ONE, W, 1 )
            END IF
         END IF

*        Expand  W  into  V  as a full n-vector.

         CALL DLOAD ( N, ZERO, V, 1 )
         DO 220 K = 1, NFREE
            J    = KX(K)
            V(J) = W(K)
  220    CONTINUE

*        Copy  W(fixed)  into the appropriate parts of  V.

         IF (MODE .GT. 1)  THEN
            DO 320 L = 1, NFIXED
               J       = KX(NFREE+L)
               V(J)    = W(NFREE+L)
  320       CONTINUE
         END IF

      ELSE
*        ===============================================================
*        Mode = 4, 5, 6, 7  or  8.
*        ===============================================================
*        Put the fixed components of  V  into the end of  W.

         IF (MODE .EQ. 5  .OR.  MODE .EQ. 6)  THEN
            DO 420, L = 1, NFIXED
               J          = KX(NFREE+L)
               W(NFREE+L) = V(J)
  420       CONTINUE
         END IF

*        Put the free  components of  V  into the beginning of  W.

         IF (NFREE .GT. 0)  THEN
            DO 520, K = 1, NFREE
               J      = KX(K)     
               W(K) = V(J)
  520       CONTINUE

*           Set  V  =  relevant part of  ZY' * W.

            IF (LENV .GT. 0)  THEN
               IF (UNITQ) THEN
                  CALL DCOPY ( LENV, W(J1), 1, V(J1), 1 )
               ELSE
                  CALL DGEMV ( 'T', NFREE, J2-J1+1, ONE, ZY(1,J1), LDZY,
     $                         W, 1, ZERO, V(J1), 1 )
               END IF
            END IF
         END IF

*        Copy the fixed components of  W  into the end of  V.

         IF (NFIXED .GT. 0  .AND.  (MODE .EQ. 5  .OR.  MODE .EQ. 6))
     $      CALL DCOPY ( NFIXED, W(NFREE+1), 1, V(NFREE+1), 1 )
      END IF

      RETURN

*     End of  CMQMUL.

      END

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     post.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine post(mode,lvec,vec,objf,objgrd,nstate)
      implicit  real*8 (a-h,o-z)
      implicit  integer*4 (i-n)
      save

*     Global data

      include "global.f"

*     Local data

      real*8 objf
      real*8 vec,objgrd
      real*8 u,work,sum,tmp
      real*8 h,hwz,e,ewu,P,PwA,Pwu
      real*8 R0

      integer*4 mode,lvec,nstate
      integer*4 i,j,isw
      integer*4 lwork

*     Local parameters

      real*8 eps
      integer*4 mwork

      parameter (eps=1.d-300)
      parameter (mwork=500)

      dimension vec(lvec),objgrd(lvec)
      dimension u(mM),work(mwork)
      dimension hwz(mM),PwA(mtheta),Pwu(mM),ewu(mM)
      dimension R0(mM*(mM+1)/2)

*     Error checks

      lwork=M
      if (lwork.gt.mwork) then
        write(3,3001) lwork
        stop
      end if

      if (lvec.ne.M) then
        write(3,3002) 
        stop
      end if

*     Copy parameters NPSOL gets to see to z.

      do i=1,M
        z(i)=vec(i)
      end do 

*     Compute the posterior objf and its gradient objgrd.

      do i=1,lR
        R0(i)=theta(ibR+i)
      end do

      call drinv(R0,M)

      do i=1,M
        u(i)=0.d0
      end do

      do j=1,M
      do i=1,j
       u(i)=u(i)+R0(j*(j-1)/2+i)*z(j)
      end do
      end do

      call pzx(u,x,P,PwA,Pwu,theta(iaA),
     &  M,L,ntermz,ntermx,work)

      sum=0.d0

      do i=1,M
        sum=sum+u(i)**2
      end do

      e=dexp(-sum/2.d0)

      do i=1,M
        ewu(i)=-e*u(i)
      end do

      h=P*e

      do i=1,M
        hwz(i)=0.d0
      end do

      do j=1,M
      do i=1,j
        hwz(j) = hwz(j) + (e*Pwu(i) + P*ewu(i))*R0(j*(j-1)/2+i)
      end do
      end do

      isw=2
      call density(isw)

      tmp=h*d+eps
      
      objf=-dlog(tmp)

      do i=1,M
        objgrd(i) = -(d*hwz(i) + h*dwz(i))/tmp
      end do

      return
3001  format(1x,'error, post, increase mwork to at least',i5)
3002  format(1x,'error, post, M and lvec don''t agree')
      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     mufun.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine mufun(mode,ncnln,lvec,nrowj,needc,vec,c,cjac,nstate)   
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      real*8 vec,c,cjac
      real*8 work
      real*8 R0
      real*8 Eyl,dEyl

      integer*4 mode,ncnln,lvec,nrowj,needc,nstate
      integer*4 lwork,mwork
      integer*4 lambda
      integer*4 i,j,ii,jj

      parameter (mwork = 500)

      dimension needc(*)
      dimension vec(lvec),c(*),cjac(nrowj,*)
      dimension R0((mM*(mM+1))/2)
      dimension lambda(mM)
      dimension dEyl(mtheta)
      dimension work(mwork)


      if (ncnln.eq.0) return

      lwork=2*ntermz
      if (lwork.gt.mwork) then
        write (3,3906) lwork
        stop
      endif

*     Copy parameters NPSOL gets to see to vsav.

      j=0
      do i=1,lvsav
        if (ivec(i).eq.0) then
          j=j+1
          vsav(i)=vec(j)
        end if
      end do 

*     Make tau and theta agree with vsav.

      do i=1,ltau
        tau(i)=vsav(i)
      end do

      do i=1,ltheta
        theta(i)=vsav(ltau+i)
      end do

*     This is an identity to pass to EYLX instead of R.

      do j=1,M
      do i=1,j
        if (i.eq.j) then
          R0(j*(j-1)/2+i)=1.d0
        else
          R0(j*(j-1)/2+i)=0.d0
        end if
      end do
      end do

      do i=1,M

        if (needc(i).gt.0) then

          do jj=1,M
            lambda(jj)=0
          end do
          lambda(i)=1

          call eylx(lambda,z,x,Eyl,dEyl,
     &      theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &      M,L,ntermz,ntermx,Kz,Kx,work)

          c(i) = Eyl

          jj=0
          do ii=1,lvsav
            if (ivec(ii).eq.0) then
              jj=jj+1
              if ((ltau+ibA+1.le.ii).and.(ii.le.ltau+ibA+lA)) then
                 cjac(i,jj)=dEyl(ibA+ii-ltau)
              else
                cjac(i,jj)=0.d0
              end if
            end if
          end do 

        end if
      end do

      return
3906  format(1x,'error, muzero, increase mwork to at least',i5)
      end

C.hr spcode1.f
C....*...1.........2.........3.........4.........5.........6.........7.*
C    
C     snpcode1.f
C
C     Copyright (C) 1990.
C
C     A. Ronald Gallant & George E. Tauchen 
C     P.O. Box 5513, Raleigh NC 27650-5513, USA   
C
C     Permission to use, copy, modify, and distribute this
C     software and its documentation for any purpose and
C     without fee is hereby granted, provided that the
C     above copyright notice appear in all copies and that
C     both that copyright notice and this permission notice
C     appear in supporting documentation.
C
C     This software is provided "as is" without any
C     expressed or implied warranty.
C
C....*...1.........2.........3.........4.........5.........6.........7.*
C.hr SETPRD
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     SETPRD     12/5/88
C
C     PURPOSE
C     COMPUTE THE INTEGER*4 ARRAYS IY, IDY, IX WHICH ALLOW EFFICIENT
C     COMPUTATION OF A MULTIVARIATE POLYNOMIAL AND ITS DERIVATIVES IN
C     LNHYX.   THEY ARE STORED IN THE COMMON BLOCK
C     COMMON /ZSETPR/ IY,IDY,IX
C     IY   - IY(2*(I-1)+1) POINTS TO A MONOMIAL WHICH WHEN MULTIPLIED BY
C            Y(IY(2*(I-1)+2)) WILL PRODUCE THE I-TH MONOMIAL IN Y.
C     IDY  - IDY(M*(I-1)+K) POINTS TO A MONOMIAL WHICH WHEN MULTIPLIED
C            BY THE K-TH ELEMENT OF THE I-TH MULTI-INDEX WILL PRODUCE
C            THE K-TH PARTIAL DERIVATIVE OF THE I-TH MONOMIAL IN Y.
C     IX   - IX(2*(I-1)+1) POINTS TO A MONOMIAL WHICH WHEN MULTIPLIED BY
C            X(IX(2*(I-1)+2)) WILL PRODUCE THE I-TH MONOMIAL IN X.
C
C     USAGE
C     CALL SETPRD(M,L,KY,KX,IDEGY,IDEGX)
C
C     WARNING
C     IF ZZLIM IS CHANGED HERE IT MUST BE CHANGED IN SUBROUTINE LNHYX
C     AND EHYX AS WELL.
C
C     SUBROUTINES CALLED
C     MULTIY, MULTIX, SETMYX
C
C     ARGUMENTS
C     M    - DIMENSION OF THE TIME SERIES, I.E. LENGTH OF Y_T, MUST BE
C            LESS THAN 100
C            INPUT, INTEGER*4
C     L    - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C            INPUT, INTEGER*4
C     KY   - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     KX   - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     IDEGY- DEGREE OF THE POLYNOMIAL IN Y, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     IDEGX- DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C            INPUT, INTEGER*4
C
C     REMARK
C     TYPICAL CODE TO COMPUTE THE POLYNOMIAL P AND ITS GRADIENT DP IS:
C     WY(1)=1
C     DO 10 I=2,KY
C10   WY(I)=WY(IY(2*(I-1)+1))*Y(IY(2*(I-1)+2))
C     WX(1)=1
C     DO 20 I=2,KX
C20   WX(I)=WX(IX(2*(I-1)+1))*X(IX(2*(I-1)+2))
C     P=0.D0
C     DO 30 K=1,M
C30   DP(K)=0.D0
C     DO 40 J=1,KY
C     CALL MULTIY(J,ALPHA)
C     DO 40 I=1,KX
C     P=P+A(I,J)*WX(I)*WY(J)
C     DO 40 K=1,M
C40   DP(K)=DP(K)+A(I,J)*WX(I)*ALPHA(K)*WY(IDY(M*(I-1)+K))
C
C     REMARK
C     THE CALL
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK) 
C     MUST PRECEDE USAGE OF THIS ROUTINE.
C
      SUBROUTINE SETPRD(M,L,KY,KX,IDEGY,IDEGX)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER*4 ALPHA(100),BETA(100),GAMMA(100)
C-----------------------------------------------------------------------
C     DECLARATIONS SHARED BETWEEN SETPRD, PZX, EHYX, AND LNHYX
C-----------------------------------------------------------------------
      INTEGER*4  ZZLIM
      PARAMETER (ZZLIM=500)
      INTEGER*4 IY(ZZLIM),IDY(ZZLIM),IX(ZZLIM)
      COMMON /ZSETPR/ IY,IDY,IX
      SAVE
C-----------------------------------------------------------------------
C
C     LOGICAL:
C     INTEGER*4 IY(2,KY),IDY(M,KY),IX(2,KX)
C
C     ERROR TRAPS
C
      NOUT=3
      IF((2*KY.GT.ZZLIM).OR.(M*KY.GT.ZZLIM).OR.(2*KX.GT.ZZLIM)) THEN
      WRITE(NOUT,3001)
      STOP
      ENDIF
C
C     INITIALIZATION
C
      DO 10 IALPHA=1,KY
      IY(2*(IALPHA-1)+1)=0
      IY(2*(IALPHA-1)+2)=0
      DO 10 INDEX=1,M
10    IDY(M*(IALPHA-1)+INDEX)=1
      DO 20 IBETA=1,KX
      IX(2*(IBETA-1)+1)=0
20    IX(2*(IBETA-1)+2)=0

C
C     OUTER LOOP OVER ALL MULTI-INDEXES ALPHA
C
      DO 190 IALPHA=1,KY
      CALL MULTIY(IALPHA,ALPHA)
C
C     LOOK FOR A PREDECESSOR TO THE MULTI-INDEX ALPHA
C
      DO 180 ITEST=1,IALPHA
      CALL MULTIY(ITEST,GAMMA)
C
      DO 130 INDEX=1,M
      ALPHA(INDEX)=ALPHA(INDEX)-1
C
      DO 120 K=1,M
120   IF(ALPHA(K).NE.GAMMA(K)) GO TO 130

C     FALL THROUGH LOOP 120 MEANS THAT ITEST IS A PREDECESSOR
      IY(2*(IALPHA-1)+1)=ITEST
      IY(2*(IALPHA-1)+2)=INDEX
      IDY(M*(IALPHA-1)+INDEX)=ITEST

130   ALPHA(INDEX)=ALPHA(INDEX)+1
C
180   CONTINUE
C
190   CONTINUE
C
C
C     OUTER LOOP OVER ALL MULTI-INDEXES BETA
C
      DO 290 IBETA=1,KX
      CALL MULTIX(IBETA,BETA)
C
C     LOOK FOR A PREDECESSOR TO THE MULTI-INDEX BETA
C
      DO 280 ITEST=1,IBETA
      CALL MULTIX(ITEST,GAMMA)
C
      DO 230 INDEX=1,M*L
      BETA(INDEX)=BETA(INDEX)-1
C
      DO 220 K=1,M*L
220   IF(BETA(K).NE.GAMMA(K)) GO TO 230

C     FALL THROUGH LOOP 220 MEANS THAT ITEST IS A PREDECESSOR
      IX(2*(IBETA-1)+1)=ITEST
      IX(2*(IBETA-1)+2)=INDEX

230   BETA(INDEX)=BETA(INDEX)+1
C
280   CONTINUE
C
290   CONTINUE
C
      RETURN
3001  FORMAT
     &(' ERROR RETURN FROM SETPRD, 2*KY, M*KY, OR 2*KX EXCEEDS ZZLIM')
      END
C.hr SETUPM
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
      SUBROUTINE SETUPM(IDEGY,M,KY)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     NOTE:    ZZMNTS IS MAXIMUM LENGTH OF ARRAY OF GAUSSIAN MOMENTS.
C     WARNING: IF ZZMNTS IS CHANGED HERE IT MUST BE CHANGED IN
C              SUBROUTINES EHYX AND EYLX AS WELL
C
      INTEGER     ZZMNTS
      PARAMETER ( ZZMNTS = 3000 )
      INTEGER*4 ALPHA(100),GAMMA(100),OMEGA(100)
      REAL*8 MOMENT(34),MNTS(ZZMNTS)
      COMMON /ZMNTS/MNTS
      SAVE
      DATA MOMENT/
     &  1.00000000000000D+00,  0.00000000000000D+00,
     &  1.00000000000000D+00,  0.00000000000000D+00,
     &  3.00000000000000D+00,  0.00000000000000D+00,
     &  1.50000000000000D+01,  0.00000000000000D+00,
     &  1.05000000000000D+02,  0.00000000000000D+00,
     &  9.45000000000000D+02,  0.00000000000000D+00,
     &  1.03950000000000D+04,  0.00000000000000D+00,
     &  1.35135000000000D+05,  0.00000000000000D+00,
     &  2.02702500000000D+06,  0.00000000000000D+00,
     &  3.44594250000000D+07,  0.00000000000000D+00,
     &  6.54729075000000D+08,  0.00000000000000D+00,
     &  1.37493105750000D+10,  0.00000000000000D+00,
     &  3.16234143225000D+11,  0.00000000000000D+00,
     &  7.90585358062500D+12,  0.00000000000000D+00,
     &  2.13458046676875D+14,  0.00000000000000D+00,
     &  6.19028335362938D+15,  0.00000000000000D+00,
     &  1.91898783962511D+17,  0.00000000000000D+00/
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(KY*KY.GT.ZZMNTS).OR.(IDEGY.GT.16)) THEN
      WRITE(3,3002)
      RETURN
      ENDIF
C
C     GENERATE MOMENTS AND STORE IN MATRIX MNTS
C
      DO 30 IGAMMA=1,KY
      CALL MULTIY(IGAMMA,GAMMA)
C
      DO 30 IALPHA=1,KY
      CALL MULTIY(IALPHA,ALPHA)
C
      DO 10 I=1,M
10    OMEGA(I)=ALPHA(I)+GAMMA(I)
C
      DINT=1.D0
      DO 20 I=1,M
20    DINT=DINT*MOMENT(OMEGA(I)+1)
C
      MNTS(KY*(IGAMMA-1)+IALPHA)=DINT
30    CONTINUE
C
      RETURN
3002  FORMAT(' ERROR RETURN FROM SETUPM:'/
     &' M EXCEEDS 100, KY*KY EXCEEDS ZZMNTS, OR IDEGY EXCEEDS 16')
      END
C.hr EHYX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C
C     EHYX     12/7/88
C
C     PURPOSE
C     COMPUTE THE INTEGRAL OF AN UNNORMALIZED HERMITE CONDITIONAL
C     DENSITY,
C
C     EH = I..I {SUM_J  A(X,J)*[INV(R)(Y-B0-B*X)]**ALPHA(J)}**2
C                * N(Y | B0 + B*X, SIGMA) DY_1...DY_M
C
C     AND ITS DERIVATIVE,
C
C     DELEH = (D/D_THETA)EH
C
C     WHERE
C     A(X,J) = SUM_I A(I,J) X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C     THETA = (VEC'(A)|B0'|VEC'(B)|R11,R12,R22,R13,R23,R33,...,RMM)'
C     SIGMA = R*R'
C
C     NOTE
C     R IS UPPER TRIANGULAR, STORED COLUMNWISE IN COMPRESSED FORM,
C     THE FACTOR N(Y | B0 + B*X, SIGMA) IS A VECTOR AUTOREGRESSION
C     (VAR), THE DEPENDENCE OF THE POLYNOMIAL IN Y ON X ACCOMMODATES
C     CONDITIONAL HETEROSKEDASTICITY AND NONLINEARITY
C
C     USAGE
C     CALL EHYX(Y,X,EH,DELEH,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
C
C     WARNING
C     IF ZZLIM IS CHANGED HERE IT MUST BE CHANGED IN SUBROUTINE SETPRD
C     AS WELL.
C
C     SUBROUTINES CALLED
C     SETMYX,SETUPM,SETPRD
C
C     ARGUMENTS
C     Y    - M-VECTOR USED AS WORKSPACE, M MUST BE LESS THAN 100
C            REAL*8
C     X    - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C            X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C            INPUT, REAL*8
C     EH   - COMPUTED VALUE OF THE INTEGRAL OF THE DENSITY
C            OUTPUT, REAL*8
C     DELEH- COMPUTED GRADIENT OF EH WITH RESPECT TO THETA, A VECTOR OF
C            LENGTH KX*KY+M+M*M*L+M*(M+1)/2
C            OUTPUT, REAL*8
C     A    - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C            COLUMNWISE 
C            INPUT, REAL*8
C     B0   - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C            INPUT, REAL*8
C     B    - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C            STORED COLUMNWISE
C            INPUT, REAL*8
C     R    - AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C            FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE VAR
C            STORED COLUMNWISE, EG. R=(R11,R12,R22,R13,R23,R33,...,RMM)
C            SIGMA=R*R', THIS IS NOT THE STANDARD CHOLESKY FACTORIZATION
C            AS IT IS UPPER TRIANGULAR, NOT LOWER, USE SUBROUTINE FACTOR
C            TO COMPUTE IT FROM SIGMA, GIVEN SIGMA.
C            INPUT, REAL*8
C     M    - DIMENSION OF THE TIME SERIES, IE. LENGTH OF Y_T, MUST BE
C            LESS THAN 100
C            INPUT, INTEGER*4
C     L    - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C            INPUT, INTEGER*4
C     KY   - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     KX   - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     IDEGY- DEGREE OF THE POLYNOMIAL IN Y, MUST BE LESS THAN 16, SEE
C            REMARK BELOW
C            INPUT, INTEGER*4
C     IDEGX- DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     WORK - WORK VECTOR OF LENGTH 2*KY
C            REAL*8
C
C     REMARK
C     THE CALLS:
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     CALL SETUPM(IDEGY,M,KY)
C     CALL SETPRD(M,L,KY,KX,IDEGY,IDEGX)
C     MUST PRECEDE USAGE OF THIS ROUTINE, IN THAT ORDER
C
      SUBROUTINE EHYX(Y,X,EH,DELEH,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     NOTE:    ZZMNTS IS MAXIMUM LENGTH OF ARRAY OF GAUSSIAN MOMENTS.
C     WARNING: IF ZZMNTS IS CHANGED HERE IT MUST BE CHANGED IN
C              SUBROUTINES SETUPM AND EYLX AS WELL
C
      INTEGER     ZZMNTS
      PARAMETER ( ZZMNTS = 3000 )
      REAL*8 Y(1),X(1),EH,DELEH(1)
      REAL*8 A(1),B0(1),B(1),R(1)
      REAL*8 WORK(1)
      REAL*8 MNTS(ZZMNTS)
      COMMON /ZMNTS/MNTS
C
C     LOGICAL:
C     REAL*8 Y(M),X(M*L),DELEH(KX*KY+M+M*M*L+M*(M+1)/2)
C     REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
C     OR:
C     REAL*8 Y(M),X(M,L),A(KX,KY)
C
C-----------------------------------------------------------------------
C     DECLARATIONS SHARED BETWEEN SETPRD, PZX, EHYX, AND LNHYX 
C-----------------------------------------------------------------------
      INTEGER*4  ZZLIM
      PARAMETER (ZZLIM=500)
      INTEGER*4 IY(ZZLIM),IDY(ZZLIM),IX(ZZLIM)
      COMMON /ZSETPR/ IY,IDY,IX
C-----------------------------------------------------------------------
C
C     LOGICAL:
C     INTEGER*4 IY(2,KY),IDY(M,KY),IX(2,KX)
C-----------------------------------------------------------------------
      SAVE
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(M*L.GT.100).OR.(KY*KY.GT.ZZMNTS)
     &.OR.(IDEGY.GT.16)) THEN
      WRITE(3,3002)
      RETURN
      ENDIF
C
C     COMPUTE POINTERS TO STACKED PARAMETER VECTOR, USED TO POINT TO
C     ELEMENTS OF DELEH=(D/DTHETA)EH(Y|X,THETA)
C
      IBA  = 0
      IBB0 = IBA   +KX*KY
      IBB  = IBB0  + M
      IBR  = IBB   + M*M*L
      LTHETA=IBR+M*(M+1)/2
C
C     IAA  = IBA +1
C     IAB0 = IBB0+1
C     IAB  = IBB +1
C     IAR  = IBR +1
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBAX = 0
      IBAXM= IBAX +KY
C     LWORK= IBAXM+KY
C
C     IAAX = IBAX +1
C     IAAXM= IBAXM+1
C
C     COMPUTE LENGTHS OF VARIOUS ARRAYS
C
      ML=M*L
C
C     INITIALIZE DELEH
C
      DO 10 I=1,LTHETA
 10   DELEH(IBA+I)=0.D0
C
C     STORE THE MONOMIALS FOR X IN FIRST COLUMN OF DELEH
C
      DELEH(IBA+1)=1.D0
      IF(KX.LE.1) GO TO 15
      DO 14 IBETA=2,KX
      IX1=IX(2*(IBETA-1)+1)
      IX2=IX(2*(IBETA-1)+2)
14    DELEH(IBA+IBETA)=DELEH(IBA+IX1)*X(IX2)
15    CONTINUE
C
C     COMPUTE A(X)
C
      DO 20 IALPHA=1,KY
20    WORK(IBAX+IALPHA)=0.D0
      DO 50 IBETA =1,KX
      XBETA=DELEH(IBA+IBETA)
      DO 40 IALPHA=1,KY
40    WORK(IBAX+IALPHA)=WORK(IBAX+IALPHA)+A(KX*(IALPHA-1)+IBETA)*XBETA
50    CONTINUE
C
C     COMPUTE A'(X)M
C
      DO 60 IGAMMA=1,KY
60    WORK(IBAXM+IGAMMA)=0.D0
      DO 70 IGAMMA=1,KY
      DO 70 IALPHA=1,KY
70    WORK(IBAXM+IGAMMA)=WORK(IBAXM+IGAMMA)
     &   +WORK(IBAX+IALPHA)*MNTS(KY*(IGAMMA-1)+IALPHA)
C
C     COMPUTE DELEH
C
      DO 90 IALPHA=1,KY
      JALPHA=KY-(IALPHA-1)
      DO 90 IBETA=1,KX
      XBETA=DELEH(IBA+IBETA)
90    DELEH(IBA+KX*(JALPHA-1)+IBETA)=2.D0*XBETA*WORK(IBAXM+JALPHA)
C
C     COMPUTE EH
C
      SUM=0.D0
      DO 110 IALPHA=1,KY
110   SUM=SUM+WORK(IBAXM+IALPHA)*WORK(IBAX+IALPHA)
C
      EH=SUM
C
      RETURN
 3002 FORMAT(' ERROR RETURN FROM EHYX:'/
     &' M OR M*L EXCEEDS 100, KY*KY EXCEEDS ZZMNTS, OR IDEGY'/
     &' EXCEEDS 16')
      END
C.hr EYLX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     EYLX     11/17/87
C
C     PURPOSE
C     COMPUTE THE LAMBDA'TH MOMENT OF  INV(R)(Y-B0-B*X)  OF AN
C     UNNORMALIZED HERMITE CONDITIONAL DENSITY
C
C     E{INV(R)(Y-B0-B*X)[**LAMBDA|X,THETA}
C        = I...I [INV(R)(Y-B0-B*X)]**LAMBDA * H(Y|X,THETA)
C
C     AND ITS DERIVATIVE
C
C     (D/D_THETA)E{INV(R)(Y-B0-B*X)[**LAMBDA|X,THETA}
C
C     WHERE
C     H(Y|X,THETA)= [SUM_J  A(X,J)*[INV(R)(Y-B0-B*X)]**ALPHA(I)]**2
C                     * N(Y | B0 + B*X, SIGMA)
C     A(X,J) = SUM_I A(I,J) X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C     THETA = (VEC'(A)|B0|VEC'(B)|R11,R12,R22,R13,R23,R33,...,RMM)'
C     SIGMA = R*R'
C
C     NOTE
C     R IS UPPER TRIANGULAR, STORED COLUMNWISE IN COMPRESSED FORM,
C     THE FACTOR N(Y | B0 + B*X, SIGMA) IS A VECTOR AUTOREGRESSION
C     (VAR), THE DEPENDENCE OF THE POLYNOMIAL IN Y ON X ACCOMMODATES
C     CONDITIONAL HETEROSKEDASTICITY AND NONLINEARITY
C
C     USAGE
C     CALL EYLX(LAMBDA,Y,X,EYL,DEL,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
C
C     SUBROUTINES CALLED
C     MULTIY,MULTIX,SETMYX,SETUPM,EHYX
C
C     REMARK:
C     THE FOLLOWING USAGE WILL COMPUTE THE MOMENTS OF THE NORMALIZED
C     DENSITY:
C     CALL EYLX(LAMBDA,Y,X,EYL,DEL,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
C     CALL EHYX(Y,X,EH,DELH,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
C     EYL=EYL/EH
C     DO 10 I=1,KX*KY+M+M*M*L+M*(M+1)/2
C10   DEL(I)=DEL(I)/EH-(EYL/EH)*DELH(I)
C
C     ARGUMENTS
C     LAMBDA- A MULTI-INDEX THAT DEFINES THE MOMENT.  I.E. LAMBDA IS
C             AN M-VECTOR OF NONNEGATIVE INTEGERS, THE I'TH ELEMENT
C             OF (Y-B0-B*X) IS TO BE RAISED TO THE POWER OF THE I'TH
C             ELEMENT OF LAMBDA.  M MUST BE LESS THAN 100.
C             INPUT, INTEGER*4
C     Y     - M-VECTOR USED AS WORKSPACE, M MUST BE LESS THAN 100
C             REAL*8
C     X     - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C             X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C     EYL   - COMPUTED LAMBDA'TH MOMENT ABOUT B0+B*X
C             OUTPUT, REAL*8
C     DEL   - COMPUTED GRADIENT OF EYL WITH RESPECT TO THETA, A VECTOR
C             OF LENGTH KX*KY+M+M*M*L+M*(M+1)/2
C             OUTPUT, REAL*8
C     A     - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C             COLUMNWISE
C             INPUT, REAL*8
C     B0    - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C             INPUT, REAL*8
C     B     - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C             STORED COLUMNWISE
C             INPUT, REAL*8
C     R     - AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C             CHOLESKY FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE
C             VAR STORED COLUMNWISE, R=(R11,R12,R22,R13,R23,R33,...,RMM)
C             SIGMA=R*R'
C             INPUT, REAL*8
C     M     - DIMENSION OF THE TIME SERIES, IE. LENGTH OF Y_T, MUST BE
C             LESS THAN 100
C             INPUT, INTEGER*4
C     L     - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C             INPUT, INTEGER*4
C     KY    - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     KX    - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     IDEGY - DEGREE OF THE POYNOMIAL IN Y, MUST BE LESS THAN 16, SEE
C             REMARK BELOW
C             INPUT, INTEGER*4
C     IDEGX - DEGREE OF THE POYNOMIAL IN X, SEE REMARK BELOW
C             INPUT, INTEGER*4
C     WORK  - WORK VECTOR OF LENGTH 2*KY
C             REAL*8
C
C     REMARK
C     THE CALLS:
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     CALL SETUPM(IDEGY,M,KY)
C     MUST PRECEDE USAGE OF THIS ROUTINE, IN THAT ORDER
C
      SUBROUTINE
     &   EYLX(LAMBDA,Y,X,EYL,DEL,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     NOTE:    ZZMNTS IS MAXIMUM LENGTH OF ARRAY OF GAUSSIAN MOMENTS.
C     WARNING: IF ZZMNTS IS CHANGED HERE IT MUST BE CHANGED IN
C              SUBROUTINE SETUPM AND EHYX AS WELL
C
      INTEGER     ZZMNTS
      PARAMETER ( ZZMNTS = 3000 )
      REAL*8 Y(1),X(1),EYL,DEL(1)
      REAL*8 A(1),B0(1),B(1),R(1)
      REAL*8 WORK(1)
      INTEGER*4 ALPHA(100),BETA(100),GAMMA(100),OMEGA(100)
      INTEGER*4 LAMBDA(100),COPY(100),ENTRY
      REAL*8 MOMENT(34),LMNTS(ZZMNTS)
      SAVE
      DATA ENTRY/0/
      DATA MOMENT/
     &  1.00000000000000D+00,  0.00000000000000D+00,
     &  1.00000000000000D+00,  0.00000000000000D+00,
     &  3.00000000000000D+00,  0.00000000000000D+00,
     &  1.50000000000000D+01,  0.00000000000000D+00,
     &  1.05000000000000D+02,  0.00000000000000D+00,
     &  9.45000000000000D+02,  0.00000000000000D+00,
     &  1.03950000000000D+04,  0.00000000000000D+00,
     &  1.35135000000000D+05,  0.00000000000000D+00,
     &  2.02702500000000D+06,  0.00000000000000D+00,
     &  3.44594250000000D+07,  0.00000000000000D+00,
     &  6.54729075000000D+08,  0.00000000000000D+00,
     &  1.37493105750000D+10,  0.00000000000000D+00,
     &  3.16234143225000D+11,  0.00000000000000D+00,
     &  7.90585358062500D+12,  0.00000000000000D+00,
     &  2.13458046676875D+14,  0.00000000000000D+00,
     &  6.19028335362938D+15,  0.00000000000000D+00,
     &  1.91898783962511D+17,  0.00000000000000D+00/
C
C     LOGICAL:
C     REAL*8 Y(M),X(M*L),DEL(KX*KY+M+M*M*L+M*(M+1)/2)
C     REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
C     INTEGER*4 ALPHA(M),BETA(M*L),GAMMA(M)
C     OR:
C     REAL*8 Y(M),X(M,L),A(KX,KY)
C
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(M*L.GT.100).OR.(KY*KY.GT.ZZMNTS)
     &.OR.(IDEGY.GT.16)) THEN
      WRITE(3,3002)
      RETURN
      ENDIF
C
C     COMPUTE POINTERS TO STACKED PARAMETER VECTOR, USED TO POINT TO
C     ELEMENTS OF DEL
C
      DO 5 I=1,M
 5    IF (COPY(I).NE.LAMBDA(I)) ENTRY=0
C
      IF (ENTRY.EQ.0) THEN
C
C     GENERATE MOMENTS AND STORE IN MATRIX LMNTS
C
      DO 30 IGAMMA=1,KY
      CALL MULTIY(IGAMMA,GAMMA)
C
      DO 30 IALPHA=1,KY
      CALL MULTIY(IALPHA,ALPHA)
C
      DO 10 I=1,M
10    OMEGA(I)=ALPHA(I)+GAMMA(I)+LAMBDA(I)
C
      DINT=1.D0
      DO 20 I=1,M
20    DINT=DINT*MOMENT(OMEGA(I)+1)
C
      LMNTS(KY*(IGAMMA-1)+IALPHA)=DINT
30    CONTINUE
C
      ENDIF
C
      IBA  = 0
      IBB0 = IBA   +KX*KY
      IBB  = IBB0  + M
      IBR  = IBB   + M*M*L
      LTHETA=IBR+M*(M+1)/2
C
C     IAA  = IBA +1
C     IAB0 = IBB0+1
C     IAB  = IBB +1
C     IAR  = IBR +1
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBAX = 0
      IBAXM= IBAX +KY
C     LWORK= IBAXM+KY
C
C     IAAX = IBAX +1
C     IAAXM= IBAXM+1
C
C     COMPUTE LENGTHS OF VARIOUS ARRAYS
C
      ML=M*L
C
C     INITIALIZE DEL TO ZERO
C
      DO 110 I=1,LTHETA
 110  DEL(IBA+I)=0.D0
C
C     COMPUTE A(X)
C
      DO 120 IALPHA=1,KY
 120  WORK(IBAX+IALPHA)=0.D0
      DO 150 IBETA =1,KX
      CALL MULTIX(IBETA,BETA)
      XBETA=1.D0
      DO 130 I=1,ML
 130  IF (BETA(I).GT.0) XBETA=XBETA*(X(I)**BETA(I))
      DO 140 IALPHA=1,KY
 140  WORK(IBAX+IALPHA)=WORK(IBAX+IALPHA)+A(KX*(IALPHA-1)+IBETA)*XBETA
 150  CONTINUE
C
C     COMPUTE A'(X)M
C
      DO 160 IGAMMA=1,KY
 160  WORK(IBAXM+IGAMMA)=0.D0
      DO 170 IGAMMA=1,KY
      DO 170 IALPHA=1,KY
 170  WORK(IBAXM+IGAMMA)=WORK(IBAXM+IGAMMA)
     &   +WORK(IBAX+IALPHA)*LMNTS(KY*(IGAMMA-1)+IALPHA)
C
C     COMPUTE DEL
C
      SUM=0.D0
      DO 200 IBETA =1,KX
      CALL MULTIX(IBETA,BETA)
      XBETA=1.D0
      DO 180 I=1,ML
 180  IF (BETA(I).GT.0) XBETA=XBETA*(X(I)**BETA(I))
C
      DO 190 IALPHA=1,KY
C
 190  DEL(IBA+KX*(IALPHA-1)+IBETA)=2.D0*XBETA*WORK(IBAXM+IALPHA)
C
 200  CONTINUE
C
C     COMPUTE EYL
C
      SUM=0.D0
      DO 210 IALPHA=1,KY
 210  SUM=SUM+WORK(IBAXM+IALPHA)*WORK(IBAX+IALPHA)
C
      EYL=SUM
C
      ENTRY=1
      DO 220 I=1,M
 220  COPY(I)=LAMBDA(I)
C
      RETURN
 3002 FORMAT(' ERROR RETURN FROM EYLX:'/
     &' M OR M*L EXCEEDS 100, KY*KY EXCEEDS ZZMNTS, OR IDEGY'/
     &' EXCEEDS 16')
      END
C.hr LNHYX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     LNHYX      12/5/88
C
C     PURPOSE
C     COMPUTE AN UNNORMALIZED LOG HERMITE CONDITIONAL DENSITY,
C
C     H(Y|X,THETA)
C        = LN {SUM_J  A(X,J)*[INV(R)*(Y-B0-B*X)]**ALPHA(J)}**2
C                  * N(Y | B0 + B*X, SIGMA)
C
C     AND ITS DERIVATIVE,
C
C     DELH(Y|X,THETA) = (D/D_THETA) LN H(Y|X,THETA)
C
C     WHERE
C     A(X,J) = SUM_I A(I,J) X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C     THETA = (VEC'(A)|B0'|VEC'(B)|R11,R12,R22,R13,R23,R33,...,RMM)'
C     SIGMA = R*R'
C
C     NOTE
C     R IS UPPER TRIANGULAR, STORED COLUMNWISE IN COMPRESSED
C     FORM,THE FACTOR N(Y | B0 + B*X, SIGMA) IS A VECTOR AUTOREGRESSION
C     (VAR), THE DEPENDENCE OF THE POLYNOMIAL IN Y ON X ACCOMMODATES
C     CONDITIONAL HETEROSKEDASTICITY AND NONLINEARITY
C
C     USAGE
C     CALL LNYX(Y,X,H,DELH,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
C
C     WARNING
C     IF ZZLIM IS CHANGED HERE IT MUST BE CHANGED IN SUBROUTINE SETPRD
C     AND EHYX AS WELL.
C     IF ZZMID IS CHANGED HERE IT MUST BE CHANGED IN SETMYX, MULTIY,
C     MULTIX, AND EHYX AS WELL.
C
C     SUBROUTINES CALLED
C     DRINV,MULTIY,MULTIX,SETMYX,SETPRD
C
C     ARGUMENTS
C     Y    - M-VECTOR OF CONTEMPORANEOUS VALUES Y_T OF THE TIME SERIES
C            M MUST BE LESS THAN 100
C            INPUT, REAL*8
C     X    - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C            X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C            INPUT, REAL*8
C     H    - COMPUTED VALUE OF THE LOG DENSITY
C            OUTPUT, REAL*8
C     DELH - COMPUTED GRADIENT OF H WITH RESPECT TO THETA, A VECTOR
C            OF LENGTH KX*KY+M+M*M*L+M*(M+1)/2
C            OUTPUT, REAL*8
C     A    - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C            COLUMNWISE
C            INPUT, REAL*8
C     B0   - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C            INPUT, REAL*8
C     B    - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C            STORED COLUMNWISE
C            INPUT, REAL*8
C     R    - AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C            FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE VAR
C            STORED COLUMNWISE, EG. R=(R11,R12,R22,R13,R23,R33,...,RMM)
C            SIGMA=R*R', THIS IS NOT THE STANDARD CHOLESKY FACTORIZATION
C            AS IT IS UPPER TRIANGULAR, NOT LOWER, USE SUBROUTINE FACTOR
C            TO COMPUTE IT FROM SIGMA, GIVEN SIGMA.
C            INPUT, REAL*8
C     M    - DIMENSION OF THE TIME SERIES, IE. LENGTH OF Y_T, MUST BE
C            LESS THAN 100
C            INPUT, INTEGER*4
C     L    - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C            INPUT, INTEGER*4
C     KY   - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     KX   - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     IDEGY- DEGREE OF THE POLYNOMIAL IN Y, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     IDEGX- DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     WORK - WORK VECTOR OF LENGTH 1+M+M*(M+1)/2+M+M.
C            REAL*8
C
C     REMARK
C     THE CALLS
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     CALL SETPRD(M,L,KY,KX,IDEGY,IDEGX)
C     MUST PRECEDE USAGE OF THIS ROUTINE, IN THAT ORDER.
C
      SUBROUTINE LNHYX(Y,X,H,DELH,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y(1),X(1),DELH(1)
      REAL*8 A(1),B0(1),B(1),R(1)
      REAL*8 WORK(1)
      INTEGER*4 ALPHA(100)
C
C----Declarations for direct access of multi-indexes ------------------
C
      INTEGER ZZMID
      PARAMETER ( ZZMID = 5000 )
      INTEGER MIDYX(ZZMID)
      COMMON /ZSVMYX/ MIDYX
C
C     NOTE:
C        MIDYX(1..M*KY)            = Y MULTINDEXES STORED AS MxKY ARRAY
C        MIDYX(M*KY+1..M*KY+ML*KX) = X MULTINDEXES STORED AS MLxKX ARRAY
C
C     WARNING:
C        The value of the parameter ZZMID must agree with the value
C        set in the routines SETMYX, MULTIY, MULTIX, and also with
C        the value set in other routines containing these declarations.
C
C-----------------------------------------------------------------------
C
C-----------------------------------------------------------------------
C     DECLARATIONS SHARED BETWEEN SETPRD, PZX, EHYX, AND LNHYX
C-----------------------------------------------------------------------
      INTEGER*4  ZZLIM
      PARAMETER (ZZLIM=500)
      INTEGER*4 IY(ZZLIM),IDY(ZZLIM),IX(ZZLIM)
      COMMON /ZSETPR/ IY,IDY,IX
C-----------------------------------------------------------------------
C
C     LOGICAL:
C     INTEGER*4 IY(2,KY),IDY(M,KY),IX(2,KX)
C
C     11/9/86
C     THIS ROUTINE WAS CODED BY USING THE CODE FROM HYX, REMOVING ALL
C     MULTIPLICATIONS BY EXPQ, AND ADJUSTING THE LAST THREE STATEMENTS
C     BEFORE THE RETURN.  TO MAKE SENSE OF THE COMMENTS BELOW, READ
C     1.D0 FOR EXPQ.
C
C     12/5/88
C     LOOP 160 WAS MODIFIED TO IMPROVE EFFICIENCY.  LOGICALLY IT IS THE
C     SAME AS LOOP 160 IN HYX.
C
C     LOGICAL:
C     REAL*8 Y(M),X(M*L),DELH(KX*KY+M+M*M*L+M*(M+1)/2+1)
C     REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
C     INTEGER*4 ALPHA(M)
C     OR:
C     REAL*8 Y(M),X(M,L),A(KX,KY)
C
C-----------------------------------------------------------------------
      SAVE
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(M*L.GT.100)) THEN
      WRITE(3,3002)
      RETURN
      ENDIF
C
C     COMPUTE POINTERS TO STACKED PARAMETER VECTOR, USED TO POINT TO
C     ELEMENTS OF DELH=(D/DTHETA)H(Y|X,THETA)
C
      IBA  = 0
      IBB0 = IBA +KX*KY
      IBB  = IBB0+M
      IBR  = IBB +M*M*L
      LTHETA=IBR +M*(M+1)/2
C
      IAA  = IBA +1
      IAB0 = IBB0+1
      IAB  = IBB +1
      IAR  = IBR +1
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBN   =0
      IBSZ  =IBN   +1
      IBRINV=IBSZ  +M
      IBZ   =IBRINV+M*(M+1)/2
      IBDZP =IBZ   +M
      LWORK =IBDZP +M
C
      IAN   =IBN   +1
      IASZ  =IBSZ  +1
      IARINV=IBRINV+1
      IAZ   =IBZ   +1
      IADZP =IBDZP +1
C
C     COMPUTE LENGTHS OF VARIOUS ARRAYS
C
      LA=KY*KX
      LR=M*(M+1)/2
      ML=M*L
C
C     INITIALIZE DELH TO ZERO
C
      DO 10 I=1,LTHETA
10    DELH(IBA+I)=0.D0
C
C     COMPUTE Z=INV(R)(Y-B0-B*X)
C
      DO 20 I=1,M
20    WORK(IBSZ+I)=Y(I)-B0(I)
      DO 30 J=1,ML
      DO 30 I=1,M
30    WORK(IBSZ+I)=WORK(IBSZ+I)-B(M*(J-1)+I)*X(J)
      DO 40 I=1,LR
40    WORK(IBRINV+I)=R(I)
      CALL DRINV(WORK(IARINV),M)
      DO 50 I=1,M
50    WORK(IBZ+I)=0.D0
      DO 60 J=1,M
      DO 60 I=1,J
60    WORK(IBZ+I)=WORK(IBZ+I)+WORK(IBRINV+J*(J-1)/2+I)*WORK(IBSZ+J)
C
C     COMPUTE P, (D/DA)P, AND (D/DZ)P
C
C     INITIALIZE ACCUMULATORS FOR P AND (D/DZ)P
      P=0.D0
      DO 100 I=1,M
100   WORK(IBDZP+I)=0.D0
C
C     ------------------------------------------------------------------
C     12/5/88 MODIFICATION OF LOOP 160
C     ------------------------------------------------------------------
C
C     INITIALIZE WY & WX, STORED AS LEADING ROW AND COLUMN OF (D/DA)P
C     WHICH IS THE LOGICAL KX*KY LEADING SUBMATRIX OF DELH.
C
      DELH(IBA+1)=1.D0
      IF(KY.LE.1) GO TO 103
      DO 102 IALPHA=2,KY
      IY1=IY(2*(IALPHA-1)+1)
      IY2=IY(2*(IALPHA-1)+2)
102   DELH(IBA+KX*(IALPHA-1)+1)=DELH(IBA+KX*(IY1-1)+1)*WORK(IBZ+IY2)
103   CONTINUE
      IF(KX.LE.1) GO TO 105
      DO 104 IBETA=2,KX
      IX1=IX(2*(IBETA-1)+1)
      IX2=IX(2*(IBETA-1)+2)
104   DELH(IBA+IBETA)=DELH(IBA+IX1)*X(IX2)
105   CONTINUE
C
C     COMPUTE P, (D/DZ)P, AND (D/DA)P
C
      DO 160 IALPHA=1,KY
C       DIRECT ACCESS OF MULTI-INDEXES, REPLACES
C       CALL MULTIY(IALPHA,ALPHA)
        DO 101 I=1,M
101     ALPHA(I)=MIDYX(M*(IALPHA-1)+I)
        YALPHA=DELH(IBA+KX*(IALPHA-1)+1)
        DO 130 I=1,M
        IDY0=IDY(M*(IALPHA-1)+I)
130     WORK(IBSZ+I)=ALPHA(I)*DELH(IBA+KX*(IDY0-1)+1)
      DO 160 IBETA=1,KX
        XBETA=DELH(IBA+IBETA)
C     ACCUMULATE THE MONOMIALS TO GET THE POLYNOMIAL P & (D/DZ)P
      P=P+A(KX*(IALPHA-1)+IBETA)*XBETA*YALPHA
      DO 150 I=1,M
150   WORK(IBDZP+I)=WORK(IBDZP+I)
     &             +A(KX*(IALPHA-1)+IBETA)*XBETA*WORK(IBSZ+I)
C     PUT THE MONOMIALS IN PROPER LOCATIONS TO GET (D/DA)P
      DELH(IBA+KX*(IALPHA-1)+IBETA)=XBETA*YALPHA
160   CONTINUE
C
C     ------------------------------------------------------------------
C
C     COMPUTE:
C     (D/DB0')P = [(D/DZ')P]*(-1)*INV(R)
C     (D/DB')P = [(D/DZ')P]*(-1)*INV(R)*(X'@I)
C        WHERE @ DENOTES KRONEKER PRODUCT
C     (D/DR_IJ)P
C        =[(D/DZ')P]*(-1)*INV(R)*T(IJ)*INV(R)*(Y-B0-B*X)
C        WHERE T(IJ) HAS A ONE IN THE IJ_TH ELEMENT AND ZEROES ELSEWHERE
C
      DO 165 I=1,M
165   WORK(IBSZ+I)=0.D0
      DO 170 J=1,M
      DO 170 I=1,J
170   WORK(IBSZ+J)=WORK(IBSZ+J)+WORK(IBRINV+J*(J-1)/2+I)*WORK(IBDZP+I)
      DO 180 I=1,M
180   DELH(IBB0+I)=-WORK(IBSZ+I)
      DO 190 J=1,ML
      DO 190 I=1,M
      IJ=M*(J-1)+I
190   DELH(IBB+IJ)=-X(J)*WORK(IBSZ+I)
      DO 195 J=1,M
      DO 195 I=1,J
      IJ=J*(J-1)/2+I
195   DELH(IBR+IJ)=-WORK(IBSZ+I)*WORK(IBZ+J)
C
C     COMPUTE P**2 AND (D/DTHETA)(P**2)
C
      DO 250 I=1,LTHETA
250   DELH(IBA+I)=2.D0*P*DELH(IBA+I)
      P2=P*P
C
C     COMPUTE DABS[1/DET(R)] AND (D/DTHETA)DABS[1/DET(R)]
C
      DETR=1.D0
      DO 260 I=1,M
260   DETR=DETR*R(I*(I-1)/2+I)
      DETR=DABS(DETR)
      SR=1.D0/DETR
      DELSR=-SR*SR
      DO 270 I=1,M
      IJ=I*(I-1)/2+I
      DELH(IBR+IJ)=DELH(IBR+IJ)+(P2/SR)*DELSR*DETR/R(IJ)
270   CONTINUE
C
C     COMPUTE P**2*DABS[1/DET(R)] AND ADJUST DERIVATIVES
C
      H=P2*SR
      DO 280 I=1,LTHETA
280   DELH(IBA+I)=DELH(IBA+I)*SR
C
C     COMPUTE EXP(Q) = EXP[(-1/2)(Y-B0-B*X)'INV(R')INV(R)(Y-B0-B*X)]
C        AND (D/DTHETA)EXP(Q)
C     (D/DB0')EXP(Q)=EXP(Q)(Y-B0-B*X)'*INV'(R)*INV(R)
C     (D/DB')EXP(Q) =EXP(Q)(Y-B0-B*X)'*INV'(R)*INV(R)*(X'@I)
C        WHERE @ DENOTES KRONEKER PRODUCT
C     (D/DR_IJ)EXP(Q)
C        =EXP(Q)[INV(R)*(Y-B0-B*X)]'*INV(R)*T(IJ)*[INV(R)*(Y-B0-B*X)]
C        WHERE T(IJ) HAS A ONE IN THE IJ_TH ELEMENT AND ZEROES ELSEWHERE
C
      Q=0.D0
      DO 350 I=1,M
350   Q=Q+WORK(IBZ+I)**2
      Q=-0.5D0*Q
C     EXPQ=DEXP(Q)
      DO 360 I=1,M
360   WORK(IBSZ+I)=0.D0
      DO 370 J=1,M
      DO 370 I=1,J
370   WORK(IBSZ+J)=WORK(IBSZ+J)+WORK(IBRINV+J*(J-1)/2+I)*WORK(IBZ+I)
      DO 380 I=1,M
380   DELH(IBB0+I)=DELH(IBB0+I)+H*WORK(IBSZ+I)
      DO 390 J=1,ML
      DO 390 I=1,M
      IJ=M*(J-1)+I
390   DELH(IBB+IJ)=DELH(IBB+IJ)+H*X(J)*WORK(IBSZ+I)
      DO 395 J=1,M
      DO 395 I=1,J
      IJ=J*(J-1)/2+I
395   DELH(IBR+IJ)=DELH(IBR+IJ)+H*WORK(IBSZ+I)*WORK(IBZ+J)
C
C     COMPUTE H=P**2*DEXP[1/DET(R)]*EXP(Q)*{DSQRT[1/(2*PI)]}**M
C     AND ADJUST DERIVATIVES
C
      SCALE=0.39894228040143267794D0**M
      DO 430 I=1,LTHETA
430   DELH(IBA+I)=DELH(IBA+I)/H
      H=DLOG(SCALE*H)+Q
C
C     WORK(IAN)=SCALE*SR*EXPQ
C
      RETURN
3002  FORMAT(' ERROR RETURN FROM LNHYX, M OR M*L EXCEEDS 100')
      END
C.hr PZX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     PZX      9/1/91
C
C     PURPOSE
C     COMPUTE THE POLYNOMIAL
C
C     P(Z|X,A)=[SUM_J  A(X,J)*Z**ALPHA(J)]**2
C
C     AND ITS DERIVATIVES
C
C     DELAP = (D/D_A)P(Z|X,A)
C     DELZP = (D/D_Z)P(Z|X,A)
C
C     WHERE
C     A(X,J) = SUM_I A(I,J)*X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C
C     USAGE
C     CALL PYZ(Z,X,P,DELAP,DELZP,A,M,L,KY,KX,WORK)
C
C     SUBROUTINES CALLED
C     SETMYX,SETPRD
C
C     ARGUMENTS
C     Z     - M-VECTOR OF NORMALIZED VALUES Z=INV(R)*(Y_T-B0-B*X) OF 
C             THE TIME SERIES Y. M MUST BE LESS THAN 100.
C             INPUT, REAL*8
C     X     - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C             X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100.
C             INPUT, REAL*8
C     P     - COMPUTED VALUE OF THE POLYNOMIAL.
C             OUTPUT, REAL*8
C     DELAP - COMPUTED GRADIENT OF P WITH RESPECT TO A, A VECTOR OF
C             LENGTH KX*KY.
C             OUTPUT, REAL*8
C     DELZP - COMPUTED GRADIENT OF H WITH RESPECT TO THETA, A VECTOR OF
C             LENGTH M.
C             OUTPUT, REAL*8
C     A     - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C             COLUMNWISE.
C             INPUT, REAL*8
C     M     - DIMENSION OF THE TIME SERIES, IE. LENGTH OF Y_T, MUST BE
C             LESS THAN 100.
C             INPUT, INTEGER*4
C     L     - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100.
C             INPUT, INTEGER*4
C     KY    - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY SETMYX,
C             SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     KX    - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY SETMYX,
C             SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     WORK  - WORK VECTOR OF LENGTH M.
C             REAL*8
C
C     REMARK
C     THE CALLS
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     CALL SETPRD(M,L,KY,KX,IDEGY,IDEGX)
C     MUST PRECEDE USE OF THIS ROUTINE
C
      SUBROUTINE PZX(Z,X,P,DELAP,DELZP,A,M,L,KY,KX,WORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      IMPLICIT INTEGER*4 (I-N)
      SAVE

      REAL*8 Z(M),X(M*L),DELAP(KX,KY),DELZP(M)
      REAL*8 A(KX,KY)
      REAL*8 WORK(M)
      REAL*8 P,TWOP,YALPHA,XBETA

      INTEGER*4 M,L,KY,KX
      INTEGER*4 IALPHA,IBETA,IY1,IY2,IDY0,IX1,IX2,I

C     MODIFIED 3/27/92 TO USE SETPRD (HORNER'S RULE) TO COMPUTE P.

C-----------------------------------------------------------------------
C     DECLARATIONS FOR DIRECT ACCESS OF MULTI-INDEXES 
C-----------------------------------------------------------------------
      INTEGER   ZZMID
      PARAMETER ( ZZMID = 5000 )
      INTEGER   MIDYX(ZZMID)
      COMMON /ZSVMYX/ MIDYX
C
C     NOTE:
C        MIDYX(1..M*KY)            = Y MULTINDEXES STORED AS MxKY ARRAY
C        MIDYX(M*KY+1..M*KY+ML*KX) = X MULTINDEXES STORED AS MLxKX ARRAY
C
C     WARNING:
C        The value of the parameter ZZMID must agree with the value
C        set in the routines SETMYX, MULTIY, MULTIX, and also with
C        the value set in other routines containing these declarations.
C
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
C     DECLARATIONS SHARED BETWEEN SETPRD, PZX, EHYX, AND LNHYX
C-----------------------------------------------------------------------
      INTEGER*4 ZZLIM
      PARAMETER (ZZLIM=500)
      INTEGER*4 IY(ZZLIM),IDY(ZZLIM),IX(ZZLIM)
      COMMON /ZSETPR/ IY,IDY,IX
C-----------------------------------------------------------------------

C     ZERO OUT ACCUMULATORS

      P=0.D0

      DO I=1,M
        DELZP(I)=0.D0
      END DO

C     INITIALIZE WY, STORED AS LEADING ROW OF (D/DA)P

      DELAP(1,1)=1.D0

      IF (KY.GT.1) THEN
        DO IALPHA=2,KY
          IY1=IY(2*(IALPHA-1)+1)
          IY2=IY(2*(IALPHA-1)+2)
          DELAP(1,IALPHA)=DELAP(1,IY1)*Z(IY2)
        END DO
      END IF

C     COMPUTE P, (D/DZ)P, AND (D/DA)P

      IF (KX.GT.1) THEN

C       INITIALIZE WX, STORED AS LEADING COLUMN OF (D/DA)P

        DO IBETA=2,KX
          IX1=IX(2*(IBETA-1)+1)
          IX2=IX(2*(IBETA-1)+2)
          DELAP(IBETA,1)=DELAP(IX1,1)*X(IX2)
        END DO

        DO IALPHA=1,KY

          YALPHA=DELAP(1,IALPHA)

          DO I=1,M
            IDY0=IDY(M*(IALPHA-1)+I)
            WORK(I)=DFLOAT(MIDYX(M*(IALPHA-1)+I))*DELAP(1,IDY0)
          END DO

        DO IBETA=1,KX

          XBETA=DELAP(IBETA,1)

          P=P+A(IBETA,IALPHA)*XBETA*YALPHA

          DO I=1,M
            DELZP(I)=DELZP(I)+A(IBETA,IALPHA)*XBETA*WORK(I)
          END DO

          DELAP(IBETA,IALPHA)=XBETA*YALPHA

        END DO
        END DO

      ELSE

        DO IALPHA=1,KY

          YALPHA=DELAP(1,IALPHA)

          DO I=1,M
            IDY0=IDY(M*(IALPHA-1)+I)
            DELZP(I)=DELZP(I)
     &        +DFLOAT(MIDYX(M*(IALPHA-1)+I))*(A(1,IALPHA)*DELAP(1,IDY0))
          END DO

          P=P+A(1,IALPHA)*YALPHA

        END DO

      END IF

C     COMPUTE P**2 AND (D/DA)(P**2)

      TWOP=2.D0*P

      DO IALPHA=1,KY
      DO IBETA=1,KX
        DELAP(IBETA,IALPHA)=TWOP*DELAP(IBETA,IALPHA)
      END DO
      END DO

      DO I=1,M
        DELZP(I)=TWOP*DELZP(I)
      END DO

      P = P*P

      RETURN
      END

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     density.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*
*     This file can be used as a templete in many pharmacokinetic 
*     applications; edit the lines marked with an X in column 73.

      subroutine density(isw)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      real*8 time,conc
      real*8 data
      real*8 Cl,V
      real*8 P,PwCl,PwV,PwS,Plag,PwClag,PwVlag,PwSlag
      real*8 E,O,OwCl,OwV,S,f,fwO,fwS
      real*8 Clwta1,Clwta2,Clwta3                                       X
      real*8 Vwtau1,Vwtau2,Vwtau3                                       X
      real*8 Swtau1,Swtau2,Swtau3                                       X
      real*8 Clwz1,Clwz2                                                X
      real*8 Vwz1,Vwz2                                                  X
      
      integer*4 i,isw
      integer*4 id0,id0lag,iptr
      integer*4 count,point

      real*8 vpow
      integer*4 mrows,mcols

      parameter (vpow=2.d0)                                             X
      parameter (mrows=2,mcols=2000)                                    X

      dimension count(mcols),point(mcols)
      dimension data(mrows,mcols)


*     If isw=1, read data; compute nobs, pointers, and counts.

      if (isw.eq.1) then

        open (unit=14,file='monoexp.dat',status='old',form='formatted') X

        nobs=0
        iptr=1
        count(iptr)=0
        point(iptr)=1
        id0lag=1

        do i=1,mcols
        
          read(14,14001,end=10) id0,time,conc                           X

          data(1,i)=time                                                X
          data(2,i)=conc                                                X

          nobs=nobs+1                                                   X

          if ((id0lag.eq.id0).or.(i.eq.1)) then
            count(iptr)=count(iptr)+1
          else
            iptr=iptr+1
            count(iptr)=1
            point(iptr)=i
            id0lag=id0
          end if
        end do
        
10      continue

        if (iptr.ne.ncases) then
          write(3,3901)
          stop
        end if

        close(14)
        return
      end if
      
      
*     If isw=2, compute the density.

      if (isw.eq.2) then

        Cl = dexp(tau(1)+z(1))                                          X
        V  = dexp(tau(2)+z(2))                                          X

        Clwz1 = Cl                                                      X
        Clwz2 = 0.d0                                                    X
        
        Vwz1  = 0.d0                                                    X
        Vwz2  = V                                                       X
 
        Clwta1 = Cl                                                     X
        Clwta2 = 0.d0                                                   X
        Clwta3 = 0.d0                                                   X

        Vwtau1 = 0.d0                                                   X
        Vwtau2 = V                                                      X
        Vwtau3 = 0.d0                                                   X

        Plag   = 1.d0
        PwClag = 0.d0
        PwVlag = 0.d0
        PwSlag = 0.d0

        do i=point(id),point(id)-1+count(id)
          time=data(1,i)                                                X
          conc=data(2,i)                                                X
          E = dexp(-(Cl/V)*time)
          O = (1.d0/V)*E
          OwV = (-1.d0/V**2)*E + O*(Cl/V**2)*time
          OwCl = O*(-1.d0/V)*time
          S = tau(3)                                                    X
          Swtau1 = 0.d0                                                 X
          Swtau2 = 0.d0                                                 X
          Swtau3 = 1.d0                                                 X
          call normalh(conc,O,S,vpow,f,fwO,fwS)
          P    = Plag*f
          PwS  = Plag*fwS + PwSlag*f
          PwCl = Plag*fwO*OwCl + PwClag*f
          PwV  = Plag*fwO*OwV + PwVlag*f
          Plag   = P
          PwSlag = PwS
          PwClag = PwCl
          PwVlag = PwV
        end do

        d = P

        dwtau(1) = PwCl*Clwta1 + PwV*Vwtau1 + PwS*Swtau1                X
        dwtau(2) = PwCl*Clwta2 + PwV*Vwtau2 + PwS*Swtau2                X
        dwtau(3) = PwCl*Clwta3 + PwV*Vwtau3 + PwS*Swtau3                X

        dwz(1) = PwCl*Clwz1 + PwV*Vwz1                                  X
        dwz(2) = PwCl*Clwz2 + PwV*Vwz2                                  X
        
        return
      end if


*     If isw=3, write random coefficients to unit 9.

      if (isw.eq.3) then
        write(9,9001) id,Cl,V
        return
      end if
        
        
*     If isw=4, print additional information if any.

      if (isw.eq.4) then
        return
      end if
      
      return
      
3901  format(1x,'error, density, error reading data')
9001  format(i5,2e30.18)
14001 format(i5,f8.0,d30.18)

      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      real*8 time,conc,dose
      real*8 dinter,age,height,weight
      real*8 album,glyco

      integer*4 form,observ,change,steady
      integer*4 race,smoker,lush
      integer*4 heart,creatn
      integer*4 index

      integer*4 mcols,debug

      parameter (mcols=6000,debug=2)

      dimension time(mcols),conc(mcols),dose(mcols)
      dimension dinter(mcols),age(mcols),height(mcols),weight(mcols)
      dimension album(mcols),glyco(mcols)
      dimension form(mcols),observ(mcols),change(mcols),steady(mcols)
      dimension race(mcols),smoker(mcols),lush(mcols)
      dimension heart(mcols),creatn(mcols)

      common /local/
     &  time,conc,dose,
     &  dinter,age,height,weight,
     &  album,glyco,
     &  form,observ,change,steady,
     &  race,smoker,lush,
     &  heart,creatn,
     &  index

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     simlat.f
*
*     Copyright (C) 1992.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine simlat()
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      real*8 V,W,work,u

      integer*4 jseed,i,ii,jj

      integer*4 mV,mwork

      parameter (mV=200,mwork=500)

      dimension V(mV),W(mV*mV),work(mwork),u(mM)

*     Error check.

      if (ntermz.gt.mV) then
        write(3,3901) ntermz
        stop
      end if

      open(unit=9,file=outfil,status='unknown',form='formatted')

*     If mwork is too small, whx should catch it.

      call whx(V,W,x,
     &  theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &  M,L,ntermz,ntermx,Kz,Kx,work,mwork)

      jseed=iseed

      do i=1,npt

        call sampz(jseed,u,V,W,M,ntermz,ntermx)

        do jj=1,M
          z(jj)=0.d0
        end do

        do jj=1,M
        do ii=1,jj
          z(ii)=z(ii)+theta(ibR+jj*(jj-1)/2+ii)*u(jj)
        end do
        end do

        do ii=1,M
          write(9,9001) z(ii)
        end do

      end do

      close(9)

      return
3901  format(1x,'error, simlat, increase mV to at least',i5)
9001  format(e30.18)
      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     normalh.f
*
*     Copyright (C) 1991,1992.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
    
*     Normalh computes the normal density evaluated at x and its deriv-
*     atives with respect to O and S.  The density is returned in f and
*     the derivatives in fwO and fwS.  O and vpow must be positive.

*     The mean of the density is O.  The variance of the density is
*     (S**2)*(O**vpow); that is, the variance is proportional to the
*     mean raised to the vpow power.

*     Normalh.f was substantially revised 3/28/92 to robustify the code
*     against negative and small values of O.   

*     The parameter eps is machine dependent.

*     Set the parameter eps to about 10,000 times the smallest real*8
*     that the machine can represent by editing the statement
*     parameter (eps=1.d-xxx)
*     For a machine with IEEE floats, such as a Sun SparcStation2, set
*     eps=1.d-300.  For an IBM System/370 machine, such as an IBM 3081,
*     set eps=1.d-80.  (The code has not been tested on IBM equipment.)

*     The value 10,000 = 100**2 above represents an assumption that 
*     normalh will not be called with x exceeding 100 in absolute value
*     when O is small.  If this assumption is violated, the computation 
*     of RV*(x-OO)**2 in the statement
*     logf = - 0.5d0*(RV*(x-OO)**2 + logV + log2pi)
*     may fail.

*     If x and S are such that RV and RV*(x-OO)**2 can be computed, 
*     then the code should not fail.

      subroutine normalh(x,O,S,vpow,f,fwO,fwS)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      real*8 x,O,S,vpow,f,fwO,fwS
      real*8 OO,SS,tol
      real*8 RV,logV,logf
      real*8 D,RVD,RVDD,fRVD,fRVDD

      integer*4 OOwO

      integer*4 ieeer,ieee_flags
      character*32 out
      
      real*8 log2pi,eps,vpsave 

      parameter (eps=1.d-300)
      parameter (log2pi=0.1837877066409345D+01)

      data vpsave /-500.d0/

      ieeer = ieee_flags('clear','exception','common',out)

      SS=dabs(S)

      if (vpow.ne.vpsave) then
        vpsave=vpow
        if (vpow.gt.1.d0) then
          tol=dexp(dlog(eps)/vpow)
        else
          tol=eps
        end if
      end if

      if (O.gt.tol) then
        OO=O
        OOwO=1
      else
        OO=tol
        OOwO=0
      end if
        
      logV=2.d0*dlog(SS)+vpow*dlog(OO)

      RV=dexp(-logV)

*     These three lines order the computations to protect against large
*     values of O.

      D=(x-O)
      RVD=RV*D
      RVDD=RVD*D

      logf = - 0.5d0*(RVDD + logV + log2pi)

      f=dexp(logf)

*     These two lines use small f to reduce the magnitude of RVDD prior 
*     to the division by OO below which helps when OO is small.

      fRVD=f*RVD
      fRVDD=fRVD*D

      if (OOwO.eq.1) then
        fwO = fRVD + 0.5d0*vpow*(fRVDD - f)/OO
      else
        fwO = 0.d0
      end if

      if (S.ge.0.d0) then
        fwS = (fRVDD - f)/SS
      else
        fwS = - (fRVDD - f)/SS
      end if

      ieeer = ieee_flags('get','exception','invalid',out)
      if (out.eq.'invalid') write(6,6901) out,x,O,S,vpow,f,fwO,fwS
      ieeer = ieee_flags('get','exception','overflow',out)
      if (out.eq.'overflow') write(6,6901) out,x,O,S,vpow,f,fwO,fwS
      ieeer = ieee_flags('get','exception','division',out)
      if (out.eq.'division') write(6,6901) out,x,O,S,vpow,f,fwO,fwS
      ieeer = ieee_flags('clear','exception','common',out)
      return
6901  format(a32,' x,O,S,vpow,f,fwO,fwS'/7d12.3)
      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine g(ka,kawtau,kawz,ke,kewtau,kewz,V,Vwtau,Vwz)     
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "../code/global.f"
      include "local.f"

      real*8 ka,kawtau,kawz
      real*8 ke,kewtau,kewz
      real*8 V,Vwtau,Vwz
      real*8 Cl,Clwtau,Clwz
      real*8 tmp
      real*8 cr,wt,gl

      integer*4 i

      dimension kawtau(mtau),kawz(mM)
      dimension kewtau(mtau),kewz(mM)
      dimension Vwtau(mtau),Vwz(mM)
      dimension Clwtau(mtau),Clwz(mM)

      if (M.ne.2) then
        write(3,3901)
        stop
      end if

      wt  = weight(index)
      gl  = glyco(index)
      tmp = creatn(index)
      if ((tmp.eq.0).or.(tmp.eq.1).or.(tmp.eq.2).or.
     &  (tmp.eq.4).or.(tmp.eq.7)) then
        cr = 1.d0
      else
        cr  = 0.0d0
      end if

      ka = dexp(tau(1))
      Cl = dexp(tau(2) + tau(4)*wt + tau(5)*gl + tau(6)*cr + z(1))
      V  = dexp(tau(3)+z(2))

      do i=1,ltau
        kawtau(i)=0.d0
        Clwtau(i)=0.d0 
        Vwtau(i)=0.d0
      end do

      do i=1,M
        kawz(i)=0.d0
        Clwz(i)=0.d0
        Vwz(i)=0.d0
      end do

      kawtau(1) = ka
      Clwtau(2) = Cl
      Vwtau(3)  = V
      Clwtau(4) = Cl*wt
      Clwtau(5) = Cl*gl
      Clwtau(6) = Cl*cr

      Clwz(1) = Cl
      Vwz(2)  = V

      ke = Cl/V
      do i=1,ltau
        kewtau(i) = Clwtau(i)/V - (ke/V)*Vwtau(i)
      end do
      do i=1,M
        kewz(i) = Clwz(i)/V - (ke/V)*Vwz(i)
      end do

      return
3901  format(1x,'error, g, this version is for M=2')
      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  LSSUBS FORTRAN
*
*     LSADD    LSADDS   LSBNDS   LSCHOL   LSCORE   LSCRSH   LSDEL
*     LSDFLT   LSFEAS   LSFILE   LSGETP   LSGSET   LSKEY    LSLOC
*     LSMOVE   LSMULS   LSOPTN   LSPRT    LSSETX   LSSOL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSADD ( UNITQ,
     $                   INFORM, IFIX, IADD, JADD,
     $                   NACTIV, NZ, NFREE, NRANK, NRES, NGQ,
     $                   N, LDA, LDZY, LDR, LDT,
     $                   KX, CONDMX,
     $                   A, R, T, RES, GQM, ZY,
     $                   W, C, S )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            KX(N)
      DOUBLE PRECISION   A(LDA,*), R(LDR,*), T(LDT,*),
     $                   RES(N,*), GQM(N,*), ZY(LDZY,*)
      DOUBLE PRECISION   W(N), C(N), S(N)

C***********************************************************************
C     LSADD   updates the factorization,  A(free) * (Z Y) = (0 T),  when
C     a constraint is added to the working set.  If  NRANK .gt. 0, the
C     factorization  ( R ) = PCQ  is also updated,  where  C  is the
C                    ( 0 )
C     least squares matrix,  R  is upper-triangular,  and  P  is an
C     orthogonal matrix.  The matrices  C  and  P  are not stored.
C
C     There are three separate cases to consider (although each case
C     shares code with another)...
C
C     (1) A free variable becomes fixed on one of its bounds when there
C         are already some general constraints in the working set.
C
C     (2) A free variable becomes fixed on one of its bounds when there
C         are only bound constraints in the working set.
C
C     (3) A general constraint (corresponding to row  IADD  of  A) is
C         added to the working set.
C
C     In cases (1) and (2), we assume that  KX(IFIX) = JADD.
C     In all cases,  JADD  is the index of the constraint being added.
C
C     If there are no general constraints in the working set,  the
C     matrix  Q = (Z Y)  is the identity and will not be touched.
C
C     If  NRES .GT. 0,  the row transformations are applied to the rows
C     of the  (N by NRES)  matrix  RES.
C     If  NGQ .GT. 0,  the column transformations are applied to the
C     columns of the  (NGQ by N)  matrix  GQM'.
C
C     Systems Optimization Laboratory, Stanford University.
C     Original version written 31-October--1984.
C     Level-2 matrix routines added 25-Apr-1988.
C     This version of  LSADD  dated 28-May-1988.
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
      COMMON    /SOL5CM/ ASIZE, DTMAX, DTMIN

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      LOGICAL            BOUND , OVERFL
      EXTERNAL           DDOT  , DDIV  , DNRM2
      INTRINSIC          MAX   , MIN
      PARAMETER         (ZERO = 0.0D+0, ONE = 1.0D+0)

*     If the condition estimator of the updated factors is greater than
*     CONDBD,  a warning message is printed.

      CONDBD = ONE / EPSPT9

      OVERFL = .FALSE.
      BOUND  = JADD .LE. N

      IF (BOUND) THEN
*        ===============================================================
*        A simple bound has entered the working set.  IADD  is not used.
*        ===============================================================
         IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $      WRITE (NOUT, 1010) NACTIV, NZ, NFREE, IFIX, JADD, UNITQ
         NANEW = NACTIV

         IF (UNITQ) THEN

*           Q  is not stored, but KX defines an ordering of the columns
*           of the identity matrix that implicitly define  Q.
*           Define the sequence of pairwise interchanges P that moves
*           the newly-fixed variable to position NFREE.
*           Reorder KX accordingly.

            DO 100, I = 1, NFREE-1
               IF (I .GE. IFIX) THEN
                  W (I) = I + 1
                  KX(I) = KX(I+1)
               ELSE
                  W(I) = I
               END IF
  100       CONTINUE

         ELSE
*           ------------------------------------------------------------
*           Q  is stored explicitly.
*           ------------------------------------------------------------
*           Set  W = the  (IFIX)-th  row of  Q.
*           Move the  (NFREE)-th  row of  Q  to position  IFIX.

            CALL DCOPY ( NFREE, ZY(IFIX,1), LDZY, W, 1 )
            IF (IFIX .LT. NFREE) THEN
               CALL DCOPY ( NFREE, ZY(NFREE,1), LDZY, ZY(IFIX,1), LDZY )
               KX(IFIX) = KX(NFREE)
            END IF
         END IF
         KX(NFREE) = JADD
      ELSE
*        ===============================================================
*        A general constraint has entered the working set.
*        IFIX  is not used.
*        ===============================================================
         IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $      WRITE (NOUT, 1020) NACTIV, NZ, NFREE, IADD, JADD, UNITQ

         NANEW  = NACTIV + 1

*        Transform the incoming row of  A  by  Q'.  Use C as workspace.

         CALL DCOPY ( N, A(IADD,1), LDA, W, 1 )
         CALL CMQMUL( 8, N, NZ, NFREE, LDZY, UNITQ, KX, W, ZY, C )

*        Check that the incoming row is not dependent upon those
*        already in the working set.

         DTNEW  = DNRM2 ( NZ, W, 1 )
         IF (NACTIV .EQ. 0) THEN

*           This is the only general constraint in the working set.

            COND   = DDIV  ( ASIZE, DTNEW, OVERFL )
            TDTMAX = DTNEW
            TDTMIN = DTNEW
         ELSE

*           There are already some general constraints in the working
*           set. Update the estimate of the condition number.

            TDTMAX = MAX( DTNEW, DTMAX )
            TDTMIN = MIN( DTNEW, DTMIN )
            COND   = DDIV  ( TDTMAX, TDTMIN, OVERFL )
         END IF

         IF (COND .GT. CONDMX  .OR.  OVERFL) GO TO 900

         IF (UNITQ) THEN

*           First general constraint added.  Set  Q = I.

            CALL F06QHF( 'General', NFREE, NFREE, ZERO, ONE, ZY, LDZY )
            UNITQ  = .FALSE.
         END IF
      END IF

      IF (BOUND) THEN
         NPIV  = NFREE
      ELSE
         NPIV  = NZ
      END IF

      NT = MIN( NRANK, NPIV )

      IF (UNITQ) THEN
*        ---------------------------------------------------------------
*        Q (i.e., ZY) is not stored explicitly.
*        Apply the sequence of pairwise interchanges P that moves the
*        newly-fixed variable to position NFREE.
*        ---------------------------------------------------------------
         IF (NGQ .GT. 0)
     $      CALL F06QKF( 'Left', 'Transpose', NFREE-1, W, NGQ, GQM, N )
            
         IF (NRANK .GT. 0) THEN

*           Apply the pairwise interchanges to the triangular part of R.
*           The subdiagonal elements generated by this process are
*           stored in  s(1), s(2), ..., s(nt-1).

            CALL F06QNF( 'Right', N, IFIX, NT, S, R, LDR )

            IF (NT .LT. NPIV) THEN

*              R is upper trapezoidal.  Apply the interchanges in
*              columns  nt  thru  npiv.

               DO 200, I = IFIX, NT-1
                  W(I) = I
  200          CONTINUE

               CALL F06QKF( 'Right', 'Normal', NFREE-1, W, NT, R, LDR )
            END IF
            
*           Eliminate the subdiagonal elements of R with a left-hand
*           sweep of rotations P2 in planes (1,2), (2,3), ...,(nt-1,nt).
*           Apply P2 to RES.

            CALL F06QRF( 'Left ', N, IFIX, NT, C, S, R, LDR )
            IF (NRES .GT. 0) 
     $         CALL F06QXF( 'Left', 'Variable', 'Forwards', NT, NRES,
     $                      IFIX, NT, C, S, RES, N )
         END IF
      ELSE
*        ---------------------------------------------------------------
*        Full matrix Q.  Define a sweep of plane rotations P such that
*                           Pw = beta*e(npiv).
*        The rotations are applied in the planes (1,2), (2,3), ...,
*        (npiv-1,npiv).  The rotations must be applied to ZY, R, T
*        and GQM'.
*        ---------------------------------------------------------------
         CALL F06FQF( 'Varble', 'Forwrds', NPIV-1, W(NPIV), W, 1, C, S )

         IF (BOUND  .AND.  NACTIV .GT. 0) THEN

            CALL DCOPY ( NACTIV, S(NZ), 1, W(NZ), 1 )
         
            S(       NZ  ) = S(NZ)*T(NACTIV,NZ+1)
            T(NACTIV,NZ+1) = C(NZ)*T(NACTIV,NZ+1)
         
            CALL F06QZF( 'Create', NACTIV, 1, NACTIV, C(NZ+1), S(NZ+1),
     $                   T(1,NZ+1), LDT )
            CALL DCOPY ( NACTIV, S(NZ), 1, T(NACTIV,NZ), LDT-1 )
         
            CALL DCOPY ( NACTIV, W(NZ), 1, S(NZ), 1 )
         END IF

         IF (NGQ .GT. 0)
     $      CALL F06QXF( 'Left ', 'Variable', 'Forwards', NPIV , NGQ,
     $                   1, NPIV, C, S, GQM, N )
         CALL F06QXF( 'Right', 'Variable', 'Forwards', NFREE, NFREE,
     $                1, NPIV, C, S, ZY, LDZY )

         IF (NRANK .GT. 0) THEN

*           Apply the rotations to the triangular part of R.
*           The subdiagonal elements generated by this process are
*           stored in  s(1),  s(2), ..., s(nt-1).

            NT = MIN( NRANK, NPIV )
            CALL F06QVF( 'Right', N, 1, NT, C, S, R, LDR )

            IF (NT .LT. NPIV) THEN

*              R is upper trapezoidal.  Pretend R is (nt x n) and
*              apply the rotations in columns  nt  thru  npiv.

               CALL F06QXF( 'Right', 'Variable', 'Forwards', NT, N,
     $                      NT, NPIV, C, S, R, LDR )
            END IF

*           Eliminate the subdiagonal elements of R with a left-hand
*           sweep of rotations P2 in planes (1,2), (2,3), ...,(nt-1,nt).
*           Apply P2 to RES.

            CALL F06QRF( 'Left ', N, 1, NT, C, S, R, LDR )
            IF (NRES .GT. 0)
     $         CALL F06QXF( 'Left', 'Variable', 'Forwards', NT, NRES,
     $                      1, NT, C, S, RES, N )
         END IF

         IF (BOUND) THEN

*           The last row and column of ZY has been transformed to plus
*           or minus the unit vector E(NFREE).  We can reconstitute the
*           columns of GQM and R corresponding to the new fixed variable.

            IF (W(NFREE) .LT. ZERO) THEN
               NF = MIN( NRANK, NFREE )
               IF (NF  .GT. 0) CALL DSCAL ( NF , -ONE,   R(1,NFREE), 1 )
               IF (NGQ .GT. 0) CALL DSCAL ( NGQ, -ONE, GQM(NFREE,1), N )
            END IF

*           ------------------------------------------------------------
*           The diagonals of T have been altered.  Recompute the
*           largest and smallest values.
*           ------------------------------------------------------------
            IF (NACTIV .GT. 0) THEN
               CALL DCOND( NACTIV, T(NACTIV,NZ), LDT-1, TDTMAX, TDTMIN )
               COND   = DDIV  ( TDTMAX, TDTMIN, OVERFL )
            END IF
         ELSE
*           ------------------------------------------------------------
*           General constraint.  Install the new row of T.
*           ------------------------------------------------------------
            CALL DCOPY ( NANEW, W(NZ), 1, T(NANEW,NZ), LDT )
         END IF
      END IF

*     ==================================================================
*     Prepare to exit.  Check the magnitude of the condition estimator.
*     ==================================================================
  900 IF (NANEW .GT. 0) THEN
         IF (COND .LT. CONDMX  .AND.  .NOT. OVERFL) THEN

*           The factorization has been successfully updated.

            INFORM = 0
            DTMAX  = TDTMAX
            DTMIN  = TDTMIN
            IF (COND .GE. CONDBD) WRITE (NOUT, 2000) JADD
         ELSE

*           The proposed working set appears to be linearly dependent.

            INFORM = 1
            IF (LSDBG  .AND.  ILSDBG(1) .GT. 0) THEN
               WRITE( NOUT, 3000 )
               IF (BOUND) THEN
                  WRITE (NOUT, 3010) ASIZE, DTMAX, DTMIN
               ELSE
                  IF (NACTIV .GT. 0) THEN
                     WRITE (NOUT, 3020) ASIZE, DTMAX, DTMIN, DTNEW
                  ELSE
                     WRITE (NOUT, 3030) ASIZE, DTNEW
                  END IF
               END IF
            END IF
         END IF
      END IF

      RETURN

 1010 FORMAT(/ ' //LSADD //  Simple bound added.'
     $       / ' //LSADD //  NACTIV    NZ NFREE  IFIX  JADD UNITQ'
     $       / ' //LSADD //  ', 5I6, L6 )
 1020 FORMAT(/ ' //LSADD //  General constraint added.           '
     $       / ' //LSADD //  NACTIV    NZ NFREE  IADD  JADD UNITQ'
     $       / ' //LSADD //  ', 5I6, L6 )
 2000 FORMAT(/ ' XXX  Serious ill-conditioning in the working set',
     $         ' after adding constraint ',  I5
     $       / ' XXX  Overflow may occur in subsequent iterations.'//)
 3000 FORMAT(/ ' //LSADD //  Dependent constraint rejected.' )
 3010 FORMAT(/ ' //LSADD //     ASIZE     DTMAX     DTMIN        '
     $       / ' //LSADD //', 1P, 3E10.2 )
 3020 FORMAT(/ ' //LSADD //     ASIZE     DTMAX     DTMIN     DTNEW'
     $       / ' //LSADD //', 1P, 4E10.2 )
 3030 FORMAT(/ ' //LSADD //     ASIZE     DTNEW'
     $       / ' //LSADD //', 1P, 2E10.2 )

*     End of  LSADD .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSADDS( UNITQ, VERTEX,
     $                   INFORM, K1, K2, NACTIV, NARTIF, NZ, NFREE,
     $                   NRANK, NREJTD, NRES, NGQ,
     $                   N, LDZY, LDA, LDR, LDT,
     $                   ISTATE, KACTIV, KX,
     $                   CONDMX,
     $                   A, R, T, RES, GQM, ZY,
     $                   W, C, S )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ, VERTEX
      INTEGER            ISTATE(*), KACTIV(N), KX(N)
      DOUBLE PRECISION   CONDMX
      DOUBLE PRECISION   A(LDA,*), R(LDR,*),
     $                   T(LDT,*), RES(N,*), GQM(N,*), ZY(LDZY,*)
      DOUBLE PRECISION   W(N), C(N), S(N)

C***********************************************************************
C     LSADDS  includes general constraints K1 thru K2 as new rows of
C     the TQ factorization stored in T, ZY.  If NRANK is nonzero, the
C     changes in Q are reflected in NRANK by N triangular factor R such
C     that
C                         C  =  P ( R ) Q,
C                                 ( 0 )
C     where  P  is orthogonal.
C
C     Systems Optimization Laboratory, Stanford University.
C     Original version written  October-31-1984.
C     This version of LSADDS dated  16-May-1988.
C***********************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
      COMMON    /SOL5CM/ ASIZE, DTMAX, DTMIN

      EXTERNAL           DNRM2
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      RTMAX  = WMACH(8)

*     Estimate the condition number of the constraints that are not
*     to be refactorized.

      IF (NACTIV .EQ. 0) THEN
         DTMAX = ZERO
         DTMIN = ONE
      ELSE
         CALL DCOND ( NACTIV, T(NACTIV,NZ+1), LDT-1, DTMAX, DTMIN )
      END IF

      DO 200, K = K1, K2
         IADD = KACTIV(K)
         JADD = N + IADD
         IF (NACTIV .LT. NFREE) THEN

            CALL LSADD ( UNITQ,
     $                   INFORM, IFIX, IADD, JADD,
     $                   NACTIV, NZ, NFREE, NRANK, NRES, NGQ,
     $                   N, LDA, LDZY, LDR, LDT,
     $                   KX, CONDMX,
     $                   A, R, T, RES, GQM, ZY,
     $                   W, C, S )

            IF (INFORM .EQ. 0) THEN
               NACTIV = NACTIV + 1
               NZ     = NZ     - 1
            ELSE
               ISTATE(JADD) =   0
               KACTIV(K)    = - KACTIV(K)
            END IF
         END IF
  200 CONTINUE

      IF (NACTIV .LT. K2) THEN

*        Some of the constraints were classed as dependent and not
*        included in the factorization.  Re-order the part of KACTIV
*        that holds the indices of the general constraints in the
*        working set.  Move accepted indices to the front and shift
*        rejected indices (with negative values) to the end.

         L      = K1 - 1
         DO 300, K = K1, K2
            I         = KACTIV(K)
            IF (I .GE. 0) THEN
               L      = L + 1
               IF (L .NE. K) THEN
                  ISWAP     = KACTIV(L)
                  KACTIV(L) = I
                  KACTIV(K) = ISWAP
               END IF
            END IF
  300    CONTINUE

*        If a vertex is required, add some temporary bounds.
*        We must accept the resulting condition number of the working
*        set.

         IF (VERTEX) THEN
            CNDMAX = RTMAX
            NZADD  = NZ
            DO 320, IARTIF = 1, NZADD
               IF (UNITQ) THEN
                  IFIX = NFREE
                  JADD = KX(IFIX)
               ELSE
                  ROWMAX = ZERO
                  DO 310, I = 1, NFREE
                     RNORM = DNRM2 ( NZ, ZY(I,1), LDZY )
                     IF (ROWMAX .LT. RNORM) THEN
                        ROWMAX = RNORM
                        IFIX   = I
                     END IF
  310             CONTINUE
                  JADD = KX(IFIX)

                  CALL LSADD ( UNITQ,
     $                         INFORM, IFIX, IADD, JADD,
     $                         NACTIV, NZ, NFREE, NRANK, NRES, NGQ,
     $                         N, LDA, LDZY, LDR, LDT,
     $                         KX, CNDMAX,
     $                         A, R, T, RES, GQM, ZY,
     $                         W, C, S  )
               END IF
               NFREE  = NFREE  - 1
               NZ     = NZ     - 1
               NARTIF = NARTIF + 1
               ISTATE(JADD) = 4
  320       CONTINUE
         END IF
      END IF

      NREJTD = K2 - NACTIV

      RETURN

*     End of  LSADDS.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSBNDS( UNITQ,
     $                   INFORM, NZ, NFREE, NRANK, NRES, NGQ,
     $                   N, LDZY, LDA, LDR, LDT,
     $                   ISTATE, KX, CONDMX,
     $                   A, R, T, RES, GQM, ZY,
     $                   W, C, S )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            ISTATE(*), KX(N)
      DOUBLE PRECISION   CONDMX
      DOUBLE PRECISION   A(LDA,*), R(LDR,*),
     $                   T(LDT,*), RES(N,*), GQM(N,*), ZY(LDZY,*)
      DOUBLE PRECISION   W(N), C(N), S(N)

************************************************************************
*     LSBNDS updates the factor R as KX is reordered to reflect the
*     status of the bound constraints given by ISTATE.  KX is reordered
*     so that the fixed variables come last.  One of two alternative
*     methods are used to reorder KX. One method needs fewer accesses 
*     to KX, the other gives a matrix  Rz  with more rows and columns.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written  30-December-1985.
*     This version of LSBNDS dated 13-May-88.
************************************************************************

      NFIXED = N - NFREE

      IF (NRANK .LT. N  .AND.  NRANK .GT. 0) THEN
*        ---------------------------------------------------------------
*        R is specified but singular.  Try and keep the dimension of Rz
*        as large as possible.
*        ---------------------------------------------------------------
         NACTV = 0
         NFREE = N
         NZ    = N

         J     = N
*+       WHILE (J .GT. 0  .AND.  N-NFREE .LT. NFIXED) DO
  100    IF    (J .GT. 0  .AND.  N-NFREE .LT. NFIXED) THEN
            IF (ISTATE(J) .GT. 0) THEN
               JADD = J
               DO 110, IFIX = NFREE, 1, -1
                  IF (KX(IFIX) .EQ. JADD) GO TO 120
  110          CONTINUE

*              Add bound JADD.

  120          CALL LSADD ( UNITQ,
     $                      INFORM, IFIX, IADD, JADD,
     $                      NACTV, NZ, NFREE, NRANK, NRES, NGQ,
     $                      N, LDA, LDZY, LDR, LDT,
     $                      KX, CONDMX,
     $                      A, R, T, RES, GQM, ZY,
     $                      W, C, S )

               NFREE = NFREE - 1
               NZ    = NZ    - 1
            END IF
            J = J - 1
            GO TO 100
*+       END WHILE
         END IF
      ELSE     
*        ---------------------------------------------------------------
*        R is of full rank,  or is not specified.
*        ---------------------------------------------------------------
         IF (NFIXED .GT. 0) THEN

*           Order KX so that the free variables come first.

            LSTART = NFREE + 1
            DO 250, K = 1, NFREE
               J = KX(K)
               IF (ISTATE(J) .GT. 0) THEN
                  DO 220, L = LSTART, N
                     J2 = KX(L)
                     IF (ISTATE(J2) .EQ. 0) GO TO 230
  220             CONTINUE

  230             KX(K)  = J2
                  KX(L)  = J
                  LSTART = L + 1

                  IF (NRANK .GT. 0)
     $               CALL CMRSWP( N, NRES, NRANK, LDR, K, L,
     $                            R, RES, C, S )
               END IF
  250       CONTINUE

         END IF
         NZ = NFREE
      END IF

      RETURN

*     End of  LSBNDS.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSCHOL( LDH, N, NRANK, TOLRNK, KX, H, INFORM )

      IMPLICIT           DOUBLE PRECISION (A-H,O-Z)
      INTEGER            KX(*)
      DOUBLE PRECISION   H(LDH,*)

************************************************************************
*     LSCHOL  forms the Cholesky factorization of the positive
*     semi-definite matrix H such that
*                   PHP'  =  R'R
*     where  P  is a permutation matrix and  R  is upper triangular.
*     The permutation P is chosen to maximize the diagonal of R at each
*     stage.  Only the diagonal and super-diagonal elements of H are
*     used.
*
*     Output:
*
*         INFORM = 0   the factorization was computed successfully,
*                      with the Cholesky factor written in the upper
*                      triangular part of H and P stored in KX.
*                  1   the matrix H was indefinite.
*
*     Original version of LSCHOL dated  2-February-1981.
*     Level 2 Blas added 29-June-1986.
*     This version of LSCHOL dated  26-Jun-1989. 
************************************************************************

      COMMON    /SOL1CM/ NOUT
      INTRINSIC          ABS   , MAX   , SQRT
      EXTERNAL           IDAMAX
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      INFORM = 0
      NRANK  = 0

*     Main loop for computing rows of  R.

      DO 200, J = 1, N

*        Find maximum available diagonal.    

         KMAX = J - 1 + IDAMAX( N-J+1, H(J,J), LDH+1 )
         DMAX = H(KMAX,KMAX)

         IF (DMAX .LE. TOLRNK*ABS(H(1,1))) GO TO 300

*        Perform a symmetric interchange if necessary.

         IF (KMAX .NE. J) THEN
            K        = KX(KMAX)
            KX(KMAX) = KX(J)
            KX(J)    = K

            CALL DSWAP ( KMAX-J, H(J+1,KMAX), 1, H(J,J+1 ), LDH )
            CALL DSWAP ( J     , H(1  ,J   ), 1, H(1,KMAX), 1   )
            CALL DSWAP ( N-KMAX+1, H(KMAX,KMAX), LDH,
     $                             H(J,KMAX)   , LDH )

         END IF

*        Set the diagonal of  R.

         D      = SQRT( DMAX )
         H(J,J) = D
         NRANK  = NRANK + 1

         IF (J .LT. N) THEN

*           Set the super-diagonal elements of this row of R and update
*           the elements of the block that is yet to be factorized.
                                                          
            CALL DSCAL ( N-J,   (ONE/D), H(J  ,J+1), LDH )
            CALL DSYR  ( 'U', N-J, -ONE, H(J  ,J+1), LDH,
     $                                   H(J+1,J+1), LDH )
         END IF

  200 CONTINUE
*     ------------------------------------------------------------------
*     Check for the semi-definite case.
*     ------------------------------------------------------------------
  300 IF (NRANK .LT. N) THEN

*        Find the largest element in the unfactorized block.

         SUPMAX = ZERO
         DO 310, I = J, N-1
            K      = I + IDAMAX( N-I, H(I,I+1), LDH )
            SUPMAX = MAX( SUPMAX, ABS(H(I,K)) )
  310    CONTINUE

         IF (SUPMAX .GT. TOLRNK*ABS(H(1,1))) THEN
            WRITE (NOUT, 1000) DMAX, SUPMAX
            INFORM = 1
         END IF
      END IF

      RETURN

 1000 FORMAT(' XXX  Hessian appears to be indefinite.'
     $      /' XXX  Maximum diagonal and off-diagonal ignored',
     $             ' in the Cholesky factorization:', 1P, 2E22.14 )

*     End of LSCHOL.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSCORE( PRBTYP, NAMED, NAMES, LINOBJ, UNITQ,
     $                   INFORM, ITER, JINF, NCLIN, NCTOTL,
     $                   NACTIV, NFREE, NRANK, NZ, NRZ,
     $                   N, LDA, LDR,
     $                   ISTATE, KACTIV, KX,
     $                   CTX, SSQ, SSQ1, SUMINF, NUMINF, XNORM,
     $                   BL, BU, A, CLAMDA, AX,
     $                   FEATOL, R, X, IW, W )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*2        PRBTYP
      CHARACTER*8        NAMES(*)
      INTEGER            ISTATE(NCTOTL), KACTIV(N), KX(N)
      INTEGER            IW(*)
      DOUBLE PRECISION   BL(NCTOTL), BU(NCTOTL), A(LDA,*),
     $                   CLAMDA(NCTOTL), AX(*),
     $                   FEATOL(NCTOTL), R(LDR,*), X(N)
      DOUBLE PRECISION   W(*)
      LOGICAL            NAMED, LINOBJ, UNITQ

************************************************************************
*     LSCORE  is a subroutine for linearly constrained linear-least
*     squares.  On entry, it is assumed that an initial working set of
*     linear constraints and bounds is available.
*     The arrays ISTATE, KACTIV and KX will have been set accordingly
*     and the arrays T and ZY will contain the TQ factorization of
*     the matrix whose rows are the gradients of the active linear
*     constraints with the columns corresponding to the active bounds
*     removed.  the TQ factorization of the resulting (NACTIV by NFREE)
*     matrix is  A(free)*Q = (0 T),  where Q is (NFREE by NFREE) and T
*     is reverse-triangular.
*
*     Values of ISTATE(J) for the linear constraints.......
*
*     ISTATE(J)
*     ---------
*          0    constraint J is not in the working set.
*          1    constraint J is in the working set at its lower bound.
*          2    constraint J is in the working set at its upper bound.
*          3    constraint J is in the working set as an equality.
*
*     Constraint J may be violated by as much as FEATOL(J).
*
*     Systems Optimization Laboratory, Stanford University.
*     This version of  LSCORE  dated  13-May-1988.
*
*     Copyright  1984  Stanford University.
*
*  This material may be reproduced by or for the U.S. Government pursu-
*  ant to the copyright license under DAR clause 7-104.9(a) (1979 Mar).
*
*  This material is based upon work partially supported by the National
*  Science Foundation under grants MCS-7926009 and ECS-8012974; the
*  Department of Energy Contract AM03-76SF00326, PA No. DE-AT03-
*  76ER72018; and the Army Research Office Contract DAA29-79-C-0110.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL3CM/ LENNAM, LDT   , NCOLT , LDZY
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
      COMMON    /SOL5CM/ ASIZE, DTMAX  , DTMIN

      INTEGER            LOCLS
      PARAMETER         (LENLS = 20)
      COMMON    /SOL1LS/ LOCLS(LENLS)

      LOGICAL            CMDBG, LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG
      COMMON    /CMDEBG/ ICMDBG(LDBG), CMDBG
*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE   (MSGLS , MSGLVL), (IDBGLS, IDBG), (LDBGLS, MSGDBG)

      EXTERNAL           DDIV  , DDOT  , DNRM2
      INTRINSIC          ABS   , MAX   , SQRT
      LOGICAL            CONVRG, CYCLIN, ERROR , FIRSTV, HITCON,
     $                   HITLOW, NEEDFG, OVERFL, PRNT  , PRNT1 , ROWERR
      LOGICAL            SINGLR, STALL , STATPT, UNBNDD, UNCON , UNITGZ,
     $                   WEAK
      PARAMETER        ( ZERO   =0.0D+0, HALF   =0.5D+0, ONE   =1.0D+0 )
      PARAMETER        ( MREFN  =1     , MSTALL =50                    )

*     Specify the machine-dependent parameters.

      EPSMCH = WMACH(3)
      FLMAX  = WMACH(7)
      RTMAX  = WMACH(8)

      LANORM = LOCLS( 2)
      LAP    = LOCLS( 3)
      LPX    = LOCLS( 4)
      LRES   = LOCLS( 5)
      LRES0  = LOCLS( 6)
      LHZ    = LOCLS( 7)
      LGQ    = LOCLS( 8)
      LCQ    = LOCLS( 9)
      LRLAM  = LOCLS(10)
      LT     = LOCLS(11)
      LZY    = LOCLS(12)
      LWTINF = LOCLS(13)
      LWRK   = LOCLS(14)

*     Set up the adresses of the contiguous arrays  ( RES0, RES )
*     and  ( GQ, CQ ).

      NRES   = 0
      IF (NRANK .GT. 0) NRES = 2
      NGQ    = 1
      IF (LINOBJ) NGQ = 2

*     Initialize.

      IREFN  =   0
      ITER   =   0
      ITMAX  =   ITMAX1
      JADD   =   0
      JDEL   =   0
      NCNLN  =   0
      NPHASE =   1
      NSTALL =   0
      NUMINF = - 1
      NRZ    =   0

      ALFA   = ZERO
      CONDMX = FLMAX
      DRZMAX = ONE
      DRZMIN = ONE
      SSQ    = ZERO

      CYCLIN = .FALSE.
      ERROR  = .FALSE.
      FIRSTV = .FALSE.
      PRNT   = .TRUE.
      PRNT1  = .TRUE.
      NEEDFG = .TRUE.
      STALL  = .TRUE.
      UNCON  = .FALSE.
      UNBNDD = .FALSE.

*     If debug output is required,  print nothing until iteration IDBG.

      MSGSVD = MSGLVL
      IF (IDBG .GT. 0  .AND.  IDBG .LE. ITMAX) THEN
         MSGLVL = 0
      END IF

*======================== start of the main loop =======================
*
*      cyclin = false
*      unbndd = false
*      error  = false
*      k      = 0
*
*      repeat
*            repeat
*                  compute Z'g,  print details of this iteration
*                  stat pt = (Z'g .eq. 0)
*                  if (not stat pt) then
*                     error =  k .ge. itmax
*                     if (not error) then
*                        compute p, alfa
*                        error = unbndd  or  cyclin
*                        if (not error) then
*                           k = k + 1
*                           x = x + alfa p
*                           if (feasible) update Z'g
*                           if necessary, add a constraint
*                        end if
*                     end if
*                  end if
*            until  stat pt  or  error
*
*            compute lam1, lam2, smllst
*            optmul =  smllst .gt. 0
*            if ( not (optmul .or. error) ) then
*                  delete an artificial or regular constraint
*            end if
*      until optmul  or  error
*
*=======================================================================

*     REPEAT
*        REPEAT
  100       IF (NEEDFG) THEN
               IF (NRANK .GT. 0) THEN
                  RESNRM = DNRM2 ( NRANK, W(LRES), 1 )
                  SSQ    = HALF*(SSQ1**2 + RESNRM**2 )
               END IF

               IF (NUMINF .NE. 0) THEN

*                 Compute the transformed gradient of either the sum of
*                 of infeasibilities or the objective.  Initialize
*                 SINGLR and UNITGZ.

                  CALL LSGSET( PRBTYP, LINOBJ, SINGLR, UNITGZ, UNITQ,
     $                         N, NCLIN, NFREE,
     $                         LDA, LDZY, LDR, NRANK, NZ, NRZ,
     $                         ISTATE, KX,
     $                         BIGBND, TOLRNK, NUMINF, SUMINF,
     $                         BL, BU, A, W(LRES), FEATOL,
     $                         W(LGQ), W(LCQ), R, X, W(LWTINF),
     $                         W(LZY), W(LWRK) )

                  IF (PRBTYP .NE. 'FP'  .AND.  NUMINF .EQ. 0
     $                                  .AND.  NPHASE .EQ. 1) THEN
                     ITMAX  = ITER + ITMAX2
                     NPHASE = 2
                  END IF
               END IF
            END IF

            GZNORM = ZERO
            IF (NZ  .GT. 0 ) GZNORM = DNRM2 ( NZ, W(LGQ), 1 )

            IF (NRZ .EQ. NZ) THEN
               GZ1NRM = GZNORM
            ELSE
               GZ1NRM = ZERO
               IF (NRZ .GT. 0) GZ1NRM = DNRM2 ( NRZ, W(LGQ), 1 )
            END IF

            GFNORM = GZNORM
            IF (NFREE .GT. 0  .AND.  NACTIV .GT. 0)
     $         GFNORM = DNRM2 ( NFREE, W(LGQ), 1 )

*           ------------------------------------------------------------
*           Print the details of this iteration.
*           ------------------------------------------------------------
*           Define small quantities that reflect the size of X, R and
*           the constraints in the working set.  If feasible,  estimate
*           the rank and condition number of Rz1.
*           Note that NRZ .LE. NRANK + 1.

            IF (NRZ .EQ. 0) THEN
               SINGLR = .FALSE.
            ELSE
               IF (NUMINF .GT. 0  .OR.  NRZ .GT. NRANK) THEN
                  ABSRZZ = ZERO
                  SINGLR = .TRUE.
               ELSE
                  CALL DCOND ( NRZ, R, LDR+1, DRZMAX, DRZMIN )
                  ABSRZZ = ABS( R(NRZ,NRZ) )
                  ROWNRM = DNRM2 ( N, R(1,1), LDR )
                  SINGLR =       ABSRZZ      .LE. DRZMAX*TOLRNK 
     $                     .OR.  ROWNRM      .LE.        TOLRNK 
     $                     .OR.  ABS(R(1,1)) .LE. ROWNRM*TOLRNK
               END IF

               IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $            WRITE (NOUT, 9100) SINGLR, ABSRZZ, DRZMAX, DRZMIN

            END IF

            CONDRZ = DDIV  ( DRZMAX, DRZMIN, OVERFL )
            CONDT  = ONE
            IF (NACTIV .GT. 0)
     $         CONDT  = DDIV  ( DTMAX , DTMIN , OVERFL )

            IF (PRNT) THEN
               CALL LSPRT ( PRBTYP, PRNT1, ISDEL, ITER, JADD, JDEL,
     $                      MSGLVL, NACTIV, NFREE, N, NCLIN,
     $                      NRANK, LDR, LDT, NZ, NRZ,
     $                      ISTATE,
     $                      ALFA, CONDRZ, CONDT, GFNORM, GZNORM, GZ1NRM,
     $                      NUMINF, SUMINF, CTX, SSQ,
     $                      AX, R, W(LT), X, W(LWRK) )
               JDEL  = 0
               JADD  = 0
               ALFA  = ZERO
            END IF

            IF (NUMINF .GT. 0) THEN
               DINKY  = ZERO
            ELSE
               OBJSIZ = ONE  + ABS( SSQ + CTX )
               WSSIZE = ZERO
               IF (NACTIV .GT. 0) WSSIZE = DTMAX
               DINKY  = EPSPT8 * MAX( WSSIZE, OBJSIZ, GFNORM )
               IF (UNCON) THEN
                  UNITGZ = GZ1NRM .LE. DINKY
               END IF
            END IF

            IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $         WRITE (NOUT, 9000) UNITGZ, IREFN, GZ1NRM, DINKY

*           If the projected gradient  Z'g  is small and Rz is of full
*           rank, X is a minimum on the working set.  An additional
*           refinement step is allowed to take care of an inaccurate
*           value of DINKY.

            STATPT = .NOT. SINGLR  .AND.  GZ1NRM .LE. DINKY
     $                             .OR.   IREFN  .GT. MREFN

            IF (.NOT. STATPT) THEN
*              ---------------------------------------------------------
*              Compute a search direction.
*              ---------------------------------------------------------
               PRNT  = .TRUE.

               ERROR = ITER .GE. ITMAX
               IF (.NOT. ERROR) THEN

                  IREFN = IREFN + 1
                  ITER  = ITER  + 1

                  IF (ITER .EQ. IDBG) THEN
                     LSDBG  = .TRUE.
                     CMDBG  =  LSDBG
                     MSGLVL =  MSGSVD
                  END IF

                  CALL LSGETP( LINOBJ, SINGLR, UNITGZ, UNITQ,
     $                         N, NCLIN, NFREE,
     $                         LDA, LDZY, LDR, NRANK, NUMINF, NRZ,
     $                         ISTATE, KX, CTP, PNORM,
     $                         A, W(LAP), W(LRES), W(LHZ), W(LPX),
     $                         W(LGQ), W(LCQ), R, W(LZY), W(LWRK) )

*                 ------------------------------------------------------
*                 Find the constraint we bump into along P.
*                 Update X and AX if the step ALFA is nonzero.
*                 ------------------------------------------------------
*                 ALFHIT is initialized to BIGALF.  If it remains
*                 that way after the call to CMALF, it will be
*                 regarded as infinite.

                  BIGALF = DDIV  ( BIGDX, PNORM, OVERFL )

                  CALL CMALF ( FIRSTV, HITLOW,
     $                         ISTATE, INFORM, JADD, N, LDA,
     $                         NCLIN, NCTOTL, NUMINF,
     $                         ALFHIT, PALFA, ATPHIT,
     $                         BIGALF, BIGBND, PNORM,
     $                         W(LANORM), W(LAP), AX,
     $                         BL, BU, FEATOL, W(LPX), X )

*                 If  Rz1  is nonsingular,  ALFA = 1.0  will be the
*                 step to the least-squares minimizer on the
*                 current subspace. If the unit step does not violate
*                 the nearest constraint by more than FEATOL,  the
*                 constraint is not added to the working set.

                  HITCON = SINGLR  .OR.  PALFA  .LE. ONE
                  UNCON  = .NOT. HITCON

                  IF (HITCON) THEN
                     ALFA = ALFHIT
                  ELSE
                     JADD   = 0
                     ALFA   = ONE
                  END IF

*                 Check for an unbounded solution or negligible step.

                  UNBNDD =  ALFA .GE. BIGALF
                  STALL  = ABS( ALFA*PNORM ) .LE. EPSPT9*XNORM
                  IF (STALL) THEN
                     NSTALL = NSTALL + 1
                     CYCLIN = NSTALL .GT. MSTALL
                  ELSE
                     NSTALL = 0
                  END IF

                  ERROR = UNBNDD  .OR.  CYCLIN
                  IF (.NOT.  ERROR) THEN
*                    ---------------------------------------------------
*                    Set X = X + ALFA*P.  Update AX, GQ, RES and CTX.
*                    ---------------------------------------------------
                     IF (ALFA .NE. ZERO)
     $                  CALL LSMOVE( HITCON, HITLOW, LINOBJ, UNITGZ,
     $                               NCLIN, NRANK, NRZ,
     $                               N, LDR, JADD, NUMINF,
     $                               ALFA, CTP, CTX, XNORM,
     $                               W(LAP), AX, BL, BU, W(LGQ),
     $                               W(LHZ), W(LPX), W(LRES),
     $                               R, X, W(LWRK) )

                     IF (HITCON) THEN
*                       ------------------------------------------------
*                       Add a constraint to the working set.
*                       Update the TQ factors of the working set.
*                       Use P as temporary work space.
*                       ------------------------------------------------
*                       Update  ISTATE.

                        IF (BL(JADD) .EQ. BU(JADD)) THEN
                           ISTATE(JADD) = 3
                        ELSE IF (HITLOW) THEN
                           ISTATE(JADD) = 1
                        ELSE
                           ISTATE(JADD) = 2
                        END IF
                        IADD = JADD - N
                        IF (JADD .LE. N) THEN

                           DO 510, IFIX = 1, NFREE
                              IF (KX(IFIX) .EQ. JADD) GO TO 520
  510                      CONTINUE
  520                   END IF

                        CALL LSADD ( UNITQ,
     $                               INFORM, IFIX, IADD, JADD,
     $                               NACTIV, NZ, NFREE, NRANK, NRES,NGQ,
     $                               N, LDA, LDZY, LDR, LDT,
     $                               KX, CONDMX,
     $                               A, R, W(LT), W(LRES),W(LGQ),W(LZY),
     $                               W(LWRK), W(LRLAM), W(LPX) )

                        NRZ    = NRZ - 1
                        NZ     = NZ  - 1

                        IF (JADD .LE. N) THEN

*                          A simple bound has been added.

                           NFREE  = NFREE  - 1
                        ELSE

*                          A general constraint has been added.

                           NACTIV = NACTIV + 1
                           KACTIV(NACTIV) = IADD
                        END IF

                        IREFN  = 0

                     END IF

*                    ---------------------------------------------------
*                    Check the feasibility of constraints with non-
*                    negative ISTATE values.  If some violations have
*                    occurred.  Refine the current X and set INFORM so
*                    that feasibility is checked in LSGSET.
*                    ---------------------------------------------------
                     CALL LSFEAS( N, NCLIN, ISTATE,
     $                            BIGBND, CNORM, ERR1, JMAX1, NVIOL,
     $                            AX, BL, BU, FEATOL, X, W(LWRK) )

                     IF (ERR1 .GT. FEATOL(JMAX1)) THEN
                        CALL LSSETX( LINOBJ, ROWERR, UNITQ,
     $                               NCLIN, NACTIV, NFREE, NRANK, NZ,
     $                               N, NCTOTL, LDZY, LDA, LDR, LDT,
     $                               ISTATE, KACTIV, KX,
     $                               JMAX1, ERR2, CTX, XNORM,
     $                               A, AX, BL, BU, W(LCQ),
     $                               W(LRES), W(LRES0), FEATOL, R,
     $                               W(LT), X, W(LZY), W(LPX), W(LWRK) )

                        IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $                     WRITE (NOUT, 2100) ERR1, ERR2
                        IF (ROWERR)       WRITE (NOUT, 2200)

                        UNCON  =   .FALSE.
                        IREFN  =   0
                        NUMINF = - 1
                     END IF
                     NEEDFG = ALFA .NE. ZERO
                  END IF
               END IF
            END IF

*        UNTIL      STATPT  .OR.  ERROR
         IF (.NOT. (STATPT  .OR.  ERROR) ) GO TO 100

*        ===============================================================
*        Try and find the index JDEL of a constraint to drop from
*        the working set.
*        ===============================================================
         JDEL   = 0

         IF (NUMINF .EQ. 0  .AND.  PRBTYP .EQ. 'FP') THEN
            IF (N .GT. NZ)
     $         CALL DLOAD ( N-NZ, (ZERO), W(LRLAM), 1 )
            JTINY  = 0
            JSMLST = 0
            JBIGST = 0
         ELSE

            CALL LSMULS( PRBTYP,
     $                   MSGLVL, N, NACTIV, NFREE,
     $                   LDA, LDT, NUMINF, NZ, NRZ,
     $                   ISTATE, KACTIV, KX, DINKY,
     $                   JSMLST, KSMLST, JINF, JTINY,
     $                   JBIGST, KBIGST, TRULAM,
     $                   A, W(LANORM), W(LGQ), W(LRLAM),
     $                   W(LT), W(LWTINF) )

         END IF

         IF (.NOT. ERROR) THEN
            IF (     JSMLST .GT. 0) THEN

*              LSMULS found a regular constraint with multiplier less
*              than (-DINKY).

               JDEL   = JSMLST
               KDEL   = KSMLST
               ISDEL  = ISTATE(JDEL)
               ISTATE(JDEL) = 0

            ELSE IF (JSMLST .LT. 0) THEN

               JDEL   = JSMLST

            ELSE IF (NUMINF .GT. 0  .AND.  JBIGST .GT. 0) THEN

*              No feasible point exists for the constraints but the
*              sum of the constraint violations may be reduced by
*              moving off constraints with multipliers greater than 1.

               JDEL   = JBIGST
               KDEL   = KBIGST
               ISDEL  = ISTATE(JDEL)
               IF (TRULAM .LE. ZERO) IS = - 1
               IF (TRULAM .GT. ZERO) IS = - 2
               ISTATE(JDEL) = IS
               FIRSTV = .TRUE.
               NUMINF = NUMINF + 1
            END IF

            IF      (JDEL .NE. 0  .AND.  SINGLR) THEN

*              Cannot delete a constraint when Rz is singular.
*              Probably a weak minimum.

               JDEL = 0
            ELSE IF (JDEL .NE. 0               ) THEN

*              Constraint JDEL has been deleted.
*              Update the matrix factorizations.

               CALL LSDEL ( UNITQ,
     $                      N, NACTIV, NFREE, NRES, NGQ, NZ, NRZ,
     $                      LDA, LDZY, LDR, LDT, NRANK,
     $                      JDEL, KDEL, KACTIV, KX,
     $                      A, W(LRES), R, W(LT), W(LGQ), W(LZY),
     $                      W(LWRK), W(LPX), W(LRLAM) )

            END IF
         END IF

         IREFN  =  0
         CONVRG =  JDEL .EQ. 0
         PRNT   = .FALSE.
         UNCON  = .FALSE.
         NEEDFG = .FALSE.

*     until       convrg  .or.  error
      IF (.NOT.  (CONVRG  .OR.  ERROR)) GO TO 100

*  .........................End of main loop............................

      WEAK = JTINY .GT. 0  .OR.  SINGLR

      IF (ERROR) THEN
         IF (UNBNDD) THEN
            INFORM = 2
            IF (NUMINF .GT. 0) INFORM = 3
         ELSE IF (ITER .GE. ITMAX) THEN
            INFORM = 4
         ELSE IF (CYCLIN) THEN
            INFORM = 5
         END IF
      ELSE IF (CONVRG) THEN
         INFORM = 0
         IF (NUMINF .GT. 0) THEN
            INFORM = 3
         ELSE IF (PRBTYP .NE. 'FP'  .AND.  WEAK) THEN
            INFORM = 1
         END IF
      END IF

*     ------------------------------------------------------------------
*     Set   CLAMDA.  Print the full solution.
*     ------------------------------------------------------------------
      MSGLVL = MSGSVD
      IF (MSGLVL .GT. 0) WRITE (NOUT, 2000) PRBTYP, ITER, INFORM

      CALL CMPRT ( MSGLVL, NFREE, LDA,
     $             N, NCLIN, NCNLN, NCTOTL, BIGBND,
     $             NAMED, NAMES, LENNAM,
     $             NACTIV, ISTATE, KACTIV, KX,
     $             A, BL, BU, X, CLAMDA, W(LRLAM), X )

      RETURN

 2000 FORMAT(/ ' Exit from ', A2, ' problem after ', I4, ' iterations.',
     $         '  INFORM =', I3 )
 2100 FORMAT(  ' XXX  Iterative refinement.  Maximum errors before and',
     $         ' after refinement are ',  1P, 2E14.2 )
 2200 FORMAT(  ' XXX  Warning.  Cannot satisfy the constraints to the',
     $         ' accuracy requested.')
 9000 FORMAT(/ ' //LSCORE//  UNITGZ IREFN     GZ1NRM      DINKY'
     $       / ' //LSCORE//  ', L6, I6, 1P, 2E11.2 )
 9100 FORMAT(/ ' //LSCORE//  SINGLR   ABS(RZZ1)      DRZMAX      DRZMIN'
     $       / ' //LSCORE//  ', L6,     1P, 3E12.4 )

*     End of  LSCORE.

      END                         
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSCRSH( COLD, VERTEX,
     $                   NCLIN, NCTOTL, NACTIV, NARTIF,
     $                   NFREE, N, LDA,
     $                   ISTATE, KACTIV,
     $                   BIGBND, TOLACT,
     $                   A, AX, BL, BU, X, WX, WORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            COLD, VERTEX
      INTEGER            ISTATE(NCTOTL), KACTIV(N)
      DOUBLE PRECISION   A(LDA,*), AX(*), BL(NCTOTL), BU(NCTOTL),
     $                   X(N), WX(N), WORK(N)

************************************************************************
*     LSCRSH  computes the quantities  ISTATE (optionally), KACTIV,
*     NACTIV, NZ and NFREE  associated with the working set at X.
*     The computation depends upon the value of the input parameter
*     COLD,  as follows...
*
*     COLD = TRUE.  An initial working set will be selected. First,
*                   nearly-satisfied or violated bounds are added.
*                   Next,  general linear constraints are added that
*                   have small residuals.
*
*     COLD = FALSE. The quantities KACTIV, NACTIV, NZ and NFREE are
*                   computed from ISTATE,  specified by the user.
*
*     Values of ISTATE(j)....
*
*        - 2         - 1         0           1          2         3
*     a'x lt bl   a'x gt bu   a'x free   a'x = bl   a'x = bu   bl = bu
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written 31-October-1984.
*     This version of LSCRSH dated 21-Nov-1990.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
      COMMON    /SOL1CM/ NOUT

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      EXTERNAL           DDOT
      INTRINSIC          ABS, MIN
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      FLMAX  =   WMACH(7)
      BIGLOW = - BIGBND
      BIGUPP =   BIGBND
      CALL DCOPY ( N, X, 1, WX, 1 )

      IF (LSDBG) THEN
         IF (ILSDBG(1) .GT. 0)
     $      WRITE (NOUT, 1000) COLD, NCLIN, NCTOTL
         IF (ILSDBG(2) .GT. 0)
     $      WRITE (NOUT, 1100) (WX(J), J = 1, N)
      END IF

      NFIXED = 0
      NACTIV = 0
      NARTIF = 0

*     If a cold start is being made, initialize  ISTATE.
*     If  BL(j) = BU(j),  set  ISTATE(j)=3  for all variables and linear
*     constraints.

      IF (COLD) THEN
         DO 100, J = 1, NCTOTL
            ISTATE(J) = 0
            IF (BL(J) .EQ. BU(J)) ISTATE(J) = 3
  100    CONTINUE
      ELSE
         DO 110, J = 1, NCTOTL
            IF (ISTATE(J) .GT. 3  .OR.  ISTATE(J) .LT. 0) ISTATE(J) = 0
  110    CONTINUE
      END IF

*     Initialize NFIXED, NFREE and KACTIV.
*     Ensure that the number of bounds and general constraints in the
*     working set does not exceed N.

      DO 200, J = 1, NCTOTL
         IF (NFIXED + NACTIV .EQ. N) ISTATE(J) = 0
         IF (ISTATE(J) .GT. 0) THEN
            IF (J .LE. N) THEN
               NFIXED = NFIXED + 1
               IF (ISTATE(J) .EQ. 1) WX(J) = BL(J)
               IF (ISTATE(J) .GE. 2) WX(J) = BU(J)
            ELSE
               NACTIV = NACTIV + 1
               KACTIV(NACTIV) = J - N
            END IF
         END IF
  200 CONTINUE

*     ------------------------------------------------------------------
*     If a cold start is required,  attempt to add as many
*     constraints as possible to the working set.
*     ------------------------------------------------------------------
      IF (COLD) THEN

*        See if any bounds are violated or nearly satisfied.
*        If so,  add these bounds to the working set and set the
*        variables exactly on their bounds.

         J = N
*+       WHILE (J .GE. 1  .AND.  NFIXED + NACTIV .LT. N) DO
  300    IF    (J .GE. 1  .AND.  NFIXED + NACTIV .LT. N) THEN
            IF (ISTATE(J) .EQ. 0) THEN
               B1     = BL(J)
               B2     = BU(J)
               IS     = 0
               IF (B1 .GT. BIGLOW) THEN
                  IF (WX(J) - B1 .LE. (ONE + ABS( B1 ))*TOLACT) IS = 1
               END IF
               IF (B2 .LT. BIGUPP) THEN
                  IF (B2 - WX(J) .LE. (ONE + ABS( B2 ))*TOLACT) IS = 2
               END IF
               IF (IS .GT. 0) THEN
                  ISTATE(J) = IS
                  IF (IS .EQ. 1) WX(J) = B1
                  IF (IS .EQ. 2) WX(J) = B2
                  NFIXED = NFIXED + 1
               END IF
            END IF
            J = J - 1
            GO TO 300
*+       END WHILE
         END IF

*        ---------------------------------------------------------------
*        The following loop finds the linear constraint (if any) with
*        smallest residual less than or equal to TOLACT  and adds it
*        to the working set.  This is repeated until the working set
*        is complete or all the remaining residuals are too large.
*        ---------------------------------------------------------------
*        First, compute the residuals for all the constraints not in the
*        working set.

         IF (NCLIN .GT. 0  .AND.  NACTIV+NFIXED .LT. N) THEN
            DO 410, I = 1, NCLIN
               IF (ISTATE(N+I) .LE. 0)
     $         AX(I) = DDOT  (N, A(I,1), LDA, WX, 1 )
  410       CONTINUE

            IS     = 1
            TOOBIG = TOLACT + TOLACT

*+          WHILE (IS .GT. 0  .AND.  NFIXED + NACTIV .LT. N) DO
  500       IF    (IS .GT. 0  .AND.  NFIXED + NACTIV .LT. N) THEN
               IS     = 0
               RESMIN = TOLACT

               DO 520, I = 1, NCLIN
                  J      = N + I
                  IF (ISTATE(J) .EQ. 0) THEN
                     B1     = BL(J)
                     B2     = BU(J)
                     RESL   = TOOBIG
                     RESU   = TOOBIG
                     IF (B1 .GT. BIGLOW)
     $                  RESL  = ABS( AX(I) - B1 ) / (ONE + ABS( B1 ))
                     IF (B2 .LT. BIGUPP)
     $                  RESU  = ABS( AX(I) - B2 ) / (ONE + ABS( B2 ))
                     RESIDL   = MIN( RESL, RESU )
                     IF(RESIDL .LT. RESMIN) THEN
                        RESMIN = RESIDL
                        IMIN   = I
                        IS     = 1
                        IF (RESL .GT. RESU) IS = 2
                     END IF
                  END IF
  520          CONTINUE

               IF (IS .GT. 0) THEN
                  NACTIV = NACTIV + 1
                  KACTIV(NACTIV) = IMIN
                  J         = N + IMIN
                  ISTATE(J) = IS
               END IF
               GO TO 500
*+          END WHILE
            END IF
         END IF
      END IF
            
      IF (VERTEX  .AND.  NACTIV+NFIXED .LT. N) THEN
*        ---------------------------------------------------------------
*        Find an initial vertex by temporarily fixing some variables.
*        Infeasible variables are moved inside their bounds.
*        ---------------------------------------------------------------
*        Compute lengths of columns of selected linear constraints
*        (just the ones corresponding to variables eligible to be
*        temporarily fixed).        

         DO 630, J = 1, N
            IF (ISTATE(J) .EQ. 0) THEN
               COLSIZ = ZERO
               DO 620, K = 1, NCLIN
                  IF (ISTATE(N+K) .GT. 0)
     $            COLSIZ = COLSIZ + ABS( A(K,J) )
  620          CONTINUE
               WORK(J) = COLSIZ
            END IF
  630    CONTINUE
         
*        Find the  NARTIF  smallest such columns.
*        This is an expensive loop.  Later we can replace it by a
*        4-pass process (say), accepting the first col that is within
*        T  of  COLMIN, where  T = 0.0, 0.001, 0.01, 0.1 (say).
*        (This comment written in 1980).
         
*+       WHILE (NFIXED + NACTIV .LT. N) DO
  640    IF    (NFIXED + NACTIV .LT. N) THEN
            COLMIN = FLMAX
            DO 650, J = 1, N
               IF (ISTATE(J) .EQ. 0) THEN
                  IF (NCLIN .EQ. 0) GO TO 660
                  COLSIZ = WORK(J)
                  IF (COLMIN .GT. COLSIZ) THEN
                     COLMIN = COLSIZ
                     JMIN   = J
                  END IF
               END IF
  650       CONTINUE
            J      = JMIN
  660       ISTATE(J) = 4
            NARTIF = NARTIF + 1
            NFIXED = NFIXED + 1
            B1     = BL(J)
            B2     = BU(J)
         
            IF (B1 .GT. BIGLOW) THEN
               IF (X(J) .LT. B1) X(J) = B1
            END IF
      
            IF (B2 .LT. BIGUPP) THEN
               IF (X(J) .GT. B2) X(J) = B2
            END IF
            GO TO 640
*+       END WHILE
         END IF
      END IF
      
      NFREE = N - NFIXED

      IF (LSDBG) THEN
         IF (ILSDBG(1) .GT. 0)
     $       WRITE (NOUT, 1300) NFIXED, NACTIV, NARTIF
         IF (ILSDBG(2) .GT. 0)
     $       WRITE (NOUT, 1200) (WX(J), J = 1, N)
      END IF

      RETURN

 1000 FORMAT(/ ' //LSCRSH// COLD NCLIN NCTOTL'
     $       / ' //LSCRSH// ', L4, I6, I7 )
 1100 FORMAT(/ ' //LSCRSH// Variables before crash... '/ (5G12.3))
 1200 FORMAT(/ ' //LSCRSH// Variables after  crash... '/ (5G12.3))
 1300 FORMAT(/ ' //LSCRSH// Working set selected ...             '
     $       / ' //LSCRSH// NFIXED NACTIV NARTIF      '
     $       / ' //LSCRSH// ', I6, 2I7 )

*     End of  LSCRSH.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSDEL ( UNITQ,
     $                   N, NACTIV, NFREE, NRES, NGQ, NZ, NRZ,
     $                   LDA, LDZY, LDR, LDT, NRANK,
     $                   JDEL, KDEL, KACTIV, KX,
     $                   A, RES, R, T, GQ, ZY,
     $                   WORK, C, S )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            KACTIV(N), KX(N)
      DOUBLE PRECISION   A(LDA,*), RES(N,*), R(LDR,*), T(LDT,*),
     $                   GQ(N,*), ZY(LDZY,*)
      DOUBLE PRECISION   WORK(N), C(N), S(N)

C***********************************************************************
C     LSDEL   updates the least-squares factor R and the factorization
C     A(free) (Z Y) = (0 T) when a regular, temporary or artificial
C     constraint is deleted from the working set.
C
C     Systems Optimization Laboratory, Stanford University.
C     Original version written 31-October-1984.
C     Level-2 matrix routines added 25-Apr-1988.
C     This version of LSDEL dated  26-Jun-1989.
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL5CM/ ASIZE, DTMAX, DTMIN

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG
      
      INTRINSIC          MIN
      EXTERNAL           IDAMAX
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      IF (JDEL .GT. 0) THEN
*        ---------------------------------------------------------------
*        Regular constraint or temporary bound deleted.
*        ---------------------------------------------------------------

         IF (JDEL .LE. N) THEN

*           Case 1.  A simple bound has been deleted.
*           =======  Columns NFREE+1 and IR of R must be swapped.

            IR     = NZ    + KDEL
            IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $         WRITE (NOUT, 1100) NACTIV, NZ, NFREE, IR, JDEL, UNITQ

            ITDEL  = 1
            NFREE  = NFREE + 1

            IF (NFREE .LT. IR) THEN
               KX(IR)    = KX(NFREE)
               KX(NFREE) = JDEL
               IF (NRANK .GT. 0)
     $            CALL CMRSWP( N, NRES, NRANK, LDR, NFREE, IR,
     $                         R, RES, C, S )
               CALL DSWAP ( NGQ, GQ(NFREE,1), N, GQ(IR,1), N )
            END IF

            IF (.NOT. UNITQ) THEN

*              Copy the incoming column of  A(free)  into the end of T.

               DO 130, KA = 1, NACTIV
                  I = KACTIV(KA)
                  T(KA,NFREE) = A(I,JDEL)
  130          CONTINUE

*              Expand Q by adding a unit row and column.

               IF (NFREE .GT. 1) THEN
                  CALL DLOAD ( NFREE-1, ZERO, ZY(NFREE,1), LDZY )
                  CALL DLOAD ( NFREE-1, ZERO, ZY(1,NFREE), 1  )
               END IF
               ZY(NFREE,NFREE) = ONE
            END IF
         ELSE        

*           Case 2.  A general constraint has been deleted.
*           =======

            IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $         WRITE (NOUT, 1200) NACTIV, NZ, NFREE, KDEL, JDEL, UNITQ

            ITDEL  = KDEL
            NACTIV = NACTIV - 1

*           Delete row  kdel  of T and move up the ones below it.
*           T becomes reverse lower Hessenberg.

            DO 220, I = KDEL, NACTIV
               KACTIV(I) = KACTIV(I+1)
               LD        = NFREE - I
               CALL DCOPY ( I+1, T(I+1,LD), LDT, T(I,LD), LDT )
  220       CONTINUE
         END IF

         NZ    = NZ     + 1

         IF (NACTIV .EQ. 0) THEN
            DTMAX = ONE
            DTMIN = ONE
         ELSE
*           ------------------------------------------------------------
*           Restore the nactiv x (nactiv+1) reverse-Hessenberg matrix  T
*           to reverse-triangular form.  The last nactiv super-diagonal 
*           elements are removed using a backward sweep of plane 
*           rotations.  The rotation for the singleton in the first
*           column is generated separately.
*           ------------------------------------------------------------
            NSUP   = NACTIV - ITDEL + 1
                                              
            IF (NSUP .GT. 0) THEN
               NPIV   = NFREE  - ITDEL + 1

               If (NSUP .GT. 1) THEN
                  CALL DCOPY ( NSUP-1, T(NACTIV-1,NZ+1), LDT-1, 
     $                         S(NZ+1), 1)
                  CALL F06QZF( 'Remove', NACTIV, 1, NSUP, 
     $                         C(NZ+1), S(NZ+1), T(1,NZ+1), LDT )
               END IF

               CALL F06BAF( T(NACTIV,NZ+1), T(NACTIV,NZ), CS, SN )
               T(NACTIV,NZ) = ZERO
               S(NZ)   = - SN
               C(NZ)   =   CS
         
               CALL F06QXF( 'Right', 'Variable', 'Backwards', 
     $                      NFREE, NFREE, NZ, NPIV, C, S, ZY, LDZY )
               CALL F06QXF( 'Left ', 'Variable', 'Backwards', 
     $                      NPIV , NGQ  , NZ, NPIV, C, S, GQ, N    )
            
               NT = MIN( NRANK, NPIV )
               
               IF (NT .LT. NPIV  .AND.  NT .GT. 0) THEN
               
*                 R is upper trapezoidal, pretend R is (nt x n) and 
*                 apply the rotations in columns  nt  thru  npiv.
               
                  CALL F06QXF( 'Right', 'Variable', 'Backwards', NT, N,
     $                         NT, NPIV, C, S, R, LDR )
               END IF
               
*              Apply the column transformations to the triangular part 
*              of  R.  A subdiagonal element is generated that must be 
*              eliminated by a row rotation before the next column 
*              transformation can be applied.
               
               IF (NZ .LT. NT) THEN
                  CALL F06QTF( 'Right', NT, NZ, NT, C, S, R, LDR )
               END IF
               
*              Apply the row rotations to the remaining rows of R.
               
               CALL F06QXF( 'Left', 'Variable', 'Backwards', NT, N-NT,
     $                      NZ, NT, C, S, R(1,NT+1), LDR )
               
               IF (NRES .GT. 0)
     $            CALL F06QXF( 'Left', 'Variable', 'Backwards', 
     $                         NT, NRES, NZ, NT, C, S, RES, N )
            END IF
            
            CALL DCOND ( NACTIV, T(NACTIV,NZ+1), LDT-1, DTMAX, DTMIN )
         END IF
      END IF

      NRZ1 = NRZ + 1

      IF (NZ .GT. NRZ) THEN
         IF (JDEL .GT. 0) THEN
            JART =   NRZ1 - 1 + IDAMAX( NZ-NRZ1+1, GQ(NRZ1,1), 1 )
         ELSE
            JART = - JDEL
         END IF

         IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $      WRITE( NOUT, 1000 ) NZ, NRZ1, JART

         IF (JART .GT. NRZ1) THEN

*           Swap columns NRZ1 and JART of R.

            IF (UNITQ) THEN
               K        = KX(NRZ1)
               KX(NRZ1)  = KX(JART)
               KX(JART) = K
            ELSE
               CALL DSWAP ( NFREE, ZY(1,NRZ1), 1, ZY(1,JART), 1 )
            END IF

            CALL DSWAP ( NGQ, GQ(NRZ1,1), N, GQ(JART,1), N )
            IF (NRANK .GT. 0)
     $         CALL CMRSWP( N, NRES, NRANK, LDR, NRZ1, JART,
     $                      R, RES, C, S )
         END IF
      END IF

      NRZ = NRZ1

      RETURN

 1000 FORMAT(/ ' //LSDEL //  Artificial constraint deleted.      '
     $       / ' //LSDEL //      NZ   NRZ   JART                 '
     $       / ' //LSDEL //  ', 3I6 )
 1100 FORMAT(/ ' //LSDEL //  Simple bound deleted.               '
     $       / ' //LSDEL //  NACTIV    NZ NFREE    IR  JDEL UNITQ'
     $       / ' //LSDEL //  ', 5I6, L6 )
 1200 FORMAT(/ ' //LSDEL //  General constraint deleted.         '
     $       / ' //LSDEL //  NACTIV    NZ NFREE  KDEL  JDEL UNITQ'
     $       / ' //LSDEL //  ', 5I6, L6 )

*     End of  LSDEL .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSDFLT( M, N, NCLIN, TITLE )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

      CHARACTER*(*)      TITLE

************************************************************************
*  LSDFLT  loads the default values of parameters not set by the user.
*
*  Systems Optimization Laboratory, Stanford University.
*  Original Fortran 77 version written 17-September-1985.
*  This version of LSDFLT dated   9-September-1986.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      LOGICAL            CMDBG, LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG
      COMMON    /CMDEBG/ ICMDBG(LDBG), CMDBG

      LOGICAL            NEWOPT
      COMMON    /SOL3LS/ NEWOPT
      SAVE      /SOL3LS/

*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE   (MSGLS , MSGLVL), (IDBGLS, IDBG), (LDBGLS, MSGDBG)

      LOGICAL            CDEFND
      CHARACTER*4        ICRSH(0:2)
      CHARACTER*3        LSTYPE(1:10)
      CHARACTER*16       KEY
      INTRINSIC          LEN    ,  MAX   , MOD
      PARAMETER        ( ZERO   =  0.0D+0, TEN    = 10.0D+0)
      PARAMETER        ( RDUMMY = -11111., IDUMMY = -11111 )
      PARAMETER        ( GIGANT = 1.0D+10*.99999           )
      PARAMETER        ( WRKTOL = 1.0D-2                   )
      DATA               ICRSH(0), ICRSH(1), ICRSH(2)
     $                 /'COLD'   ,'WARM'   ,'HOT '   /
      DATA               LSTYPE(1), LSTYPE(2)
     $                 /' FP'     ,' LP'     /
      DATA               LSTYPE(3), LSTYPE(4), LSTYPE(5), LSTYPE(6)
     $                 /'QP1'     ,'QP2'     ,'QP3'     ,'QP4'     /
      DATA               LSTYPE(7), LSTYPE(8), LSTYPE(9), LSTYPE(10)
     $                 /'LS1'     ,'LS2'     ,'LS3'     ,'LS4'     /

      EPSMCH = WMACH( 3)

*     Make a dummy call to LSKEY to ensure that the defaults are set.

      CALL LSKEY ( NOUT, '*', KEY )
      NEWOPT = .TRUE.

*     Save the optional parameters set by the user.  The values in
*     RPRMLS and IPRMLS may be changed to their default values.

      CALL ICOPY ( MXPARM, IPRMLS, 1, IPSVLS, 1 )
      CALL DCOPY ( MXPARM, RPRMLS, 1, RPSVLS, 1 )

      IF (       LPROB  .LT. 0      )  LPROB   = 7
                                       CDEFND  = LPROB .EQ. 2*(LPROB/2)
      IF (       LCRASH .LT. 0
     $    .OR.   LCRASH .GT. 2      )  LCRASH  = 0
      IF (       ITMAX1 .LT. 0      )  ITMAX1  = MAX(50, 5*(N+NCLIN))
      IF (       ITMAX2 .LT. 0      )  ITMAX2  = MAX(50, 5*(N+NCLIN))
      IF (       MSGLVL .EQ. IDUMMY )  MSGLVL  = 10
      IF (       IDBG   .LT. 0
     $    .OR.   IDBG   .GT. ITMAX1 + ITMAX2
     $                              )  IDBG    = 0
      IF (       MSGDBG .LT. 0      )  MSGDBG  = 0
      IF (       MSGDBG .EQ. 0      )  IDBG    = ITMAX1 + ITMAX2 + 1
      IF (       TOLACT .LT. ZERO   )  TOLACT  = WRKTOL
      IF (       TOLFEA .EQ. RDUMMY
     $    .OR.  (TOLFEA .GE. ZERO
     $    .AND.  TOLFEA .LT. EPSMCH))  TOLFEA  = EPSPT5
      IF (       TOLRNK .LE. ZERO
     $    .AND.  CDEFND             )  TOLRNK  = EPSPT5
      IF (       TOLRNK .LE. ZERO   )  TOLRNK  = TEN*EPSMCH
      IF (       BIGBND .LE. ZERO   )  BIGBND  = GIGANT
      IF (       BIGDX  .LE. ZERO   )  BIGDX   = MAX(GIGANT, BIGBND)

      LSDBG = IDBG .EQ. 0
      CMDBG = LSDBG
      K     = 1
      MSG   = MSGDBG
      DO 200, I = 1, LDBG
         ILSDBG(I) = MOD( MSG/K, 10 )
         ICMDBG(I) = ILSDBG(I)
         K = K*10
  200 CONTINUE

      IF (MSGLVL .GT. 0) THEN

*        Print the title.

         LENT = LEN( TITLE )
         IF (LENT .GT. 0) THEN
            NSPACE = (81 - LENT)/2 + 1
            WRITE (NOUT, '(///// (80A1) )')
     $         (' ', J=1, NSPACE), (TITLE(J:J), J=1,LENT)
            WRITE (NOUT, '(80A1 //)')
     $         (' ', J=1, NSPACE), ('='       , J=1,LENT)
         END IF

         WRITE (NOUT, 2000)
         WRITE (NOUT, 2100) LSTYPE(LPROB),
     $                      NCLIN , TOLFEA, ICRSH(LCRASH),
     $                      N     , BIGBND, TOLACT,
     $                      M     , BIGDX , TOLRNK
         WRITE (NOUT, 2200) EPSMCH, ITMAX1, MSGLVL,
     $                              ITMAX2
      END IF

      RETURN

 2000 FORMAT(
     $//' Parameters'
     $/ ' ----------' )
 2100 FORMAT(
     $/ ' Problem type...........', 7X, A3
     $/ ' Linear constraints.....', I10,     6X,
     $  ' Feasibility tolerance..', 1PE10.2, 6X,
     $  1X, A4, ' start.............'
     $/ ' Variables..............', I10,     6X,
     $  ' Infinite bound size....', 1PE10.2, 6X,
     $  ' Crash tolerance........', 1PE10.2
     $/ ' Objective matrix rows..', I10,     6X,
     $  ' Infinite step size.....', 1PE10.2, 6X,
     $  ' Rank tolerance.........', 1PE10.2 )
 2200 FORMAT(
     $/ ' EPS (machine precision)', 1PE10.2, 6X,
     $  ' Feasibility phase itns.', I10, 6X,
     $  ' Print level............', I10
     $/ 40X,
     $  ' Optimality  phase itns.', I10 )

*     End of  LSDFLT.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSFEAS( N, NCLIN, ISTATE,
     $                   BIGBND, CVNORM, ERRMAX, JMAX, NVIOL,
     $                   AX, BL, BU, FEATOL, X, WORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            ISTATE(N+NCLIN)
      DOUBLE PRECISION   AX(*), BL(N+NCLIN), BU(N+NCLIN)
      DOUBLE PRECISION   FEATOL(N+NCLIN), X(N)
      DOUBLE PRECISION   WORK(N+NCLIN)

************************************************************************
*  LSFEAS  computes the following...
*  (1)  The number of constraints that are violated by more
*       than  FEATOL  and the 2-norm of the constraint violations.
*
*  Systems Optimization Laboratory, Stanford University.
*  Original version      April    1984.
*  This version of  LSFEAS  dated  17-October-1985.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      EXTERNAL           IDAMAX, DNRM2
      INTRINSIC          ABS
      PARAMETER        ( ZERO = 0.0D+0 )

      BIGLOW = - BIGBND
      BIGUPP =   BIGBND

*     ==================================================================
*     Compute NVIOL,  the number of constraints violated by more than
*     FEATOL,  and CVNORM,  the 2-norm of the constraint violations and
*     residuals of the constraints in the working set.
*     ==================================================================
      NVIOL  = 0

      DO 200, J = 1, N+NCLIN
         FEASJ  = FEATOL(J)
         IS     = ISTATE(J)
         RES    = ZERO

         IF (IS .GE. 0  .AND.  IS .LT. 4) THEN
            IF (J .LE. N) THEN
               CON =  X(J)
            ELSE
               I   = J - N
               CON = AX(I)
            END IF

            TOLJ   = FEASJ

*           Check for constraint violations.

            IF (BL(J) .GT. BIGLOW) THEN
               RES    = BL(J) - CON
               IF (RES .GT.   FEASJ ) NVIOL = NVIOL + 1
               IF (RES .GT.    TOLJ ) GO TO 190
            END IF

            IF (BU(J) .LT. BIGUPP) THEN
               RES    = BU(J) - CON
               IF (RES .LT. (-FEASJ)) NVIOL = NVIOL + 1
               IF (RES .LT.  (-TOLJ)) GO TO 190
            END IF

*           This constraint is satisfied,  but count the residual as a
*           violation if the constraint is in the working set.

            IF (IS .LE. 0) RES = ZERO
            IF (IS .EQ. 1) RES = BL(J) - CON
            IF (IS .GE. 2) RES = BU(J) - CON
            IF (ABS( RES ) .GT. FEASJ) NVIOL = NVIOL + 1
         END IF
  190    WORK(J) = RES
  200 CONTINUE

      JMAX   = IDAMAX( N+NCLIN, WORK, 1 )
      ERRMAX = ABS ( WORK(JMAX) )

      IF (LSDBG  .AND.  ILSDBG(1) .GT. 0)
     $   WRITE (NOUT, 1000) ERRMAX, JMAX

      CVNORM  = DNRM2 ( N+NCLIN, WORK, 1 )

      RETURN

 1000 FORMAT(/ ' //LSFEAS//  The maximum violation is ', 1PE14.2,
     $                     ' in constraint', I5 )

*     End of  LSFEAS.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSFILE( IOPTNS, INFORM )
      INTEGER            IOPTNS, INFORM

************************************************************************
*     LSFILE  reads the options file from unit  IOPTNS  and loads the
*     options into the relevant elements of  IPRMLS  and  RPRMLS.
*
*     If  IOPTNS .lt. 0  or  IOPTNS .gt. 99  then no file is read,
*     otherwise the file associated with unit  IOPTNS  is read.
*
*     Output:
*
*         INFORM = 0  if a complete  OPTIONS  file was found
*                     (starting with  BEGIN  and ending with  END);
*                  1  if  IOPTNS .lt. 0  or  IOPTNS .gt. 99;
*                  2  if  BEGIN  was found, but end-of-file
*                     occurred before  END  was found;
*                  3  if end-of-file occurred before  BEGIN  or
*                     ENDRUN  were found;
*                  4  if  ENDRUN  was found before  BEGIN.
************************************************************************
      LOGICAL             NEWOPT
      COMMON     /SOL3LS/ NEWOPT
      SAVE       /SOL3LS/

      DOUBLE PRECISION    WMACH(15)
      COMMON     /SOLMCH/ WMACH
      SAVE       /SOLMCH/

      EXTERNAL            MCHPAR, LSKEY
      LOGICAL             FIRST
      SAVE                FIRST , NOUT
      DATA                FIRST /.TRUE./

*     If first time in, set NOUT.
*     NEWOPT is true first time into LSFILE or LSOPTN
*     and just after a call to LSSOL.

      IF (FIRST) THEN
         FIRST  = .FALSE.
         NEWOPT = .TRUE.
         CALL MCHPAR()
         NOUT = WMACH(11)
      END IF

      CALL OPFILE( IOPTNS, NOUT, INFORM, LSKEY )

      RETURN

*     End of  LSFILE.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSGETP( LINOBJ, SINGLR, UNITGZ, UNITQ,
     $                   N, NCLIN, NFREE,
     $                   LDA, LDZY, LDR, NRANK, NUMINF, NRZ,
     $                   ISTATE, KX, CTP, PNORM,
     $                   A, AP, RES, HZ, P,
     $                   GQ, CQ, R, ZY, WORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            LINOBJ, SINGLR, UNITGZ, UNITQ
      INTEGER            ISTATE(N+NCLIN), KX(N)
      DOUBLE PRECISION   A(LDA,*), AP(*), RES(*), HZ(*), P(N),
     $                   GQ(N), CQ(*), R(LDR,*), ZY(LDZY,*)
      DOUBLE PRECISION   WORK(N)

************************************************************************
*     LSGETP  computes the following quantities for  LSCORE.
*     (1) The vector  (hz1) = (Rz1)(pz1).
*         If X is not yet feasible,  the product is computed directly.
*         If  Rz1 is singular,  hz1  is zero.  Otherwise  hz1  satisfies
*         the equations
*                        Rz1'hz1 = -gz1,
*         where  g  is the total gradient.  If there is no linear term
*         in the objective,  hz1  is set to  dz1  directly.
*     (2) The search direction P (and its 2-norm).  The vector P is
*         defined as  Z*(pz1), where  (pz1)  depends upon whether or
*         not X is feasible and the nonsingularity of  (Rz1).
*         If  NUMINF .GT. 0,  (pz1)  is the steepest-descent direction.
*         Otherwise,  x  is the solution of the  NRZ*NRZ  triangular
*         system   (Rz1)*(pz1) = (hz1).
*     (3) The vector Ap,  where A is the matrix of linear constraints.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written 31-October-1984.
*     Level 2 Blas added 11-June-1986.
*     This version of LSGETP dated  5-Aug-1987.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      EXTERNAL           DDOT  , DNRM2
      INTRINSIC          MIN
      PARAMETER        ( ZERO = 0.0D+0, ONE  = 1.0D+0 )

      IF (SINGLR) THEN
*        ---------------------------------------------------------------
*        The triangular factor for the current objective function is
*        singular,  i.e., the objective is linear along the last column
*        of Z1.  This can only occur when UNITGZ is TRUE.
*        ---------------------------------------------------------------
         IF (NRZ .GT. 1) THEN
            CALL DCOPY ( NRZ-1, R(1,NRZ), 1, P, 1 )
            CALL DTRSV ( 'U', 'N', 'N', NRZ-1, R, LDR, P, 1 )
         END IF
         P(NRZ) = - ONE

         GTP = DDOT  ( NRZ, GQ, 1, P, 1 )
         IF (GTP .GT. ZERO) CALL DSCAL ( NRZ, (-ONE), P, 1 )

         IF (NRZ .LE. NRANK) THEN
            IF (NUMINF .EQ. 0) THEN
               IF (UNITGZ) THEN
                  HZ(NRZ) = R(NRZ,NRZ)*P(NRZ)
               ELSE
                  CALL DLOAD ( NRZ, (ZERO), HZ, 1 )
               END IF
            ELSE
               HZ(1)   = R(1,1)*P(1)
            END IF
         END IF
      ELSE
*        ---------------------------------------------------------------
*        The objective is quadratic in the space spanned by Z1.
*        ---------------------------------------------------------------
         IF (LINOBJ) THEN
            IF (UNITGZ) THEN
               IF (NRZ .GT. 1)
     $            CALL DLOAD ( NRZ-1, (ZERO), HZ, 1 )
               HZ(NRZ) = - GQ(NRZ)/R(NRZ,NRZ)
            ELSE
               CALL DCOPY ( NRZ, GQ  , 1, HZ, 1 )
               CALL DSCAL ( NRZ, (-ONE), HZ, 1 )
               CALL DTRSV ( 'U', 'T', 'N', NRZ, R, LDR, HZ, 1 )
            END IF
         ELSE
            CALL DCOPY ( NRZ, RES, 1, HZ, 1 )
         END IF

*        Solve  Rz1*pz1 = hz1.

         CALL DCOPY ( NRZ, HZ, 1, P, 1 )
         CALL DTRSV ( 'U', 'N', 'N', NRZ, R, LDR, P, 1 )
      END IF

*     Compute  p = Z1*pz1  and its norm.

      IF (LINOBJ)
     $   CTP = DDOT  ( NRZ, CQ, 1, P, 1 )
      PNORM  = DNRM2 ( NRZ, P, 1 )

      CALL CMQMUL( 1, N, NRZ, NFREE, LDZY, UNITQ, KX, P, ZY, WORK )

      IF (LSDBG  .AND.  ILSDBG(2) .GT. 0)
     $   WRITE (NOUT, 1000) (P(J), J = 1, N)

*     Compute  Ap.

      IF (NCLIN .GT. 0) THEN
         CALL DGEMV ( 'No transpose', NCLIN, N, ONE, A, LDA,
     $                P, 1, ZERO, AP, 1 )

         IF (LSDBG  .AND.  ILSDBG(2) .GT. 0)
     $      WRITE (NOUT, 1100) (AP(I), I = 1, NCLIN)
      END IF

      RETURN

 1000 FORMAT(/ ' //LSGETP//   P ... ' / (1P, 5E15.5))
 1100 FORMAT(/ ' //LSGETP//  AP ... ' / (1P, 5E15.5))

*     End of  LSGETP.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSGSET( PRBTYP, LINOBJ, SINGLR, UNITGZ, UNITQ,
     $                   N, NCLIN, NFREE,
     $                   LDA, LDZY, LDR, NRANK, NZ, NRZ,
     $                   ISTATE, KX,
     $                   BIGBND, TOLRNK, NUMINF, SUMINF,
     $                   BL, BU, A, RES, FEATOL,
     $                   GQ, CQ, R, X, WTINF, ZY, WRK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*2        PRBTYP
      LOGICAL            LINOBJ, SINGLR, UNITGZ, UNITQ
      INTEGER            ISTATE(*), KX(N)
      DOUBLE PRECISION   BL(*), BU(*), A(LDA,*),
     $                   RES(*), FEATOL(*)
      DOUBLE PRECISION   GQ(N), CQ(*), R(LDR,*), X(N), WTINF(*),
     $                   ZY(LDZY,*)
      DOUBLE PRECISION   WRK(N)

************************************************************************
*     LSGSET  finds the number and weighted sum of infeasibilities for
*     the bounds and linear constraints.   An appropriate transformed
*     gradient vector is returned in  GQ.
*
*     Positive values of  ISTATE(j)  will not be altered.  These mean
*     the following...
*
*               1             2           3
*           a'x = bl      a'x = bu     bl = bu
*
*     Other values of  ISTATE(j)  will be reset as follows...
*           a'x lt bl     a'x gt bu     a'x free
*              - 2           - 1           0
*
*     If  x  is feasible,  LSGSET computes the vector Q(free)'g(free),
*     where  g  is the gradient of the the sum of squares plus the
*     linear term.  The matrix Q is of the form
*                    ( Q(free)  0       ),
*                    (   0      I(fixed))
*     where  Q(free)  is the orthogonal factor of  A(free)  and  A  is
*     the matrix of constraints in the working set.  The transformed
*     gradients are stored in GQ.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written 31-October-1984.
*     Level 2 Blas added 11-June-1986.
*     This version of LSGSET dated 28-May-1988.
************************************************************************
      EXTERNAL           DDOT  , IDRANK
      INTRINSIC          ABS   , MAX   , MIN
      PARAMETER        ( ZERO = 0.0D+0, HALF = 0.5D+0, ONE = 1.0D+0 )
                     
      BIGUPP =   BIGBND
      BIGLOW = - BIGBND

      NUMINF =   0
      SUMINF =   ZERO
      CALL DLOAD ( N, ZERO, GQ, 1 )

      DO 200, J = 1, N+NCLIN
         IF (ISTATE(J) .LE. 0) THEN
            FEASJ  = FEATOL(J)
            IF (J .LE. N) THEN
               CTX = X(J)
            ELSE
               K   = J - N
               CTX = DDOT  ( N, A(K,1), LDA, X, 1 )
            END IF
            ISTATE(J) = 0

*           See if the lower bound is violated.

            IF (BL(J) .GT. BIGLOW) THEN
               S = BL(J) - CTX
               IF (S     .GT. FEASJ ) THEN
                  ISTATE(J) = - 2
                  WEIGHT    = - WTINF(J)
                  GO TO 160
               END IF
            END IF

*           See if the upper bound is violated.

            IF (BU(J) .GE. BIGUPP) GO TO 200
            S = CTX - BU(J)
            IF (S     .LE. FEASJ ) GO TO 200
            ISTATE(J) = - 1
            WEIGHT    =   WTINF(J)

*           Add the infeasibility.

  160       NUMINF = NUMINF + 1
            SUMINF = SUMINF + ABS( WEIGHT ) * S
            IF (J .LE. N) THEN
               GQ(J) = WEIGHT
            ELSE
               CALL DAXPY ( N, WEIGHT, A(K,1), LDA, GQ, 1 )
            END IF
         END IF
  200 CONTINUE

*     ------------------------------------------------------------------
*     Install  GQ,  the transformed gradient.
*     ------------------------------------------------------------------
      SINGLR = .FALSE.
      UNITGZ = .TRUE.

      IF (NUMINF .GT. 0) THEN
         CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ, KX, GQ, ZY, WRK )
      ELSE IF (NUMINF .EQ. 0  .AND.  PRBTYP .EQ. 'FP') THEN
         CALL DLOAD ( N, ZERO, GQ, 1 )
      ELSE

*        Ready for the Optimality Phase.
*        Set NRZ so that Rz1 is nonsingular.

         IF (NRANK .EQ. 0) THEN
            IF (LINOBJ) THEN
               CALL DCOPY ( N, CQ, 1, GQ, 1 )
            ELSE
               CALL DLOAD ( N, ZERO, GQ, 1 )
            END IF
            NRZ    = 0
         ELSE

*           Compute  GQ = - R' * (transformed residual)

            CALL DCOPY ( NRANK, RES, 1, GQ, 1 )
            CALL DSCAL ( NRANK, (-ONE), GQ, 1 )
            CALL DTRMV ( 'U', 'T', 'N', NRANK, R, LDR, GQ, 1 )
            IF (NRANK .LT. N)
     $         CALL DGEMV( 'T', NRANK, N-NRANK, -ONE,R(1,NRANK+1),LDR,
     $                      RES, 1, ZERO, GQ(NRANK+1), 1 )

            IF (LINOBJ) CALL DAXPY ( N, ONE, CQ, 1, GQ, 1 )
            UNITGZ = .FALSE.

            ROWNRM = DNRM2 ( N, R(1,1), LDR )
            IF (         ROWNRM  .LE.        TOLRNK
     $          .OR. ABS(R(1,1)) .LE. ROWNRM*TOLRNK) THEN
               NRZ = 0
            ELSE
               NRZ = IDRANK( MIN(NRANK, NZ), R, LDR+1, TOLRNK )
            END IF
         END IF
      END IF

      RETURN

*     End of  LSGSET.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSKEY ( NOUT, BUFFER, KEY )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*(*)      BUFFER

************************************************************************
*     LSKEY   decodes the option contained in  BUFFER  in order to set
*     a parameter value in the relevant element of  IPRMLS  or  RPRMLS.
*
*
*     Input:
*
*     NOUT   A unit number for printing error messages.
*            NOUT  must be a valid unit.
*
*     Output:
*
*     KEY    The first keyword contained in BUFFER.
*
*
*     LSKEY  calls OPNUMB and the subprograms
*                 LOOKUP, SCANNR, TOKENS, UPCASE
*     (now called OPLOOK, OPSCAN, OPTOKN, OPUPPR)
*     supplied by Informatics General, Inc., Palo Alto, California.
*
*     Systems Optimization Laboratory, Stanford University.
*     This version dated Jan 22, 1986.
************************************************************************
*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------

      EXTERNAL           OPNUMB
      LOGICAL            FIRST , MORE  , NUMBER, OPNUMB, SORTED
      SAVE               FIRST

      PARAMETER         (     MAXKEY = 27,  MAXTIE = 10,   MAXTOK = 10,
     $                        MAXTYP = 16)
      CHARACTER*16       KEYS(MAXKEY), TIES(MAXTIE), TOKEN(MAXTOK),
     $                   TYPE(MAXTYP)
      CHARACTER*16       KEY, KEY2, KEY3, VALUE

      PARAMETER         (IDUMMY = -11111,  RDUMMY = -11111.0,
     $                   SORTED = .TRUE.,  ZERO   =  0.0     )

      DATA                FIRST
     $                  /.TRUE./
      DATA   KEYS
     $ / 'BEGIN           ',
     $   'COLD            ', 'CONSTRAINTS     ', 'CRASH           ',
     $   'DEBUG           ', 'DEFAULTS        ', 'END             ',
     $   'FEASIBILITY     ', 'HOT             ', 'INFINITE        ',
     $   'IPRMLS          ', 'ITERATIONS      ', 'ITERS:ITERATIONS',
     $   'ITNS :ITERATIONS', 'LINEAR          ', 'LIST            ',
     $   'LOWER           ', 'NOLIST          ', 'OPTIMALITY      ',
     $   'PRINT           ', 'PROBLEM         ', 'RANK            ',
     $   'RPRMLS          ', 'START           ', 'UPPER           ',
     $   'VARIABLES       ', 'WARM            '/

      DATA   TIES
     $ / 'BOUND           ', 'CONSTRAINTS     ',
     $   'NO              ', 'NO.      :NUMBER', 'NUMBER          ',
     $   'PHASE           ', 'STEP            ',
     $   'TOLERANCE       ', 'TYPE            ', 'YES             '/

      DATA   TYPE
     $ / 'FP              ',
     $   'LEAST       :LS1', 'LINEAR       :LP', 'LP              ',
     $   'LS          :LS1', 'LS1             ', 'LS2             ',
     $   'LS3             ', 'LS4             ', 'LSQ         :LS1',
     $   'QP          :QP2', 'QP1             ', 'QP2             ',
     $   'QP3             ', 'QP4             ', 'QUADRATIC   :QP2'/
*-----------------------------------------------------------------------

      IF (FIRST) THEN
         FIRST  = .FALSE.
         DO 10, I = 1, MXPARM
            IPRMLS(I) = IDUMMY
            RPRMLS(I) = RDUMMY
   10    CONTINUE
      END IF

*     Eliminate comments and empty lines.
*     A '*' appearing anywhere in BUFFER terminates the string.

      I      = INDEX( BUFFER, '*' )
      IF (I .EQ. 0) THEN
         LENBUF = LEN( BUFFER )
      ELSE
         LENBUF = I - 1
      END IF
      IF (LENBUF .LE. 0) THEN
         KEY = '*'
         GO TO 900
      END IF

*     ------------------------------------------------------------------
*     Extract up to MAXTOK tokens from the record.
*     NTOKEN returns how many were actually found.
*     KEY, KEY2, KEY3 are the first tokens if any, otherwise blank.
*     ------------------------------------------------------------------
      NTOKEN = MAXTOK
      CALL OPTOKN( BUFFER(1:LENBUF), NTOKEN, TOKEN )
      KEY    = TOKEN(1)
      KEY2   = TOKEN(2)
      KEY3   = TOKEN(3)

*     Certain keywords require no action.

      IF (KEY .EQ. ' '     .OR.  KEY .EQ. 'BEGIN' ) GO TO 900
      IF (KEY .EQ. 'LIST'  .OR.  KEY .EQ. 'NOLIST') GO TO 900
      IF (KEY .EQ. 'END'                          ) GO TO 900

*     Most keywords will have an associated integer or real value,
*     so look for it no matter what the keyword.

      I      = 1
      NUMBER = .FALSE.

   50 IF (I .LT. NTOKEN  .AND.  .NOT. NUMBER) THEN
         I      = I + 1
         VALUE  = TOKEN(I)
         NUMBER = OPNUMB( VALUE )
         GO TO 50
      END IF

      IF (NUMBER) THEN
         READ (VALUE, '(BN, E16.0)') RVALUE
      ELSE
         RVALUE = ZERO
      END IF

*     Convert the keywords to their most fundamental form
*     (upper case, no abbreviations).
*     SORTED says whether the dictionaries are in alphabetic order.
*     LOCi   says where the keywords are in the dictionaries.
*     LOCi = 0 signals that the keyword wasn't there.

      CALL OPLOOK( MAXKEY, KEYS, SORTED, KEY , LOC1 )
      CALL OPLOOK( MAXTIE, TIES, SORTED, KEY2, LOC2 )

*     ------------------------------------------------------------------
*     Decide what to do about each keyword.
*     The second keyword (if any) might be needed to break ties.
*     Some seemingly redundant testing of MORE is used
*     to avoid compiler limits on the number of consecutive ELSE IFs.
*     ------------------------------------------------------------------
      MORE   = .TRUE.
      IF (MORE) THEN
         MORE   = .FALSE.
         IF (KEY .EQ. 'COLD        ') THEN
            LCRASH = 0
         ELSE IF (KEY .EQ. 'CONSTRAINTS ') THEN
            NNCLIN = RVALUE
         ELSE IF (KEY .EQ. 'CRASH       ') THEN
            TOLACT = RVALUE
         ELSE IF (KEY .EQ. 'DEBUG       ') THEN
            LDBGLS = RVALUE
         ELSE IF (KEY .EQ. 'DEFAULTS    ') THEN
            DO 20, I = 1, MXPARM
               IPRMLS(I) = IDUMMY
               RPRMLS(I) = RDUMMY
   20       CONTINUE
         ELSE IF (KEY .EQ. 'FEASIBILITY ') THEN
              IF (KEY2.EQ. 'PHASE       ') ITMAX1 = RVALUE
              IF (KEY2.EQ. 'TOLERANCE   ') TOLFEA = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE
            MORE   = .TRUE.
         END IF
      END IF

      IF (MORE) THEN
         MORE   = .FALSE.
         IF (KEY .EQ. 'HOT         ') THEN
            LCRASH = 2
         ELSE IF (KEY .EQ. 'INFINITE    ') THEN
              IF (KEY2.EQ. 'BOUND       ') BIGBND = RVALUE * 0.99999
              IF (KEY2.EQ. 'STEP        ') BIGDX  = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'IPRMLS      ') THEN
*           Allow things like  IPRMLS 21 = 100  to set IPRMLS(21) = 100
            IVALUE = RVALUE
            IF (IVALUE .GE. 1  .AND. IVALUE .LE. MXPARM) THEN
               READ (KEY3, '(BN, I16)') IPRMLS(IVALUE)
            ELSE
               WRITE(NOUT, 2400) IVALUE
            END IF
         ELSE IF (KEY .EQ. 'ITERATIONS  ') THEN
            ITMAX2 = RVALUE
         ELSE IF (KEY .EQ. 'LINEAR      ') THEN
            NNCLIN = RVALUE
         ELSE IF (KEY .EQ. 'LOWER       ') THEN
            BNDLOW = RVALUE
         ELSE
            MORE   = .TRUE.
         END IF
      END IF

      IF (MORE) THEN
         MORE   = .FALSE.
         IF      (KEY .EQ. 'OPTIMALITY  ') THEN
            ITMAX2 = RVALUE
         ELSE IF (KEY .EQ. 'PROBLEM     ') THEN
            IF      (KEY2 .EQ. 'NUMBER') THEN
               NPROB  = RVALUE
            ELSE IF (KEY2 .EQ. 'TYPE  ') THEN

*              Recognize     Problem type = LP     etc.

               CALL OPLOOK( MAXTYP, TYPE, SORTED, KEY3, LOC3 )
               IF (KEY3 .EQ. 'FP' ) LPROB = 1
               IF (KEY3 .EQ. 'LP' ) LPROB = 2
               IF (KEY3 .EQ. 'QP1') LPROB = 3
               IF (KEY3 .EQ. 'QP2') LPROB = 4
               IF (KEY3 .EQ. 'QP3') LPROB = 5
               IF (KEY3 .EQ. 'QP4') LPROB = 6
               IF (KEY3 .EQ. 'LS1') LPROB = 7
               IF (KEY3 .EQ. 'LS2') LPROB = 8
               IF (KEY3 .EQ. 'LS3') LPROB = 9
               IF (KEY3 .EQ. 'LS4') LPROB = 10
               IF (LOC3 .EQ.  0  ) WRITE(NOUT, 2330) KEY3
            ELSE
               WRITE(NOUT, 2320) KEY2
            END IF
         ELSE
            MORE   = .TRUE.
         END IF
      END IF

      IF (MORE) THEN
         MORE   = .FALSE.
         IF      (KEY .EQ. 'PRINT       ') THEN
            MSGLS  = RVALUE
         ELSE IF (KEY .EQ. 'RANK        ') THEN
            TOLRNK = RVALUE
         ELSE IF (KEY .EQ. 'RPRMLS      ') THEN
*           Allow things like  RPRMLS 21 = 2  to set RPRMLS(21) = 2.0
            IVALUE = RVALUE
            IF (IVALUE .GE. 1  .AND. IVALUE .LE. MXPARM) THEN
               READ (KEY3, '(BN, E16.0)') RPRMLS(IVALUE)
            ELSE
               WRITE(NOUT, 2400) IVALUE
            END IF
         ELSE IF (KEY .EQ. 'START       ') THEN
            IDBGLS = RVALUE
         ELSE IF (KEY .EQ. 'UPPER       ') THEN
            BNDUPP = RVALUE
         ELSE IF (KEY .EQ. 'VARIABLES   ') THEN
            NN     = RVALUE
         ELSE IF (KEY .EQ. 'WARM        ') THEN
            LCRASH = 1
         ELSE
            WRITE(NOUT, 2300) KEY
         END IF
      END IF

  900 RETURN

 2300 FORMAT(' XXX  Keyword not recognized:         ', A)
 2320 FORMAT(' XXX  Second keyword not recognized:  ', A)
 2330 FORMAT(' XXX  Third  keyword not recognized:  ', A)
 2400 FORMAT(' XXX  The PARM subscript is out of range:', I10)

*     End of LSKEY

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSLOC ( LPROB, N, NCLIN, LITOTL, LWTOTL )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

************************************************************************
*     LSLOC   allocates the addresses of the work arrays for  LSCORE.
*
*     Note that the arrays  ( GQ, CQ )  and  ( RES, RES0, HZ )  lie in
*     contiguous areas of workspace.
*     RES, RES0 and HZ are not needed for LP.
*     CQ is defined when the objective has an explicit linear term.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written  29-October-1984.
*     This version of LSLOC dated 16-February-1986.
************************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL3CM/ LENNAM, LDT   , NCOLT, LDZY

      PARAMETER        ( LENLS = 20 )
      COMMON    /SOL1LS/ LOCLS(LENLS)

      LOGICAL            LSDBG
      PARAMETER        ( LDBG = 5 )
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      MINIW     = LITOTL + 1
      MINW      = LWTOTL + 1


*     Assign array lengths that depend upon the problem dimensions.

      IF (NCLIN .EQ. 0) THEN
         LENT  = 0
         LENZY = 0
      ELSE
         LENT  = LDT *NCOLT
         LENZY = LDZY*LDZY
      END IF

      LENCQ  = 0
      IF (LPROB .EQ. 2*(LPROB/2)) LENCQ  = N
      LENRES = 0
      IF (LPROB .GT. 2          ) LENRES = N

      LKACTV    = MINIW
      MINIW     = LKACTV + N

      LANORM    = MINW
      LAP       = LANORM + NCLIN
      LPX       = LAP    + NCLIN
      LGQ       = LPX    + N
      LCQ       = LGQ    + N
      LRES      = LCQ    + LENCQ
      LRES0     = LRES   + LENRES
      LHZ       = LRES0  + LENRES
      LRLAM     = LHZ    + LENRES
      LT        = LRLAM  + N
      LZY       = LT     + LENT
      LWTINF    = LZY    + LENZY
      LWRK      = LWTINF + N  + NCLIN
      LFEATL    = LWRK   + N  + NCLIN
      MINW      = LFEATL + N  + NCLIN

      LOCLS( 1) = LKACTV
      LOCLS( 2) = LANORM
      LOCLS( 3) = LAP
      LOCLS( 4) = LPX
      LOCLS( 5) = LRES
      LOCLS( 6) = LRES0
      LOCLS( 7) = LHZ
      LOCLS( 8) = LGQ
      LOCLS( 9) = LCQ
      LOCLS(10) = LRLAM
      LOCLS(11) = LT
      LOCLS(12) = LZY
      LOCLS(13) = LWTINF
      LOCLS(14) = LWRK
      LOCLS(15) = LFEATL

      LITOTL    = MINIW - 1
      LWTOTL    = MINW  - 1

      RETURN

*     End of  LSLOC .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSMOVE( HITCON, HITLOW, LINOBJ, UNITGZ,
     $                   NCLIN, NRANK, NRZ,
     $                   N, LDR, JADD, NUMINF,
     $                   ALFA, CTP, CTX, XNORM,
     $                   AP, AX, BL, BU, GQ, HZ, P, RES,
     $                   R, X, WORK )

      IMPLICIT           DOUBLE PRECISION (A-H,O-Z)
      LOGICAL            HITCON, HITLOW, LINOBJ, UNITGZ
      DOUBLE PRECISION   AP(*), AX(*), BL(*), BU(*), GQ(*), HZ(*),
     $                   P(N), RES(*), R(LDR,*), X(N)
      DOUBLE PRECISION   WORK(*)

************************************************************************
*     LSMOVE  changes X to X + ALFA*P and updates CTX, AX, RES and GQ
*     accordingly.
*
*     If a bound was added to the working set,  move X exactly on to it,
*     except when a negative step was taken (CMALF may have had to move
*     to some other closer constraint.)
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written 27-December-1985.
*     Level 2 BLAS added 11-June-1986.
*     This version of LSMOVE dated 11-June-1986.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      EXTERNAL           DDOT  , DNRM2
      INTRINSIC          ABS   , MIN
      PARAMETER        ( ZERO  = 0.0D+0, ONE = 1.0D+0 )

      CALL DAXPY ( N, ALFA, P, 1, X, 1 )
      IF (LINOBJ) CTX = CTX + ALFA*CTP

      IF (HITCON  .AND.  JADD .LE. N) THEN
         BND = BU(JADD)
         IF (HITLOW) BND = BL(JADD)
         IF (ALFA .GE. ZERO) X(JADD) = BND
      END IF
      XNORM  = DNRM2 ( N, X, 1 )

      IF (NCLIN .GT. 0)
     $   CALL DAXPY ( NCLIN, ALFA, AP, 1, AX, 1 )

      IF (NRZ .LE. NRANK) THEN
         IF (UNITGZ) THEN
            RES(NRZ) = RES(NRZ) - ALFA*HZ(NRZ)
         ELSE
            CALL DAXPY ( NRZ, (-ALFA), HZ, 1, RES, 1  )
         END IF

         IF (NUMINF .EQ. 0) THEN

*           Update the transformed gradient GQ so that
*           GQ = GQ + ALFA*R'( HZ ).
*                            ( 0  )

            IF (UNITGZ) THEN
               CALL DAXPY ( N-NRZ+1, ALFA*HZ(NRZ), R(NRZ,NRZ), LDR,
     $                                             GQ(NRZ)   , 1      )
            ELSE
               CALL DCOPY ( NRZ, HZ, 1, WORK, 1 )
               CALL DTRMV ( 'U', 'T', 'N', NRZ, R, LDR, WORK, 1 )
               IF (NRZ .LT. N)
     $            CALL DGEMV ( 'T', NRZ, N-NRZ, ONE, R(1,NRZ+1), LDR,
     $                         HZ, 1, ZERO, WORK(NRZ+1), 1 )
               CALL DAXPY ( N, ALFA, WORK, 1, GQ, 1 )
            END IF
         END IF
      END IF

      RETURN

*     End of  LSMOVE.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSMULS( PRBTYP,
     $                   MSGLVL, N, NACTIV, NFREE,
     $                   LDA, LDT, NUMINF, NZ, NRZ,
     $                   ISTATE, KACTIV, KX, DINKY,
     $                   JSMLST, KSMLST, JINF, JTINY,
     $                   JBIGST, KBIGST, TRULAM,
     $                   A, ANORMS, GQ, RLAMDA, T, WTINF )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*2        PRBTYP
      INTEGER            ISTATE(*), KACTIV(N), KX(N)
      DOUBLE PRECISION   A(LDA,*), ANORMS(*),
     $                   GQ(N), RLAMDA(N), T(LDT,*), WTINF(*)

************************************************************************
*     LSMULS  first computes the Lagrange multiplier estimates for the
*     given working set.  It then determines the values and indices of
*     certain significant multipliers.  In this process, the multipliers
*     for inequalities at their upper bounds are adjusted so that a
*     negative multiplier for an inequality constraint indicates non-
*     optimality.  All adjusted multipliers are scaled by the 2-norm
*     of the associated constraint row.  In the following, the term
*     minimum refers to the ordering of numbers on the real line,  and
*     not to their magnitude.
*
*     JSMLST  is the index of the minimum of the set of adjusted
*             multipliers with values less than  - DINKY.  A negative
*             JSMLST defines the index in Q'g of the artificial
*             constraint to be deleted.
*     KSMLST  marks the position of general constraint JSMLST in KACTIV.
*
*     JBIGST  is the index of the largest of the set of adjusted
*             multipliers with values greater than (1 + DINKY).
*     KBIGST  marks its position in KACTIV.
*
*     On exit,  elements 1 thru NACTIV of RLAMDA contain the unadjusted
*     multipliers for the general constraints.  Elements NACTIV onwards
*     of RLAMDA contain the unadjusted multipliers for the bounds.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written 31-October-1984.
*     This version of LSMULS dated  30-June-1986.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      INTRINSIC          ABS, MIN
      PARAMETER        ( ZERO   =0.0D+0,ONE    =1.0D+0 )

      NFIXED =   N - NFREE

      JSMLST =   0
      KSMLST =   0
      SMLLST = - DINKY

      TINYLM =   DINKY
      JTINY  =   0

      JBIGST =   0
      KBIGST =   0
      BIGGST =   ONE + DINKY

      IF (NRZ .LT. NZ) THEN
*        ---------------------------------------------------------------
*        Compute JSMLST for the artificial constraints.
*        ---------------------------------------------------------------
         DO 100, J = NRZ+1, NZ
            RLAM = - ABS( GQ(J) )
            IF (RLAM .LT. SMLLST) THEN
               SMLLST =   RLAM
               JSMLST = - J
            ELSE IF (RLAM .LT. TINYLM) THEN
               TINYLM =   RLAM
               JTINY  =   J
            END IF
  100    CONTINUE

         IF (MSGLVL .GE. 20)
     $      WRITE (NOUT, 1000) (GQ(K), K=NRZ+1,NZ)

      END IF

*     ------------------------------------------------------------------
*     Compute JSMLST for regular constraints and temporary bounds.
*     ------------------------------------------------------------------
*     First, compute the Lagrange multipliers for the general
*     constraints in the working set, by solving  T'*lamda = Y'g.

      IF (N .GT. NZ)
     $   CALL DCOPY ( N-NZ, GQ(NZ+1), 1, RLAMDA, 1 )
      IF (NACTIV .GT. 0)
     $   CALL CMTSOL( 2, LDT, NACTIV, T(1,NZ+1), RLAMDA )

*     -----------------------------------------------------------------
*     Now set elements NACTIV, NACTIV+1,... of  RLAMDA  equal to
*     the multipliers for the bound constraints.
*     -----------------------------------------------------------------
      DO 190, L = 1, NFIXED
         J     = KX(NFREE+L)
         BLAM  = RLAMDA(NACTIV+L)
         DO 170, K = 1, NACTIV
            I    = KACTIV(K)
            BLAM = BLAM - A(I,J)*RLAMDA(K)
  170    CONTINUE
         RLAMDA(NACTIV+L) = BLAM
  190 CONTINUE

*     -----------------------------------------------------------------
*     Find JSMLST and KSMLST.
*     -----------------------------------------------------------------
      DO 330, K = 1, N - NZ
         IF (K .GT. NACTIV) THEN
            J = KX(NZ+K)
         ELSE
            J = KACTIV(K) + N
         END IF

         IS   = ISTATE(J)

         I    = J - N
         IF (J .LE. N) ANORMJ = ONE
         IF (J .GT. N) ANORMJ = ANORMS(I)

         RLAM = RLAMDA(K)

*        Change the sign of the estimate if the constraint is in
*        the working set at its upper bound.

         IF (IS .EQ. 2) RLAM =      - RLAM
         IF (IS .EQ. 3) RLAM =   ABS( RLAM )
         IF (IS .EQ. 4) RLAM = - ABS( RLAM )

         IF (IS .NE. 3) THEN
            SCDLAM = RLAM * ANORMJ
            IF      (SCDLAM .LT. SMLLST) THEN
               SMLLST = SCDLAM
               JSMLST = J
               KSMLST = K
            ELSE IF (SCDLAM .LT. TINYLM) THEN
               TINYLM = SCDLAM
               JTINY  = J
            END IF
         END IF

         IF (NUMINF .GT. 0  .AND.  J .GT. JINF) THEN
            SCDLAM = RLAM/WTINF(J)
            IF (SCDLAM .GT. BIGGST) THEN
               BIGGST = SCDLAM
               TRULAM = RLAMDA(K)
               JBIGST = J
               KBIGST = K
            END IF
         END IF
  330 CONTINUE

*     -----------------------------------------------------------------
*     If required, print the multipliers.
*     -----------------------------------------------------------------
      IF (MSGLVL .GE. 20) THEN
         IF (NFIXED .GT. 0)
     $      WRITE (NOUT, 1100) PRBTYP, (KX(NFREE+K),
     $                         RLAMDA(NACTIV+K), K=1,NFIXED)
         IF (NACTIV .GT. 0)
     $      WRITE (NOUT, 1200) PRBTYP, (KACTIV(K),
     $                         RLAMDA(K), K=1,NACTIV)
      END IF

      IF (LSDBG  .AND.  ILSDBG(1) .GT. 0) THEN
         WRITE (NOUT, 9000) JSMLST, SMLLST, KSMLST
         WRITE (NOUT, 9100) JBIGST, BIGGST, KBIGST
         WRITE (NOUT, 9200) JTINY , TINYLM
      END IF

      RETURN

 1000 FORMAT(/ ' Multipliers for the artificial constraints        '
     $       / 4(5X, 1PE11.2))
 1100 FORMAT(/ ' Multipliers for the ', A2, ' bound  constraints   '
     $       / 4(I5, 1PE11.2))
 1200 FORMAT(/ ' Multipliers for the ', A2, ' linear constraints   '
     $       / 4(I5, 1PE11.2))
 9000 FORMAT(/ ' //LSMULS//  JSMLST     SMLLST     KSMLST (Scaled) '
     $       / ' //LSMULS//  ', I6, 1PE11.2, 5X, I6 )
 9100 FORMAT(  ' //LSMULS//  JBIGST     BIGGST     KBIGST (Scaled) '
     $       / ' //LSMULS//  ', I6, 1PE11.2, 5X, I6 )
 9200 FORMAT(  ' //LSMULS//   JTINY     TINYLM                     '
     $       / ' //LSMULS//  ', I6, 1PE11.2)

*     End of  LSMULS.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSOPTN( STRING )
      CHARACTER*(*)      STRING

************************************************************************
*     LSOPTN  loads the option supplied in  STRING  into the relevant
*     element of  IPRMLS  or  RPRMLS.
************************************************************************

      LOGICAL             NEWOPT
      COMMON     /SOL3LS/ NEWOPT
      SAVE       /SOL3LS/

      DOUBLE PRECISION    WMACH(15)
      COMMON     /SOLMCH/ WMACH
      SAVE       /SOLMCH/

      EXTERNAL            MCHPAR
      CHARACTER*16        KEY
      CHARACTER*72        BUFFER
      LOGICAL             FIRST , PRNT
      SAVE                FIRST , NOUT  , PRNT
      DATA                FIRST /.TRUE./

*     If first time in, set  NOUT.
*     NEWOPT  is true first time into  LSFILE  or  LSOPTN
*     and just after a call to  LSSOL.
*     PRNT    is set to true whenever  NEWOPT  is true.

      IF (FIRST) THEN
         FIRST  = .FALSE.
         NEWOPT = .TRUE.
         CALL MCHPAR()
         NOUT   =  WMACH(11)
      END IF
      BUFFER = STRING

*     Call  LSKEY   to decode the option and set the parameter value.
*     If NEWOPT is true, reset PRNT and test specially for NOLIST.

      IF (NEWOPT) THEN
         NEWOPT = .FALSE.
         PRNT   = .TRUE.
         CALL LSKEY ( NOUT, BUFFER, KEY )

         IF (KEY .EQ. 'NOLIST') THEN
            PRNT   = .FALSE.
         ELSE
            WRITE (NOUT, '(// A / A /)')
     $         ' Calls to LSOPTN',
     $         ' ---------------'
            WRITE (NOUT, '( 6X, A )') BUFFER
         END IF
      ELSE
         IF (PRNT)
     $      WRITE (NOUT, '( 6X, A )') BUFFER
         CALL LSKEY ( NOUT, BUFFER, KEY )

         IF (KEY .EQ.   'LIST') PRNT = .TRUE.
         IF (KEY .EQ. 'NOLIST') PRNT = .FALSE.
      END IF

      RETURN

*     End of  LSOPTN.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSPRT ( PRBTYP, PRNT1, ISDEL, ITER, JADD, JDEL,
     $                   MSGLVL, NACTIV, NFREE, N, NCLIN,
     $                   NRANK, LDR, LDT, NZ, NRZ, ISTATE,
     $                   ALFA, CONDRZ, CONDT, GFNORM, GZNORM, GZ1NRM,
     $                   NUMINF, SUMINF, CTX, SSQ,
     $                   AX, R, T, X, WORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*2        PRBTYP
      LOGICAL            PRNT1
      INTEGER            ISTATE(*)
      DOUBLE PRECISION   AX(*), R(LDR,*), T(LDT,*), X(N)
      DOUBLE PRECISION   WORK(N)

************************************************************************
*  LSPRT  prints various levels of output for  LSCORE.
*
*           Msg        Cumulative result
*           ---        -----------------
*
*        le   0        no output.
*
*        eq   1        nothing now (but full output later).
*
*        eq   5        one terse line of output.
*
*        ge  10        same as 5 (but full output later).
*
*        ge  20        constraint status,  x  and  Ax.
*
*        ge  30        diagonals of  T  and  R.
*
*
*  Debug printing is performed depending on the logical variable  LSDBG.
*  LSDBG  is set true when  IDBG  major iterations have been performed.
*  At this point,  printing is done according to a string of binary
*  digits of the form  SVT  (stored in the integer array  ILSDBG).
*
*  S  set 'on'  gives information from the maximum step routine  CMALF.
*  V  set 'on'  gives various vectors in  LSCORE  and its auxiliaries.
*  T  set 'on'  gives a trace of which routine was called and an
*               indication of the progress of the run.
*
*  Systems Optimization Laboratory, Stanford University.
*  Original version written 31-October-1984.
*  This version of LSPRT dated 14-January-1985.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      CHARACTER*2        LADD, LDEL
      CHARACTER*2        LSTATE(0:5)
      DATA               LSTATE(0), LSTATE(1), LSTATE(2)
     $                  /'  '     , 'L '     , 'U '     /
      DATA               LSTATE(3), LSTATE(4), LSTATE(5)
     $                  /'E '     , 'T '     , 'Z '     /

      IF (MSGLVL .GE. 15) WRITE (NOUT, 1000) PRBTYP, ITER

      IF (MSGLVL .GE. 5) THEN
         IF      (JDEL .GT. 0) THEN
            KDEL =   ISDEL
         ELSE IF (JDEL .LT. 0) THEN
            JDEL = - JDEL
            KDEL =   5
         ELSE
            KDEL =   0
         END IF

         IF (JADD .GT. 0) THEN
            KADD = ISTATE(JADD)
         ELSE
            KADD = 0
         END IF

         LDEL   = LSTATE(KDEL)
         LADD   = LSTATE(KADD)

         IF (NUMINF .GT. 0) THEN
            OBJ    = SUMINF
         ELSE
            OBJ    = SSQ + CTX
         END IF

*        ---------------------------------------------------------------
*        Print the terse line.
*        ---------------------------------------------------------------
         IF (NRANK .EQ. 0) THEN
            IF (PRNT1  .OR.  MSGLVL .GE. 15) WRITE (NOUT, 1100)
            WRITE (NOUT, 1200) ITER, JDEL, LDEL, JADD, LADD,
     $                         ALFA, NUMINF, OBJ, N-NFREE, NACTIV,
     $                         NZ, NRZ, GFNORM, GZ1NRM, CONDT
         ELSE
            IF (PRNT1  .OR.  MSGLVL .GE. 15) WRITE (NOUT, 1110)
            WRITE (NOUT, 1200) ITER, JDEL, LDEL, JADD, LADD,
     $                         ALFA, NUMINF, OBJ, N-NFREE, NACTIV,
     $                         NZ, NRZ, GFNORM, GZ1NRM, CONDT, CONDRZ
         END IF

         IF (MSGLVL .GE. 20) THEN
            WRITE (NOUT, 2000) PRBTYP
            WRITE (NOUT, 2100) (X(J) , ISTATE(J)  ,  J=1,N)
            IF (NCLIN .GT. 0)
     $      WRITE (NOUT, 2200) (AX(K), ISTATE(N+K), K=1,NCLIN )

            IF (MSGLVL .GE. 30) THEN
*              ---------------------------------------------------------
*              Print the diagonals of  T  and  R.
*              ---------------------------------------------------------
               IF (NACTIV .GT. 0) THEN
                  CALL DCOPY ( NACTIV, T(NACTIV,NZ+1), LDT-1, WORK,1 )
                  WRITE (NOUT, 3000) PRBTYP, (WORK(J), J=1,NACTIV)
               END IF
               IF (NRANK  .GT. 0)
     $            WRITE (NOUT, 3100) PRBTYP, (R(J,J) , J=1,NRANK )
            END IF
            WRITE (NOUT, 5000)
         END IF
      END IF

      PRNT1 = .FALSE.

      RETURN

 1000 FORMAT(/// ' ', A2, ' iteration', I5
     $         / ' =================' )
 1100 FORMAT(// '  Itn Jdel  Jadd      Step',
     $          ' Ninf  Sinf/Objective', '  Bnd', '  Lin', '    Nz',
     $          '   Nz1   Norm Gf  Norm Gz1   Cond T' )
 1110 FORMAT(// '  Itn Jdel  Jadd      Step',
     $          ' Ninf  Sinf/Objective', '  Bnd', '  Lin', '    Nz',
     $          '   Nz1   Norm Gf  Norm Gz1   Cond T Cond Rz1' )
 1200 FORMAT(I5, I5, A1, I5, A1, 1PE9.1, I5, 1X, 1PE15.6, 2I5,
     $       2I6, 1P, 2E10.2, 1P, 2E9.1 )
 2000 FORMAT(/ ' Values and status of the ', A2, ' constraints'
     $       / ' ---------------------------------------' )
 2100 FORMAT(/ ' Variables...'                 /   (1X, 5(1PE15.6, I5)))
 2200 FORMAT(/ ' General linear constraints...'/   (1X, 5(1PE15.6, I5)))
 3000 FORMAT(/ ' Diagonals of ' , A2,' working set factor T'
     $       /   (1P, 5E15.6))
 3100 FORMAT(/ ' Diagonals of ' , A2, ' triangle R         '
     $       /   (1P, 5E15.6))
 5000 FORMAT(/// ' ---------------------------------------------------',
     $           '--------------------------------------------' )

*     End of  LSPRT .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSSETX( LINOBJ, ROWERR, UNITQ,
     $                   NCLIN, NACTIV, NFREE, NRANK, NZ,
     $                   N, NCTOTL, LDZY, LDA, LDR, LDT,
     $                   ISTATE, KACTIV, KX,
     $                   JMAX, ERRMAX, CTX, XNORM,
     $                   A, AX, BL, BU, CQ, RES, RES0, FEATOL,
     $                   R, T, X, ZY, P, WORK )

      IMPLICIT           DOUBLE PRECISION (A-H,O-Z)
      LOGICAL            LINOBJ, ROWERR, UNITQ
      INTEGER            ISTATE(NCTOTL), KACTIV(N), KX(N)
      DOUBLE PRECISION   A(LDA,*), AX(*), BL(NCTOTL), BU(NCTOTL),
     $                   CQ(*), RES(*), RES0(*), FEATOL(NCTOTL), P(N),
     $                   R(LDR,*), T(LDT,*), ZY(LDZY,*), X(N)
      DOUBLE PRECISION   WORK(NCTOTL)

************************************************************************
*  LSSETX  computes the point on a working set that is closest to the
*  input vector  x  (in the least-squares sense).  The norm of  x, the
*  transformed residual vector  Pr - RQ'x,  and the constraint values
*  Ax  are also initialized.
*
*  If the computed point gives a row error of more than the feasibility
*  tolerance, an extra step of iterative refinement is used.  If  x  is
*  still infeasible,  the logical variable  ROWERR  is set.
*
*  Systems Optimization Laboratory, Stanford University.
*  Original version written 31-October-1984.
*  This version dated 29-December-1985.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG

      EXTERNAL           IDAMAX, DDOT
      INTRINSIC          ABS, MIN
      PARAMETER        ( NTRY  = 2 )
      PARAMETER        ( ZERO  = 0.0D+0, ONE = 1.0D+0 )

*     ------------------------------------------------------------------
*     Move  x  onto the simple bounds in the working set.
*     ------------------------------------------------------------------
      DO 100, K = NFREE+1, N
          J   = KX(K)
          IS  = ISTATE(J)
          BND = BL(J)
          IF (IS .GE. 2) BND  = BU(J)
          IF (IS .NE. 4) X(J) = BND
  100 CONTINUE

*     ------------------------------------------------------------------
*     Move  x  onto the general constraints in the working set.
*     We shall make  ntry  tries at getting acceptable row errors.
*     ------------------------------------------------------------------
      KTRY   = 1
      JMAX   = 1
      ERRMAX = ZERO

*     REPEAT
  200    IF (NACTIV .GT. 0) THEN

*           Set  work = residuals for constraints in the working set.
*           Solve for p, the smallest correction to x that gives a point
*           on the constraints in the working set.  Define  p = Y*(py),
*           where  py  solves the triangular system  T*(py) = residuals.

            DO 220, I = 1, NACTIV
               K   = KACTIV(I)
               J   = N + K
               BND = BL(J)
               IF (ISTATE(J) .EQ. 2) BND = BU(J)
               WORK(I) = BND - DDOT  ( N, A(K,1), LDA, X, 1 )
  220       CONTINUE

            CALL CMTSOL( 1, LDT, NACTIV, T(1,NZ+1), WORK )
            CALL DLOAD ( N, ZERO, P, 1 )
            CALL DCOPY ( NACTIV, WORK, 1, P(NZ+1), 1 )

            CALL CMQMUL( 2, N, NZ, NFREE, LDZY, UNITQ, KX, P, ZY, WORK )
            CALL DAXPY ( N, ONE, P, 1, X, 1 )
         END IF

*        ---------------------------------------------------------------
*        Compute the 2-norm of  x.
*        Initialize  Ax  for all the general constraints.
*        ---------------------------------------------------------------
         XNORM  = DNRM2 ( N, X, 1 )
         IF (NCLIN .GT. 0)
     $      CALL DGEMV ( 'N', NCLIN, N, ONE, A, LDA,
     $                   X, 1, ZERO, AX, 1 )

*        ---------------------------------------------------------------
*        Check the row residuals.
*        ---------------------------------------------------------------
         IF (NACTIV .GT. 0) THEN
            DO 300, K = 1, NACTIV
               I   = KACTIV(K)
               J   = N + I
               IS  = ISTATE(J)
               IF (IS .EQ. 1) WORK(K) = BL(J) - AX(I)
               IF (IS .GE. 2) WORK(K) = BU(J) - AX(I)
  300       CONTINUE

            JMAX   = IDAMAX( NACTIV, WORK, 1 )
            ERRMAX = ABS( WORK(JMAX) )
         END IF

         KTRY = KTRY + 1
*     UNTIL    (ERRMAX .LE. FEATOL(JMAX) .OR. KTRY .GT. NTRY
      IF (.NOT.(ERRMAX .LE. FEATOL(JMAX) .OR. KTRY .GT. NTRY)) GO TO 200

      ROWERR = ERRMAX .GT. FEATOL(JMAX)

*     ==================================================================
*     Compute the linear objective value  c'x  and the transformed
*     residual  Pr  -  RQ'x = RES0  -  RQ'x.
*     ==================================================================
      IF (NRANK .GT. 0  .OR.  LINOBJ) THEN
         CALL DCOPY ( N, X, 1, P, 1 )
         CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ, KX, P, ZY, WORK )
      END IF

      CTX = ZERO
      IF (LINOBJ)
     $   CTX = DDOT  ( N, CQ, 1, P, 1 )

      IF (NRANK .GT. 0) THEN

         CALL DTRMV ( 'U', 'N', 'N', NRANK, R, LDR, P, 1 )
         IF (NRANK .LT. N)
     $      CALL DGEMV ( 'N', NRANK, N-NRANK, ONE, R(1,NRANK+1), LDR,
     $                   P(NRANK+1), 1, ONE, P, 1 )

         CALL DCOPY ( NRANK,       RES0, 1, RES, 1 )
         CALL DAXPY ( NRANK, -ONE, P   , 1, RES, 1 )

      END IF

      IF (LSDBG  .AND.  ILSDBG(2) .GT. 0)
     $   WRITE (NOUT, 2200) (X(J), J = 1, N)

      RETURN

 2200 FORMAT(/ ' //LSSETX// Variables after refinement ... '/ (5G12.3))

*     End of  LSSETX.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE LSSOL ( MM, N,
     $                   NCLIN, LDA, LDR,
     $                   A, BL, BU, CVEC,
     $                   ISTATE, KX, X, R, B,
     $                   INFORM, ITER, OBJ, CLAMDA,
     $                   IW, LENIW, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            LENIW, LENW
      INTEGER            ISTATE(N+NCLIN), KX(N)
      INTEGER            IW(LENIW)
      DOUBLE PRECISION   BL(N+NCLIN), BU(N+NCLIN), A(LDA,*)
      DOUBLE PRECISION   CLAMDA(N+NCLIN), CVEC(*)
      DOUBLE PRECISION   R(LDR,*), X(N), B(*)
      DOUBLE PRECISION   W(LENW)

************************************************************************
*  LSSOL  solves problems of the form
*
*           Minimize               F(x)
*              x
*                                 (  x )
*           subject to    bl  .le.(    ).ge.  bu,
*                                 ( Ax )
*
*  where  '  denotes the transpose of a column vector,  x  denotes the
*  n-vector of parameters and  F(x) is one of the following functions..
*
*  FP =  None                         (find a feasible point).
*  LP =  c'x
*  QP1=        1/2 x'Rx                R  n times n, symmetric pos. def.
*  QP2=  c'x + 1/2 x'Rx                .  .   ..        ..       ..  ..
*  QP3=        1/2 x'R'Rx              R  m times n, upper triangular.
*  QP4=  c'x + 1/2 x'R'Rx              .  .   ..  .   ..      ...
*  LS1=        1/2 (b - Rx)'(b - Rx)   R  m times n, rectangular.
*  LS2=  c'x + 1/2 (b - Rx)'(b - Rx)   .  .   ..  .     ...
*  LS3=        1/2 (b - Rx)'(b - Rx)   R  m times n, upper triangular.
*  LS4=  c'x + 1/2 (b - Rx)'(b - Rx)   .  .   ..  .   ..      ...
*
*  The matrix  R  is entered as the two-dimensional array  R  (of row
*  dimension  LDR).  If  LDR = 0,  R  is not accessed.
*
*  The vector  c  is entered in the one-dimensional array  CVEC.
*
*  NCLIN  is the number of general linear constraints (rows of  A).
*  (NCLIN may be zero.)
*
*  The first  N  components of  BL  and   BU  are lower and upper
*  bounds on the variables.  The next  NCLIN  components are
*  lower and upper bounds on the general linear constraints.
*
*  The matrix  A  of coefficients in the general linear constraints
*  is entered as the two-dimensional array  A  (of dimension
*  LDA by N).  If NCLIN = 0, A is not accessed.
*
*  The vector  x  must contain an initial estimate of the solution,
*  and will contain the computed solution on output.
*
*
*  Complete documentation for  LSSOL  is contained in Report SOL 86-1,
*  Users Guide for LSSOL (Version 1.0), by P.E. Gill, S. J. Hammarling,
*  W. Murray, M.A. Saunders and M.H. Wright, Department of
*  Operations Research, Stanford University, Stanford, California 94305.
*
*  Systems Optimization Laboratory, Stanford University.
*  Version 1.00 Dated  30-Jan-1986.
*  Version 1.01 Dated  30-Jun-1986.   Level-2 BLAS added
*  Version 1.02 Dated  13-May-1988.   Level-2 matrix routines added.
*  Version 1.03 Dated  19-Jun-1989.   Some obscure bugs fixed.      
*
*  Copyright  1984  Stanford University.
*
*  This material may be reproduced by or for the U.S. Government pursu-
*  ant to the copyright license under DAR clause 7-104.9(a) (1979 Mar).
*
*  This material is based upon work partially supported by the National
*  Science Foundation under Grants MCS-7926009 and ECS-8312142; the
*  Department of Energy Contract AM03-76SF00326, PA No. DE-AT03-
*  76ER72018; the Army Research Office Contract DAA29-84-K-0156;
*  and the Office of Naval Research Grant N00014-75-C-0267.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL3CM/ LENNAM, LDT, NCOLT, LDZY
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
      COMMON    /SOL5CM/ ASIZE, DTMAX, DTMIN

      PARAMETER         (LENLS = 20)
      COMMON    /SOL1LS/ LOCLS(LENLS)

      LOGICAL            LSDBG
      PARAMETER         (LDBG = 5)
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG
*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE   (MSGLS , MSGLVL), (IDBGLS, IDBG), (LDBGLS, MSGDBG)

      INTRINSIC          MAX, MIN

*     Local variables.

      LOGICAL            COLD  , FACTRZ, LINOBJ, NAMED , ROWERR,
     $                   UNITQ , VERTEX
      CHARACTER*2        PRBTYP
      CHARACTER*8        NAMES(1)
      PARAMETER        ( ZERO   =0.0D+0, POINT1 =0.1D+0, POINT3 =3.3D-1)
      PARAMETER        ( POINT8 =0.8D+0, POINT9 =0.9D+0, ONE    =1.0D+0)

      CHARACTER*40       TITLE
      DATA               TITLE
     $                 / 'SOL/LSSOL  ---  Version 1.03   Jun  1989' /

*     Set the machine-dependent constants.

      CALL MCHPAR()

      EPSMCH = WMACH( 3)
      RTEPS  = WMACH( 4)
      NOUT   = WMACH(11)

      EPSPT3 = EPSMCH**POINT3
      EPSPT5 = RTEPS
      EPSPT8 = EPSMCH**POINT8
      EPSPT9 = EPSMCH**POINT9

      NAMED  = .FALSE.

      INFORM = 0
      ITER   = 0

      CONDMX = ONE / EPSPT5

      NCTOTL = N + NCLIN

*     Set the default values of the parameters.

      CALL LSDFLT( MM, N, NCLIN, TITLE )

*     Set all parameters determined by the problem type.

      IF      (LPROB .EQ. 1 ) THEN
         PRBTYP    = 'FP'
         M      = 0
         LINOBJ = .FALSE.
         FACTRZ = .TRUE.
      ELSE IF (LPROB .EQ. 2 ) THEN
         PRBTYP    = 'LP'
         M      = 0
         LINOBJ = .TRUE.
         FACTRZ = .TRUE.
      ELSE IF (LPROB .EQ. 3 ) THEN
         PRBTYP    = 'QP'
         M      = MM
         LINOBJ = .FALSE.
         FACTRZ = .TRUE.
      ELSE IF (LPROB .EQ. 4 ) THEN
         PRBTYP    = 'QP'
         M      = MM
         LINOBJ = .TRUE.
         FACTRZ = .TRUE.
      ELSE IF (LPROB .EQ. 5 ) THEN
         PRBTYP    = 'QP'
         M      = MM
         LINOBJ = .FALSE.
         FACTRZ = .FALSE.
      ELSE IF (LPROB .EQ. 6 ) THEN
         PRBTYP    = 'QP'
         M      = MM
         LINOBJ = .TRUE.
         FACTRZ = .FALSE.
      ELSE IF (LPROB .EQ. 7 ) THEN
         PRBTYP    = 'LS'
         M      = MM
         LINOBJ = .FALSE.
         FACTRZ = .TRUE.
      ELSE IF (LPROB .EQ. 8 ) THEN
         PRBTYP    = 'LS'
         M      = MM
         LINOBJ = .TRUE.
         FACTRZ = .TRUE.
      ELSE IF (LPROB .EQ. 9 ) THEN
         PRBTYP    = 'LS'
         M      = MM
         LINOBJ = .FALSE.
         FACTRZ = .FALSE.
      ELSE IF (LPROB .EQ. 10) THEN
         PRBTYP    = 'LS'
         M      = MM
         LINOBJ = .TRUE.
         FACTRZ = .FALSE.
      END IF

*     Assign the dimensions of arrays in the parameter list of LSCORE.
*     Economies of storage are possible if the minimum number of active
*     constraints and the minimum number of fixed variables are known in
*     advance.  The expert user should alter MINACT and MINFXD
*     accordingly.
*     If a linear program is being solved and the matrix of general
*     constraints is fat,  i.e.,  NCLIN .LT. N,  a non-zero value is
*     known for MINFXD.  Note that in this case, VERTEX must be
*     set  .TRUE..

      MINACT = 0
      MINFXD = 0

      VERTEX = .FALSE.
      IF (      (PRBTYP .EQ. 'LP'  .OR.  PRBTYP .EQ. 'FP')
     $    .AND.  NCLIN  .LT. N   ) THEN
         MINFXD = N - NCLIN - 1
         VERTEX = .TRUE.
      END IF

      MXFREE = N - MINFXD
      MAXACT = MAX( 1, MIN( N, NCLIN ) )
      MAXNZ  = N - ( MINFXD + MINACT )

      IF (NCLIN .EQ. 0) THEN
         LDZY   = 1
         LDT    = 1
         NCOLT  = 1
         VERTEX = .FALSE.
      ELSE
         LDZY   = MAX( 1, MXFREE )
         LDT    = MAX( MAXNZ, MAXACT )
         NCOLT  = MXFREE
      END IF

      NCNLN  = 0
      LENNAM = 1

*     Allocate certain arrays that are not done in LSLOC.

      LITOTL = 0

      LAX    = 1
      LWTOTL = LAX + NCLIN  - 1

*     Allocate remaining work arrays.

      CALL LSLOC ( LPROB, N, NCLIN, LITOTL, LWTOTL )

      COLD  = LCRASH .EQ. 0

*     Check input parameters and storage limits.

      CALL CMCHK ( NERROR, MSGLVL, LCRASH, (.NOT.FACTRZ),
     $             LENIW, LENW, LITOTL, LWTOTL,
     $             N, NCLIN, NCNLN,
     $             ISTATE, KX, NAMED, NAMES, LENNAM,
     $             BL, BU, X )

      IF (NERROR .GT. 0) THEN
         INFORM = 6
         GO TO 800
      END IF

      LKACTV = LOCLS( 1)

      LANORM = LOCLS( 2)
      LPX    = LOCLS( 4)
      LRES   = LOCLS( 5)
      LRES0  = LOCLS( 6)
      LGQ    = LOCLS( 8)
      LCQ    = LOCLS( 9)
      LRLAM  = LOCLS(10)
      LT     = LOCLS(11)
      LZY    = LOCLS(12)
      LWTINF = LOCLS(13)
      LWRK   = LOCLS(14)
      LFEATL = LOCLS(15)

      IF (TOLFEA .GT. ZERO)
     $   CALL DLOAD ( N+NCLIN, (TOLFEA), W(LFEATL), 1 )

      IANRMJ = LANORM
      DO 200, J = 1, NCLIN
         W(IANRMJ) = DNRM2 ( N, A(J,1), LDA )
         IANRMJ    = IANRMJ + 1
  200 CONTINUE
      IF (NCLIN .GT. 0)
     $   CALL DCOND ( NCLIN, W(LANORM), 1, ASIZE, AMIN )

      CALL DCOND ( NCTOTL, W(LFEATL), 1, FEAMAX, FEAMIN )
      CALL DCOPY ( NCTOTL, W(LFEATL), 1, W(LWTINF), 1 )
      CALL DSCAL ( NCTOTL, (ONE/FEAMIN), W(LWTINF), 1 )

      SSQ1   = ZERO

      IF (FACTRZ) THEN
*        ===============================================================
*        Factorize R using QR or Cholesky.  KX must be initialized.
*        ===============================================================
         DO 210, I = 1, N
            KX(I) = I
  210    CONTINUE

         IF      (PRBTYP .EQ. 'LP'  .OR.  PRBTYP .EQ. 'FP') THEN
            NRANK = 0
         ELSE IF (PRBTYP .EQ. 'QP') THEN
*           ------------------------------------------------------------
*           Compute the Cholesky factorization of R.  The Hessian is
*           M times M and resides in the upper left-hand corner of R.
*           ------------------------------------------------------------
            DO 220, J = M+1, N
               CALL DLOAD ( M, (ZERO), R(1,J), 1 )
  220       CONTINUE

            CALL LSCHOL( LDR, M, NRANK, TOLRNK, KX, R, INFO )

            IF (NRANK .GT. 0)
     $         CALL DLOAD ( NRANK, (ZERO), W(LRES0), 1 )

         ELSE IF (PRBTYP .EQ. 'LS') THEN
*           ------------------------------------------------------------
*           Compute the orthogonal factorization PRQ = ( U ),  where P
*                                                      ( 0 )
*           is an orthogonal matrix and Q is a permutation matrix.
*           Overwrite R with the upper-triangle U.  The orthogonal
*           matrix P is applied to the residual and discarded.  The
*           permutation is stored in the array KX.  Once U has been
*           computed we need only work with vectors of length N within
*           LSCORE.  However, it is necessary to store the sum of
*           squares of the terms  B(NRANK+1),...,B(M),  where B = Pr.
*           ------------------------------------------------------------
            CALL DGEQRP( 'Column iterchanges', M, N, R, LDR,
     $                   W(LWRK), IW(LKACTV), W(LGQ), INFO )

            LJ  = LKACTV
            DO 230, J = 1, N
               JMAX = IW(LJ)
               IF (JMAX .GT. J) THEN
                  JSAVE    = KX(JMAX)
                  KX(JMAX) = KX(J)
                  KX(J)    = JSAVE
               END IF
               LJ = LJ + 1
  230       CONTINUE

            CALL DGEAPQ( 'Transpose', 'Separate', M, MIN( N,M-1 ), 
     $                   R, LDR, W(LWRK), 1, B, M, W(LGQ), INFO )

            ROWNRM = DNRM2 ( N, R(1,1), LDR )
            IF (          ROWNRM  .LE.        TOLRNK
     $          .OR.  ABS(R(1,1)) .LE. ROWNRM*TOLRNK) THEN
               NRANK = 0
            ELSE
               NRANK = IDRANK( MIN(N, M), R, LDR+1, TOLRNK )
            END IF

            IF (M .GT. NRANK) SSQ1 = DNRM2 ( M-NRANK, B(NRANK+1), 1 )

            IF (NRANK .GT. 0)
     $         CALL DCOPY ( NRANK, B, 1, W(LRES0), 1 )
         END IF
      ELSE
*        ===============================================================
*        R is input as an upper-triangular matrix with M rows.
*        ===============================================================
         NRANK = M
         IF (NRANK .GT. 0) THEN
            IF      (PRBTYP .EQ. 'QP') THEN
               CALL DLOAD ( NRANK, (ZERO), W(LRES0), 1 )
            ELSE IF (PRBTYP .EQ. 'LS') THEN
               CALL DCOPY ( NRANK, B, 1, W(LRES0), 1 )
            END IF
         END IF
      END IF

      IF (       MSGLVL .GT. 0     .AND.  NRANK  .LT. N
     $    .AND.  PRBTYP .NE. 'LP'  .AND.  PRBTYP .NE. 'FP')
     $   WRITE (NOUT, 9000) NRANK

*     ------------------------------------------------------------------
*     Find an initial working set.
*     ------------------------------------------------------------------
      CALL LSCRSH( COLD, VERTEX,
     $             NCLIN, NCTOTL, NACTIV, NARTIF,
     $             NFREE, N, LDA,
     $             ISTATE, IW(LKACTV),
     $             BIGBND, TOLACT,
     $             A, W(LAX), BL, BU, X, W(LGQ), W(LWRK) )

*     ------------------------------------------------------------------
*     Compute the TQ factorization of the constraints while keeping R in
*     upper-triangular form.  Transformations associated with Q are
*     applied to CQ.  Transformations associated with P are applied to
*     RES0.  If some simple bounds are in the working set,  KX is
*     re-ordered so that the free variables come first.
*     ------------------------------------------------------------------
*     First, add the bounds. To save a bit of work, CQ is not loaded
*     until after KX has been re-ordered.

      NGQ   = 0
      NRES  = 0
      IF (NRANK .GT. 0) NRES = 1
      UNITQ = .TRUE.

      CALL LSBNDS( UNITQ,
     $             INFORM, NZ, NFREE, NRANK, NRES, NGQ,
     $             N, LDZY, LDA, LDR, LDT,
     $             ISTATE, KX, CONDMX,
     $             A, R, W(LT), W(LRES0), W(LCQ), W(LZY),
     $             W(LWRK), W(LPX), W(LRLAM) )

      IF (LINOBJ) THEN

*        Install the transformed linear term in CQ.
*        CMQMUL applies the permutations in KX to CVEC.

         NGQ = 1
         CALL DCOPY ( N, CVEC, 1, W(LCQ), 1 )
         CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ,
     $                KX, W(LCQ), W(LZY), W(LWRK) )
      END IF

      IF (NACTIV .GT. 0) THEN
         NACT1  = NACTIV
         NACTIV = 0

         CALL LSADDS( UNITQ, VERTEX,
     $                INFORM, 1, NACT1, NACTIV, NARTIF, NZ, NFREE,
     $                NRANK, NREJTD, NRES, NGQ,
     $                N, LDZY, LDA, LDR, LDT,
     $                ISTATE, IW(LKACTV), KX, CONDMX,
     $                A, R, W(LT), W(LRES0), W(LCQ), W(LZY),
     $                W(LWRK), W(LPX), W(LRLAM) )
      END IF

*     ------------------------------------------------------------------
*     Move the initial  x  onto the constraints in the working set.
*     Compute the transformed residual vector  Pr = Pb - RQ'x.
*     ------------------------------------------------------------------
      CALL LSSETX( LINOBJ, ROWERR, UNITQ,
     $             NCLIN, NACTIV, NFREE, NRANK, NZ,
     $             N, NCTOTL, LDZY, LDA, LDR, LDT,
     $             ISTATE, IW(LKACTV), KX,
     $             JMAX, ERRMAX, CTX, XNORM,
     $             A, W(LAX), BL, BU, W(LCQ), W(LRES), W(LRES0),
     $             W(LFEATL), R, W(LT), X, W(LZY), W(LPX), W(LWRK) )

      JINF = 0

      CALL LSCORE( PRBTYP, NAMED, NAMES, LINOBJ, UNITQ,
     $             INFORM, ITER, JINF, NCLIN, NCTOTL,
     $             NACTIV, NFREE, NRANK, NZ, NRZ,
     $             N, LDA, LDR,
     $             ISTATE, IW(LKACTV), KX,
     $             CTX, OBJ, SSQ1,
     $             SUMINF, NUMINF, XNORM,
     $             BL, BU, A, CLAMDA, W(LAX),
     $             W(LFEATL), R, X, IW, W )

      OBJ    = OBJ    + CTX
      IF (PRBTYP .EQ. 'LS'  .AND.  NRANK .GT. 0)
     $   CALL DCOPY ( NRANK, W(LRES), 1, B, 1 )

*     ==================================================================
*     Print messages if required.
*     ==================================================================
  800 IF (MSGLVL .GT.   0) THEN
         IF (INFORM .EQ.   0) THEN
            IF (PRBTYP .EQ. 'FP') THEN
               WRITE (NOUT, 2001)
            ELSE
               WRITE (NOUT, 2002) PRBTYP
            END IF
         END IF
         IF (INFORM .EQ.   1) WRITE (NOUT, 2010) PRBTYP
         IF (INFORM .EQ.   2) WRITE (NOUT, 2020) PRBTYP
         IF (INFORM .EQ.   3) WRITE (NOUT, 2030)
         IF (INFORM .EQ.   4) WRITE (NOUT, 2040)
         IF (INFORM .EQ.   5) WRITE (NOUT, 2050)
         IF (INFORM .EQ.   6) WRITE (NOUT, 2060) NERROR

         IF (INFORM .LT.   6) THEN
            IF      (NUMINF .EQ. 0) THEN
                IF (PRBTYP .NE. 'FP') WRITE (NOUT, 3000) PRBTYP, OBJ
            ELSE IF (INFORM .EQ. 3) THEN
               WRITE (NOUT, 3010) SUMINF
            ELSE
               WRITE (NOUT, 3020) SUMINF
            END IF
            IF (NUMINF .GT. 0) OBJ = SUMINF
         END IF
      END IF

*     Recover the optional parameters set by the user.

      CALL ICOPY ( MXPARM, IPSVLS, 1, IPRMLS, 1 )
      CALL DCOPY ( MXPARM, RPSVLS, 1, RPRMLS, 1 )

      RETURN

 2001 FORMAT(/ ' Exit LSSOL - Feasible point found.     ')
 2002 FORMAT(/ ' Exit LSSOL - Optimal ', A2, ' solution.')
 2010 FORMAT(/ ' Exit LSSOL - Weak ',    A2, ' solution.')
 2020 FORMAT(/ ' Exit LSSOL - ', A2,         ' solution is unbounded.' )
 2030 FORMAT(/ ' Exit LSSOL - Cannot satisfy the linear constraints. ' )
 2040 FORMAT(/ ' Exit LSSOL - Too many iterations.')
 2050 FORMAT(/ ' Exit LSSOL - Too many iterations without changing X.' )
 2060 FORMAT(/ ' Exit LSSOL - ', I10, ' errors found in the input',
     $         ' parameters.  Problem abandoned.'         )
 3000 FORMAT(/ ' Final ', A2, ' objective value =', G16.7 )
 3010 FORMAT(/ ' Minimum sum of infeasibilities =', G16.7 )
 3020 FORMAT(/ ' Final sum of infeasibilities =',   G16.7 )

 9000 FORMAT(/ ' Rank of the objective function data matrix = ', I5 )

*     End of  LSSOL .

      END

C.hr snpcode5.f
C....*...1.........2.........3.........4.........5.........6.........7.*
C    
C     snpcode5.f
C
C     Copyright (C) 1990.
C
C     A. Ronald Gallant & George E. Tauchen 
C     P.O. Box 5513, Raleigh NC 27650-5513, USA   
C
C     Permission to use, copy, modify, and distribute this
C     software and its documentation for any purpose and
C     without fee is hereby granted, provided that the
C     above copyright notice appear in all copies and that
C     both that copyright notice and this permission notice
C     appear in supporting documentation.
C
C     This software is provided "as is" without any
C     expressed or implied warranty.
C
C....*...1.........2.........3.........4.........5.........6.........7.*
C.hr WHX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     WHX      1/6/90
C
C     PURPOSE
C
C     COMPUTE WEIGHTS V(J) SUCH THAT THE HERMITE CONDITIONAL DENSITY
C     CAN BE COMPUTED AS
C
C       H(Z|X,THETA)=[SUM_J: V(J)* PRD_K: Z(K)**L(K,J)]**2 * N(Z)
C
C     WHERE L(K,J) DENOTES THE ELEMENTS OF APPROPRIATE MULTI-INDEXES
C     COMPUTED USING MULTIY.
C
C     COMPUTE WEIGHTS W(I,J) SUCH THAT
C
C       G(Z|X,THETA) = SUM_IJ: W(I,J) * PRD_K: C[Z(K)| L(K,I)+L(K,J)+1]
C
C     IS A W(I,J) WEIGHTED MIXTURE OF INDEPENDENT CHI RANDOM VARIABLES
C     AS DEFINED IN MONAHAN:
C
C        C(U|A) = [2**(1-A/2)/GAMMA(A/2)] * U**(A-1) * EXP(-X**2/2)
C
C     NOTE
C     ONE CAN DRAW FROM G(Z|X,THETA), CHANGE THE SIGN OF EACH COMPONENT
C     OF Z WITH PROBABILITY 1/2, AND USE
C
C       B(Z|X,THETA)=[SUM_J: V(J)* PRD_K: |Z(K)|**L(K,J)]**2 * N(Z)
C
C     TO MAJORIZE H(Z|X,THETA) TO GET A SAMPLE FROM H(Z|X,THETA) BY THE
C     REJECTION METHOD.  SEE KENNEDY AND GENTLE.
C
C     USAGE
C     CALL WHX(V,W,X,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,LWORK)
C
C     REFERENCES
C     MONAHAN, JOHN F. (1987) "AN ALGORITHM FOR GENERATING CHI RANDOM 
C     VARIABLES," ACM TRANSACTIONS ON MATHEMATICAL SOFTWARE, VOL. 13, 
C     NO. 2, P. 168-172. ALGORITHM 651. (1988) CORRIGENDUM, VOL. 13, 
C     NO. 1  P. 111.
C     KENNEDY, WILLIAM J. JR. AND JAMES E. GENTLE (1980), STATISTICAL
C     COMPUTING, NEW YORK: MARCEL DEKKER, INC., P. 186.
C
C     SUBROUTINES CALLED
C     MULTIY,MULTIX,SETMYX,EHYX,GAMMLN
C
C     ARGUMENTS
C     V    - KY-VECTOR OF COMPUTED WEIGHTS
C            OUTPUT, REAL*8
C     W    - KY*KY-VECTOR OF COMPUTED WEIGHTS
C            OUTPUT, REAL*8
C     X    - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C            X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C            INPUT, REAL*8
C     A    - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C            COLUMNWISE
C            INPUT, REAL*8
C     B0   - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C            INPUT, REAL*8
C     B    - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C            STORED COLUMNWISE
C            INPUT, REAL*8
C     R    - AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C            FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE VAR
C            STORED COLUMNWISE, EG. R=(R11,R12,R22,R13,R23,R33,...,RMM)
C            SIGMA=R*R', THIS IS NOT THE STANDARD CHOLESKY FACTORIZATION
C            AS IT IS UPPER TRIANGULAR, NOT LOWER, USE SUBROUTINE FACTOR
C            TO COMPUTE IT FROM SIGMA, GIVEN SIGMA.
C            INPUT, REAL*8
C     M    - DIMENSION OF THE TIME SERIES, IE. LENGTH OF Y_T, MUST BE
C            LESS THAN 100
C            INPUT, INTEGER*4
C     L    - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C            INPUT, INTEGER*4
C     KY   - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     KX   - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     IDEGY- DEGREE OF THE POLYNOMIAL IN Y, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     IDEGX- DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     WORK - WORK VECTOR OF LENGTH M+KX*KY+M+M*M*L+M*(M+1)/2+2*KY.
C            REAL*8
C     LWORK- DECLARED DIMENSION OF WORK IN CALLING PROGRAM.
C            INPUT, INTEGER*4
C
C     REMARK
C     THE CALL
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     MUST PRECEDE USAGE OF THIS ROUTINE
C
      SUBROUTINE WHX(V,W,X,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,LWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 V(KY),W(KY,KY),X(M*L)
      REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
      REAL*8 WORK(LWORK)
      INTEGER*4 ALPHA(100),BETA(100),LI(100),LJ(100)
      SAVE
C
C     ERROR TRAP FOR: ALPHA(M), BETA(M*L), LI(M), LJ(M)
C
      IF ((M.GT.100).OR.(M*L.GT.100)) THEN
        WRITE(3,3002)
        STOP
      ENDIF
C
C     COMPUTE LENGTH OF STACKED PARAMETER VECTOR
C
      IBA  = 0
      IBB0 = IBA +KX*KY
      IBB  = IBB0+M
      IBR  = IBB +M*M*L
      LTHETA=IBR +M*(M+1)/2
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBY    = 0
      IBDEL  = IBY   + M
      IBW    = IBDEL + LTHETA
      LENGTH = IBW   + 2*KY
C
      IAY    = IBY   + 1
      IADEL  = IBDEL + 1
      IAW    = IBW   + 1
C
      IF (LENGTH.GT.LWORK) THEN
        WRITE(3,3003)
        STOP
      ENDIF
C
C     INITIALIZE WEIGHTS
C
      DO 20 J=1,KY
        V(J)=0.D0
      DO 20 I=1,KY
        W(I,J)=0.D0
20    CONTINUE
C
C     GET NORMALIZING CONSTANT EH
C
      CALL EHYX(WORK(IAY),X,EH,WORK(IADEL),A,B0,B,R,M,L,
     &  KY,KX,IDEGY,IDEGX,WORK(IAW))
      ROOTEH=DSQRT(EH)
C
C     COMPUTE V
C
      DO 120 IBETA=1,KX
C       GET THE EXPONENT FOR THE MONOMIAL XBETA=X**BETA
        CALL MULTIX(IBETA,BETA)
C       COMPUTE XBETA
        XBETA=1.D0
        DO 100 I=1,M*L
          IF (BETA(I).GT.0) XBETA=XBETA*(X(I)**BETA(I))
100     CONTINUE
      DO 120 IALPHA=1,KY
C       ACCUMULATE THE MONOMIALS TO GET V(J)
        V(IALPHA)=V(IALPHA)+A(KX*(IALPHA-1)+IBETA)*XBETA
120   CONTINUE
C
      DO 125 IALPHA=1,KY
        V(IALPHA)=V(IALPHA)/ROOTEH
125   CONTINUE
C
C     COMPUTE PRODUCT OF GAMMA DENSITY NORMALIZATION FACTORS
C     USE W(I,J) AS TEMPORARY STORAGE
C
      ADJ=0.D0
      DLNB=DLOG(2.D0)
      DO 165 J=1,KY
      IF (V(J).EQ.0.D0) GO TO 165
C       GET LAMBDA_J
        CALL MULTIY(J,LJ)
      DO 160 I=1,J
      IF (V(I).EQ.0.D0) GO TO 160
C       GET LAMBDA_I
        CALL MULTIY(I,LI)
C       COMPUTE SUM OF LI AND LJ
        DO 130 II=1,M
          ALPHA(II)=LI(II)+LJ(II)
130     CONTINUE
        DLG=0.D0
        DO 140 II=1,M
          IA=LI(II)+LJ(II)+1
          DI=IA/2.D0
          DLG=DLG+GAMMLN(DI)-DLNB*(1.D0-DI)
140     CONTINUE
        IF (DLG.GT.ADJ) ADJ=DLG
        W(I,J)=DLG
        W(J,I)=DLG
160   CONTINUE
165   CONTINUE
C
C     COMPUTE W(I,J)
C
      SUM=0.D0
      DO 185 J=1,KY
      IF (V(J).EQ.0.D0) GO TO 185
      DO 180 I=1,KY
      IF (V(I).EQ.0.D0) GO TO 180
        W(I,J)=DABS(V(J))*DABS(V(I))*DEXP(W(I,J)-ADJ)
        SUM=SUM+W(I,J)
180   CONTINUE
185   CONTINUE
      DO 190 J=1,KY
      DO 190 I=1,KY
        W(I,J)=W(I,J)/SUM
190   CONTINUE
C
      RETURN
3002  FORMAT(' ERROR RETURN FROM WHX, M OR M*L EXCEEDS 100')
3003  FORMAT(' ERROR RETURN FROM WHX, LWORK NOT BIG ENOUGH')
      END
C.hr SAMPY
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     SAMPY    1/17/90
C
C     PURPOSE
C     SIMULATE A Y SCALED TO ORIGINAL UNITS GIVEN AN X SCALED IN 
C     ORIGINAL UNITS
C
C     USAGE
C
C     DO 20 I=1,NREPS
C     code to fetch an X in original units
C     CALL SAMPY (0,ISEED,Y,MUSTAT,CSTAT,X,NLOG,C,
C    &            A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,LWORK)
C     DO 10 J=1,NSTEP
C     code to compute R
C     CALL SAMPY (1,ISEED,Y,MUSTAT,CSTAT,X,NLOG,C,
C    &            A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,LWORK)
C     other statements
C10   CONTINUE  
C20   CONTINUE  
C
C     SUBROUTINES CALLED
C     WHX,MULTIY,MULTIX,SETMYX,EHYX,GAMMLN,DRINV,BZ,HZ,SAMPZ,GCHIRV,RAN
C
C     ARGUMENTS
C     ISW -   SWITCH, ISW=0: INITIALIZE X.
C                     ISW=1: COMPUTE Y, NEW X
C             INPUT, INTEGER*4
C     ISEED - SEED FOR THE RANDOM NUMBER GENERATOR RAN
C             INPUT, INTEGER*4
C     Y     - A SIMULATED VALUE OF Y IN ORIGINAL UNITS.
C             OUTPUT, REAL*8
C     MUSTAT- M-VECTOR, SAMPLE MEAN OF THE DATA IN ORIGINAL UNITS.
C             INPUT, REAL*8
C     CSTAT - M BY M MATRIX CONTAINING THE FACTORED SAMPLE VARIANCE OF
C             THE DATA IN ORIGINAL UNITS, VAR = (CSTAT)*(CSTAT)'. CSTAT
C             IS ASSUMED TO HAVE ALL ZEROES BELOW THE DIAGONAL.
C             INPUT, REAL*8
C     X     - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END IN
C             TIME SERIAL ORDER. X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE
C             LESS THAT 100
C             INPUT & OUTPUT, REAL*8
C     NLOG  - SWITCH, IF NLOG.EQ.1 THE LOGISTIC TRANSFORM IS NOT USED 
C             INPUT, INTEGER*4                                        
C     C     - LOGISTIC TRANSFORM SCALE FACTOR.
C             INPUT, REAL*8
C     A    -  COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C             COLUMNWISE
C             INPUT, REAL*8
C     B0   -  M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C             INPUT, REAL*8
C     B    -  COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C             STORED COLUMNWISE
C             INPUT, REAL*8
C     R    -  AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C             FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE VAR PART
C             STORED COLUMNWISE, EG. R=(R11,R12,R22,R13,R23,R33,...,RMM)
C             SIGMA=R*R', THIS IS NOT THE STANDARD CHOLESKY FACTORIZATION
C             AS IT IS UPPER TRIANGULAR, NOT LOWER, USE SUBROUTINE FACTOR
C             TO COMPUTE IT FROM SIGMA, GIVEN SIGMA.
C             INPUT, REAL*8
C     M    -  DIMENSION OF THE TIME SERIES, IE. LENGTH OF Y_T, MUST BE
C             LESS THAN 100
C             INPUT, INTEGER*4
C     L    -  NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C             INPUT, INTEGER*4
C     KY   -  NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY SETMYX,
C             SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     KX   -  NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY SETMYX,
C             SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     IDEGY-  DEGREE OF THE POLYNOMIAL IN Y, SEE REMARK BELOW
C             INPUT, INTEGER*4
C     IDEGX-  DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C             INPUT, INTEGER*4
C     WORK -  WORK VECTOR OF LENGTH 
C             M + KX*KY + M + M*M*L +M*(M+1)/2 + 2*KY + KY + KY*KY
C     LWORK-  DECLARED DIMENSION OF WORK IN CALLING PROGRAM.
C             INPUT, INTEGER*4
C
      SUBROUTINE SAMPY(ISW,ISEED,Y,MUSTAT,CSTAT,X,NLOG,C,
     &                  A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,LWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y(M),MUSTAT(M),CSTAT(M*M),X(M*L)
      REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
      REAL*8 WORK(LWORK)
      SAVE
C
C     COMPUTE POINTERS TO WORKSPACE
C
      IBV    = 0
      IBW    = IBV    + KY
      IBWORK = IBW    + KY*KY
      LENGTH = IBWORK + M + KX*KY + M + M*M*L +M*(M+1)/2 + 2*KY
C
      IAV    = IBV    + 1
      IAW    = IBW    + 1
      IAWORK = IBWORK + 1
C
      IF(ISW.EQ.0) GO TO 10
      IF(ISW.GT.0) GO TO 100
C
C     INITIALIZATION
C
10    CONTINUE
C
C     ERROR CHECKS
C
      IF (LENGTH.GT.LWORK) THEN
        WRITE(3,3003)
        STOP
      ENDIF
      IF (L.LE.0) THEN
        WRITE(3,3004) 
        STOP
      ENDIF
C
C     POINTERS FOR THIS BLOCK
C
      IBP = 0
      IBC = IBP + M*M
C
      IAP = IBP+1
      IAC = IBC+1
C
C     LOCATION SCALE SHIFT OF X OFF OF CSTAT AND MUSTAT
C
      DO 35 J=1,M
      DO 35 I=1,J
        WORK(IBC+J*(J-1)/2+I)=CSTAT(M*(J-1)+I)
35    CONTINUE
      CALL DRINV(WORK(IAC),M)
      DO 40 J=1,M
      DO 40 I=1,M
        WORK(IBP+M*(J-1)+I)=0.D0
        IF(I.LE.J) WORK(IBP+M*(J-1)+I)=WORK(IBC+J*(J-1)/2+I)
40    CONTINUE
      DO 50 J=1,L
      DO 50 I=1,M
        WORK(IBC+M*(J-1)+I)=X(M*(J-1)+I)-MUSTAT(I)
50    CONTINUE
      DO 60 J=1,L
        CALL DGMPRD(WORK(IAP),WORK(IBC+M*(J-1)+1),X(M*(J-1)+1),M,M,1)
60    CONTINUE
C
C     LOGISTIC TRANSFORM, IF REQUIRED
C
      IF (NLOG.NE.1) THEN                                               
        DO 70 I=1,M*L                                                  
          ECX=DEXP(C*X(I))                                     
          X(I)=(4.D0/C)*ECX/(1.D0+ECX)-2.D0/C                  
70      CONTINUE                                                       
      ENDIF
      RETURN
C
C     COMPUTE Y
C
100   CONTINUE
C
C     COMPUTE WEIGHTS V & W
C
      CALL WHX(WORK(IAV),WORK(IAW),X,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,
     &         WORK(IAWORK),LWORK-IBWORK)
C
C     COMPUTE Y
C
      CALL SAMPZ(ISEED,WORK(IAWORK),WORK(IAV),WORK(IAW),M,KY,KX)
C
      DO 120 I=1,M
        Y(I)=0.D0
120   CONTINUE
      DO 130 J=1,M
      DO 130 I=1,J
        Y(I)=Y(I)+R(J*(J-1)/2+I)*WORK(IBWORK+J)
130   CONTINUE
      CALL DGMPRD(B,X,WORK(IAWORK),M,M*L,1)
      DO 140 I=1,M
        Y(I)=Y(I)+B0(I)+WORK(IBWORK+I)
140   CONTINUE
C
C     PUSH ELEMENTS OF X BACK ONE LAG
C
      IF (L.GE.2) THEN
        DO 150 I=1,M*(L-1)
          X(I) = X(M+I)
150     CONTINUE
      ENDIF
C
C     ADD NEW, LAGGED, TRANSFORMED Y TO THE END OF X
C
      IF (NLOG.NE.1) THEN                                               
        DO 170 I=1,M                                                  
          ECX=DEXP(C*Y(I))                                     
          X(M*(L-1)+I)=(4.D0/C)*ECX/(1.D0+ECX)-2.D0/C                  
170     CONTINUE                                                       
      ELSE
        DO 180 I=1,M                                                  
          X(M*(L-1)+I)=Y(I)
180     CONTINUE                                                       
      ENDIF
C
C     CONVERT Y TO ORIGINAL UNITS
C
      CALL DGMPRD(CSTAT,Y,WORK(IAWORK),M,M,1)
      DO 190 I=1,M
        Y(I)=WORK(IBWORK+I)+MUSTAT(I)
190   CONTINUE
      RETURN
3003  FORMAT(' ERROR RETURN FROM SAMPY, LWORK NOT BIG ENOUGH')
3004  FORMAT(' ERROR RETURN FROM SAMPY, L .LE. 0')
      END
C.hr SAMPZ
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     SAMPZ      1/9/90
C
C     PURPOSE
C     SAMPLE FROM THE HERMITE CONDITIONAL DENSITY USING OUTPUT FROM WHX.  
C     SEE WHX FOR DOCUMENTATION.
C
C     USAGE
C     CALL SAMPZ(ISEED,Z,V,W,M,KY,KX)
C
C     NOTE
C     THIS ROUTINE RELIES ON WHX FOR ERROR CHECKING.
C
C     SUBROUTINES CALLED
C     GCHIVR, RAN, HZ, BZ
C
      SUBROUTINE SAMPZ(ISEED,Z,V,W,M,KY,KX)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Z(M),V(KY),W(KY,KY)
      INTEGER*4 ALPHA(100),LI(100),LJ(100)
      REAL*4 GCHIRV,RAN,SA
      SAVE
C
C     TOP OF "DO ... UNTIL ... " LOOP
C
100   CONTINUE
C
      U=RAN(ISEED)
      SUM=0.D0
      DO 10 J=1,KY
      DO 10 I=1,KY
        II=I
        JJ=J
        SUM=SUM+W(I,J)
        IF (SUM.GT.U) GO TO 20
10    CONTINUE
20    CONTINUE
C
      CALL MULTIY(II,LI)
      CALL MULTIY(JJ,LJ)
C
C       COMPUTE SUM OF LI AND LJ
        DO 50 I=1,M
          ALPHA(I)=LI(I)+LJ(I)
50      CONTINUE
C
C       GENERATE M CHI'S AND RANDOMLY CHANGE SIGN
        DO 60 I=1,M
          SA=ALPHA(I)+1
          Z(I)=GCHIRV(SA,ISEED)
          IF (RAN(ISEED).GT.0.5E0) Z(I)=-Z(I)
60      CONTINUE
C       
C     UNTIL CONDITION
C
C       ACCEPT OR REJECT
        U=RAN(ISEED)
        IF ( U*BZ(Z,V,M,KY,KX) .GT. HZ(Z,V,M,KY,KX) ) GO TO 100
C
C     BOTTOM OF "DO ... UNTIL ... " LOOP
C
      RETURN
      END
C.hr BZ
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     BZ       1/9/90
C
C     PURPOSE
C     MAJORIZE HZ USING OUTPUT FROM WHX.  SEE WHX FOR DOCUMENTATION.
C     REAL*8 FUNCTION.
C
C     USAGE
C     A=BZ(Z,V,M,KY,KX)
C
C     THIS ROUTINE RELIES ON WHX FOR ERROR CHECKING.
C
      REAL*8 FUNCTION BZ(Z,V,M,KY,KX)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Z(M),V(KY)
      INTEGER*4 ALPHA(100)
      SAVE
C
      PI=3.1415926535897932D0
C
      SUM=0.D0
      DO 20 I=1,KY
        CALL MULTIY(I,ALPHA)
        ZALPHA=1.D0
        DO 10 J=1,M
          IF(ALPHA(J).GT.0) ZALPHA=ZALPHA*DABS(Z(J))**ALPHA(J)
10      CONTINUE
        SUM=SUM+DABS(V(I))*ZALPHA
20    CONTINUE
C
      SSZ=0.D0
      DO 30 J=1,M
        SSZ=SSZ+Z(J)**2
30    CONTINUE
C
      BZ=(SUM**2)*DEXP(-0.5D0*SSZ)/DSQRT(2.D0*PI)**M
C
      RETURN
      END
C.hr HZ
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     HZ       1/9/90
C
C     PURPOSE
C     COMPUTE THE HERMITE CONDITIONAL DENSITY USING OUTPUT FROM WHX.  
C     SEE WHX FOR DOCUMENTATION.  REAL*8 FUNCTION.
C
C     USAGE
C     A=HZ(Z,V,M,KY,KX)
C
C     THIS ROUTINE RELIES ON WHX FOR ERROR CHECKING.
C
      REAL*8 FUNCTION HZ(Z,V,M,KY,KX)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Z(M),V(KY)
      INTEGER*4 ALPHA(100)
      SAVE
C
      PI=3.1415926535897932D0
C
      SUM=0.D0
      DO 20 I=1,KY
        CALL MULTIY(I,ALPHA)
        ZALPHA=1.D0
        DO 10 J=1,M
          IF(ALPHA(J).GT.0) ZALPHA=ZALPHA*Z(J)**ALPHA(J)
10      CONTINUE
        SUM=SUM+V(I)*ZALPHA
20    CONTINUE
C
      SSZ=0.D0
      DO 30 J=1,M
        SSZ=SSZ+Z(J)**2
30    CONTINUE
C
      HZ=(SUM**2)*DEXP(-0.5D0*SSZ)/DSQRT(2.D0*PI)**M
C
      RETURN
      END
C.hr GCHIRV
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
      REAL FUNCTION GCHIRV(A,ISEED)
C
C  ALGORITHM TO GENERATE RANDOM VARIABLES WITH THE CHI DISTRIBUTION
C  WITH A DEGREES OF FREEDOM,  FOR A GREATER THAN OR EQUAL TO ONE
C
C  J F MONAHAN (MAY, 1986) DEPT OF STATISTICS, NCSU, RALEIGH, NC USA
C  MODIFIED 1/24/90 BY A R GALLANT TO SET SEED DIFFERENTLY
C
      REAL A
      REAL ALPHA,ALPHM1,BETA,U,V,VMIN,VDIF,Z,ZZ,RNUM,W,S,EMHLF,VMAXU,
     *     RSQRT2,EMHLF4,EQTRT2,C
      SAVE
C
      DATA EMHLF/ .6065307 /, VMAXU/ .8577639 /, RSQRT2/ .7071068 /
      DATA EMHLF4/ .1516327 /, EQTRT2/ 2.568051 /, C/ 1.036961 /
C
      DATA ALPHA/ 0. /
C                     IS THIS ALPHA THE SAME AS THE LAST ONE?
      IF( A .EQ. ALPHA ) GO TO 1
C                     DO A LITTLE SETUP
      ALPHA = A
      ALPHM1 = ALPHA - 1.
      BETA = SQRT( ALPHM1 )
C                     GET DIMENSIONS OF BOX
      VMAXU = EMHLF * ( RSQRT2 + BETA )/( .5 + BETA )
      VMIN =  -BETA
      IF( BETA .GT. 0.483643 ) VMIN = EMHLF4/ALPHA - EMHLF
      VDIF = VMAXU - VMIN
C                     START ( AND RESTART ) ALGORITHM HERE
  1   CONTINUE
      U = RAN(ISEED)
      V = VDIF*RAN(ISEED) + VMIN
      Z = V / U
C                     DO SOME QUICK REJECT CHECKS FIRST
      IF( Z .LE. - BETA ) GO TO 1
      ZZ = Z * Z
      RNUM = 2.5 - ZZ
      IF( Z .LT. 0. ) RNUM = RNUM + ZZ * Z / ( 3. * (Z + BETA ) )
C                     DO QUICK INNER CHECK
      IF( U .LT. RNUM/EQTRT2 ) GO TO 9
      IF( ZZ .GE. C / U + 1.4 ) GO TO 1
C                     ABOVE WAS KNUTH'S NORMAL OUTER CHECK
      W = 2. * ALOG( U )
C                     NOW THE REAL CHECK
      S = - ( ZZ / 2. + Z * BETA )
      IF( BETA .GT. 0. ) S = ALPHM1*ALOG(1.+Z/BETA) + S
      IF( W .GT. S ) GO TO 1
C                     SUCCESS HERE -- TRANSFORM AND GO
  9   GCHIRV = Z + BETA
      RETURN
      END
C.hr GAMMLN
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C 
C     THIS IS A MODIFICATION OF THE ROUTINE OF THE SAME NAME IN PRESS, 
C     WILLIAM H., BRIAN P. FLANNERY, SAUL A. TEUKOLSKY, AND WILLIAM T.
C     VETTERLING (1986), NUMERICAL RECIPES, CAMBRIDGE UNIVERSITY PRESS,
C     CAMBRIDGE, U.K., P. 157.
C
      REAL*8 FUNCTION GAMMLN(XX)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
      SAVE
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*DLOG(TMP)-TMP
      SER=ONE
      DO 11 J=1,6
        X=X+ONE
        SER=SER+COF(J)/X
11    CONTINUE
      GAMMLN=TMP+DLOG(STP*SER)
      RETURN
      END
C.hr RAN
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
      REAL FUNCTION RAN(IX)
C  UNIFORM PSEUDORANDOM NUMBER GENERATOR
C  FORTRAN VERSION OF LEWIS, GOODMAN, MILLER
C  SCHRAGE,  ACM TOMS V.5 (1979) P132
C  MODIFIED 1/24/90 BY A R GALLANT TO SET SEED DIFFERENTLY
      INTEGER A,P,IX,B15,B16,XHI,XALO,LEFTLO,FHI,K
      SAVE
      DATA A/16807/,B15/32768/,B16/65536/,P/2147483647/
      XHI=IX/B16
      XALO=(IX-XHI*B16)*A
      LEFTLO=XALO/B16
      FHI=XHI*A+LEFTLO
      K=FHI/B15
      IX=(((XALO-LEFTLO*B16)-P)+(FHI-K*B15)*B16)+K
      IF(IX.LT.0) IX=IX+P
      RAN=FLOAT(IX)*4.656612875E-10
      RETURN
      END

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     sizes.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine sizes(isw)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      integer*4 isw

      if (isw.eq.1) then

        open(unit=8,file=infile,status='old',form='formatted')

        read(8,8000) name
        read(8,8001) ncases
        read(8,8002) npt,iq
        read(8,8001) lx
        read(8,8001) ltau
        read(8,8001) M
        read(8,8002) Kz,Iz
        read(8,8002) Kx,Ix
        read(8,8001) maxitr
        read(8,8003) ftol
        read(8,8001) iseed
        read(8,8003) sfac
        read(8,8002) ngrd,jt
        read(8,8001) iunit9
        read(8,8001) iCvec
        read(8,8001) muzero
        read(8,8001) verify

*       This routine relies on a subsequent call to values with
*       isw=1 to read the rest of the file and close unit 8.

        return
      end if


      if (isw.eq.2) then

        open(unit=9,file=outfil,status='unknown',form='formatted')

        write(9,9000) name
        write(9,9001) ncases
        write(9,9002) npt,iq
        write(9,9003) lx
        write(9,9004) ltau
        write(9,9005) M
        write(9,9006) Kz,Iz
        write(9,9007) Kx,Ix
        write(9,9008) maxitr
        write(9,9009) ftol
        write(9,9010) iseed
        write(9,9011) sfac
        write(9,9012) ngrd,jt     
        write(9,9013) iunit9
        write(9,9017) iCvec
        write(9,9018) muzero
        write(9,9016) verify

*       This routine relies on a subsequent call to values with
*       isw=2 to write the rest of the file and close unit 9.

        return
      end if


      if (isw.eq.3) then
        write(3,3000) name
        write(3,3001) ncases
        write(3,3002) npt,iq
        write(3,3003) lx
        write(3,3004) ltau
        write(3,3005) M
        write(3,3006) Kz,Iz
        write(3,3007) Kx,Ix
        write(3,3008) maxitr
        write(3,3009) ftol
        write(3,3010) iseed
        write(3,3011) sfac
        write(3,3012) ngrd,jt
        write(3,3013) iunit9
        write(3,3017) iCvec
        write(3,3018) muzero
        write(3,3016) verify
        return
      end if

3000  format(15x,'name    ',a10  )
3001  format(15x,'ncases  ',i5,5x)
3002  format(15x,'npt,iq  ',2i5  )
3003  format(15x,'lx      ',i5,5x)
3004  format(15x,'ltau    ',i5,5x)
3005  format(15x,'M       ',i5,5x)
3006  format(15x,'Kz,Iz   ',2i5  )
3007  format(15x,'Kx,Ix   ',2i5  )
3008  format(15x,'maxitr  ',i5,5x)
3009  format(15x,'ftol    ',d10.1)
3010  format(15x,'iseed   ',i5,5x)
3011  format(15x,'sfac    ',d10.1)
3012  format(15x,'ngrd,jt ',2i5  )
3013  format(15x,'iunit9  ',i5,5x)
3016  format(15x,'verify  ',i5,5x)
3017  format(15x,'iCvec   ',i5,5x)
3018  format(15x,'muzero  ',i5,5x)
8000  format(a10)   
8001  format(i5)
8002  format(2i5)
8003  format(d10.0)
9000  format(a10,  '    name    format(a10  )')
9001  format(i5,5x,'    ncases  format(i5,5x)')
9002  format(2i5,  '    npt,iq  format(2i5  )',
     &' (npt MCarlo if iq=0, npt quad if iq=1)')  
9003  format(i5,5x,'    lx      format(i5,5x)')
9004  format(i5,5x,'    ltau    format(i5,5x)')
9005  format(i5,5x,'    M       format(i5,5x)')
9006  format(2i5,  '    Kz,Iz   format(2i5  )')
9007  format(2i5,  '    Kx,Ix   format(2i5  )')
9008  format(i5,5x,'    maxitr  format(i5,5x)')
9009  format(d10.1,'    ftol    format(d10.1)')
9010  format(i5,5x,'    iseed   format(i5,5x)')
9011  format(d10.1,'    sfac    format(d10.1)')
9012  format(2i5  ,'    ngrd,jt format(2i5  )',
     &' (plot points for joint if jt=1)')
9013  format(i5,5x,'    iunit9  format(i5,5x)',
     &' (0 parmfile, 1 eff, 2 sim, 4 plt)')
9016  format(i5,5x,'    verify  format(i5,5x)',
     &' (verify derivatives if verify=1)')
9017  format(i5,5x,'    iCvec   format(i5,5x)',
     &' (compute Cvec if iCvec=1 & iq=1)')
9018  format(i5,5x,'    muzero  format(i5,5x)',
     &' (impose Ez=0 if muzero=1)')
      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  F06 FORTRAN
*     A subset of the NAG F06 Chapter with some modifications.
*     The routines perform the same function as the NAG F06 routines.
*
*                         Level 0  F06  Scalar routines
*                         -------  ---- ---------------
*     F06AAZ+         F06BAF+         DDIV/F06BLF+    DNORM/F06BMF+
*
*                         Level 1  BLAS Vector routines
*                         -------  ---- ---------------
*     DAXPY           DCOPY           DDOT            DNRM2    
*     DSCAL           DSWAP           IDAMAX          DROT
*
*                         Level 1  F06  Vector routines
*                         -------  ---  ---------------
*     F06DBF/ILOAD    F06FBF/DLOAD    F06FCF/DDSCL    F06DFF/ICOPY      
*     F06FJF/DSSQ+    F06FKF          F06FLF/DCOND    F06KLF/IDRANK+    
*     F06FQF          F06FRF/DGRFG+
*
*                         Level 2  BLAS Matrix-vector routines
*                         -------  ---  ----------------------
*     DGEMV           DGER            DSYMV           DSYR     
*     DTRMV           DTRSV
*
*                         Level 2  F06  Matrix routines
*                         -------  ---  ---------------
*     F06QFF          F06QGF          F06QHF          F06QJF   
*     F06QKF          F06QNF          F06QRF          F06QSF   
*     F06QTF          F06QVF          F06QWF          F06QXF   
*     F06QZF
*
*    +Differs from the Nag F06 version.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

*UPTODATE F06AAZTEXT
      SUBROUTINE F06AAZ( SRNAME, INFO )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     Modified by PEG 9/25/88.
C     .. Scalar Arguments ..
      INTEGER            INFO
      CHARACTER*13       SRNAME
C     ..
C
C  Purpose
C  =======
C
C  F06AAZ  is an error handler for the Level 2 BLAS routines.
C
C  It is called by the Level 2 BLAS routines if an input parameter is
C  invalid.
C
C  Parameters
C  ==========
C
C  SRNAME - CHARACTER*13.
C           On entry, SRNAME specifies the name of the routine which
C           called F06AAZ.
C
C  INFO   - INTEGER.
C           On entry, INFO specifies the position of the invalid
C           parameter in the parameter-list of the calling routine.
C
C
C  Auxiliary routine for Level 2 Blas.
C
C  Written on 20-July-1986.
C
C     .. Local Scalars ..
      CHARACTER*80       REC (1)
C     ..
C     .. Executable Statements ..
      WRITE (REC (1),99999) SRNAME, INFO
C
      RETURN
C
99999 FORMAT ( ' ** On entry to ', A13, ' parameter number ', I2,
     $         ' had an illegal value' )
C
C     End of F06AAZ.
C
      END
** END OF F06AAZTEXT
      SUBROUTINE F06BAF( X, Y, CS, SN )

      DOUBLE PRECISION   X, Y, CS, SN

      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

C
C  DROT3G  generates a plane rotation that reduces the vector (X, Y) to
C  the vector (A, 0),  where A is defined as follows...
C
C     If both X and Y are negligibly small, or
C     if Y is negligible relative to Y,
C     then  A = X,  and the identity rotation is returned.
C
C     If X is negligible relative to Y,
C     then  A = Y,  and the swap rotation is returned.
C
C     Otherwise,  A = sign(X) * sqrt( X**2 + Y**2 ).
C
C  In all cases,  X and Y are overwritten by A and 0,  and CS will lie
C  in the closed interval (0, 1).  Also,  the absolute value of CS and
C  SN (if nonzero) will be no less than the machine precision,  EPS.
C
C  DROT3G  guards against overflow and underflow.
C  It is assumed that  FLMIN .lt. EPS**2  (i.e.  RTMIN .lt. EPS).
C
C  Systems Optimization Laboratory, Stanford University.
C  Original version dated January 1982.
C  F77 version dated 28-June-1986.
C  This version of DROT3G dated 28-June-1986.
C
      DOUBLE PRECISION   A, B, EPS, ONE, RTMIN, ZERO
      LOGICAL            FIRST
      INTRINSIC          ABS, MAX, SQRT
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      SAVE               FIRST , EPS   , RTMIN
      DATA               FIRST / .TRUE. /

      IF( FIRST )THEN
         FIRST = .FALSE.
         EPS    = WMACH(3)
         RTMIN  = WMACH(6)
      END IF

      IF (Y .EQ. ZERO) THEN

         CS = ONE
         SN = ZERO

      ELSE IF (X .EQ. ZERO) THEN

         CS = ZERO
         SN = ONE
         X  = Y

      ELSE

         A      = ABS(X)
         B      = ABS(Y)
         IF (MAX(A,B) .LE. RTMIN) THEN
            CS = ONE
            SN = ZERO
         ELSE
            IF (A .GE. B) THEN
               IF (B .LE. EPS*A) THEN
                  CS = ONE
                  SN = ZERO
                  GO TO 900
               ELSE
                  A  = A * SQRT( ONE + (B/A)**2 )
               END IF
            ELSE
               IF (A .LE. EPS*B) THEN
                  CS = ZERO
                  SN = ONE
                  X  = Y
                  GO TO 900
               ELSE
                  A  = B * SQRT( ONE + (A/B)**2 )
               END IF
            END IF
            IF (X .LT. ZERO) A = - A
            CS = X/A
            SN = Y/A
            X  = A
         END IF
      END IF

  900 Y  = ZERO

      RETURN

*     End of  F06BAF (DROT3G).

      END
*UPTODATE F06BLFTEXT
      DOUBLE PRECISION FUNCTION F06BLF( A, B, FAIL )
      DOUBLE PRECISION          DDIV
      ENTRY                     DDIV  ( A, B, FAIL )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     Modified by PEG 9/25/88.
C     .. Scalar Arguments ..
      DOUBLE PRECISION                  A, B
      LOGICAL                           FAIL
C     ..
C
C  F06BLF returns the value div given by
C
C     div = ( a/b                 if a/b does not overflow,
C           (
C           ( 0.0                 if a .eq. 0.0,
C           (
C           ( sign( a/b )*flmax   if a .ne. 0.0  and a/b would overflow,
C
C  where  flmax  is a large value, via the function name. In addition if
C  a/b would overflow then  fail is returned as true, otherwise  fail is
C  returned as false.
C
C  Note that when  a and b  are both zero, fail is returned as true, but
C  div  is returned as  0.0. In all other cases of overflow  div is such
C  that  abs( div ) = flmax.
C
C  When  b = 0  then  sign( a/b )  is taken as  sign( a ).
C
C  Nag Fortran 77 O( 1 ) basic linear algebra routine.
C
C  -- Written on 26-October-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION      ONE         , ZERO
      PARAMETER           ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION      ABSB, DIV, FLMAX, FLMIN
      LOGICAL               FIRST
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
C     .. Intrinsic Functions ..
      INTRINSIC             ABS, SIGN
C     .. Save statement ..
      SAVE                  FIRST, FLMIN, FLMAX
C     .. Data statements ..
      DATA                  FIRST/ .TRUE. /
C     ..
C     .. Executable Statements ..
      IF( A.EQ.ZERO )THEN
         DIV = ZERO
         IF( B.EQ.ZERO )THEN
            FAIL = .TRUE.
         ELSE
            FAIL = .FALSE.
         END IF
      ELSE
C
         IF( FIRST )THEN
            FIRST  = .FALSE.
            FLMIN  = WMACH( 5 )
            FLMAX  = WMACH( 7 )
         END IF
C
         IF( B.EQ.ZERO )THEN
            DIV  =  SIGN( FLMAX, A )
            FAIL = .TRUE.
         ELSE
            ABSB = ABS( B )
            IF( ABSB.GE.ONE )THEN
               FAIL = .FALSE.
               IF( ABS( A ).GE.ABSB*FLMIN )THEN
                  DIV = A/B
               ELSE
                  DIV = ZERO
               END IF
            ELSE
               IF( ABS( A ).LE.ABSB*FLMAX )THEN
                  FAIL = .FALSE.
                  DIV  =  A/B
               ELSE
                  FAIL = .TRUE.
                  DIV  = FLMAX
                  IF( ( ( A.LT.ZERO ).AND.( B.GT.ZERO ) ).OR.
     $                ( ( A.GT.ZERO ).AND.( B.LT.ZERO ) )     )
     $               DIV = -DIV
               END IF
            END IF
         END IF
      END IF
C
      F06BLF = DIV
      RETURN
C
C     End of F06BLF. ( DDIV )
C
      END
** END OF F06BLFTEXT
*UPTODATE F06BMFTEXT
      DOUBLE PRECISION FUNCTION F06BMF( SCALE, SSQ )
      DOUBLE PRECISION          DNORM
      ENTRY                     DNORM ( SCALE, SSQ )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     Modified by PEG 9/25/88.
C     .. Scalar Arguments ..
      DOUBLE PRECISION                  SCALE, SSQ
C     ..
C
C  F06BMF returns the value norm given by
C
C     norm = ( scale*sqrt( ssq ), scale*sqrt( ssq ) .lt. flmax
C            (
C            ( flmax,             scale*sqrt( ssq ) .ge. flmax
C
C  via the function name.
C
C
C  Nag Fortran 77 O( 1 ) basic linear algebra routine.
C
C  -- Written on 22-October-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      DOUBLE PRECISION      FLMAX, NORM, SQT
      LOGICAL               FIRST
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
C     .. Intrinsic Functions ..
      INTRINSIC             SQRT
C     .. Save statement ..
      SAVE                  FIRST, FLMAX
C     .. Data statements ..
      DATA                  FIRST/ .TRUE. /
C     ..
C     .. Executable Statements ..
      IF( FIRST )THEN
         FIRST = .FALSE.
         FLMAX = WMACH( 7 )
      END IF
C
      SQT = SQRT( SSQ )
      IF( SCALE.LT.FLMAX/SQT )THEN
         NORM = SCALE*SQT
      ELSE
         NORM = FLMAX
      END IF
C
      F06BMF = NORM
      RETURN
C
C     End of F06BMF. ( DNORM )
C
      END
** END OF F06BMFTEXT
*UPTODATE F06ECFTEXT
      SUBROUTINE F06ECF( N, ALPHA, X, INCX, Y, INCY )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     Modified by PEG 9/25/88.
C     .. Entry Points ..
      ENTRY      DAXPY ( N, ALPHA, X, INCX, Y, INCY )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, INCY, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * ), Y( * )
C     ..
C
C  F06ECF performs the operation
C
C     y := alpha*x + y
C
C
C  Nag Fortran 77 version of the Blas routine DAXPY.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 3-September-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      INTEGER            I, IX, IY
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ALPHA.NE.ZERO )THEN
            IF( ( INCX.EQ.INCY ).AND.( INCX.GT.0 ) )THEN
               DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
                  Y( IX ) = ALPHA*X( IX ) + Y( IX )
   10          CONTINUE
            ELSE
               IF( INCY.GE.0 )THEN
                  IY = 1
               ELSE
                  IY = 1 - ( N - 1 )*INCY
               END IF
               IF( INCX.GT.0 )THEN
                  DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
                     Y( IY ) = ALPHA*X( IX ) + Y( IY )
                     IY      = IY            + INCY
   20             CONTINUE
               ELSE
                  IX = 1 - ( N - 1 )*INCX
                  DO 30, I = 1, N
                     Y( IY ) = ALPHA*X( IX ) + Y( IY )
                     IX      = IX            + INCX
                     IY      = IY            + INCY
   30             CONTINUE
               END IF
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06ECF. ( DAXPY )
C
      END
** END OF F06ECFTEXT
*UPTODATE F06EFFTEXT
      SUBROUTINE F06EFF( N, X, INCX, Y, INCY )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      ENTRY      DCOPY ( N, X, INCX, Y, INCY )
C     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * ), Y( * )
C     ..
C
C  F06EFF performs the operation
C
C     y := x
C
C
C  Nag Fortran 77 version of the Blas routine DCOPY.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 26-November-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      INTEGER            I, IX, IY
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ( INCX.EQ.INCY ).AND.( INCY.GT.0 ) )THEN
            DO 10, IY = 1, 1 + ( N - 1 )*INCY, INCY
               Y( IY ) = X( IY )
   10       CONTINUE
         ELSE
            IF( INCX.GE.0 )THEN
               IX = 1
            ELSE
               IX = 1 - ( N - 1 )*INCX
            END IF
            IF( INCY.GT.0 )THEN
               DO 20, IY = 1, 1 + ( N - 1 )*INCY, INCY
                  Y( IY ) = X( IX )
                  IX      = IX      + INCX
   20          CONTINUE
            ELSE
               IY = 1 - ( N - 1 )*INCY
               DO 30, I = 1, N
                  Y( IY ) = X( IX )
                  IY      = IY      + INCY
                  IX      = IX      + INCX
   30          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06EFF. ( DCOPY )
C
      END
** END OF F06EFFTEXT
*UPTODATE F06EAFTEXT
      DOUBLE PRECISION FUNCTION F06EAF( N, X, INCX, Y, INCY )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      DOUBLE PRECISION          DDOT
      ENTRY                     DDOT  ( N, X, INCX, Y, INCY )
C     .. Scalar Arguments ..
      INTEGER                           INCX, INCY, N
C     .. Array Arguments ..
      DOUBLE PRECISION                  X( * ), Y( * )
C     ..
C
C  F06EAF returns the value
C
C     F06EAF = x'y
C
C
C  Nag Fortran 77 version of the Blas routine DDOT.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 21-September-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION      ZERO
      PARAMETER           ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION      SUM
      INTEGER               I, IX, IY
C     ..
C     .. Executable Statements ..
      SUM = ZERO
      IF( N.GT.0 )THEN
         IF( ( INCX.EQ.INCY ).AND.( INCX.GT.0 ) )THEN
            DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
               SUM = SUM + X( IX )*Y( IX )
   10       CONTINUE
         ELSE
            IF( INCY.GE.0 )THEN
               IY = 1
            ELSE
               IY = 1 - ( N - 1 )*INCY
            END IF
            IF( INCX.GT.0 )THEN
               DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
                  SUM = SUM + X( IX )*Y( IY )
                  IY  = IY  + INCY
   20          CONTINUE
            ELSE
               IX = 1 - ( N - 1 )*INCX
               DO 30, I = 1, N
                  SUM = SUM + X( IX )*Y( IY )
                  IX  = IX  + INCX
                  IY  = IY  + INCY
   30          CONTINUE
            END IF
         END IF
      END IF
C
      F06EAF = SUM
      RETURN
C
C     End of F06EAF. ( DDOT )
C
      END
** END OF F06EAFTEXT
*UPTODATE F06EJFTEXT
      DOUBLE PRECISION FUNCTION F06EJF( N, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      DOUBLE PRECISION          DNRM2
      ENTRY                     DNRM2 ( N, X, INCX )
C     .. Scalar Arguments ..
      INTEGER                           INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION                  X( * )
C     ..
C
C  F06EJF returns the euclidean norm of a vector via the function
C  name, so that
C
C     F06EJF := sqrt( x'*x )
C
C
C  Nag Fortran 77 version of the Blas routine DNRM2.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 25-October-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION      ONE         , ZERO
      PARAMETER           ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION      NORM, SCALE, SSQ
C     .. External Functions ..
      DOUBLE PRECISION      F06BMF
      EXTERNAL              F06BMF
C     .. External Subroutines ..
      EXTERNAL              F06FJF
C     .. Intrinsic Functions ..
      INTRINSIC             ABS
C     ..
C     .. Executable Statements ..
      IF( N.LT.1 )THEN
         NORM  = ZERO
      ELSE IF( N.EQ.1 )THEN
         NORM  = ABS( X( 1 ) )
      ELSE
         SCALE = ZERO
         SSQ   = ONE
         CALL F06FJF( N, X, INCX, SCALE, SSQ )
         NORM  = F06BMF( SCALE, SSQ )
      END IF
C
      F06EJF = NORM
      RETURN
C
C     End of F06EJF. ( DNRM2 )
C
      END
** END OF F06EJFTEXT
*UPTODATE F06EDFTEXT
      SUBROUTINE F06EDF( N, ALPHA, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      ENTRY      DSCAL ( N, ALPHA, X, INCX )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
C     ..
C
C  F06EDF performs the operation
C
C     x := alpha*x
C
C
C  Nag Fortran 77 version of the Blas routine DSCAL.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 26-November-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      INTEGER            IX
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ALPHA.EQ.ZERO )THEN
            DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = ZERO
   10       CONTINUE
         ELSE IF( ALPHA.EQ.( -ONE ) )THEN
            DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = -X( IX )
   20       CONTINUE
         ELSE IF( ALPHA.NE.ONE )THEN
            DO 30, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = ALPHA*X( IX )
   30       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06EDF. ( DSCAL )
C
      END
** END OF F06EDFTEXT
*UPTODATE F06EGFTEXT
      SUBROUTINE F06EGF( N, X, INCX, Y, INCY )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      ENTRY      DSWAP ( N, X, INCX, Y, INCY )
C     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * ), Y( * )
C     ..
C
C  F06EGF performs the operations
C
C     temp := x,   x := y,   y := temp.
C
C
C  Nag Fortran 77 version of the Blas routine DSWAP.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 26-November-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, IX, IY
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ( INCX.EQ.INCY ).AND.( INCY.GT.0 ) )THEN
            DO 10, IY = 1, 1 + ( N - 1 )*INCY, INCY
               TEMP    = X( IY )
               X( IY ) = Y( IY )
               Y( IY ) = TEMP
   10       CONTINUE
         ELSE
            IF( INCX.GE.0 )THEN
               IX = 1
            ELSE
               IX = 1 - ( N - 1 )*INCX
            END IF
            IF( INCY.GT.0 )THEN
               DO 20, IY = 1, 1 + ( N - 1 )*INCY, INCY
                  TEMP    = X( IX )
                  X( IX ) = Y( IY )
                  Y( IY ) = TEMP
                  IX      = IX      + INCX
   20          CONTINUE
            ELSE
               IY = 1 - ( N - 1 )*INCY
               DO 30, I = 1, N
                  TEMP    = X( IX )
                  X( IX ) = Y( IY )
                  Y( IY ) = TEMP
                  IY      = IY      + INCY
                  IX      = IX      + INCX
   30          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06EGF. ( DSWAP )
C
      END
** END OF F06EGFTEXT
*UPTODATE F06JLFTEXT
      INTEGER FUNCTION F06JLF( N, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      INTEGER          IDAMAX
      ENTRY            IDAMAX( N, X, INCX )
C     .. Scalar Arguments ..
      INTEGER                  INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION         X( * )
C     ..
C
C  F06JLF returns the smallest value of i such that
C
C     abs( x( i ) ) = max( abs( x( j ) ) )
C                      j
C
C
C  Nag Fortran 77 version of the Blas routine IDAMAX.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 31-May-1983.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      DOUBLE PRECISION         XMAX
      INTEGER                  I, IMAX, IX
C     .. Intrinsic Functions ..
      INTRINSIC                ABS
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IMAX = 1
         IF( N.GT.1 )THEN
            XMAX = ABS( X( 1 ) )
            IX   = 1
            DO 10, I = 2, N
               IX = IX + INCX
               IF( XMAX.LT.ABS( X( IX ) ) )THEN
                  XMAX = ABS( X( IX ) )
                  IMAX = I
               END IF
   10       CONTINUE
         END IF
      ELSE
         IMAX = 0
      END IF
C
      F06JLF = IMAX
      RETURN
C
C     End of F06JLF. ( IDAMAX )
C
      END
** END OF F06JLFTEXT
*UPTODATE F06EPFTEXT
      SUBROUTINE F06EPF( N, X, INCX, Y, INCY, C, S )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Entry Points ..
      ENTRY      DROT  ( N, X, INCX, Y, INCY, C, S )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   C, S
      INTEGER            INCX, INCY, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * ), Y( * )
C     ..
C
C  F06EPF performs the plane rotation
C
C     ( x  y ) = ( x  y )*( c  -s ).
C                         ( s   c )
C
C
C  Nag Fortran 77 version of the Blas routine DROT.
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 23-January-1984.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP1
      INTEGER            I, IX, IY
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ( S.NE.ZERO ).OR.( C.NE.ONE ) )THEN
            IF( ( C.EQ.ZERO ).AND.( S.EQ.ONE ) )THEN
               IF( ( INCX.EQ.INCY ).AND.( INCX.GT.0 ) )THEN
                  DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
                     TEMP1   = -X( IX )
                     X( IX ) =  Y( IX )
                     Y( IX ) =  TEMP1
   10             CONTINUE
               ELSE
                  IF( INCY.GE.0 )THEN
                     IY = 1
                  ELSE
                     IY = 1 - ( N - 1 )*INCY
                  END IF
                  IF( INCX.GT.0 )THEN
                     DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
                        TEMP1   = -X( IX )
                        X( IX ) =  Y( IY )
                        Y( IY ) =  TEMP1
                        IY      =  IY       + INCY
   20                CONTINUE
                  ELSE
                     IX = 1 - ( N - 1 )*INCX
                     DO 30, I = 1, N
                        TEMP1   = -X( IX )
                        X( IX ) =  Y( IY )
                        Y( IY ) =  TEMP1
                        IX      =  IX      + INCX
                        IY      =  IY      + INCY
   30                CONTINUE
                  END IF
               END IF
            ELSE IF( ( C.EQ.ZERO ).AND.( S.EQ.( -ONE ) ) )THEN
               IF( ( INCX.EQ.INCY ).AND.( INCX.GT.0 ) )THEN
                  DO 40, IX = 1, 1 + ( N - 1 )*INCX, INCX
                     TEMP1   =  X( IX )
                     X( IX ) = -Y( IX )
                     Y( IX ) =  TEMP1
   40             CONTINUE
               ELSE
                  IF( INCY.GE.0 )THEN
                     IY = 1
                  ELSE
                     IY = 1 - ( N - 1 )*INCY
                  END IF
                  IF( INCX.GT.0 )THEN
                     DO 50, IX = 1, 1 + ( N - 1 )*INCX, INCX
                        TEMP1   =  X( IX )
                        X( IX ) = -Y( IY )
                        Y( IY ) =  TEMP1
                        IY      =  IY       + INCY
   50                CONTINUE
                  ELSE
                     IX = 1 - ( N - 1 )*INCX
                     DO 60, I = 1, N
                        TEMP1   =  X( IX )
                        X( IX ) = -Y( IY )
                        Y( IY ) =  TEMP1
                        IX      =  IX      + INCX
                        IY      =  IY      + INCY
   60                CONTINUE
                  END IF
               END IF
            ELSE
               IF( ( INCX.EQ.INCY ).AND.( INCX.GT.0 ) )THEN
                  DO 70, IX = 1, 1 + ( N - 1 )*INCX, INCX
                     TEMP1   = X( IX )
                     X( IX ) = S*Y( IX ) + C*TEMP1
                     Y( IX ) = C*Y( IX ) - S*TEMP1
   70             CONTINUE
               ELSE
                  IF( INCY.GE.0 )THEN
                     IY = 1
                  ELSE
                     IY = 1 - ( N - 1 )*INCY
                  END IF
                  IF( INCX.GT.0 )THEN
                     DO 80, IX = 1, 1 + ( N - 1 )*INCX, INCX
                        TEMP1   = X( IX )
                        X( IX ) = S*Y( IY ) + C*TEMP1
                        Y( IY ) = C*Y( IY ) - S*TEMP1
                        IY      = IY        + INCY
   80                CONTINUE
                  ELSE
                     IX = 1 - ( N - 1 )*INCX
                     DO 90, I = 1, N
                        TEMP1   = X( IX )
                        X( IX ) = S*Y( IY ) + C*TEMP1
                        Y( IY ) = C*Y( IY ) - S*TEMP1
                        IX      = IX        + INCX
                        IY      = IY        + INCY
   90                CONTINUE
                  END IF
               END IF
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06EPF. ( DROT )
C
      END
** END OF F06EPFTEXT
*UPTODATE F06DBFTEXT
      SUBROUTINE F06DBF( N, CONST, X, INCX )
      ENTRY      ILOAD ( N, CONST, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      INTEGER            CONST, INCX, N
C     .. Array Arguments ..
      INTEGER            X( * )
C     ..
C                      
C  F06DBF performs the operation
C
C     x = const*e,   e' = ( 1  1 ... 1 ).
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 18-February-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      INTEGER            IX
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( CONST.NE.0 )THEN
            DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = CONST
   10       CONTINUE
         ELSE
            DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = 0
   20       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06DBF. ( ILOAD )
C
      END
** END OF F06DBFTEXT
*UPTODATE F06FBFTEXT
      SUBROUTINE F06FBF( N, CONST, X, INCX )
      ENTRY      DLOAD ( N, CONST, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      DOUBLE PRECISION   CONST
      INTEGER            INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
C     ..
C
C  F06FBF performs the operation
C
C     x = const*e,   e' = ( 1  1 ... 1 ).
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 22-September-1983.
C     Sven Hammarling, Nag Central Office.
C
C                      
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      INTEGER            IX
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( CONST.NE.ZERO )THEN
            DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = CONST
   10       CONTINUE
         ELSE
            DO 20, IX = 1, 1 + ( N - 1 )*INCX, INCX
               X( IX ) = ZERO
   20       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06FBF. ( DLOAD )
C
      END
** END OF F06FBFTEXT
*UPTODATE F06FCFTEXT
      SUBROUTINE F06FCF( N, D, INCD, X, INCX )
      ENTRY      DDSCL ( N, D, INCD, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      INTEGER            INCD, INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION   D( * ), X( * )
C     ..
C
C  F06FCF performs the operation
C
C     x := diag( d )*x
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 22-September-1983.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      INTEGER            I, ID, IX
C     .. External Subroutines ..
      EXTERNAL           DSCAL
C     .. Intrinsic Functions ..
      INTRINSIC          ABS
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ( INCD.EQ.0 ).AND.( INCX.NE.0 ) )THEN
            CALL DSCAL( N, D( 1 ), X, ABS( INCX ) )
         ELSE IF( ( INCD.EQ.INCX ).AND.( INCD.GT.0 ) )THEN
            DO 10, ID = 1, 1 + ( N - 1 )*INCD, INCD
               X( ID ) = D( ID )*X( ID )
   10       CONTINUE
         ELSE
            IF( INCX.GE.0 )THEN
               IX = 1
            ELSE
               IX = 1 - ( N - 1 )*INCX
            END IF
            IF( INCD.GT.0 )THEN
               DO 20, ID = 1, 1 + ( N - 1 )*INCD, INCD
                  X( IX ) = D( ID )*X( IX )
                  IX      = IX              + INCX
   20          CONTINUE
            ELSE
               ID = 1 - ( N - 1 )*INCD
               DO 30, I = 1, N
                  X( IX ) = D( ID )*X( IX )
                  ID      = ID              + INCD
                  IX      = IX              + INCX
   30          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06FCF. ( DDSCL )
C            
      END
** END OF F06FCFTEXT
*UPTODATE F06DFFTEXT
      SUBROUTINE F06DFF( N, X, INCX, Y, INCY )
      ENTRY      ICOPY ( N, X, INCX, Y, INCY )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      INTEGER            INCX, INCY, N
C     .. Array Arguments ..
      INTEGER            X( * ), Y( * )
C     ..
C
C  F06DFF performs the operation
C
C     y := x
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 10-February-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      INTEGER            I, IX, IY
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ( INCX.EQ.INCY ).AND.( INCY.GT.0 ) )THEN
            DO 10, IY = 1, 1 + ( N - 1 )*INCY, INCY
               Y( IY ) = X( IY )
   10       CONTINUE
         ELSE
            IF( INCX.GE.0 )THEN
               IX = 1
            ELSE
               IX = 1 - ( N - 1 )*INCX
            END IF
            IF( INCY.GT.0 )THEN
               DO 20, IY = 1, 1 + ( N - 1 )*INCY, INCY
                  Y( IY ) = X( IX )
                  IX      = IX      + INCX
   20          CONTINUE
            ELSE
               IY = 1 - ( N - 1 )*INCY
               DO 30, I = 1, N
                  Y( IY ) = X( IX )
                  IY      = IY      + INCY
                  IX      = IX      + INCX
   30          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06DFF. ( ICOPY )
C
      END
** END OF F06DFFTEXT
*UPTODATE F06FJFTEXT
      SUBROUTINE F06FJF( N, X, INCX, SCALE, SUMSQ )
      ENTRY      DSSQ  ( N, X, INCX, SCALE, SUMSQ )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      DOUBLE PRECISION   SCALE, SUMSQ
      INTEGER            INCX, N
C     .. Array Arguments ..                   
      DOUBLE PRECISION   X( * )
C     ..
C
C  F06FJF returns the values scl and smsq such that
C
C     ( scl**2 )*smsq = x( 1 )**2 +...+ x( n )**2 + ( scale**2 )*sumsq,
C
C  where x( i ) = X( 1 + ( i - 1 )*INCX ). The value of sumsq is assumed
C  to be at least unity and the value of smsq will then satisfy
C
C     1.0 .le. smsq .le. ( sumsq + n ) .
C
C  scale is assumed to be non-negative and scl returns the value
C
C     scl = max( scale, abs( x( i ) ) ) .
C
C  scale and sumsq must be supplied in SCALE and SUMSQ respectively.
C  scl and smsq are overwritten on SCALE and SUMSQ respectively.
C
C  The routine makes only one pass through the vector X.
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 22-October-1982.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   ABSXI
      INTEGER            IX
C     .. Intrinsic Functions ..
      INTRINSIC          ABS
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         DO 10, IX = 1, 1 + ( N - 1 )*INCX, INCX
            IF( X( IX ).NE.ZERO )THEN
               ABSXI = ABS( X( IX ) )
               IF( SCALE.LT.ABSXI )THEN
                  SUMSQ = 1     + SUMSQ*( SCALE/ABSXI )**2
                  SCALE = ABSXI
               ELSE
                  SUMSQ = SUMSQ +       ( ABSXI/SCALE )**2
               END IF
            END IF
   10    CONTINUE
      END IF
      RETURN
C
C     End of F06FJF. ( DSSQ )
C
      END
** END OF F06FJFTEXT
*UPTODATE F06FKFTEXT
      DOUBLE PRECISION FUNCTION F06FKF( N, W, INCW, X, INCX )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      INTEGER                           INCW, INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION                  W( * ), X( * )
C     ..
C
C  F06FKF returns the weighted euclidean norm of a vector via the
C  function name, so that
C
C     F06FKF := sqrt( x'*W*x ),   where   W = diag( w ).
C
C  The elements of w are assumed to be non-negative.
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 25-June-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION      ONE         , ZERO
      PARAMETER           ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION      ABSYI, NORM, SCALE, SSQ
      INTEGER               I, IW, IX
C     .. External Functions ..
      DOUBLE PRECISION      F06BMF
      EXTERNAL              F06BMF
C     .. Intrinsic Functions ..
      INTRINSIC             ABS, SQRT
C     ..
C     .. Executable Statements ..
      IF( N.LT.1 )THEN
         NORM  = ZERO
      ELSE IF( N.EQ.1 )THEN
         NORM  = SQRT( W( 1 ) )*ABS( X( 1 ) )
      ELSE
         IF( INCW.GT.0 )THEN
            IW = 1
         ELSE
            IW = 1 - ( N - 1 )*INCW
         END IF
         IF( INCX.GT.0 )THEN
            IX = 1
         ELSE
            IX = 1 - ( N - 1 )*INCX
         END IF
         SCALE = ZERO
         SSQ   = ONE
         DO 10, I = 1, N
            IF( ( W( IW ).NE.ZERO ).AND.( X( IX ).NE.ZERO ) )THEN
               ABSYI = SQRT( W( IW ) )*ABS( X( IX ) )
               IF( SCALE.LT.ABSYI )THEN
                  SSQ   = 1     + SSQ*( SCALE/ABSYI )**2
                  SCALE = ABSYI
               ELSE
                  SSQ   = SSQ   +     ( ABSYI/SCALE )**2
               END IF
            END IF
            IW = IW + INCW
            IX = IX + INCX
   10    CONTINUE
         NORM = F06BMF( SCALE, SSQ )
      END IF
C
      F06FKF = NORM
      RETURN
C
C     End of F06FKF.
C
      END
** END OF F06FKFTEXT
*UPTODATE F06FLFTEXT
      SUBROUTINE F06FLF( N, X, INCX, XMAX, XMIN )
      ENTRY      DCOND ( N, X, INCX, XMAX, XMIN )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      DOUBLE PRECISION   XMAX, XMIN
      INTEGER            INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
C     ..
C
C  F06FLF returns the values xmax and xmin given by
C
C     xmax = max( abs( x( i ) ) ),   xmin = min( abs( x( i ) ) ).
C             i                              i
C
C  If n is less than unity then xmax and xmin are returned as zero.
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 27-February-1986.
C     Sven Hammarling, Nag Central Office.
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      INTEGER            IX
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
C     ..
C     .. Executable Statements ..
      IF( N.LT.1 )THEN
         XMAX = ZERO
         XMIN = ZERO
      ELSE
         XMAX = ABS( X( 1 ) )
         XMIN = XMAX
         DO 10 IX = 1 + INCX, 1 + ( N - 1 )*INCX, INCX
            XMAX = MAX( XMAX, ABS( X( IX ) ) )
            XMIN = MIN( XMIN, ABS( X( IX ) ) )
   10    CONTINUE
      END IF
C
      RETURN
C
C     End of F06FLF. ( DCOND )
C
      END
** END OF F06FLFTEXT
*UPTODATE F06KLFTEXT
      INTEGER FUNCTION F06KLF( N, X, INCX, TOL )
      INTEGER          IDRANK                    
      ENTRY            IDRANK( N, X, INCX, TOL )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     Modified by PEG 9/25/88.
C     .. Scalar Arguments ..
      DOUBLE PRECISION         TOL
      INTEGER                  INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION         X( * )
C     ..
C
C  F06KLF finds the first element of the n element vector x for which
C
C     abs( x( k ) ).le.tol*max( abs( x( 1 ) ), ..., abs( x( k - 1 ) ) )
C
C  and returns the value ( k - 1 ) in the function name F06KLF. If no
C  such k exists then F06KLF is returned as n.
C
C  If tol is supplied as less than zero then the value epsmch, where
C  epsmch is the relative machine precision, is used in place of tol.
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 27-February-1986.
C     Sven Hammarling, Nag Central Office.
C                        
C     .. Parameters ..
      DOUBLE PRECISION         ZERO
      PARAMETER              ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION         TL, XMAX
      INTEGER                  IX, K
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
C     .. Intrinsic Functions ..
      INTRINSIC                ABS, MAX
C     ..
C     .. Executable Statements ..
      K = 0
      IF( N.GE.1 )THEN
         IX = 1
         IF( TOL.LT.ZERO )THEN
            TL = WMACH(3)
         ELSE
            TL = TOL
         END IF
         XMAX = ABS( X( IX ) )
C
C+       WHILE( K.LT.N )LOOP
   10    IF   ( K.LT.N )THEN
            IF( ABS( X( IX ) ).LE.TL*XMAX )
     $         GO TO 20
            XMAX = MAX( XMAX, ABS( X( IX ) ) )
            K    = K  + 1
            IX   = IX + INCX
            GO TO 10
         END IF
C+       END WHILE
C
      END IF
C
   20 F06KLF = K
      RETURN
C
C     End of F06KLF. ( IDRANK )
C
      END
** END OF F06KLFTEXT
*UPTODATE F06FQFTEXT
      SUBROUTINE F06FQF( PIVOT, DIRECT, N, ALPHA, X, INCX, C, S )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, N
      CHARACTER*1        DIRECT, PIVOT
C     .. Array Arguments ..
      DOUBLE PRECISION   C( * ), S( * ), X( * )
C     ..
C
C  F06FQF generates the parameters of an orthogonal matrix P such that
C
C     when   PIVOT = 'F' or 'f'   and   DIRECT = 'F' or 'f'
C     or     PIVOT = 'V' or 'v'   and   DIRECT = 'B' or 'b'
C
C        P*( alpha ) = ( beta ),
C          (   x   )   (   0  )
C
C     when   PIVOT = 'F' or 'f'   and   DIRECT = 'B' or 'b'
C     or     PIVOT = 'V' or 'v'   and   DIRECT = 'F' or 'f'
C
C        P*(   x   ) = (   0  ),
C          ( alpha ) = ( beta )
C
C  where alpha is a scalar and x is an n element vector.
C
C  When  PIVOT = 'F' or 'f'  ( fixed pivot )
C  and  DIRECT = 'F' or 'f'  ( forward sequence ) then
C        
C     P is given as the sequence of plane rotation matrices
C
C        P = P( n )*P( n - 1 )*...*P( 1 )
C
C     where P( k ) is a plane rotation matrix for the ( 1, k + 1 ) plane
C     designed to annihilate the kth element of x.
C
C  When  PIVOT = 'V' or 'v'  ( variable pivot )
C  and  DIRECT = 'B' or 'b'  ( backward sequence ) then
C
C     P is given as the sequence of plane rotation matrices
C
C        P = P( 1 )*P( 2 )*...*P( n )
C
C     where P( k ) is a plane rotation matrix for the ( k, k + 1 ) plane
C     designed to annihilate the kth element of x.
C
C  When  PIVOT = 'F' or 'f'  ( fixed pivot )
C  and  DIRECT = 'B' or 'b'  ( backward sequence ) then
C
C     P is given as the sequence of plane rotation matrices
C
C        P = P( 1 )*P( 2 )*...*P( n )
C
C     where P( k ) is a plane rotation matrix for the ( k, n + 1 ) plane
C     designed to annihilate the kth element of x.
C
C  When  PIVOT = 'V' or 'v'  ( variable pivot )
C  and  DIRECT = 'F' or 'f'  ( forward sequence ) then
C
C     P is given as the sequence of plane rotation matrices
C
C        P = P( n )*P( n - 1 )*...*P( 1 )
C
C     where P( k ) is a plane rotation matrix for the ( k, k + 1 ) plane
C     designed to annihilate the kth element of x.
C
C  The routine returns the cosine, c( k ), and sine, s( k ) that define
C  the matrix P( k ), such that the two by two rotation part of P( k ),
C  R( k ), has the form
C
C     R( k ) = (  c( k )  s( k ) ).
C              ( -s( k )  c( k ) )
C
C  On entry, ALPHA must contain  the scalar alpha and on exit, ALPHA is
C  overwritten by beta. The cosines and sines are returned in the arrays
C  C and S and the vector x is overwritten by the tangents of the plane
C  rotations ( t( k ) = s( k )/c( k ) ).
C
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 19-April-1985.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      INTEGER            I, IX
C     .. External Subroutines ..
      EXTERNAL           F06BAF
C     ..
C     .. Executable Statements ..
      IF( N.GT.0 )THEN
         IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
            IX = 1 + ( N - 1 )*INCX
            IF( ( PIVOT.EQ.'V' ).OR.( PIVOT.EQ.'v' ) )THEN
               DO 10, I = N, 2, -1
                  CALL F06BAF( X( IX - INCX ), X( IX ), C( I ), S( I ) )
                  IX = IX - INCX
   10          CONTINUE
               CALL F06BAF( ALPHA, X( IX ), C( 1 ), S( 1 ) )
            ELSE IF( ( PIVOT.EQ.'F' ).OR.( PIVOT.EQ.'f' ) )THEN
C
C              Here we choose c and s so that
C
C                 ( alpha ) := (  c  s )*( alpha  )
C                 (   0   )    ( -s  c ) ( x( i ) )
C
C              which is equivalent to
C
C                 (   0   ) := ( c  -s )*( x( i ) )
C                 ( alpha )    ( s   c ) ( alpha  )
C
C              and so we need to return  s( i ) = -s  in order to make
C              R( i ) look like
C
C                 R( i ) = (  c( i )  s( i ) ).
C                          ( -s( i )  c( i ) )
C
               DO 20, I = N, 1, -1
                  CALL F06BAF( ALPHA, X( IX ), C( I ), S( I ) )
                  S( I )  = -S( I )
                  X( IX ) = -X( IX )
                  IX      =  IX      - INCX
   20          CONTINUE
            END IF
         ELSE IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
            IX = 1
            IF( ( PIVOT.EQ.'V' ).OR.( PIVOT.EQ.'v' ) )THEN
C
C              Here we choose c and s so that
C
C                 ( x( i + 1 ) ) := (  c  s )*( x( i + 1 ) )
C                 (    0       )    ( -s  c ) ( x( i )     )
C
C              which is equivalent to
C
C                 (    0       ) := ( c  -s )*( x( i )     )
C                 ( x( i + 1 ) )    ( s   c ) ( x( i + 1 ) )
C
C              and so we need to return  s( i ) = -s  in order to make
C              R( i ) look like
C
C                 R( i ) = (  c( i )  s( i ) ).
C                          ( -s( i )  c( i ) )
C
               DO 30, I = 1, N - 1
                  CALL F06BAF( X( IX + INCX ), X( IX ), C( I ), S( I ) )
                  S( I )  = -S( I )
                  X( IX ) = -X( IX )
                  IX      =  IX      + INCX
   30          CONTINUE
               CALL F06BAF( ALPHA, X( IX ), C( N ), S( N ) )
               S( N )  = -S( N )
               X( IX ) = -X( IX )
            ELSE IF( ( PIVOT.EQ.'F' ).OR.( PIVOT.EQ.'f' ) )THEN
               DO 40, I = 1, N
                  CALL F06BAF( ALPHA, X( IX ), C( I ), S( I ) )
                  IX = IX + INCX
   40          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06FQF. ( SSROTG )
C
      END
** END OF F06FQFTEXT
*UPTODATE F06FRFTEXT
      SUBROUTINE F06FRF( N, ALPHA, X, INCX, TOL, ZETA )
      ENTRY      DGRFG ( N, ALPHA, X, INCX, TOL, ZETA )
C     MARK 12 RELEASE. NAG COPYRIGHT 1986.
C     Modified by PEG 9/25/88.
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA, TOL, ZETA
      INTEGER            INCX, N
C     .. Array Arguments ..
      DOUBLE PRECISION   X( * )
C     ..
C
C  F06FRF generates details of a generalized Householder reflection such
C  that
C
C     P*( alpha ) = ( beta ),   P'*P = I.
C       (   x   )   (   0  )
C
C  P is given in the form
C
C     P = I - ( zeta )*( zeta  z' ),
C             (   z  )
C
C  where z is an n element vector and zeta is a scalar that satisfies
C
C     1.0 .le. zeta .le. sqrt( 2.0 ).
C
C  zeta is returned in ZETA unless x is such that
C
C     max( abs( x( i ) ) ) .le. max( eps*abs( alpha ), tol )
C
C  where eps is the relative machine precision and tol is the user
C  supplied value TOL, in which case ZETA is returned as 0.0 and P can
C  be taken to be the unit matrix.
C
C  beta is overwritten on alpha and z is overwritten on x.
C  the routine may be called with  n = 0  and advantage is taken of the
C  case where  n = 1.
C
C
C  Nag Fortran 77 O( n ) basic linear algebra routine.
C
C  -- Written on 30-August-1984.
C     Sven Hammarling, Nag Central Office.
C     This version dated 28-September-1984.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   BETA, EPS, SCALE, SSQ
      LOGICAL            FIRST
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
C     .. External Subroutines ..
      EXTERNAL           F06FJF, DSCAL
C     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, SIGN, SQRT
C     .. Save statement ..
      SAVE               EPS, FIRST
C     .. Data statements ..
      DATA               FIRST/ .TRUE. /
C     ..
C     .. Executable Statements ..
      IF( N.LT.1 )THEN
         ZETA = ZERO
      ELSE IF( ( N.EQ.1 ).AND.( X( 1 ).EQ.ZERO ) )THEN
         ZETA = ZERO
      ELSE
C
         IF( FIRST )THEN
            FIRST = .FALSE.
            EPS   =  WMACH(3)
         END IF
C
C        Treat case where P is a 2 by 2 matrix specially.
C
         IF( N.EQ.1 )THEN
C
C           Deal with cases where  ALPHA = zero  and
C           abs( X( 1 ) ) .le. max( EPS*abs( ALPHA ), TOL )  first.
C
            IF( ALPHA.EQ.ZERO )THEN
               ZETA   =  ONE
               ALPHA  =  ABS ( X( 1 ) )
               X( 1 ) = -SIGN( ONE, X( 1 ) )
            ELSE IF( ABS( X( 1 ) ).LE.MAX( EPS*ABS( ALPHA ), TOL ) )THEN
               ZETA   =  ZERO
            ELSE
               IF( ABS( ALPHA ).GE.ABS( X( 1 ) ) )THEN
                  BETA = ABS( ALPHA ) *SQRT( 1 + ( X( 1 )/ALPHA )**2 )
               ELSE
                  BETA = ABS( X( 1 ) )*SQRT( 1 + ( ALPHA/X( 1 ) )**2 )
               END IF
               ZETA = SQRT( ( ABS( ALPHA ) + BETA )/BETA )
               IF( ALPHA.GE.ZERO )
     $            BETA = -BETA
               X( 1 ) = -X( 1 )/( ZETA*BETA )
               ALPHA  = BETA
            END IF
         ELSE
C
C           Now P is larger than 2 by 2.
C
            SSQ   = ONE
            SCALE = ZERO
            CALL F06FJF( N, X, INCX, SCALE, SSQ )
C
C           Treat cases where  SCALE = zero,
C           SCALE .le. max( EPS*abs( ALPHA ), TOL )  and
C           ALPHA = zero  specially.
C           Note that  SCALE = max( abs( X( i ) ) ).
C
            IF( ( SCALE.EQ.ZERO ).OR.
     $          ( SCALE.LE.MAX( EPS*ABS( ALPHA ), TOL ) ) )THEN
               ZETA  = ZERO
            ELSE IF( ALPHA.EQ.ZERO )THEN
               ZETA  = ONE
               ALPHA = SCALE*SQRT( SSQ )
               CALL DSCAL( N, -1/ALPHA, X, INCX )
            ELSE
               IF( SCALE.LT.ABS( ALPHA ) )THEN
                  BETA = ABS( ALPHA )*SQRT( 1 + SSQ*( SCALE/ALPHA )**2 )
               ELSE
                  BETA = SCALE       *SQRT( SSQ +   ( ALPHA/SCALE )**2 )
               END IF
               ZETA = SQRT( ( BETA + ABS( ALPHA ) )/BETA )
               IF( ALPHA.GT.ZERO )
     $            BETA = -BETA
               CALL DSCAL( N, -1/( ZETA*BETA ), X, INCX )
               ALPHA = BETA
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06FRF. ( DGRFG )
C
      END
** END OF F06FRFTEXT
*UPTODATE F06PAFTEXT
      SUBROUTINE F06PAF( TRANS, M, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     .. Entry Points ..
      ENTRY      DGEMV ( TRANS, M, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA, BETA
      INTEGER            INCX, INCY, LDA, M, N
      CHARACTER*1        TRANS
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
C     ..
C
C  Purpose
C  =======
C
C  DGEMV  performs one of the matrix-vector operations
C
C     y := alpha*A*x + beta*y,   or   y := alpha*A'*x + beta*y,
C
C  where alpha and beta are scalars, x and y are vectors and A is an
C  m by n matrix.
C
C  Parameters
C  ==========
C
C  TRANS  - CHARACTER*1.
C           On entry, TRANS specifies the operation to be performed as
C           follows:
C
C              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.
C
C              TRANS = 'T' or 't'   y := alpha*A'*x + beta*y.
C
C              TRANS = 'C' or 'c'   y := alpha*A'*x + beta*y.
C
C           Unchanged on exit.
C
C  M      - INTEGER.
C           On entry, M specifies the number of rows of the matrix A.
C           M must be at least zero.
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the number of columns of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry, ALPHA specifies the scalar alpha.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry, the leading m by n part of the array A must
C           contain the matrix of coefficients.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, m ).
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of DIMENSION at least
C           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
C           and at least
C           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
C           Before entry, the incremented array X must contain the
C           vector x.
C           Unchanged on exit.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C  BETA   - DOUBLE PRECISION.
C           On entry, BETA specifies the scalar beta. When BETA is
C           supplied as zero then Y need not be set on input.
C           Unchanged on exit.
C
C  Y      - DOUBLE PRECISION array of DIMENSION at least
C           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
C           and at least
C           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
C           Before entry with BETA non-zero, the incremented array Y
C           must contain the vector y. On exit, Y is overwritten by the
C           updated vector y.
C
C  INCY   - INTEGER.
C           On entry, INCY specifies the increment for the elements of
C           Y. INCY must not be zero.
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, IY, J, JX, JY, KX, KY, LENX, LENY
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.(TRANS.EQ.'N' .OR. TRANS.EQ.'n').AND.
     $         .NOT.(TRANS.EQ.'T' .OR. TRANS.EQ.'t').AND.
     $         .NOT.(TRANS.EQ.'C' .OR. TRANS.EQ.'c')      )THEN
         INFO = 1
      ELSE IF( M.LT.0 )THEN
         INFO = 2
      ELSE IF( N.LT.0 )THEN
         INFO = 3
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PAF/DGEMV ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ALPHA.EQ.ZERO ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
C
C     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
C     up the start points in  X  and  Y.
C
      IF( (TRANS.EQ.'N' .OR. TRANS.EQ.'n') )THEN
         LENX = N
         LENY = M
      ELSE
         LENX = M
         LENY = N
      END IF
      IF( INCX.GT.0 )THEN
         KX = 1
      ELSE
         KX = 1 - ( LENX - 1 )*INCX
      END IF
      IF( INCY.GT.0 )THEN
         KY = 1
      ELSE
         KY = 1 - ( LENY - 1 )*INCY
      END IF
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through A.
C
C     First form  y := beta*y.
C
      IF( BETA.NE.ONE )THEN
         IF( INCY.EQ.1 )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 10, I = 1, LENY
                  Y( I ) = ZERO
   10          CONTINUE
            ELSE
               DO 20, I = 1, LENY
                  Y( I ) = BETA*Y( I )
   20          CONTINUE
            END IF
         ELSE
            IY = KY
            IF( BETA.EQ.ZERO )THEN
               DO 30, I = 1, LENY
                  Y( IY ) = ZERO
                  IY      = IY   + INCY
   30          CONTINUE
            ELSE
               DO 40, I = 1, LENY
                  Y( IY ) = BETA*Y( IY )
                  IY      = IY           + INCY
   40          CONTINUE
            END IF
         END IF
      END IF
      IF( ALPHA.EQ.ZERO )
     $   RETURN
      IF( (TRANS.EQ.'N' .OR. TRANS.EQ.'n') )THEN
C
C        Form  y := alpha*A*x + y.
C
         JX = KX
         IF( INCY.EQ.1 )THEN
            DO 60, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  DO 50, I = 1, M
                     Y( I ) = Y( I ) + TEMP*A( I, J )
   50             CONTINUE
               END IF
               JX = JX + INCX
   60       CONTINUE
         ELSE
            DO 80, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IY   = KY
                  DO 70, I = 1, M
                     Y( IY ) = Y( IY ) + TEMP*A( I, J )
                     IY      = IY      + INCY
   70             CONTINUE
               END IF
               JX = JX + INCX
   80       CONTINUE
         END IF
      ELSE
C
C        Form  y := alpha*A'*x + y.
C
         JY = KY
         IF( INCX.EQ.1 )THEN
            DO 100, J = 1, N
               TEMP = ZERO
               DO 90, I = 1, M
                  TEMP = TEMP + A( I, J )*X( I )
   90          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
  100       CONTINUE
         ELSE
            DO 120, J = 1, N
               TEMP = ZERO
               IX   = KX
               DO 110, I = 1, M
                  TEMP = TEMP + A( I, J )*X( IX )
                  IX   = IX   + INCX
  110          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP
               JY      = JY      + INCY
  120       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06PAF (DGEMV ).
C
      END
** END OF F06PAFTEXT
*UPTODATE F06PMFTEXT
      SUBROUTINE F06PMF( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     .. Entry Points ..
      ENTRY      DGER  ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, INCY, LDA, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
C     ..
C
C  Purpose
C  =======
C
C  DGER   performs the rank 1 operation
C
C     A := alpha*x*y' + A,
C
C  where alpha is a scalar, x is an m element vector, y is an n element
C  vector and A is an m by n matrix.
C
C  Parameters
C  ==========
C
C  M      - INTEGER.
C           On entry, M specifies the number of rows of the matrix A.
C           M must be at least zero.
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the number of columns of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry, ALPHA specifies the scalar alpha.
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( m - 1 )*abs( INCX ) ).
C           Before entry, the incremented array X must contain the m
C           element vector x.
C           Unchanged on exit.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C  Y      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCY ) ).
C           Before entry, the incremented array Y must contain the n
C           element vector y.
C           Unchanged on exit.
C
C  INCY   - INTEGER.
C           On entry, INCY specifies the increment for the elements of
C           Y. INCY must not be zero.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry, the leading m by n part of the array A must
C           contain the matrix of coefficients. On exit, A is
C           overwritten by the updated matrix.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, m ).
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, J, JY, KX
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( M.LT.0 )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PMF/DGER  ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through A.
C
      IF( INCY.GT.0 )THEN
         JY = 1
      ELSE
         JY = 1 - ( N - 1 )*INCY
      END IF
      IF( INCX.EQ.1 )THEN
         DO 20, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               DO 10, I = 1, M
                  A( I, J ) = A( I, J ) + X( I )*TEMP
   10          CONTINUE
            END IF
            JY = JY + INCY
   20    CONTINUE
      ELSE
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( M - 1 )*INCX
         END IF
         DO 40, J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               IX   = KX
               DO 30, I = 1, M
                  A( I, J ) = A( I, J ) + X( IX )*TEMP
                  IX        = IX        + INCX
   30          CONTINUE
            END IF
            JY = JY + INCY
   40    CONTINUE
      END IF
C
      RETURN
C
C     End of F06PMF (DGER  ).
C
      END
** END OF F06PMFTEXT
*UPTODATE F06PCFTEXT
      SUBROUTINE F06PCF( UPLO, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     .. Entry Points ..
      ENTRY      DSYMV ( UPLO, N, ALPHA, A, LDA, X, INCX,
     $                   BETA, Y, INCY )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA, BETA
      INTEGER            INCX, INCY, LDA, N
      CHARACTER*1        UPLO
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
C     ..
C
C  Purpose
C  =======
C
C  DSYMV  performs the matrix-vector  operation
C
C     y := alpha*A*x + beta*y,
C
C  where alpha and beta are scalars, x and y are n element vectors and
C  A is an n by n symmetric matrix.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the upper or lower
C           triangular part of the array A is to be referenced as
C           follows:
C
C              UPLO = 'U' or 'u'   Only the upper triangular part of A
C                                  is to be referenced.
C
C              UPLO = 'L' or 'l'   Only the lower triangular part of A
C                                  is to be referenced.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the order of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry, ALPHA specifies the scalar alpha.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry with  UPLO = 'U' or 'u', the leading n by n
C           upper triangular part of the array A must contain the upper
C           triangular part of the symmetric matrix and the strictly
C           lower triangular part of A is not referenced.
C           Before entry with UPLO = 'L' or 'l', the leading n by n
C           lower triangular part of the array A must contain the lower
C           triangular part of the symmetric matrix and the strictly
C           upper triangular part of A is not referenced.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, n ).
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCX ) ).
C           Before entry, the incremented array X must contain the n
C           element vector x.
C           Unchanged on exit.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C  BETA   - DOUBLE PRECISION.
C           On entry, BETA specifies the scalar beta. When BETA is
C           supplied as zero then Y need not be set on input.
C           Unchanged on exit.
C
C  Y      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCY ) ).
C           Before entry, the incremented array Y must contain the n
C           element vector y. On exit, Y is overwritten by the updated
C           vector y.
C
C  INCY   - INTEGER.
C           On entry, INCY specifies the increment for the elements of
C           Y. INCY must not be zero.
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP1, TEMP2
      INTEGER            I, INFO, IX, IY, J, JX, JY, KX, KY
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.(UPLO.EQ.'U' .OR. UPLO.EQ.'u').AND.
     $         .NOT.(UPLO.EQ.'L' .OR. UPLO.EQ.'l')      )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 5
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 7
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 10
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PCF/DSYMV ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( ( N.EQ.0 ).OR.( ( ALPHA.EQ.ZERO ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
C
C     Set up the start points in  X  and  Y.
C
      IF( INCX.GT.0 )THEN
         KX = 1
      ELSE
         KX = 1 - ( N - 1 )*INCX
      END IF
      IF( INCY.GT.0 )THEN
         KY = 1
      ELSE
         KY = 1 - ( N - 1 )*INCY
      END IF
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through the triangular part
C     of A.
C
C     First form  y := beta*y.
C
      IF( BETA.NE.ONE )THEN
         IF( INCY.EQ.1 )THEN
            IF( BETA.EQ.ZERO )THEN
               DO 10, I = 1, N
                  Y( I ) = ZERO
   10          CONTINUE
            ELSE
               DO 20, I = 1, N
                  Y( I ) = BETA*Y( I )
   20          CONTINUE
            END IF
         ELSE
            IY = KY
            IF( BETA.EQ.ZERO )THEN
               DO 30, I = 1, N
                  Y( IY ) = ZERO
                  IY      = IY   + INCY
   30          CONTINUE
            ELSE
               DO 40, I = 1, N
                  Y( IY ) = BETA*Y( IY )
                  IY      = IY           + INCY
   40          CONTINUE
            END IF
         END IF
      END IF
      IF( ALPHA.EQ.ZERO )
     $   RETURN
      IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
C
C        Form  y  when A is stored in upper triangle.
C
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 60, J = 1, N
               TEMP1 = ALPHA*X( J )
               TEMP2 = ZERO
               DO 50, I = 1, J - 1
                  Y( I ) = Y( I ) + TEMP1*A( I, J )
                  TEMP2  = TEMP2  + A( I, J )*X( I )
   50          CONTINUE
               Y( J ) = Y( J ) + TEMP1*A( J, J ) + ALPHA*TEMP2
   60       CONTINUE
         ELSE
            JX = KX
            JY = KY
            DO 80, J = 1, N
               TEMP1 = ALPHA*X( JX )
               TEMP2 = ZERO
               IX    = KX
               IY    = KY
               DO 70, I = 1, J - 1
                  Y( IY ) = Y( IY ) + TEMP1*A( I, J )
                  TEMP2   = TEMP2   + A( I, J )*X( IX )
                  IX      = IX      + INCX
                  IY      = IY      + INCY
   70          CONTINUE
               Y( JY ) = Y( JY ) + TEMP1*A( J, J ) + ALPHA*TEMP2
               JX      = JX      + INCX
               JY      = JY      + INCY
   80       CONTINUE
         END IF
      ELSE
C
C        Form  y  when A is stored in lower triangle.
C
         IF( ( INCX.EQ.1 ).AND.( INCY.EQ.1 ) )THEN
            DO 100, J = 1, N
               TEMP1  = ALPHA*X( J )
               TEMP2  = ZERO
               Y( J ) = Y( J )       + TEMP1*A( J, J )
               DO 90, I = J + 1, N
                  Y( I ) = Y( I ) + TEMP1*A( I, J )
                  TEMP2  = TEMP2  + A( I, J )*X( I )
   90          CONTINUE
               Y( J ) = Y( J ) + ALPHA*TEMP2
  100       CONTINUE
         ELSE
            JX = KX
            JY = KY
            DO 120, J = 1, N
               TEMP1   = ALPHA*X( JX )
               TEMP2   = ZERO
               Y( JY ) = Y( JY )       + TEMP1*A( J, J )
               IX      = JX
               IY      = JY
               DO 110, I = J + 1, N
                  IX      = IX      + INCX
                  IY      = IY      + INCY
                  Y( IY ) = Y( IY ) + TEMP1*A( I, J )
                  TEMP2   = TEMP2   + A( I, J )*X( IX )
  110          CONTINUE
               Y( JY ) = Y( JY ) + ALPHA*TEMP2
               JX      = JX      + INCX
               JY      = JY      + INCY
  120       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06PCF (DSYMV ).
C
      END
** END OF F06PCFTEXT
*UPTODATE F06PPFTEXT
      SUBROUTINE F06PPF( UPLO, N, ALPHA, X, INCX, A, LDA )
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     .. Entry Points ..
      ENTRY      DSYR  ( UPLO, N, ALPHA, X, INCX, A, LDA )
C     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, LDA, N
      CHARACTER*1        UPLO
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * )
C     ..
C
C  Purpose
C  =======
C
C  DSYR   performs the symmetric rank 1 operation
C
C     A := alpha*x*x' + A,
C
C  where alpha is a real scalar, x is an n element vector and A is an
C  n by n symmetric matrix.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the upper or lower
C           triangular part of the array A is to be referenced as
C           follows:
C
C              UPLO = 'U' or 'u'   Only the upper triangular part of A
C                                  is to be referenced.
C
C              UPLO = 'L' or 'l'   Only the lower triangular part of A
C                                  is to be referenced.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the order of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  ALPHA  - DOUBLE PRECISION.
C           On entry, ALPHA specifies the scalar alpha.
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCX ) ).
C           Before entry, the incremented array X must contain the n
C           element vector x.
C           Unchanged on exit.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry with  UPLO = 'U' or 'u', the leading n by n
C           upper triangular part of the array A must contain the upper
C           triangular part of the symmetric matrix and the strictly
C           lower triangular part of A is not referenced. On exit, the
C           upper triangular part of the array A is overwritten by the
C           upper triangular part of the updated matrix.
C           Before entry with UPLO = 'L' or 'l', the leading n by n
C           lower triangular part of the array A must contain the lower
C           triangular part of the symmetric matrix and the strictly
C           upper triangular part of A is not referenced. On exit, the
C           lower triangular part of the array A is overwritten by the
C           lower triangular part of the updated matrix.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, n ).
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, J, JX, KX
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.(UPLO.EQ.'U' .OR. UPLO.EQ.'u').AND.
     $         .NOT.(UPLO.EQ.'L' .OR. UPLO.EQ.'l')      )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 7
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PPF/DSYR  ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( ( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
C
C     Set the start point in X if the increment is not unity.
C
      IF( INCX.LE.0 )THEN
         KX = 1 - ( N - 1 )*INCX
      ELSE IF( INCX.NE.1 )THEN
         KX = 1
      END IF
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through the triangular part
C     of A.
C
      IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
C
C        Form  A  when A is stored in upper triangle.
C
         IF( INCX.EQ.1 )THEN
            DO 20, J = 1, N
               IF( X( J ).NE.ZERO )THEN
                  TEMP = ALPHA*X( J )
                  DO 10, I = 1, J
                     A( I, J ) = A( I, J ) + X( I )*TEMP
   10             CONTINUE
               END IF
   20       CONTINUE
         ELSE
            JX = KX
            DO 40, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IX   = KX
                  DO 30, I = 1, J
                     A( I, J ) = A( I, J ) + X( IX )*TEMP
                     IX        = IX        + INCX
   30             CONTINUE
               END IF
               JX = JX + INCX
   40       CONTINUE
         END IF
      ELSE
C
C        Form  A  when A is stored in lower triangle.
C
         IF( INCX.EQ.1 )THEN
            DO 60, J = 1, N
               IF( X( J ).NE.ZERO )THEN
                  TEMP = ALPHA*X( J )
                  DO 50, I = J, N
                     A( I, J ) = A( I, J ) + X( I )*TEMP
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE
            JX = KX
            DO 80, J = 1, N
               IF( X( JX ).NE.ZERO )THEN
                  TEMP = ALPHA*X( JX )
                  IX   = JX
                  DO 70, I = J, N
                     A( I, J ) = A( I, J ) + X( IX )*TEMP
                     IX        = IX        + INCX
   70             CONTINUE
               END IF
               JX = JX + INCX
   80       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06PPF (DSYR  ).
C
      END
** END OF F06PPFTEXT
*UPTODATE F06PFFTEXT
      SUBROUTINE F06PFF( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     .. Entry Points ..
      ENTRY      DTRMV ( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
C     .. Scalar Arguments ..
      INTEGER            INCX, LDA, N
      CHARACTER*1        DIAG, TRANS, UPLO
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * )
C     ..
C
C  Purpose
C  =======
C
C  DTRMV  performs one of the matrix-vector operations
C
C     x := A*x,   or   x := A'*x,
C
C  where x is n element vector and A is an n by n unit, or non-unit,
C  upper or lower triangular matrix.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the matrix is an upper or
C           lower triangular matrix as follows:
C
C              UPLO = 'U' or 'u'   A is an upper triangular matrix.
C
C              UPLO = 'L' or 'l'   A is a lower triangular matrix.
C
C           Unchanged on exit.
C
C  TRANS  - CHARACTER*1.
C           On entry, TRANS specifies the operation to be performed as
C           follows:
C
C              TRANS = 'N' or 'n'   x := A*x.
C
C              TRANS = 'T' or 't'   x := A'*x.
C
C              TRANS = 'C' or 'c'   x := A'*x.
C
C           Unchanged on exit.
C
C  DIAG   - CHARACTER*1.
C           On entry, DIAG specifies whether or not A is unit
C           triangular as follows:
C
C              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
C
C              DIAG = 'N' or 'n'   A is not assumed to be unit
C                                  triangular.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the order of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry with  UPLO = 'U' or 'u', the leading n by n
C           upper triangular part of the array A must contain the upper
C           triangular matrix and the strictly lower triangular part of
C           A is not referenced.
C           Before entry with UPLO = 'L' or 'l', the leading n by n
C           lower triangular part of the array A must contain the lower
C           triangular matrix and the strictly upper triangular part of
C           A is not referenced.
C           Note that when  DIAG = 'U' or 'u', the diagonal elements of
C           A are not referenced either, but are assumed to be unity.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, n ).
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCX ) ).
C           Before entry, the incremented array X must contain the n
C           element vector x. On exit, X is overwritten with the
C           tranformed vector x.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, J, JX, KX
      LOGICAL            NOUNIT
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.(UPLO .EQ.'U' .OR. UPLO .EQ.'u').AND.
     $         .NOT.(UPLO .EQ.'L' .OR. UPLO .EQ.'l')      )THEN
         INFO = 1
      ELSE IF( .NOT.(TRANS.EQ.'N' .OR. TRANS.EQ.'n').AND.
     $         .NOT.(TRANS.EQ.'T' .OR. TRANS.EQ.'t').AND.
     $         .NOT.(TRANS.EQ.'C' .OR. TRANS.EQ.'c')      )THEN
         INFO = 2
      ELSE IF( .NOT.(DIAG .EQ.'U' .OR. DIAG .EQ.'u').AND.
     $         .NOT.(DIAG .EQ.'N' .OR. DIAG .EQ.'n')      )THEN
         INFO = 3
      ELSE IF( N.LT.0 )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PFF/DTRMV ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( N.EQ.0 )
     $   RETURN
C
      NOUNIT = (DIAG.EQ.'N' .OR. DIAG.EQ.'n')
C
C     Set up the start point in X if the increment is not unity. This
C     will be  ( N - 1 )*INCX  too small for descending loops.
C
      IF( INCX.LE.0 )THEN
         KX = 1 - ( N - 1 )*INCX
      ELSE IF( INCX.NE.1 )THEN
         KX = 1
      END IF
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through A.
C
      IF( (TRANS.EQ.'N' .OR. TRANS.EQ.'n') )THEN
C
C        Form  x := A*x.
C
         IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
            IF( INCX.EQ.1 )THEN
               DO 20, J = 1, N
                  IF( X( J ).NE.ZERO )THEN
                     TEMP = X( J )
                     DO 10, I = 1, J - 1
                        X( I ) = X( I ) + TEMP*A( I, J )
   10                CONTINUE
                     IF( NOUNIT )
     $                  X( J ) = X( J )*A( J, J )
                  END IF
   20          CONTINUE
            ELSE
               JX = KX
               DO 40, J = 1, N
                  IF( X( JX ).NE.ZERO )THEN
                     TEMP = X( JX )
                     IX   = KX
                     DO 30, I = 1, J - 1
                        X( IX ) = X( IX ) + TEMP*A( I, J )
                        IX      = IX      + INCX
   30                CONTINUE
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )*A( J, J )
                  END IF
                  JX = JX + INCX
   40          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 60, J = N, 1, -1
                  IF( X( J ).NE.ZERO )THEN
                     TEMP = X( J )
                     DO 50, I = N, J + 1, -1
                        X( I ) = X( I ) + TEMP*A( I, J )
   50                CONTINUE
                     IF( NOUNIT )
     $                  X( J ) = X( J )*A( J, J )
                  END IF
   60          CONTINUE
            ELSE
               KX = KX + ( N - 1 )*INCX
               JX = KX
               DO 80, J = N, 1, -1
                  IF( X( JX ).NE.ZERO )THEN
                     TEMP = X( JX )
                     IX   = KX
                     DO 70, I = N, J + 1, -1
                        X( IX ) = X( IX ) + TEMP*A( I, J )
                        IX      = IX      - INCX
   70                CONTINUE
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )*A( J, J )
                  END IF
                  JX = JX - INCX
   80          CONTINUE
            END IF
         END IF
      ELSE
C
C        Form  x := A'*x.
C
         IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
            IF( INCX.EQ.1 )THEN
               DO 100, J = N, 1, -1
                  TEMP = X( J )
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 90, I = J - 1, 1, -1
                     TEMP = TEMP + A( I, J )*X( I )
   90             CONTINUE
                  X( J ) = TEMP
  100          CONTINUE
            ELSE
               JX = KX + ( N - 1 )*INCX
               DO 120, J = N, 1, -1
                  TEMP = X( JX )
                  IX   = JX
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 110, I = J - 1, 1, -1
                     IX   = IX   - INCX
                     TEMP = TEMP + A( I, J )*X( IX )
  110             CONTINUE
                  X( JX ) = TEMP
                  JX      = JX   - INCX
  120          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 140, J = 1, N
                  TEMP = X( J )
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 130, I = J + 1, N
                     TEMP = TEMP + A( I, J )*X( I )
  130             CONTINUE
                  X( J ) = TEMP
  140          CONTINUE
            ELSE
               JX = KX
               DO 160, J = 1, N
                  TEMP = X( JX )
                  IX   = JX
                  IF( NOUNIT )
     $               TEMP = TEMP*A( J, J )
                  DO 150, I = J + 1, N
                     IX   = IX   + INCX
                     TEMP = TEMP + A( I, J )*X( IX )
  150             CONTINUE
                  X( JX ) = TEMP
                  JX      = JX   + INCX
  160          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06PFF (DTRMV ).
C
      END
** END OF F06PFFTEXT
*UPTODATE F06PJFTEXT
      SUBROUTINE F06PJF( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
C     MARK 13 RE-ISSUE. NAG COPYRIGHT 1988.
C     .. Entry Points ..
      ENTRY      DTRSV ( UPLO, TRANS, DIAG, N, A, LDA, X, INCX )
C     .. Scalar Arguments ..
      INTEGER            INCX, LDA, N
      CHARACTER*1        DIAG, TRANS, UPLO
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * )
C     ..
C
C  Purpose
C  =======
C
C  DTRSV  solves one of the systems of equations
C
C     A*x = b,   or   A'*x = b,
C
C  where b and x are n element vectors and A is an n by n unit, or
C  non-unit, upper or lower triangular matrix.
C
C  No test for singularity or near-singularity is included in this
C  routine. Such tests must be performed before calling this routine.
C
C  Parameters
C  ==========
C
C  UPLO   - CHARACTER*1.
C           On entry, UPLO specifies whether the matrix is an upper or
C           lower triangular matrix as follows:
C
C              UPLO = 'U' or 'u'   A is an upper triangular matrix.
C
C              UPLO = 'L' or 'l'   A is a lower triangular matrix.
C
C           Unchanged on exit.
C
C  TRANS  - CHARACTER*1.
C           On entry, TRANS specifies the equations to be solved as
C           follows:
C
C              TRANS = 'N' or 'n'   A*x = b.
C
C              TRANS = 'T' or 't'   A'*x = b.
C
C              TRANS = 'C' or 'c'   A'*x = b.
C
C           Unchanged on exit.
C
C  DIAG   - CHARACTER*1.
C           On entry, DIAG specifies whether or not A is unit
C           triangular as follows:
C
C              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
C
C              DIAG = 'N' or 'n'   A is not assumed to be unit
C                                  triangular.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the order of the matrix A.
C           N must be at least zero.
C           Unchanged on exit.
C
C  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
C           Before entry with  UPLO = 'U' or 'u', the leading n by n
C           upper triangular part of the array A must contain the upper
C           triangular matrix and the strictly lower triangular part of
C           A is not referenced.
C           Before entry with UPLO = 'L' or 'l', the leading n by n
C           lower triangular part of the array A must contain the lower
C           triangular matrix and the strictly upper triangular part of
C           A is not referenced.
C           Note that when  DIAG = 'U' or 'u', the diagonal elements of
C           A are not referenced either, but are assumed to be unity.
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in the calling (sub) program. LDA must be at least
C           max( 1, n ).
C           Unchanged on exit.
C
C  X      - DOUBLE PRECISION array of dimension at least
C           ( 1 + ( n - 1 )*abs( INCX ) ).
C           Before entry, the incremented array X must contain the n
C           element right-hand side vector b. On exit, X is overwritten
C           with the solution vector x.
C
C  INCX   - INTEGER.
C           On entry, INCX specifies the increment for the elements of
C           X. INCX must not be zero.
C           Unchanged on exit.
C
C
C  Level 2 Blas routine.
C
C  -- Written on 22-October-1986.
C     Jack Dongarra, Argonne National Lab.
C     Jeremy Du Croz, Nag Central Office.
C     Sven Hammarling, Nag Central Office.
C     Richard Hanson, Sandia National Labs.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, J, JX, KX
      LOGICAL            NOUNIT
C     .. External Subroutines ..
      EXTERNAL           F06AAZ
C     .. Intrinsic Functions ..
      INTRINSIC          MAX
C     ..
C     .. Executable Statements ..
C
C     Test the input parameters.
C
      INFO = 0
      IF     ( .NOT.(UPLO .EQ.'U' .OR. UPLO .EQ.'u').AND.
     $         .NOT.(UPLO .EQ.'L' .OR. UPLO .EQ.'l')      )THEN
         INFO = 1
      ELSE IF( .NOT.(TRANS.EQ.'N' .OR. TRANS.EQ.'n').AND.
     $         .NOT.(TRANS.EQ.'T' .OR. TRANS.EQ.'t').AND.
     $         .NOT.(TRANS.EQ.'C' .OR. TRANS.EQ.'c')      )THEN
         INFO = 2
      ELSE IF( .NOT.(DIAG .EQ.'U' .OR. DIAG .EQ.'u').AND.
     $         .NOT.(DIAG .EQ.'N' .OR. DIAG .EQ.'n')      )THEN
         INFO = 3
      ELSE IF( N.LT.0 )THEN
         INFO = 4
      ELSE IF( LDA.LT.MAX( 1, N ) )THEN
         INFO = 6
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 8
      END IF
      IF( INFO.NE.0 )THEN
         CALL F06AAZ( 'F06PJF/DTRSV ', INFO )
         RETURN
      END IF
C
C     Quick return if possible.
C
      IF( N.EQ.0 )
     $   RETURN
C
      NOUNIT = (DIAG.EQ.'N' .OR. DIAG.EQ.'n')
C
C     Set up the start point in X if the increment is not unity. This
C     will be  ( N - 1 )*INCX  too small for descending loops.
C
      IF( INCX.LE.0 )THEN
         KX = 1 - ( N - 1 )*INCX
      ELSE IF( INCX.NE.1 )THEN
         KX = 1
      END IF
C
C     Start the operations. In this version the elements of A are
C     accessed sequentially with one pass through A.
C
      IF( (TRANS.EQ.'N' .OR. TRANS.EQ.'n') )THEN
C
C        Form  x := inv( A )*x.
C
         IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
            IF( INCX.EQ.1 )THEN
               DO 20, J = N, 1, -1
                  IF( X( J ).NE.ZERO )THEN
                     IF( NOUNIT )
     $                  X( J ) = X( J )/A( J, J )
                     TEMP = X( J )
                     DO 10, I = J - 1, 1, -1
                        X( I ) = X( I ) - TEMP*A( I, J )
   10                CONTINUE
                  END IF
   20          CONTINUE
            ELSE
               JX = KX + ( N - 1 )*INCX
               DO 40, J = N, 1, -1
                  IF( X( JX ).NE.ZERO )THEN
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )/A( J, J )
                     TEMP = X( JX )
                     IX   = JX
                     DO 30, I = J - 1, 1, -1
                        IX      = IX      - INCX
                        X( IX ) = X( IX ) - TEMP*A( I, J )
   30                CONTINUE
                  END IF
                  JX = JX - INCX
   40          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 60, J = 1, N
                  IF( X( J ).NE.ZERO )THEN
                     IF( NOUNIT )
     $                  X( J ) = X( J )/A( J, J )
                     TEMP = X( J )
                     DO 50, I = J + 1, N
                        X( I ) = X( I ) - TEMP*A( I, J )
   50                CONTINUE
                  END IF
   60          CONTINUE
            ELSE
               JX = KX
               DO 80, J = 1, N
                  IF( X( JX ).NE.ZERO )THEN
                     IF( NOUNIT )
     $                  X( JX ) = X( JX )/A( J, J )
                     TEMP = X( JX )
                     IX   = JX
                     DO 70, I = J + 1, N
                        IX      = IX      + INCX
                        X( IX ) = X( IX ) - TEMP*A( I, J )
   70                CONTINUE
                  END IF
                  JX = JX + INCX
   80          CONTINUE
            END IF
         END IF
      ELSE
C
C        Form  x := inv( A' )*x.
C
         IF( (UPLO.EQ.'U' .OR. UPLO.EQ.'u') )THEN
            IF( INCX.EQ.1 )THEN
               DO 100, J = 1, N
                  TEMP = X( J )
                  DO 90, I = 1, J - 1
                     TEMP = TEMP - A( I, J )*X( I )
   90             CONTINUE
                  IF( NOUNIT )
     $               TEMP = TEMP/A( J, J )
                  X( J ) = TEMP
  100          CONTINUE
            ELSE
               JX = KX
               DO 120, J = 1, N
                  TEMP = X( JX )
                  IX   = KX
                  DO 110, I = 1, J - 1
                     TEMP = TEMP - A( I, J )*X( IX )
                     IX   = IX   + INCX
  110             CONTINUE
                  IF( NOUNIT )
     $               TEMP = TEMP/A( J, J )
                  X( JX ) = TEMP
                  JX      = JX   + INCX
  120          CONTINUE
            END IF
         ELSE
            IF( INCX.EQ.1 )THEN
               DO 140, J = N, 1, -1
                  TEMP = X( J )
                  DO 130, I = N, J + 1, -1
                     TEMP = TEMP - A( I, J )*X( I )
  130             CONTINUE
                  IF( NOUNIT )
     $               TEMP = TEMP/A( J, J )
                  X( J ) = TEMP
  140          CONTINUE
            ELSE
               KX = KX + ( N - 1 )*INCX
               JX = KX
               DO 160, J = N, 1, -1
                  TEMP = X( JX )
                  IX   = KX
                  DO 150, I = N, J + 1, -1
                     TEMP = TEMP - A( I, J )*X( IX )
                     IX   = IX   - INCX
  150             CONTINUE
                  IF( NOUNIT )
     $               TEMP = TEMP/A( J, J )
                  X( JX ) = TEMP
                  JX      = JX   - INCX
  160          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06PJF (DTRSV ).
C
      END
** END OF F06PJFTEXT
*UPTODATE F06QFFTEXT
      SUBROUTINE F06QFF( MATRIX, M, N, A, LDA, B, LDB )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      CHARACTER*1        MATRIX
      INTEGER            M, N, LDA, LDB
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
C     ..
C
C  F06QFF  copies  the  m by n  matrix  A  into  the  m by n  matrix  B.
C
C  If   MATRIX = 'G' or 'g'   then  A  and  B  are  regarded as  general
C                             matrices,
C  if   MATRIX = 'U' or 'u'   then  A  and  B  are  regarded  as   upper
C                             triangular,  and only  elements  for which
C                             i.le.j  are referenced,
C  if   MATRIX = 'L' or 'l'   then  A  and  B  are  regarded  as   lower
C                             triangular,  and only  elements  for which
C                             i.ge.j  are referenced.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 21-November-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      INTEGER            I, J
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MATRIX.EQ.'G' ).OR.( MATRIX.EQ.'g' ) )THEN
         DO 20 J = 1, N
            DO 10 I = 1, M
               B( I, J ) = A( I, J )
   10       CONTINUE
   20    CONTINUE
      ELSE IF( ( MATRIX.EQ.'U' ).OR.( MATRIX.EQ.'u' ) )THEN
         DO 40 J = 1, N
            DO 30 I = 1, MIN( M, J )
               B( I, J ) = A( I, J )
   30       CONTINUE
   40    CONTINUE
      ELSE IF( ( MATRIX.EQ.'L' ).OR.( MATRIX.EQ.'l' ) )THEN
         DO 60 J = 1, MIN( M, N )
            DO 50 I = J, M
               B( I, J ) = A( I, J )
   50       CONTINUE
   60    CONTINUE
      END IF
C
      RETURN
C
C     End of F06QFF. ( SMCOPY )
C
      END
** END OF F06QFFTEXT
*UPTODATE F06QGFTEXT
      DOUBLE PRECISION FUNCTION F06QGF( NORM, MATRIX, M, N, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER                           LDA, M, N
      CHARACTER*1                       MATRIX, NORM
C     .. Array Arguments ..
      DOUBLE PRECISION                  A( LDA, * )
C     ..
C
C  Purpose
C  =======
C
C  F06QGF  returns the value of the one norm,  or the Frobenius norm, or
C  the element of  largest absolute value of a real matrix A.  A  may be
C  rectangular,  or square,  or triangular,  or symmetric.
C
C  Description
C  ===========
C
C  F06QGF returns the value
C
C     F06QGF = ( max( abs( a( i, j ) ) ) , NORM = 'M' or 'm'
C              (
C              ( norm1( A )  ,             NORM = '1', 'O' or 'o'
C              (
C              ( normF( A ) ,              NORM = 'F', 'f', 'E' or 'e'
C
C  where norm1 denotes the one norm of a matrix (maximum column sum) and
C  normF denotes the  Frobenius norm of a matrix  (square root of sum of
C  squares).  Note that  max( abs( a( i, j ) ) )  is not a  matrix norm.
C
C  The type of matrix for which  F06QGF is returned is determined by the
C  parameter MATRIX.
C
C  If   MATRIX = 'G' or 'g'   then  A  is regarded as  a general matrix,
C  If   MATRIX = 'U' or 'u'   then  A  is regarded as  upper triangular,
C  If   MATRIX = 'L' or 'l'   then  A  is regarded as  lower triangular,
C  If   MATRIX = 'S' or 's'   then  A  is regarded as symmetric and only
C             or 'H' or 'h'   the  upper triangular part of the array  A
C                             is referenced,
C  If   MATRIX = 'Y' or 'y'   then  A  is regarded as symmetric and only
C             or 'E' or 'e'   the  lower triangular part of the array  A
C                             is referenced.
C
C  Parameters
C  ==========
C
C  NORM  -  CHARACTER*1.
C
C           On entry,  NORM specifies the value to be returned in F06QGF
C           as described above.
C
C           Unchanged on exit.
C
C  MATRIX - CHARACTER*1.
C
C           On entry,  MATRIX  specifies the type of matrix and,  in the
C           case of a  symmetric matrix,  the part of the array in which
C           the matrix is stored as described above.
C
C           Unchanged on exit.
C
C  M      - INTEGER.
C
C           On entry,  M  specifies the number of rows of the matrix  A.
C           M  must be at least  zero and when the  matrix is  symmetric
C           then  M must be equal to  N. When  M = 0  then F06QGF is set
C           to zero and an immediate return is effected.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C           On entry, N specifies the number of columns of the matrix A.
C           N  must be at least zero. When  N = 0  then F06QGF is set to
C           zero and an immediate return is effected.
C
C           Unchanged on exit.
C
C  A      - REAL array of DIMENSION ( LDA, n ).
C
C           Before entry,  A  must contain the  m by n  matrix for which
C           F06QGF is required.
C
C           If  MATRIX = 'U' or 'u' or 'S' or 's' or 'H' or 'h' then the
C           strictly lower triangular part of A is not referenced.
C
C           If  MATRIX = 'L' or 'l' or 'Y' or 'y' or 'E' or 'e' then the
C           strictly upper triangular part of A is not referenced.
C
C           Unchanged on exit.
C
C  LDA    - INTEGER.
C           On entry, LDA specifies the first dimension of A as declared
C           in  the  calling  (sub)  program.  LDA  must be at least  M.
C
C           Unchanged on exit.
C
C  Further comments
C  ================
C
C  If A is part of a matrix B partitioned as
C
C     B = ( B1  B2 ) ,
C         ( B3  A  )
C
C  where  B1 is an l by k matrix  ( l.ge.0, k.ge.0 ),  then this routine
C  may be called with the parameter  A as  b( l + 1, k + 1 ) and  LDA as
C  the first dimension of  B  as declared in the calling  (sub) program.
C
C  This routine  can be inefficient on  paged machines when the one norm
C  is required, the matrix is symmetric and N is large.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 13-January-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION                  ONE, ZERO
      PARAMETER                         ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION                  SCALE, SUM, VALUE
      INTEGER                           I, J
C     .. External Functions ..
      DOUBLE PRECISION                  F06BMF
      EXTERNAL                          F06BMF
C     .. External Subroutines ..
      EXTERNAL                          F06FJF
C     .. Intrinsic Functions ..
      INTRINSIC                         ABS, MAX, MIN
C     ..
C     .. Executable Statements ..
      IF( MIN( M, N ).EQ.0 )THEN
         VALUE = ZERO
      ELSE IF( ( NORM.EQ.'M' ).OR.( NORM.EQ.'m' ) )THEN
C
C        Find  max( abs( a( i, j ) ) ).
C
         VALUE = ZERO
         IF( ( MATRIX.EQ.'G' ).OR.( MATRIX.EQ.'g' ) )THEN
            DO 20 J = 1, N
               DO 10 I = 1, M
                  VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   10          CONTINUE
   20       CONTINUE
         ELSE IF( ( MATRIX.EQ.'U' ).OR.( MATRIX.EQ.'u' ).OR.
     $            ( MATRIX.EQ.'S' ).OR.( MATRIX.EQ.'s' ).OR.
     $            ( MATRIX.EQ.'H' ).OR.( MATRIX.EQ.'h' ) )THEN
            DO 40 J = 1, N
               DO 30 I = 1, MIN( M, J )
                  VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   30          CONTINUE
   40       CONTINUE
         ELSE IF( ( MATRIX.EQ.'L' ).OR.( MATRIX.EQ.'l' ).OR.
     $            ( MATRIX.EQ.'Y' ).OR.( MATRIX.EQ.'y' ).OR.
     $            ( MATRIX.EQ.'E' ).OR.( MATRIX.EQ.'e' ) )THEN
            DO 60 J = 1, MIN( M, N )
               DO 50 I = J, M
                  VALUE = MAX( VALUE, ABS( A( I, J ) ) )
   50          CONTINUE
   60       CONTINUE
         END IF
      ELSE IF( ( NORM.EQ.'1' ).OR.( NORM.EQ.'O' ).OR.
     $         ( NORM.EQ.'o' ) )THEN
C
C        Find  norm1( A ).
C
         VALUE = ZERO
         IF( ( MATRIX.EQ.'G' ).OR.( MATRIX.EQ.'g' ) )THEN
            DO 80 J = 1, N
               SUM = ZERO
               DO 70 I = 1, M
                  SUM = SUM + ABS( A( I, J ) )
   70          CONTINUE
               VALUE = MAX( VALUE, SUM )
   80       CONTINUE
         ELSE IF( ( MATRIX.EQ.'U' ).OR.( MATRIX.EQ.'u' ) )THEN
            DO 100 J = 1, N
               SUM = ZERO
               DO 90 I = 1, MIN( M, J )
                  SUM = SUM + ABS( A( I, J ) )
   90          CONTINUE
               VALUE = MAX( VALUE, SUM )
  100       CONTINUE
         ELSE IF( ( MATRIX.EQ.'L' ).OR.( MATRIX.EQ.'l' ) )THEN
            DO 120 J = 1, MIN( M, N )
               SUM = ZERO
               DO 110 I = J, M
                  SUM = SUM + ABS( A( I, J ) )
  110          CONTINUE
               VALUE = MAX( VALUE, SUM )
  120       CONTINUE
         ELSE IF( ( MATRIX.EQ.'S' ).OR.( MATRIX.EQ.'s' ).OR.
     $            ( MATRIX.EQ.'H' ).OR.( MATRIX.EQ.'h' ) )THEN
            DO 150 J = 1, N
               SUM = ZERO
               DO 130 I = 1, J
                  SUM = SUM + ABS( A( I, J ) )
  130          CONTINUE
               DO 140 I = J + 1, N
                  SUM = SUM + ABS( A( J, I ) )
  140          CONTINUE
               VALUE = MAX( VALUE, SUM )
  150       CONTINUE
         ELSE IF( ( MATRIX.EQ.'Y' ).OR.( MATRIX.EQ.'y' ).OR.
     $            ( MATRIX.EQ.'E' ).OR.( MATRIX.EQ.'e' ) )THEN
            DO 180 J = 1, N
               SUM = ZERO
               DO 160 I = 1, J - 1
                  SUM = SUM + ABS( A( J, I ) )
  160          CONTINUE
               DO 170 I = J, N
                  SUM = SUM + ABS( A( I, J ) )
  170          CONTINUE
               VALUE = MAX( VALUE, SUM )
  180       CONTINUE
         END IF
      ELSE IF( ( NORM.EQ.'F' ).OR.( NORM.EQ.'f' ).OR.( NORM.EQ.'E' ).OR.
     $         ( NORM.EQ.'e' ) )THEN
C
C        Find  normF( A ).
C
         SCALE = ZERO
         SUM = ONE
         IF( ( MATRIX.EQ.'G' ).OR.( MATRIX.EQ.'g' ) )THEN
            DO 190 J = 1, N
               CALL F06FJF( M, A( 1, J ), 1, SCALE, SUM )
  190       CONTINUE
         ELSE IF( ( MATRIX.EQ.'U' ).OR.( MATRIX.EQ.'u' ) )THEN
            DO 200 J = 1, N
               CALL F06FJF( MIN( M, J ), A( 1, J ), 1, SCALE, SUM )
  200       CONTINUE
         ELSE IF( ( MATRIX.EQ.'L' ).OR.( MATRIX.EQ.'l' ) )THEN
            DO 210 J = 1, MIN( M, N )
               CALL F06FJF( M - J + 1, A( J, J ), 1, SCALE, SUM )
  210       CONTINUE
         ELSE IF( ( MATRIX.EQ.'S' ).OR.( MATRIX.EQ.'s' ).OR.
     $            ( MATRIX.EQ.'H' ).OR.( MATRIX.EQ.'h' ).OR.
     $            ( MATRIX.EQ.'Y' ).OR.( MATRIX.EQ.'y' ).OR.
     $            ( MATRIX.EQ.'E' ).OR.( MATRIX.EQ.'e' ) )THEN
            IF( ( MATRIX.EQ.'S' ).OR.( MATRIX.EQ.'s' ).OR.
     $          ( MATRIX.EQ.'H' ).OR.( MATRIX.EQ.'h' ) )THEN
               DO 220 J = 2, N
                  CALL F06FJF( J - 1, A( 1, J ), 1, SCALE, SUM )
  220          CONTINUE
            ELSE
               DO 230 J = 1, N - 1
                  CALL F06FJF( N - J, A( J + 1, J ), 1, SCALE, SUM )
  230          CONTINUE
            END IF
            SUM = 2*SUM
            CALL F06FJF( N, A( 1, 1 ), LDA + 1, SCALE, SUM )
         END IF
         VALUE = F06BMF( SCALE, SUM )
      END IF
C
      F06QGF = VALUE
      RETURN
C
C     End of F06QGF. ( SMNRM )
C
      END
** END OF F06QGFTEXT
*UPTODATE F06QHFTEXT
      SUBROUTINE F06QHF( MATRIX, M, N, CONST, DIAG, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      CHARACTER*1        MATRIX
      DOUBLE PRECISION   CONST, DIAG
      INTEGER            LDA, M, N
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * )
C     ..
C
C  F06QHF forms the m by n matrix A given by
C
C     a( i, j ) = (  diag  i.eq.j,
C                 (
C                 ( const  i.ne.j.
C
C  If   MATRIX = 'G' or 'g'   then  A  is regarded  as a general matrix,
C  if   MATRIX = 'U' or 'u'   then  A  is regarded  as upper triangular,
C                             and only  elements  for which  i.le.j  are
C                             referenced,
C  if   MATRIX = 'L' or 'l'   then  A  is regarded  as lower triangular,
C                             and only  elements  for which  i.ge.j  are
C                             referenced.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 21-November-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      INTEGER            I, J
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MATRIX.EQ.'G' ).OR.( MATRIX.EQ.'g' ) )THEN
         DO 20 J = 1, N
            DO 10 I = 1, M
               A( I, J ) = CONST
   10       CONTINUE
   20    CONTINUE
         IF( CONST.NE.DIAG )THEN
            DO 30 I = 1, MIN( M, N )
               A( I, I ) = DIAG
   30       CONTINUE
         END IF
      ELSE IF( ( MATRIX.EQ.'U' ).OR.( MATRIX.EQ.'u' ) )THEN
         DO 50 J = 1, N
            DO 40 I = 1, MIN( M, J )
               A( I, J ) = CONST
   40       CONTINUE
   50    CONTINUE
         IF( CONST.NE.DIAG )THEN
            DO 60 I = 1, MIN( M, N )
               A( I, I ) = DIAG
   60       CONTINUE
         END IF
      ELSE IF( ( MATRIX.EQ.'L' ).OR.( MATRIX.EQ.'l' ) )THEN
         DO 80 J = 1, MIN( M, N )
            DO 70 I = J, M
               A( I, J ) = CONST
   70       CONTINUE
   80    CONTINUE
         IF( CONST.NE.DIAG )THEN
            DO 90 I = 1, MIN( M, N )
               A( I, I ) = DIAG
   90       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06QHF. ( SMLOAD )
C
      END
** END OF F06QHFTEXT
*UPTODATE F06QJFTEXT
      SUBROUTINE F06QJF( SIDE, TRANS, N, PERM, K, B, LDB )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K, LDB, N
      CHARACTER*1        SIDE, TRANS
C     .. Array Arguments ..
      DOUBLE PRECISION   B( LDB, * )
      INTEGER            PERM( * )
C     ..
C
C  Purpose
C  =======
C
C  F06QJF performs one of the transformations
C
C     B := P'*B   or   B := P*B,   where B is an m by k matrix,
C
C  or
C
C     B := B*P'   or   B := B*P,   where B is a k by m matrix,
C
C  P being an m by m permutation matrix of the form
C
C     P = P( 1, index( 1 ) )*P( 2, index( 2 ) )*...*P( n, index( n ) ),
C
C  where  P( i, index( i ) ) is the permutation matrix that interchanges
C  items i and index( i ). That is P( i, index( i ) ) is the unit matrix
C  with rows and columns  i and index( i )  interchanged.  Of course, if
C  index( i ) = i  then  P( i, index( i ) ) = I.
C
C  This routine  is intended for use in  conjunction with  Nag auxiliary
C  routines that  perform  interchange  operations,  such  as  pivoting.
C
C  Parameters
C  ==========
C
C  SIDE   - CHARACTER*1.
C  TRANS
C           On entry,  SIDE  ( Left-hand side, or Right-hand side )  and
C           TRANS  ( Transpose, or No transpose )  specify the operation
C           to be performed as follows.
C
C           SIDE = 'L' or 'l'   and   TRANS = 'T' or 't'
C
C              Perform the operation   B := P'*B.
C
C           SIDE = 'L' or 'l'   and   TRANS = 'N' or 'n'
C
C              Perform the operation   B := P*B.
C
C           SIDE = 'R' or 'r'   and   TRANS = 'T' or 't'
C
C              Perform the operation   B := B*P'.
C
C           SIDE = 'R' or 'r'   and   TRANS = 'N' or 'n'
C
C              Perform the operation   B := B*P.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C
C           On entry,  N must specify the value of n. N must be at least
C           zero.  When  N = 0  then an  immediate  return is  effected.
C
C           Unchanged on exit.
C
C  PERM   - INTEGER array of DIMENSION at least ( n ).
C
C           Before  entry,  PERM  must  contain the  n  indices  for the
C           permutation matrices. index( i ) must satisfy
C
C              1 .le. index( i ) .le. m.
C
C           It is usual for index( i ) to be at least i, but this is not
C           necessary for this routine.
C
C           Unchanged on exit.
C
C  K      - INTEGER.
C
C           On entry with  SIDE = 'L' or 'l',  K must specify the number
C           of columns of B and on entry with  SIDE = 'R' or 'r', K must
C           specify the  number of rows of B.  K must be at least  zero.
C           When  K = 0  then an immediate return is effected.
C
C           Unchanged on exit.
C
C  B      - REAL  array of  DIMENSION  ( LDB, ncolb ),  where  ncolb = k
C           when  SIDE = 'L' or 'l'  and  ncolb = m  when  SIDE = 'R' or
C           'r'.
C
C           Before entry  with  SIDE = 'L' or 'l',  the  leading  m by K
C           part  of  the  array   B  must  contain  the  matrix  to  be
C           transformed  and  before entry with  SIDE = 'R' or 'r',  the
C           leading  K by m part of the array  B must contain the matrix
C           to  be  transformed.  On  exit,  B  is  overwritten  by  the
C           transformed matrix.
C
C  LDB    - INTEGER.
C
C           On entry,  LDB  must specify  the  leading dimension  of the
C           array  B  as declared  in the  calling  (sub) program.  When
C           SIDE = 'L' or 'l'   then  LDB  must  be  at  least  m,  when
C           SIDE = 'R' or 'r'   then  LDB  must  be  at  least  k.
C           Unchanged on exit.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 13-January-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, J, L
      LOGICAL            LEFT, NULL, RIGHT, TRNSP
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( MIN( N, K ).EQ.0 )
     $   RETURN
      LEFT = ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' )
      RIGHT = ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' )
      NULL = ( TRANS.EQ.'N' ).OR.( TRANS.EQ.'n' )
      TRNSP = ( TRANS.EQ.'T' ).OR.( TRANS.EQ.'t' )
      IF( LEFT )THEN
         IF( TRNSP )THEN
            DO 20 I = 1, N
               IF( PERM( I ).NE.I )THEN
                  L = PERM( I )
                  DO 10 J = 1, K
                     TEMP = B( I, J )
                     B( I, J ) = B( L, J )
                     B( L, J ) = TEMP
   10             CONTINUE
               END IF
   20       CONTINUE
         ELSE IF( NULL )THEN
            DO 40 I = N, 1, -1
               IF( PERM( I ).NE.I )THEN
                  L = PERM( I )
                  DO 30 J = 1, K
                     TEMP = B( L, J )
                     B( L, J ) = B( I, J )
                     B( I, J ) = TEMP
   30             CONTINUE
               END IF
   40       CONTINUE
         END IF
      ELSE IF( RIGHT )THEN
         IF( TRNSP )THEN
            DO 60 J = N, 1, -1
               IF( PERM( J ).NE.J )THEN
                  L = PERM( J )
                  DO 50 I = 1, K
                     TEMP = B( I, J )
                     B( I, J ) = B( I, L )
                     B( I, L ) = TEMP
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE IF( NULL )THEN
            DO 80 J = 1, N
               IF( PERM( J ).NE.J )THEN
                  L = PERM( J )
                  DO 70 I = 1, K
                     TEMP = B( I, L )
                     B( I, L ) = B( I, J )
                     B( I, J ) = TEMP
   70             CONTINUE
               END IF
   80       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06QJF. ( SGEAP )
C
      END
** END OF F06QJFTEXT
*UPTODATE F06QKFTEXT
      SUBROUTINE F06QKF( SIDE, TRANS, N, PERM, K, B, LDB )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K, LDB, N
      CHARACTER*1        SIDE, TRANS
C     .. Array Arguments ..
      DOUBLE PRECISION   PERM( * ), B( LDB, * )
C     ..
C
C  Purpose
C  =======
C
C  F06QKF performs one of the transformations
C
C     B := P'*B   or   B := P*B,   where B is an m by k matrix,
C
C  or
C
C     B := B*P'   or   B := B*P,   where B is a k by m matrix,
C
C  P being an m by m permutation matrix of the form
C
C     P = P( 1, index( 1 ) )*P( 2, index( 2 ) )*...*P( n, index( n ) ),
C
C  where  P( i, index( i ) ) is the permutation matrix that interchanges
C  items i and index( i ). That is P( i, index( i ) ) is the unit matrix
C  with rows and columns  i and  index( i )  interchanged. Of course, if
C  index( i ) = i  then  P( i, index( i ) ) = I.
C
C  This  routine is intended  for use in conjunction with  Nag auxiliary
C  routines  that  perform  interchange  operations,  such  as  sorting.
C
C  Parameters
C  ==========
C
C  SIDE   - CHARACTER*1.
C  TRANS
C           On entry,  SIDE  ( Left-hand side, or Right-hand side )  and
C           TRANS  ( Transpose, or No transpose )  specify the operation
C           to be performed as follows.
C
C           SIDE = 'L' or 'l'   and   TRANS = 'T' or 't'
C
C              Perform the operation   B := P'*B.
C
C           SIDE = 'L' or 'l'   and   TRANS = 'N' or 'n'
C
C              Perform the operation   B := P*B.
C
C           SIDE = 'R' or 'r'   and   TRANS = 'T' or 't'
C
C              Perform the operation   B := B*P'.
C
C           SIDE = 'R' or 'r'   and   TRANS = 'N' or 'n'
C
C              Perform the operation   B := B*P.
C
C           Unchanged on exit.
C
C  N      - INTEGER.
C
C           On entry, N must specify the value of n.  N must be at least
C           zero.  When  N = 0  then an  immediate  return  is effected.
C
C           Unchanged on exit.
C
C  PERM   - REAL             array of DIMENSION at least ( n ).
C
C           Before  entry,  PERM  must  contain  the  n indices  for the
C           permutation matrices. index( i ) must satisfy
C
C              1 .le. index( i ) .le. m.
C
C           It is usual for index( i ) to be at least i, but this is not
C           necessary for this routine. It is assumed that the statement
C           INDEX = PERM( I )  returns the correct integer in  INDEX, so
C           that,  if necessary,  PERM( I )  should contain a real value
C           slightly larger than  INDEX.
C
C           Unchanged on exit.
C
C  K      - INTEGER.
C
C           On entry with  SIDE = 'L' or 'l',  K must specify the number
C           of columns of B and on entry with  SIDE = 'R' or 'r', K must
C           specify the number of rows of  B.  K must be at least  zero.
C           When  K = 0  then an immediate return is effected.
C
C           Unchanged on exit.
C
C  B      - REAL  array  of  DIMENSION ( LDB, ncolb ),  where  ncolb = k
C           when  SIDE = 'L' or 'l'  and  ncolb = m  when  SIDE = 'R' or
C           'r'.
C
C           Before entry  with  SIDE = 'L' or 'l',  the  leading  m by K
C           part  of  the  array   B  must  contain  the  matrix  to  be
C           transformed  and before  entry with  SIDE = 'R' or 'r',  the
C           leading  K by m part of the array  B must contain the matrix
C           to  be  transformed.  On exit,   B  is  overwritten  by  the
C           transformed matrix.
C
C  LDB    - INTEGER.
C
C           On entry,  LDB  must specify  the  leading dimension  of the
C           array  B  as declared  in the  calling  (sub) program.  When
C           SIDE = 'L' or 'l'   then  LDB  must  be  at  least  m,  when
C           SIDE = 'R' or 'r'   then  LDB  must  be  at  least  k.
C           Unchanged on exit.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 11-August-1987.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Local Scalars ..
      LOGICAL            LEFT, NULL, RIGHT, TRNSP
      INTEGER            I, J, L
      DOUBLE PRECISION   TEMP
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( MIN( N, K ).EQ.0 )
     $   RETURN
      LEFT = ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' )
      RIGHT = ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' )
      NULL = ( TRANS.EQ.'N' ).OR.( TRANS.EQ.'n' )
      TRNSP = ( TRANS.EQ.'T' ).OR.( TRANS.EQ.'t' )
      IF( LEFT )THEN
         IF( TRNSP )THEN
            DO 20 I = 1, N
               L = PERM( I )
               IF( L.NE.I )THEN
                  DO 10 J = 1, K
                     TEMP = B( I, J )
                     B( I, J ) = B( L, J )
                     B( L, J ) = TEMP
   10             CONTINUE
               END IF
   20       CONTINUE
         ELSE IF( NULL )THEN
            DO 40 I = N, 1, -1
               L = PERM( I )
               IF( L.NE.I )THEN
                  DO 30 J = 1, K
                     TEMP = B( L, J )
                     B( L, J ) = B( I, J )
                     B( I, J ) = TEMP
   30             CONTINUE
               END IF
   40       CONTINUE
         END IF
      ELSE IF( RIGHT )THEN
         IF( TRNSP )THEN
            DO 60 J = N, 1, -1
               L = PERM( J )
               IF( L.NE.J )THEN
                  DO 50 I = 1, K
                     TEMP = B( I, J )
                     B( I, J ) = B( I, L )
                     B( I, L ) = TEMP
   50             CONTINUE
               END IF
   60       CONTINUE
         ELSE IF( NULL )THEN
            DO 80 J = 1, N
               L = PERM( J )
               IF( L.NE.J )THEN
                  DO 70 I = 1, K
                     TEMP = B( I, L )
                     B( I, L ) = B( I, J )
                     B( I, J ) = TEMP
   70             CONTINUE
               END IF
   80       CONTINUE
         END IF
      END IF
C
      RETURN
C
C     End of F06QKF. ( SGEAPR )
C
      END
** END OF F06QKFTEXT
*UPTODATE F06QNFTEXT
      SUBROUTINE F06QNF( SIDE, N, K1, K2, S, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, N
      CHARACTER*1        SIDE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), S( * )
C     ..
C
C  F06QNF applies a  sequence  of  pairwise interchanges to either  the
C  left,  or the right,  of the  n by n  upper triangular matrix  U,  to
C  transform U to an  upper Hessenberg matrix. The interchanges are
C  applied in planes k1 up to k2.
C
C  The upper Hessenberg matrix, H, is formed as
C
C     H = P*U,    when   SIDE = 'L' or 'l',  (  Left-hand side )
C
C  where P is a permutation matrix of the form
C
C     P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 )
C
C  and is formed as
C
C     H = U*P',   when   SIDE = 'R' or 'r',  ( Right-hand side )
C
C  where P is a permutation matrix of the form
C
C     P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C  P( k ) being a pairwise interchange for the  ( k, k + 1 ) plane.
C  The  two by two
C  interchange part of P( k ), R( k ), is assumed to have the form
C
C     R( k ) = ( 0  1 ).
C              ( 1  0 )
C
C  The matrix  U must be supplied in the n by n leading upper triangular
C  part of the array  A, and this is overwritten by the upper triangular
C  part of  H.
C
C  The  sub-diagonal elements of  H, h( k + 1, k ),  are returned in the
C  elements s( k ),  k = k1, k1 + 1, ..., k2 - 1.
C
C  If n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
C  greater than n then an immediate return is effected.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 16-May-1988.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   AIJ, TEMP
      INTEGER            I, J
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MIN( N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $   ( K2.GT.N ) )RETURN
      IF( ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' ) )THEN
C
C        Apply the permutations to columns n back to k1.
C
         DO 20 J = N, K1, -1
            IF( J.GE.K2 )THEN
               AIJ = A( K2, J )
            ELSE
C
C              Form  the  additional sub-diagonal element  h( j + 1, j )
C              and store it in s( j ).
C
               AIJ    = ZERO
               S( J ) = A( J, J )
            END IF
            DO 10 I = MIN( K2, J ) - 1, K1, -1
               TEMP          = A( I, J )
               A( I + 1, J ) = TEMP
               AIJ           = AIJ
   10       CONTINUE
            A( K1, J ) = AIJ
   20    CONTINUE
      ELSE IF( ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' ) )THEN
C
C        Apply  the  plane interchanges to  columns  k1  up to
C        ( k2 - 1 ) and  form   the   additional  sub-diagonal
C        elements,   storing  h( j + 1, j ) in s( j ).
C
         DO 40 J = K1, K2 - 1
            DO 30 I = 1, J
               TEMP = A( I, J + 1 )
               A( I, J + 1 ) = A( I, J )
               A( I, J )     = TEMP
   30       CONTINUE
            S( J )            = A( J + 1, J + 1 )
            A( J + 1, J + 1 ) = ZERO
   40    CONTINUE
      END IF
C
      RETURN
C
C     End of F06QNF. ( SUTSRH )
C
      END
** END OF F06QNFTEXT
*UPTODATE F06QRFTEXT
      SUBROUTINE F06QRF( SIDE, N, K1, K2, C, S, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, N
      CHARACTER*1        SIDE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )
C     ..
C
C  F06QRF restores an upper Hessenberg matrix H to upper triangular form
C  by  applying a sequence of  plane rotations  from either the left, or
C  the right.  The matrix  H  is assumed to have  non-zero  sub-diagonal
C  elements  in  positions  h( k + 1, k ),  k = k1, k1 + 1, ..., k2 - 1,
C  only  and  h( k + 1, k )  must  be  supplied  in  s( k ).
C
C  H is restored to the upper triangular matrix R either as
C
C     R = P*H,   when   SIDE = 'L' or 'l'  (  Left-hand side )
C
C  where P is an orthogonal matrix of the form
C
C     P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C  or as
C
C     R = H*P',  when   SIDE = 'R' or 'r'  ( Right-hand side )
C
C  where P is an orthogonal matrix of the form
C
C     P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C  in both cases  P( k )  being a  plane rotation  for the  ( k, k + 1 )
C  plane.  The cosine and sine that define P( k ) are returned in c( k )
C  and  s( k )  respectively.  The two by two  rotation part of  P( k ),
C  Q( k ), is of the form
C
C     Q( k ) = (  c( k )  s( k ) ).
C              ( -s( k )  c( k ) )
C
C  The upper triangular part of the matrix  H  must be supplied in the n
C  by n  leading upper triangular part of  A, and this is overwritten by
C  the upper triangular matrix R.
C
C  If n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
C  greater than n then an immediate return is effected.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 13-January-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   AIJ, CTEMP, STEMP, SUBH, TEMP
      INTEGER            I, J
C     .. External Subroutines ..
      EXTERNAL           F06BAF
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MIN( N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $   ( K2.GT.N ) )RETURN
      IF( ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' ) )THEN
C
C        Restore   H  to  upper  triangular  form  by  annihilating  the
C        sub-diagonal elements of H.  The jth rotation is chosen so that
C
C           ( h( j, j ) ) := (  c  s )*( h( j, j )     ).
C           (     0     )    ( -s  c ) ( h( j + 1, j ) )
C
C        Apply the rotations in columns k1 up to n.
C
         DO 20 J = K1, N
            AIJ = A( K1, J )
            DO 10 I = K1, MIN( J, K2 ) - 1
               TEMP = A( I + 1, J )
               A( I, J ) = S( I )*TEMP + C( I )*AIJ
               AIJ = C( I )*TEMP - S( I )*AIJ
   10       CONTINUE
            IF( J.LT.K2 )THEN
C
C              Set up the rotation.
C
               SUBH = S( J )
               CALL F06BAF( AIJ, SUBH, C( J ), S( J ) )
               A( J, J ) = AIJ
            ELSE
               A( K2, J ) = AIJ
            END IF
   20    CONTINUE
      ELSE IF( ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' ) )THEN
C
C        Restore   H  to  upper  triangular  form  by  annihilating  the
C        sub-diagonal elements of H.  The jth rotation is chosen so that
C
C           ( h( j + 1, j + 1 ) ) := (  c  s )*( h( j + 1, j + 1 ) ),
C           (         0         )    ( -s  c ) ( h( j + 1, j )     )
C
C        which can be expressed as
C
C           ( 0  h( j + 1, j + 1 ) ) :=
C
C               ( h( j + 1, j )  h( j + 1, j + 1 ) )*(  c  s ).
C                                                    ( -s  c )
C
C        Thus we return  c( j ) = c  and  s( j ) = -s  to make the plane
C        rotation matrix look like
C
C           Q( j ) = (  c( j )  s( j ) ).
C                    ( -s( j )  c( j ) )
C
         DO 40 J = K2 - 1, K1, -1
            SUBH = S( J )
            CALL F06BAF( A( J + 1, J + 1 ), SUBH, CTEMP, STEMP )
            STEMP = -STEMP
            S( J ) = STEMP
            C( J ) = CTEMP
            IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
               DO 30 I = J, 1, -1
                  TEMP = A( I, J + 1 )
                  A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                  A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
   30          CONTINUE
            END IF
   40    CONTINUE
      END IF
C
      RETURN
C
C     End of F06QRF. ( SUHQR )
C
      END
** END OF F06QRFTEXT
*UPTODATE F06QSFTEXT
      SUBROUTINE F06QSF( SIDE, N, K1, K2, C, S, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, N
      CHARACTER*1        SIDE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )
C     ..
C
C  F06QSF restores an upper spiked matrix  H to upper triangular form by
C  applying a sequence of plane rotations, in planes  k1 up to k2,  from
C  either the left, or the right.
C
C  The matrix  H is assumed to have non-zero elements only in the spiked
C  positions, h( k2, k ) for a row spike and h( k + 1, k1 ) for a column
C  spike, k = k1, k1 + 1, ..., k2 - 1, and these must be supplied in the
C  elements s( k ).
C
C  When  SIDE = 'L' or 'l'  (  Left-hand side )
C
C     H  is  assumed  to have a  row spike  and is restored to the upper
C     triangular matrix  R as
C
C        R = P*H,
C
C     where P is an orthogonal matrix of the form
C
C        P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C     P( k )  being a  plane rotation  matrix for the  ( k, k2 )  plane.
C
C  When  SIDE = 'R' or 'r'  ( Right-hand side )
C
C     H  is assumed to have a  column spike and is restored to the upper
C     triangular matrix R as
C
C        R = H*P',
C
C     where P is an orthogonal matrix of the form
C
C        P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C     P( k ) being a plane rotation matrix for the  ( k1, k + 1 ) plane.
C
C  The  two by two  rotation  part of  P( k ),  Q( k ),  is of  the form
C
C     Q( k ) = (  c( k )  s( k ) )
C              ( -s( k )  c( k ) )
C
C  and  c( k ) and s( k ) are returned in the kth elements of the arrays
C  C and S respectively.
C
C  The upper triangular part of the matrix  H must be supplied in the  n
C  by n  leading upper triangular part of  A, and this is overwritten by
C  the upper triangular matrix R.
C
C  If n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
C  greater than n then an immediate return is effected.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 13-January-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   AIJ, CTEMP, SPIKE, STEMP, TEMP
      INTEGER            I, J
C     .. External Subroutines ..
      EXTERNAL           F06BAF
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MIN( N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $   ( K2.GT.N ) )RETURN
      IF( ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' ) )THEN
C
C        Restore H to upper triangular form by annihilating the elements
C        in  the  spike  of  H.  The  jth rotation  is  chosen  so  that
C
C        ( h( j, j ) ) := (  c  s )*( h( j , j ) ).
C        (     0     )    ( -s  c ) ( h( k2, j ) )
C
C        Apply the rotations in columns k1 up to ( k2 - 1 ).
C
         DO 20 J = K1, K2 - 1
            SPIKE = S( J )
            DO 10 I = K1, J - 1
               AIJ = A( I, J )
               A( I, J ) = S( I )*SPIKE + C( I )*AIJ
               SPIKE = C( I )*SPIKE - S( I )*AIJ
   10       CONTINUE
C
C           Set up the rotation.
C
            CALL F06BAF( A( J, J ), SPIKE, C( J ), S( J ) )
   20    CONTINUE
C
C        Apply the rotations to columns k2 up to n.
C
         DO 40 J = K2, N
            TEMP = A( K2, J )
            DO 30 I = K1, K2 - 1
               AIJ = A( I, J )
               A( I, J ) = S( I )*TEMP + C( I )*AIJ
               TEMP = C( I )*TEMP - S( I )*AIJ
   30       CONTINUE
            A( K2, J ) = TEMP
   40    CONTINUE
      ELSE IF( ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' ) )THEN
C
C        Restore H to upper triangular form by annihilating the spike of
C        H. The jth rotation is chosen so that
C
C           ( h( j, j ) ) := (  c  s )*( h( j, j )  ),
C           (     0     )    ( -s  c ) ( h( j, k1 ) )
C
C        which can be expressed as
C
C           ( 0  h( j, j ) ) := ( h( j, k1 )  h( j, j ) )*(  c  s ).
C                                                         ( -s  c )
C
C        Thus we return  c( j ) = c  and  s( j ) = -s  to make the plane
C        rotation matrix look like
C
C           Q( j ) = (  c( j )  s( j ) ).
C                    ( -s( j )  c( j ) )
C
         DO 70 J = K2, K1 + 1, -1
            CALL F06BAF( A( J, J ), S( J - 1 ), CTEMP, STEMP )
            STEMP = -STEMP
            S( J - 1 ) = STEMP
            C( J - 1 ) = CTEMP
            IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
               DO 50 I = J - 1, K1 + 1, -1
                  SPIKE = S( I - 1 )
                  S( I - 1 ) = STEMP*A( I, J ) + CTEMP*SPIKE
                  A( I, J ) = CTEMP*A( I, J ) - STEMP*SPIKE
   50          CONTINUE
               DO 60 I = K1, 1, -1
                  TEMP = A( I, K1 )
                  A( I, K1 ) = STEMP*A( I, J ) + CTEMP*TEMP
                  A( I, J ) = CTEMP*A( I, J ) - STEMP*TEMP
   60          CONTINUE
            END IF
   70    CONTINUE
      END IF
C
      RETURN
C
C     End of F06QSF. ( SUSQR )
C
      END
** END OF F06QSFTEXT
*UPTODATE F06QTFTEXT
      SUBROUTINE F06QTF( SIDE, N, K1, K2, C, S, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, N
      CHARACTER*1        SIDE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )
C     ..
C
C  F06QTF performs the transformation
C
C     R := P*U*Q'  when  SIDE = 'L' or 'l'  (  Left-hand side )
C
C     R := Q*U*P'  when  SIDE = 'R' or 'r'  ( Right-hand side ),
C
C  where  U and R  are  n by n  upper  triangular  matrices,   P  is  an
C  orthogonal matrix,  consisting of a given sequence of plane rotations
C  to be  applied  in  planes  k1 to k2,  and  Q  is  a  unitary  matrix
C  consisting of a sequence of plane rotations, applied in planes  k1 to
C  k2,  chosen to make  R  upper triangular.
C
C  When  SIDE = 'L' or 'l'  then  P  is  given  as a  sequence of  plane
C  rotation matrices
C
C     P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C  where  P( k ) is a plane rotation matrix for the  ( k, k + 1 ) plane.
C  In this case the matrix Q is given as
C
C     Q = Q( k2 - 1 )*...*Q( k1 + 1 )*Q( k1 ),
C
C  where  Q( k ) is a plane rotation matrix for the  ( k, k + 1 ) plane.
C
C  When  SIDE = 'R' or 'r'  then  P  is  given  as a  sequence of  plane
C  rotation matrices
C
C     P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C  where  P( k ) is a plane rotation matrix for the  ( k, k + 1 ) plane.
C  In this case the matrix Q is given as
C
C     Q = Q( k1 )*Q( k1 + 1 )*...*Q( k2 - 1 ),
C
C  where  Q( k ) is a plane rotation matrix for the  ( k, k + 1 ) plane.
C
C  The  upper  triangular  matrix  U  must  be  supplied  in the  n by n
C  leading upper triangular part of  A,  and this  is overwritten by the
C  upper triangular matrix  R.  The cosine  and  sine  that  define  the
C  plane rotation matrix  P( k )  must be supplied in  c( k ) and s( k )
C  respectively,  and  the two by two rotation part of  P( k ),  T( k ),
C  is assumed to be of the form
C
C     T( k ) = (  c( k )  s( k ) ).
C              ( -s( k )  c( k ) )
C
C  The cosine  and  sine that define  Q( k )  are overwritten on  c( k )
C  and  s( k )  respectively and the two by two rotation part of  Q( k )
C  will have the form of  T( k )  above.
C
C  If  n or k1  are less  than  unity, or  k1  is not  less than  k2, or
C  k2  is greater than  n  then an immediate return is effected.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 26-November-1987.
C     Sven Hammarling and Mick Pont, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   AIJ, CTEMP, FILL, STEMP, TEMP
      INTEGER            I, I1, J
C     .. External Subroutines ..
      EXTERNAL           F06BAF
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MIN( N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $   ( K2.GT.N ) )RETURN
      IF( ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' ) )THEN
C
C        Apply the left-hand transformations,  column by column,  to the
C        triangular part of  U,  but not to  anywhere  that would  cause
C        fill.
C
         DO 20 J = K1 + 1, N
C
C           Apply  P( k1 ) ... P( j - 1 )  to column j.
C
            AIJ = A( K1, J )
            DO 10 I = K1, MIN( J - 1, K2 - 1 )
               A( I, J ) = S( I )*A( I + 1, J ) + C( I )*AIJ
               AIJ = C( I )*A( I + 1, J ) - S( I )*AIJ
   10       CONTINUE
            A( I, J ) = AIJ
   20    CONTINUE
C
C           Now apply each  left-hand tranformation  to form the fill-in
C           elements and apply a  right-hand transformation to eliminate
C           the fill-in element.
C
         DO 40 J = K1, K2 - 1
C
C           Apply  P( j )  to the jth diagonal element  and the  fill-in
C           position.
C
            FILL = -S( J )*A( J, J )
            A( J, J ) = C( J )*A( J, J )
C
C           Now  set up  the rotation  Q( j )  to eliminate the  fill-in
C           element,  and  apply  Q( j )  to  the  jth  and  ( j + 1 )th
C           columns.
C
            CALL F06BAF( A( J + 1, J + 1 ), FILL, CTEMP, STEMP )
            C( J ) = CTEMP
            S( J ) = -STEMP
            IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
               STEMP = -STEMP
               DO 30 I = 1, J
                  TEMP = A( I, J + 1 )
                  A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                  A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
   30          CONTINUE
            END IF
   40    CONTINUE
      ELSE IF( ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' ) )THEN
C
C        We intermingle the  left and right hand transformations so that
C        at the kth step we form
C
C           A := Q( k )*A*P( k )'.
C
C        First  apply  the  transformations  in  columns  k2 back to k1.
C
         DO 60 J = K2 - 1, K1, -1
C
C           First apply  P( j ).
C
            IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
               CTEMP = C( J )
               STEMP = S( J )
               DO 50 I = 1, J
                  TEMP = A( I, J + 1 )
                  A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                  A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
   50          CONTINUE
C
C              Next form the fill-in element  a( j + 1, j )  by applying
C              P( j ).
C
               FILL = S( J )*A( J + 1, J + 1 )
               A( J + 1, J + 1 ) = C( J )*A( J + 1, J + 1 )
C
C              Now set up the rotation  Q( j )  to eliminate the fill-in
C              element.
C
               CALL F06BAF( A( J, J ), FILL, C( J ), S( J ) )
            END IF
   60    CONTINUE
C
C        Finally  apply  Q( k2 - 1 ) ... Q( k1 )  to columns  n  back to
C        ( k1 + 1 ).
C
         DO 80 J = N, K1 + 1, -1
            I1 = MIN( K2, J )
            AIJ = A( I1, J )
            DO 70 I = I1 - 1, K1, -1
               TEMP = A( I, J )
               A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
               AIJ = S( I )*AIJ + C( I )*TEMP
   70       CONTINUE
            A( K1, J ) = AIJ
   80    CONTINUE
      END IF
      RETURN
C
C     End of F06QTF. ( SUTSQR )
C
      END
** END OF F06QTFTEXT
*UPTODATE F06QVFTEXT
      SUBROUTINE F06QVF( SIDE, N, K1, K2, C, S, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, N
      CHARACTER*1        SIDE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )
C     ..
C
C  F06QVF applies a  given sequence  of  plane rotations  to either  the
C  left,  or the right,  of the  n by n  upper triangular matrix  U,  to
C  transform U to an  upper Hessenberg matrix. The rotations are applied
C  in planes k1 up to k2.
C
C  The upper Hessenberg matrix, H, is formed as
C
C     H = P*U,    when   SIDE = 'L' or 'l',  (  Left-hand side )
C
C  where P is an orthogonal matrix of the form
C
C     P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 )
C
C  and is formed as
C
C     H = U*P',   when   SIDE = 'R' or 'r',  ( Right-hand side )
C
C  where P is an orthogonal matrix of the form
C
C     P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C  P( k ) being a plane rotation matrix for the  ( k, k + 1 ) plane. The
C  cosine and sine that define P( k ), k = k1, k1 + 1, ..., k2 - 1, must
C  be  supplied  in  c( k )  and  s( k )  respectively.  The  two by two
C  rotation part of P( k ), R( k ), is assumed to have the form
C
C     R( k ) = (  c( k )  s( k ) ).
C              ( -s( k )  c( k ) )
C
C  The matrix  U must be supplied in the n by n leading upper triangular
C  part of the array  A, and this is overwritten by the upper triangular
C  part of  H.
C
C  The  sub-diagonal elements of  H, h( k + 1, k ),  are returned in the
C  elements s( k ),  k = k1, k1 + 1, ..., k2 - 1.
C
C  If n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
C  greater than n then an immediate return is effected.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 13-January-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   AIJ, CTEMP, STEMP, TEMP
      INTEGER            I, J
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MIN( N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $   ( K2.GT.N ) )RETURN
      IF( ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' ) )THEN
C
C        Apply the plane rotations to columns n back to k1.
C
         DO 20 J = N, K1, -1
            IF( J.GE.K2 )THEN
               AIJ = A( K2, J )
            ELSE
C
C              Form  the  additional sub-diagonal element  h( j + 1, j )
C              and store it in s( j ).
C
               AIJ = C( J )*A( J, J )
               S( J ) = -S( J )*A( J, J )
            END IF
            DO 10 I = MIN( K2, J ) - 1, K1, -1
               TEMP = A( I, J )
               A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
               AIJ = S( I )*AIJ + C( I )*TEMP
   10       CONTINUE
            A( K1, J ) = AIJ
   20    CONTINUE
      ELSE IF( ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' ) )THEN
C
C        Apply  the  plane rotations  to  columns  k1  up to  ( k2 - 1 )
C        and  form   the   additional  sub-diagonal  elements,   storing
C        h( j + 1, j ) in s( j ).
C
         DO 40 J = K1, K2 - 1
            IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
               STEMP = S( J )
               CTEMP = C( J )
               DO 30 I = 1, J
                  TEMP = A( I, J + 1 )
                  A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                  A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
   30          CONTINUE
               S( J ) = STEMP*A( J + 1, J + 1 )
               A( J + 1, J + 1 ) = CTEMP*A( J + 1, J + 1 )
            END IF
   40    CONTINUE
      END IF
C
      RETURN
C
C     End of F06QVF. ( SUTSRH )
C
      END
** END OF F06QVFTEXT
*UPTODATE F06QWFTEXT
      SUBROUTINE F06QWF( SIDE, N, K1, K2, C, S, A, LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, N
      CHARACTER*1        SIDE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )
C     ..
C
C  F06QWF applies a  given sequence  of  plane rotations  to either  the
C  left,  or the right,  of the  n by n  upper triangular  matrix  U  to
C  transform  U  to an upper spiked matrix. The rotations are applied in
C  planes k1 up to k2.
C
C  The upper spiked matrix, H, is formed as
C
C     H = P*U,   when   SIDE = 'L' or 'l',  ( Left-hand side )
C
C  where P is an orthogonal matrix of the form
C
C     P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C  P( k ) being a plane rotation matrix for the ( k, k2 ) plane, and is
C  formed as
C
C     H = U*P',   when   SIDE = 'R' or 'r',  ( Right-hand side )
C
C  where P is an orthogonal matrix of the form
C
C     P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C  P( k )  being a  plane rotation matrix for the  ( k1, k + 1 )  plane.
C
C  The cosine and sine that define  P( k ), k = k1, k1 + 1, ..., k2 - 1,
C  must be  supplied  in  c( k ) and s( k ) respectively. The two by two
C  rotation part of P( k ), R( k ), is assumed to have the form
C
C     R( k ) = (  c( k )  s( k ) ).
C              ( -s( k )  c( k ) )
C
C  The matrix  U must be supplied in the n by n leading upper triangular
C  part of the array  A, and this is overwritten by the upper triangular
C  part of H.
C
C  When  SIDE = 'L' or 'l'  then a  row spike  is  generated  in  H  and
C  when  SIDE = 'R' or 'r'  then a  column spike is generated. For a row
C  spike the elements  h( k2, k )  and for a  column spike  the elements
C  h( k + 1, k1 ), k = k1, k1 + 1, ..., k2 - 1, are returned in  s( k ).
C
C  If n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
C  greater than n then an immediate return is effected.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 13-January-1986.
C     Sven Hammarling, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   AIJ, CTEMP, SPIKE, STEMP, TEMP
      INTEGER            I, J
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      IF( ( MIN( N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $   ( K2.GT.N ) )RETURN
      IF( ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' ) )THEN
C
C        Apply the plane rotations to columns n back to k2.
C
         DO 20 J = N, K2, -1
            TEMP = A( K2, J )
            DO 10 I = K2 - 1, K1, -1
               AIJ = A( I, J )
               A( I, J ) = S( I )*TEMP + C( I )*AIJ
               TEMP = C( I )*TEMP - S( I )*AIJ
   10       CONTINUE
            A( K2, J ) = TEMP
   20    CONTINUE
C
C        Form  the spike  and apply the rotations in columns  ( k2 - 1 )
C        back to k1.
C
         DO 40 J = K2 - 1, K1, -1
            SPIKE = -S( J )*A( J, J )
            A( J, J ) = C( J )*A( J, J )
            DO 30 I = J - 1, K1, -1
               AIJ = A( I, J )
               A( I, J ) = S( I )*SPIKE + C( I )*AIJ
               SPIKE = C( I )*SPIKE - S( I )*AIJ
   30       CONTINUE
            S( J ) = SPIKE
   40    CONTINUE
      ELSE IF( ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' ) )THEN
C
C        Apply the  plane rotations to columns  ( k1 + 1 ) up to k2  and
C        form the spike.
C
         DO 70 J = K1 + 1, K2
            CTEMP = C( J - 1 )
            STEMP = S( J - 1 )
            IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
               DO 50 I = 1, K1
                  TEMP = A( I, K1 )
                  A( I, K1 ) = STEMP*A( I, J ) + CTEMP*TEMP
                  A( I, J ) = CTEMP*A( I, J ) - STEMP*TEMP
   50          CONTINUE
               DO 60 I = K1 + 1, J - 1
                  SPIKE = S( I - 1 )
                  S( I - 1 ) = STEMP*A( I, J ) + CTEMP*SPIKE
                  A( I, J ) = CTEMP*A( I, J ) - STEMP*SPIKE
   60          CONTINUE
               S( J - 1 ) = STEMP*A( J, J )
               A( J, J ) = CTEMP*A( J, J )
            END IF
   70    CONTINUE
      END IF
C
      RETURN
C
C     End of F06QWF. ( SUTSRS )
C
      END
** END OF F06QWFTEXT
*UPTODATE F06QXFTEXT
      SUBROUTINE F06QXF( SIDE, PIVOT, DIRECT, M, N, K1, K2, C, S, A,
     $                   LDA )
C     MARK 13 RELEASE. NAG COPYRIGHT 1988.
C     .. Scalar Arguments ..
      INTEGER            K1, K2, LDA, M, N
      CHARACTER*1        DIRECT, PIVOT, SIDE
C     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )
C     ..
C
C  F06QXF  performs the transformation
C
C     A := P*A,   when   SIDE = 'L' or 'l'  (  Left-hand side )
C
C     A := A*P',  when   SIDE = 'R' or 'r'  ( Right-hand side )
C
C  where A is an m by n matrix and P is an orthogonal matrix, consisting
C  of a  sequence  of  plane  rotations,  applied  in  planes  k1 to k2,
C  determined by the parameters PIVOT and DIRECT as follows:
C
C     When  PIVOT  = 'V' or 'v'  ( Variable pivot )
C     and   DIRECT = 'F' or 'f'  ( Forward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
C
C        where  P( k )  is a plane rotation matrix for the  ( k, k + 1 )
C        plane.
C
C     When  PIVOT  = 'V' or 'v'  ( Variable pivot )
C     and   DIRECT = 'B' or 'b'  ( Backward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C        where  P( k )  is a plane rotation matrix for the  ( k, k + 1 )
C        plane.
C
C     When  PIVOT  = 'T' or 't'  ( Top pivot )
C     and   DIRECT = 'F' or 'f'  ( Forward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k2 - 1 )*P( k2 - 2 )*...*P( k1 ),
C
C        where  P( k )  is a plane rotation matrix for the ( k1, k + 1 )
C        plane.
C
C     When  PIVOT  = 'T' or 't'  ( Top pivot )
C     and   DIRECT = 'B' or 'b'  ( Backward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C        where  P( k )  is a plane rotation matrix for the ( k1, k + 1 )
C        plane.
C
C     When  PIVOT  = 'B' or 'b'  ( Bottom pivot )
C     and   DIRECT = 'F' or 'f'  ( Forward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k2 - 1 )*P( k2 - 2 )*...*P( k1 ),
C
C        where  P( k )  is a  plane rotation  matrix  for the  ( k, k2 )
C        plane.
C
C     When  PIVOT  = 'B' or 'b'  ( Bottom pivot )
C     and   DIRECT = 'B' or 'b'  ( Backward sequence ) then
C
C        P is given as a sequence of plane rotation matrices
C
C           P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
C
C        where  P( k )  is a  plane rotation  matrix  for the  ( k, k2 )
C        plane.
C
C  c( k ) and s( k )  must contain the  cosine and sine  that define the
C  matrix  P( k ).  The  two by two  plane rotation  part of the  matrix
C  P( k ), R( k ), is assumed to be of the form
C
C     R( k ) = (  c( k )  s( k ) ).
C              ( -s( k )  c( k ) )
C
C  If m, n or k1 are less than unity,  or k2 is not greater than k1,  or
C  SIDE = 'L' or 'l'  and  k2  is greater than  m, or  SIDE = 'R' or 'r'
C  and  k2  is greater than  n,  then an  immediate return  is effected.
C
C
C  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
C
C  -- Written on 20-November-1986.
C     Sven Hammarling and Mick Pont, Nag Central Office.
C
C
C     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
C     .. Local Scalars ..
      DOUBLE PRECISION   AIJ, CTEMP, STEMP, TEMP
      INTEGER            I, J
      LOGICAL            LEFT, RIGHT
C     .. Intrinsic Functions ..
      INTRINSIC          MIN
C     ..
C     .. Executable Statements ..
      LEFT = ( SIDE.EQ.'L' ).OR.( SIDE.EQ.'l' )
      RIGHT = ( SIDE.EQ.'R' ).OR.( SIDE.EQ.'r' )
      IF( ( MIN( M, N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.
     $    ( ( LEFT ).AND.( K2.GT.M ) ).OR.
     $    ( ( RIGHT ).AND.( K2.GT.N ) ) )RETURN
      IF( LEFT )THEN
         IF( ( PIVOT.EQ.'V' ).OR.( PIVOT.EQ.'v' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 20 J = 1, N
                  AIJ = A( K1, J )
                  DO 10 I = K1, K2 - 1
                     TEMP = A( I + 1, J )
                     A( I, J ) = S( I )*TEMP + C( I )*AIJ
                     AIJ = C( I )*TEMP - S( I )*AIJ
   10             CONTINUE
                  A( K2, J ) = AIJ
   20          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 40 J = 1, N
                  AIJ = A( K2, J )
                  DO 30 I = K2 - 1, K1, -1
                     TEMP = A( I, J )
                     A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
                     AIJ = S( I )*AIJ + C( I )*TEMP
   30             CONTINUE
                  A( K1, J ) = AIJ
   40          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'T' ).OR.( PIVOT.EQ.'t' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 60 J = 1, N
                  TEMP = A( K1, J )
                  DO 50 I = K1, K2 - 1
                     AIJ = A( I + 1, J )
                     A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
                     TEMP = S( I )*AIJ + C( I )*TEMP
   50             CONTINUE
                  A( K1, J ) = TEMP
   60          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 80 J = 1, N
                  TEMP = A( K1, J )
                  DO 70 I = K2 - 1, K1, -1
                     AIJ = A( I + 1, J )
                     A( I + 1, J ) = C( I )*AIJ - S( I )*TEMP
                     TEMP = S( I )*AIJ + C( I )*TEMP
   70             CONTINUE
                  A( K1, J ) = TEMP
   80          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'B' ).OR.( PIVOT.EQ.'b' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 100 J = 1, N
                  TEMP = A( K2, J )
                  DO 90 I = K1, K2 - 1
                     AIJ = A( I, J )
                     A( I, J ) = S( I )*TEMP + C( I )*AIJ
                     TEMP = C( I )*TEMP - S( I )*AIJ
   90             CONTINUE
                  A( K2, J ) = TEMP
  100          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 120 J = 1, N
                  TEMP = A( K2, J )
                  DO 110 I = K2 - 1, K1, -1
                     AIJ = A( I, J )
                     A( I, J ) = S( I )*TEMP + C( I )*AIJ
                     TEMP = C( I )*TEMP - S( I )*AIJ
  110             CONTINUE
                  A( K2, J ) = TEMP
  120          CONTINUE
            END IF
         END IF
      ELSE IF( RIGHT )THEN
         IF( ( PIVOT.EQ.'V' ).OR.( PIVOT.EQ.'v' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 140 J = K1, K2 - 1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 130 I = 1, M
                        TEMP = A( I, J + 1 )
                        A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                        A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
  130                CONTINUE
                  END IF
  140          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 160 J = K2 - 1, K1, -1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 150 I = M, 1, -1
                        TEMP = A( I, J + 1 )
                        A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                        A( I, J ) = STEMP*TEMP + CTEMP*A( I, J )
  150                CONTINUE
                  END IF
  160          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'T' ).OR.( PIVOT.EQ.'t' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 180 J = K1 + 1, K2
                  CTEMP = C( J - 1 )
                  STEMP = S( J - 1 )
                  IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
                     DO 170 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = CTEMP*TEMP - STEMP*A( I, K1 )
                        A( I, K1 ) = STEMP*TEMP + CTEMP*A( I, K1 )
  170                CONTINUE
                  END IF
  180          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 200 J = K2, K1 + 1, -1
                  CTEMP = C( J - 1 )
                  STEMP = S( J - 1 )
                  IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
                     DO 190 I = M, 1, -1
                        TEMP = A( I, J )
                        A( I, J ) = CTEMP*TEMP - STEMP*A( I, K1 )
                        A( I, K1 ) = STEMP*TEMP + CTEMP*A( I, K1 )
  190                CONTINUE
                  END IF
  200          CONTINUE
            END IF
         ELSE IF( ( PIVOT.EQ.'B' ).OR.( PIVOT.EQ.'b' ) )THEN
            IF( ( DIRECT.EQ.'F' ).OR.( DIRECT.EQ.'f' ) )THEN
               DO 220 J = K1, K2 - 1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 210 I = 1, M
                        TEMP = A( I, J )
                        A( I, J ) = STEMP*A( I, K2 ) + CTEMP*TEMP
                        A( I, K2 ) = CTEMP*A( I, K2 ) - STEMP*TEMP
  210                CONTINUE
                  END IF
  220          CONTINUE
            ELSE IF( ( DIRECT.EQ.'B' ).OR.( DIRECT.EQ.'b' ) )THEN
               DO 240 J = K2 - 1, K1, -1
                  IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
                     CTEMP = C( J )
                     STEMP = S( J )
                     DO 230 I = M, 1, -1
                        TEMP = A( I, J )
                        A( I, J ) = STEMP*A( I, K2 ) + CTEMP*TEMP
                        A( I, K2 ) = CTEMP*A( I, K2 ) - STEMP*TEMP
  230                CONTINUE
                  END IF
  240          CONTINUE
            END IF
         END IF
      END IF
C
      RETURN
C
C     End of F06QXF. ( SGESRC )
C
      END
** END OF F06QXFTEXT
      SUBROUTINE F06QZF( HESS, N, K1, K2, C, S, A, LDA )
*     .. Scalar Arguments ..
      CHARACTER*1        HESS
      INTEGER            K1, K2, LDA, N
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), C( * ), S( * )
*     ..
*
*  F06QZF  either applies a  given sequence  of  plane rotations  to the
*  right of the n by n reverse lower triangular matrix T, to transform T
*  to a  reverse lower Hessenberg matrix  H, or restores a reverse lower
*  Hessenberg matrix H to reverse lower triangular form T, by applying a
*  sequence of plane rotations from the right.
*
*  The rotations are applied  in planes k1 up to k2.
*
*  When   HESS = 'C' or 'c',   ( Create ),  then   the   reverse   lower
*  Hessenberg matrix, H, is formed as
*
*     H = T*P',
*
*  where P is an orthogonal matrix of the form
*
*     P = P( k2 - 1 )*...*P( k1 + 1 )*P( k1 ),
*
*  P( k ) being a plane rotation matrix for the  ( k, k + 1 ) plane. The
*  cosine and sine that define P( k ), k = k1, k1 + 1, ..., k2 - 1, must
*  be  supplied  in  c( k )  and  s( k )  respectively.  The  two by two
*  rotation part of P( k ), R( k ), is assumed to have the form
*
*     R( k ) = (  c( k )  s( k ) ).
*              ( -s( k )  c( k ) )
*
*  The matrix  T must be supplied in the n by n reverse lower triangular
*  part  of the array  A,  and this is overwritten by the  reverse lower
*  triangular part of  H.
*
*  The super-diagonal elements of  H, h( n - k, k ), are returned in the
*  elements s( k ),  k = k1, k1 + 1, ..., k2 - 1.
*
*  If n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
*  greater than n then an immediate return is effected.
*
*  When   HESS = 'R' or 'r',   ( Remove ),  then   the   reverse   lower
*  Hessenberg matrix  H  is  assumed  to  have  non-zero  super-diagonal
*  elements  in  positions  h( n - k, k ),  k = k1, k1 + 1, ..., k2 - 1,
*  only and  h( n - k, k ) must be supplied in  s( k ). H is restored to
*  the reverse lower triangular matrix T as
*
*     T = H*P',
*
*  where P is an orthogonal matrix of the form
*
*     P = P( k1 )*P( k1 + 1 )*...*P( k2 - 1 ),
*
*  P( k ) being a plane rotation for the  ( k, k + 1 ) plane. The cosine
*  and  sine  that  define  P( k )  are  returned  in  c( k ) and s( k )
*  respectively.  The  two by two  rotation part of  P( k ),  R( k ), is
*  of the form
*
*     R( k ) = (  c( k )  s( k ) ).
*              ( -s( k )  c( k ) )
*
*  The reverse lower triangular part of the matrix H must be supplied in
*  the  n by n  reverse  lower  triangular  part  of  A,   and  this  is
*  overwritten by the reverse triangular matrix T.
*
*  If n or k1 are less than unity,  or k1 is not less than k2,  or k2 is
*  greater than n then an immediate return is effected.
*
*  When   n = 7, k1 = 2 and k2 = 5   then  T  and  H  are  of  the  form
*
*     T = ( 0  0  0  0  0  0  X ),   H = ( 0  0  0  0  0  0  X ).
*         ( 0  0  0  0  0  X  X )        ( 0  0  0  0  X  X  X )
*         ( 0  0  0  0  X  X  X )        ( 0  0  0  X  X  X  X )
*         ( 0  0  0  X  X  X  X )        ( 0  0  X  X  X  X  X )
*         ( 0  0  X  X  X  X  X )        ( 0  X  X  X  X  X  X )
*         ( 0  X  X  X  X  X  X )        ( 0  X  X  X  X  X  X )
*         ( X  X  X  X  X  X  X )        ( X  X  X  X  X  X  X )
*
*
*  This routine  is  principally intended  for use  with the  non-linear
*  optimization routines such as E04UCF, in order to help vectorization.
*  Nag Fortran 77 O( n**2 ) basic linear algebra routine.
*
*  -- Written on 10-May-1988.
*     Sven Hammarling, Nag Central Office.
*
*
*     .. Intrinsic Functions ..
      INTRINSIC          MIN
*     .. External Subroutines ..
      EXTERNAL           F06BAF
*     .. Local Scalars ..
      DOUBLE PRECISION   CTEMP, STEMP, SUPH, TEMP
      INTEGER            I, J
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0E+0, ZERO = 0.0E+0 )
*     ..
*     .. Executable Statements ..
      IF( ( MIN( N, K1 ).LT.1 ).OR.( K2.LE.K1 ).OR.( K2.GT.N ) )
     $   RETURN
      IF( ( HESS.EQ.'C' ).OR.( HESS.EQ.'c' ) )THEN
*
*        Apply  the  plane rotations  to  columns  k1  up to  ( k2 - 1 )
*        and  form   the  additional  super-diagonal  elements,  storing
*        h( n - j, j ) in s( j ).
*
         DO 20, J = K1, K2 - 1
            IF( ( C( J ).NE.ONE ).OR.( S( J ).NE.ZERO ) )THEN
               STEMP             = S( J )
               CTEMP             = C( J )
               S( J )            = STEMP*A( N - J, J + 1 )
               A( N - J, J + 1 ) = CTEMP*A( N - J, J + 1 )
               DO 10, I = N - J + 1, N
                  TEMP          = A( I, J + 1 )
                  A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                  A( I, J )     = STEMP*TEMP + CTEMP*A( I, J )
   10          CONTINUE
            END IF
   20    CONTINUE
      ELSE IF( ( HESS.EQ.'R' ).OR.( HESS.EQ.'r' ) )THEN
*
*        Restore  H to reverse lower triangular form by annihilating the
*        super-diagonal elements of  H.  The  jth rotation  is chosen so
*        that
*
*          ( h( n - j, n - j ) ) := (  c  s )*( h( n - j, n - j     ) ),
*          (         0         )    ( -s  c ) ( h( n - j, n - j - 1 ) )
*
*        which can be expressed as
*
*           ( 0  h( n - j, n - j ) ) :=
*
*               ( h( n - j, n - j - 1 )  h( n - j, n - j ) )*(  c  s ).
*                                                            ( -s  c )
*
*        Thus we return  c( j ) = c  and  s( j ) = -s  to make the plane
*        rotation matrix look like
*
*           R( j ) = (  c( j )  s( j ) ).
*                    ( -s( j )  c( j ) )
*
         DO 40, J = K2 - 1, K1, -1
            SUPH   =  S( J )
            CALL F06BAF( A( N - J, J + 1 ), SUPH, CTEMP, STEMP )
            STEMP  = -STEMP
            S( J ) =  STEMP
            C( J ) =  CTEMP
            IF( ( CTEMP.NE.ONE ).OR.( STEMP.NE.ZERO ) )THEN
               DO 30, I = N - J + 1, N
                  TEMP          = A( I, J + 1 )
                  A( I, J + 1 ) = CTEMP*TEMP - STEMP*A( I, J )
                  A( I, J )     = STEMP*TEMP + CTEMP*A( I, J )
   30          CONTINUE
            END IF
   40    CONTINUE
      END IF
*
      RETURN
*
*     End of F06QZF.
*
      END
** END OF F06QZFTEXT

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     nlmix.f
*
*     Copyright (C) 1991, 1992.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*
*     Program control is by entries in a parmfile that looks like this:
*
*     monoexp       name    format(a10  )
*        50         ncases  format(i5,5x)
*        10    1    npt,iq  format(2i5  ) (npt MCarlo if iq=0, npt quad if iq=1)
*         2         lx      format(i5,5x)
*         3         ltau    format(i5,5x)
*         2         M       format(i5,5x)
*         2    0    Kz,Iz   format(2i5  )
*         0    0    Kx,Ix   format(2i5  )
*       400         maxitr  format(i5,5x)
*        0.1D-05    ftol    format(d10.1)
*       956         iseed   format(i5,5x)
*        0.4D+01    sfac    format(d10.1)
*        30    1    ngrd,jt format(2i5  ) (plot points for joint if jt=1)
*         0         iunit9  format(i5,5x) (0 parmfile, 1 eff, 2 sim, 4 plt)
*         1         iCvec   format(i5,5x) (compute Cvec if iCvec=1 & iq=1)
*         1         muzero  format(i5,5x) (impose Ez=0 if muzero=1)
*                   blank line
*     Start values for tau.
*           0.100000000000000000D+00 0   tau(  1)    format(d30.18,1x,i1)
*           0.500000000000000000D+00 0   tau(  2)    format(d30.18,1x,i1)
*           0.500000000000000000D-01 0   tau(  3)    format(d30.18,1x,i1)
*     SNP parameters of theta start values.
*         0    0    1                    Kz, Iz, ntermz  format(3i5)
*         0    0    1                    Kx, Ix, ntermx  format(3i5)
*     Start values for theta.
*           0.100000000000000000D+01 1   theta(  1)  format(d30.18,1x,i1)
*           0.000000000000000000D+00 1   theta(  2)  format(d30.18,1x,i1)
*           0.000000000000000000D+00 1   theta(  3)  format(d30.18,1x,i1)
*           0.000000000000000000D+00 1   theta(  4)  format(d30.18,1x,i1)
*           0.000000000000000000D+00 1   theta(  5)  format(d30.18,1x,i1)
*           0.000000000000000000D+00 1   theta(  6)  format(d30.18,1x,i1)
*           0.000000000000000000D+00 1   theta(  7)  format(d30.18,1x,i1)
*           0.030000000000000000D+00 0   theta(  8)  format(d30.18,1x,i1)
*           0.025000000000000000D+00 0   theta(  9)  format(d30.18,1x,i1)
*           0.080000000000000000D+00 0   theta( 10)  format(d30.18,1x,i1)
*
*     Note that in the example above, the SNP model to be fitted is 
*     bigger than the model for which start values are given.  The 
*     program uses the values for the smaller model to impute start
*     values for the larger model.
*
*     The 1's and 0's following the start values in column 32 are used 
*     to impose the start value as constraint: 0 means free, 1 means 
*     constrained.  In the SNP part, A(1,1) is always constrained to be
*     1.0D+00 and the regression part to be 0.0D+00.

*     The format for a start value line is (d30.18,1x,i1).

*     The program reads from the parmfile designated by the first entry
*     in a line from the file control.dat.  The second entry in a line 
*     from control.dat defines the output parmfile.  The imputed start
*     values are a uniform[-1,1] random number times the third entry, 
*     fnew.  The values of theta from the smaller model are replaced by
*     a theta(i) plus uniform[-1,1] random number times theta(i) times 
*     the fourth entry, fold.  Similarly for tau.  The fifth entry is 
*     the seed for the random number generator, nseed.  If nseed=0 then 
*     fnew is used as a fill value for the imputed start values and the 
*     values of theta from the smaller model are left unchanged.   The 
*     format for a line from control.dat is (a12,3x,a12,3x,2f10.1,i10); 
*     an example is
*
*     parmfile.dat   out_a.dat      0.0       0.0       8746
*     parmfile.dat   out_b.dat      0.0001    0.0       72365
*     parmfile.dat   out_c.dat      0.0001    0.0001    08745
*     parmfile.dat   out_d.dat      0.001     0.0       357
*     parmfile.dat   out_e.dat      0.001     0.001     8054
*
*     An output parmfile can be used as an input parmfile.  The easiest 
*     way to get a custom parmfile is to let the program generate one 
*     with the desired SNP settings from the example above and edit it.
*
*     The user must write subroutine density which gives the density in 
*     terms of the parameters tau(ltau) and random effects z(M) for each
*     case id = 1, ..., ncases.  Don't forget to compute nobs.
*
*     Dependence of the SNP density on x(lx) hasn't been debugged and 
*     probably doesn't work.  Thus, always put Kx=Ix=0 in the parmfile.
*     
*     If iunit9 is set to 4 and jt to 1, a file that can be used to plot
*     joint density is written to outfil instead of a parmfile; sfac 
*     determines the scaling and ngrd the number of grid points per 
*     coordinate.  The following values are printed to this file with 
*     format e30.18.  First, E(z), M values; Second, the upper triangle 
*     of Var(z) stored columnwise, M*(M+1)/2 values; Third, the grid 
*     increments, M values; Thereafter, z and h(z), written end to end.
*     Total file length is M+M*(M+1)/2+M+M*(2*ngrd+1)**M.  Note that z
*     is not constrained to have mean zero if muzero=0, which violates 
*     the typical regression conventions.  In reporting results, one 
*     may wish to add E(z) to the appropriate coordinates of tau and 
*     subtract E(z) from the plot coordinates before plotting them.  
*     If all the mass has been captured by the grid, a Riemann sum using 
*     zinc(i) as the weights should yield 1.  
*
*     If iunit9 is set to 4 and jt to 0, then files that can be used to 
*     plot the marginal densities are written.  The names of these files 
*     and the format, which is as above were M=1, are written to outfil
*
*     If iunit9 is set to 1, emperical Bayes estimates are written to
*     outfil instead of a parmfile, format e30.18.  This assumes that
*     density.f for isw=3 is written analagously to the example supplied
*     with the distribution.
*
*     If iunit9 is set to 2, a simulation from the SNP density is written 
*     to outfil instead of a parmfile, format e30.18.  
*
      program nlmix
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

*     Global data.

      include "global.f"

*     Local data

      real*8 work
      real*8 vec
      real*8 a,bl,bu
      real*8 c,cjac,clamda
      real*8 objf,objgrd,Rsmall,Rbig
      real*8 fn,fp,bic,aic,hq

      integer*4 isw,i,j,jj,ictr,ier
      integer*4 lwork,idummy
      integer*4 iwork
      integer*4 lvec
      integer*4 istate
      integer*4 msglvl,mode

      external  mcarlo,quad,post,mufun,confun

*     Local parameters

      real*8 bigbnd,feps,difint

      integer*4 itreff,vereff,dereff
      integer*4 debug
      integer*4 miwork,mwork,needc
      integer*4 derlev
      integer*4 nclin,ncnln,nrowa,ntotal

      parameter (debug=0)
*     parameter (debug=1)
      parameter (itreff=200)
      parameter (vereff  = -1)
      parameter (dereff  = 3)
      parameter (miwork=500,mwork=10000)
      parameter (bigbnd  = 1.d+10)
      parameter (feps    = 1.d-15)
      parameter (difint  = 1.d-8)
      parameter (derlev  = 2)
      parameter (nclin=0,nrowa=1)
      parameter (ntotal=mvec+nclin+mM)

      dimension iwork(miwork),needc(mM)
      dimension work(mwork)
      dimension vec(mvec)
      dimension a(1),bl(ntotal),bu(ntotal)
      dimension istate(ntotal)
      dimension c(mM),cjac(mM*mvec),clamda(ntotal)
      dimension objgrd(ntotal),Rsmall(mM*mM),Rbig(mvec*mvec)

      open(unit=3,file='detail.dat',status='unknown',form='formatted')
      open(unit=27,file='options.dat',status='unknown',form='formatted')
      open(unit=12,file='control.dat',status='unknown',form='formatted')

      iprint=0
      lnsize=80

*     Correspondences between SNP code and nlmix.f code.

*       SNP    nlmix
*      ------  ------
*      IDEGY    Kz
*      IDEGX    Kx
*      LINTY    Iz
*      LINTX    Ix
*      KY       ntermz
*      KX       ntermx

*     The contents of units 12 and 8 control program flow.

      ictr=0
900   read(12,12000,end=910) infile,outfil,fnew,fold,nseed
      ictr=ictr+1

*     Open infile as unit 8 and read parameters.

      call sizes(1)
      if (iprint.eq.0) then
        call spacer(2)
        call header('/nlmix version 3.0//_')
        call header('/line from control.dat//_')
        call spacer(2)
        write(3,3003)
        write(3,3004) infile,outfil,fnew,fold,nseed
        call header('/Dimensions and switches//_')
        call spacer(2)
        call sizes(3)
      end if

      L=1
      do i=1,mx
        if (M*i.lt.lx) L=i
      end do

      if (miwork.lt.2*M*L) then
        write(3,3905) 2*M*L
        stop
      end if

*     Setup SNP local data.

      call setmyx(M,L,L,Kz,Kx,Iz,Ix,ntermz,ntermx,idummy,iwork)
      call setprd(M,L,ntermz,ntermx,Kz,Kx)
      call setupm(Kz,M,ntermz)

*     Compute the length of theta and its subarrays.

      lA  = ntermz*ntermx
      lB0 = M
      lB  = M*M*L
      lR  = (M*(M+1))/2

      ltheta = lA + lB0 + lB + lR

*     Compute pointers to the stacked SNP parameter vector theta.

      ibA  = 0
      ibB0 = ibA  + lA
      ibB  = ibB0 + lB0
      ibR  = ibB  + lB

      iaA  = ibA  + 1
      iaB0 = ibB0 + 1
      iaB  = ibB  + 1
      iaR  = ibR  + 1
            
*     Error checks.
            
      if (mtheta.lt.ltheta) then
        write(3,3901) ltheta
        stop
      end if

      if (mtau.lt.ltau) then
        write(3,3902) ltau
        stop
      end if

      if (mtau.lt.M) then
        write(3,3902) M
        stop
      end if

      if (mM.lt.M) then
        write(3,3903) M
        stop
      end if

      if (mx.lt.lx+M) then
        write(3,3904) lx+M
        stop
      end if

*     Read start values from infile and close unit 8.

      call values (1)

      if (iprint.eq.0) then
        call header('/start values//_')
        call header('/tau//_')
        call dgmpnt(tau,ltau,1)
        call header('/A//_')
        call dgmpnt(theta(iaA),ntermx,ntermz)
        call header('/B0//_')
        call dgmpnt(theta(iaB0),M,1)
        call header('/B//_')
        call dgmpnt(theta(iaB),M,M*L)
        call header('/R//_')
        call dgmpnt(theta(iaR),lR,1)
       end if

*     Initial call to subroutine density with isw = 1 allows user to
*     read data from a file, setup local data, etc.

      isw=1
      call density(isw)

      if (iprint.eq.0) then
        msglvl=10
      else
        msglvl=0
      end if

*     Call to NPSOL as it appears in NPSOL documentation:
*
*     call npsol(n,nclin,ncnln,nrowa,nrowj,nrowr,
*    &             a,bl,bu,
*    &             confun,objfun,
*    &             inform,iter,istate,
*    &             c,cjac,clamda,objf,objgrd,r,x,
*    &             iw,leniw,w,lenw)
*

*     Write the options file that NPSOL uses.

      rewind 27
      write(27,27000)
      write(27,27001) bigbnd
      write(27,27002) maxitr
      write(27,27004) ftol
      write(27,27005) msglvl
      if (verify.eq.1) then
        write(27,27006) 3
      else
        write(27,27006) -1
      end if
      write(27,27007) derlev
*     write(27,27008) feps
*     write(27,27009) difint
      write(27,27900)
      rewind 27
      call npfile(27,inform)

*     Store parameter values and constraint indicators end to end 
*     in vsav and ivec repectively.

      lvsav = ltau+ltheta

      nfit1=0
      do i=1,ltau
        vsav(i)=tau(i)
        ivec(i)=itau(i)
        if (itau(i).eq.0) nfit1=nfit1+1
      end do

      nfit2=0
      do i=1,ltheta
        vsav(ltau+i)=theta(i)
        ivec(ltau+i)=itheta(i)
        if (itheta(i).eq.0) nfit2=nfit2+1
      end do

      nfit = nfit1 + nfit2
      pmax = ltau + lA - 1 + lR

*     The parameters that NPSOL is to see are stored in vec.

*     If ivec(i)=1, NPSOL doesn't get to see the ith parameter which 
*     constrains the ith parameter stay at its start value.

      j=0
      do i=1,lvsav
        if (ivec(i).eq.0) then
          j=j+1
          vec(j)=vsav(i)
        end if
      end do 
      lvec=j

      if (lvec.ne.nfit) then
        write(3,3999)
        stop
       end if

*     Fill in bl and bu.

      do i=1,lvec
        bl(i)=-bigbnd
        bu(i)= bigbnd
      end do

        ncnln=M
      if ((muzero.eq.1).and.(Kz.gt.0)) then
        do i=lvec+1,lvec+ncnln
          bl(i)=0.d0
          bu(i)=0.d0
        end do
        mode=0
        do i=1,M
          needc(i)=1
        end do
        call mufun(mode,ncnln,lvec,M,needc,vec,c,cjac,1)
      else
        ncnln=0
      end if

      net  = nfit-ncnln

      if (iprint.eq.0) then
        call header('/bl, vec, bu//_')
        call spacer(2)
        do i=1,lvec
          write(3,3001) bl(i),vec(i),bu(i)
        end do
        if (ncnln.gt.0) then
          do i=lvec+1,lvec+ncnln
            write(3,3001) bl(i),c(i-lvec),bu(i)
          end do
        end if
        call spacer(2)
      end if

*     Evaluate objective function at start values.

      mode = 0

      if (iq.eq.0) then
        call mcarlo(mode,lvec,vec,objf,objgrd,1)
      else
        call quad(mode,lvec,vec,objf,objgrd,1)
      end if

      if (iprint.eq.0) then
        call header('/Objective function at start values//_')
        call spacer(2)
        write(3,3002) objf, objf
      end if

      doCvec = 0

      if ((maxitr.ne.0).and.(iq.eq.0)) then
        call npsol(lvec,nclin,ncnln,nrowa,M,mvec,
     &             a,bl,bu,
     &             mufun,mcarlo,
     &             inform,iter,istate,
     &             c,cjac,clamda,objf,objgrd,Rbig,vec,
     &             iwork,miwork,work,mwork)
      elseif ((maxitr.ne.0).and.(iq.eq.1)) then
        call npsol(lvec,nclin,ncnln,nrowa,M,mvec,
     &             a,bl,bu,
     &             mufun,quad,
     &             inform,iter,istate,
     &             c,cjac,clamda,objf,objgrd,Rbig,vec,
     &             iwork,miwork,work,mwork)
      else
        call header('/NPSOL not called because maxitr=0//_')
        iter=0
        inform=4
      end if  

*     Copy the parameters that NPSOL has changed to vsav.

      j=0
      do i=1,lvsav
        if (ivec(i).eq.0) then
          j=j+1
          vsav(i)=vec(j)
        end if
      end do 

*     Make tau and theta agree with vsav.

      do i=1,ltau
        tau(i)=vsav(i)
      end do

      do i=1,ltheta
        theta(i)=vsav(ltau+i)
      end do

*     Compute some statistics.

      fn  = dfloat(nobs)
      fp  = dfloat(net)

      sn  = objf
      bic = sn + (fp/fn)*dlog(fn)/2.d0
      hq  = sn + (fp/fn)*dlog(dlog(fn))
      aic = sn + (fp/fn)

      lwork=(M+1)*ltheta+M+max0(2*ntermz,lR)
      if (lwork.gt.mwork) then
        write (3,3906) lwork
        stop
      endif

      do j=1,ltau
      do i=1,M
        dEz(M*(j-1)+i)=0.d0
      end do
      end do

      call mean(z,x,Ez,dEz(M*ltau+1),
     &  theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &  M,L,ntermz,ntermx,Kz,Kx,
     &  work,iwork)

      lwork=M*M*(ltheta+1)+ltheta+max0(2*ntermz,lR)+lR
      if (lwork.gt.mwork) then
        write (3,3906) lwork
        stop
      end if

      do j=1,ltau
      do i=1,lR
        dCz(lR*(j-1)+i)=0.d0
      end do
      end do

      call varcov(z,x,Cz,dCz(lR*ltau+1),
     &  theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &  M,L,ntermz,ntermx,Kz,Kx,
     &  work,iwork)

      if (lvec.ne.nfit) then
        write(3,3999)
        stop
       end if

      if ((iCvec.eq.1).and.(iq.eq.1)) then

        j=0
        do jj=1,lvsav
          if (ivec(jj).eq.0) then
            j=j+1
            do i=1,M
              dEz(M*(j-1)+i)=dEz(M*(jj-1)+i)
            end do  
            do i=1,lR
              dCz(lR*(j-1)+i)=dCz(lR*(jj-1)+i)
            end do  
          end if
        end do 

        doCvec = 1
        call quad(mode,lvec,vec,objf,objgrd,1)
        doCvec = 0

        do i=1,nfit1
        do j=1,nfit1
          Ctau(nfit1*(j-1)+i)=Cvec(nfit*(j-1)+i)
        end do
        end do

        call dsweep(Ctau,nfit1,1.d-13,ier)
        if (ier.ne.0) write(3,3908) outfil

        call dsweep(Cvec,nfit,1.d-13,ier)
        if (ier.ne.0) write(3,3908) outfil

        if (ncnln.gt.0) then
          lwork=max0(lR,M)*nfit
          if (lwork.gt.mwork) then
            write (3,3906) lwork
            stop
          endif
          call mufun(mode,ncnln,lvec,M,needc,vec,c,cjac,1)
          call dgmtra(cjac,work,M,nfit)
          call dgmaba(work,Cvec,Rsmall,nfit,M)
          call dsweep(Rsmall,M,1.d-13,ier)
          if (ier.ne.0) write(3,3908) outfil
          call dgmprd(cjac,Cvec,work,M,nfit,nfit)
          call dgmaba(work,Rsmall,Rbig,M,nfit)
          call dgmsub(Cvec,Rbig,Cvec,nfit,nfit)
          do i=1,nfit
            if (Cvec(nfit*(i-1)+i).lt.0.d0) then
              do j=1,nfit
                Cvec(nfit*(j-1)+i)=0.d0
                Cvec(nfit*(i-1)+j)=0.d0
              end do
            end if
          end do
        end if

        call dgmtra(dEz,work,M,nfit)
        call dgmaba(work,Cvec,CovEz,nfit,M)
        call dgmtra(dCz,work,lR,nfit)
        call dgmaba(work,Cvec,CovCz,nfit,lR)

      end if

      if (iprint.eq.0) then
        call header('/estimated values//_')
        call header('/tau//_')
        call dgmpnt(tau,ltau,1)
        call header('/A//_')
        call dgmpnt(theta(iaA),ntermx,ntermz)
        call header('/B0//_')
        call dgmpnt(theta(iaB0),M,1)
        call header('/B//_')
        call dgmpnt(theta(iaB),M,M*L)
        call header('/R//_')
        call dgmpnt(theta(iaR),lR,1)
        call header('/Ez//_')
        call dgmpnt(Ez,M,1)
        if ((iCvec.eq.1).and.(iq.eq.1)) then
          call header('/CovEz//_')
          call dgmpnt(CovEz,M,M)
        end if
        call header('/Cz//_')
        call dgmpnt(Cz,lR,1)
        if ((iCvec.eq.1).and.(iq.eq.1)) then
          call header('/CovCz//_')
          call dgmpnt(CovCz,lR,lR)
        end if
      end if

      if (debug.eq.1) then

        write(*,'(1x,''Lines printed to summary.dat'')')

        write(*,10001) infile,outfil
        write(*,10002) iter,maxitr,inform,Kz,Iz,net,pmax,sn,hq

        call derchk()

      end if

*     Write results to outfil.

      call sizes(2)
      call values (2)

*     If iunit9=4 overwrite the file written to unit 9 by subroutines
*     sizes and subroutine values by a file written by plot. 

      if (iunit9.eq.4) call plot()

*     If iunit9=2 overwrite the file written to unit 9 by subroutines
*     sizes and subroutine values by a file written by simlat. 

      if (iunit9.eq.2) call simlat()

*     If iunit9=1 overwrite the file written to unit 9 by subroutines
*     sizes and values by a file written by density called with isw=3. 

      if (iunit9.eq.1) then

        rewind 27
        write(27,27000)
        write(27,27001) bigbnd
        write(27,27002) itreff
        write(27,27004) ftol
        write(27,27005) msglvl
        write(27,27006) vereff
        write(27,27007) dereff
*       write(27,27008) feps
*       write(27,27009) difint
        write(27,27900)
        rewind 27
        call npfile(27,inform)

        lvec=M

        do i=1,lvec
          bl(i)=-bigbnd
          bu(i)= bigbnd
        end do

        open(unit=9,file=outfil,status='unknown',form='formatted')

        do id=1,ncases

          call pstart(vec,lvec)

          call npsol(lvec,nclin,ncnln,nrowa,1,mM,
     &               a,bl,bu,
     &               confun,post,
     &               inform,iter,istate,
     &               c,cjac,clamda,objf,objgrd,Rsmall,vec,
     &               iwork,miwork,work,mwork)

          if (inform.ne.0) write(3,3907) id

          do i=1,lvec
            z(i)=vec(i)
          end do
       
          isw=2
          call density(isw)
          isw=3
          call density(isw)

        end do

        close(9)

      end if

*     Write results to summary file.  The open and close stuff
*     is to allow the file to be read during computations (that is,
*     defeat buffering) and to increase the odds that the file is 
*     closed if the program aborts or is killed.

      open(unit=10,file='summary.dat',status='unknown',form='formatted')
      j=0
200   read(10,10000,end=210)
      j=j+1
      go to 200
210   continue
      rewind 10
      do i=1,j
        read(10,10000)
      end do
      if (ictr.eq.1) write(10,10003)
      write(10,10001) infile,outfil
      write(10,10002) iter,maxitr,inform,Kz,Iz,net,pmax,sn,hq
      close(10)

      if (iprint.eq.0) then
        call header('/summary of results//_')
        call spacer(2)
        write(3,10001) infile,outfil
        write(3,10002) iter,maxitr,inform,Kz,Iz,net,pmax,sn,hq
      end if

*     Call to subroutine density with isw = 4 allows user to
*     write data to a file to save global or local data, etc.

      isw=4
      call density(isw)

      go to 900
910   continue      

      close(3)
      close(12)
      close(27)
      stop
3001  format(1x,3d25.16)
3002  format(1x,'Starting value =',f20.8,5x,d30.18)
3003  format(6x,'infile',9x,'outfil',20x,'fnew',11x,'fold',5x,'nseed')
3004  format(6x,a12,3x,a12,3x,2f15.10,i10)
3901  format(1x,'error, main, increase mtheta to at least',i5)
3902  format(1x,'error, main, increase mtau to at least',i5)
3903  format(1x,'error, main, increase mM to at least',i5)
3904  format(1x,'error, main, increase mx to at least',i5)
3905  format(1x,'error, main, increase miwork to at least',i5)
3906  format(1x,'error, main, increase mwork to at least',i5)
3907  format(1x,'error, main, inform.ne.0 for id = ,',i5,
     &/'              parameter itreff should probably be increased.')
3908  format(1x,'error, main, outfil=',a12,', error return from dsweep')
3999  format(1x,'error, main, this should never happen')
10000 format(i5)
10001 format(1x,'infile=',a12,' outfil=',a12)
10002 format(1x,'iter=',i3,'/',i3,' inform=',i2,' Kz=',i2,' Iz=',i2,
     &  ' net=',i3,'/',i3,' sn=',f12.7,' hq=',f12.7)
10003 format(1x,'Program restart.')
12000 format(a12,3x,a12,3x,2f10.1,i10)
27000 format('Begin',74x,' ')
27001 format('   Infinite Bound            ',d15.3,35x,' ')
27002 format('   Major Iteration Limit     ',i15  ,35x,' ')
27003 format('   Function Precision        ',d15.3,35x,' ')
27004 format('   Optimality Tolerance      ',d15.3,35x,' ')
27005 format('   Major Print Level         ',i15  ,35x,' ')
27006 format('   Verify Level              ',i15  ,35x,' ')
27007 format('   Derivative Level          ',i15  ,35x,' ')
27008 format('   Function Precision        ',d15.3,35x,' ')
27009 format('   Difference Interval       ',d15.3,35x,' ')
27900 format('end  ',74x,' ')
      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     FILE LSMAIN FORTRAN
*
*     Sample program for LSSOL  Version 1.02  May 1988.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

*     Set the declared array dimensions.
*     NROWC  = the declared row dimension of  C.
*     NROWA  = the declared row dimension of  A.
*     MAXN   = maximum no. of variables allowed for.
*     MAXM   = maximum no. of observations allowed for.
*     MAXBND = maximum no. of variables + linear constraints.
*     LIWORK = the length of the integer work array.
*     LWORK  = the length of the double precision work array.

      PARAMETER         (NROWC  =   3, NROWA =  10,
     $                   MAXN   =   9, MAXM  =  10,
     $                   LIWORK =  60, LWORK = 900,
     $                   MAXBND = MAXN + NROWC )

      INTEGER            KX(MAXN), ISTATE(MAXBND)
      INTEGER            IWORK(LIWORK)
      DOUBLE PRECISION   C(NROWC,MAXN), B(MAXM)
      DOUBLE PRECISION   BL(MAXBND), BU(MAXBND), CLAMDA(MAXBND)
      DOUBLE PRECISION   CVEC(MAXN)
      DOUBLE PRECISION   A(NROWA,MAXN), X(MAXN)
      DOUBLE PRECISION   WORK(LWORK)

      DOUBLE PRECISION   BIGBND
      CHARACTER*10       CBGBND

      INTRINSIC          FLOAT

      PARAMETER        ( POINT1=0.1D+0, POINT3=0.3D+0, ONEPT5=1.5D+0 )
      PARAMETER        ( ZERO  =0.0D+0, ONE   =1.0D+0, TWO   =2.0D+0 )
      PARAMETER        ( THREE =3.0D+0, FOUR  =4.0D+0, FIVE  =5.0D+0 )
      PARAMETER        ( SIX   =6.0D+0                               )

      BIGBND =  1.0D+15
      CBGBND = '1.0D+15'

*     ==========================================
*     Example 1.  A linear least-squares problem.
*     ==========================================
*     Set the actual problem dimensions.
*     M      = the number of observations (rows of A)   (may be 0).
*     N      = the number of variables.
*     NCLIN  = the number of general linear constraints (may be 0).

      M      = 10
      N      = 9
      NCLIN  = 3
      NBND   = N + NCLIN

*     ------------------------------------------------------------------
*     Assign file numbers and problem data.
*     NOUT   = the unit number for printing.
*     IOPTNS = the unit number for reading the options file.
*     A      = the least-squares matrix.
*     B      = the vector of observations.
*     C      = the general constraint matrix.
*     BL     = the lower bounds on  x  and  C*x.
*     BU     = the upper bounds on  x  and  C*x.
*     X      = the initial estimate of the solution.
*     ------------------------------------------------------------------
      IOPTNS = 5
      NOUT   = 6

      DO 120 J = 1, N
         DO 110 I = 1, M
            A(I,J) = ONE
            B(I)   = ONE
  110    CONTINUE
  120 CONTINUE

      A(2 ,2) =   TWO
      A(10,2) =   ZERO

      A(3,3) =    THREE
      A(6,3) =    TWO
      A(9,3) =    ZERO

      A(4,4) =    FOUR
      A(5,4) =    THREE
      A(8,4) =    ZERO

      A(7,5) =    ZERO

      A(6,6) =    ZERO

      A(2 ,7) =   TWO
      A(3 ,7) = - ONE
      A(6 ,7) =   ZERO
      A(9 ,7) =   TWO
      A(10,7) =   ZERO

      A(2 ,8) =   ZERO
      A(3 ,8) = - ONE
      A(6 ,8) =   ZERO
      A(9 ,8) =   TWO
      A(10,8) =   TWO

      A(2 ,9) =   ZERO
      A(3 ,9) = - THREE
      A(6 ,9) = - ONE
      A(9 ,9) =   THREE
      A(10,9) =   TWO

      DO 140 J = 1, N
         DO 130 I = 1, NCLIN
            C(I,J) = ONE
  130    CONTINUE
  140 CONTINUE

      C(1,9) =   FOUR

      C(2,2) =   TWO
      C(2,3) =   THREE
      C(2,4) =   FOUR
      C(2,5) = - TWO

      C(3,2) = - ONE
      C(3,4) = - ONE

      DO 150 J = 1, N
         BL(J) = - TWO
         BU(J) =   TWO
  150 CONTINUE
      BL( 3) = - BIGBND

*     Set the ranges for the general constraints.

      BL(N+1) =   TWO
      BU(N+1) =   BIGBND
      BL(N+2) = - BIGBND
      BU(N+2) = - TWO
      BL(N+3) = - FOUR
      BU(N+3) = - TWO

      DO 170 J = 1, N
         X(J) = ONE / FLOAT(J)
  170 CONTINUE


*     ------------------------------------------------------------------
*     Read the options file.
*     Add a single option using a call to LSOPTN.
*     ------------------------------------------------------------------

      CALL LSFILE( IOPTNS, INFORM )
      IF (INFORM .NE. 0) THEN
         WRITE (NOUT, 3000) INFORM
         STOP
      END IF

      CALL LSOPTN( 'Infinite Bound size ='//CBGBND )

*     ------------------------------------------------------------------
*     Solve the problem.
*     ------------------------------------------------------------------

      CALL LSSOL ( M, N,
     $             NCLIN, NROWC, NROWA,
     $             C, BL, BU, CVEC,
     $             ISTATE, KX, X, A, B,
     $             INFORM, ITER, OBJ, CLAMDA,
     $             IWORK, LIWORK, WORK, LWORK )

*     Test for an error condition.

      IF (INFORM .GT. 1) GO TO 999

*     ================================================
*     Example 2.  A QP with Hessian bordered by zeros.
*     ================================================
*     Set the new problem dimensions.
*     M      = the number of rows (and columns) of A  (may be 0).
*     N      = the number of variables.
*     NCLIN  = the number of general linear constraints (may be 0).
*     CVEC   = the linear part of the objective function.

         M      = 5
         N      = 9
         NCLIN  = 3
         NBND   = N + NCLIN

         DO 220 J = 1, M
            DO 210 I = 1, J-1
               A(I,J) = ONE
  210       CONTINUE
  220    CONTINUE

         DO 230 I = 1, M
            A(I,I) = TWO
  230    CONTINUE

         DO 260 J = 1, N
            BL(J) = - TWO
            BU(J) =   TWO
  260    CONTINUE

         BL(N+1) = - TWO
         BU(N+1) =   ONEPT5
         BL(N+2) = - TWO
         BU(N+2) =   ONEPT5
         BL(N+3) = - TWO
         BU(N+3) =   FOUR

         DO 270 J = 1, N
            CVEC(J) = - ONE
  270    CONTINUE
         CVEC(1) = - FOUR
         CVEC(8) = - POINT1
         CVEC(9) = - POINT3

         DO 280 J = 1, N
            X(J) = ZERO
  280    CONTINUE


*     ------------------------------------------------------------------
*     Assign some new options.
*     ------------------------------------------------------------------

      CALL LSOPTN( 'Defaults         ' )
      CALL LSOPTN( 'Problem type  QP2' )
      CALL LSOPTN( 'Rank tolerance  =  1.0E-10' )
      CALL LSOPTN( 'Feasibility tolerance = 1.0E-10' )

*     ------------------------------------------------------------------
*     Solve the QP problem.
*     ------------------------------------------------------------------

      CALL LSSOL ( M, N,
     $             NCLIN, NROWC, NROWA,
     $             C, BL, BU, CVEC,
     $             ISTATE, KX, X, A, B,
     $             INFORM, ITER, OBJ, CLAMDA,
     $             IWORK, LIWORK, WORK, LWORK )

*     Test for an error condition.

      IF (INFORM .GT. 1) GO TO 999
      STOP

*     Error condition.

  999 WRITE (NOUT, 3010) INFORM
      STOP

 3000 FORMAT(/ '  LSFILE terminated with  INFORM =', I3)
 3010 FORMAT(/ '  LSSOL  terminated with  INFORM =', I3)

*     End of the example program for LSSOL.

      END

C.hr snpcode4.f
C....*...1.........2.........3.........4.........5.........6.........7.*
C    
C     snpcode4.f
C
C     Copyright (C) 1990.
C
C     A. Ronald Gallant & George E. Tauchen 
C     P.O. Box 5513, Raleigh NC 27650-5513, USA   
C
C     Permission to use, copy, modify, and distribute this
C     software and its documentation for any purpose and
C     without fee is hereby granted, provided that the
C     above copyright notice appear in all copies and that
C     both that copyright notice and this permission notice
C     appear in supporting documentation.
C
C     This software is provided "as is" without any
C     expressed or implied warranty.
C
C....*...1.........2.........3.........4.........5.........6.........7.*
C.hr HYX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     HYX      10/28/86
C
C     PURPOSE
C     COMPUTE AN UNNORMALIZED HERMITE CONDITIONAL DENSITY,
C
C     H(Y|X,THETA)={SUM_J  A(X,J)*[INV(R)*(Y-B0-B*X)]**ALPHA(I)}**2
C                  * N(Y | B0 + B*X, SIGMA)
C
C     AND ITS DERIVATIVE,
C
C     DELH(Y|X,THETA) = (D/D_THETA)H(Y|X,THETA)
C
C     WHERE
C     A(X,J) = SUM_I A(I,J) X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C     THETA = (VEC'(A)|B0'|VEC'(B)|R11,R12,R22,R13,R23,R33,...,RMM)'
C     SIGMA = R*R'
C
C     NOTE
C     R IS UPPER TRIANGULAR, STORED COLUMNWISE IN COMPRESSED FORM,
C     THE FACTOR N(Y | B0 + B*X, SIGMA) IS A VECTOR AUTOREGRESSION
C     (VAR), THE DEPENDENCE OF THE POLYNOMIAL IN Y ON X ACCOMMODATES
C     CONDITIONAL HETEROSKEDASTICITY AND NONLINEARITY
C
C     USAGE
C     CALL HYX(Y,X,H,DELH,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
C
C     SUBROUTINES CALLED
C     DRINV,MULTIY,MULTIX,SETMYX
C
C     ARGUMENTS
C     Y    - M-VECTOR OF CONTEMPORANEOUS VALUES Y_T OF THE TIME SERIES
C            M MUST BE LESS THAN 100
C            INPUT, REAL*8
C     X    - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C            X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C            INPUT, REAL*8
C     H    - COMPUTED VALUE OF THE DENSITY
C            OUTPUT, REAL*8
C     DELH - COMPUTED GRADIENT OF H WITH RESPECT TO THETA, A VECTOR OF
C            LENGTH KX*KY+M+M*M*L+M*(M+1)/2
C            OUTPUT, REAL*8
C     A    - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C            COLUMNWISE
C            INPUT, REAL*8
C     B0   - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C            INPUT, REAL*8
C     B    - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C            STORED COLUMNWISE
C            INPUT, REAL*8
C     R    - AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C            FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE VAR
C            STORED COLUMNWISE, EG. R=(R11,R12,R22,R13,R23,R33,...,RMM)
C            SIGMA=R*R', THIS IS NOT THE STANDARD CHOLESKY FACTORIZATION
C            AS IT IS UPPER TRIANGULAR, NOT LOWER, USE SUBROUTINE FACTOR
C            TO COMPUTE IT FROM SIGMA, GIVEN SIGMA.
C            INPUT, REAL*8
C     M    - DIMENSION OF THE TIME SERIES, IE. LENGTH OF Y_T, MUST BE
C            LESS THAN 100
C            INPUT, INTEGER*4
C     L    - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C            INPUT, INTEGER*4
C     KY   - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     KX   - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY SETMYX,
C            SEE REMARK BELOW.
C            INPUT, INTEGER*4
C     IDEGY- DEGREE OF THE POYNOMIAL IN Y, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     IDEGX- DEGREE OF THE POYNOMIAL IN X, SEE REMARK BELOW
C            INPUT, INTEGER*4
C     WORK - WORK VECTOR OF LENGTH 1+M+M*(M+1)/2+M+M. ON RETURN CONTAINS
C            ( N(Y|B0+B*X,SIGMA) | (Y-B0-B*X)'INV(SIGMA) | INV(R) |
C            (Y-B0-B*X)'INV(R') | (D/DZ')P )
C            REAL*8
C
C     REMARK
C     THE CALL
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     MUST PRECEDE USAGE OF THIS ROUTINE
C
      SUBROUTINE HYX(Y,X,H,DELH,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y(1),X(1),DELH(1)
      REAL*8 A(1),B0(1),B(1),R(1)
      REAL*8 WORK(1)
      INTEGER*4 ALPHA(100),BETA(100)
      SAVE
C
C     LOGICAL:
C     REAL*8 Y(M),X(M*L),DELH(KX*KY+M+M*M*L+M*(M+1)/2+1)
C     REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
C     INTEGER*4 ALPHA(M),BETA(M*L)
C     OR:
C     REAL*8 Y(M),X(M,L),A(KX,KY)
C
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(M*L.GT.100)) THEN
      WRITE(3,3002)
      RETURN
      ENDIF
C
C     COMPUTE POINTERS TO STACKED PARAMETER VECTOR, USED TO POINT TO
C     ELEMENTS OF DELH=(D/DTHETA)H(Y|X,THETA)
C
      IBA  = 0
      IBB0 = IBA +KX*KY
      IBB  = IBB0+M
      IBR  = IBB +M*M*L
      LTHETA=IBR +M*(M+1)/2
C
      IAA  = IBA +1
      IAB0 = IBB0+1
      IAB  = IBB +1
      IAR  = IBR +1
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBN   =0
      IBSZ  =IBN   +1
      IBRINV=IBSZ  +M
      IBZ   =IBRINV+M*(M+1)/2
      IBDZP =IBZ   +M
      LWORK =IBDZP +M
C

      IAN   =IBN   +1
      IASZ  =IBSZ  +1
      IARINV=IBRINV+1
      IAZ   =IBZ   +1
      IADZP =IBDZP +1
C
C     COMPUTE LENGTHS OF VARIOUS ARRAYS
C
      LA=KY*KX
      LR=M*(M+1)/2
      ML=M*L
C
C     INITIALIZE DELH TO ZERO
C
      DO 10 I=1,LTHETA
10    DELH(IBA+I)=0.D0
C
C     COMPUTE Z=INV(R)(Y-B0-B*X)
C
      DO 20 I=1,M
20    WORK(IBSZ+I)=Y(I)-B0(I)
      DO 30 J=1,ML
      DO 30 I=1,M
30    WORK(IBSZ+I)=WORK(IBSZ+I)-B(M*(J-1)+I)*X(J)
      DO 40 I=1,LR
40    WORK(IBRINV+I)=R(I)
      CALL DRINV(WORK(IARINV),M)
      DO 50 I=1,M
50    WORK(IBZ+I)=0.D0
      DO 60 J=1,M
      DO 60 I=1,J
60    WORK(IBZ+I)=WORK(IBZ+I)+WORK(IBRINV+J*(J-1)/2+I)*WORK(IBSZ+J)
C
C     COMPUTE P, (D/DA)P, AND (D/DZ)P
C
C     INITIALIZE ACCUMULATORS FOR P AND (D/DZ)P
      P=0.D0
      DO 100 I=1,M
100   WORK(IBDZP+I)=0.D0
C     LOOP 160 ACCUMULATES MONOMIALS TO GET P AND (D/DZ)P;
C     IT ALSO PUTS THEM IN DELH TO GET (D/DA)P
      DO 160 IALPHA=1,KY
C        GET EXPONANT FOR MONOMIAL YALPHA
         CALL MULTIY(IALPHA,ALPHA)
C        INITIALIZE ACCUMULATORS FOR YALPHA AND (D/DZ)YALPHA
         Y1=1.D0
         Y2=1.D0
         DO 105 I=1,M
105      WORK(IBSZ+I)=ALPHA(I)
C        LOOP 115 ACCUMULATES DEGREE ONE FACTORS, IF ANY
         DO 115 I=1,M
         IF (ALPHA(I).GT.0) THEN
         Y1=Y1*WORK(IBZ+I)
         DO 110 J=1,M
110      IF (I.NE.J) WORK(IBSZ+J)=WORK(IBSZ+J)*WORK(IBZ+I)
         ENDIF
115      CONTINUE
C        LOOPS 120 & 130 ACCUMULATE HIGHER ORDER FACTORS, IF ANY
         DO 120 I=1,M
         NTIMES=ALPHA(I)-1
120      IF(NTIMES.GT.0) Y2=Y2*(WORK(IBZ+I)**NTIMES)
         YALPHA=Y1*Y2
         DO 130 I=1,M
130      WORK(IBSZ+I)=WORK(IBSZ+I)*Y2
      DO 160 IBETA=1,KX
C        GET EXPONANT FOR MONOMIAL XBETA
         CALL MULTIX(IBETA,BETA)
C        INITIALIZE ACCUMULATOR
         XBETA=1.D0
C        ACCUMULATE
         DO 140 I=1,ML
140      IF (BETA(I).GT.0) XBETA=XBETA*(X(I)**BETA(I))
C     ACCUMULATE THE MONOMIALS TO GET THE POLYNOMIAL P & (D/DZ)P
      P=P+A(KX*(IALPHA-1)+IBETA)*XBETA*YALPHA
      DO 150 I=1,M
150   WORK(IBDZP+I)=WORK(IBDZP+I)
     &             +A(KX*(IALPHA-1)+IBETA)*XBETA*WORK(IBSZ+I)
C     PUT THE MONOMIALS IN PROPER LOCATIONS TO GET (D/DA)P
      DELH(IBA+KX*(IALPHA-1)+IBETA)=XBETA*YALPHA
160   CONTINUE
C
C     COMPUTE:
C     (D/DB0')P = [(D/DZ')P]*(-1)*INV(R)
C     (D/DB')P = [(D/DZ')P]*(-1)*INV(R)*(X'@I)
C        WHERE @ DENOTES KRONEKER PRODUCT
C     (D/DR_IJ)P
C        =[(D/DZ')P]*(-1)*INV(R)*T(IJ)*INV(R)*(Y-B0-B*X)
C        WHERE T(IJ) HAS A ONE IN THE IJ_TH ELEMENT AND ZEROES ELSEWHERE
C
      DO 165 I=1,M
165   WORK(IBSZ+I)=0.D0
      DO 170 J=1,M
      DO 170 I=1,J
170   WORK(IBSZ+J)=WORK(IBSZ+J)+WORK(IBRINV+J*(J-1)/2+I)*WORK(IBDZP+I)
      DO 180 I=1,M
180   DELH(IBB0+I)=-WORK(IBSZ+I)
      DO 190 J=1,ML
      DO 190 I=1,M
      IJ=M*(J-1)+I
190   DELH(IBB+IJ)=-X(J)*WORK(IBSZ+I)
      DO 195 J=1,M
      DO 195 I=1,J
      IJ=J*(J-1)/2+I
195   DELH(IBR+IJ)=-WORK(IBSZ+I)*WORK(IBZ+J)
C
C     COMPUTE P**2 AND (D/DTHETA)(P**2)
C
      DO 250 I=1,LTHETA
250   DELH(IBA+I)=2.D0*P*DELH(IBA+I)
      P2 =P*P

C
C     COMPUTE DABS[1/DET(R)] AND (D/DTHETA)DABS[1/DET(R)]
C
      DETR=1.D0
      DO 260 I=1,M
260   DETR=DETR*R(I*(I-1)/2+I)
      DETR=DABS(DETR)
      SR=1.D0/DETR
      DELSR=-SR*SR
      DO 270 I=1,M
      IJ=I*(I-1)/2+I
      DELH(IBR+IJ)=DELH(IBR+IJ)+(P2/SR)*DELSR*DETR/R(IJ)
270   CONTINUE
C
C     COMPUTE P**2*DABS[1/DET(R)] AND ADJUST DERIVATIVES
C
      H=P2*SR
      DO 280 I=1,LTHETA
280   DELH(IBA+I)=DELH(IBA+I)*SR
C
C     COMPUTE EXP(Q) = EXP[(-1/2)(Y-B0-B*X)'INV(R')INV(R)(Y-B0-B*X)]
C        AND (D/DTHETA)EXP(Q)
C     (D/DB0')EXP(Q)=EXP(Q)(Y-B0-B*X)'*INV'(R)*INV(R)
C     (D/DB')EXP(Q) =EXP(Q)(Y-B0-B*X)'*INV'(R)*INV(R)*(X'@I)
C        WHERE @ DENOTES KRONEKER PRODUCT
C     (D/DR_IJ)EXP(Q)
C        =EXP(Q)[INV(R)*(Y-B0-B*X)]'*INV(R)*T(IJ)*[INV(R)*(Y-B0-B*X)]
C        WHERE T(IJ) HAS A ONE IN THE IJ_TH ELEMENT AND ZEROES ELSEWHERE
C
      Q=0.D0
      DO 350 I=1,M
350   Q=Q+WORK(IBZ+I)**2
      Q=-0.5D0*Q
      EXPQ=DEXP(Q)
      DO 360 I=1,M
360   WORK(IBSZ+I)=0.D0
      DO 370 J=1,M
      DO 370 I=1,J
370   WORK(IBSZ+J)=WORK(IBSZ+J)+WORK(IBRINV+J*(J-1)/2+I)*WORK(IBZ+I)
      DO 380 I=1,M
380   DELH(IBB0+I)=EXPQ*DELH(IBB0+I)+H*EXPQ*WORK(IBSZ+I)
      DO 390 J=1,ML
      DO 390 I=1,M
      IJ=M*(J-1)+I
390   DELH(IBB+IJ)=EXPQ*DELH(IBB+IJ)+H*EXPQ*X(J)*WORK(IBSZ+I)
      DO 395 J=1,M
      DO 395 I=1,J
      IJ=J*(J-1)/2+I
395   DELH(IBR+IJ)=EXPQ*DELH(IBR+IJ)+H*EXPQ*WORK(IBSZ+I)*WORK(IBZ+J)
C
C     COMPUTE P**2*DABS[1/DET(R)]*EXP(Q) AND ADJUST DERIVATIVES
C
      H=H*EXPQ
      DO 420 I=1,LA
420   DELH(IBA+I)=EXPQ*DELH(IBA+I)
C
C     COMPUTE H=P**2*DEXP[1/DET(R)]*EXP(Q)*{DSQRT[1/(2*PI)]}**M
C     AND ADJUST DERIVATIVES
C
      TWOPI=8.D0*DATAN(1.D0)
      SCALE=(1.D0/DSQRT(TWOPI))**M
      H=SCALE*H
      DO 430 I=1,LTHETA
430   DELH(IBA+I)=SCALE*DELH(IBA+I)
C
      WORK(IAN)=SCALE*SR*EXPQ
C
      RETURN
3002  FORMAT(' ERROR RETURN FROM HYX, M OR M*L EXCEEDS 100')
      END
C.hr RESID
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     RESID    12/17/87
C
C     PURPOSE
C     COMPUTE A NORMALIZED RESIDUAL FROM A HERMITE CONDITIONAL DENSITY
C
C     RES = INV{HALF[VAR(Y|X)]}[Y-E(Y|X)]
C         = INV(P)[INV(R)(Y-B0-B*X)-E(Z|X)]
C
C     AND ITS DERIVATIVE
C
C     DER = (D/D_THETA)RES
C
C     WHERE
C     THE DENSITIES DEFINING EXPECTATIONS ARE:
C     H(Y|X,THETA)= [SUM_J  A(X,J)*[INV(R)(Y-B0-B*X)]**ALPHA(I)]**2
C                     * N(Y | B0 + B*X, SIGMA)/INTEGRAL_OF_NUMERATOR
C     H(Z|X,THETA)= [SUM_J  A(X,J)*Z**ALPHA(I)]**2
C                     * N(Z | 0, I)/INTEGRAL_OF_NUMERATOR
C     A(X,J) = SUM_I A(I,J) X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C     THETA = (VEC'(A)|B0|VEC'(B)|R11,R12,R22,R13,R23,R33,...,RMM)'
C     SIGMA = R*R'
C     VAR(Z|X) = E[Z-E(Z|X)][Z-E(Z|X)]' = P*P'
C
C     NOTE
C     R IS UPPER TRIANGULAR, STORED COLUMNWISE IN COMPRESSED FORM,
C     THE FACTOR N(Y | B0 + B*X, SIGMA) IS A VECTOR AUTOREGRESSION
C     (VAR), THE DEPENDENCE OF THE POLYNOMIAL IN Y ON X ACCOMMODATES
C     CONDITIONAL HETEROSKEDASTICITY AND NONLINEARITY
C
C     USAGE
C     CALL RESID(Y,X,RES,DER,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,IWORK)
C
C     SUBROUTINES CALLED
C     MULTIY,MULTIX,SETMYX,SETUPM,DRINV,FACTOR,EHYX,EYLX
C
C     ARGUMENTS
C     Y     - M-VECTOR CONTAINING OBSERVED VALUE OF Y
C             INPUT, REAL*8
C     X     - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C             X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C             INPUT, REAL*8
C     RES   - COMPUTED RESIDUAL, AN M-VECTOR
C             OUTPUT, REAL*8
C     DER   - COMPUTED JACOBIAN OF RES WITH RESPECT TO THETA, AN M BY
C             LTHETA MATRIX WHERE LTHETA=KX*KY+M+M*M*L+M*(M+1)/2,
C             STORED COLUMNWISE.
C             OUTPUT, REAL*8
C     A     - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C             COLUMNWISE.
C             INPUT, REAL*8
C     B0    - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C             INPUT, REAL*8
C     B     - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C             STORED COLUMNWISE.
C             INPUT, REAL*8
C     R     - AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C             CHOLESKY FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE
C             VAR STORED COLUMNWISE, R=(R11,R12,R22,R13,R23,R33,...,RMM)
C             SIGMA=R*R'
C             INPUT, REAL*8
C     M     - DIMENSION OF THE TIME SERIES, I.E. LENGTH OF Y_T, MUST BE
C             LESS THAN 100
C             INPUT, INTEGER*4
C     L     - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C             INPUT, INTEGER*4
C     KY    - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     KX    - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     IDEGY - DEGREE OF THE POLYNOMIAL IN Y, MUST BE LESS THAN 16, SEE
C             REMARK BELOW
C             INPUT, INTEGER*4
C     IDEGX - DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C             INPUT, INTEGER*4
C     WORK  - WORK VECTOR OF LENGTH
C             (M+M*(M+1)/2+1)*LTHETA+2*M+MAX0(2*KY,(M*(M+1)/2))
C             +(M*(M+1)/2+1)*(M*(M+1)/2)
C             WORKSPACE, REAL*8
C     IWORK - WORK VECTOR OF LENGTH M
C             WORKSPACE, INTEGER*4
C
C     REMARK
C     THE CALLS:
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     CALL SETUPM(IDEGY,M,KY)
C     MUST PRECEDE USAGE OF THIS ROUTINE, IN THAT ORDER
C
C
      SUBROUTINE
     &   RESID(Y,X,RES,DER,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,IWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y(1),X(1),DER(1),RES(1)
      REAL*8 A(1),B0(1),B(1),R(1)
      REAL*8 WORK(1)
      INTEGER*4 IWORK(1)
      SAVE
C
C     LOGICAL:
C     REAL*8 Y(M),X(M*L),DER(M,KX*KY+M+M*M*L+M*(M+1)/2+1)
C     REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
C     OR:
C     REAL*8 Y(M),X(M,L),A(KX,KY)
C
      IOUT=3
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(M*L.GT.100)) THEN
      WRITE(IOUT,3002)
      RETURN
      ENDIF
C
C     COMPUTE POINTERS TO STACKED PARAMETER VECTOR, USED TO POINT TO
C     ELEMENTS OF DER=(D/D_THETA)RES
C
      IBA  = 0
      IBB0 = IBA +KX*KY
      IBB  = IBB0+M
      IBR  = IBB +M*M*L
      LTHETA=IBR +M*(M+1)/2
C
      IAA  = IBA +1
      IAB0 = IBB0+1
      IAB  = IBB +1
      IAR  = IBR +1
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBDMU =0
      IBDP  =IBDMU +M*LTHETA
      IBBOT =IBDP  +(M*(M+1)/2)*LTHETA
      IBZ   =IBBOT +LTHETA
      IBMUZ =IBZ   +M
      IBW   =IBMUZ +M
      IBPINV=IBW   +MAX0(2*KY,(M*(M+1)/2))
      IBS   =IBPINV+M*(M+1)/2
      LWORK =IBS   +(M*(M+1)/2)*(M*(M+1)/2)
C
      IADMU =IBDMU +1
      IADP  =IBDP  +1
      IABOT =IBBOT +1
      IAZ   =IBZ   +1
      IAMUZ =IBMUZ +1
      IAW   =IBW   +1
      IAPINV=IBPINV+1
      IAS   =IBS   +1
C
C     EQUIVALENCED POINTERS
C
      IBRINV=IBPINV
      IBPZ  =IBS
C
      IARINV=IBRINV+1
      IAPZ  =IBPZ  +1
C
C     COMPUTE LENGTHS OF VARIOUS ARRAYS
C
      LA=KY*KX
      LR=M*(M+1)/2
      ML=M*L
C
C     INITIALIZE DER TO ZERO
C
      DO 10 J=1,LTHETA
      DO 10 I=1,M
10    DER(M*(J-1)+I)=0.D0
C
C     COMPUTE Z=INV(R)(Y-B0-B*X)
C
      DO 20 I=1,M
20    RES(I)=Y(I)-B0(I)
      DO 30 J=1,ML
      DO 30 I=1,M
30    RES(I)=RES(I)-B(M*(J-1)+I)*X(J)
      DO 40 I=1,LR
40    WORK(IBRINV+I)=R(I)
      CALL DRINV(WORK(IARINV),M)
      DO 50 I=1,M
50    WORK(IBZ+I)=0.D0
      DO 60 J=1,M
      DO 60 I=1,J
60    WORK(IBZ+I)=WORK(IBZ+I)+WORK(IBRINV+J*(J-1)/2+I)*RES(J)
C
C     COMPUTE:
C
C     (D/DB0')Z  = (-1)*INV(R)
C     (D/DB')Z   = (-1)*INV(R)*(X'@I)
C     (D/DR_IJ)Z = (-1)*INV(R)*T(IJ)*INV(R)*(Y-B0-B*X)
C
C     WHERE
C     @ DENOTES KRONECKER PRODUCT AND
C     T(IJ) HAS A ONE IN THE IJ_TH ELEMENT AND ZEROES ELSEWHERE
C
      DO 70 I=1,M
      DO 70 K=1,I
70    DER(M*(IBB0+I-1)+K)=-WORK(IBRINV+I*(I-1)/2+K)
C
      DO 80 J=1,ML
      DO 80 I=1,M
      IJ=M*(J-1)+I
      DO 80 K=1,I
80    DER(M*(IBB+IJ-1)+K)=-X(J)*WORK(IBRINV+I*(I-1)/2+K)
C
      DO 90 J=1,M
      DO 90 I=1,J
      IJ=J*(J-1)/2+I
      DO 90 K=1,I
90    DER(M*(IBR+IJ-1)+K)=-WORK(IBRINV+I*(I-1)/2+K)*WORK(IBZ+J)
C
C     COMPUTE E(Z|X) AND PUT IT IN MUZ
C     COMPUTE THE TRANSPOSE OF (D/D_THETA)E(Z|X) AND PUT IT IN DMU
C     SUBTRACT E(Z|X) FROM Z AND (D/D_THETA)E(Z|X) FROM DER
C
      CALL EHYX(RES,X,EH,WORK(IABOT),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      DO 140 I=1,M
      DO 110 K=1,M
110   IWORK(K)=0
      IWORK(I)=1
      CALL EYLX(IWORK,RES,X,EYL,WORK(IADMU+LTHETA*(I-1)),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      RATIO=EYL/EH
      WORK(IBMUZ+I)=RATIO
      DO 115 J=1,LTHETA
115   WORK(IBDMU+LTHETA*(I-1)+J)
     &   =(WORK(IBDMU+LTHETA*(I-1)+J)/EH-(RATIO/EH)*WORK(IBBOT+J))
      WORK(IBZ+I)=WORK(IBZ+I)-RATIO
      DO 120 J=1,LTHETA
120   DER(M*(J-1)+I)=DER(M*(J-1)+I)-WORK(IBDMU+LTHETA*(I-1)+J)
140   CONTINUE
C
C     COMPUTE E(ZZ'|X)-E(Z|X)E(Z'|X), PUT IT IN PINV
C
C     COMPUTE THE TRANSPOSE OF (D/D_THETA)[E(ZZ'|X)-E(Z|X)E(Z'|X)]
C     AND PUT IT IN DP
C
      DO 160 J=1,M
      DO 160 I=1,J
      IJ=J*(J-1)/2+I
      DO 150 K=1,M
150   IWORK(K)=0
      IWORK(I)=1
      IWORK(J)=IWORK(J)+1
      CALL EYLX(IWORK,RES,X,EYL,WORK(IADP+LTHETA*(IJ-1)),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      WORK(IBS+IJ)=EYL/EH
      WORK(IBPINV+IJ)=EYL/EH-WORK(IBMUZ+I)*WORK(IBMUZ+J)
160   CONTINUE
C
      DO 165 J=1,M
      DO 165 I=1,J
      IJ=J*(J-1)/2+I
      DO 165 K=1,LTHETA
      WORK(IBDP+LTHETA*(IJ-1)+K)
     &   =WORK(IBDP+LTHETA*(IJ-1)+K)/EH
     &      -(WORK(IBS+IJ)/EH)*WORK(IBBOT+K)
     &      -WORK(IBMUZ+I)*WORK(IBDMU+LTHETA*(J-1)+K)
     &      -WORK(IBMUZ+J)*WORK(IBDMU+LTHETA*(I-1)+K)
165   CONTINUE
C
C     FACTOR E(ZZ'|X)-E(Z|X)E(Z'|X)=PP', INVERT P, PUT RESULT IN PINV
C     COMPUTE (D/D_THETA)P, PUT RESULT IN DP
C
      CALL FACTOR(WORK(IAPINV),WORK(IAS),M,1.D-13,IER)
      IF (IER.LT.0) THEN
      WRITE(IOUT,3003) IER
      RETURN
      ENDIF
      CALL DRINV(WORK(IAPINV),M)
C
      DO 174 J=1,LTHETA
      DO 171 I=1,LR
171   WORK(IBW+I)=0.D0
      DO 172 I=1,LR
      DO 172 K=1,LR
172   WORK(IBW+I)=WORK(IBW+I)
     &            +WORK(IBS+LR*(K-1)+I)*WORK(IBDP+LTHETA*(K-1)+J)
      DO 173 I=1,LR
173   WORK(IBDP+LTHETA*(I-1)+J)=WORK(IBW+I)
174   CONTINUE
C
C     COMPUTE (PINV)Z AND PUT IT IN PZ
C
      DO 175 I=1,M
175   WORK(IBPZ+I)=0.D0
      DO 177 J=1,M
      DO 177 I=1,J
177   WORK(IBPZ+I)=WORK(IBPZ+I)+WORK(IBPINV+J*(J-1)/2+I)*WORK(IBZ+J)
C
C     PUT DER TO (PINV)DER
C
      DO 184 K=1,LTHETA
      DO 181 I=1,M
181   RES(I)=0.D0
      DO 182 J=1,M
      DO 182 I=1,J
182   RES(I)=RES(I)+WORK(IBPINV+J*(J-1)/2+I)*DER(M*(K-1)+J)
      DO 183 I=1,M
183   DER(M*(K-1)+I)=RES(I)
184   CONTINUE
C
C     ADD [(D/D_VECP)(INVP*Z)]*(D/D_THETA)VECP TO DER
C
      DO 196 JJ=1,LTHETA
      DO 190 K=1,M
190   RES(K)=0.D0
      DO 192 J=1,M
      DO 192 I=1,J
      IJ=J*(J-1)/2+I
      DO 192 K=1,I
192   RES(K)=RES(K)
     &   -WORK(IBPINV+I*(I-1)/2+K)*WORK(IBPZ+J)
     &      *WORK(IBDP+LTHETA*(IJ-1)+JJ)
      DO 194 K=1,M
194   DER(M*(JJ-1)+K)=DER(M*(JJ-1)+K)+RES(K)
196   CONTINUE
C
C     PUT PZ IN RES
C
      DO 198 I=1,M
198   RES(I)=WORK(IBPZ+I)
C
      RETURN
3002  FORMAT(' ERROR RETURN FROM RESID, M OR M*L EXCEEDS 100')
3003  FORMAT(' ERROR RETURN FROM RESID, FACTOR RETURNED IER =',I5)
      END
C.hr MEAN
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     MEAN     12/17/87
C
C     PURPOSE
C     COMPUTE THE MEAN OF A HERMITE CONDITIONAL DENSITY
C
C     EY = E(Y|X)
C        = B0 + B*X + R*E(Z|X)
C
C     AND ITS DERIVATIVE
C
C     DER = (D/D_THETA)MEAN
C
C     WHERE
C     THE DENSITIES DEFINING EXPECTATIONS ARE:
C     H(Y|X,THETA)= [SUM_J  A(X,J)*[INV(R)(Y-B0-B*X)]**ALPHA(I)]**2
C                     * N(Y | B0 + B*X, SIGMA)/INTEGRAL_OF_NUMERATOR
C     H(Z|X,THETA)= [SUM_J  A(X,J)*Z**ALPHA(I)]**2
C                     * N(Z | 0, I)/INTEGRAL_OF_NUMERATOR
C     A(X,J) = SUM_I A(I,J) X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C     THETA = (VEC'(A)|B0|VEC'(B)|R11,R12,R22,R13,R23,R33,...,RMM)'
C     SIGMA = R*R'
C
C     NOTE
C     R IS UPPER TRIANGULAR, STORED COLUMNWISE IN COMPRESSED FORM,
C     THE FACTOR N(Y | B0 + B*X, SIGMA) IS A VECTOR AUTOREGRESSION
C     (VAR), THE DEPENDENCE OF THE POLYNOMIAL IN Y ON X ACCOMMODATES
C     CONDITIONAL HETEROSKEDASTICITY AND NONLINEARITY
C
C     USAGE
C     CALL MEAN(Y,X,EY,DER,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,IWORK)
C
C     SUBROUTINES CALLED
C     MULTIY,MULTIX,SETMYX,SETUPM,EHYX,EYLX
C
C     ARGUMENTS
C     Y     - M-VECTOR CONTAINING OBSERVED VALUE OF Y
C             WORKSPACE, REAL*8
C     X     - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C             X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C     EY    - COMPUTED MEAN, AN M-VECTOR
C             OUTPUT, REAL*8
C     DER   - COMPUTED JACOBIAN OF EY WITH RESPECT TO THETA, AN M BY
C             LTHETA MATRIX WHERE LTHETA=KX*KY+M+M*M*L+M*(M+1)/2,
C             STORED COLUMNWISE.
C             OUTPUT, REAL*8
C     A     - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C             COLUMNWISE.
C             INPUT, REAL*8
C     B0    - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C             INPUT, REAL*8
C     B     - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C             STORED COLUMNWISE.
C             INPUT, REAL*8
C     R     - AN M*(M+1)/2-VECTOR CONTAINING THE UPPER TRIANGLE OF THE
C             CHOLESKY FACTOR OF THE VARIANCE-COVARIANCE MATRIX OF THE
C             VAR STORED COLUMNWISE, R=(R11,R12,R22,R13,R23,R33,...,RMM)
C             SIGMA=R*R'
C             INPUT, REAL*8
C     M     - DIMENSION OF THE TIME SERIES, I.E. LENGTH OF Y_T, MUST BE
C             LESS THAN 100
C             INPUT, INTEGER*4
C     L     - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C             INPUT, INTEGER*4
C     KY    - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     KX    - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     IDEGY - DEGREE OF THE POLYNOMIAL IN Y, MUST BE LESS THAN 16, SEE
C             REMARK BELOW
C             INPUT, INTEGER*4
C     IDEGX - DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C             INPUT, INTEGER*4
C     WORK  - WORK VECTOR OF LENGTH
C             (M+1)*LTHETA+M+MAX0(2*KY,(M*(M+1)/2))
C             WORKSPACE, REAL*8
C     IWORK - WORK VECTOR OF LENGTH M
C             WORKSPACE, INTEGER*4
C
C     REMARK
C     THE CALLS:
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     CALL SETUPM(IDEGY,M,KY)
C     MUST PRECEDE USAGE OF THIS ROUTINE, IN THAT ORDER
C
C
      SUBROUTINE
     &   MEAN(Y,X,EY,DER,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,IWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y(1),X(1),DER(1),EY(1)
      REAL*8 A(1),B0(1),B(1),R(1)
      REAL*8 WORK(1)
      INTEGER*4 IWORK(1)
      SAVE
C
C     LOGICAL:
C     REAL*8 Y(M),X(M*L),DER(M,KX*KY+M+M*M*L+M*(M+1)/2+1)
C     REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
C     OR:
C     REAL*8 Y(M),X(M,L),A(KX,KY)
C
      IOUT=3
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(M*L.GT.100)) THEN
      WRITE(IOUT,3002)
      RETURN
      ENDIF
C
C     COMPUTE POINTERS TO STACKED PARAMETER VECTOR, USED TO POINT TO
C     ELEMENTS OF DER=(D/D_THETA)EY
C
      IBA  = 0
      IBB0 = IBA +KX*KY
      IBB  = IBB0+M
      IBR  = IBB +M*M*L
      LTHETA=IBR +M*(M+1)/2
C
      IAA  = IBA +1
      IAB0 = IBB0+1
      IAB  = IBB +1
      IAR  = IBR +1
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBDMU =0
      IBBOT =IBDMU +M*LTHETA
      IBMUZ =IBBOT +LTHETA
      IBW   =IBMUZ +M
      LWORK =IBW   +MAX0(2*KY,(M*(M+1)/2))
C
      IADMU =IBDMU +1
      IABOT =IBBOT +1
      IAMUZ =IBMUZ +1
      IAW   =IBW   +1
C
C     COMPUTE LENGTHS OF VARIOUS ARRAYS
C
      ML=M*L
C
C     INITIALIZE DER TO ZERO
C
      DO 10 J=1,LTHETA
      DO 10 I=1,M
10    DER(M*(J-1)+I)=0.D0
C
C     PUT EY = B0+B*X
C
      DO 20 I=1,M
20    EY(I)=B0(I)
      DO 30 J=1,ML
      DO 30 I=1,M
30    EY(I)=EY(I)+B(M*(J-1)+I)*X(J)
C
C     PUT DER = [(D/DB0')(B0+B*X)|(D/DB')(B0+B*X)]
C             = [ I | (X'@I) ]
C
      DO 70 I=1,M
70    DER(M*(IBB0+I-1)+I)=1.D0
C
      DO 80 J=1,ML
      IPTR=M*IBB+M*M*(J-1)
      DO 80 I=1,M
80    DER(IPTR+M*(I-1)+I)=X(J)
C
C     COMPUTE E(Z|X) AND PUT IT IN MUZ
C     COMPUTE THE TRANSPOSE OF (D/D_THETA)E(Z|X) AND PUT IT IN DMU
C
      CALL EHYX(Y,X,EH,WORK(IABOT),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      DO 140 I=1,M
      DO 110 K=1,M
110   IWORK(K)=0
      IWORK(I)=1
      CALL EYLX(IWORK,Y,X,EYL,WORK(IADMU+LTHETA*(I-1)),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      RATIO=EYL/EH
      WORK(IBMUZ+I)=RATIO
      DO 115 J=1,LTHETA
115   WORK(IBDMU+LTHETA*(I-1)+J)
     &   =(WORK(IBDMU+LTHETA*(I-1)+J)/EH-(RATIO/EH)*WORK(IBBOT+J))
140   CONTINUE
C
C     ADD R*E(Z|X) TO EY
C
      DO 150 J=1,M
      DO 150 I=1,J
      IJ=J*(J-1)/2+I
150   EY(I)=EY(I)+R(IJ)*WORK(IBMUZ+J)
C
C     ADD (D/D_R)(R*E) EVALUATED AT E = E(Z|X) TO DER
C
      DO 160 J=1,M
      IPTR=M*IBR+M*(J*(J-1)/2)
      DO 160 I=1,J
160   DER(IPTR+M*(I-1)+I)=DER(IPTR+M*(I-1)+I)+WORK(IBMUZ+J)
C
C     ADD R[(D/D_THETA)E(Z|X)] TO DER
C
      DO 170 K=1,LTHETA
      DO 170 J=1,M
      DO 170 I=1,J
      IJ=J*(J-1)/2+I
170   DER(M*(K-1)+I)
     &   =DER(M*(K-1)+I)+R(IJ)*WORK(IBDMU+LTHETA*(J-1)+K)
C
      RETURN
3002  FORMAT(' ERROR RETURN FROM MEAN, M OR M*L EXCEEDS 100')
      END
C.hr VARCOV
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     VARCOV   12/17/87
C
C     PURPOSE
C     COMPUTE THE VARIANCE-COVARIANCE MATRIX OF A HERMITE CONDITIONAL
C     DENSITY
C
C     VAR = VAR(Y|X)
C         = R*VAR(Z|X)*R'
C
C     AND ITS DERIVATIVE
C
C     DER = (D/D_THETA)VARCOV
C
C     WHERE
C     THE DENSITIES DEFINING EXPECTATIONS ARE:
C     H(Y|X,THETA)= [SUM_J  A(X,J)*[INV(R)(Y-B0-B*X)]**ALPHA(I)]**2
C                     * N(Y | B0 + B*X, SIGMA)/INTEGRAL_OF_NUMERATOR
C     H(Z|X,THETA)= [SUM_J  A(X,J)*Z**ALPHA(I)]**2
C                     * N(Z | 0, I)/INTEGRAL_OF_NUMERATOR
C     A(X,J) = SUM_I A(I,J) X**BETA(I), I = 1, ..., KX, J = 1, ..., KY
C     THETA = (VEC'(A)|B0|VEC'(B)|R11,R12,R22,R13,R23,R33,...,RMM)'
C     SIGMA = R*R'
C     VAR(Z|X) = E[Z-E(Z|X)][Z-E(Z|X)]' = P*P'
C
C     NOTE
C     R IS UPPER TRIANGULAR, STORED COLUMNWISE IN COMPRESSED FORM,
C     THE FACTOR N(Y | B0 + B*X, SIGMA) IS A VECTOR AUTOREGRESSION
C     (VAR), THE DEPENDENCE OF THE POLYNOMIAL IN Y ON X ACCOMMODATES
C     CONDITIONAL HETEROSKEDASTICITY AND NONLINEARITY
C
C     USAGE
C     CALL VARCOV(Y,X,VAR,DER,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,IWORK)
C
C     SUBROUTINES CALLED
C     MULTIY,MULTIX,SETMYX,SETUPM,EHYX,EYLX
C
C     ARGUMENTS
C     Y     - M-VECTOR CONTAINING OBSERVED VALUE OF Y
C             WORKSPACE, REAL*8
C     X     - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END
C             X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE LESS THAN 100
C     VAR   - COMPUTED UPPER TRIANGLE OF THE VARIANCE-COVARIANCE MATRIX,
C             STORED AS AN LR-VECTOR WHERE LR=M*(M+1)/2. THE ORDERING IS
C             VAR=(V11,V12,V22,V13,V23,V33,...,VMM).
C             OUTPUT, REAL*8
C     DER   - COMPUTED JACOBIAN OF VAR WITH RESPECT TO THETA, AN LR BY
C             LTHETA MATRIX WHERE LTHETA=KX*KY+M+M*M*L+M*(M+1)/2,
C             STORED COLUMNWISE.
C             OUTPUT, REAL*8
C     A     - COEFFICIENTS OF THE POLYNOMIAL, A KX BY KY MATRIX, STORED
C             COLUMNWISE.
C             INPUT, REAL*8
C     B0    - M-VECTOR OF COEFFICIENTS, THE CONSTANT TERM OF THE VAR
C             INPUT, REAL*8
C     B     - COEFFICIENTS FOR THE REGRESSION ON X, AN M BY M*L MATRIX,
C             STORED COLUMNWISE.
C             INPUT, REAL*8
C     R     - AN LR-VECTOR CONTAINING THE UPPER TRIANGLE OF THE CHOLESKY
C             FACTOR OF THE VARIANCE-COVARIANCE MATRIX SIGMA=R*R' OF THE
C             VAR PART OF THE DENSITY STORED COLUMNWISE,
C             R=(R11,R12,R22,R13,R23,R33,...,RMM)
C             INPUT, REAL*8
C     M     - DIMENSION OF THE TIME SERIES, I.E. LENGTH OF Y_T, MUST BE
C             LESS THAN 100
C             INPUT, INTEGER*4
C     L     - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100
C             INPUT, INTEGER*4
C     KY    - NUMBER OF TERMS IN THE POLYNOMIAL IN Y, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     KX    - NUMBER OF TERMS IN THE POLYNOMIAL IN X, COMPUTED BY
C             SETMYX, SEE REMARK BELOW.
C             INPUT, INTEGER*4
C     IDEGY - DEGREE OF THE POLYNOMIAL IN Y, MUST BE LESS THAN 16, SEE
C             REMARK BELOW
C             INPUT, INTEGER*4
C     IDEGX - DEGREE OF THE POLYNOMIAL IN X, SEE REMARK BELOW
C             INPUT, INTEGER*4
C     WORK  - WORK VECTOR OF LENGTH
C             M*M*(LTHETA+1)+LTHETA+MAX0(2*KY,(M*(M+1)/2))+M*(M+1)/2
C             WORKSPACE, REAL*8
C     IWORK - WORK VECTOR OF LENGTH M
C             WORKSPACE, INTEGER*4
C
C     REMARK
C     THE CALLS:
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,KY,KX,IDUMMY,IWORK)
C     CALL SETUPM(IDEGY,M,KY)
C     MUST PRECEDE USAGE OF THIS ROUTINE, IN THAT ORDER
C
C
      SUBROUTINE
     &   VARCOV(Y,X,VAR,DER,A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK,IWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Y(1),X(1),DER(1),VAR(1)
      REAL*8 A(1),B0(1),B(1),R(1)
      REAL*8 WORK(1)
      INTEGER*4 ROW,COL,IWORK(1)
      SAVE
C
C     LOGICAL:
C     REAL*8 Y(M),X(M*L),DER(LR,KX*KY+M+M*M*L+M*(M+1)/2+1)
C     REAL*8 A(KX*KY),B0(M),B(M,M*L),R(M*(M+1)/2)
C     OR:
C     REAL*8 Y(M),X(M,L),A(KX,KY)
C
      IOUT=3
C
C     ERROR TRAP
C
      IF ((M.GT.100).OR.(M*L.GT.100)) THEN
      WRITE(IOUT,3002)
      RETURN
      ENDIF
C
C     COMPUTE POINTERS TO STACKED PARAMETER VECTOR, USED TO POINT TO
C     ELEMENTS OF DER=(D/D_THETA)VAR
C
      IBA  = 0
      IBB0 = IBA +KX*KY
      IBB  = IBB0+M
      IBR  = IBB +M*M*L
      LTHETA=IBR +M*(M+1)/2
C
      IAA  = IBA +1
      IAB0 = IBB0+1
      IAB  = IBB +1
      IAR  = IBR +1
C
C     COMPUTE POINTERS TO WORK VECTOR
C
      IBGV  =0
      IBGD  =IBGV  +M*M
      IBBOT =IBGD  +M*M*LTHETA
      IBW   =IBBOT +LTHETA
      IBS   =IBW   +MAX0(2*KY,(M*(M+1)/2))
      LWORK =IBS   +M*(M+1)/2
C
      IAGV  =IBGV  +1
      IAGD  =IBGD  +1
      IABOT =IBBOT +1
      IAW   =IBW   +1
      IAS   =IBS   +1
C
C     EQUIVALENCED POINTERS
C
      IBMUZ =IBGV
      IBDMU =IBGD
C
      IAMUZ =IBMUZ +1
      IADMU =IBDMU +1
C
C     COMPUTE LENGTHS OF VARIOUS ARRAYS
C
      LA=KY*KX
      LR=M*(M+1)/2
      ML=M*L
      LGV=M*M
C
C     COMPUTE E(Z|X) AND PUT IT IN MUZ
C     COMPUTE THE TRANSPOSE OF (D/D_THETA)E(Z|X) AND PUT IT IN DMU
C
      CALL EHYX(Y,X,EH,WORK(IABOT),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      DO 140 I=1,M
      DO 110 K=1,M
110   IWORK(K)=0
      IWORK(I)=1
      CALL EYLX(IWORK,Y,X,EYL,WORK(IADMU+LTHETA*(I-1)),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      RATIO=EYL/EH
      WORK(IBMUZ+I)=RATIO
      DO 115 J=1,LTHETA
115   WORK(IBDMU+LTHETA*(I-1)+J)
     &   =(WORK(IBDMU+LTHETA*(I-1)+J)/EH-(RATIO/EH)*WORK(IBBOT+J))
140   CONTINUE
C
C     COMPUTE E(ZZ'|X)-E(Z|X)E(Z'|X), PUT IT IN VAR
C
C     COMPUTE THE TRANSPOSE OF (D/D_THETA)[E(ZZ'|X)-E(Z|X)E(Z'|X)]
C     AND PUT IT IN DER
C
      DO 160 J=1,M
      DO 160 I=1,J
      IJ=J*(J-1)/2+I
      DO 150 K=1,M
150   IWORK(K)=0
      IWORK(I)=1
      IWORK(J)=IWORK(J)+1
      CALL EYLX(IWORK,Y,X,EYL,DER(LTHETA*(IJ-1)+1),
     &   A,B0,B,R,M,L,KY,KX,IDEGY,IDEGX,WORK(IAW))
      WORK(IBS+IJ)=EYL/EH
      VAR(IJ)=EYL/EH-WORK(IBMUZ+I)*WORK(IBMUZ+J)
160   CONTINUE
C
      DO 165 J=1,M
      DO 165 I=1,J
      IJ=J*(J-1)/2+I
      DO 165 K=1,LTHETA
      DER(LTHETA*(IJ-1)+K)
     &   =DER(LTHETA*(IJ-1)+K)/EH
     &      -(WORK(IBS+IJ)/EH)*WORK(IBBOT+K)
     &      -WORK(IBMUZ+I)*WORK(IBDMU+LTHETA*(J-1)+K)
     &      -WORK(IBMUZ+J)*WORK(IBDMU+LTHETA*(I-1)+K)
165   CONTINUE
C
C     EXPAND CONTENTS OF VAR AND DER TO THE GENERAL MATRICES GV AND GD
C
      DO 175 J=1,M
      DO 175 I=1,J
      IJ1=J*(J-1)/2+I
      IJ0=M*(J-1)+I
      JI0=M*(I-1)+J
      WORK(IBGV+IJ0)=VAR(IJ1)
      WORK(IBGV+JI0)=VAR(IJ1)
      DO 170 K=1,LTHETA
      WORK(IBGD+LGV*(K-1)+IJ0)=DER(LTHETA*(IJ1-1)+K)
      WORK(IBGD+LGV*(K-1)+JI0)=DER(LTHETA*(IJ1-1)+K)
170   CONTINUE
175   CONTINUE
C
C     SET DER TO ZERO
C
      DO 180 J=1,LTHETA
      DO 180 I=1,LR
180   DER(LR*(J-1)+I)=0.D0
C
C     PUT VAR TO R*GV*R' AND PUT THE DIFFERENTIAL WRT R IN DER
C
      DO 185 COL=1,M
      DO 185 ROW=1,COL
      IJ=COL*(COL-1)/2+ROW
      VAR(IJ)=0.D0
      DO 185 I=ROW,M
      DO 185 J=COL,M
      VAR(IJ)=VAR(IJ)
     &   +R(I*(I-1)/2+ROW)*WORK(IBGV+M*(J-1)+I)*R(J*(J-1)/2+COL)
      DER(LR*(IBR+I*(I-1)/2+ROW-1)+IJ)=DER(LR*(IBR+I*(I-1)/2+ROW-1)+IJ)
     &   +WORK(IBGV+M*(J-1)+I)*R(J*(J-1)/2+COL)
      DER(LR*(IBR+J*(J-1)/2+COL-1)+IJ)=DER(LR*(IBR+J*(J-1)/2+COL-1)+IJ)
     &   +WORK(IBGV+M*(J-1)+I)*R(I*(I-1)/2+ROW)
185   CONTINUE
C
C     ADD R*GD(K)*R' TO DER
C
      DO 195 K=1,LTHETA
      DO 195 COL=1,M
      DO 195 ROW=1,COL
      IJ=COL*(COL-1)/2+ROW
      DO 190 I=ROW,M
      DO 190 J=COL,M
190   DER(LR*(K-1)+IJ)=DER(LR*(K-1)+IJ)
     & +R(I*(I-1)/2+ROW)*WORK(IBGD+LGV*(K-1)+M*(J-1)+I)*R(J*(J-1)/2+COL)
195   CONTINUE
C
      RETURN
3002  FORMAT(' ERROR RETURN FROM VARCOV, M OR M*L EXCEEDS 100')
      END
C.hr PCORD
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     PCORD    4/14/88
C
C     PURPOSE
C     GENERATE Y'S FOR PLOTTING PURPOSES.
C
C     NOTE
C     IN ORIGINAL UNITS, THE GRID GENERATED IS:
C     MU(I)-NGRD*SCALE*SE(I), ..., MU(I)+NGRD*SCALE*SE(I)
C     FOR I = 1, ..., M  WHERE MU(I) AND SE(I) ARE THE SAMPLE MEAN AND
C     VARIANCE OF THE ORIGINAL DATA. (2*NGRD+1)**M DISTINCT POINTS CAN
C     BE GENERATED IN SUCCESIVE CALLS TO PCORD WITH ISW=1.
C
C     USAGE
C     CALL PCORD(0,YPLT,Y,X,M,L,NGRD,S,MUSTAT,CSTAT,PSTAT,IY,YINC,WORK)
C     DO 10 I=1,(2*NGRD+1)**M
C     CALL PCORD(1,YPLT,Y,X,M,L,NGRD,S,MUSTAT,CSTAT,PSTAT,IY,YINC,WORK)
C     OTHER STATEMENTS
C10   CONTINUE
C
C     SUBROUTINES CALLED
C     DRINV, DGMPNT
C
C     ARGUMENTS
C     ISW   - SWITCH, ISW = 0: INITIALIZE X, PSTAT, IY, YINC;
C                     ISW = 1: COMPUTE THE NEXT YPLT AND Y VALUES.
C             INPUT, INTEGER*4
C     YPLT  - AN M-VECTOR OF PLOT POINTS IN ORIGINAL UNITS.  THE COMPUTE
C             GRID IS EQUALLY SPACED AND RECTANGULAR IN ORIGINAL UNITS.
C             OUTPUT, REAL*8
C     Y     - AN M-VECTOR OF PLOT POINTS IN TRANSFORMED UNITS AS
C             APPROPRIATE FOR CALLS TO HYX.
C             OUTPUT, REAL*8
C     X     - M*L VECTOR OF LAGGED VALUES OF Y, STORED END TO END IN
C             TIME SERIAL ORDER. X=(Y'_T-L, ..., Y'_T-1), M*L MUST BE
C             LESS THAT 100
C             INPUT & OUTPUT, REAL*8
C     M     - DIMENSION OF THE TIME SERIES. IE. LENGTH OF Y_T.  MUST BE
C             LESS THAN 100.
C             INPUT, INTEGER*4
C     L     - NUMBER OF LAGS IN THE VAR, M*L MUST BE LESS THAN 100.
C             INPUT, INTEGER*4
C     S     - SCALE FACTOR, 3.D0 IS A GOOD PLACE TO START.
C             INPUT, REAL*8
C     MUSTAT- M-VECTOR, SAMPLE MEAN OF THE DATA IN ORIGINAL UNITS.
C             INPUT, REAL*8
C     CSTAT - M BY M MATRIX CONTAINING THE FACTORED SAMPLE VARIANCE OF
C             THE DATA IN ORIGINAL UNITS, VAR = (CSTAT)*(CSTAT)'. CSTAT
C             IS ASSUMED TO HAVE ALL ZEROES BELOW THE DIAGONAL.
C             INPUT, REAL*8
C     PSTAT - M BY M INVERSE OF CSTAT.
C             OUTPUT, REAL*8
C     IY    - M-VECTOR USED TO REMEMBER WHICH YPLT'S HAVE ALREADY BEEN
C             COMPUTED.
C             OUTPUT, INTEGER*4
C     YINC  - M-VECTOR OF PLOT INCREMENTS.
C             OUTPUT, INTEGER*4
C     WORK  - WORKSPACE OF LENGTH M*M
C             REAL*8
C
      SUBROUTINE PCORD
     &(ISW,YPLT,Y,X,M,L,NGRD,S,MUSTAT,CSTAT,PSTAT,IY,YINC,WORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 YPLT(M),Y(M),X(M*L)
      REAL*8 MUSTAT(M),CSTAT(M*M),PSTAT(M*M),YINC(M)
      REAL*8 WORK(1)
      INTEGER*4 IY(M)
      SAVE
C
      IF(ISW.EQ.0) GO TO 10
      IF(ISW.EQ.1) GO TO 100
C
C     INITIALIZATION
C
10    CONTINUE
      DO 20 I=1,M
      IY(I)=-NGRD
20    YINC(I)=0.D0
      IY(1)=IY(1)-1
      DO 25 J=1,M
      DO 25 I=1,M
25    YINC(I)=YINC(I)+CSTAT(M*(J-1)+I)**2
      FNGRD=NGRD
      DO 30 I=1,M
30    YINC(I)=S*DSQRT(YINC(I))/FNGRD
      DO 35 J=1,M
      DO 35 I=1,J
35    WORK(J*(J-1)/2+I)=CSTAT(M*(J-1)+I)
      CALL DRINV(WORK,M)
      DO 40 J=1,M
      DO 40 I=1,M
      PSTAT(M*(J-1)+I)=0.D0
40    IF(I.LE.J) PSTAT(M*(J-1)+I)=WORK(J*(J-1)/2+I)
      DO 50 J=1,L
      DO 50 I=1,M
50    WORK(M*(J-1)+I)=X(M*(J-1)+I)-MUSTAT(I)
      DO 60 J=1,L
60    CALL DGMPRD(PSTAT,WORK(M*(J-1)+1),X(M*(J-1)+1),M,M,1)
      RETURN
C
C     COMPUTE YPLT AND Y
C
100   CONTINUE
      DO 110 I=1,M
      IF(IY(I).LT.NGRD) THEN
         IY(I)=IY(I)+1
         GO TO 120
      ELSE
         IY(I)=-NGRD
      ENDIF
110   CONTINUE
120   CONTINUE
      DO 130 I=1,M
      FIY=IY(I)
      WORK(I)=FIY*YINC(I)
130   YPLT(I)=MUSTAT(I)+WORK(I)
      CALL DGMPRD(PSTAT,WORK,Y,M,M,1)
      RETURN
      END

      subroutine density(isw)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      real*8 time,dose,weight,conc,adummy,tlag
      real*8 data
      real*8 Cl,V,expz1,expz2
      real*8 Q,QwCl,QwV
      real*8 A,Alag,E
      real*8 AwQ,AwQlag
      real*8 P,PwCl,PwV,PwS,Plag,PwClag,PwVlag,PwSlag
      real*8 O,S,f,fwO,fwS

      integer*4 i,j,isw
      integer*4 id0,id0lag,apgar,mdv,evid,iptr
      integer*4 count,point

      character*15 z1out, z2out

      integer*4 mrows,mcols,debug

      parameter (mrows=5,mcols=800,debug=0)

      dimension count(mcols),point(mcols)
      dimension data(mrows,mcols)


*     If isw=1, read and setup local data; compute nobs.

      if (isw.eq.1) then

        if (iunit9.eq.1) then
          j=0
          do i=1,12
            if (outfil(i:i).eq.' ') then
              j=i
              go to 5
            end if  
          end do
5         continue          
          if (j.eq.0) then
            z1out=outfil//'.z1'
            z2out=outfil//'.z2'
          else
            z1out=outfil(1:j-1)//'.z1'  
            z2out=outfil(1:j-1)//'.z2'  
          end if
          open (unit=21,file=z1out,status='unknown',form='formatted')
          open (unit=22,file=z2out,status='unknown',form='formatted')
        end if

        open (unit=14,file='/home/arg/r/mix/pheno/pheno.dat',
     &    status='old',form='formatted')

        nobs=0
        iptr=1
        count(iptr)=0
        point(iptr)=1
        id0lag=1

        do i=1,mcols
          read(14,14001,end=10)
     &      id0,time,dose,weight,apgar,conc,mdv,evid

          data(1,i)=time
          data(2,i)=dose
          data(3,i)=weight
          data(4,i)=conc
          if (apgar.lt.5.d0) then
            data(5,i)=1.d0
          else
            data(5,i)=0.d0
          end if

          if (conc.gt.0.d0) nobs=nobs+1

          if (id0lag.eq.id0) then
            count(iptr)=count(iptr)+1
          else
            iptr=iptr+1
            count(iptr)=1
            id0lag=id0
            point(iptr)=i
          end if
        end do
10      continue

        if (iptr.ne.ncases) then
          write(3,3001)
          stop
        end if

        close(14)
        return
      end if
 

*     If isw=2, compute the density.

      if (isw.eq.2) then
        weight=data(3,point(id))
        adummy=data(5,point(id))

        x(1)=weight
        x(2)=adummy

        expz1=dexp(z(1))
        expz2=dexp(z(2))

        Cl =  weight*tau(1)*expz1
        V  =  weight*tau(2)*(1.d0+adummy*tau(3))*expz2

        Q    = Cl/V
        QwCl = 1.d0/V
        QwV  = -Cl/(V *V)

        Plag   = 1.d0
        PwClag = 0.d0
        PwVlag = 0.d0
        PwSlag = 0.d0

        Alag   = 0.d0
        AwQlag = 0.d0
        tlag   = 0.d0
 
        do i=point(id),point(id)-1+count(id)
          time=data(1,i)
          dose=data(2,i)
          conc=data(4,i)
          E = dexp(-Q*(time-tlag))
          if (dose .gt. 0.d0) then
            A = Alag*E + dose
            AwQ = -Alag*(time-tlag)*E + AwQlag*E
          else
            A = Alag*E
            AwQ = -Alag*(time-tlag)*E + AwQlag*E
            O = A/V
            S = tau(4)
            call normalh(conc,O,S,2.d0,f,fwO,fwS)
            P   = Plag*f
            PwS  = Plag*fwS + PwSlag*f
            PwCl = Plag*fwO*(AwQ/V)*QwCl + PwClag*f
            PwV  = Plag*fwO*((AwQ/V)*QwV-A/(V*V)) + PwVlag*f
            Plag   = P
            PwSlag = PwS
            PwClag = PwCl
            PwVlag = PwV
          end if
          tlag=time
          Alag=A
          AwQlag=AwQ
        end do

        d = P
        dwtau(1)=PwCl*weight*expz1
        dwtau(2)=PwV*weight*(1.d0+adummy*tau(3))*expz2
        dwtau(3)=PwV*weight*tau(2)*adummy*expz2
        dwtau(4)=PwS
        dwz(1)=PwCl*Cl
        dwz(2)=PwV*V
        return
      end if

*     If isw=3, write individual effects to unit 9.

      if (isw.eq.3) then
        write(9,9001) id,Cl,V
        write(21,21000) z(1)
        write(22,22000) z(2)
      end if
        
*     If isw=4, print some debugging information.

      if (isw.eq.4) then

        if (iunit9.eq.1) then
          close(21)
          close(22)
        end if

        if ((iprint.eq.0).and.(debug.ne.0)) then
          do i=1,ncases
            write(3,3008) i,point(i),count(i)
            write(3,3009) (data(j,point(i)),j=1,mrows)
            write(3,3009) (data(j,point(i)-1+count(i)),j=1,mrows)
          end do
          write(3,3002) Cl,V
          write(3,3003) Q,QwCl,QwV
          write(3,3004) A,Alag,E
          write(3,3005) AwQ,AwQlag
          write(3,3006) P,PwCl,PwV,PwS,Plag,PwClag,PwVlag,PwSlag
          write(3,3007) O,S,f,fwO,fwS
          return
        end if
      end if

      return
3001  format(1x,'error, density, error reading data')
3002  format(1x,'Cl,V'/1x,2f20.8)
3003  format(1x,'R,RwCl,RwV'/1x,3f20.8)
3004  format(1x,'A,Alag,E'/1x,3f20.8)
3005  format(1x,'AwR,AwRlag'/1x,2f20.8)
3006  format(1x,'P,PwCl,PwV,PwS,Plag,PwClag,PwVlag,PwSlag'/1x,8f12.8)
3007  format(1x,'O,S,f,fwO,fwS'/1x,5f11.7)
3008  format(1x,'i,point,count',1x,3i5)
3009  format(1x,'data',1x,8f8.4)
3010  format(1x,'time, dose, A, conc, A/V',f7.1,4f10.6)
3011  format(1x,'time, f, fwO, fwS       ',f7.1,3f10.6)
3012  format(1x,'time, P, PwCl, PwV, PwS ',f7.1,4f10.6)
9001  format(i5,2d30.18)
14001 format(i7,3f7.0,i7,f7.0,i7,i2)
21000 format(1x,f28.20)
22000 format(1x,f28.20)
      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine density(isw)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "../code/global.f"
      include "local.f"

      real*8 delta,Fa,Fe,timeL
      real*8 O,OL,Owtau,OwtauL,Owz,OwzL
      real*8 Oa,OaL,Oawtau,OawtuL,Oawz,OawzL
      real*8 ka,kawtau,kawz
      real*8 ke,kewtau,kewz
      real*8 V,Vwtau,Vwz
      real*8 P,Pwtau,Pwz,PL,PwtauL,PwzL
      real*8 S,f,fwO,fwS
      real*8 OaVsav,Osave

      integer*4 i,j,isw
      integer*4 id0,id0lag,iptr
      integer*4 count,point,obs
      integer*4 idsave,ctsave

      character*12 fname

      dimension count(mcols),point(mcols),obs(mcols)
      dimension kawtau(mtau),kawz(mM)
      dimension kewtau(mtau),kewz(mM)
      dimension Vwtau(mtau),Vwz(mM)
      dimension Owtau(mtau),OwtauL(mtau),Owz(mM),OwzL(mM)
      dimension Oawtau(mtau),OawtuL(mtau),Oawz(mM),OawzL(mM)
      dimension Pwtau(mtau),Pwz(mM),PwtauL(mtau),PwzL(mM)
      dimension OaVsav(mcols),Osave(mcols)
      dimension idsave(mcols),ctsave(mcols)

*     If isw=1, read local data, compute nobs.

      if (isw.eq.1) then

        if (iunit9.eq.1) then 
          open (unit=14,file='quinplot.dat',
     &      status='old',form='formatted')
        else
          open (unit=14,file='quin.dat',
     &      status='old',form='formatted')
        endif
        
        nobs=0
        iptr=1
        count(iptr)=0
        point(iptr)=1
        obs(iptr)=0
        id0lag=1

        do i=1,mcols

          ctsave(i) = 0

          read(14,14001,end=10)
     &      id0,
     &      time(i),conc(i),dose(i),
     &      form(i),observ(i),change(i),steady(i),
     &      dinter(i),age(i),height(i),weight(i),
     &      race(i),smoker(i),lush(i),
     &      heart(i),creatn(i),
     &      album(i),glyco(i)

          if (observ(i).eq.0) nobs=nobs+1

          if ((id0lag.eq.id0).or.(i.eq.1)) then
            count(iptr)=count(iptr)+1
            if (observ(i).eq.0) obs(iptr)=obs(iptr)+1
          else
            iptr=iptr+1
            count(iptr)=1
            point(iptr)=i
            if (observ(i).eq.0) then
              obs(iptr)=1
            else
              obs(iptr)=0
            end if
            id0lag=id0
          end if

          idsave(i) = iptr
          ctsave(i) = count(iptr)
          OaVsav(i) = 0.d0
          Osave(i)  = 0.d0

        end do

10      continue

        if (iptr.ne.ncases) then
          write(3,3901)
          stop
        end if

        close(14)
        return
      end if


*     If isw=2, compute the density.

      if (isw.eq.2) then

        timeL=0.d0

        OaL=0.d0
        OL=0.d0
        do j=1,ltau
          Oawtau(j)=0.d0
          OawtuL(j)=0.d0
          Owtau(j)=0.d0
          OwtauL(j)=0.d0
        end do
        do j=1,M
          Oawz(j)=0.d0
          OawzL(j)=0.d0
          Owz(j)=0.d0
          OwzL(j)=0.d0
        end do

        PL = 1.d0
        do j=1,ltau
          Pwtau(j)=0.d0
          PwtauL(j)=0.d0
        end do
        do j=1,M
          Pwz(j)=0.d0
          PwzL(j)=0.d0
        end do

        do i=point(id),point(id)-1+count(id)


          index = i
          call g(ka,kawtau,kawz,ke,kewtau,kewz,V,Vwtau,Vwz)

*         Steady state or not?
          if (steady(i).ge.1) then

*           Steady state.

            Fa = 1.d0/(1.d0 - dexp(-ka*dinter(i)))
            Fe = 1.d0/(1.d0 - dexp(-ke*dinter(i)))
            Oa = (dose(i)/V)*Fa
            O  = (dose(i)/V)*(ka/(ka-ke))*(Fe-Fa)
            do j=1,ltau-1
              Oawtau(j) = 
     &          - (Oa/V)*Vwtau(j)
     &          - (dose(i)/V)*Fa**2*dinter(i)*dexp(-ka*dinter(i))
     &              *kawtau(j)
              Owtau(j) = 
     &          - (O/V)*Vwtau(j)
     &          + (dose(i)/V)/(ka-ke)*(Fe-Fa)*kawtau(j)
     &          - (dose(i)/V)*ka/(ka-ke)**2*(Fe-Fa)*kawtau(j)
     &          + (dose(i)/V)*ka/(ka-ke)*Fa**2
     &            *dinter(i)*dexp(-ka*dinter(i))*kawtau(j)
     &          + (dose(i)/V)*ka/(ka-ke)**2*(Fe-Fa)*kewtau(j)
     &          - (dose(i)/V)*ka/(ka-ke)*Fe**2
     &            *dinter(i)*dexp(-ke*dinter(i))*kewtau(j)
            end do
            do j=1,M
              Oawz(j) = 
     &          - (Oa/V)*Vwz(j)
     &          - (dose(i)/V)*Fa**2*dinter(i)*dexp(-ka*dinter(i))
     &              *kawz(j)
              Owz(j) = 
     &          - (O/V)*Vwz(j)
     &          + (dose(i)/V)/(ka-ke)*(Fe-Fa)*kawz(j)
     &          - (dose(i)/V)*ka/(ka-ke)**2*(Fe-Fa)*kawz(j)
     &          + (dose(i)/V)*ka/(ka-ke)*Fa**2
     &            *dinter(i)*dexp(-ka*dinter(i))*kawz(j)
     &          + (dose(i)/V)*ka/(ka-ke)**2*(Fe-Fa)*kewz(j)
     &          - (dose(i)/V)*ka/(ka-ke)*Fe**2
     &            *dinter(i)*dexp(-ke*dinter(i))*kewz(j)
            end do

          else

*           Non-steady state.

            delta = time(i)-timeL
            Fa = dexp(-ka*delta)
            Fe = dexp(-ke*delta)
            Oa = OaL*Fa+(dose(i)/V)
            O  = OL*Fe + OaL*(ka/(ka-ke))*(Fe-Fa)
            do j=1,ltau-1
              Oawtau(j) =
     &          + OawtuL(j)*Fa 
     &          - OaL*delta*Fa*kawtau(j) 
     &          - dose(i)*Vwtau(j)/(V**2)    
              Owtau(j) =
     &          + OwtauL(j)*Fe 
     &          - OL*delta*Fe*kewtau(j)
     &          + OawtuL(j)*ka*(Fe-Fa)/(ka-ke)
     &          + OaL*(Fe-Fa)*kawtau(j)/(ka-ke)
     &          + OaL*ka*(Fe-Fa)*(kewtau(j)-kawtau(j))/((ka-ke)**2)
     &          + OaL*ka*delta*(kawtau(j)*Fa-kewtau(j)*Fe)/(ka-ke)
            end do
            do j=1,M
              Oawz(j) =
     &            + OawzL(j)*Fa 
     &            - OaL*delta*Fa*kawz(j)
     &            - dose(i)*Vwz(j)/(V**2)    
              Owz(j) =
     &            + OwzL(j)*Fe 
     &            - OL*delta*Fe*kewz(j)
     &            + OawzL(j)*ka*(Fe-Fa)/(ka-ke)
     &            + OaL*(Fe-Fa)*kawz(j)/(ka-ke)
     &            + OaL*ka*(Fe-Fa)*(kewz(j)-kawz(j))/((ka-ke)**2)
     &            + OaL*ka*delta*(kawz(j)*Fa-kewz(j)*Fe)/(ka-ke)
            end do

          end if

          timeL = time(i)
          OaL = Oa
          OL = O
          do j=1,ltau-1
            OawtuL(j)=Oawtau(j)
            OwtauL(j)=Owtau(j)
          end do
          do j=1,M
            OawzL(j)=Oawz(j)
            OwzL(j)=Owz(j)
          end do

          OaVsav(i) = Oa*V
          Osave(i) = O

*         Concentration measurement?
          if (observ(i).eq.0) then

            S=tau(ltau)
            call normalh(conc(i),O,S,2.d0,f,fwO,fwS)
            P = PL*f
            do j=1,ltau-1
              Pwtau(j) = PL*fwO*Owtau(j) + PwtauL(j)*f
            end do
            Pwtau(ltau) = PL*fwS + PwtauL(ltau)*f
            do j=1,M
              Pwz(j) = PL*fwO*Owz(j) + PwzL(j)*f
            end do

            PL = P
            do j=1,ltau
              PwtauL(j) = Pwtau(j)
            end do
            do j=1,M
              PwzL(j) = Pwz(j)
            end do

          end if

        end do

        d = P
        do j=1,ltau
          dwtau(j) = Pwtau(j)
        end do
        do j=1,M
          dwz(j) = Pwz(j)
        end do

        return
      end if

*     If isw=3, write individual random coefficients and effects to
*     unit 9.

      if (isw.eq.3) then
        write(9,9001) id,(z(j),j=1,M)
        return
      end if

*     If isw=4, print plotting information.

      if (isw.eq.4) then

        if (iunit9.ne.1) then
          open (unit=14,file='data.dat',
     &      status='unknown',form='formatted')

          do i=1,mcols
            if (ctsave(i).eq.0) go to 20
            write(14,14002)
     &      i,ctsave(i),idsave(i),
     &      time(i),conc(i),dose(i),
     &      form(i),observ(i),change(i),steady(i),
     &      dinter(i),age(i),height(i),weight(i),
     &      race(i),smoker(i),lush(i),
     &      heart(i),creatn(i),
     &      album(i),glyco(i)
          end do
 20       continue 
          close(14)
        end if
        
        if (iunit9.eq.1) then
      
          fname=outfil//'            '

          j=0
          do i=1,12
            if (fname(i:i).eq.'.') then
              j=i
            end if
            if ((fname(i:i).eq.' ').and.(j.eq.0)) then
              j=i
              fname(j+1:j+1)='f'
            end if
          end do
    
          if (j.eq.0) then
            fname(9:9)='.'
            j=9
          else 
            fname(j:j)='.'
          end if
          
          fname(j+1:j+3)='fit'
          
          if (fname.eq.outfil) then
            fname(j+1:j+3)='ftt'
          end if
          
          open (unit=14,file=fname,status='unknown',form='formatted')
  
          do i=1,mcols
            if (ctsave(i).gt.0.d0) then
              write(14,14003)
     &        i,ctsave(i),idsave(i),
     &        time(i),conc(i),
     &        Osave(i),OaVsav(i),
     &        dose(i),dinter(i)
            end if
          end do

          close(14)
          
          open (unit=14,file='covar.dat',
     &      status='unknown',form='formatted')
     
          do j=1,ncases
            i=point(j)
            write(14,14002)
     &        obs(j),count(j),j,
     &        time(i),conc(i),dose(i),
     &        form(i),observ(i),change(i),steady(i),
     &        dinter(i),age(i),height(i),weight(i),
     &        race(i),smoker(i),lush(i),
     &        heart(i),creatn(i),
     &        album(i),glyco(i)
          end do
          
          close(14)
        end if
        
      return
      end if

      return

3901  format(1x,'error, density, error reading data')
3902  format(1x,'error, density, ',12a,', ',32a)
9001  format(i5,100e30.18)
14001 format(
     &  i4,
     &  f8.2,f4.1,f5.0,
     &  4i2,
     &  f3.0,f3.0,f3.0,f4.0,
     &  3i2,
     &  2i2,
     &  f4.1,f5.0
     &  )
14002 format(
     &  1x,i5,i5,i4,
     &  f8.2,f4.1,f5.0,
     &  4i2,
     &  f4.0,f4.0,f4.0,f5.0,
     &  3i2,
     &  2i2,
     &  f4.1,f5.0
     &  )
14003  format(
     &  1x,i5,i5,i4,
     &  f9.2,f5.1,
     &  f11.5,f13.5,
     &  f6.0,f5.0
     &  )
      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  chsubs.f
*
*     chcore   chfd     chfdlc   chfdls   chfgrd   chcjac   chfjac
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CHCORE( DEBUG, DONE, FIRST, EPSA, EPSR, FX, X,
     $                   INFORM, ITER, ITMAX,
     $                   CDEST, FDEST, SDEST, ERRBND, F1,
     $                   F2, H, HOPT, HPHI )

      IMPLICIT           DOUBLE PRECISION (A-H,O-Z)
      LOGICAL            DEBUG, DONE, FIRST

C***********************************************************************
C     CHCORE  implements algorithm  FD, the method described in
C     Gill, P.E., Murray, W., Saunders, M.A., and Wright, M. H.,
C     Computing Forward-Difference Intervals for Numerical Optimization,
C     Siam Journal on Scientific and Statistical Computing, vol. 4,
C     pp. 310-321, June 1983.
C     
C     The procedure is based on finding an interval (HPHI) that
C     produces an acceptable estimate of the second derivative, and
C     then using that estimate to compute an interval that should
C     produce a reasonable forward-difference approximation.
C     
C     One-sided difference estimates are used to ensure feasibility with
C     respect to an upper or lower bound on X.  If X is close to an 
C     upper bound, the trial intervals will be negative.  The final 
C     interval is always positive.
C     
C     CHCORE has been designed to use a reverse communication
C     control structure, i.e., all evaluations of the function occur
C     outside this routine.  The calling routine repeatedly calls  
C     CHCORE  after computing the indicated function values.
C     
C     CHCORE  is similar to subroutine FDCORE described in Report
C     SOL 83-6, Documentation of FDCORE and FDCALC, by P.E. Gill,
C     W. Murray,  M.A. Saunders, and M.H. Wright, Department of
C     Operations Research,  Stanford University, Stanford, California
C     94305, June 1983.
C     
C     Systems Optimization Laboratory, Stanford University.
C     Based on Fortran 66 Version 2.1 of  FDCORE  written June 1983.
C     Fortran 77 Version written 25-May-1985.
C     This version of  CHCORE  dated  11-February-1986.
C***********************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            CE1BIG, CE2BIG, TE2BIG, OVERFL
      SAVE               CDSAVE, FDSAVE, HSAVE, OLDH, RHO, SDSAVE
      SAVE               CE1BIG, CE2BIG, TE2BIG
      EXTERNAL           DDIV
      INTRINSIC          ABS   , MAX   , MIN  , SQRT

      PARAMETER         (BNDLO  =1.0D-3, BNDUP  =1.0D-1                )

      PARAMETER         (ZERO   =0.0D+0, SIXTH  =1.6D-1, FOURTH =2.5D-1)
      PARAMETER         (HALF   =5.0D-1, ONE    =1.0D+0, TWO    =2.0D+0)
      PARAMETER         (THREE  =3.0D+0, FOUR   =4.0D+0, TEN    =1.0D+1)

*     ------------------------------------------------------------------
*     Explanation of local variables...
*
*     BNDLO, BNDUP, and RHO control the logic of the routine.
*     BNDLO and BNDUP are the lower and upper bounds that define an
*     acceptable value of the bound on the relative condition error in
*     the second derivative estimate.
*
*     The scalar RHO is the factor by which the interval is multiplied
*     or divided, and also the multiple of the well-scaled interval
*     that is used as the initial trial interval.
*
*     All these values are discussed in the documentation.
*     ------------------------------------------------------------------

      ITER  = ITER + 1

*     Compute the forward-,  backward-,  central-  and second-order
*     difference estimates.

      FDEST  = DDIV  ( F1 - FX,     H, OVERFL )
      FDEST2 = DDIV  ( F2 - FX, TWO*H, OVERFL )

      OLDCD = CDEST
      CDEST = DDIV  ( FOUR*F1 - THREE*FX - F2, TWO*H, OVERFL )

      OLDSD = SDEST
      SDEST = DDIV  ( FX      - TWO*F1   + F2, H*H  , OVERFL )

*     Compute  FDCERR  and  SDCERR,  bounds on the relative condition
*     errors in the first and second derivative estimates.

      AFDMIN = MIN( ABS( FDEST ), ABS( FDEST2 ) )
      FDCERR = DDIV  ( EPSA, HALF*ABS( H )*AFDMIN, OVERFL )
      SDCERR = DDIV  ( EPSA, FOURTH*ABS( SDEST )*H*H, OVERFL )

      IF (DEBUG)
     $   WRITE (NOUT, 9000) ITER  , FX   , H,
     $                      F1    , FDEST,
     $                      F2    , FDEST2,
     $                      CDEST , SDEST,
     $                      FDCERR, SDCERR

*     ==================================================================
*     Select the correct case.
*     ==================================================================
      IF (FIRST) THEN
*        ---------------------------------------------------------------
*        First time through.
*        Check whether SDCERR lies in the acceptable range.
*        ------------------------------------------------------------
         FIRST  = .FALSE.
         DONE   = SDCERR .GE. BNDLO  .AND.  SDCERR .LE. BNDUP
         TE2BIG = SDCERR .LT. BNDLO
         CE2BIG = SDCERR .GT. BNDUP
         CE1BIG = FDCERR .GT. BNDUP

         IF (.NOT. CE1BIG) THEN
            HSAVE  = H
            FDSAVE = FDEST
            CDSAVE = CDEST
            SDSAVE = SDEST
         END IF

         RHO  = EPSR**(-SIXTH)/FOUR
         IF (TE2BIG) THEN

*           The truncation error may be too big  (same as saying
*           SDCERR is too small).  Decrease the trial interval.

            RHO    = TEN*RHO
            OLDH   = H
            H      = H / RHO
         ELSE IF (CE2BIG) THEN

*           SDCERR is too large.  Increase the trial interval.

            OLDH   = H
            H      = H*RHO
         END IF
      ELSE IF (CE2BIG) THEN
*        ---------------------------------------------------------------
*        During the last iteration,  the trial interval was
*        increased in order to decrease SDCERR.
*        ---------------------------------------------------------------
         IF (CE1BIG  .AND.  FDCERR .LE. BNDUP) THEN
            CE1BIG = .FALSE.
            HSAVE  = H
            FDSAVE = FDEST
            CDSAVE = CDEST
            SDSAVE = SDEST
         END IF

*        If SDCERR is small enough, accept H.  Otherwise,
*        increase H again.

         DONE   = SDCERR .LE. BNDUP
         IF (.NOT. DONE) THEN
            OLDH   = H
            H      = H*RHO
         END IF
      ELSE IF (TE2BIG) THEN
*        ---------------------------------------------------------------
*        During the last iteration,  the interval was decreased in order
*        to reduce the truncation error.
*        ---------------------------------------------------------------
         DONE   = SDCERR .GT. BNDUP
         IF (DONE) THEN

*           SDCERR has jumped from being too small to being too
*           large.  Accept the previous value of H.

            H     = OLDH
            SDEST = OLDSD
            CDEST = OLDCD
         ELSE

*           Test whether FDCERR is sufficiently small.

            IF (FDCERR .LE. BNDUP) THEN
               CE1BIG = .FALSE.
               HSAVE  = H
               FDSAVE = FDEST
               CDSAVE = CDEST
               SDSAVE = SDEST
            END IF

*           Check whether SDCERR is in range.

            DONE  = SDCERR .GE. BNDLO

            IF (.NOT. DONE) THEN

*              SDCERR is still too small, decrease H again.

               OLDH = H
               H    = H / RHO
            END IF
         END IF

      END IF

*     ==================================================================
*     We have either finished or have a new estimate of H.
*     ==================================================================
      IF (DONE) THEN

*        Sufficiently good second-derivative estimate found.
*        Compute the optimal interval.

         HPHI   = ABS( H )
         HOPT   = TWO * SQRT( EPSA ) / SQRT( ABS( SDEST ) )

*        ERR1 is the error bound on the forward-difference estimate
*        with the final value of H.  ERR2 is the difference of FDEST
*        and the central-difference estimate with HPHI.

         ERR1   = HOPT*ABS( SDEST )
         ERR2   = ABS( FDEST - CDEST )
         ERRBND = MAX( ERR1, ERR2 )

*        Set INFORM = 4  if the forward- and central-difference
*        estimates are not close.

         INFORM = 0
         IF (ERRBND .GT. HALF*ABS( FDEST )) INFORM = 4
      ELSE
*        ---------------------------------------------------------------
*        Check whether the maximum number of iterations has been
*        exceeded.  If not, exit.
*        ---------------------------------------------------------------
         DONE = ITER .GE. ITMAX
         IF (DONE) THEN
            IF (CE1BIG) THEN

*              FDCERR was never small.  Probably a constant function.

               INFORM = 1
               HPHI   = HOPT
               FDEST  = ZERO
               CDEST  = ZERO
               SDEST  = ZERO
               ERRBND = ZERO
            ELSE IF (CE2BIG) THEN

*              FDCERR was small,  but SDCERR was never small.
*              Probably a linear or odd function.

               INFORM = 2
               HPHI   = ABS( HSAVE )
               HOPT   = HPHI
               FDEST  = FDSAVE
               CDEST  = CDSAVE
               SDEST  = ZERO
               ERRBND = TWO*EPSA / HOPT
            ELSE

*              The only remaining case occurs when the second
*              derivative is changing too rapidly for an adequate
*              interval to be found (SDCERR remained small even
*              though H was decreased ITMAX times).

               INFORM = 3
               HPHI   = ABS( HSAVE )
               HOPT   = HPHI
               FDEST  = FDSAVE
               CDEST  = CDSAVE
               SDEST  = SDSAVE
               ERRBND = HOPT*ABS( SDEST )/TWO + TWO*EPSA/HOPT
            END IF
         END IF
      END IF

      IF (DEBUG) THEN
         WRITE (NOUT, 9001) CE1BIG, CE2BIG, TE2BIG
         IF (DONE)
     $      WRITE (NOUT, 9002) INFORM, HOPT, ERRBND
      END IF

      RETURN

 9000 FORMAT(/ ' //CHCORE//  ITN ', I3,
     $                             ' FX     H      ', 5X, 1P, 2D16.6
     $       / ' //CHCORE//  F1      FDEST         ', 5X, 1P, 2D16.6
     $       / ' //CHCORE//  F2      FDEST2        ', 5X, 1P, 2D16.6
     $       / ' //CHCORE//  CDEST   SDEST         ', 5X, 1P, 2D16.6
     $       / ' //CHCORE//  FDCERR  SDCERR        ', 5X, 1P, 2D16.6)
 9001 FORMAT(  ' //CHCORE//  CE1BIG  CE2BIG  TE2BIG', 5X, 3L2       )
 9002 FORMAT(  ' //CHCORE//  INFORM  HOPT    ERRBND', I5, 1P, 2D16.6)

*     End of  CHCORE.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CHFD  ( INFORM, MSGLVL, LVLDER,
     $                   N, NCNLN, LDCJ, LDCJU,
     $                   BIGBND, EPSRF, FDNORM, OBJF,
     $                   OBJFUN, CONFUN, NEEDC,
     $                   BL, BU, C, C1, C2, CJAC, CJACU,
     $                   GRAD, GRADU, HFORWD, HCNTRL,
     $                   X, Y, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            NEEDC(*)
      DOUBLE PRECISION   BL(N), BU(N)
      DOUBLE PRECISION   C(*), C1(*), C2(*),
     $                   CJAC(LDCJ,*), CJACU(LDCJU,*)
      DOUBLE PRECISION   GRAD(N), GRADU(N)
      DOUBLE PRECISION   HFORWD(*), HCNTRL(*)
      DOUBLE PRECISION   X(N), Y(N), W(LENW)
      EXTERNAL           OBJFUN, CONFUN

************************************************************************
*  CHFD    computes difference intervals for the missing gradients of
*  F(x) and c(x).  Intervals are computed using a procedure that usually
*  requires about two function evaluations if the function is well
*  scaled.  Central-difference gradients are obtained as a by-product
*  of the algorithm.
*
*  On entry...
*     OBJF and C contain the problem functions at the point X.
*     An element of CJAC or GRAD not equal to RDUMMY signifies a known
*     gradient value.  Such values are not estimated by differencing.
*     CJACU and GRADU have dummy elements in the same positions as
*     CJAC and GRADU.
*
*  On exit...                          
*     CJAC and GRAD contain central-difference derivative estimates.
*     Elements of CJACU and GRADU are unaltered except for those
*     corresponding to constant derivatives, which are given the same
*     values as CJAC or GRAD.
*
*  The work array  W  is not used at present.
*
*  Systems Optimization Laboratory, Department of Operations Research,
*  Stanford University, Stanford, California 94305
*  Original version written 28-July-1985.
*  This version of CHFD   dated 14-July-1986.
************************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            DEBUG , DONE  , FIRST , HEADNG, NEEDED
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      EXTERNAL           DNRM2
      PARAMETER         (RDUMMY =-11111.0              )
      PARAMETER         (FACTOR =0.97D+0               )
      PARAMETER         (ZERO   =0.0D+0, HALF   =0.5D+0, ONE   =1.0D+0)
      PARAMETER         (TWO    =2.0D+0, FOUR   =4.0D+0, TEN   =1.0D+1)

      INFORM = 0
      NEEDED = LVLDER .EQ. 0  .OR.  LVLDER .EQ. 2
     $                        .OR.  LVLDER .EQ. 1  .AND.  NCNLN .GT. 0
      IF (.NOT. NEEDED) RETURN

      DEBUG  = NPDBG  .AND.  INPDBG(5) .GT. 0
      IF (LFDSET .EQ. 0) THEN
         IF (MSGLVL .GT. 0) WRITE (NOUT, 1000)

         NSTATE = 0
         ITMAX  = 3
         MODE   = 0

         NCCNST = 0
         NFCNST = 0
         HEADNG = .TRUE.

         FDNORM = ZERO

*        ===============================================================
*        For each column of the Jacobian augmented by the transpose of
*        the objective gradient, rows IROW1 thru IROW2 are searched for
*        missing elements.
*        ===============================================================
         IROW1  = 1
         IROW2  = NCNLN + 1
         IF (LVLDER .EQ. 1) IROW2 = NCNLN
         IF (LVLDER .EQ. 2) IROW1 = NCNLN + 1

         BIGLOW = - BIGBND
         BIGUPP =   BIGBND

         IF (NCNLN  .GT. 0)
     $      CALL ILOAD ( NCNLN, (0), NEEDC, 1 )

         DO 600 J = 1, N
            XJ     = X(J)
            NFOUND = 0
            SUMSD  = ZERO
            SUMEPS = ZERO
            HFD    = ZERO
            HCD    = ZERO
            HMAX   = ZERO
            HMIN   = ONE / EPSPT3
            ERRMAX = ZERO
            ERRMIN = ZERO

            STEPBL = BIGLOW
            STEPBU = BIGUPP
            IF (BL(J) .GT. BIGLOW) STEPBL = BL(J) - XJ
            IF (BU(J) .LT. BIGUPP) STEPBU = BU(J) - XJ

            SIGNH  = ONE
            IF (HALF*(STEPBL + STEPBU) .LT. ZERO) SIGNH =  - ONE

            DO 500 I = IROW1, IROW2

               IF (I .LE. NCNLN) THEN
                  TEST = CJACU(I,J)
               ELSE
                  TEST = GRADU(J)
               END IF

               IF (TEST .EQ. RDUMMY) THEN
*                 ======================================================
*                 Get the difference interval for this component.
*                 ======================================================
                  NFOUND = NFOUND + 1

                  IF (I .LE. NCNLN) THEN
                     NEEDC(I) = 1
                     FX       = C(I)
                     EPSA     = EPSRF*(ONE + ABS( C(I) ))
                  ELSE
                     FX       = OBJF
                     EPSA     = EPSRF*(ONE + ABS( FX ))
                  END IF

*                 ------------------------------------------------------
*                 Find a finite-difference interval by iteration.
*                 ------------------------------------------------------
                  ITER   = 0
                  HOPT   = TWO*(ONE + ABS( XJ ))*SQRT( EPSRF )
                  H      = SIGNH*TEN*HOPT
                  CDEST  = ZERO
                  SDEST  = ZERO
                  FIRST  = .TRUE.

*+                REPEAT
  400                X(J)  = XJ + H
                     IF (I .LE. NCNLN) THEN
                        CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                               NEEDC, X, C1, CJACU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                        F1 = C1(I)
                     ELSE
                        CALL OBJFUN( MODE, N, X, F1, GRADU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                     END IF

                     X(J)  = XJ + H + H
                    IF (I .LE. NCNLN) THEN
                       CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                              NEEDC, X, C1, CJACU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                        F2 = C1(I)
                     ELSE
                        CALL OBJFUN( MODE, N, X, F2, GRADU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                     END IF

                     CALL CHCORE( DEBUG, DONE, FIRST, EPSA, EPSRF,FX,XJ,
     $                            INFO, ITER, ITMAX,
     $                            CDEST, FDEST, SDEST, ERRBND, F1,
     $                            F2, H, HOPT, HPHI )
      
*+                UNTIL     DONE
                  IF (.NOT. DONE) GO TO 400

                  IF (I .LE. NCNLN) THEN
                     CJAC(I,J) = CDEST
                     IF (INFO .EQ. 1  .OR.  INFO .EQ. 2) THEN
                        NCCNST    =   NCCNST + 1
                        NCDIFF    =   NCDIFF - 1
                        CJACU(I,J) = - RDUMMY
                     END IF
                  ELSE
                     GRAD(J)   = CDEST
                     IF (INFO .EQ. 1  .OR.  INFO .EQ. 2) THEN
                        NFCNST    =   NFCNST + 1
                        NFDIFF    =   NFDIFF - 1
                        GRADU(J)  = - RDUMMY
                     END IF
                  END IF

                  SUMSD  = SUMSD  + ABS( SDEST )
                  SUMEPS = SUMEPS +      EPSA
                  IF (HOPT .GT. HMAX) THEN
                     HMAX   = HOPT
                     ERRMAX = ERRBND
                  END IF
                  IF (HOPT .LT. HMIN) THEN
                     HMIN   = HOPT
                     ERRMIN = ERRBND
                  END IF

                  IF (INFO .EQ. 0) HCD  = MAX ( HCD, HPHI )
               END IF
  500       CONTINUE

            IF (NFOUND .GT. 0) THEN
               IF (HMIN .GT. HMAX) THEN
                  HMIN   = HMAX
                  ERRMIN = ERRMAX
               END IF

               IF      (FOUR*SUMEPS .LT. HMIN*HMIN*SUMSD) THEN
                  HFD    = HMIN
                  ERRMAX = ERRMIN
               ELSE IF (FOUR*SUMEPS .GT. HMAX*HMAX*SUMSD) THEN
                  HFD    = HMAX
               ELSE
                  HFD    = TWO*SQRT( SUMEPS / SUMSD )
                  ERRMAX = TWO*SQRT( SUMEPS * SUMSD )
               END IF

               IF (HCD .EQ. ZERO) HCD = TEN*HFD

               IF (MSGLVL .GT. 0) THEN
                  IF (HEADNG) WRITE (NOUT, 1100)
                  WRITE (NOUT, 1200) J, XJ, HFD, HCD, ERRMAX
                  HEADNG = .FALSE.
               END IF
            END IF

            FDNORM    = MAX (FDNORM, HFD)
            HFORWD(J) = HFD / (ONE + ABS(XJ))
            HCNTRL(J) = HCD / (ONE + ABS(XJ))
            X(J)      = XJ
  600    CONTINUE

         IF (NCCNST + NFCNST .GT. 0) THEN

*           Check that the constants have been set properly by
*           evaluating the gradients at a strange (but feasible) point.

            D      =   ONE / N

            DO 710 J = 1, N
               XJ     =   X(J)
               STEPBL = - ONE
               STEPBU =   ONE
               IF (BL(J) .GT. BIGLOW)
     $            STEPBL = MAX( STEPBL, BL(J) - XJ )
               IF (BU(J) .LT. BIGUPP  .AND.  BU(J) .GT. BL(J))
     $            STEPBU = MIN( STEPBU, BU(J) - XJ )

               IF (HALF*(STEPBL + STEPBU) .LT. ZERO) THEN
                  Y(J) = XJ + D*STEPBL
               ELSE
                  Y(J) = XJ + D*STEPBU
               END IF

               D = FACTOR*D
  710       CONTINUE

            IF (NCNLN .GT. 0) THEN
               CALL ILOAD ( NCNLN, (1), NEEDC, 1 )
               CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                      NEEDC, Y, C2, CJACU, NSTATE )
               IF (MODE .LT. 0) GO TO 9999
            END IF

            CALL OBJFUN( MODE, N, Y, OBJF2, GRADU, NSTATE )
            IF (MODE .LT. 0) GO TO 9999

*           ------------------------------------------------------------
*           Loop over each of the components of  x.
*           ------------------------------------------------------------
            DO 800 J = 1, N
               YJ     = Y(J)
               DX     = HALF*(X(J) - YJ)
               Y(J)   = YJ + DX

               IF (NCNLN .GT. 0) THEN
                  NFOUND = 0
                  DO 720 I = 1, NCNLN
                     IF (CJACU(I,J) .EQ. - RDUMMY) THEN
                        NEEDC(I) = 1
                        NFOUND   = NFOUND + 1
                     ELSE
                        NEEDC(I) = 0
                     END IF
  720             CONTINUE

                  IF (NFOUND .GT. 0) THEN
                     CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                            NEEDC, Y, C1, CJACU, NSTATE )
                     IF (MODE .LT. 0) GO TO 9999

                     DO 730 I = 1, NCNLN
                        IF (NEEDC(I) .EQ. 1) THEN
                           CJDIFF = ( C1(I) -  C2(I) ) / DX
                           IF (CJDIFF .EQ. CJAC(I,J)) THEN
                              CJACU(I,J) = CJDIFF
                           ELSE
                              CJACU(I,J) = RDUMMY
                              NCCNST    = NCCNST - 1
                              NCDIFF    = NCDIFF + 1
                           END IF
                        END IF
  730                CONTINUE
                  END IF
               END IF

*              Now check the objective gradient component.

               IF (GRADU(J) .EQ. - RDUMMY) THEN

                  CALL OBJFUN( MODE, N, Y, F1, GRADU, NSTATE )
                  IF (MODE .LT. 0) GO TO 9999

                  GDIFF = (F1 - OBJF2)/DX
                  IF (GDIFF .EQ. GRAD(J)) THEN
                     GRADU(J) = GDIFF
                  ELSE
                     GRADU(J) = RDUMMY
                     NFDIFF   = NFDIFF + 1
                     NFCNST   = NFCNST - 1
                  END IF
               END IF

               Y(J)  = YJ
  800       CONTINUE

            IF (MSGLVL .GT. 0) THEN
               IF (LVLDER .LT. 2  .AND.  NCCNST .GT. 0)
     $            WRITE (NOUT, 1300) NCCNST
               IF (LVLDER .NE. 1  .AND.  NFCNST .GT. 0)
     $            WRITE (NOUT, 1400) NFCNST
            END IF

            IF (NCDIFF .EQ. 0  .AND.  LVLDER .LT. 2) THEN
               IF (LVLDER .EQ. 0) LVLDER = 2
               IF (LVLDER .EQ. 1) LVLDER = 3
               IF (MSGLVL .GT. 0) WRITE (NOUT, 1500) LVLDER
            END IF

            IF (NFDIFF .EQ. 0  .AND.  LVLDER .NE. 1) THEN
               IF (LVLDER .EQ. 0) LVLDER = 1
               IF (LVLDER .EQ. 2) LVLDER = 3
               IF (MSGLVL .GT. 0) WRITE (NOUT, 1600) LVLDER
            END IF
         END IF
      ELSE IF (LFDSET .EQ. 2) THEN

*        The user has supplied HFORWD and HCNTRL.
*        Check for wild values.

         DO 900 J = 1, N
            IF (HFORWD(J) .LE. ZERO) THEN
               WRITE (NOUT, 2000) J, HFORWD(J), EPSPT5
               HFORWD(J) = EPSPT5
            END IF
  900    CONTINUE
         DO 910 J = 1, N
            IF (HCNTRL(J) .LE. ZERO) THEN
               WRITE (NOUT, 2100) J, HCNTRL(J), EPSPT3
               HCNTRL(J) = EPSPT3
            END IF
  910    CONTINUE
      END IF

      RETURN

 9999 INFORM = MODE
      RETURN

 1000 FORMAT(//' Computation of the finite-difference intervals'
     $       / ' ----------------------------------------------' )
 1100 FORMAT(//'    J      X(J)   Forward DX(J)   Central DX(J) ',
     $         '     Error est.' /)
 1200 FORMAT(  I5, 1P, E10.2, E16.6, 2E16.6 )
 1300 FORMAT(/ I5,  '  constant constraint gradient elements assigned.')
 1400 FORMAT(/ I5,  '  constant  objective gradient elements assigned.')
 1500 FORMAT(//' All missing Jacobian elements are constants.  ',
     $         ' Derivative level increased to ', I4 )
 1600 FORMAT(//' All missing objective gradients are constants.  ',
     $         ' Derivative level increased to ', I4 )
 2000 FORMAT(' XXX  ', I4,'-th difference interval ',         1PE10.2,
     $       ' replaced by ', 1PE10.2 )
 2100 FORMAT(' XXX  ', I4,'-th central-difference interval ', 1PE10.2,
     $       ' replaced by ', 1PE10.2 )

*     End of  CHFD  .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine chfdlc( inform, msglvl, lvlder, n, 
     $                   bigbnd, epsrf, fdnorm, objf,
     $                   objfun, bl, bu, 
     $                   grad, gradu, hforwd, hcntrl,
     $                   x, y, w, lenw )

      implicit           double precision(a-h,o-z)
      double precision   bl(n), bu(n)
      double precision   grad(n), gradu(n)
      double precision   hforwd(*), hcntrl(*)
      double precision   x(n), y(n), w(lenw)
      external           objfun

C***********************************************************************
C     CHFDLC  computes difference intervals for the missing gradients of
C     f(x).  Difference intervals are computed using a procedure that 
C     usually requires about two evaluations if  f(x)  is well scaled.
C     Central-difference gradients are obtained as a by-product of the
C     algorithm.
C
C     On entry...
C       OBJF  contains the objective function at the point X.
C       An element of  GRAD  not equal to  RDUMMY  signifies a user-
C       specified value.  Such values are not estimated by differencing.
C       GRAD  has dummy elements in the same positions as GRADU.
C
C     On exit...                          
C       GRAD  contain central-difference derivative estimates.
C       Elements of  GRADU  are unaltered except for those corresponding 
C       to constant derivatives, which are given values values found
C       by differencing.
C
C     The work array  W  is not used at present.
C
C     Original version written  5-July-1990.
C     This version of  CHFDLC  dated  5-Jul-1990.
C***********************************************************************
      common    /sol1cm/ nout
      common    /sol4cm/ epspt3, epspt5, epspt8, epspt9

      common    /sol4np/ lvldif, ncdiff, nfdiff, lfdset

      logical            npdbg
      parameter         (ldbg = 5)
      common    /npdebg/ inpdbg(ldbg), npdbg

      logical            debug , done  , first , headng, needed
      intrinsic          abs   , max   , min   , sqrt
      external           dnrm2
      parameter         (rdummy =-11111.0              )
      parameter         (factor =0.97d+0               )
      parameter         (zero   =0.0d+0, half   =0.5d+0, one   =1.0d+0)
      parameter         (two    =2.0d+0, ten    =1.0d+1)

      inform = 0
      needed = lvlder .eq. 0  .or.  lvlder .eq. 2
      if (.not. needed) return

      debug  = npdbg  .and.  inpdbg(5) .gt. 0
      if (lfdset .eq. 0) then
         if (msglvl .gt. 0) write (nout, 1000)

         nstate = 0
         itmax  = 3
         mode   = 0

         nfcnst = 0
         headng = .true.

         fdnorm = zero

         biglow = - bigbnd
         bigupp =   bigbnd

         do 600, j = 1, n
            xj     = x(j)

            stepbl = biglow
            stepbu = bigupp
            if (bl(j) .gt. biglow) stepbl = bl(j) - xj
            if (bu(j) .lt. bigupp) stepbu = bu(j) - xj

            signh  = one
            if (half*(stepbl + stepbu) .lt. zero) signh =  - one

            if (gradu(j) .eq. rdummy) then
*              =========================================================
*              This component needs a difference interval.
*              =========================================================
               epsa     = epsrf*(one + abs( objf ))
               iter   = 0
               hopt   = two*(one + abs( xj ))*sqrt( epsrf )
               h      = signh*ten*hopt
               cdest  = zero
               sdest  = zero
               first  = .true.

*+             repeat
  400             x(j)  = xj + h
                  call objfun( mode, n, x, f1, gradu, nstate )
                  if (mode .lt. 0) go to 9999

                  x(j)  = xj + h + h
                  call objfun( mode, n, x, f2, gradu, nstate )
                  if (mode .lt. 0) go to 9999

                  call chcore( debug, done, first, epsa, epsrf,
     $                         objf, xj, info, iter, itmax,
     $                         cdest, fdest, sdest, errbnd, f1,
     $                         f2, h, hopt, hphi )
*+             until     done
               if (.not. done) go to 400

               grad(j) = cdest
               if (info .eq. 1  .or.  info .eq. 2) then
                  nfcnst   =   nfcnst + 1
                  nfdiff   =   nfdiff - 1
                  gradu(j) = - rdummy
               end if

               if (info .eq. 0) then
                  hfd = hopt
                  hcd = hphi
               else 
                  hfd = two*(one + abs( xj ))*sqrt( epsrf )
                  hcd = ten*hfd
               end if

               if (msglvl .gt. 0) then
                  if (headng) write (nout, 1100)
                  write (nout, 1200) j, xj, hfd, hcd, errbnd
                  headng = .false.
               end if
            end if

            fdnorm    = max (fdnorm, hfd)
            hforwd(j) = hfd / (one + abs(xj))
            hcntrl(j) = hcd / (one + abs(xj))
            x(j)      = xj
  600    continue

         if (nfcnst .gt. 0) then

*           Check that the constant elements of  g  have been identified
*           correctly.  Re-evaluate the gradients at a strange feasible
*           point.

            d      =   one / n

            do 710, j = 1, n
               xj     =   x(j)
               stepbl = - one
               stepbu =   one
               if (bl(j) .gt. biglow)
     $            stepbl = max( stepbl, bl(j) - xj )
               if (bu(j) .lt. bigupp  .and.  bu(j) .gt. bl(j))
     $            stepbu = min( stepbu, bu(j) - xj )

               if (half*(stepbl + stepbu) .lt. zero) then
                  y(j) = xj + d*stepbl
               else
                  y(j) = xj + d*stepbu
               end if

               d = factor*d
  710       continue

            call objfun( mode, n, y, objf2, gradu, nstate )
            if (mode .lt. 0) go to 9999

*           ------------------------------------------------------------
*           Loop over each component of  x.
*           ------------------------------------------------------------
            do 800, j = 1, n
               yj     = y(j)
               dx     = half*(x(j) - yj)
               y(j)   = yj + dx

               if (gradu(j) .eq. - rdummy) then

                  call objfun( mode, n, y, f1, gradu, nstate )
                  if (mode .lt. 0) go to 9999

                  gdiff = (f1 - objf2)/dx
                  if (gdiff .eq. grad(j)) then
                     gradu(j) = gdiff
                  else
                     gradu(j) = rdummy
                     nfdiff   = nfdiff + 1
                     nfcnst   = nfcnst - 1
                  end if
               end if

               y(j)  = yj
  800       continue

            if (msglvl .gt. 0) then
               if (nfcnst .gt. 0)
     $            write (nout, 1400) nfcnst
            end if

            if (nfdiff .eq. 0) then
               if (lvlder .eq. 0) lvlder = 1
               if (lvlder .eq. 2) lvlder = 3
               if (msglvl .gt. 0) write (nout, 1600) lvlder
            end if
         end if
      else if (lfdset .eq. 2) then

*        The user has supplied  hforwd  and  hcntrl.
*        Check for wild values.

         do 900, j = 1, n
            if (hforwd(j) .le. zero) then
               write (nout, 2000) j, hforwd(j), epspt5
               hforwd(j) = epspt5
            end if
  900    continue
         do 910, j = 1, n
            if (hcntrl(j) .le. zero) then
               write (nout, 2100) j, hcntrl(j), epspt3
               hcntrl(j) = epspt3
            end if
  910    continue
      end if

      return

 9999 inform = mode

 1000 format(//' Computation of the finite-difference intervals'
     $       / ' ----------------------------------------------' )
 1100 format(//'    j      x(j)   Forward dx(j)   Central dx(j) ',
     $         '     Error est.' /)
 1200 format(  i5, 1p, e10.2, e16.6, 2e16.6 )
 1300 format(/ i5,  '  constant constraint gradient elements assigned.')
 1400 format(/ I5,  '  constant  objective gradient elements assigned.')
 1600 format(//' All missing objective gradients are constants.  ',
     $         ' Derivative level increased to ', i4 )
 2000 format(' XXX  ', i4,'-th difference interval ',         1pe10.2,
     $       ' replaced by ', 1pe10.2 )
 2100 format(' XXX  ', i4,'-th central-difference interval ', 1pe10.2,
     $       ' replaced by ', 1pe10.2 )

*     End of  CHFDLC.

      end
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CHFDLS( INFORM, MSGLVL, LVLDER,
     $                   M, N, NCNLN, LDCJ, LDCJU, LDFJ, LDFJU,
     $                   BIGBND, EPSRF, FDNORM,
     $                   CONFUN, OBJFUN, NEEDC,
     $                   BL, BU, C, C1, C2, CJAC, CJACU,
     $                   F, F1, F2, FJAC, FJACU, HFORWD, HCNTRL,
     $                   X, Y, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            NEEDC(*)
      DOUBLE PRECISION   BL(N), BU(N)
      DOUBLE PRECISION   C(*), C1(*), C2(*),
     $                   CJAC(LDCJ,*), CJACU(LDCJU,*)
      DOUBLE PRECISION   F(*), F1(*), F2(*),
     $                   FJAC(LDFJ,*), FJACU(LDFJU,*)
      DOUBLE PRECISION   HFORWD(*), HCNTRL(*)
      DOUBLE PRECISION   X(N), Y(N), W(LENW)
      EXTERNAL           OBJFUN, CONFUN

C***********************************************************************
C     CHFDLS  computes difference intervals for missing Jacobian
C     elements of f(x) and c(x).  Intervals are computed using a
C     procedure that requires about two function evaluations if the
C     function is well scaled.  Central-difference gradients are
C     obtained as a by-product of the algorithm.
C
C     On entry...
C        F and C contain the problem functions at the point X.
C        An element of CJAC or FJAC not equal to RDUMMY signifies a known
C        gradient value.  Such values are not estimated by differencing.
C        CJACU and FJACU have dummy elements in the same positions as
C        CJAC and FJAC.
C
C     On exit...
C        CJAC and FJAC contain central-difference derivative estimates.
C        Elements of CJACU and FJACU are unaltered except for those
C        corresponding to constant derivatives, which are given the same
C        values as CJAC or FJAC.
C
C     The work array  W  is not used at present.
C
C     Systems Optimization Laboratory,
C     Department of Operations Research,
C     Stanford University, Stanford, California 94305
C     Original version written 10-May-1988.
C     This version of CHFDLS dated  8-Jun-1989.
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            DEBUG , DONE  , FIRST , HEADNG, NEEDED
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      EXTERNAL           DNRM2
      PARAMETER         (RDUMMY =-11111.0              )
      PARAMETER         (FACTOR =0.97D+0               )
      PARAMETER         (ZERO   =0.0D+0, HALF   =0.5D+0, ONE   =1.0D+0)
      PARAMETER         (TWO    =2.0D+0, FOUR   =4.0D+0, TEN   =1.0D+1)

      INFORM = 0
      NEEDED = LVLDER .EQ. 0  .OR.  LVLDER .EQ. 2
     $                        .OR.  LVLDER .EQ. 1  .AND.  NCNLN .GT. 0
      IF (.NOT. NEEDED) RETURN

      DEBUG  = NPDBG  .AND.  INPDBG(5) .GT. 0
      IF (LFDSET .EQ. 0) THEN
         IF (MSGLVL .GT. 0) WRITE (NOUT, 1000)

         NSTATE = 0
         ITMAX  = 3
         MODE   = 0

         NCCNST = 0
         NFCNST = 0
         HEADNG = .TRUE.

         FDNORM = ZERO

*        ===============================================================
*        For each column of the matrix
*              ( CJAC  )
*              ( FJAC  ),
*        rows IROW1 thru IROW2 are searched for missing elements.
*        ===============================================================
         IROW1  = 1
         IROW2  = NCNLN + M
         IF (LVLDER .EQ. 1) IROW2 = NCNLN
         IF (LVLDER .EQ. 2) IROW1 = NCNLN + 1

         BIGLOW = - BIGBND
         BIGUPP =   BIGBND

         IF (NCNLN  .GT. 0)
     $      CALL ILOAD ( NCNLN, (0), NEEDC, 1 )

         DO 600, J = 1, N
            XJ     = X(J)
            NFOUND = 0
            SUMSD  = ZERO
            SUMEPS = ZERO
            HFD    = ZERO
            HCD    = ZERO
            HMAX   = ZERO
            HMIN   = ONE / EPSPT3
            ERRMAX = ZERO
            ERRMIN = ZERO

            STEPBL = BIGLOW
            STEPBU = BIGUPP
            IF (BL(J) .GT. BIGLOW) STEPBL = BL(J) - XJ
            IF (BU(J) .LT. BIGUPP) STEPBU = BU(J) - XJ

            SIGNH  = ONE
            IF (HALF*(STEPBL + STEPBU) .LT. ZERO) SIGNH =  - ONE

            DO 500, IROW = IROW1, IROW2

               IF (IROW .LE. NCNLN) THEN
                  I    = IROW
                  TEST = CJACU(I,J)
               ELSE
                  I    = IROW - NCNLN
                  TEST = FJACU(I,J)
               END IF

               IF (TEST .EQ. RDUMMY) THEN
*                 ======================================================
*                 Get the difference interval for this component.
*                 ======================================================
                  NFOUND = NFOUND + 1

                  IF (IROW .LE. NCNLN) THEN
                     NEEDC(I) = 1
                     FX       = C(I)
                  ELSE
                     FX       = F(I)
                  END IF

                  EPSA     = EPSRF*(ONE + ABS( FX ))

*                 ------------------------------------------------------
*                 Find a finite-difference interval by iteration.
*                 ------------------------------------------------------
                  ITER   = 0
                  HOPT   = TWO*(ONE + ABS( XJ ))*SQRT( EPSRF )
                  H      = SIGNH*TEN*HOPT
                  CDEST  = ZERO
                  SDEST  = ZERO
                  FIRST  = .TRUE.

*+                REPEAT
  400                X(J)  = XJ + H
                     IF (IROW .LE. NCNLN) THEN
                        CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                               NEEDC, X, C1, CJACU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                        FFORW = C1(I)
                     ELSE
                        CALL OBJFUN( MODE, M    , N, LDFJU,
     $                                      X, F1, FJACU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                        FFORW = F1(I)
                     END IF

                     X(J)  = XJ + H + H
                    IF (IROW .LE. NCNLN) THEN
                       CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                              NEEDC, X, C1, CJACU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                        FBACK = C1(I)
                     ELSE
                        CALL OBJFUN( MODE, M    , N, LDFJU,
     $                                      X, F1, FJACU, NSTATE )
                        IF (MODE .LT. 0) GO TO 9999
                        FBACK = F1(I)
                     END IF

                     CALL CHCORE( DEBUG, DONE, FIRST, EPSA, EPSRF,FX,XJ,
     $                            INFO, ITER, ITMAX,
     $                            CDEST, FDEST, SDEST, ERRBND, FFORW,
     $                            FBACK, H, HOPT, HPHI )

*+                UNTIL     DONE
                  IF (.NOT. DONE) GO TO 400

                  IF (IROW .LE. NCNLN) THEN
                     CJAC(I,J) = CDEST
                     IF (INFO .EQ. 1  .OR.  INFO .EQ. 2) THEN
                        NCCNST     =   NCCNST + 1
                        NCDIFF     =   NCDIFF - 1
                        CJACU(I,J) = - RDUMMY
                     END IF
                  ELSE
                     FJAC(I,J) = CDEST
                     IF (INFO .EQ. 1  .OR.  INFO .EQ. 2) THEN
                        NFCNST     =   NFCNST + 1
                        NFDIFF     =   NFDIFF - 1
                        FJACU(I,J) = - RDUMMY
                     END IF
                  END IF

                  SUMSD  = SUMSD  + ABS( SDEST )
                  SUMEPS = SUMEPS +      EPSA
                  IF (HOPT .GT. HMAX) THEN
                     HMAX   = HOPT
                     ERRMAX = ERRBND
                  END IF
                  IF (HOPT .LT. HMIN) THEN
                     HMIN   = HOPT
                     ERRMIN = ERRBND
                  END IF

                  IF (INFO .EQ. 0) HCD  = MAX ( HCD, HPHI )
               END IF
  500       CONTINUE

            IF (NFOUND .GT. 0) THEN
               IF (HMIN .GT. HMAX) THEN
                  HMIN   = HMAX
                  ERRMIN = ERRMAX
               END IF

               IF      (FOUR*SUMEPS .LT. HMIN*HMIN*SUMSD) THEN
                  HFD    = HMIN
                  ERRMAX = ERRMIN
               ELSE IF (FOUR*SUMEPS .GT. HMAX*HMAX*SUMSD) THEN
                  HFD    = HMAX
               ELSE
                  HFD    = TWO*SQRT( SUMEPS / SUMSD )
                  ERRMAX = TWO*SQRT( SUMEPS * SUMSD )
               END IF

               IF (HCD .EQ. ZERO) HCD = TEN*HFD

               IF (MSGLVL .GT. 0) THEN
                  IF (HEADNG) WRITE (NOUT, 1100)
                  WRITE (NOUT, 1200) J, XJ, HFD, HCD, ERRMAX
                  HEADNG = .FALSE.
               END IF
            END IF

            FDNORM    = MAX (FDNORM, HFD)
            HFORWD(J) = HFD / (ONE + ABS(XJ))
            HCNTRL(J) = HCD / (ONE + ABS(XJ))
            X(J)      = XJ
  600    CONTINUE

         IF (NCCNST + NFCNST .GT. 0) THEN

*           Check that the constants have been set properly by
*           evaluating the gradients at a strange (but feasible) point.

            D      =   ONE / N

            DO 710, J = 1, N
               XJ     =   X(J)
               STEPBL = - ONE
               STEPBU =   ONE
               IF (BL(J) .GT. BIGLOW)
     $            STEPBL = MAX( STEPBL, BL(J) - XJ )
               IF (BU(J) .LT. BIGUPP  .AND.  BU(J) .GT. BL(J))
     $            STEPBU = MIN( STEPBU, BU(J) - XJ )

               IF (HALF*(STEPBL + STEPBU) .LT. ZERO) THEN
                  Y(J) = XJ + D*STEPBL
               ELSE
                  Y(J) = XJ + D*STEPBU
               END IF

               D = FACTOR*D
  710       CONTINUE

            IF (NCNLN .GT. 0) THEN
               CALL ILOAD ( NCNLN, (1), NEEDC, 1 )
               CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                      NEEDC, Y, C2, CJACU, NSTATE )
               IF (MODE .LT. 0) GO TO 9999
            END IF

            IF (M     .GT. 0) THEN
               CALL OBJFUN( MODE, M, N, LDFJU, Y, F2, FJACU, NSTATE )
               IF (MODE .LT. 0) GO TO 9999
            END IF

*           ------------------------------------------------------------
*           Loop over each of the components of  x.
*           ------------------------------------------------------------
            DO 800, J = 1, N
               YJ     = Y(J)
               DX     = HALF*(X(J) - YJ)
               Y(J)   = YJ + DX

               IF (NCNLN .GT. 0) THEN
                  NFOUND = 0
                  DO 720, I = 1, NCNLN
                     IF (CJACU(I,J) .EQ. - RDUMMY) THEN
                        NEEDC(I) = 1
                        NFOUND   = NFOUND + 1
                     ELSE
                        NEEDC(I) = 0
                     END IF
  720             CONTINUE

                  IF (NFOUND .GT. 0) THEN
                     CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                            NEEDC, Y, C1, CJACU, NSTATE )
                     IF (MODE .LT. 0) GO TO 9999

                     DO 730, I = 1, NCNLN
                        IF (NEEDC(I) .EQ. 1) THEN
                           CJDIFF = ( C1(I) -  C2(I) ) / DX
                           IF (CJDIFF .EQ. CJAC(I,J)) THEN
                              CJACU(I,J) = CJDIFF
                           ELSE
                              CJACU(I,J) = RDUMMY
                              NCCNST    = NCCNST - 1
                              NCDIFF    = NCDIFF + 1
                           END IF
                        END IF
  730                CONTINUE
                  END IF
               END IF

*              Now check the objective Jacobian.

               IF (M .GT. 0) THEN
                  NFOUND = 0
                  DO 740, I = 1, M
                     IF (FJACU(I,J) .EQ. - RDUMMY) THEN
                        NFOUND = NFOUND + 1
                     END IF
  740             CONTINUE

                  IF (NFOUND .GT. 0) THEN
                     CALL OBJFUN( MODE, M, N, LDFJU,
     $                            Y, F1, FJACU, NSTATE )
                     IF (MODE .LT. 0) GO TO 9999

                     DO 750, I = 1, M
                        IF (FJACU(I,J) .EQ. - RDUMMY) THEN
                           FJDIFF = ( F1(I) -  F2(I) ) / DX
                           IF (FJDIFF .EQ. FJAC(I,J)) THEN
                              FJACU(I,J) = FJDIFF
                           ELSE
                              FJACU(I,J) = RDUMMY
                              NFCNST     = NFCNST - 1
                              NFDIFF     = NFDIFF + 1
                           END IF
                        END IF
  750                CONTINUE
                  END IF
               END IF

               Y(J)  = YJ
  800       CONTINUE

            IF (MSGLVL .GT. 0) THEN
               IF (LVLDER .LT. 2  .AND.  NCCNST .GT. 0)
     $            WRITE (NOUT, 1300) NCCNST
               IF (LVLDER .NE. 1  .AND.  NFCNST .GT. 0)
     $            WRITE (NOUT, 1400) NFCNST
            END IF

            IF (NCDIFF .EQ. 0  .AND.  LVLDER .LT. 2) THEN
               IF (LVLDER .EQ. 0) LVLDER = 2
               IF (LVLDER .EQ. 1) LVLDER = 3
               IF (MSGLVL .GT. 0) WRITE (NOUT, 1500) LVLDER
            END IF

            IF (NFDIFF .EQ. 0  .AND.  LVLDER .NE. 1) THEN
               IF (LVLDER .EQ. 0) LVLDER = 1
               IF (LVLDER .EQ. 2) LVLDER = 3
               IF (MSGLVL .GT. 0) WRITE (NOUT, 1600) LVLDER
            END IF
         END IF
      ELSE IF (LFDSET .EQ. 2) THEN

*        The user has supplied HFORWD and HCNTRL.
*        Check for wild values.

         DO 900, J = 1, N
            IF (HFORWD(J) .LE. ZERO) THEN
               WRITE (NOUT, 2000) J, HFORWD(J), EPSPT5
               HFORWD(J) = EPSPT5
            END IF
  900    CONTINUE
         DO 910, J = 1, N
            IF (HCNTRL(J) .LE. ZERO) THEN
               WRITE (NOUT, 2100) J, HCNTRL(J), EPSPT3
               HCNTRL(J) = EPSPT3
            END IF
  910    CONTINUE
      END IF

      RETURN

 9999 INFORM = MODE
      RETURN

 1000 FORMAT(//' Computation of the finite-difference intervals'
     $       / ' ----------------------------------------------' )
 1100 FORMAT(//'    J      X(J)   Forward DX(J)   Central DX(J) ',
     $         '     Error est.' /)
 1200 FORMAT(  I5, 1P, E10.2, E16.6, 2E16.6 )
 1300 FORMAT(/ I5,  '  constant constraint gradient elements assigned.')
 1400 FORMAT(/ I5,  '  constant objective  gradient elements assigned.')
 1500 FORMAT(//' All missing constraint Jacobian elements',
     $         ' are constants.   Derivative level increased to ', I4 )
 1600 FORMAT(//' All missing objective  Jacobian elements',
     $         ' are constants.   Derivative level increased to ', I4 )
 2000 FORMAT(' XXX  ', I4,'-th difference interval ',         1PE10.2,
     $       ' replaced by ', 1PE10.2 )
 2100 FORMAT(' XXX  ', I4,'-th central-difference interval ', 1PE10.2,
     $       ' replaced by ', 1PE10.2 )

*     End of  CHFDLS.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
      SUBROUTINE CHFGRD( INFORM, MSGLVL, N,
     $                   BIGBND, EPSRF, OKTOL, FDCHK, OBJF, XNORM,
     $                   OBJFUN,
     $                   BL, BU, GRAD, GRADU, DX, X, Y, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

      DOUBLE PRECISION   BL(N), BU(N), GRAD(N), GRADU(N), DX(N)
      DOUBLE PRECISION   X(N), Y(N), W(LENW)
      EXTERNAL           OBJFUN

C***********************************************************************
C     CHFGRD  checks if the gradients of the objective function have
C     been coded correctly.
C
C     On input,  the value of the objective function at the point X is
C     stored in OBJF.  The corresponding gradient is stored in GRADU.
C     If any gradient component has not been specified,  it will have a
C     dummy value.  Missing values are not checked.
C
C     A cheap test is first undertaken by calculating the directional
C     derivative using two different methods.  If this proves 
C     satisfactory and no further information is desired, CHFGRD is 
C     terminated.  Otherwise, the routine CHCORE is called to give 
C     optimal step-sizes and a forward-difference approximation to each 
C     component of the gradient for which a test is deemed necessary,
C     either by the program or the user.
C
C     Other inputs:
C
C           X         The n-dimensional point at which the
C                     gradient is to be verified.
C           EPSRF     The positive bound on the relative error
C                     associated with computing the function at
C                     the point x.
C           OKTOL     The desired relative accuracy which the
C                     components of the gradient should satisfy.
C
C     LVRFYC has the following meaning...
C
C       -1        do not perform any check.
C        0        do the cheap test only.
C        1 or 3   do both cheap and full test.
C
C     Systems Optimization Laboratory, Stanford University.
C     Original version written  19-May-1985.
C     This version of CHFGRD dated  28-Jun-1989.  
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      COMMON    /SOL5NP/ LVRFYC, JVERFY(4)

      LOGICAL            NPDBG        
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            CONST , DEBUG , DONE  , FIRST , HEADNG
      LOGICAL            NEEDED, OK
      CHARACTER*4        KEY   , LBAD  , LGOOD
      CHARACTER*18       RESULT(0:4)
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      EXTERNAL           DDOT
      PARAMETER         (RDUMMY =-11111.0              )
      PARAMETER         (ZERO   =0.0D+0, HALF  = 0.5D+0, POINT9 =0.9D+0)
      PARAMETER         (ONE    =1.0D+0, TWO   = 2.0D+0, TEN    =1.0D+1)
      PARAMETER         (LBAD   ='BAD?', LGOOD = '  OK')
      DATA               RESULT
     $                 / '                 ', 'Constant?      ',
     $                   'Linear or odd?   ', 'Too nonlinear?',
     $                   'Small derivative?'                   /

      INFORM = 0
      NEEDED = LVRFYC .EQ. 0  .OR.  LVRFYC .EQ. 1  .OR.  LVRFYC .EQ. 3
      IF (.NOT. NEEDED) RETURN
 
      WRITE (NOUT, 1000)
      DEBUG  = NPDBG  .AND.  INPDBG(5) .GT. 0
      NSTATE = 0

      BIGLOW = - BIGBND
      BIGUPP =   BIGBND

*     ==================================================================
*     Perform the cheap test.
*     ==================================================================
      H =     (ONE + XNORM)*FDCHK

      DXJ  = ONE / N
      DO 110 J = 1, N
         DX(J) =   DXJ
         DXJ   = - DXJ*POINT9
  110 CONTINUE

*     ------------------------------------------------------------------
*     Do not perturb X(J) if the  J-th  element is missing.
*     Compute the directional derivative.
*     ------------------------------------------------------------------
      NCHECK = 0
      DO 120 J = 1, N
         IF (GRAD(J) .EQ. RDUMMY) THEN
            DX(J) = ZERO
         ELSE
            NCHECK = NCHECK + 1

            XJ     =   X(J)                             
            STEPBL = - ONE       
            STEPBU =   ONE
            IF (BL(J) .GT. BIGLOW)
     $         STEPBL = MAX( STEPBL, BL(J) - XJ )
            IF (BU(J) .LT. BIGUPP  .AND.  BU(J) .GT. BL(J))
     $         STEPBU = MIN( STEPBU, BU(J) - XJ )

            IF (HALF*(STEPBL + STEPBU) .LT. ZERO) THEN
               DX(J) = DX(J)*STEPBL
            ELSE
               DX(J) = DX(J)*STEPBU
            END IF
         END IF
  120 CONTINUE

      IF (NCHECK .EQ. 0) THEN
         WRITE (NOUT, 3500)
         RETURN
      END IF
      GDX    = DDOT  ( N, GRADU, 1, DX, 1 )

*     ------------------------------------------------------------------
*     Make forward-difference approximation along  p.
*     ------------------------------------------------------------------
      CALL DCOPY ( N,     X, 1, Y, 1 )
      CALL DAXPY ( N, H, DX, 1, Y, 1 )
      
      MODE   = 0
      CALL OBJFUN( MODE, N, Y, OBJF1, GRADU, NSTATE )
      IF (MODE .LT. 0) GO TO 9999

      GDIFF =    (OBJF1 - OBJF) / H
      ERROR = ABS(GDIFF - GDX ) / (ABS(GDX) + ONE)

      OK    = ERROR .LE. OKTOL
      IF (OK) THEN
         IF (MSGLVL .GT. 0) WRITE (NOUT, 1100)
      ELSE
         WRITE (NOUT, 1200)
         IF (ERROR .GE. POINT9) INFORM = 1
      END IF

      IF (MSGLVL .GT. 0) WRITE (NOUT, 1300) GDX, GDIFF

*     ==================================================================
*     Component-wise check.
*     ==================================================================
      IF (LVRFYC .EQ. 1  .OR.  LVRFYC .EQ. 3) THEN
         HEADNG = .TRUE.
         ITMAX  = 3
         NWRONG = 0
         NGOOD  = 0
         JMAX   = 0
         EMAX   = ZERO
         NCHECK = 0
         J1     = JVERFY(1)
         J2     = JVERFY(2)

*        ---------------------------------------------------------------
*        Loop over each of the components of  x.
*        ---------------------------------------------------------------
         DO 500 J = J1, J2

            IF (GRAD(J) .NE. RDUMMY) THEN
*              ---------------------------------------------------------
*              Check this gradient component.
*              ---------------------------------------------------------
               NCHECK = NCHECK + 1
               GJ     = GRAD(J)
               GSIZE  = ABS( GJ )
               XJ     = X(J)
*              ---------------------------------------------------------
*              Find a finite-difference interval by iteration.
*              ---------------------------------------------------------
               ITER   = 0
               EPSA   = EPSRF*(ONE + ABS( OBJF ))
               CDEST  = ZERO
               SDEST  = ZERO
               FIRST  = .TRUE.

               STEPBL = BIGLOW
               STEPBU = BIGUPP
               IF (BL(J) .GT. BIGLOW) STEPBL = BL(J) - XJ
               IF (BU(J) .LT. BIGUPP) STEPBU = BU(J) - XJ

               HOPT   = TWO*(ONE + ABS( XJ ))*SQRT( EPSRF )
               H      = TEN*HOPT
               IF (HALF*(STEPBL + STEPBU) .LT. ZERO) H =  - H

*+             REPEAT
  400             X(J)  = XJ + H
                  CALL OBJFUN( MODE, N, X, F1, GRADU, NSTATE )
                  IF (MODE .LT. 0) GO TO 9999

                  X(J)  = XJ + H + H
                  CALL OBJFUN( MODE, N, X, F2, GRADU, NSTATE )
                  IF (MODE .LT. 0) GO TO 9999
                              
                  CALL CHCORE( DEBUG, DONE, FIRST, EPSA, EPSRF, OBJF,XJ,
     $                         INFO, ITER, ITMAX,
     $                         CDEST, FDEST, SDEST, ERRBND, F1,
     $                         F2, H, HOPT, HPHI )

*+             UNTIL     DONE
               IF (.NOT. DONE) GO TO 400

*              ---------------------------------------------------------
*              Exit for this variable.
*              ---------------------------------------------------------
               GDIFF = CDEST
               X(J)  = XJ

               ERROR = ABS(GDIFF - GJ) / (GSIZE + ONE)
               IF (ERROR .GE. EMAX) THEN
                  EMAX  = ERROR
                  JMAX  = J
               END IF

               OK =  ERROR .LE. OKTOL
               IF (OK) THEN
                  KEY    = LGOOD
                  NGOOD  = NGOOD  + 1
               ELSE
                  KEY    = LBAD
                  NWRONG = NWRONG + 1
               END IF

*              Zero components are not printed.

               CONST = OK .AND. INFO .EQ. 1 .AND. ABS(GJ) .LT. EPSPT8
               IF (.NOT. CONST) THEN
                  IF (HEADNG) WRITE (NOUT, 3000)
                  IF (OK) THEN
                     WRITE (NOUT, 3100) J, XJ, HOPT, GJ, GDIFF,
     $                                  KEY, ITER
                  ELSE
                     WRITE (NOUT, 3110) J, XJ, HOPT, GJ, GDIFF,
     $                                  KEY, ITER, RESULT(INFO)
                  END IF
                  HEADNG = .FALSE.
               END IF
            END IF
  500    CONTINUE

*        ===============================================================
*        Done.
*        ===============================================================
         INFORM = 0
         IF (NWRONG .EQ. 0) THEN
            WRITE (NOUT, 3200) NGOOD , NCHECK, J1    , J2
         ELSE
            WRITE (NOUT, 3300) NWRONG, NCHECK, J1    , J2
            IF (ERROR .GE. POINT9) INFORM = 1
         END IF
         WRITE (NOUT, 3400) EMAX, JMAX
      END IF

      CALL DCOPY ( N, GRAD, 1, GRADU, 1 )

      RETURN

 9999 INFORM = MODE
      RETURN

 1000 FORMAT(/// ' Verification of the objective gradients.'
     $       /   ' ----------------------------------------' )
 1100 FORMAT(/   ' The objective gradients seem to be ok.')
 1200 FORMAT(/   ' XXX  The objective gradients seem to be incorrect.')
 1300 FORMAT(/   ' Directional derivative of the objective', 1PE18.8/
     $           ' Difference approximation               ', 1PE18.8 )
 3000 FORMAT(// 4X, 'J', 4X, 'X(J)', 5X, 'DX(J)', 11X,
     $           'G(J)', 9X, '  Difference approxn  Itns' /)
 3100 FORMAT(  I5, 1P, 2E10.2,      2E18.8, 2X, A4, I6          )
 3110 FORMAT(  I5, 1P, 2E10.2,      2E18.8, 2X, A4, I6, 2X, A18 )
 3200 FORMAT(/ I7, '  Objective gradients out of the', I6,
     $             '  set in cols', I6, '  through', I6,
     $             '  seem to be ok.')
 3300 FORMAT(/   ' XXX  There seem to be', I6,
     $           '  incorrect objective gradients out of the', I6,
     $           '  set in cols', I6, '  through', I6 )
 3400 FORMAT(/   ' The largest relative error was', 1PE12.2,
     $           '   in element', I6 /)
 3500 FORMAT(/   ' No gradient elements assigned.' )

*     End of  CHFGRD.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CHCJAC( INFORM, LVLDER, MSGLVL,
     $                   NCSET, N, NCNLN, LDCJ, LDCJU,
     $                   BIGBND, EPSRF, OKTOL, FDCHK, XNORM,
     $                   CONFUN, NEEDC,
     $                   BL, BU, C, C1, CJAC, CJACU, CJDX,
     $                   DX, ERR, X, Y, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            NEEDC(*)
      DOUBLE PRECISION   BL(N), BU(N), C(*), C1(*), CJDX(*),
     $                   CJAC(LDCJ,*), CJACU(LDCJU,*), ERR(*)
      DOUBLE PRECISION   DX(N), X(N), Y(N), W(LENW)
      EXTERNAL           CONFUN

C***********************************************************************
C     CHCJAC  checks if the gradients of the constraints have been coded
C     correctly.
C
C     On input,  the values of the constraints at the point X are stored
C     in C.  Their corresponding gradients are stored in CJACU.  If any
C     Jacobian component has not been specified,  it will have a dummy
C     value.  Missing values are not checked.
C
C     A cheap test is first undertaken by calculating the directional
C     derivative using two different methods.  If this proves 
C     satisfactory and no further information is desired, CHCJAC is 
C     terminated.  Otherwise, CHCORE is called to give optimal stepsizes
C     and a central-difference approximation to each component of the 
C     Jacobian for which a test is deemed necessary, either by the 
C     program or the user.
C
C     LVRFYC has the following meaning...
C
C       -1        do not perform any check.
C        0        do the cheap test only.
C        2 or 3   do both cheap and full test.
C
C     Systems Optimization Laboratory, Stanford University.
C     Original version written  19-May-1985.
C     This version of CHCJAC dated 28-Jun-1989.  
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      COMMON    /SOL5NP/ LVRFYC, JVERFY(4)

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            CONST , DEBUG , DONE  , FIRST , HEADNG
      LOGICAL            NEEDED, OK
      CHARACTER*4        KEY   , LBAD  , LGOOD
      CHARACTER*18       RESULT(0:4)
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      EXTERNAL           DDOT  , IDAMAX
      PARAMETER         (RDUMMY =-11111.0              )
      PARAMETER         (ZERO   =0.0D+0, HALF   =0.5D+0, POINT9 =0.9D+0)
      PARAMETER         (ONE    =1.0D+0, TWO    =2.0D+0, TEN    =1.0D+1)
      PARAMETER         (LBAD   ='BAD?', LGOOD  ='  OK')
      DATA               RESULT
     $                 / '                 ', 'Constant?      ',
     $                   'Linear or odd?   ', 'Too nonlinear?',
     $                   'Small derivative?'                   /

      INFORM = 0
      NEEDED = NCNLN  .GT. 0  .AND.
     $         LVRFYC .EQ. 0  .OR.   LVRFYC .EQ. 2  .OR.  LVRFYC .EQ. 3
      IF (.NOT. NEEDED) RETURN

      WRITE (NOUT, 1000)
      DEBUG  = NPDBG  .AND.  INPDBG(5) .GT. 0
      NSTATE = 0

      BIGLOW = - BIGBND
      BIGUPP =   BIGBND

*     ==================================================================
*     Perform the cheap test.
*     ==================================================================
      H = (ONE + XNORM)*FDCHK

      DXJ  = ONE / N
      DO 110 J = 1, N
         DX(J) =   DXJ
         DXJ   = - DXJ*POINT9
  110 CONTINUE

*     ------------------------------------------------------------------
*     Do not perturb  X(J)  if the  J-th  column contains any
*     unknown elements.  Compute the directional derivative for each
*     constraint gradient.
*     ------------------------------------------------------------------
      NCHECK = 0
      DO 140 J = 1, N
         DO 130 I = 1, NCNLN
            IF (CJAC(I,J) .EQ. RDUMMY) THEN
               DX(J) = ZERO      
               GO TO 140
            END IF           
  130    CONTINUE
         NCHECK = NCHECK + 1

         XJ     =   X(J)
         STEPBL = - ONE
         STEPBU =   ONE
         IF (BL(J) .GT. BIGLOW)
     $      STEPBL = MAX( STEPBL, BL(J) - XJ )
         IF (BU(J) .LT. BIGUPP  .AND.  BU(J) .GT. BL(J))
     $      STEPBU = MIN( STEPBU, BU(J) - XJ )

         IF (HALF*(STEPBL + STEPBU) .LT. ZERO) THEN
            DX(J) = DX(J)*STEPBL
         ELSE
            DX(J) = DX(J)*STEPBU
         END IF
  140 CONTINUE

      IF (NCHECK .EQ. 0) THEN
         WRITE (NOUT, 2300)
      ELSE

*        Compute  (Jacobian)*DX.

         CALL DGEMV ( 'Normal', NCNLN, N, ONE, CJACU, LDCJU,
     $                DX, 1, ZERO, CJDX, 1 )

*        ---------------------------------------------------------------
*        Make forward-difference approximation along DX.
*        ---------------------------------------------------------------
         CALL DCOPY ( N,     X, 1, Y, 1 )
         CALL DAXPY ( N, H, DX, 1, Y, 1 )

         CALL ILOAD ( NCNLN, (1), NEEDC, 1 )

         MODE   = 0
         CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                NEEDC, Y, C1, CJACU, NSTATE )
         IF (MODE .LT. 0) GO TO 9999

*        Set  ERR = (C1 - C)/H  - Jacobian*DX.  This should be small.

         DO 170 I = 1, NCNLN
            ERR(I) = (C1(I) - C(I)) / H  -  CJDX(I)
  170    CONTINUE            
         IMAX  = IDAMAX( NCNLN, ERR, 1 )
         EMAX  = ABS(ERR(IMAX)) / (ABS(CJDX(IMAX)) + ONE)

         IF (EMAX .LE. OKTOL) THEN
            IF (MSGLVL .GT. 0) WRITE (NOUT, 2000)
         ELSE
            WRITE (NOUT, 2100)
            IF (EMAX .GE. POINT9) INFORM = 1
         END IF
         IF (MSGLVL .GE. 0) WRITE (NOUT, 2200) EMAX, IMAX
      END IF

*     ==================================================================
*     Component-wise check.
*     ==================================================================
      IF (LVRFYC .GE. 2) THEN
         IF (LVLDER .EQ. 3) THEN

*           Recompute the Jacobian to find the non-constant elements.

            CALL F06QHF( 'General', NCNLN, N, RDUMMY, RDUMMY, 
     $                   CJACU, LDCJU )

            CALL ILOAD ( NCNLN, (1), NEEDC, 1 )
            NSTATE = 0
            MODE   = 2

            CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                   NEEDC, X, C1, CJACU, NSTATE )
            IF (MODE .LT. 0) GO TO 9999

         END IF

         CALL ILOAD ( NCNLN, (0), NEEDC, 1 )

         ITMAX  =   3
         NCHECK =   0
         NWRONG =   0
         NGOOD  =   0
         COLMAX = - ONE
         JCOL   =   0
         IROW   =   0
         MODE   =   0
         J3     =   JVERFY(3)
         J4     =   JVERFY(4)

*        ---------------------------------------------------------------
*        Loop over each column.
*        ---------------------------------------------------------------
         DO 600 J = J3, J4

            CALL DLOAD ( NCNLN, ZERO, ERR, 1 )
            HEADNG = .TRUE.
            XJ     = X(J)

            STEPBL = BIGLOW
            STEPBU = BIGUPP
            IF (BL(J) .GT. BIGLOW) STEPBL = BL(J) - XJ
            IF (BU(J) .LT. BIGUPP) STEPBU = BU(J) - XJ

            SIGNH  = ONE
            IF (HALF*(STEPBL + STEPBU) .LT. ZERO) SIGNH =  - ONE

            DO 500, I = 1, NCNLN
               EPSACI   = EPSRF*(ONE + ABS( C(I) ))

               IF (CJACU(I,J) .NE. RDUMMY) THEN
*                 ------------------------------------------------------
*                 Check this Jacobian element.
*                 ------------------------------------------------------
                  NCHECK   = NCHECK + 1
                  NEEDC(I) = 1

                  CIJ    = CJAC(I,J)
                  CJSIZE = ABS( CIJ )
*                 ------------------------------------------------------
*                 Find a finite-difference interval by iteration.
*                 ------------------------------------------------------
                  ITER   = 0
                  HOPT   = TWO*(ONE + ABS( XJ ))*SQRT( EPSRF )
                  H      = TEN*HOPT*SIGNH
                  CDEST  = ZERO
                  SDEST  = ZERO
                  FIRST  = .TRUE.

*+                REPEAT
  400                X(J)  = XJ + H
                     CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                            NEEDC, X, C1, CJACU, NSTATE )
                     IF (MODE .LT. 0) GO TO 9999
                     F1    = C1(I)

                     X(J)  = XJ + H + H
                     CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                            NEEDC, X, C1, CJACU, NSTATE )
                     IF (MODE .LT. 0) GO TO 9999
                     F2    = C1(I)
                                                     
                     CALL CHCORE( DEBUG,DONE,FIRST,EPSACI,EPSRF,C(I),XJ,
     $                            INFO, ITER, ITMAX,
     $                            CDEST, FDEST, SDEST, ERRBND, F1,
     $                            F2, H, HOPT, HPHI )

*+                UNTIL     DONE
                  IF (.NOT. DONE) GO TO 400

*                 ------------------------------------------------------
*                 Exit for this element.
*                 ------------------------------------------------------
                  CJDIFF   = CDEST
                  ERR(I)   = ABS(CJDIFF - CIJ) / (CJSIZE + ONE)

                  OK       = ERR(I) .LE. OKTOL
                  IF (OK) THEN
                     KEY    = LGOOD
                     NGOOD  = NGOOD  + 1
                  ELSE
                     KEY    = LBAD
                     NWRONG = NWRONG + 1
                  END IF

                  CONST = OK .AND. INFO       .EQ. 1
     $                       .AND. ABS( CIJ ) .LT. EPSPT8
                  IF (.NOT. CONST) THEN
                     IF (HEADNG) THEN
                        WRITE (NOUT, 4000)
                        IF (OK)
     $                     WRITE (NOUT, 4100)   J, XJ    , HOPT, I,
     $                                        CIJ, CJDIFF, KEY , ITER
                        IF (.NOT. OK)
     $                     WRITE (NOUT, 4110)   J, XJ    , HOPT, I,
     $                                        CIJ, CJDIFF, KEY , ITER,
     $                                        RESULT(INFO)
                        HEADNG = .FALSE.
                     ELSE
                        IF (OK)
     $                     WRITE (NOUT, 4200)              HOPT, I,
     $                                        CIJ, CJDIFF, KEY , ITER
                        IF (.NOT. OK)
     $                     WRITE (NOUT, 4210)              HOPT, I,
     $                                        CIJ, CJDIFF, KEY , ITER,
     $                                        RESULT(INFO)
                     END IF
                  END IF
                  NEEDC(I) = 0
               END IF
  500       CONTINUE

*           ------------------------------------------------------------
*           Finished with this column.
*           ------------------------------------------------------------
            IF (.NOT. HEADNG) THEN
               IMAX = IDAMAX( NCNLN, ERR, 1 )
               EMAX = ABS( ERR(IMAX) )

               IF (EMAX .GE. COLMAX) THEN
                  IROW   = IMAX
                  JCOL   = J
                  COLMAX = EMAX
               END IF
            END IF
            X(J) = XJ

  600    CONTINUE

         INFORM = 0
         IF (NCHECK .EQ. 0) THEN
            WRITE (NOUT, 4600) NCSET
         ELSE
            IF (NWRONG .EQ. 0) THEN
               WRITE (NOUT, 4300) NGOOD , NCHECK, J3, J4
            ELSE
               WRITE (NOUT, 4400) NWRONG, NCHECK, J3, J4
               IF (COLMAX .GE. POINT9) INFORM = 1
            END IF
            WRITE (NOUT, 4500) COLMAX, IROW, JCOL
         END IF

      END IF

*     Copy  ( constants + gradients + dummy values )  back into CJACU.
      
      CALL F06QFF( 'General', NCNLN, N, CJAC, LDCJ, CJACU, LDCJU )

      RETURN            

 9999 INFORM = MODE
      RETURN

 1000 FORMAT(/// ' Verification of the constraint gradients.'
     $       /   ' -----------------------------------------' )
 2000 FORMAT(/   ' The constraint Jacobian seems to be ok.')
 2100 FORMAT(/   ' XXX  The constraint Jacobian seems to be incorrect.')
 2200 FORMAT(/   ' The largest relative error was', 1PE12.2,
     $           '  in row', I5 /)
 2300 FORMAT(/   ' Every column contains a constant or',
     $           ' missing element.')
 4000 FORMAT(// ' Column    X(J)     DX(J)    Row   ',
     $          ' Jacobian Value      Difference Approxn  Itns'    )
 4100 FORMAT(/ I7,      1P, 2E10.2, I5, 2E18.8, 2X, A4, I6         )
 4110 FORMAT(/ I7,      1P, 2E10.2, I5, 2E18.8, 2X, A4, I6, 2X, A18)
 4200 FORMAT(  7X, 10X, 1P,  E10.2, I5, 2E18.8, 2X, A4, I6         )
 4210 FORMAT(  7X, 10X, 1P,  E10.2, I5, 2E18.8, 2X, A4, I6, 2X, A18)
 4300 FORMAT(/ I7, '  constraint Jacobian elements out of the', I6,
     $             '  set in cols', I6, '  through', I6,
     $             '  seem to be ok.')
 4400 FORMAT(/   ' XXX  There seem to be', I6,
     $           '  incorrect Jacobian elements out of the', I6,
     $           '  set in cols', I6, '  through', I6 )
 4500 FORMAT(/ ' The largest relative error was', 1PE12.2,
     $         '  in row', I5, ',  column', I5 /)
 4600 FORMAT(  ' All', I6, '   assigned Jacobian elements are',
     $         ' constant.' )

*     End of  CHCJAC.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CHFJAC( INFORM, LVLDER, MSGLVL,
     $                   NFSET, M, N, LDFJ, LDFJU,
     $                   BIGBND, EPSRF, OKTOL, FDCHK, XNORM,
     $                   OBJFUN,
     $                   BL, BU, F, F1, FJAC, FJACU, FJDX,
     $                   DX, ERR, X, Y, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION   BL(N), BU(N), F(*), F1(*), FJDX(*),
     $                   FJAC(LDFJ,*), FJACU(LDFJU,*), ERR(*)
      DOUBLE PRECISION   DX(N), X(N), Y(N), W(LENW)
      EXTERNAL           OBJFUN

C***********************************************************************
C     CHFJAC  checks if the objective Jacobian matrix has been coded
C     correctly.
C
C     On input,  the values of the objective vector at the point X are
C     stored in F.  Their corresponding gradients are stored in FJACU.
C     If any Jacobian component has not been specified,  it will have a
C     dummy value.  Missing values are not checked.
C
C     A cheap test is first undertaken by calculating the directional
C     derivative using two different methods.  If this proves
C     satisfactory and no further information is desired, CHFJAC is
C     terminated.  Otherwise, CHCORE is called to give optimal stepsizes
C     and a central-difference approximation to each component of the
C     Jacobian for which a test is deemed necessary, either by the
C     program or the user.
C
C     LVRFYC has the following meaning...
C
C       -1        do not perform any check.
C        0        do the cheap test only.
C        2 or 3   do both cheap and full test.
C
C     Systems Optimization Laboratory, Stanford University.
C     Original version written  10-May-1988.
C     This version of CHFJAC dated  28-Jun-1989.
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      COMMON    /SOL5NP/ LVRFYC, JVERFY(4)

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            CONST , DEBUG , DONE  , FIRST , HEADNG
      LOGICAL            NEEDED, OK
      CHARACTER*4        KEY   , LBAD  , LGOOD
      CHARACTER*18       RESULT(0:4)
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      EXTERNAL           DDOT  , IDAMAX
      PARAMETER         (RDUMMY =-11111.0              )
      PARAMETER         (ZERO   =0.0D+0, HALF   =0.5D+0, POINT9 =0.9D+0)
      PARAMETER         (ONE    =1.0D+0, TWO    =2.0D+0, TEN    =1.0D+1)
      PARAMETER         (LBAD   ='BAD?', LGOOD  ='  OK')
      DATA               RESULT
     $                 / '                 ', 'Constant?      ',
     $                   'Linear or odd?   ', 'Too nonlinear?',
     $                   'Small derivative?'                   /

      INFORM = 0
      NEEDED = LVRFYC .EQ. 0  .OR.  LVRFYC .EQ. 1  .OR.  LVRFYC .EQ. 3
      IF (.NOT. NEEDED) RETURN

      WRITE (NOUT, 1000)
      DEBUG  = NPDBG  .AND.  INPDBG(5) .GT. 0
      NSTATE = 0

      BIGLOW = - BIGBND
      BIGUPP =   BIGBND

*     ==================================================================
*     Perform the cheap test.
*     ==================================================================
      H = (ONE + XNORM)*FDCHK

      DXJ  = ONE / N
      DO 110, J = 1, N
         DX(J) =   DXJ
         DXJ   = - DXJ*POINT9
  110 CONTINUE

*     ------------------------------------------------------------------
*     Do not perturb  X(J)  if the  J-th  column contains any
*     unknown elements.  Compute the directional derivative for each
*     objective gradient.
*     ------------------------------------------------------------------
      NCHECK = 0
      DO 140, J = 1, N
         DO 130, I = 1, M
            IF (FJAC(I,J) .EQ. RDUMMY) THEN
               DX(J) = ZERO
               GO TO 140
            END IF
  130    CONTINUE
         NCHECK = NCHECK + 1

         XJ     =   X(J)
         STEPBL = - ONE
         STEPBU =   ONE
         IF (BL(J) .GT. BIGLOW)
     $      STEPBL = MAX( STEPBL, BL(J) - XJ )
         IF (BU(J) .LT. BIGUPP  .AND.  BU(J) .GT. BL(J))
     $      STEPBU = MIN( STEPBU, BU(J) - XJ )

         IF (HALF*(STEPBL + STEPBU) .LT. ZERO) THEN
            DX(J) = DX(J)*STEPBL
         ELSE
            DX(J) = DX(J)*STEPBU
         END IF
  140 CONTINUE

      IF (NCHECK .EQ. 0) THEN
         WRITE (NOUT, 2300)
      ELSE

*        Compute  (Jacobian)*DX.

         CALL DGEMV ( 'Normal', M, N, ONE, FJACU, LDFJU,
     $                 DX, 1, ZERO, FJDX, 1 )

*        ---------------------------------------------------------------
*        Make forward-difference approximation along DX.
*        ---------------------------------------------------------------
         CALL DCOPY ( N,     X, 1, Y, 1 )
         CALL DAXPY ( N, H, DX, 1, Y, 1 )

         MODE   = 0
         CALL OBJFUN( MODE, M, N, LDFJU,
     $                Y, F1, FJACU, NSTATE )
         IF (MODE .LT. 0) GO TO 9999

*        Set  ERR = (F1 - F)/H  - Jacobian*DX.  This should be small.

         DO 170, I = 1, M
            ERR(I) = (F1(I) - F(I)) / H  -  FJDX(I)
  170    CONTINUE
         IMAX  = IDAMAX( M, ERR, 1 )
         EMAX  = ABS(ERR(IMAX)) / (ABS(FJDX(IMAX)) + ONE)

         IF (EMAX .LE. OKTOL) THEN
            IF (MSGLVL .GT. 0) WRITE (NOUT, 2000)
         ELSE
            WRITE (NOUT, 2100)
            IF (EMAX .GE. POINT9) INFORM = 1
         END IF
         IF (MSGLVL .GE. 0) WRITE (NOUT, 2200) EMAX, IMAX
      END IF

*     ==================================================================
*     Component-wise check.
*     ==================================================================
      IF (LVRFYC .GE. 2) THEN
         IF (LVLDER .EQ. 3) THEN

*           Recompute the Jacobian to find the non-constant elements.

            CALL F06QHF( 'General', M, N, RDUMMY, RDUMMY,
     $                   FJACU, LDFJU )

            NSTATE = 0
            MODE   = 2

            CALL OBJFUN( MODE, M, N, LDFJU,
     $                   X, F1, FJACU, NSTATE )
            IF (MODE .LT. 0) GO TO 9999

         END IF

         ITMAX  =   3
         NCHECK =   0
         NWRONG =   0
         NGOOD  =   0
         COLMAX = - ONE
         JCOL   =   0
         IROW   =   0
         MODE   =   0
         J3     =   JVERFY(3)
         J4     =   JVERFY(4)

*        ---------------------------------------------------------------
*        Loop over each column.
*        ---------------------------------------------------------------
         DO 600, J = J3, J4

            CALL DLOAD ( M, ZERO, ERR, 1 )
            HEADNG = .TRUE.
            XJ     = X(J)

            STEPBL = BIGLOW
            STEPBU = BIGUPP
            IF (BL(J) .GT. BIGLOW) STEPBL = BL(J) - XJ
            IF (BU(J) .LT. BIGUPP) STEPBU = BU(J) - XJ   
                                                 
            SIGNH  = ONE
            IF (HALF*(STEPBL + STEPBU) .LT. ZERO) SIGNH =  - ONE

            DO 500, I = 1, M
               EPSAFI   = EPSRF*(ONE + ABS( F(I) ))

               IF (FJACU(I,J) .NE. RDUMMY) THEN
*                 ------------------------------------------------------
*                 Check this Jacobian element.
*                 ------------------------------------------------------
                  NCHECK   = NCHECK + 1

                  FIJ    = FJAC(I,J)
                  FJSIZE = ABS( FIJ )
*                 ------------------------------------------------------
*                 Find a finite-difference interval by iteration.
*                 ------------------------------------------------------
                  ITER   = 0
                  HOPT   = TWO*(ONE + ABS( XJ ))*SQRT( EPSRF )
                  H      = TEN*HOPT*SIGNH
                  CDEST  = ZERO
                  SDEST  = ZERO
                  FIRST  = .TRUE.

*+                REPEAT
  400                X(J)  = XJ + H
                     CALL OBJFUN( MODE, M, N, LDFJU,
     $                            X, F1, FJACU, NSTATE )
                     IF (MODE .LT. 0) GO TO 9999
                     FFORW = F1(I)

                     X(J)  = XJ + H + H
                     CALL OBJFUN( MODE, M, N, LDFJU,
     $                            X, F1, FJACU, NSTATE )
                     IF (MODE .LT. 0) GO TO 9999
                     FBACK = F1(I)

                     CALL CHCORE( DEBUG,DONE,FIRST,EPSAFI,EPSRF,F(I),XJ,
     $                            INFO, ITER, ITMAX,
     $                            CDEST, FDEST, SDEST, ERRBND, FFORW,
     $                            FBACK, H, HOPT, HPHI )

*+                UNTIL     DONE
                  IF (.NOT. DONE) GO TO 400

*                 ------------------------------------------------------
*                 Exit for this element.
*                 ------------------------------------------------------
                  FJDIFF   = CDEST
                  ERR(I)   = ABS(FJDIFF - FIJ) / (FJSIZE + ONE)

                  OK       = ERR(I) .LE. OKTOL
                  IF (OK) THEN
                     KEY    = LGOOD
                     NGOOD  = NGOOD  + 1
                  ELSE
                     KEY    = LBAD
                     NWRONG = NWRONG + 1
                  END IF

                  CONST = OK .AND. INFO       .EQ. 1
     $                       .AND. ABS( FIJ ) .LT. EPSPT8
                  IF (.NOT. CONST) THEN
                     IF (HEADNG) THEN
                        WRITE (NOUT, 4000)
                        IF (OK)
     $                     WRITE (NOUT, 4100)   J, XJ    , HOPT, I,
     $                                        FIJ, FJDIFF, KEY , ITER
                        IF (.NOT. OK)
     $                     WRITE (NOUT, 4110)   J, XJ    , HOPT, I,
     $                                        FIJ, FJDIFF, KEY , ITER,
     $                                        RESULT(INFO)
                        HEADNG = .FALSE.
                     ELSE
                        IF (OK)
     $                     WRITE (NOUT, 4200)              HOPT, I,
     $                                        FIJ, FJDIFF, KEY , ITER
                        IF (.NOT. OK)
     $                     WRITE (NOUT, 4210)              HOPT, I,
     $                                        FIJ, FJDIFF, KEY , ITER,
     $                                        RESULT(INFO)
                     END IF
                  END IF
               END IF
  500       CONTINUE

*           ------------------------------------------------------------
*           Finished with this column.
*           ------------------------------------------------------------
            IF (.NOT. HEADNG) THEN
               IMAX = IDAMAX( M, ERR, 1 )
               EMAX = ABS( ERR(IMAX) )

               IF (EMAX .GE. COLMAX) THEN
                  IROW   = IMAX
                  JCOL   = J
                  COLMAX = EMAX
               END IF
            END IF
            X(J) = XJ

  600    CONTINUE

         INFORM = 0
         IF (NCHECK .EQ. 0) THEN
            WRITE (NOUT, 4600) NFSET
         ELSE
            IF (NWRONG .EQ. 0) THEN
               WRITE (NOUT, 4300) NGOOD , NCHECK, J3, J4
            ELSE
               WRITE (NOUT, 4400) NWRONG, NCHECK, J3, J4
               IF (COLMAX .GE. POINT9) INFORM = 1
            END IF
            WRITE (NOUT, 4500) COLMAX, IROW, JCOL
         END IF

      END IF

*     Copy  ( constants + gradients + dummy values )  back into FJACU.

      CALL F06QFF( 'General', M, N, FJAC, LDFJ, FJACU, LDFJU )

      RETURN

 9999 INFORM = MODE
      RETURN

 1000 FORMAT(/// ' Verification of the objective gradients.'
     $       /   ' ----------------------------------------' )
 2000 FORMAT(/   ' The objective Jacobian seems to be ok.')
 2100 FORMAT(/   ' XXX  The objective Jacobian seems to be incorrect.')
 2200 FORMAT(/   ' The largest relative error was', 1PE12.2,
     $           '  in row', I5 /)
 2300 FORMAT(/   ' Every column contains a constant or',
     $           ' missing element.')
 4000 FORMAT(// ' Column    X(J)     DX(J)    Row   ',
     $          ' Jacobian Value      Difference Approxn  Itns'    )
 4100 FORMAT(/ I7,      1P, 2E10.2, I5, 2E18.8, 2X, A4, I6         )
 4110 FORMAT(/ I7,      1P, 2E10.2, I5, 2E18.8, 2X, A4, I6, 2X, A18)
 4200 FORMAT(  7X, 10X, 1P,  E10.2, I5, 2E18.8, 2X, A4, I6         )
 4210 FORMAT(  7X, 10X, 1P,  E10.2, I5, 2E18.8, 2X, A4, I6, 2X, A18)
 4300 FORMAT(/ I7, '  Objective Jacobian elements out of the', I6,
     $             '  set in cols', I6, '  through', I6,
     $             '  seem to be ok.')
 4400 FORMAT(/   ' XXX  There seem to be', I6,
     $           '  incorrect objective Jacobian elements out of the',
     $             I6, '  set in cols', I6, '  through', I6 )
 4500 FORMAT(/ ' The largest relative error was', 1PE12.2,
     $         '  in row', I5, ',  column', I5 /)
 4600 FORMAT(  ' All', I6, '   assigned Jacobian elements are',
     $         ' constant.' )

*     End of  CHFJAC.

      END

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  OPSUBS FORTRAN
*
*     OPFILE   OPLOOK   OPNUMB   OPSCAN   OPTOKN   OPUPPR
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE OPFILE( IOPTNS, NOUT, INFORM, OPKEY )
      INTEGER            IOPTNS, NOUT, INFORM
      EXTERNAL           OPKEY

************************************************************************
*     OPFILE  reads the options file from unit  IOPTNS  and loads the
*     options into the relevant elements of the integer and real
*     parameter arrays.
*
*     Systems Optimization Laboratory, Stanford University.
*     This version dated December 18, 1985.
************************************************************************
      LOGICAL             PRNT
      CHARACTER*16        KEY   , TOKEN(1)
      CHARACTER*72        BUFFER, OLDBUF

      PRNT   = .TRUE.

*     Return if the unit number is out of range.

      IF (IOPTNS .LT. 0  .OR.  IOPTNS .GT. 99) THEN
         INFORM = 1
         RETURN
      END IF

*     ------------------------------------------------------------------
*     Look for  BEGIN, ENDRUN  or  SKIP.
*     ------------------------------------------------------------------
      NREAD  = 0
   50    READ (IOPTNS, '(A)', END = 930) BUFFER
         NREAD = NREAD + 1
         NKEY  = 1
         CALL OPTOKN( BUFFER, NKEY, TOKEN )
         KEY   = TOKEN(1)
         IF (KEY .EQ. 'ENDRUN') GO TO 940
         IF (KEY .NE. 'BEGIN' ) THEN
            IF (NREAD .EQ. 1  .AND.  KEY .NE. 'SKIP') THEN
               WRITE (NOUT, 2000) IOPTNS, BUFFER
            END IF
            GO TO 50
         END IF

*     ------------------------------------------------------------------
*     BEGIN found.
*     This is taken to be the first line of an OPTIONS file.
*     Read the second line to see if it is NOLIST.
*     ------------------------------------------------------------------
      OLDBUF = BUFFER
      READ (IOPTNS, '(A)', END = 920) BUFFER

      CALL OPKEY ( NOUT, BUFFER, KEY )

      IF (KEY .EQ. 'NOLIST') THEN
         PRNT   = .FALSE.
      END IF

      IF (PRNT) THEN
         WRITE (NOUT, '(// A / A /)')
     $      ' OPTIONS file',
     $      ' ------------'
         WRITE (NOUT, '(6X, A )') OLDBUF, BUFFER
      END IF

*     ------------------------------------------------------------------
*     Read the rest of the file.
*     ------------------------------------------------------------------
*+    while (key .ne. 'end') loop
  100 IF    (KEY .NE. 'END') THEN
         READ (IOPTNS, '(A)', END = 920) BUFFER
         IF (PRNT)
     $      WRITE (NOUT, '( 6X, A )') BUFFER

         CALL OPKEY ( NOUT, BUFFER, KEY )

         IF (KEY .EQ.   'LIST') PRNT = .TRUE.
         IF (KEY .EQ. 'NOLIST') PRNT = .FALSE.
         GO TO 100
      END IF
*+    end while

      INFORM =  0
      RETURN

  920 WRITE (NOUT, 2200) IOPTNS
      INFORM = 2
      RETURN

  930 WRITE (NOUT, 2300) IOPTNS
      INFORM = 3
      RETURN

  940 WRITE (NOUT, '(// 6X, A)') BUFFER
      INFORM = 4
      RETURN

 2000 FORMAT(
     $ //' XXX  Error while looking for an OPTIONS file on unit', I7
     $ / ' XXX  The file should start with BEGIN, SKIP or ENDRUN'
     $ / ' XXX  but the first record found was the following:'
     $ //' ---->', A
     $ //' XXX  Continuing to look for OPTIONS file...')
 2200 FORMAT(//' XXX  End-of-file encountered while processing',
     $         ' an OPTIONS file on unit', I6)
 2300 FORMAT(//' XXX  End-of-file encountered while looking for',
     $         ' an OPTIONS file on unit', I6)

*     End of  OPFILE.

      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE OPLOOK (NDICT, DICTRY, ALPHA, KEY, ENTRY)
C
C
C Description and usage:
C
C       Performs dictionary lookups.  A pointer is returned if a
C    match is found between the input key and the corresponding
C    initial characters of one of the elements of the dictionary.
C    If a "synonym" has been provided for an entry, the search is
C    continued until a match to a primary dictionary entry is found.
C    Cases of no match, or multiple matches, are also provided for.
C
C     Dictionary entries must be left-justified, and may be alphabetized
C    for faster searches.  Secondary entries, if any, are composed of
C    two words separated by one or more characters such as blank, tab,
C    comma, colon, or equal sign which are treated as non-significant
C    by OPSCAN.  The first entry of each such pair serves as a synonym
C    for the second, more fundamental keyword.
C
C       The ordered search stops after the section of the dictionary
C    having the same first letters as the key has been checked, or
C    after a specified number of entries have been examined.  A special
C    dictionary entry, the vertical bar '|', will also terminate the
C    search.  This will speed things up if an appropriate dictionary
C    length parameter cannot be determined.  Both types of search are
C    sequential.  See "Notes" below for some suggestions if efficiency
C    is an issue.
C
C
C Parameters:
C
C    Name    Dimension  Type  I/O/S  Description
C    NDICT               I    I      Number of dictionary entries to be
C                                    examined.
C    DICTRY  NDICT       C    I      Array of dictionary entries,
C                                    left-justified in their fields.
C                                    May be alphabetized for efficiency,
C                                    in which case ALPHA should be
C                                    .TRUE.  Entries with synonyms are
C                                    of the form
C                                    'ENTRY : SYNONYM', where 'SYNONYM'
C                                    is a more fundamental entry in the
C                                    same dictionary.  NOTE: Don't build
C                                    "circular" dictionaries!
C    ALPHA               L    I      Indicates whether the dictionary
C                                    is in alphabetical order, in which
C                                    case the search can be terminated
C                                    sooner.
C    KEY                 C    I/O    String to be compared against the
C                                    dictionary.  Abbreviations are OK
C                                    if they correspond to a unique
C                                    entry in the dictionary.  KEY is
C                                    replaced on termination by its most
C                                    fundamental equivalent dictionary
C                                    entry (uppercase, left-justified)
C                                    if a match was found.
C    ENTRY               I      O    Dictionary pointer.  If > 0, it
C                                    indicates which entry matched KEY.
C                                    In case of trouble, a negative
C                                    value means that a UNIQUE match
C                                    was not found - the absolute value
C                                    of ENTRY points to the second
C                                    dictionary entry that matched KEY.
C                                    Zero means that NO match could be
C                                    found.  ENTRY always refers to the
C                                    last search performed -
C                                    in searching a chain of synonyms,
C                                    a non-positive value will be
C                                    returned if there is any break,
C                                    even if the original input key
C                                    was found.
C
C
C External references:
C
C    Name    Description
C    OPSCAN  Finds first and last significant characters.
C
C
C Environment:  Digital VAX-11/780 VMS FORTRAN (FORTRAN 77).
C               Appears to satisfy the ANSI Fortran 77 standard.
C
C
C Notes:
C
C    (1)  IMPLICIT NONE is non-standard.  (Has been commented out.)
C
C    (2)  We have assumed that the dictionary is not too big.  If
C         many searches are to be done or if the dictionary has more
C         than a dozen or so entries, it may be advantageous to build
C         an index array of pointers to the beginning of the section
C         of the dictionary containing each letter, then pass in the
C         portion of the dictionary beginning with DICTRY (INDEX).
C         (This won't generally work for dictionaries with synonyms.)
C         For very large problems, a completely different approach may
C         be advisable, e.g. a binary search for ordered dictionaries.
C
C    (3)  OPLOOK is case sensitive.  In most applications it will be
C         necessary to use an uppercase dictionary, and to convert the
C         input key to uppercase before calling OPLOOK.  Companion
C         routines OPTOKN and PAIRS, available from the author, already
C         take care of this.
C
C    (4)  The key need not be left-justified.  Any leading (or
C         trailing) characters which are "non-significant" to OPSCAN
C         will be ignored.  These include blanks, horizontal tabs,
C         commas, colons, and equal signs.  See OPSCAN for details.
C
C    (5)  The ASCII collating sequence for character data is assumed.
C         (N.B. This means the numerals precede the alphabet, unlike
C         common practice!)  This should not cause trouble on EBCDIC
C         machines if DICTRY just contains alphabetic keywords.
C         Otherwise it may be necessary to use the FORTRAN lexical
C         library routines to force use of the ASCII sequence.
C
C    (6)  Parameter NUMSIG sets a limit on the length of significant
C         dictionary entries.  Special applications may require that
C         this be increased.  (It is 16 in the present version.)
C
C    (7)  No protection against "circular" dictionaries is provided:
C         don't claim that A is B, and that B is A.  All synonym chains
C         must terminate!  Other potential errors not checked for
C         include duplicate or mis-ordered entries.
C
C    (8)  The handling of ambiguities introduces some ambiguity:
C
C            ALPHA = .TRUE.  A potential problem, when one entry
C                            looks like an abbreviation for another
C                            (eg. does 'A' match 'A' or 'AB'?) was
C                            resolved by dropping out of the search
C                            immediately when an "exact" match is found.
C
C            ALPHA = .FALSE. The programmer must ensure that the above
C                            situation does not arise: each dictionary
C                            entry must be recognizable, at least when
C                            specified to full length.  Otherwise, the
C                            result of a search will depend on the
C                            order of entries.
C
C
C Author:  Robert Kennelly, Informatics General Corporation.
C
C
C Development history:
C
C    24 Feb. 1984  RAK/DAS  Initial design and coding.
C    25 Feb. 1984    RAK    Combined the two searches by suitable
C                           choice of terminator FLAG.
C    28 Feb. 1984    RAK    Optional synonyms in dictionary, no
C                           longer update KEY.
C    29 Mar. 1984    RAK    Put back replacement of KEY by its
C                           corresponding entry.
C    21 June 1984    RAK    Corrected bug in error handling for cases
C                           where no match was found.
C    23 Apr. 1985    RAK    Introduced test for exact matches, which
C                           permits use of dictionary entries which
C                           would appear to be ambiguous (for ordered
C                           case).  Return -I to point to the entry
C                           which appeared ambiguous (had been -1).
C                           Repaired loop termination - had to use
C                           equal length strings or risk quitting too
C                           soon when one entry is an abbreviation
C                           for another.  Eliminated HIT, reduced
C                           NUMSIG to 16.
C    15 Nov. 1985    MAS    Loop 20 now tests .LT. FLAG, not .LE. FLAG.
C                           If ALPHA is false, FLAG is now '|', not '{'.
C    26 Jan. 1986    PEG    Declaration of FLAG and TARGET modified to
C                           conform to ANSI-77 standard.
C-----------------------------------------------------------------------


C     Variable declarations.
C     ----------------------

*     IMPLICIT NONE

C     Parameters.

      INTEGER
     $   NUMSIG
      CHARACTER
     $   BLANK, VBAR
      PARAMETER
     $   (BLANK = ' ', VBAR = '|', NUMSIG = 16)

C     Variables.

      LOGICAL
     $   ALPHA
      INTEGER
     $   ENTRY, FIRST, I, LAST, LENGTH, MARK, NDICT
*     CHARACTER
*    $   DICTRY (NDICT) * (*), FLAG * (NUMSIG),
*    $   KEY * (*), TARGET * (NUMSIG)
      CHARACTER
     $   DICTRY (NDICT) * (*), FLAG * 16,
     $   KEY * (*), TARGET * 16

C     Procedures.

      EXTERNAL
     $   OPSCAN


C     Executable statements.
C     ----------------------

      ENTRY = 0

C     Isolate the significant portion of the input key (if any).

      FIRST = 1
      LAST  = MIN( LEN(KEY), NUMSIG )
      CALL OPSCAN (KEY, FIRST, LAST, MARK)

      IF (MARK .GT. 0) THEN
         TARGET = KEY (FIRST:MARK)

C        Look up TARGET in the dictionary.

   10    CONTINUE
            LENGTH = MARK - FIRST + 1

C           Select search strategy by cunning choice of termination test
C           flag.  The vertical bar is just about last in both the
C           ASCII and EBCDIC collating sequences.

            IF (ALPHA) THEN
               FLAG = TARGET
            ELSE
               FLAG = VBAR
            END IF


C           Perform search.
C           ---------------

            I = 0
   20       CONTINUE
               I = I + 1
               IF (TARGET (1:LENGTH) .EQ. DICTRY (I) (1:LENGTH)) THEN
                  IF (ENTRY .EQ. 0) THEN

C                    First "hit" - must still guard against ambiguities
C                    by searching until we've gone beyond the key
C                    (ordered dictionary) or until the end-of-dictionary
C                    mark is reached (exhaustive search).

                     ENTRY = I

C                    Special handling if match is exact - terminate
C                    search.  We thus avoid confusion if one dictionary
C                    entry looks like an abbreviation of another.
C                    This fix won't generally work for un-ordered
C                    dictionaries!

                     FIRST = 1
                     LAST = NUMSIG
                     CALL OPSCAN (DICTRY (ENTRY), FIRST, LAST, MARK)
                     IF (MARK .EQ. LENGTH) I = NDICT
                  ELSE


C                    Oops - two hits!  Abnormal termination.
C                    ---------------------------------------

                     ENTRY = -I
                     RETURN
                  END IF
               END IF

C           Check whether we've gone past the appropriate section of the
C           dictionary.  The test on the index provides insurance and an
C           optional means for limiting the extent of the search.

            IF (DICTRY (I) (1:LENGTH) .LT. FLAG  .AND.  I .LT. NDICT)
     $         GO TO 20


C           Check for a synonym.
C           --------------------

            IF (ENTRY .GT. 0) THEN

C              Look for a second entry "behind" the first entry.  FIRST
C              and MARK were determined above when the hit was detected.

               FIRST = MARK + 2
               CALL OPSCAN (DICTRY (ENTRY), FIRST, LAST, MARK)
               IF (MARK .GT. 0) THEN

C                 Re-set target and dictionary pointer, then repeat the
C                 search for the synonym instead of the original key.

                  TARGET = DICTRY (ENTRY) (FIRST:MARK)
                  ENTRY = 0
                  GO TO 10

               END IF
            END IF

      END IF
      IF (ENTRY .GT. 0) KEY = DICTRY (ENTRY)


C     Normal termination.
C     -------------------

      RETURN

C     End of OPLOOK
      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      FUNCTION OPNUMB( STRING )

      LOGICAL          OPNUMB
      CHARACTER*(*)    STRING

************************************************************************
*     Description and usage:
*
*        A simple(-minded) test for numeric data is implemented by
*        searching an input string for legitimate characters:
*                digits 0 to 9, D, E, -, + and .
*        Insurance is provided by requiring that a numeric string
*        have at least one digit, at most one D, E or .
*        and at most two -s or +s.  Note that a few ambiguities remain:
*
*           (a)  A string might have the form of numeric data but be
*                intended as text.  No general test can hope to detect
*                such cases.
*
*           (b)  There is no check for correctness of the data format.
*                For example a meaningless string such as 'E1.+2-'
*                will be accepted as numeric.
*
*        Despite these weaknesses, the method should work in the
*        majority of cases.
*
*
*     Parameters:
*
*        Name    Dimension  Type  I/O/S  Description
*        OPNUMB              L      O    Set .TRUE. if STRING appears
*                                        to be numerical data.
*        STRING              C    I      Input data to be tested.
*
*
*     Environment:  ANSI FORTRAN 77.
*
*
*     Notes:
*
*        (1)  It is assumed that STRING is a token extracted by
*             OPTOKN, which will have converted any lower-case
*             characters to upper-case.
*
*        (2)  OPTOKN pads STRING with blanks, so that a genuine
*             number is of the form  '1234        '.
*             Hence, the scan of STRING stops at the first blank.
*
*        (3)  COMPLEX data with parentheses will not look numeric.
*
*
*     Systems Optimization Laboratory, Stanford University.
*     12 Nov  1985    Initial design and coding, starting from the
*                     routine ALPHA from Informatics General, Inc.
************************************************************************

      LOGICAL         NUMBER
      INTEGER         J, LENGTH, NDIGIT, NEXP, NMINUS, NPLUS, NPOINT
      CHARACTER*1     ATOM

      NDIGIT = 0
      NEXP   = 0
      NMINUS = 0
      NPLUS  = 0
      NPOINT = 0
      NUMBER = .TRUE.
      LENGTH = LEN (STRING)
      J      = 0

   10    J    = J + 1
         ATOM = STRING (J:J)
         IF      (ATOM .GE. '0'  .AND.  ATOM .LE. '9') THEN
            NDIGIT = NDIGIT + 1
         ELSE IF (ATOM .EQ. 'D'  .OR.   ATOM .EQ. 'E') THEN
            NEXP   = NEXP   + 1
         ELSE IF (ATOM .EQ. '-') THEN
            NMINUS = NMINUS + 1
         ELSE IF (ATOM .EQ. '+') THEN
            NPLUS  = NPLUS  + 1
         ELSE IF (ATOM .EQ. '.') THEN
            NPOINT = NPOINT + 1
         ELSE IF (ATOM .EQ. ' ') THEN
            J      = LENGTH
         ELSE
            NUMBER = .FALSE.
         END IF

         IF (NUMBER  .AND.  J .LT. LENGTH) GO TO 10

      OPNUMB = NUMBER
     $         .AND.  NDIGIT .GE. 1
     $         .AND.  NEXP   .LE. 1
     $         .AND.  NMINUS .LE. 2
     $         .AND.  NPLUS  .LE. 2
     $         .AND.  NPOINT .LE. 1

      RETURN

*     End of OPNUMB
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE OPSCAN (STRING, FIRST, LAST, MARK)
C
C
C Description and usage:
C
C       Looks for non-blank fields ("tokens") in a string, where the
C    fields are of arbitrary length, separated by blanks, tabs, commas,
C    colons, or equal signs.  The position of the end of the 1st token
C    is also returned, so this routine may be conveniently used within
C    a loop to process an entire line of text.
C
C       The procedure examines a substring, STRING (FIRST : LAST), which
C    may of course be the entire string (in which case just call OPSCAN
C    with FIRST <= 1 and LAST >= LEN (STRING) ).  The indices returned
C    are relative to STRING itself, not the substring.
C
C
C Parameters:
C
C    Name    Dimension  Type  I/O/S  Description
C    STRING              C    I      Text string containing data to be
C                                    scanned.
C    FIRST               I    I/O    Index of beginning of substring.
C                                    If <= 1, the search begins with 1.
C                                    Output is index of beginning of
C                                    first non-blank field, or 0 if no
C                                    token was found.
C    LAST                I    I/O    Index of end of substring.
C                                    If >= LEN (STRING), the search
C                                    begins with LEN (STRING).  Output
C                                    is index of end of last non-blank
C                                    field, or 0 if no token was found.
C    MARK                I      O    Points to end of first non-blank
C                                    field in the specified substring.
C                                    Set to 0 if no token was found.
C
C
C Environment:  Digital VAX-11/780 VMS FORTRAN (FORTRAN 77).
C               ANSI Fortran 77, except for the tab character HT.
C
C Notes:
C
C    (1)  IMPLICIT NONE is non-standard.  Constant HT (Tab) is defined
C         in a non-standard way:  the CHAR function is not permitted
C         in a PARAMETER declaration (OK on VAX, though).  For Absoft
C         FORTRAN 77 on 68000 machines, use HT = 9.  In other cases, it
C         may be best to declare HT as a variable and assign
C         HT = CHAR(9) on ASCII machines, or CHAR(5) for EBCDIC.
C
C    (2)  The pseudo-recursive structure was chosen for fun.  It is
C         equivalent to three DO loops with embedded GO TOs in sequence.
C
C    (3)  The variety of separators recognized limits the usefulness of
C         this routine somewhat.  The intent is to facilitate handling
C         such tokens as keywords or numerical values.  In other
C         applications, it may be necessary for ALL printing characters
C         to be significant.  A simple modification to statement
C         function SOLID will do the trick.
C
C
C Author:  Robert Kennelly, Informatics General Corporation.
C
C
C Development history:
C
C    29 Dec. 1984    RAK    Initial design and coding, (very) loosely
C                           based on SCAN_STRING by Ralph Carmichael.
C    25 Feb. 1984    RAK    Added ':' and '=' to list of separators.
C    16 Apr. 1985    RAK    Defined SOLID in terms of variable DUMMY
C                           (previous re-use of STRING was ambiguous).
C
C-----------------------------------------------------------------------


C     Variable declarations.
C     ----------------------

*     IMPLICIT NONE

C     Parameters.

      CHARACTER
     $   BLANK, EQUAL, COLON, COMMA, HT
      PARAMETER
     $   (BLANK = ' ', EQUAL = '=', COLON = ':', COMMA = ',')

C     Variables.

      LOGICAL
     $   SOLID
      INTEGER
     $   BEGIN, END, FIRST, LAST, LENGTH, MARK
      CHARACTER
     $   DUMMY, STRING * (*)

C     Statement functions.

      SOLID (DUMMY) = (DUMMY .NE. BLANK) .AND.
     $                (DUMMY .NE. COLON) .AND.
     $                (DUMMY .NE. COMMA) .AND.
     $                (DUMMY .NE. EQUAL) .AND.
     $                (DUMMY .NE. HT)


C     Executable statements.
C     ----------------------

****  HT     = CHAR(9) for ASCII machines, CHAR(5) for EBCDIC.
      HT     = CHAR(9)
      MARK   = 0
      LENGTH = LEN (STRING)
      BEGIN  = MAX (FIRST, 1)
      END    = MIN (LENGTH, LAST)

C     Find the first significant character ...

      DO 30 FIRST = BEGIN, END, +1
         IF (SOLID (STRING (FIRST : FIRST))) THEN

C           ... then the end of the first token ...

            DO 20 MARK = FIRST, END - 1, +1
               IF (.NOT.SOLID (STRING (MARK + 1 : MARK + 1))) THEN

C                 ... and finally the last significant character.

                  DO 10 LAST = END, MARK, -1
                     IF (SOLID (STRING (LAST : LAST))) THEN
                        RETURN
                     END IF
   10             CONTINUE

C                 Everything past the first token was a separator.

                  LAST = LAST + 1
                  RETURN
               END IF
   20       CONTINUE

C           There was nothing past the first token.

            LAST = MARK
            RETURN
         END IF
   30 CONTINUE

C     Whoops - the entire substring STRING (BEGIN : END) was composed of
C     separators !

      FIRST = 0
      MARK = 0
      LAST = 0
      RETURN

C     End of OPSCAN
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE OPTOKN (STRING, NUMBER, LIST)
C
C
C Description and usage:
C
C       An aid to parsing input data.  The individual "tokens" in a
C    character string are isolated, converted to uppercase, and stored
C    in an array.  Here, a token is a group of significant, contiguous
C    characters.  The following are NON-significant, and hence may
C    serve as separators:  blanks, horizontal tabs, commas, colons,
C    and equal signs.  See OPSCAN for details.  Processing continues
C    until the requested number of tokens have been found or the end
C    of the input string is reached.
C
C
C Parameters:
C
C    Name    Dimension  Type  I/O/S  Description
C    STRING              C    I      Input string to be analyzed.
C    NUMBER              I    I/O    Number of tokens requested (input)
C                                    and found (output).
C    LIST    NUMBER      C      O    Array of tokens, changed to upper
C                                    case.
C
C
C External references:
C
C    Name    Description
C    OPSCAN  Finds positions of first and last significant characters.
C    OPUPPR  Converts a string to uppercase.
C
C
C Environment:  Digital VAX-11/780 VMS FORTRAN (FORTRAN 77).
C               Appears to satisfy the ANSI Fortran 77 standard.
C
C
C Notes:
C
C    (1)  IMPLICIT NONE is non-standard.  (Has been commented out.)
C
C
C Author:  Robert Kennelly, Informatics General Corporation.
C
C
C Development history:
C
C    16 Jan. 1984    RAK    Initial design and coding.
C    16 Mar. 1984    RAK    Revised header to reflect full list of
C                           separators, repaired faulty WHILE clause
C                           in "10" loop.
C    18 Sep. 1984    RAK    Change elements of LIST to uppercase one
C                           at a time, leaving STRING unchanged.
C
C-----------------------------------------------------------------------


C     Variable declarations.
C     ----------------------

*     IMPLICIT NONE

C     Parameters.

      CHARACTER
     $   BLANK
      PARAMETER
     $   (BLANK = ' ')

C     Variables.

      INTEGER
     $   COUNT, FIRST, I, LAST, MARK, NUMBER
      CHARACTER
     $   STRING * (*), LIST (NUMBER) * (*)

C     Procedures.

      EXTERNAL
     $   OPUPPR, OPSCAN


C     Executable statements.
C     ----------------------

C     WHILE there are tokens to find, loop UNTIL enough have been found.

      FIRST = 1
      LAST = LEN (STRING)

      COUNT = 0
   10 CONTINUE

C        Get delimiting indices of next token, if any.

         CALL OPSCAN (STRING, FIRST, LAST, MARK)
         IF (LAST .GT. 0) THEN
            COUNT = COUNT + 1

C           Pass token to output string array, then change case.

            LIST (COUNT) = STRING (FIRST : MARK)
            CALL OPUPPR (LIST (COUNT))
            FIRST = MARK + 2
            IF (COUNT .LT. NUMBER) GO TO 10

         END IF


C     Fill the rest of LIST with blanks and set NUMBER for output.

      DO 20 I = COUNT + 1, NUMBER
         LIST (I) = BLANK
   20 CONTINUE

      NUMBER = COUNT


C     Termination.
C     ------------

      RETURN

C     End of OPTOKN
      END
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      SUBROUTINE OPUPPR(STRING)
C
C ACRONYM:  UPper CASE
C
C PURPOSE:  This subroutine changes all lower case letters in the
C           character string to upper case.
C
C METHOD:   Each character in STRING is treated in turn.  The intrinsic
C           function INDEX effectively allows a table lookup, with
C           the local strings LOW and UPP acting as two tables.
C           This method avoids the use of CHAR and ICHAR, which appear
C           be different on ASCII and EBCDIC machines.
C
C ARGUMENTS
C    ARG       DIM     TYPE I/O/S DESCRIPTION
C  STRING       *       C   I/O   Character string possibly containing
C                                 some lower-case letters on input;
C                                 strictly upper-case letters on output
C                                 with no change to any non-alphabetic
C                                 characters.
C
C EXTERNAL REFERENCES:
C  LEN    - Returns the declared length of a CHARACTER variable.
C  INDEX  - Returns the position of second string within first.
C
C ENVIRONMENT:  ANSI FORTRAN 77
C
C DEVELOPMENT HISTORY:
C     DATE  INITIALS  DESCRIPTION
C   06/28/83   CLH    Initial design.
C   01/03/84   RAK    Eliminated NCHAR input.
C   06/14/84   RAK    Used integer PARAMETERs in comparison.
C   04/21/85   RAK    Eliminated DO/END DO in favor of standard code.
C   09/10/85   MAS    Eliminated CHAR,ICHAR in favor of LOW, UPP, INDEX.
C
C AUTHOR: Charles Hooper, Informatics General, Palo Alto, CA.
C
C-----------------------------------------------------------------------

      CHARACTER      STRING * (*)
      INTEGER        I, J
      CHARACTER      C*1, LOW*26, UPP*26
      DATA           LOW /'abcdefghijklmnopqrstuvwxyz'/,
     $               UPP /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

      DO 10 J = 1, LEN(STRING)
         C    = STRING(J:J)
         IF (C .GE. 'a'  .AND.  C .LE. 'z') THEN
            I           = INDEX( LOW, C )
            IF (I .GT. 0) STRING(J:J) = UPP(I:I)
         END IF
   10 CONTINUE
      RETURN
     
*     End of OPUPPR

      END 

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     confun.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine confun(mode,ncnln,n,nrowj,needc,x,c,cjac,nstate)   
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save
      integer*4 mode,ncnln,n,nrowj,needc,nstate
      real*8    x,c,cjac
      dimension needc(*)
      dimension x(n),c(*),cjac(nrowj,*)
      return
      end 

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     mcarlo.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine mcarlo(mode,lvec,vec,objf,objgrd,nstate)
      implicit  real*8 (a-h,o-z)
      implicit  integer*4 (i-n)
      save

      include "global.f"

      real*8 objf,tmp
      real*8 vec,objgrd
      real*8 V,W,work
      real*8 sum,sumdel,u
      real*8 ftrial,fobs

      integer*4 mode,lvec,nstate
      integer*4 jseed,i,j,ii,jj,isw

      real*8 eps
      integer*4 mV,mwork

      parameter (mV=200,mwork=500,eps=1.d-300)

      dimension vec(lvec),objgrd(lvec)
      dimension V(mV),W(mV*mV),work(mwork)
      dimension sumdel(mtau+mtheta),u(mM)

*     Copy parameters NPSOL gets to see to vsav.

      j=0
      do i=1,lvsav
        if (ivec(i).eq.0) then
          j=j+1
          vsav(i)=vec(j)
        end if
      end do 

*     Make tau and theta agree with vsav.

      do i=1,ltau
        tau(i)=vsav(i)
      end do

      do i=1,ltheta
        theta(i)=vsav(ltau+i)
      end do

*     Error checks.

      if (ntermz.gt.mV) then
        write(3,3001) ntermz
        stop
      end if

*     If mwork is too small, whx should catch it.

      call whx(V,W,x,
     &  theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &  M,L,ntermz,ntermx,Kz,Kx,work,mwork)

      ftrial=dfloat(npt)
      fobs=dfloat(nobs)
      jseed=iseed

      objf=0.d0

*     Anlalytic derivatives are not supplied for the polynomial
*     parameters of the SNP.  NPSOL computes them numerically.

      j=0
      do i=1,lvsav
        if (ivec(i).eq.0) then
          j=j+1
          if ((i.le.ltau).or.(i.ge.ltau+iaR)) then
            objgrd(j)=0.d0
          end if
        end if
      end do

*     Compute the log likelihood.

      do id=1,ncases

*     Integrate the d density with respect to the SNP density and
*     and store it in sum. 
*     Compute derivatives with respect to the parameters tau and 
*     R and store them in sumdel.

        sum=0.d0

        do j=1,lvsav
          sumdel(j)=0.d0
        end do

        do i=1,npt
          call sampz(jseed,u,V,W,M,ntermz,ntermx)

          do jj=1,M
            z(jj)=0.d0
          end do

          do jj=1,M
          do ii=1,jj
            z(ii)=z(ii)+theta(ibR+jj*(jj-1)/2+ii)*u(jj)
          end do
          end do

          isw=2
          call density(isw)

          sum=sum+d

          do jj=1,ltau
            sumdel(jj)=sumdel(jj)+dwtau(jj)
          end do

          do jj=1,M
          do ii=1,jj
            sumdel(ltau+ibR+jj*(jj-1)/2+ii)
     &        = sumdel(ltau+ibR+jj*(jj-1)/2+ii)
     &          + dwz(ii)*u(jj)
          end do
          end do
        end do

        sum = sum/ftrial

        do j=1,lvsav
          sumdel(j)=sumdel(j)/ftrial
        end do

        sum=sum+eps

        objf=objf-dlog(sum)/fobs

        tmp=sum*fobs

        j=0
        do i=1,lvsav
          if (ivec(i).eq.0) then
            j=j+1
            if ((i.le.ltau).or.(i.ge.ltau+iaR)) then
              objgrd(j)=objgrd(j)-sumdel(i)/tmp
            end if
          end if
        end do

      end do

      return
3001  format(1x,'error, mcarlo, increase mV to at least',i5)
      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      program quinplot
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      real*8 time,conc,dose
      real*8 album,glyco
      real*8 tbig,tsmall

      integer*4 form,observ,change,steady
      integer*4 dinter,age,height,weight
      integer*4 race,smoker,lush
      integer*4 heart,creatn
      integer*4 i,j
      integer*4 id0,id0lag,iptr
      integer*4 count,point
      integer*4 repeat

      real*8 pinc

      integer*4 mcols
      integer*4 incrmt,tics

      parameter (pinc=1.d0)
      parameter (mcols=5000)
      parameter (incrmt=50)
      parameter (tics=3)

      dimension time(mcols),conc(mcols),dose(mcols)
      dimension dinter(mcols),age(mcols),height(mcols),weight(mcols)
      dimension album(mcols),glyco(mcols)
      dimension form(mcols),observ(mcols),change(mcols),steady(mcols)
      dimension race(mcols),smoker(mcols),lush(mcols)
      dimension heart(mcols),creatn(mcols)
      dimension count(mcols),point(mcols)

      open (unit=14,file='quin.dat',
     &  status='old',form='formatted')

      open (unit=15,file='quinplot.dat',
     &  status='unknown',form='formatted')

      iptr=1
      count(iptr)=0
      point(iptr)=1
      id0lag=1

      do i=1,mcols

        read(14,14001,end=10)
     &    id0,
     &    time(i),conc(i),dose(i),
     &    form(i),observ(i),change(i),steady(i),
     &    dinter(i),age(i),height(i),weight(i),
     &    race(i),smoker(i),lush(i),
     &    heart(i),creatn(i),
     &    album(i),glyco(i)

        if ((id0lag.eq.id0).or.(i.eq.1)) then
          count(iptr)=count(iptr)+1
        else
          iptr=iptr+1
          count(iptr)=1
          id0lag=id0
          point(iptr)=i
        end if

        repeat=0
        if (count(iptr).ge.2) then
          repeat = (time(i)-time(i-1))/incrmt
          tbig=time(i-1)+dfloat(repeat*incrmt)
          tsmall=time(i)-tics*pinc
          if (tbig.gt.tsmall) then
            repeat=repeat-1
          end if
        end if

        if (repeat.ge.1) then
          do j=1,repeat
            tbig=time(i-1)+dfloat(j*incrmt)
            write(15,14001)
     &        id0,
     &        tbig,0.d0,0.d0,
     &        form(i),1,3,0,
     &        0,age(i),height(i),weight(i),
     &        race(i),smoker(i),lush(i),
     &        heart(i),creatn(i),
     &        album(i),glyco(i)
          end do
        end if

        do j=1,tics
          tsmall=time(i)-(tics-j+1)*pinc
          if ((dose(i).gt.0.d0).and.(time(i-1).lt.tsmall)) then
            write(15,14001)
     &        id0,
     &        tsmall,0.d0,0.d0,
     &        form(i),1,3,0,
     &        0,age(i),height(i),weight(i),
     &        race(i),smoker(i),lush(i),
     &        heart(i),creatn(i),
     &        album(i),glyco(i)
          end if
        end do

        write(15,14001)
     &    id0,
     &    time(i),conc(i),dose(i),
     &    form(i),observ(i),change(i),steady(i),
     &    dinter(i),age(i),height(i),weight(i),
     &    race(i),smoker(i),lush(i),
     &    heart(i),creatn(i),
     &    album(i),glyco(i)

      end do

10    continue
      close(14)
      close(15)
      stop

14001 format(
     &  1x,i3,
     &  1x,f7.2,1x,f3.1,1x,f4.0,
     &  1x,i1,1x,i1,1x,i1,1x,i1,
     &  1x,i2,1x,i2,1x,i2,1x,i3,
     &  1x,i1,1x,i1,1x,i1,
     &  1x,i1,1x,i1,
     &  1x,f3.1,1x,f4.0
     &  )

      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     FILE NPMAIN FORTRAN
*
*     Sample program for NPSOL Version 4.04  August 1986.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

*     Set the declared array dimensions.
*     NROWA  = the declared row dimension of  A.
*     NROWJ  = the declared row dimension of  CJAC.
*     NROWR  = the declared row dimension of  R.
*     MAXN   = maximum no. of variables allowed for.
*     MAXBND = maximum no. of variables + linear & nonlinear constrnts.
*     LIWORK = the length of the integer work array.
*     LWORK  = the length of the double precision work array.

      PARAMETER         (NROWA  =  5, NROWJ  =  20, NROWR =   10,
     $                   MAXN   =  9, LIWORK =  70, LWORK = 1000,
     $                   MAXBND =  MAXN + NROWA + NROWJ)

      INTEGER            ISTATE(MAXBND)
      INTEGER            IWORK(LIWORK)
      DOUBLE PRECISION   A(NROWA,MAXN)
      DOUBLE PRECISION   BL(MAXBND), BU(MAXBND)
      DOUBLE PRECISION   C(NROWJ), CJAC(NROWJ,MAXN), CLAMDA(MAXBND)
      DOUBLE PRECISION   OBJGRD(MAXN), R(NROWR,MAXN), X(MAXN)
      DOUBLE PRECISION   WORK(LWORK)
      EXTERNAL           OBJFN1, OBJFN2, CONFN1, CONFN2

      PARAMETER         (ZERO = 0.0, ONE = 1.0)

*     Set the actual problem dimensions.
*     N      = the number of variables.
*     NCLIN  = the number of general linear constraints (may be 0).
*     NCNLN  = the number of nonlinear constraints (may be 0).

      N      = 9
      NCLIN  = 4
      NCNLN  = 14
      NBND   = N + NCLIN + NCNLN

*     ------------------------------------------------------------------
*     Assign file numbers and the data arrays.
*     NOUT   = the unit number for printing.
*     IOPTNS = the unit number for reading the options file.
*     Bounds  .ge.    BIGBND  will be treated as plus  infinity.
*     Bounds  .le.  - BIGBND  will be treated as minus infinity.
*     A      = the linear constraint matrix.
*     BL     = the lower bounds on  x,  a'x  and  c(x).
*     BU     = the upper bounds on  x,  a'x  and  c(x).
*     X      = the initial estimate of the solution.
*     ------------------------------------------------------------------
      NOUT   = 6
      IOPTNS = 5
      BIGBND = 1.0D+15

*     Set the matrix  A.

      DO 40 J = 1, N
         DO 30 I = 1, NCLIN
            A(I,J) = ZERO
   30    CONTINUE
   40 CONTINUE
      A(1,1) = -ONE
      A(1,2) =  ONE
      A(2,2) = -ONE
      A(2,3) =  ONE
      A(3,3) =  ONE
      A(3,4) = -ONE
      A(4,4) =  ONE
      A(4,5) = -ONE

*     Set the bounds.

      DO 50 J  =  1, NBND
         BL(J) = -BIGBND
         BU(J) =  BIGBND
   50 CONTINUE
      BL(1)  =  ZERO
      BL(3)  = -ONE
      BL(5)  =  ZERO
      BL(6)  =  ZERO
      BL(7)  =  ZERO

      BU(3)  =  ONE
      BU(8)  =  ZERO
      BU(9)  =  ZERO

*     Set lower bounds of zero for all four linear constraints.

      DO 60 J  =  N+1,  N+NCLIN
         BL(J) =  ZERO
   60 CONTINUE

*     Set upper bounds of one for all 14 nonlinear constraints.

      DO 70 J  =  N + NCLIN + 1,  NBND
         BU(J) =  ONE
   70 CONTINUE

*     Set the initial estimate of  X.

      X(1)   =  .1
      X(2)   =  .125
      X(3)   =  .666666
      X(4)   =  .142857
      X(5)   =  .111111
      X(6)   =  .2
      X(7)   =  .25
      X(8)   = -.2
      X(9)   = -.25


*     ------------------------------------------------------------------
*     Read the options file.               
*     ------------------------------------------------------------------

      CALL NPFILE( IOPTNS, INFORM )
      IF (INFORM .NE. 0) THEN
         WRITE (NOUT, 3000) INFORM
         STOP
      END IF

*     ------------------------------------------------------------------
*     Solve the problem.
*     ------------------------------------------------------------------

      CALL NPSOL ( N, NCLIN, NCNLN, NROWA, NROWJ, NROWR,
     $             A, BL, BU,
     $             CONFN1, OBJFN1,
     $             INFORM, ITER, ISTATE,
     $             C, CJAC, CLAMDA, OBJF, OBJGRD, R, X,
     $             IWORK, LIWORK, WORK, LWORK )

      IF (INFORM .GT. 0) GO TO 900

*     ------------------------------------------------------------------
*     The following is for illustrative purposes only.
*     A second run solves the same problem,  but defines the objective
*     and constraints via the subroutines OBJFN2 and CONFN2.  Some
*     objective derivatives and the constant Jacobian elements are not
*     supplied.
*     We do a warm start using
*              ISTATE    (the working set)
*              CLAMDA    (the Lagrange multipliers)
*              R         (the Hessian approximation)
*     from the previous run, but with a slightly perturbed starting
*     point.  The previous option file must have specified
*              Hessian    Yes
*     for R to be a useful approximation.
*     ------------------------------------------------------------------

      DO 100 J = 1, N
         X(J)  = X(J) + 0.1
  100 CONTINUE

*     The previous parameters are retained and updated.

      CALL NPOPTN( '   Derivative level               0')
      CALL NPOPTN( '   Verify                        No')
      CALL NPOPTN( '   Warm Start')
      CALL NPOPTN( '   Major iterations              20')
      CALL NPOPTN( '   Major print level             10')

      CALL NPSOL ( N, NCLIN, NCNLN, NROWA, NROWJ, NROWR,
     $             A, BL, BU,
     $             CONFN2, OBJFN2,
     $             INFORM, ITER, ISTATE,
     $             C, CJAC, CLAMDA, OBJF, OBJGRD, R, X,
     $             IWORK, LIWORK, WORK, LWORK )

      IF (INFORM .GT. 0) GO TO 900
      STOP

*     -----------
*     Error exit.
*     -----------

  900 WRITE (NOUT, 3010) INFORM
      STOP

 3000 FORMAT(/ ' NPFILE terminated with  INFORM =', I3)
 3010 FORMAT(/ ' NPSOL  terminated with  INFORM =', I3)

*     End of the example program for NPSOL.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE OBJFN1( MODE, N, X, OBJF, OBJGRD, NSTATE )
      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION   X(N), OBJGRD(N)

*-----------------------------------------------------------------------
*     OBJFN1  computes the value and first derivatives of the nonlinear
*     objective function.
*-----------------------------------------------------------------------
      OBJF   = - X(2)*X(6) + X(1)*X(7) - X(3)*X(7) - X(5)*X(8)
     $         + X(4)*X(9) + X(3)*X(8)

      OBJGRD(1) =   X(7)
      OBJGRD(2) = - X(6)
      OBJGRD(3) = - X(7) + X(8)
      OBJGRD(4) =   X(9)
      OBJGRD(5) = - X(8)
      OBJGRD(6) = - X(2)
      OBJGRD(7) = - X(3) + X(1)
      OBJGRD(8) = - X(5) + X(3)
      OBJGRD(9) =   X(4)

      RETURN

*     End of  OBJFN1.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CONFN1( MODE, NCNLN, N, NROWJ,
     $                   NEEDC, X, C, CJAC, NSTATE )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            NEEDC(*)
      DOUBLE PRECISION   X(N), C(*), CJAC(NROWJ,*)

*-----------------------------------------------------------------------
*     CONFN1  computes the values and first derivatives of the nonlinear
*     constraints.
*
*     The zero elements of Jacobian matrix are set only once.  This
*     occurs during the first call to CONFN1  (NSTATE = 1).
*-----------------------------------------------------------------------
      PARAMETER         (ZERO = 0.0, TWO = 2.0)

      IF (NSTATE .EQ. 1) THEN

*        First call to CONFN1.  Set all Jacobian elements to zero.
*        N.B.  This will only work with `Derivative Level = 3'.

         DO 120 J = 1, N
            DO 110 I = 1, NCNLN
               CJAC(I,J) = ZERO
  110       CONTINUE
  120    CONTINUE

      END IF

      IF (NEEDC(1) .GT. 0) THEN
         C(1)       =   X(1)**2  +  X(6)**2
         CJAC(1,1)  =   TWO*X(1)
         CJAC(1,6)  =   TWO*X(6)
      END IF

      IF (NEEDC(2) .GT. 0) THEN
         C(2)       =   (X(2) - X(1))**2  +  (X(7) - X(6))**2
         CJAC(2,1)  = - TWO*(X(2) - X(1))
         CJAC(2,2)  =   TWO*(X(2) - X(1))
         CJAC(2,6)  = - TWO*(X(7) - X(6))
         CJAC(2,7)  =   TWO*(X(7) - X(6))
      END IF

      IF (NEEDC(3) .GT. 0) THEN
         C(3)       =   (X(3) - X(1))**2  +  X(6)**2
         CJAC(3,1)  = - TWO*(X(3) - X(1))
         CJAC(3,3)  =   TWO*(X(3) - X(1))
         CJAC(3,6)  =   TWO*X(6)
      END IF

      IF (NEEDC(4) .GT. 0) THEN
         C(4)       =   (X(1) - X(4))**2  +  (X(6) - X(8))**2
         CJAC(4,1)  =   TWO*(X(1) - X(4))
         CJAC(4,4)  = - TWO*(X(1) - X(4))
         CJAC(4,6)  =   TWO*(X(6) - X(8))
         CJAC(4,8)  = - TWO*(X(6) - X(8))
      END IF

      IF (NEEDC(5) .GT. 0) THEN
         C(5)       =   (X(1) - X(5))**2  +  (X(6) - X(9))**2
         CJAC(5,1)  =   TWO*(X(1) - X(5))
         CJAC(5,5)  = - TWO*(X(1) - X(5))
         CJAC(5,6)  =   TWO*(X(6) - X(9))
         CJAC(5,9)  = - TWO*(X(6) - X(9))
      END IF

      IF (NEEDC(6) .GT. 0) THEN
         C(6)       =   X(2)**2  +  X(7)**2
         CJAC(6,2)  =   TWO*X(2)
         CJAC(6,7)  =   TWO*X(7)
      END IF

      IF (NEEDC(7) .GT. 0) THEN
         C(7)       =   (X(3) - X(2))**2  +  X(7)**2
         CJAC(7,2)  = - TWO*(X(3) - X(2))
         CJAC(7,3)  =   TWO*(X(3) - X(2))
         CJAC(7,7)  =   TWO*X(7)
      END IF

      IF (NEEDC(8) .GT. 0) THEN
         C(8)       =   (X(4) - X(2))**2  +  (X(8) - X(7))**2
         CJAC(8,2)  = - TWO*(X(4) - X(2))
         CJAC(8,4)  =   TWO*(X(4) - X(2))
         CJAC(8,7)  = - TWO*(X(8) - X(7))
         CJAC(8,8)  =   TWO*(X(8) - X(7))
      END IF

      IF (NEEDC(9) .GT. 0) THEN
         C(9)       =   (X(2) - X(5))**2  +  (X(7) - X(9))**2
         CJAC(9,2)  =   TWO*(X(2) - X(5))
         CJAC(9,5)  = - TWO*(X(2) - X(5))
         CJAC(9,7)  =   TWO*(X(7) - X(9))
         CJAC(9,9)  = - TWO*(X(7) - X(9))
      END IF

      IF (NEEDC(10) .GT. 0) THEN
         C(10)      =   (X(4) - X(3))**2  +  X(8)**2
         CJAC(10,3) = - TWO*(X(4) - X(3))
         CJAC(10,4) =   TWO*(X(4) - X(3))
         CJAC(10,8) =   TWO*X(8)
      END IF

      IF (NEEDC(11) .GT. 0) THEN
         C(11)      =   (X(5) - X(3))**2  +  X(9)**2
         CJAC(11,3) = - TWO*(X(5) - X(3))
         CJAC(11,5) =   TWO*(X(5) - X(3))
         CJAC(11,9) =   TWO*X(9)
      END IF

      IF (NEEDC(12) .GT. 0) THEN
         C(12)      =   X(4)**2  +  X(8)**2
         CJAC(12,4) =   TWO*X(4)
         CJAC(12,8) =   TWO*X(8)
      END IF

      IF (NEEDC(13) .GT. 0) THEN
         C(13)      =   (X(4) - X(5))**2  +  (X(9) - X(8))**2
         CJAC(13,4) =   TWO*(X(4) - X(5))
         CJAC(13,5) = - TWO*(X(4) - X(5))
         CJAC(13,8) = - TWO*(X(9) - X(8))
         CJAC(13,9) =   TWO*(X(9) - X(8))
      END IF

      IF (NEEDC(14) .GT. 0) THEN
         C(14)      =   X(5)**2  +  X(9)**2
         CJAC(14,5) =   TWO*X(5)
         CJAC(14,9) =   TWO*X(9)
      END IF

      RETURN

*     End of  CONFN1.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE OBJFN2( MODE, N, X, OBJF, OBJGRD, NSTATE )
      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION   X(N), OBJGRD(N)

*-----------------------------------------------------------------------
*     OBJFN2  computes the value and some first derivatives of the
*     nonlinear objective function.
*-----------------------------------------------------------------------

      OBJF   = - X(2)*X(6) + X(1)*X(7) - X(3)*X(7) - X(5)*X(8)
     $         + X(4)*X(9) + X(3)*X(8)

      OBJGRD(3) = - X(7) + X(8)
      OBJGRD(7) = - X(3) + X(1)
      OBJGRD(8) = - X(5) + X(3)

      RETURN

*     End of  OBJFN2.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE CONFN2( MODE, NCNLN, N, NROWJ,
     $                   NEEDC, X, C, CJAC, NSTATE )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            NEEDC(*)
      DOUBLE PRECISION   X(N), C(*), CJAC(NROWJ,*)

*-----------------------------------------------------------------------
*     CONFN2  computes the values and the non-constant derivatives of
*     the nonlinear constraints.
*-----------------------------------------------------------------------
      PARAMETER         (TWO = 2.0)

      IF (NEEDC(1) .GT. 0) THEN
         C(1)       =   X(1)**2  +  X(6)**2
         CJAC(1,1)  =   TWO*X(1)
         CJAC(1,6)  =   TWO*X(6)
      END IF

      IF (NEEDC(2) .GT. 0) THEN
         C(2)       =   (X(2) - X(1))**2  +  (X(7) - X(6))**2
         CJAC(2,1)  = - TWO*(X(2) - X(1))
         CJAC(2,2)  =   TWO*(X(2) - X(1))
         CJAC(2,6)  = - TWO*(X(7) - X(6))
         CJAC(2,7)  =   TWO*(X(7) - X(6))
      END IF

      IF (NEEDC(3) .GT. 0) THEN
         C(3)       =   (X(3) - X(1))**2  +  X(6)**2
         CJAC(3,1)  = - TWO*(X(3) - X(1))
         CJAC(3,3)  =   TWO*(X(3) - X(1))
         CJAC(3,6)  =   TWO*X(6)
      END IF

      IF (NEEDC(4) .GT. 0) THEN
         C(4)       =   (X(1) - X(4))**2  +  (X(6) - X(8))**2
         CJAC(4,1)  =   TWO*(X(1) - X(4))
         CJAC(4,4)  = - TWO*(X(1) - X(4))
         CJAC(4,6)  =   TWO*(X(6) - X(8))
         CJAC(4,8)  = - TWO*(X(6) - X(8))
      END IF

      IF (NEEDC(5) .GT. 0) THEN
         C(5)       =   (X(1) - X(5))**2  +  (X(6) - X(9))**2
         CJAC(5,1)  =   TWO*(X(1) - X(5))
         CJAC(5,5)  = - TWO*(X(1) - X(5))
         CJAC(5,6)  =   TWO*(X(6) - X(9))
         CJAC(5,9)  = - TWO*(X(6) - X(9))
      END IF

      IF (NEEDC(6) .GT. 0) THEN
         C(6)       =   X(2)**2  +  X(7)**2
         CJAC(6,2)  =   TWO*X(2)
         CJAC(6,7)  =   TWO*X(7)
      END IF

      IF (NEEDC(7) .GT. 0) THEN
         C(7)       =   (X(3) - X(2))**2  +  X(7)**2
         CJAC(7,2)  = - TWO*(X(3) - X(2))
         CJAC(7,3)  =   TWO*(X(3) - X(2))
         CJAC(7,7)  =   TWO*X(7)
      END IF

      IF (NEEDC(8) .GT. 0) THEN
         C(8)       =   (X(4) - X(2))**2  +  (X(8) - X(7))**2
         CJAC(8,2)  = - TWO*(X(4) - X(2))
         CJAC(8,4)  =   TWO*(X(4) - X(2))
         CJAC(8,7)  = - TWO*(X(8) - X(7))
         CJAC(8,8)  =   TWO*(X(8) - X(7))
      END IF

      IF (NEEDC(9) .GT. 0) THEN
         C(9)       =   (X(2) - X(5))**2  +  (X(7) - X(9))**2
         CJAC(9,2)  =   TWO*(X(2) - X(5))
         CJAC(9,5)  = - TWO*(X(2) - X(5))
         CJAC(9,7)  =   TWO*(X(7) - X(9))
         CJAC(9,9)  = - TWO*(X(7) - X(9))
      END IF

      IF (NEEDC(10) .GT. 0) THEN
         C(10)      =   (X(4) - X(3))**2  +  X(8)**2
         CJAC(10,3) = - TWO*(X(4) - X(3))
         CJAC(10,4) =   TWO*(X(4) - X(3))
         CJAC(10,8) =   TWO*X(8)
      END IF

      IF (NEEDC(11) .GT. 0) THEN
         C(11)      =   (X(5) - X(3))**2  +  X(9)**2
         CJAC(11,3) = - TWO*(X(5) - X(3))
         CJAC(11,5) =   TWO*(X(5) - X(3))
         CJAC(11,9) =   TWO*X(9)
      END IF

      IF (NEEDC(12) .GT. 0) THEN
         C(12)      =   X(4)**2  +  X(8)**2
         CJAC(12,4) =   TWO*X(4)
         CJAC(12,8) =   TWO*X(8)
      END IF

      IF (NEEDC(13) .GT. 0) THEN
         C(13)      =   (X(4) - X(5))**2  +  (X(9) - X(8))**2
         CJAC(13,4) =   TWO*(X(4) - X(5))
         CJAC(13,5) = - TWO*(X(4) - X(5))
         CJAC(13,8) = - TWO*(X(9) - X(8))
         CJAC(13,9) =   TWO*(X(9) - X(8))
      END IF

      IF (NEEDC(14) .GT. 0) THEN
         C(14)      =   X(5)**2  +  X(9)**2
         CJAC(14,5) =   TWO*X(5)
         CJAC(14,9) =   TWO*X(9)
      END IF

      RETURN

*     End of  CONFN2.

      END

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     values.f
*
*     Copyright (C) 1991, 1992.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine values(isw)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      real*4 ran
      
      real*8 fran
      real*8 rhoij,cii,fii,cjj,fjj
      real*8 fn,fp,bic,aic,hq

      integer*4 mseed
      integer*4 isw,i,j,ij,iprsav
      integer*4 Kz0,Iz0,nz0
      integer*4 Kx0,Ix0,nx0
      integer*4 lthet0
      integer*4 iwork,liwork
      integer*4 alpha,beta
      integer*4 ialpha,ibeta

      
*     Uncomment the following two lines, and those right before
*     the format statements, on a Sun running under SunOS 4.1.1 
*     and perhaps other Sun OS's.

*     integer*4 ieeer,ieee_flags
*     character*32 out

      integer*4 miwork

      parameter (miwork=200)

      dimension iwork(miwork)
      dimension alpha(100),beta(100)


      if (isw.eq.1) then
        read(8,8000)

        do i=1,ltau
          read(8,8001) tau(i),itau(i)
        end do

        read(8,8000)

        read(8,8002) Kz0,Iz0,nz0
        read(8,8002) Kx0,Ix0,nx0

        read(8,8000)

        lthet0 = nz0*nx0 + M + M*M*L + lR

        do i=1,lthet0
          read(8,8001) theta(i),itheta(i)
          vsav(i)=dble(itheta(i))
        end do

        liwork = 2*M*L + M*nz0 + M*L*nx0 + nz0 + nx0

        if (liwork.gt.miwork) then
          write(3,3001) liwork
          stop
        end if

        iprsav=iprint
        iprint=1
        
        call snprst
     &   (vsav,M,0,L,Kz0,Kx0,Iz0,Ix0,
     &   0,L,Kz,Kx,Iz,Ix,0.d0,ij,iwork)

        call snprst
     &   (theta,M,0,L,Kz0,Kx0,Iz0,Ix0,
     &   0,L,Kz,Kx,Iz,Ix,fnew,ij,iwork)

        if (lthet0.ne.ltheta) then
          do i=1,ltheta
            itheta(i)=int(vsav(i))
          end do
        end if

        do i=1,lthet0
          vsav(i)=1.d0
        end do

        call snprst
     &   (vsav,M,0,L,Kz0,Kx0,Iz0,Ix0,
     &   0,L,Kz,Kx,Iz,Ix,0.d0,ij,iwork)

        iprint=iprsav

        mseed=nseed
        
        if (mseed.ne.0) then
          do i=1,ltau
            if (itau(i).ne.1) then 
              fran = -1.d0 + 2.d0*dble(ran(mseed))
              tau(i)=tau(i)+tau(i)*fold*fran
            end if
          end do
          do i=1,ltheta
            if (itheta(i).ne.1) then 
              fran = -1.d0 + 2.d0*dble(ran(mseed))
              if (vsav(i).eq.1.d0) then
                theta(i)=theta(i)+theta(i)*fold*fran
              else
                theta(i)=fnew*fran
              end if
            end if
          end do
        end if       

        
        liwork = 2*M*L + M*nz0 + M*L*nx0 + nz0 + nx0
*     The first element of the polynomial part of the SNP model
*     is always fixed at one.

        theta(ibA+1)=1.d0
        itheta(ibA+1)=1

*     The regression part of the SNP model is not used, zeroing
*     them out accomplishes this.

        do i=ibB0+1,ibB0+M
          theta(i)=0.d0
          itheta(i)=1
        end do
        do i=ibB+1,ibB+M*M*L
          theta(i)=0.d0
          itheta(i)=1
        end do

*    With these built in restrictions, pmax is the maximum number 
*    of free parameters.

        close(8)
        return
      end if

      if (isw.eq.2) then
        write(9,9000)

        do i=1,ltau
          write(9,9001) tau(i),itau(i),i
        end do

        write(9,9002)

        write(9,9003) Kz,Iz,ntermz
        write(9,9004) Kx,Ix,ntermx

        write(9,9005)

        do i=1,ltheta
          write(9,9009) theta(i),itheta(i),i
        end do

        write(9,9006)

        do i=1,M
          write(9,9018) Ez(i),i
        end do

        write(9,9007)

        do j=1,M
        do i=1,j
          write(9,9019) Cz(j*(j-1)/2+i),i,j
        end do
        end do

        write(9,9017)

        do j=1,M
          cjj = Cz(j*(j-1)/2+j)
          if (cjj.gt.0) then
            fjj = 1.d0/dsqrt(cjj)
          else
            fjj = 0.d0
          end if
        do i=1,j
          cii = Cz(i*(i-1)/2+i)
          if (cii.gt.0) then
            fii = 1.d0/dsqrt(cii)
          else
            fii = 0.d0
          end if

          rhoij = Cz(j*(j-1)/2+i)*fjj*fii

          write(9,9020) rhoij,i,j
        end do
        end do

        fn  = dfloat(nobs)
        fp  = dfloat(net)

        bic = sn + (fp/fn)*dlog(fn)/2.d0
        hq  = sn + (fp/fn)*dlog(dlog(fn))
        aic = sn + (fp/fn)

        write(9,9101)
        write(9,9102) infile
        write(9,9103) outfil
        write(9,9104) fnew,fnew
        write(9,9114) fold,fold
        write(9,9115) nseed
        write(9,9105) iter,maxitr
        write(9,9106) inform
        write(9,9109) nobs
        write(9,9110) net,pmax
        write(9,9107) sn,sn
        write(9,9108) bic,bic
        write(9,9113) hq,hq 
        write(9,9112) aic,aic
        write(9,9111) (2*nobs)*sn,(2*nobs)*sn

        if ((iCvec.eq.1).and.(iq.eq.1)) then

          write(9,9010)
          j=0
          do i=1,ltau
            if (itau(i).eq.0) then
              j=j+1
              write(9,9013) tau(i),dsqrt(Cvec(nfit*(j-1)+j)),i
            else
              write(9,9015) tau(i),i
            end if
          end do
          
          write(9,9011)

          do ialpha=1,ntermz
          do ibeta=1,ntermx
            ij=ntermx*(ialpha-1)+ibeta
            call multiy(ialpha,alpha)
            call multix(ibeta,beta)
            if (itheta(ibA+ij).eq.0) then
              j=j+1
              write(9,9012) 
     &          theta(ij),dsqrt(Cvec(nfit*(j-1)+j)),ij,(alpha(i),i=1,M)
            else
              write(9,9014) theta(ij),ij,(alpha(i),i=1,M)
            end if
          end do
          end do

          do i=ibB0+1,ibB0+M
            if (itheta(i).eq.0) then
              j=j+1
              write(9,9012) 
     &          theta(i),dsqrt(Cvec(nfit*(j-1)+j)),i
            else
              write(9,9014) theta(i),i
            end if
          end do

          do i=ibB+1,ibB+M*M*L
            if (itheta(i).eq.0) then
              j=j+1
              write(9,9012) 
     &          theta(i),dsqrt(Cvec(nfit*(j-1)+j)),i
            else
              write(9,9014) theta(i),i
            end if
          end do

          do i=ibR+1,ibR+lR
            if (itheta(i).eq.0) then
              j=j+1
              write(9,9012) 
     &          theta(i),dsqrt(Cvec(nfit*(j-1)+j)),i
            else
              write(9,9014) theta(i),i
            end if
          end do

          write(9,9016)
          j=0
          do i=1,ltau
            if (itau(i).eq.0) then
              j=j+1
              write(9,9013) tau(i),dsqrt(Ctau(nfit1*(j-1)+j)),i
            else
              write(9,9015) tau(i),i
            end if
          end do

          write(9,9021)

          if (muzero.eq.1) then 
            do i=1,M
              write(9,9025) Ez(i),i
            end do
          else
            do i=1,M
              write(9,9023) Ez(i),dsqrt(CovEz(M*(i-1)+i)),i
            end do
          end if

          write(9,9022)

          do j=1,M
          do i=1,j
            ij=j*(j-1)/2+i
            write(9,9024) Cz(ij),sqrt(CovCz(lR*(ij-1)+ij)),i,j
          end do
          end do

        end if

*       Uncomment the following seven lines, and those amongst the 
*       variable declarations, on a Sun running under SunOS 4.1.1 
*       and perhaps other Sun OS's.

*       ieeer = ieee_flags('get','exception','invalid',out)
*       if (out.eq.'invalid') write(9,9901) out
*       ieeer = ieee_flags('get','exception','overflow',out)
*       if (out.eq.'overflow') write(9,9901) out
*       ieeer = ieee_flags('get','exception','division',out)
*       if (out.eq.'division') write(9,9901) out
*       ieeer = ieee_flags('clear','exception','common',out)

        close(9)
        return
      end if

3001  format(1x,'error, values, increase miwork to at least', i5)
8000  format(a10)
8001  format(d30.18,1x,i1)
8002  format(3i5)
9000  format('Start values for tau.')
9001  format(d30.18,1x,i1,3x,'tau(',i3,')    format(d30.18,1x,i1)')
9002  format('SNP parameters of theta start values.')
9003  format(3i5,20x,'Kz, Iz, ntermz  format(3i5)')
9004  format(3i5,20x,'Kx, Ix, ntermx  format(3i5)')
9005  format('Start values for theta.')
9006  format('Mean of z, Ez.')
9007  format('Variance matrix of z, Cz.')
9009  format(d30.18,1x,i1,3x,'theta(',i3,')  format(d30.18,1x,i1)')
9010  format('Values of tau (repeated) and standard errors')
9011  format
     &  ('Values of theta (repeated), standard errors,',
     &  ' and multi-indexes')
9012  format(f20.8,3x,f20.8,3x,'theta(',i3,')',3x,100i1)
9013  format(f20.8,3x,f20.8,3x,'tau(',i3,')')
9014  format(f20.8,12x,'constrained',3x,'theta(',i3,')',3x,100i1)
9015  format(f20.8,12x,'constrained',3x,'tau(',i3,')')
9016  format('Values of tau (repeated) and conditional standard errors')
9017  format
     &('Correlation matrix of z, rho.')
9018  format(d30.18,5x,'Ez(',i3,')')
9019  format(d30.18,5x,'Cz(',i3,',',i3,')')
9020  format(f23.15,12x,'rho(',i3,',',i3,')')
9021  format('Mean of z, Ez, (repeated) and standard errors.')
9022  format
     &('Variance matrix of z, Cz, (repeated) and standard errors.')
9023  format(f20.8,3x,f20.8,3x,'Ez(',i3,')')
9024  format(f20.8,3x,f20.8,3x,'Cz(',i3,',',i3,')')
9025  format(f20.8,12x,'constrained',3x,'Ez(',i3,')')
9101  format('Results from fit.')
9102  format('  infile            = ',2x,a12)
9103  format('  outfil            = ',2x,a12)
9104  format('  fnew              = ',f15.8,5x,d27.18)
9105  format('  iter/maxitr       = ',i5,' /',i5)
9106  format('  inform            = ',i5)
9107  format('  sn = objf         = ',f15.8,5x,d27.18)
9108  format('  Schwarz = bic     = ',f15.8,5x,d27.18)
9109  format('  nobs              = ',i8)
9110  format('  net/pmax          = ',i5,' /',i5)
9111  format('  -2 ln likelihood  = ',f15.8,5x,d27.18)
9112  format('  Akaike = aic      = ',f15.8,5x,d27.18)
9113  format('  Hannan&Quinn = hq = ',f15.8,5x,d27.18)
9114  format('  fold              = ',f15.8,5x,d27.18)
9115  format('  nseed             = ',i10)
9901  format('  IEEE floating-point arithmetic exception, ',a32)
      end

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     global.f
*
*     Copyright (C) 1991, 1992.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8

      save /nlmixr/
      save /nlmixi/
      save /nlmixc/
      save /zprint/
      save /zlnsiz/

      real*8 ftol,sfac
      real*8 fnew,fold
      real*8 sn
      real*8 tau,theta,vsav
      real*8 d,dwtau,z,dwz,x
      real*8 Ez,dEz
      real*8 Cz,dCz
      real*8 Cvec,Ctau
      real*8 CovEz,CovCz

      integer*4 ncases,npt,iq,nobs,jt
      integer*4 nfit,nfit1,nfit2,pmax,net
      integer*4 lx,ltau,lvsav
      integer*4 M,L,Kz,Kx,Iz,Ix,ntermz,ntermx
      integer*4 ibA,ibB0,ibB,ibR,iaA,iaB0,iaB,iaR
      integer*4 lA,lB0,lB,lR,ltheta
      integer*4 id,iseed,maxitr,muzero
      integer*4 iter,inform,ngrd,iunit9,iCvec,doCvec
      integer*4 verify
      integer*4 itau,itheta,ivec
      integer*4 iprint,lnsize

      character*10 name
      character*12 infile,outfil

      integer*4 mx
      integer*4 mM
      integer*4 mtau
      integer*4 mtheta
      integer*4 mvec
      integer*4 nseed

      parameter (mx=10)
      parameter (mM=5)
      parameter (mtau=50)
      parameter (mtheta=100)
      parameter (mvec=mtau+mtheta)

      dimension tau(mtau),theta(mtheta),vsav(mvec)
      dimension dwtau(mtau),z(mM),dwz(mM),x(mx)
      dimension Ez(mM),dEz(mM*mvec)
      dimension Cz(mM*(mM+1)/2),dCz((mM*(mM+1)/2)*mvec)
      dimension Cvec(mvec*mvec),Ctau(mtau*mtau)
      dimension CovEz(mM*mM),CovCz((mM*(mM+1)/2)*(mM*(mM+1)/2))
      dimension itau(mtau),itheta(mtheta),ivec(mvec)
 
      common /nlmixr/
     &  ftol,sfac,
     &  fnew,fold,
     &  sn,
     &  tau,theta,vsav,
     &  d,dwtau,z,dwz,x,
     &  Ez,dEz,
     &  Cz,dCz,
     &  Cvec,Ctau,
     &  CovEz,CovCz

      common /nlmixi/
     &  ncases,npt,iq,nobs,jt,
     &  nfit,nfit1,nfit2,pmax,net,
     &  lx,ltau,lvsav,
     &  M,L,Kz,Kx,Iz,Ix,ntermz,ntermx,
     &  ibA,ibB0,ibB,ibR,iaA,iaB0,iaB,iaR,
     &  lA,lB0,lB,lR,ltheta,
     &  id,iseed,maxitr,muzero,
     &  iter,inform,ngrd,iunit9,iCvec,doCvec,
     &  verify,
     &  itau,itheta,ivec,
     &  nseed

      common /nlmixc/
     &  name,
     &  infile,outfil

      common /zprint/ iprint
      common /zlnsiz/ lnsize

C.hr snpcode3.f
C....*...1.........2.........3.........4.........5.........6.........7.*
C    
C     snpcode3.f
C
C     Copyright (C) 1990.
C
C     A. Ronald Gallant & George E. Tauchen 
C     P.O. Box 5513, Raleigh NC 27650-5513, USA   
C
C     Permission to use, copy, modify, and distribute this
C     software and its documentation for any purpose and
C     without fee is hereby granted, provided that the
C     above copyright notice appear in all copies and that
C     both that copyright notice and this permission notice
C     appear in supporting documentation.
C
C     This software is provided "as is" without any
C     expressed or implied warranty.
C
C....*...1.........2.........3.........4.........5.........6.........7.*
C.hr MULTIY
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     MULTIY 1/26/88
C
C     PURPOSE: Fetch Ith multi-index for the Y polynomial
C     ARGUMENTS:
C          I - Integer pointer, between 1 and KY,
C              supplied by calling routine
C        IDX - Integer array of multi-indexes of length M,
C              returned by MULTIY.
C
C     WARNING: IF ZZMID IS CHANGED HERE IT MUST BE CHANGED IN
C               SUBROUTINES MULTIX, SETMYX, LNHYX AS WELL

C     WARNING: THE CALL TO SETMYX MUST PRECEDE USAGE OF THIS ROUTINE
C
      SUBROUTINE MULTIY(I,IDX)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C----Declarations Shared between SETMYX and MULTIY,X -------------------
C
      INTEGER ZZMID
      PARAMETER ( ZZMID = 5000 )
      INTEGER ZM, ZML, ZKY, ZKX, ZMKY
      INTEGER MIDYX(ZZMID)
      COMMON /ZSVMYX/ MIDYX
      COMMON /ZSVPYX/ ZM, ZML, ZKY, ZKX, ZMKY
C
C     NOTE:
C        MIDYX(1..M*KY)            = Y MULTINDEXES STORED AS MxKY ARRAY
C        MIDYX(M*KY+1..M*KY+ML*KX) = X MULTINDEXES STORED AS MLxKX ARRAY
C        ZM = M, ZML = M*L, ZKY = KY, ZKX = KX, ZMKY = M*KY
C-----------------------------------------------------------------------
      DIMENSION IDX(1)
      SAVE
      NOUT=3
C
C ERROR TRAP
C
      IF ( (I .LT. 1) .OR. (I .GT. ZKY) ) THEN
         WRITE(NOUT,900) I
 900     FORMAT(//' *** MULTIY ERROR: INDEX OUT OF RANGE. ',
     1          //'     INDEX =  ', I15,
     2          //'     ABNORMAL RETURN'//)
         RETURN
      ENDIF
C
C FETCH Y MULTI-INDEX
C
      IB = (I-1)*ZM
      DO 10 K=1,ZM
         IDX(K) = MIDYX(IB+K)
 10   CONTINUE
      RETURN
      END
C.hr MULTIX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     MULTIX 1/26/88
C
C     PURPOSE: Fetch Ith multi-index for the X polynomial
C     ARGUMENTS:
C          I - Integer pointer, between 1 and KX,
C              supplied by calling routine
C        IDX - Integer array of multi-indexes of length M,
C              returned by MULTIY.
C
C     WARNING: IF ZZMID IS CHANGED HERE IT MUST BE CHANGED IN
C               SUBROUTINES MULTIY, SETMYX, LNHYX AS WELL
C
C     WARNING: THE CALL TO SETMYX MUST PRECEDE USAGE OF THIS ROUTINE
C
      SUBROUTINE MULTIX(I,IDX)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C----Declarations Shared between SETMYX and MULTIY,X -------------------
C
      INTEGER ZZMID
      PARAMETER ( ZZMID = 5000 )
      INTEGER ZM, ZML, ZKY, ZKX, ZMKY
      INTEGER MIDYX(ZZMID)
      COMMON /ZSVMYX/ MIDYX
      COMMON /ZSVPYX/ ZM, ZML, ZKY, ZKX, ZMKY
C
C     NOTE:
C        MIDYX(1..M*KY)         =    Y MULTINDEXES STORED AS MxKY ARRAY
C        MIDYX(M*KY+1..M*KY+ML*KX) = X MULTINDEXES STORED AS MLxKX ARRAY
C        ZM = M, ZML = M*L, ZKY = KY, ZKX = KX, ZMKY = M*KY
C-----------------------------------------------------------------------
      DIMENSION IDX(1)
      SAVE
      NOUT=3
C
C ERROR TRAP
C
      IF ( (I .LT. 1) .OR. (I .GT. ZKX) ) THEN
         WRITE(NOUT,910) I
 910     FORMAT(//' *** MULTIX ERROR: INDEX OUT OF RANGE. ',
     1          //'     INDEX =  ', I15,
     2          //'     ABNORMAL RETURN'//)
         RETURN
      ENDIF
C
C FETCH X MULTI-INDEX
C
      IB = ZMKY + (I-1)*ZML
      DO 10 K=1,ZML
         IDX(K) = MIDYX(IB+K)
 10   CONTINUE
      RETURN
      END
C.hr SETMYX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     SETMYX  1/11/89
C
C     PURPOSE: Calculate KY, KX, and initialize the common blocks ZSVMYX
C              and ZSVPYX.  the block ZSVMYX holds the INTEGER array
C              MIDYX containing the multi-indexes for an SNP model.
C              Upon return, elements 1..M*KY of the array MIDYX are the
C              multi-indexes for the Y polynomial arranged as an MxKY
C              array; elements M*KY+1..M*KY+(M*L)*KX of MIDYX are
C              the multi-indexes for the X polynomial arranged as an
C              (M*L)xKX array.  the block ZSVPYX contains copies of
C              various constants as follows:
C                 ZM = M, ZML = M*L, ZKY = KY, ZKX = KX, ZMKY = M*KY
C              Thus, ZMKY+1 points to the start of the X multi-indexes.
C
C     USAGE:
C
C     CALL SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,
C    &            KY,KX,IDUMMY,IWORK)
C
C     ARGUMENTS:
C           M - INTEGER, Dimension of the time series, supplied by the
C                 calling routine.
C           L - INTEGER, Lag length of X vector of the SNP model,
C                 supplied by calling routine.
C       LPOLY - INTEGER, Lag length of the X part of the polynomial,
C                 supplied by calling routine.  LPOLY cannot exceed L.
C       IDEGY - INTEGER, Degree of the Y polynomial, supplied by
C                 calling routine.
C       IDEGX - INTEGER, Degree of the X polynomial, supplied by
C                 calling routine.
C       LINTY - INTEGER, Limit on interactions included in the Y
C                 polynomial (See SUBROUTINE FLAGY), supplied by
C                 calling routine.
C       LINTX - INTEGER, Limit on interactions included in the X
C                 polynomial (See SUBROUTINE FLAGX), supplied by
C                 calling routine.
C          KY - INTEGER, Number of monomials in the Y polynomial
C                 characterized by M, IDEGY, and LINTY, returned.
C          KX - INTEGER, Number of monomials in the X polynomial
C                 characterized by M*L, IDEGX, and LINTX, returned.
C      IDUMMY - INTEGER, reserved for future use.
C       IWORK - An INTEGER work array of length 2*M*L.
C
C     WARNING:
C        IF ZZMID IS CHANGED HERE IT MUST BE CHANGED IN
C        SUBROUTINES MULTIY, MULTIX, LNHYX, EHYX AS WELL.
C
C     RESTRICTIONS:
C        0 <= LPOLY <= L
C        0 <= LINTY <= IDEGY
C        0 <= LINTX <= IDEGX
C
C
C     REMARKS: The routine works in tandem with TLOOP to generate all of
C        the multi-indexes.  For instance, generation of the Y multi-
C        indexes procedes as follows.  The indexes are generated by
C        degree, with the variable ITOT, ITOT=0,1,...,IDEGY, indicating
C        the degree of indexes currently be generated.  For each value
C        of ITOT, the routine TLOOP is repeatedly called.  The second
C        argument of TLOOP is an array of length M containing a multi-
C        index of degree ITOT; the first argument is an array of working
C        totals used by TLOOP.  (On the first call to TLOOP, its first
C        and second arguments must contains zeros in the first M-1
C        places  and ITOT in the Mth place.)  For each multi-index
C        returned by TLOOP, the routine FLAGY is called to see if that
C        multi-index meets the selection criterion. If it does, then
C        that multi-index is placed on a stack in the array MIDYX in the
C        common block ZZMID.  This continues until TLOOP sets IEND=1, in
C        which case all multi-indexes of degree ITOT have generated.
C           The X multi-indexes are generated in the same manner and
C        follow the Y multi-indexes on the stack.
C           If the routine determines that there is insufficient space
C        on the stack, then it stops placing them on the stack, but
C        continues generating and counting them to determine how much
C        larger the stack needs to be.
C
C     SUBROUTINES CALLED: TLOOP, FLAGY, FLAGX
C
      SUBROUTINE SETMYX(M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX,
     &                  KY,KX,IDUMMY,IWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C----Declarations Shared between SETMYX and MULTIY,X -------------------
C
      INTEGER ZZMID
      PARAMETER ( ZZMID = 5000 )
      INTEGER ZM, ZML, ZKY, ZKX, ZMKY
      INTEGER MIDYX(ZZMID)
      COMMON /ZSVMYX/ MIDYX
      COMMON /ZSVPYX/ ZM, ZML, ZKY, ZKX, ZMKY
C
C     NOTE:
C        MIDYX(1..M*KY)            = Y MULTINDEXES STORED AS MxKY ARRAY
C        MIDYX(M*KY+1..M*KY+ML*KX) = X MULTINDEXES STORED AS MLxKX ARRAY
C        ZM = M, ZML = M*L, ZKY = KY, ZKX = KX, ZMKY = M*KY
C-----------------------------------------------------------------------
      INTEGER IWORK(1)
      SAVE
      NOUT=3
C
C ERROR TRAP
C
      IF ( (M     .LT.   1) .OR. (L     .LT. 1    ) .OR.
     &     (LPOLY .LT.   0) .OR. (LPOLY .GT. L    ) .OR.
     &     (IDEGY .LT.   0) .OR. (IDEGX .LT. 0    ) .OR.
     &     (LINTY .LT.   0) .OR. (LINTY .GT. IDEGY) .OR.
     &     (LINTX .LT.   0) .OR. (LINTX .GT. IDEGX)   ) THEN
            WRITE(NOUT,900) M,L,LPOLY,IDEGY,IDEGX,LINTY,LINTX
 900     FORMAT(//' *** SETMYX ERROR: INVALID INPUT',/
     &            '      M = ', I5,/
     &            '      L = ', I5,/
     &            '  LPOLY = ', I5,/
     &            '  IDEGY = ', I5,/
     &            '  IDEGX = ', I5,//
     &            '  LINTY = ', I5,/
     &            '  LINTX = ', I5,//)
         STOP
      ENDIF
C
C START ROUTINE
C
      ML    = M*L
      ZM    = M
      ZML   = ML
      IOVER = 0
C
C  LOAD Y MULTI-INDEXES INTO ARRAY MIDYX
C
      IKS = 1
      IKV = IKS + M
      ICOUNT = 0
      DO 10 J=1,IDEGY+1
         ITOT = J - 1
         IEND = 0
         DO 15 K = 1, M
            IWORK(IKS-1+K) = 0
            IWORK(IKV-1+K) = 0
 15       CONTINUE
         IWORK(IKS-1+M) = ITOT
         IWORK(IKV-1+M) = ITOT
C
 20      IF ( IEND .EQ. 0 ) THEN
            LOC = ICOUNT*M
            CALL FLAGY(IWORK(IKV),M,IDEGY,LINTY,IFLAG,IDUMMY)
            IF (IFLAG .EQ. 0) THEN
               ICOUNT = ICOUNT + 1
               IF (LOC+M .LE. ZZMID) THEN
                  DO 30 K=1,M
                     MIDYX(LOC+K) = IWORK(IKV-1+K)
 30               CONTINUE
               ELSE
                  IOVER = 1
               ENDIF
            ENDIF
            CALL TLOOP(IWORK(IKS),IWORK(IKV),M,ITOT,IEND)
            GOTO 20
         ENDIF
 10   CONTINUE
      KY   = ICOUNT
      ZKY  = KY
      ZMKY = M*KY
C
C  LOAD X MULTI-INDEXES INTO ARRAY MIDYX
C
      IKS = 1
      IKV = IKS + ML
      ICOUNT = 0
      DO 60 J=1,IDEGX+1
         ITOT = J - 1
         IEND = 0
         DO 65 K = 1, ML
            IWORK(IKS-1+K) = 0
            IWORK(IKV-1+K) = 0
 65       CONTINUE
         IWORK(IKS-1+ML) = ITOT
         IWORK(IKV-1+ML) = ITOT
C
 70      IF ( IEND .EQ. 0 ) THEN
            LOC = ICOUNT*ML
            CALL FLAGX(IWORK(IKV),M,L,LPOLY,IDEGX,LINTX,IFLAG,IDUMMY)
            IF (IFLAG .EQ. 0) THEN
               ICOUNT = ICOUNT + 1
               IF (ZMKY+LOC+ML .LE. ZZMID) THEN
                  DO 80 K=1,ML
                     MIDYX(ZMKY+LOC+K) = IWORK(IKV-1+K)
 80               CONTINUE
               ELSE
                  IOVER = 1
               ENDIF
            ENDIF
            CALL TLOOP(IWORK(IKS),IWORK(IKV),ML,ITOT,IEND)
            GOTO 70
         ENDIF
 60   CONTINUE
      KX   = ICOUNT
      ZKX  = KX
C
C  CHECK IF SUFFICIENT SPACE HAD BEEN ALLOCATED TO STORE MULTI
C    INDEXES AND THEN EXIT
C
      IF (IOVER .EQ. 0) RETURN
C
C  IF WE GET HERE THERE WASN'T ENOUGH SPACE
C
      IREQ = M*KY + ML*KX
      WRITE(NOUT,910) ZZMID, IREQ, KY, KX
 910  FORMAT(' ***SETMYX ERROR: INSUFFICIENT SPACE FOR MULTINDEXES'/
     &       ' ALLOCATED (ZZMID) .........', I10/
     &       ' REQUIRED  (SET ZZMID TO)...', I10///
     &       ' KX ........................', I10/
     &       ' KY ........................', I10)
         STOP
      END
C.hr TLOOP
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
      SUBROUTINE TLOOP(KS,KV,M,ITOT,IEND)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION KS(M),KV(M)
      SAVE
C--------------------------------------C
C ERROR TRAPS                          C
C--------------------------------------C
      IER=0
      IEND=0
      NOUT=3
      IF (M .LT. 1) IER=1
      IF (M .GE. 1) THEN
         DO 5 L=1,M
            IF (KS(L) .LT. 0 .OR. KS(L) .GT. ITOT) IER=2
 5          IF (KV(L) .LT. 0 .OR. KV(L) .GT. ITOT) IER=3
      END IF
      IF ( IER .GT. 0 ) THEN
         WRITE(NOUT,900) IER, M
 900     FORMAT(//' *** TLOOP ERROR: BAD INPUT DATA ',
     1          //'     IER = ', I5,
     2          //'     NUMBER OF VARIABLES(M) = ', I15)
         IF ( M .GE. 1 ) THEN
            WRITE(NOUT,910)
 910        FORMAT(//'     ,   KS,   KV'//)
            DO 7 L=1,M
               WRITE(NOUT,920) L, KS(L), KV(L)
 920           FORMAT(3I5)
 7          CONTINUE
         ENDIF
      ENDIF
C--------------------------------------C
C START ROUTINE                        C
C--------------------------------------C
      IF (M .GE. 2) THEN
         KV(M-1) = KV(M-1) + 1
         IF (M .GE. 3) THEN
            DO 30 L=1,M-2
               IF (KV(M-L) .LT. ITOT-KS(M-L-1)+1) GO TO 40
               KV(M-L)=0
               KV(M-L-1) = KV(M-L-1) + 1
 30         CONTINUE
 40         CONTINUE
            KS(1)=KV(1)
            DO 50 L=2,M-1
 50         KS(L)=KS(L-1)+KV(L)
            KV(M)=ITOT-KS(M-1)
         ELSE
            KS(1)=KV(1)
            KV(2)=ITOT-KV(1)
         END IF
      END IF
      IF (M .EQ. 1 .OR. KV(1) .EQ. ITOT + 1) IEND=1
      RETURN
      END
C.HR  FLAGY
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C     1/16/89
C     FLAGY
C
C     PURPOSE:
C        Inspect a Y multi-index and set a flag indicating whether it
C        is to be screened out.
C
C     USAGE:
C     CALL FLAGY(ALPHA,M,IDEGY,LINTY,IFLAG,IDUMMY)
C
C     ARGUMENTS:
C
C     ALPHA  - INTEGER array of length M containing multi-index to be
C              inspected.
C     M      - INTEGER, length of Y, supplied by calling routine.
C     IDEGY  - INTEGER, degree of Y polynomial, supplied by
C                calling routine.
C     LINTY  - INTEGER, limit on iteractions, supplied by
C                calling routine.
C     IFLAG  - INTEGER, flag (0 means retain ALPHA, 1 means
C                             reject ALPHA), returned.
C     IDUMMY - INTEGER, reserved for future use.
C
C     REMARKS:
C        IFLAG will be set to 1, indicating rejection, if the degree
C        of the interaction exceeds IDEGY-LINTY; otherwise IFLAG is set
C        to zero.
C
      SUBROUTINE FLAGY(ALPHA,M,IDEGY,LINTY,IFLAG,IDUMMY)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER ALPHA(1)
      SAVE
      IFLAG = 0
      IDG = 0
      NGZ = 0
      DO 10 J=1,M
         IF (ALPHA(J) .GT. 0) THEN
            NGZ = NGZ + 1
            IDG = IDG + ALPHA(J)
         ENDIF
 10   CONTINUE
      IF (NGZ .GE. 2 .AND. IDG .GT. IDEGY-LINTY) IFLAG=1
      CONTINUE
      RETURN
      END
C.HR  FLAGX
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C
C
C     1/16/89
C     FLAGX
C
C     PURPOSE:
C        Inspect a X multi-index and set a flag indicating whether it
C        is to be screened out.
C
C     USAGE:
C     CALL FLAGX(BETA,M,L,LPOLY,IDEGX,LINTX,IFLAG,IDUMMY)
C
C     ARGUMENTS:
C
C     BETA  -  INTEGER array of length M*L containing multi-index to be
C                inspected.
C     M      - INTEGER, length of the time series, supplied by
C                calling routine.
C     L      - INTEGER, maximum lag length of the model (X is of
C                length M*L), supplied by calling routine.
C     LPOLY  - INTEGER, lag length of polynomial part of the model,
C                supplied by calling routine. LPOLY<=L.
C     IDEGX  - INTEGER, degree of X polynomial, supplied by
C                calling routine.
C     LINTX  - INTEGER, limit on iteractions, supplied by
C                calling routine.
C     IFLAG  - INTEGER, flag (0 means retain ALPHA, 1 means
C                             reject ALPHA), returned.
C     IDUMMY - INTEGER, reserved for future use.
C
C     REMARKS:
C        IFLAG will be set to 1, indicating rejection, if BETA
C        equals zero in the first M*(L-LPOLY) places and if the degree
C        of the interaction exceeds IDEGX-LINTX; otherwise IFLAG is set
C        to zero.
C
      SUBROUTINE FLAGX(BETA,M,L,LPOLY,IDEGX,LINTX,IFLAG,IDUMMY)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER BETA(1)
      SAVE
      IFLAG = 0
      DO 10 J=1,M*(L-LPOLY)
         IF (BETA(J) .GT. 0) THEN
            IFLAG = 1
            RETURN
         ENDIF
 10   CONTINUE
      IDG   = 0
      NGZ   = 0
      DO 20 J=M*(L-LPOLY)+1,M*L
         IF (BETA(J) .GT. 0) THEN
            NGZ = NGZ + 1
            IDG = IDG + BETA(J)
         ENDIF
 20   CONTINUE
      IF (NGZ .GE. 2 .AND. IDG .GT. IDEGX-LINTX) IFLAG=1
      RETURN
      END
C.hr SNPRST
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C     SUBROUTINE SNPRST 1/12/89
C
C     PURPOSE
C     MODIFY THETA FROM A SMALLER SNPRX MODEL TO A
C     LARGER SNPRX MODEL.
C
C     USAGE
C      CALL SNPRST(THETA,M,
C     &     LRX0,LPOLY0,IDEGY0,IDEGX0,LINTY0,LINTX0,
C     &     LRX1,LPOLY1,IDEGY1,IDEGX1,LINTY1,LINTX1,TWEAK,
C     &     IDUMMY,IWORK)
C
C     ARGUMENTS
C     THETA  - A REAL*8 ARRAY OF LENGTH LTHETA1.
C                THETA IS MODIFIED BY SNPRST:  ON ENTRY T0 SNPRST, THETA
C                IS ARRANGED FOR AN SNPRX(LPOLY0,LRX0,IDEGY0,IDEGX0)
C                MODEL; ON EXIT IT ARRANGED FOR AN
C                SNPRX(LPOLY1,LRX1,IDEGY1,IDEGX1) MODEL. THE POLYNOMIAL
C                PARAMETERS OF THE LARGER MODEL THAT ARE IMPLICITLY
C                ZERO IN THE LARGER MODEL ARE SET TO TWEAK, AS ARE
C                THE VAR AND RX PARAMETERS THAT ARE IMPLICITLY ZERO
C                IN THE LARGER MODEL.
C     M      - INTEGER, THE LENGTH OF Y, SUPPLIED BY CALLING ROUTINE.
C     LRX0   - INTEGER, LAG LENGTH OF RX PART OF THE SMALLER
C                MODEL, SUPPLIED BY CALLING ROUTINE.
C     LPOLY0 - INTEGER, LAG LENGTH OF THE X POLYNOMIAL IN THE
C                SMALLER MODEL, SUPPLIED BY CALLING ROUTINE.
C     IDEGY0 - INTEGER, DEGREE OF Y POLYNOMIAL OF THE SMALLER MODEL,
C                SUPPLIED BY CALLING ROUTINE.
C     IDEGX0 - INTEGER, DEGREE OF X POLYNOMIAL OF THE SMALLER MODEL,
C                SUPPLIED BY CALLING ROUTINE.
C     LINTY0 - INTEGER, HIGHEST DEGREE INTERACTION ALLOWED IN THE Y
C                 POLYNOMIAL OF THE SMALLER MODEL, SUPPLIED BY
C                 CALLING ROUTINE.
C     LINTX0 - INTEGER, HIGHEST DEGREE INTERACTION ALLOWED IN THE X
C                 POLYNOMIAL OF THE SMALLER MODEL, SUPPLIED BY
C                 CALLING ROUTINE.
C     LRX1   - INTEGER, LAG LENGTH OF RX PART OF THE LARGER MODEL
C                MODEL, SUPPLIED BY CALLING ROUTINE.
C     LPOLY1 - INTEGER, LAG LENGTH OF THE X POLYNOMIAL IN THE
C                LARGER MODEL, SUPPLIED BY CALLING ROUTINE.
C     IDEGY1 - INTEGER, DEGREE OF Y POLYNOMIAL OF THE LARGER MODEL,
C                SUPPLIED BY CALLING ROUTINE.
C     IDEGX1 - INTEGER, DEGREE OF X POLYNOMIAL OF THE LARGER MODEL,
C                SUPPLIED BY CALLING ROUTINE.
C     LINTY1 - INTEGER, HIGHEST DEGREE INTERACTION ALLOWED IN THE Y
C                 POLYNOMIAL OF THE LARGER MODEL, SUPPLIED BY
C                 CALLING ROUTINE.
C     LINTX1 - INTEGER, HIGHEST DEGREE INTERACTION ALLOWED IN THE X
C                 POLYNOMIAL OF THE LARGER MODEL, SUPPLIED BY
C                 CALLING ROUTINE.
C     TWEAK  - TWEAK VALUE FOR THOSE ELEMENTS OF THETA THAT ARE
C               IMPLICITLY SET TO ZERO IN THE SMALLER MODEL
C     IDUMMY - INTEGER, RESERVED FOR FUTURE USE.
C
C     IWORK  - INTEGER WORK ARRAY OF LENGTH AT LEAST
C                2*M*L1 + M*KY0 + M*L0*KX0 + KY0 + KX0 where
C                L0 = MAX0(LRX0,LPOLY0)
C                L1 = MAX0(LRX1,LPOLY1)
C
C     WHERE
C        LTHETA0 = KX0*KY0 + M + L0*M*M + (LRX0+1)*M*(M+1)/2
C        LTHETA1 = KX1*KY1 + M + L1*M*M + (LRX1+1)*M*(M+1)/2
C
C     SUBROUTINES CALLED
C        SETMYX, MULTIY, MULTIX
C
C     REMARKS
C        THE WORK ON THETA IS DONE IN PLACE.  IF THE MODELS ARE
C        OF THE SAME SIZE THEN THE ROUTINE HAS NO EFFECT ON THETA.
C
C     WARNING
C        THIS ROUTINE USES SETMYX TO GENERATE MULTI-INDEXES
C        THE CALLS TO SETMYX MIGHT NEED TO BE MODIFIED
C        IF THAT ROUTINE IS EVER CHANGED.
C
      SUBROUTINE SNPRST(THETA,M,
     &    LRX0,LPOLY0,IDEGY0,IDEGX0,LINTY0,LINTX0,
     &    LRX1,LPOLY1,IDEGY1,IDEGX1,LINTY1,LINTX1,TWEAK,
     &    IDUMMY,IWORK)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 THETA(1)
      INTEGER IWORK(1)
      COMMON /ZPRINT/ IPRINT
      SAVE
C
C  SET SOME CONSTANTS
C
      NOUT = 3
C
      L0   = MAX0(LRX0,LPOLY0)
      L1   = MAX0(LRX1,LPOLY1)
      ML0  = M*L0
      ML1  = M*L1
C
C   VERIFY PARAMETERS
C
      IF (IPRINT.EQ.0) THEN
        WRITE(NOUT,3000) M,L0,L1,
     &    LRX0,   LRX1,
     &    LPOLY0, LPOLY1,
     &    IDEGY0, IDEGY1,
     &    IDEGX0, IDEGX1,
     &    LINTY0, LINTY1,
     &    LINTX0, LINTX1, TWEAK
      ENDIF
 3000   FORMAT(//5X,'REINITIALIZING THETA FOR A RESTART'/
     &           5X,'----------------------------------'//
     & ' M.........', I3/
     & ' L0........', I3, ' L1........ ', I3//
     & ' LRX0......', I3, ' LRX1...... ', I3/
     & ' LPOLY0....', I3, ' LPOLY1.... ', I3/
     & ' IDEGY0....', I3, ' IDEGY1.... ', I3/
     & ' IDEGX0....', I3, ' IDEGX1.... ', I3/
     & ' LINTY0....', I3, ' LINTY1.... ', I3/
     & ' LINTX0....', I3, ' LINTX1.... ', I3/
     & ' TWEAK.....', F10.5/)
C
C  CALL SETMYX TO SETUP MULTI-INDEXES FOR THE SMALLER MODEL.
C
      LSETYX = 2*ML1
      ISETYX = 1
      CALL SETMYX(M,L0,LPOLY0,IDEGY0,IDEGX0,LINTY0,LINTX0,KY0,KX0,
     &            IDUMMY,IWORK(ISETYX))
C
C   DEFINE POINTERS TO MULTI-INDEXES OF THE SMALLER MODEL AND
C     SAVE THESE MULTI-INDEXES IN IWORK.
C
      IMY0   = ISETYX + LSETYX
      IMX0   = IMY0   + M*KY0
      ITOP   = IMX0   + ML0*KX0
      DO 110 IY=1,KY0
        CALL MULTIY(IY,IWORK(ITOP))
         DO 112 J=1,M
            IWORK(IMY0-1+J+(IY-1)*M) = IWORK(ITOP-1+J)
 112     CONTINUE
 110  CONTINUE
      DO 120 IX=1,KX0
         CALL MULTIX(IX,IWORK(ITOP))
         DO 122 J=1,ML0
            IWORK(IMX0-1+J+(IX-1)*ML0) = IWORK(ITOP-1+J)
 122     CONTINUE
 120  CONTINUE
C
C  CALL SETMYX TO RESET THE MULTI-INDEXES FOR THE LARGER MODEL.
C
      CALL SETMYX(M,L1,LPOLY1,IDEGY1,IDEGX1,LINTY1,LINTX1,KY1,KX1,
     &            IDUMMY,IWORK(ISETYX))
C
C  COMPUTE POINTERS TO ARRAYS THAT HOLD THE REMAPPINGS
C    OF THE Y AND X MULTI-INDEXS.
C
      IYD  = ITOP
      IXD  = IYD  +  KY0
      ITOP = IXD  +  KX0
C
C  DETERMINE THE MAPPINGS BETWEEN THE TWO SETS OF Y AND X MULTI-INDEXES.
C
C  FOR EACH Y MULTI-INDEX IN THE SMALLER MODEL, SCAN FOR A MATCH
C    IN THE LARGER MODEL.  FALL THROUGH LOOP 144 MEANS A
C    MATCH IS FOUND AND THE LOCATION IS SAVED.  FALL THROUGH
C    LOOP 142 MEANS NO MATCH WAS FOUND, WHICH IS FATAL.
C
      IALPHA = ISETYX
      DO 140 IY0=1,KY0
         DO 142 IY1=1,KY1
            CALL MULTIY(IY1,IWORK(IALPHA))
            DO 144 J=1,M
               IF ( IWORK(IMY0  -1+J+(IY0-1)*M) .NE.
     &              IWORK(IALPHA-1+J          )      ) GOTO 142
 144        CONTINUE
            IWORK(IYD-1+IY0) = IY1
            GOTO 140
 142     CONTINUE
         GOTO 980
 140  CONTINUE
C
C  FOR EACH X MULTI-INDEX IN THE SMALLER MODEL SCAN FOR A MATCH
C    IN THE LARGER MODEL.  FALL THROUGH LOOP 154 MEANS A
C    MATCH IS FOUND AND THE LOCATION IS SAVED.  FALL THROUGH
C    LOOP 152 MEANS NO MATCH WAS FOUND, WHICH IS A FATAL ERROR.
C
      IBETA = ISETYX
      DO 150 IX0=1,KX0
         DO 152 IX1=1,KX1
            CALL MULTIX(IX1,IWORK(IBETA))
            DO 153 J=1,(L1-LPOLY0)*M
               IF (IWORK(IBETA-1+J) .NE. 0) GOTO 152
 153        CONTINUE
            DO 154 J=1,LPOLY0*M
               IF ( IWORK(IBETA+ML1-J              ) .NE.
     &              IWORK(IMX0 +ML0-J + (IX0-1)*ML0)    ) GOTO 152
 154        CONTINUE
            IWORK(IXD-1+IX0) = IX1
            GOTO 150
 152     CONTINUE
         GOTO 990
 150  CONTINUE
C
C   SET SOME CONSTANTS AND THEN REARRANGE THETA, STARTING
C   AND THE END AND MOVING TOWARDS THE BEGINNING.
C
      NA0   = KX0*KY0
      NA1   = KX1*KY1
      NQ0   = M + M*ML0
      NQ1   = M + M*ML1
      LR    = (M*(M+1))/2
      NR0   = LR*(1+M*LRX0)
      NR1   = LR*(1+M*LRX1)
      NT0   = NA0 + NQ0 + NR0
      NT1   = NA1 + NQ1 + NR1
C
C   MOVE  RX(LRX1...1) AND PUT 0.0 IN THE EMPTY SPACE
C
      DO 21 I=1,NR0-LR
         THETA(NT1-I+1) = THETA(NT0-I+1)
 21   CONTINUE
      DO 22 I=1,NR1-NR0
         THETA(NA1+NQ1+LR+I) = 0.0
 22   CONTINUE
C
C   MOVE RX(0)
C
      DO 23 I=1,LR
         THETA(NA1+NQ1+LR-I+1) = THETA(NA0+NQ0+LR-I+1)
23    CONTINUE
C
C   MOVE  B AND PUT TWEAK IN EXTRA PLACE
C
      DO 24 I=1,M*ML0
         THETA(NA1+NQ1-I+1) = THETA(NA0+NQ0-I+1)
 24   CONTINUE
      DO 26 I=1,M*M*(L1-L0)
         THETA(NA1+M+I) = TWEAK
 26   CONTINUE
C
C   MOVE B0
C
      DO 28 I=1,M
         THETA(NA1+M-I+1) = THETA(NA0+M-I+1)
 28   CONTINUE
C
C  NOW PUT IN TWEAK AND MOVE THE POLYNOMIAL PARAMETERS
C
      DO 200 IXY=KX0*KY0+1,KX1*KY1
 200     THETA(IXY) = TWEAK
      DO 210 IY0=1,KY0
         IYY0 = KY0 - IY0  + 1
         IYY1 = IWORK(IYD-1+IYY0)
         DO 216 IX0=1,KX0
            IXX0 = KX0 - IX0  + 1
            IXX1 = IWORK(IXD-1+IXX0)
            IXY0 = IXX0 + (IYY0-1)*KX0
            IXY1 = IXX1 + (IYY1-1)*KX1
            THETA(IXY1) = THETA(IXY0)
            IF (IXY1 .GT. IXY0) THETA(IXY0) = TWEAK
 216     CONTINUE
 210  CONTINUE
C
C  DONE
C
      RETURN
C
C  HERE WE HANDLE THE SITUATIONS WHERE NO MATCHES WERE FOUND.
C  THE PROGRAM IS HALTED BECAUSE THE RESULTS WILL BE MEANINGLESS.
C
 980  CONTINUE
      WRITE(NOUT,3981) M,
     & LRX0,   LRX1,
     & LPOLY0, LPOLY1,
     & IDEGY0, IDEGY1,
     & IDEGX0, IDEGX1,
     & LINTY0, LINTY1,
     & LINTX0, LINTX1
      STOP
 990  CONTINUE
      WRITE(NOUT,3982) M,
     & LRX0,   LRX1,
     & LPOLY0, LPOLY1,
     & IDEGY0, IDEGY1,
     & IDEGX0, IDEGX1,
     & LINTY0, LINTY1,
     & LINTX0, LINTX1
       STOP
 3981 FORMAT(
     &/' ***ERROR: SNPRST: UNABLE TO FIND MATCHING Y MULTI-INDEX'/
     & ' M.........', I3/
     & ' LRX0......', I3, ' LRX1...... ', I3/
     & ' LPOLY0....', I3, ' LPOLY1.... ', I3/
     & ' IDEGY0....', I3, ' IDEGY1.... ', I3/
     & ' IDEGX0....', I3, ' IDEGX1.... ', I3/
     & ' LINTY0....', I3, ' LINTY1.... ', I3/
     & ' LINTX0....', I3, ' LINTX1.... ', I3/)
 3982 FORMAT(
     &/' ***ERROR: SNPRST: UNABLE TO FIND MATCHING X MULTI-INDEX'/
     & ' M.........', I3/
     & ' LRX0......', I3, ' LRX1...... ', I3/
     & ' LPOLY0....', I3, ' LPOLY1.... ', I3/
     & ' IDEGY0....', I3, ' IDEGY1.... ', I3/
     & ' IDEGX0....', I3, ' IDEGX1.... ', I3/
     & ' LINTY0....', I3, ' LINTY1.... ', I3/
     & ' LINTX0....', I3, ' LINTX1.... ', I3/)
      END

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  SRSUBS FORTRAN
*
*     SRCHC    SRCHQ
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE SRCHC ( DEBUG, DONE, FIRST, IMPRVD, INFORM,
     $                   ALFMAX, EPSAF, ETA,
     $                   XTRY, FTRY, GTRY, OLDF, OLDG,
     $                   TOLABS, TOLREL, TOLTNY,
     $                   ALFA, ALFBST, FBEST, GBEST )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            DEBUG , DONE  , FIRST , IMPRVD

************************************************************************
*  SRCHC   is a  step-length  algorithm for minimizing a function of one
*  variable.  It will be called  repeatedly  by a  search  routine whose
*  purpose is to  estimate a point  ALFA = ALFBST  that  minimizes  some
*  function  F(alfa)  over the closed interval (0, ALFMAX).
*
*  SRCHC  requires both the function  F(alfa)  and its gradient  G(alfa)
*  to be  evaluated  at various  points within  the interval.  New step-
*  length  estimates  are  computed  using  cubic  interpolation  with
*  safeguards.
*
*  Reverse communication is used to allow the calling program to
*  evaluate F and G.  Some of the parameters must be set or tested
*  by the calling program.  the remainder would ordinarily be local
*  variables.
*
*
*  Input parameters (relevant to the calling program)
*  --------------------------------------------------
*
*  DEBUG         specifies whether detailed output is wanted.
*
*  FIRST         must be .TRUE. on the first entry. It is subsequently
*                altered by SRCHC.
*
*  MFSRCH        is an upper limit on the number of times SRCHC is to be
*                entered consecutively with DONE = .FALSE. (following
*                an initial entry with FIRST = .TRUE..
*
*  ALFA          is the first estimate of the step length.  ALFA is
*                subsequently altered by SRCHC (see below).
*
*  ALFMAX        is the upper limit of the interval to be searched.
*
*  EPSAF         is an estimate of the absolute precision in the
*                computed value of F.
*
*  ETA           controls the accuracy of the search.  It must lie
*                in the range   0.0  le  ETA  lt  1.0.  Decreasing
*                ETA  tends to increase the accuracy of the search.
*
*  FTRY, GTRY    are the values of F, G  at the new point
*                ALFA = ALFBST + XTRY.
*
*  OLDF, OLDG    are the values of F(0) and G(0). OLDG must be negative.
*
*  TOLABS,TOLREL define a function TOL(ALFA) = TOLREL*ALFA + TOLABS such
*                that if F has already been evaluated at step ALFA,  it
*                will not be evaluated closer than TOL(ALFA).  These
*                values may be reduced by SRCHC.
*
*  TOLTNY        is the smallest value that TOLABS is allowed to be
*                reduced to.
*
*
*  Output parameters (relevant to the calling program)
*  ---------------------------------------------------
*
*  IMPRVD        is true if the previous step ALFA was the best point
*                so far.  Any related quantities should be saved by the
*                calling program (e.g., gradient arrays) before paying
*                attention to DONE.
*
*  DONE = FALSE  means the calling program should evaluate
*                      FTRY = F(ALFA),  GTRY = G(ALFA)
*                for the new trial step ALFA, and then re-enter SRCHC.
*
*  DONE = TRUE   means that no new steplength was calculated.  The value
*                of INFORM gives the result of the linesearch as follows
*
*                INFORM = 1 means the search has terminated successfully
*                           with ALFBST less than ALFMAX.
*
*                INFORM = 2 means the search has terminated successfully
*                           with ALFBST = ALFMAX.
*
*                INFORM = 3 means that the search failed to find a point
*                           of sufficient decrease in MFSRCH functions,
*                           but an improved point was found.
*
*                INFORM = 4 means ALFMAX is so small that a search
*                           should not have been attempted.
*
*                INFORM = 5 is never set by SRCHC.
*
*                INFORM = 6 means the search has failed to find a useful
*                           step.  If the function and gradient have
*                           been programmed correctly, this will usually
*                           occur if the minimum lies very close to
*                           ALFA = 0 or the gradient is not sufficiently
*                           accurate.
*
*  NFSRCH        counts the number of times SRCHC has been entered
*                consecutively with DONE = FALSE (i.e., with a new
*                function value FTRY).
*
*  ALFA          is the step at which the next function FTRY and
*                gradient GTRY must be computed.
*
*  ALFBST        should be accepted by the calling program as the
*                required step-length estimate, whenever SRCHC returns
*                INFORM = 1 or 2 (and possibly 3).
*
*  FBEST, GBEST  will be the corresponding values of F, G.
*
*
*  The following parameters retain information between entries
*  -----------------------------------------------------------
*
*  ALFUZZ        is such that, if the final ALFA lies in the interval
*                (0,ALFUZZ)  and  ABS( F(ALFA)-OLDF ).LE.EPSAF,  ALFA
*                cannot be guaranteed to be a point of sufficient
*                decrease.
*
*  BRAKTD        is false if F and G have not been evaluated at
*                the far end of the interval of uncertainty.  In this
*                case, the point B will be at ALFMAX + TOL(ALFMAX).
*
*  CRAMPD        is true if ALFMAX is very small (le TOLABS).  If the
*                search fails, this indicates that a zero step should be
*                taken.
*
*  EXTRAP        is true if XW lies outside the interval of uncertainty.
*                In this case, extra safeguards are applied to allow for
*                instability in the polynomial fit.
*
*  MOVED         is true if a better point has been found (ALFBST GT 0).
*
*  WSET          records whether a second-best point has been determined
*                It will always be true when convergence is tested.
*
*  NSAMEA        is the number of consecutive times that the left-hand
*                end of the interval of uncertainty has remained the
*                same.
*
*  NSAMEB        similarly for the right-hand end.
*
*  A, B, ALFBST  define the current interval of uncertainty.
*                The required minimum lies somewhere within the
*                closed interval  (ALFBST + A, ALFBST + B).
*
*  ALFBST        is the best point so far.  It is always at one end of
*                the interval of uncertainty.  Hence we have
*                either  A lt 0,  B = 0  or  A = 0,  B gt 0.
*
*  FBEST, GBEST  are the values of F, G at the point ALFBST.
*
*  FACTOR        controls the rate at which extrapolated estimates of
*                ALFA may expand into the interval of uncertainty.
*                FACTOR is not used if the minimum has been bracketed
*                (i.e., when the variable BRAKTD is true).
*
*  FW, GW        are the values of F, G at the point ALFBST + XW.
*                They are not defined until WSET is true.
*
*  XTRY          is the trial point within the shifted interval (A, B).
*
*  XW            is such that  ALFBST + XW  is the second-best point.
*                It is not defined until  WSET  is true.
*                In some cases,  XW  will replace a previous  XW  that
*                has a lower function but has just been excluded from
*                the interval of uncertainty.
*
*  RMU           controls what is meant by a significant decrease in F.
*                The final F(ALFBST)  should lie on or below the line
*                      L(ALFA)  =  OLDF + ALFA*RMU*OLDG.
*                RMU  should be in the open interval (0, 1/2).
*                The value  RMU = 1.0E-4  is good for most purposes.
*
*  RTMIN         is used to avoid floating-point underflow.  It should
*                be reasonably close to the square root of the smallest
*                representable positive number.
*
*
*  Systems Optimization Laboratory, Stanford University, California.
*  Original version February 1982.  Rev. May 1983.
*  Original F77 version 22-August-1985.
*  This version of SRCHC dated 29-June-1986.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
      COMMON    /SOL1CM/ NOUT

      EXTERNAL           DNORM
      INTRINSIC          ABS   , SQRT
      LOGICAL            BRAKTD, CRAMPD, EXTRAP, MOVED , WSET
      SAVE               BRAKTD, CRAMPD, EXTRAP, MOVED , WSET

      SAVE               NFSRCH, NSAMEA, NSAMEB
      SAVE               A     , B     , ALFUZZ, FACTOR, RTMIN
      SAVE               XW    , FW    , GW    , TOLMAX

      LOGICAL            CLOSEF, CONV1 , CONV2 , CONVRG
      LOGICAL            FITOK , SETXW , SIGDEC

      PARAMETER        ( ZERO  =0.0D+0, POINT1 =0.1D+0, HALF   =0.5D+0 )
      PARAMETER        ( ONE   =1.0D+0, TWO    =2.0D+0, THREE  =3.0D+0 )
      PARAMETER        ( FIVE  =5.0D+0, TEN    =1.0D+1, ELEVEN =1.1D+1 )
      PARAMETER        ( RMU   =1.0D-4, MFSRCH =15                     )

*     ------------------------------------------------------------------
*     Local variables
*     ===============
*
*     CLOSEF     is true if the new function FTRY is within EPSAF of
*                FBEST (up or down).
*
*     CONVRG     will be set to true if at least one of the convergence
*                conditions holds at ALFBST.
*
*     SIGDEC     says whether FBEST represents a significant decrease in
*                the function, compared to the initial value OLDF.
*  ---------------------------------------------------------------------

      IMPRVD = .FALSE.
      IF (FIRST) THEN
*        ---------------------------------------------------------------
*        First entry.  Initialize various quantities, check input data
*        and prepare to evaluate the function at the initial step ALFA.
*        ---------------------------------------------------------------
         FIRST  = .FALSE.
         RTMIN  = WMACH(6)

         NFSRCH = 0
         ALFBST = ZERO
         FBEST  = OLDF
         GBEST  = OLDG
         CRAMPD = ALFMAX .LE. TOLABS
         DONE   = ALFMAX .LE. TOLTNY  .OR.  OLDG .GE. ZERO
         MOVED  = .FALSE.

         IF (.NOT. DONE) THEN
            BRAKTD = .FALSE.
            EXTRAP = .FALSE.
            WSET   = .FALSE.
            NSAMEA = 0
            NSAMEB = 0
            ALFUZZ = ALFMAX
            IF (TWO*EPSAF .LT. - OLDG*RMU*ALFMAX)
     $         ALFUZZ = - TWO*EPSAF/(RMU*OLDG)

            TOLMAX = TOLABS + TOLREL*ALFMAX
            A      = ZERO
            B      = ALFMAX + TOLMAX
            FACTOR = FIVE
            TOL    = TOLABS
            XTRY   = ALFA
            IF (DEBUG)
     $         WRITE (NOUT, 1000) ALFMAX, OLDF , OLDG  , TOLABS,
     $                            ALFUZZ, EPSAF, TOLREL, CRAMPD
         END IF
      ELSE
*        ---------------------------------------------------------------
*        Subsequent entries. The function has just been evaluated at
*        ALFA = ALFBST + XTRY,  giving FTRY and GTRY.
*        ---------------------------------------------------------------
         NFSRCH = NFSRCH + 1
         NSAMEA = NSAMEA + 1
         NSAMEB = NSAMEB + 1

         IF (.NOT. BRAKTD) THEN
            TOLMAX = TOLABS + TOLREL*ALFMAX
            B      = ALFMAX - ALFBST + TOLMAX
         END IF

*        See if the new step is better.  If ALFA is large enough that
*        FTRY can be distinguished numerically from OLDF,  the function
*        is required to be sufficiently decreased.

         IF (ALFA .LE. ALFUZZ) THEN
            SIGDEC = FTRY - OLDF                 .LE. EPSAF
         ELSE
            SIGDEC = FTRY - OLDF - ALFA*RMU*OLDG .LE. EPSAF
         END IF
         CLOSEF = ABS( FTRY - FBEST ) .LE.    EPSAF
         IMPRVD =    ( FTRY - FBEST ) .LE. (- EPSAF)
         IF (CLOSEF) IMPRVD = ABS( GTRY ) .LE. ABS( GBEST )
         IMPRVD = IMPRVD  .AND.  SIGDEC

         IF (DEBUG) WRITE (NOUT, 1100)
     $      ALFA, FTRY, GTRY, FTRY - OLDF - ALFA*RMU*OLDG

         IF (IMPRVD) THEN

*           We seem to have an improvement.  The new point becomes the
*           origin and other points are shifted accordingly.

            FW     = FBEST
            FBEST  = FTRY
            GW     = GBEST
            GBEST  = GTRY
            ALFBST = ALFA
            MOVED  = .TRUE.

            A      = A    - XTRY
            B      = B    - XTRY
            XW     = ZERO - XTRY
            WSET   = .TRUE.
            EXTRAP =       XW .LT. ZERO  .AND.  GBEST .LT. ZERO
     $               .OR.  XW .GT. ZERO  .AND.  GBEST .GT. ZERO

*           Decrease the length of the interval of uncertainty.

            IF (GTRY .LE. ZERO) THEN
               A      = ZERO
               NSAMEA = 0
            ELSE
               B      = ZERO
               NSAMEB = 0
               BRAKTD = .TRUE.
            END IF
         ELSE

*           The new function value is not better than the best point so
*           far.  The origin remains unchanged but the new point may
*           qualify as XW.  XTRY must be a new bound on the best point.

            IF (XTRY .LE. ZERO) THEN
               A      = XTRY
               NSAMEA = 0
            ELSE
               B      = XTRY
               NSAMEB = 0
               BRAKTD = .TRUE.
            END IF

*           If XW has not been set or FTRY is better than FW, update the
*           points accordingly.

            SETXW = .TRUE.
            IF (WSET)
     $         SETXW = FTRY .LE. FW + EPSAF  .OR.  .NOT. EXTRAP

            IF (SETXW) THEN
               XW     = XTRY
               FW     = FTRY
               GW     = GTRY
               WSET   = .TRUE.
               EXTRAP = .FALSE.
            END IF
         END IF

*        ---------------------------------------------------------------
*        Check the termination criteria.  WSET will always be true.
*        ---------------------------------------------------------------
         TOL    = TOLABS + TOLREL*ALFBST

         IF (ALFBST .LE. ALFUZZ) THEN
            SIGDEC = FBEST - OLDF                   .LE. EPSAF
         ELSE
            SIGDEC = FBEST - OLDF - ALFBST*RMU*OLDG .LE. EPSAF
         END IF

         CONV1  = (B - A) .LE. (TOL + TOL)
         CONV2  = MOVED  .AND.  SIGDEC
     $                   .AND.  ABS(GBEST) .LE. ETA*ABS(OLDG)
         CONVRG = CONV1  .OR.   CONV2

         IF (DEBUG) WRITE (NOUT, 1200)
     $      ALFBST + A, ALFBST + B, B - A, TOL,
     $      NSAMEA, NSAMEB, BRAKTD, CLOSEF,
     $      IMPRVD, CONV1 , CONV2 , EXTRAP,
     $      ALFBST, FBEST , GBEST , FBEST - OLDF - ALFBST*RMU*OLDG,
     $      ALFBST + XW, FW, GW

         IF (NFSRCH .GE. MFSRCH) THEN
            DONE = .TRUE.
         ELSE IF (CONVRG) THEN
            IF (MOVED) THEN
               DONE = .TRUE.
            ELSE

*              A better point has not yet been found (the step XW is no
*              better than step zero).  Check that the change in F is
*              consistent with an X-perturbation of TOL,  the minimum
*              spacing estimate.  If not, the value of TOL is reduced.
*              F is larger than EPSAF, the value of TOL is reduced.

               TOL    = TOL/TEN
               TOLABS = TOL
               IF (ABS(FW - OLDF) .LE. EPSAF  .OR.  TOL .LE. TOLTNY)
     $            DONE = .TRUE.
            END IF
         END IF

*        ---------------------------------------------------------------
*        Proceed with the computation of a trial step length.
*        The choices are...
*        1. Parabolic fit using gradients only, if the F values are
*           close.
*        2. Cubic fit for a minimum, using both function and gradients.
*        3. Damped cubic or parabolic fit if the regular fit appears to
*           be consistently over-estimating the distance to the minimum.
*        4. Bisection, geometric bisection, or a step of  TOL  if
*           choices 2 or 3 are unsatisfactory.
*        ---------------------------------------------------------------
         IF (.NOT. DONE) THEN
            XMIDPT = HALF*(A + B)
            S      = ZERO
            Q      = ZERO

            IF (CLOSEF) THEN
*              ---------------------------------------------------------
*              Fit a parabola to the two best gradient values.
*              ---------------------------------------------------------
               S      = GBEST
               Q      = GBEST - GW
               IF (DEBUG) WRITE (NOUT, 2200)
            ELSE
*              ---------------------------------------------------------
*              Fit cubic through  FBEST  and  FW.
*              ---------------------------------------------------------
               IF (DEBUG) WRITE (NOUT, 2100)
               FITOK  = .TRUE.
               R      = THREE*(FBEST - FW)/XW + GBEST + GW
               ABSR   = ABS( R )
               S      = SQRT( ABS( GBEST ) ) * SQRT( ABS( GW ) )
               IF (S .LE. RTMIN) THEN
                  Q   = ABSR
               ELSE

*                 Compute  Q =  the square root of  R*R - GBEST*GW.
*                 The method avoids unnecessary underflow and overflow.

                  IF ((GW .LT. ZERO  .AND.  GBEST .GT. ZERO) .OR.
     $                (GW .GT. ZERO  .AND.  GBEST .LT. ZERO)) THEN
                     SUMSQ  = ONE
                     IF (ABSR .LT. S) THEN
                        IF (ABSR .GE. S*RTMIN) SUMSQ = ONE + (ABSR/S)**2
                        SCALE  = S
                     ELSE
                        IF (S .GE. ABSR*RTMIN) SUMSQ = ONE + (S/ABSR)**2
                        SCALE  = ABSR
                     END IF
                     Q     = DNORM ( SCALE, SUMSQ )
                  ELSE IF (ABSR .GE. S) THEN
                     Q     = SQRT(ABSR + S)*SQRT(ABSR - S)
                  ELSE
                     FITOK  = .FALSE.
                  END IF

               END IF

               IF (FITOK) THEN

*                 Compute the minimum of the fitted cubic.

                  IF (XW .LT. ZERO) Q = - Q
                  S  = GBEST -  R - Q
                  Q  = GBEST - GW - Q - Q
               END IF
            END IF

*           ------------------------------------------------------------
*           Construct an artificial interval  (ARTIFA, ARTIFB)  in which
*           the new estimate of the step length must lie.  Set a default
*           value of XTRY that will be used if the polynomial fit fails.
*           ------------------------------------------------------------
            ARTIFA = A
            ARTIFB = B
            IF (.NOT. BRAKTD) THEN

*              The minimum has not been bracketed.  Set an artificial
*              upper bound by expanding the interval  XW  by a suitable
*              FACTOR.

               XTRY   = - FACTOR*XW
               ARTIFB =   XTRY
               IF (ALFBST + XTRY .LT. ALFMAX) FACTOR = FIVE*FACTOR

            ELSE IF (EXTRAP) THEN

*              The points are configured for an extrapolation.
*              Set a default value of  XTRY  in the interval  (A,B)
*              that will be used if the polynomial fit is rejected.  In
*              the following,  DTRY  and  DAUX  denote the lengths of
*              the intervals  (A,B)  and  (0,XW)  (or  (XW,0),  if
*              appropriate).  The value of  XTRY is the point at which
*              the exponents of  DTRY  and  DAUX  are approximately
*              bisected.

               DAUX = ABS( XW )
               DTRY = B - A
               IF (DAUX .GE. DTRY) THEN
                  XTRY = FIVE*DTRY*(POINT1 + DTRY/DAUX)/ELEVEN
               ELSE
                  XTRY = HALF * SQRT( DAUX ) * SQRT( DTRY )
               END IF
               IF (XW .GT. ZERO)   XTRY = - XTRY
               IF (DEBUG) WRITE (NOUT, 2400) XTRY, DAUX, DTRY

*              Reset the artificial bounds.  If the point computed by
*              extrapolation is rejected,  XTRY will remain at the
*              relevant artificial bound.

               IF (XTRY .LE. ZERO) ARTIFA = XTRY
               IF (XTRY .GT. ZERO) ARTIFB = XTRY
            ELSE

*              The points are configured for an interpolation.  The
*              default value XTRY bisects the interval of uncertainty.
*              The artificial interval is just (A,B).

               XTRY   = XMIDPT
               IF (DEBUG) WRITE (NOUT, 2300) XTRY
               IF (NSAMEA .GE. 3  .OR.  NSAMEB .GE. 3) THEN

*                 If the interpolation appears to be over-estimating the
*                 distance to the minimum,  damp the interpolation step.

                  FACTOR = FACTOR / FIVE
                  S      = FACTOR * S
               ELSE
                  FACTOR = ONE
               END IF
            END IF

*           ------------------------------------------------------------
*           The polynomial fits give  (S/Q)*XW  as the new step.
*           Reject this step if it lies outside  (ARTIFA, ARTIFB).
*           ------------------------------------------------------------
            IF (Q .NE. ZERO) THEN
               IF (Q .LT. ZERO) S = - S
               IF (Q .LT. ZERO) Q = - Q
               IF (S*XW .GE. Q*ARTIFA  .AND.  S*XW .LE. Q*ARTIFB) THEN

*                 Accept the polynomial fit.

                  XTRY = ZERO
                  IF (ABS( S*XW ) .GE. Q*TOL) XTRY = (S/Q)*XW
                  IF (DEBUG) WRITE (NOUT, 2500) XTRY
               END IF
            END IF
         END IF
      END IF

*     ==================================================================

      IF (.NOT. DONE) THEN
         ALFA  = ALFBST + XTRY
         IF (BRAKTD  .OR.  ALFA .LT. ALFMAX - TOLMAX) THEN

*           The function must not be evaluated too close to A or B.
*           (It has already been evaluated at both those points.)

            IF (XTRY .LE. A + TOL  .OR.  XTRY .GE. B - TOL) THEN
               XTRY = TOL
               IF (HALF*(A + B) .LE. ZERO) XTRY = - TOL
               ALFA = ALFBST + XTRY
            END IF

         ELSE

*           The step is close to or larger than ALFMAX, replace it by
*           ALFMAX to force evaluation of the function at the boundary.

            BRAKTD = .TRUE.
            XTRY   = ALFMAX - ALFBST
            ALFA   = ALFMAX

         END IF
      END IF

*     ------------------------------------------------------------------
*     Exit.
*     ------------------------------------------------------------------
      IF (DONE) THEN
         IF (MOVED) THEN
            IF (CONVRG) THEN
               INFORM = 1
               IF (ALFA .EQ. ALFMAX) INFORM = 2
            ELSE
               INFORM = 3
            END IF
         ELSE IF (OLDG .GE. ZERO  .OR.  ALFMAX .LT. TOLTNY) THEN
            INFORM = 7
         ELSE
            INFORM = 6
            IF (CRAMPD) INFORM = 4
         END IF
      END IF


      IF (DEBUG) WRITE (NOUT, 3000)
      RETURN

 1000 FORMAT(/' ALFMAX  OLDF    OLDG    TOLABS', 1P2E22.14,   1P2E16.8
     $       /' ALFUZZ  EPSAF           TOLREL', 1P2E22.14,16X,1PE16.8
     $       /' CRAMPD                        ',  L6)
 1100 FORMAT(/' ALFA    FTRY    GTRY    CTRY  ', 1P2E22.14,   1P2E16.8)
 1200 FORMAT(/' A       B       B - A   TOL   ', 1P2E22.14,   1P2E16.8
     $       /' NSAMEA  NSAMEB  BRAKTD  CLOSEF', 2I3, 2L6
     $       /' IMPRVD  CONVRG  EXTRAP        ',  L6, 3X, 2L1, L6
     $       /' ALFBST  FBEST   GBEST   CBEST ', 1P2E22.14,   1P2E16.8
     $       /' ALFAW   FW      GW            ', 1P2E22.14,    1PE16.8/)
 2100 FORMAT( ' Cubic.   ')
 2200 FORMAT( ' Parabola.')
 2300 FORMAT( ' Bisection.              XMIDPT', 1P1E22.14)
 2400 FORMAT( ' Geo. bisection. XTRY,DAUX,DTRY', 1P3E22.14)
 2500 FORMAT( ' Polynomial fit accepted.  XTRY', 1P1E22.14)
 3000 FORMAT( ' ----------------------------------------------------'/)

*     End of  SRCHC .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE SRCHQ ( DEBUG, DONE, FIRST, IMPRVD, INFORM,
     $                   ALFMAX, ALFSML, EPSAF, ETA,
     $                   XTRY, FTRY, OLDF, OLDG,
     $                   TOLABS, TOLREL, TOLTNY,
     $                   ALFA, ALFBST, FBEST )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            DEBUG , DONE  , FIRST , IMPRVD

************************************************************************
*  SRCHQ  is a step-length algorithm for minimizing a function of one
*  variable.  It will be called repeatedly by a search routine whose
*  purpose is to estimate a point ALFA = ALFBST that minimizes some
*  function F(ALFA) over the closed interval (0, ALFMAX).
*
*  SRCHQ  requires the function F(ALFA) (but not its gradient) to be
*  evaluated at various points within the interval.  New steplength
*  estimates are computed using quadratic interpolation with safeguards.
*
*  Reverse communication is used to allow the calling program to
*  evaluate F.  Some of the parameters must be set or tested by the
*  calling program.  The remainder would ordinarily be local variables.
*
*
*  Input parameters (relevant to the calling program)
*  --------------------------------------------------
*
*  DEBUG         specifies whether detailed output is wanted.
*
*  FIRST         must be .TRUE. on the first entry. It is subsequently
*                altered by SRCHQ.
*
*  MFSRCH        is an upper limit on the number of times SRCHQ is to be
*                entered consecutively with DONE = .FALSE. (following
*                an initial entry with FIRST = .TRUE.).
*
*  ALFA          is the first estimate of the steplength.  ALFA is
*                subsequently altered by SRCHQ (see below).
*
*  ALFMAX        is the upper limit of the interval to be searched.
*
*  ALFSML        is intended to prevent inefficiency when the optimum
*                step is very small, for cases where the calling program
*                would prefer to re-define F(ALFA).  ALFSML is allowed
*                to be zero. Early termination will occur if SRCHQ
*                determines that the optimum step lies somewhere in the
*                interval (0, ALFSML) (but not if ALFMAX .LE. ALFSML).
*
*  EPSAF         is an estimate of the absolute precision in the
*                computed value of F.
*
*  ETA           controls the accuracy of the search.  It must lie
*                in the range  0 .LE. ETA .LT. 1.  Decreasing ETA tends
*                to increase the accuracy of the search.
*
*  FTRY          the value of F at the new point ALFA = ALFBST + XTRY.
*
*  OLDF, OLDG    are the values of F(0) and G(0). OLDG must be negative.
*
*  TOLABS,TOLREL define a function  TOL(ALFA) = TOLREL*ALFA + TOLABS
*                such that if F has already been evaluated at step ALFA,
*                then it will not be evaluated at any point closer than
*                TOL(ALFA).  These values may be reduced by SRCHQ if
*                they seem to be too large.
*
*  TOLTNY        is the smallest value that TOLABS is allowed to be
*                reduced to.
*
*
*  Output parameters (relevant to the calling program)
*  ---------------------------------------------------
*
*  IMPRVD        is true if the previous step ALFA was the best point
*                so far.  Any related quantities should be saved by the
*                calling program (e.g., arrays) before paying attention
*                to DONE.
*
*  DONE = FALSE  means the calling program should evaluate FTRY for the
*                new trial step ALFA, and then re-enter SRCHQ.
*
*  DONE = TRUE   means that no new steplength was calculated.  The value
*                of INFORM gives the result of the linesearch as follows
*
*                INFORM = 1 means the search has terminated successfully
*                           with ALFBST less than ALFMAX.
*
*                INFORM = 2 means the search has terminated successfully
*                           with ALFBST = ALFMAX.
*
*                INFORM = 3 means that the search failed to find a point
*                           of sufficient decrease in MFSRCH functions,
*                           but an improved point was found.
*
*                INFORM = 4 means ALFMAX is so small that a search
*                           should not have been attempted.
*
*                INFORM = 5 means that the search was terminated because
*                           of ALFSML (see above).
*
*                INFORM = 6 means the search has failed to find a useful
*                           step.  If the function has been programmed
*                           correctly, this will usually occur if the
*                           minimum lies very close to ALFA = 0.
*
*  NFSRCH        counts the number of times SRCHQ has been entered
*                consecutively with DONE = FALSE (i.e., with a new
*                function value FTRY).
*
*  ALFA          is the step at which the next function FTRY must be
*                computed.
*
*  ALFBST        should be accepted by the calling program as the
*                required steplength estimate, whenever SRCHQ returns
*                INFORM = 1, 2 or 3.
*
*  FBEST         will be the corresponding value of F.
*
*
*  The following parameters retain information between entries
*  -----------------------------------------------------------
*
*  ALFUZZ        is such that, if the final ALFA lies in the interval
*                (0,ALFUZZ) and ABS( F(ALFA)-OLDF ) .LE. EPSAF,  ALFA
*                cannot be guaranteed to be a point of sufficient
*                decrease.
*
*  BRAKTD        is false if F has not been evaluated at the far end
*                of the interval of uncertainty.  In this case, the
*                point B will be at ALFMAX + TOL(ALFMAX).
*
*  CRAMPD        is true if ALFMAX is very small (.LE. TOLABS).  If the
*                search fails, this indicates that a zero step should
*                be taken.
*
*  EXTRAP        is true if ALFBST has moved at least once and XV lies
*                outside the interval of uncertainty.  In this case,
*                extra safeguards are applied to allow for instability
*                in the polynomial fit.
*
*  MOVED         is true if a better point has been found (ALFBST GT 0).
*
*  VSET          records whether a third-best point has been defined.
*
*  WSET          records whether a second-best point has been defined.
*                It will always be true by the time the convergence
*                test is applied.
*
*  NSAMEA        is the number of consecutive times that the left-hand
*                end of the interval of uncertainty has remained the
*                same.
*
*  NSAMEB        similarly for the right-hand end.
*
*  A, B, ALFBST  define the current interval of uncertainty.
*                The required minimum lies somewhere within the
*                closed interval  (ALFBST + A, ALFBST + B).
*
*  ALFBST        is the best point so far.  it is strictly within the
*                the interval of uncertainty except when it lies at the
*                left-hand end when ALFBST has not been moved.
*                Hence we have A .LE. 0 and B .GT. 0.
*
*  FBEST         is the value of F at the point ALFBST.
*
*  FA            is the value of F at the point ALFBST + A.
*
*  FACTOR        controls the rate at which extrapolated estimates of
*                ALFA  may expand into the interval of uncertainty.
*                FACTOR is not used if the minimum has been bracketed
*                (i.e., when the variable BRAKTD is true).
*
*  FV, FW        are the values of F at the points ALFBST + XV,
*                ALFBST + XW.  They are not defined until VSET or WSET
*                are true.
*
*  XTRY          is the trial point within the shifted interval (A, B).
*                The new trial function value must be computed at the
*                point ALFA = ALFBST + XTRY.
*
*  XV            is such that ALFBST + XV is the third-best point. It is
*                not defined until VSET is true.
*
*  XW            is such that ALFBST + XW is the second-best point. It
*                is not defined until WSET is true.  In some cases, XW
*                will replace a previous XW that has a lower function
*                but has just been excluded from (A,B).
*
*  RMU           controls what is meant by a significant decrease in F.
*                The final F(ALFBST)  should lie on or below the line
*                      L(ALFA)  =  OLDF + ALFA*RMU*OLDG.
*                RMU  should be in the open interval (0, 1/2).
*                The value  RMU = 1.0E-4  is good for most purposes.
*
*
*  Systems Optimization Laboratory, Stanford University, California.
*  Original version February 1982.  Rev. May 1983.
*  Original F77 version 22-August-1985.
*  This version of SRCHQ dated 30-July-1986.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            BRAKTD, CRAMPD, EXTRAP, MOVED , VSET  , WSET
      SAVE               BRAKTD, CRAMPD, EXTRAP, MOVED , VSET  , WSET

      SAVE               NFSRCH, NSAMEA, NSAMEB
      SAVE               A     , B     , FA    , ALFUZZ, FACTOR
      SAVE               XW    , FW    , XV    , FV    , TOLMAX

      LOGICAL            CLOSEF, CONV1 , CONV2 , CONV3 , CONVRG
      LOGICAL            SETXV , SIGDEC, XINXW
      INTRINSIC          ABS   , SQRT

      PARAMETER        ( ZERO  =0.0D+0, POINT1 =0.1D+0, HALF   =0.5D+0 )
      PARAMETER        ( ONE   =1.0D+0, TWO    =2.0D+0, FIVE   =5.0D+0 )
      PARAMETER        ( TEN   =1.0D+1, ELEVEN =1.1D+1                 )
      PARAMETER        ( RMU   =1.0D-4, MFSRCH =15                     )

*     ------------------------------------------------------------------
*     Local variables
*     ===============
*
*     CLOSEF     is true if the worst function FV is within EPSAF of
*                FBEST (up or down).
*
*     CONVRG     will be set to true if at least one of the convergence
*                conditions holds at ALFBST.
*
*     SIGDEC     says whether FBEST represents a significant decrease
*             in the function, compared to the initial value OLDF.
*
*     XINXW      is true if XTRY is in (XW,0) or (0,XW).
*     ------------------------------------------------------------------

      IMPRVD = .FALSE.
      IF (FIRST) THEN
*        ---------------------------------------------------------------
*        First entry.  Initialize various quantities, check input data
*        and prepare to evaluate the function at the initial step ALFA.
*        ---------------------------------------------------------------
         FIRST  = .FALSE.
         NFSRCH = 0
         ALFBST = ZERO
         FBEST  = OLDF
         CRAMPD = ALFMAX .LE. TOLABS
         DONE   = ALFMAX .LE. TOLTNY  .OR.  OLDG .GE. ZERO
         MOVED  = .FALSE.

         IF (.NOT. DONE) THEN
            BRAKTD = .FALSE.
            CRAMPD = ALFMAX .LE. TOLABS
            EXTRAP = .FALSE.
            VSET   = .FALSE.
            WSET   = .FALSE.
            NSAMEA = 0
            NSAMEB = 0
            ALFUZZ = ALFMAX
            IF (TWO*EPSAF .LT. - OLDG*RMU*ALFMAX)
     $         ALFUZZ = - TWO*EPSAF/(RMU*OLDG)

            TOLMAX = TOLREL*ALFMAX + TOLABS
            A      = ZERO
            B      = ALFMAX + TOLMAX
            FA     = OLDF
            FACTOR = FIVE
            TOL    = TOLABS
            XTRY   = ALFA
            IF (DEBUG)
     $         WRITE (NOUT, 1000) ALFMAX, OLDF , OLDG  , TOLABS,
     $                            ALFUZZ,         EPSAF, TOLREL,
     $                            CRAMPD
         END IF
      ELSE
*        ---------------------------------------------------------------
*        Subsequent entries.  The function has just been evaluated at
*        ALFA = ALFBST + XTRY,  giving FTRY.
*        ---------------------------------------------------------------
         NFSRCH = NFSRCH + 1
         NSAMEA = NSAMEA + 1
         NSAMEB = NSAMEB + 1

         IF (.NOT. BRAKTD) THEN
            TOLMAX = TOLABS + TOLREL*ALFMAX
            B      = ALFMAX - ALFBST + TOLMAX
         END IF

*        Check if XTRY is in the interval (XW,0) or (0,XW).

         XINXW  = .FALSE.
         IF (WSET) XINXW =       ZERO .LT. XTRY  .AND.  XTRY .LE. XW
     $                     .OR.    XW .LE. XTRY  .AND.  XTRY .LT. ZERO

*        See if the new step is better.

         IF (ALFA .LE. ALFUZZ) THEN
            SIGDEC = FTRY - OLDF                 .LE. (- EPSAF)
         ELSE
            SIGDEC = FTRY - OLDF - ALFA*RMU*OLDG .LE.    EPSAF
         END IF
         IMPRVD = SIGDEC  .AND.  (FTRY .LE. FBEST - EPSAF)

         IF (DEBUG) WRITE (NOUT, 1100)
     $      ALFA, FTRY, FTRY - OLDF - ALFA*RMU*OLDG

         IF (IMPRVD) THEN

*           We seem to have an improvement.  The new point becomes the
*           origin and other points are shifted accordingly.

            IF (WSET) THEN
               XV     = XW - XTRY
               FV     = FW
               VSET   = .TRUE.
            END IF

            XW     = ZERO - XTRY
            FW     = FBEST
            WSET   = .TRUE.
            FBEST  = FTRY
            ALFBST = ALFA
            MOVED  = .TRUE.

            A      = A    - XTRY
            B      = B    - XTRY
            EXTRAP = .NOT. XINXW

*           Decrease the length of (A,B).

            IF (XTRY .GE. ZERO) THEN
               A      = XW
               FA     = FW
               NSAMEA = 0
            ELSE
               B      = XW
               NSAMEB = 0
               BRAKTD = .TRUE.
            END IF
         ELSE

*           The new function value is no better than the current best
*           point.  XTRY must an end point of the new (A,B).

            IF (XTRY .LT. ZERO) THEN
               A      = XTRY
               FA     = FTRY
               NSAMEA = 0
            ELSE
               B      = XTRY
               NSAMEB = 0
               BRAKTD = .TRUE.
            END IF

*           The origin remains unchanged but XTRY may qualify as XW.

            IF (WSET) THEN
               IF (FTRY .LE. FW + EPSAF) THEN
                  XV     = XW
                  FV     = FW
                  VSET   = .TRUE.

                  XW     = XTRY
                  FW     = FTRY
                  IF (MOVED) EXTRAP = XINXW
               ELSE IF (MOVED) THEN
                  SETXV = .TRUE.
                  IF (VSET)
     $               SETXV = FTRY .LE. FV + EPSAF  .OR.  .NOT. EXTRAP

                  IF (SETXV) THEN
                     IF (VSET  .AND.  XINXW) THEN
                        XW = XV
                        FW = FV
                     END IF
                     XV = XTRY
                     FV = FTRY
                     VSET = .TRUE.
                  END IF
               ELSE
                  XW = XTRY
                  FW = FTRY
               END IF
            ELSE
               XW     = XTRY
               FW     = FTRY
               WSET   = .TRUE.
            END IF
         END IF

*        ---------------------------------------------------------------
*        Check the termination criteria.
*        ---------------------------------------------------------------
         TOL    = TOLABS + TOLREL*ALFBST

         IF (ALFBST .LE. ALFUZZ) THEN
            SIGDEC = FBEST - OLDF                   .LE. (- EPSAF)
         ELSE
            SIGDEC = FBEST - OLDF - ALFBST*RMU*OLDG .LE.    EPSAF
         END IF
         CLOSEF = .FALSE.
         IF (VSET) CLOSEF = ABS( FBEST - FV ) .LE. EPSAF

         CONV1  =  MAX( ABS( A ), B )  .LE.  (TOL + TOL)
         CONV2  =  MOVED  .AND.  SIGDEC
     $                    .AND.  ABS( FA - FBEST )  .LE.  A*ETA*OLDG
         CONV3  = CLOSEF  .AND.  (SIGDEC  .OR.
     $                           (.NOT. MOVED)  .AND.  (B .LE. ALFUZZ))
         CONVRG = CONV1  .OR.  CONV2  .OR.  CONV3

         IF (DEBUG) THEN
            WRITE (NOUT, 1200) ALFBST + A, ALFBST + B, B - A, TOL,
     $         NSAMEA, NSAMEB, BRAKTD, CLOSEF,
     $         IMPRVD, CONV1, CONV2, CONV3, EXTRAP,
     $         ALFBST, FBEST,  FBEST - OLDF - ALFBST*RMU*OLDG,
     $         ALFBST + XW, FW
            IF (VSET)
     $         WRITE (NOUT, 1300) ALFBST + XV, FV
         END IF

         IF (NFSRCH .GE. MFSRCH  .OR.  ALFBST + B .LE. ALFSML) THEN
            DONE = .TRUE.
         ELSE IF (CONVRG) THEN
            IF (MOVED) THEN
               DONE = .TRUE.
            ELSE

*              A better point has not yet been found (the step XW is no
*              better than step zero).  Check that the change in F is
*              consistent with an X-perturbation of TOL,  the minimum
*              spacing estimate.  If not, the value of TOL is reduced.

               TOL    = TOL/TEN
               TOLABS = TOL
               IF (ABS(FW - OLDF) .LE. EPSAF  .OR.  TOL .LE. TOLTNY)
     $            DONE = .TRUE.
            END IF
         END IF

*        ---------------------------------------------------------------
*        Proceed with the computation of a trial step length.
*        The choices are...
*        1. Parabolic fit using function values only.
*        2. Damped parabolic fit if the regular fit appears to be
*           consistently over-estimating the distance to the minimum.
*        3. Bisection, geometric bisection, or a step of TOL if the
*           parabolic fit is unsatisfactory.
*        ---------------------------------------------------------------
         XMIDPT = HALF*(A + B)
         S      = ZERO
         Q      = ZERO

*        ===============================================================
*        Fit a parabola.
*        ===============================================================
*        Check if there are two or three points for the parabolic fit.

         GW = (FW - FBEST)/XW
         IF (VSET  .AND.  MOVED) THEN

*           Three points available.  Use FBEST, FW and FV.

            GV = (FV - FBEST)/XV
            S  = GV - (XV/XW)*GW
            Q  = TWO*(GV - GW)
            IF (DEBUG) WRITE (NOUT, 2200)
         ELSE

*           Only two points available.  Use FBEST, FW and OLDG.

            IF (MOVED) THEN
               S  = OLDG - TWO*GW
            ELSE
               S  = OLDG
            END IF
            Q = TWO*(OLDG - GW)
            IF (DEBUG) WRITE (NOUT, 2100)
         END IF

*        ---------------------------------------------------------------
*        Construct an artificial interval (ARTIFA, ARTIFB) in which the
*        new estimate of the steplength must lie.  Set a default value
*        of XTRY that will be used if the polynomial fit is rejected.
*        In the following, the interval (A,B) is considered the sum of
*        two intervals of lengths DTRY and DAUX, with common end point
*        the best point (zero).  DTRY is the length of the interval into
*        which the default XTRY will be placed and ENDPNT denotes its
*        non-zero end point.  The magnitude of XTRY is computed so that
*        the exponents of DTRY and DAUX are approximately bisected.
*        ---------------------------------------------------------------
         ARTIFA = A
         ARTIFB = B
         IF (.NOT. BRAKTD) THEN

*           The minimum has not been bracketed.  Set an artificial upper
*           bound by expanding the interval XW by a suitable factor.

            XTRY   = - FACTOR*XW
            ARTIFB =   XTRY
            IF (ALFBST + XTRY .LT. ALFMAX) FACTOR = FIVE*FACTOR
         ELSE IF (VSET .AND. MOVED) THEN

*           Three points exist in the interval of uncertainty.
*           Check if the points are configured for an extrapolation
*           or an interpolation.

            IF (EXTRAP) THEN

*              The points are configured for an extrapolation.

               IF (XW .LT. ZERO) ENDPNT = B
               IF (XW .GT. ZERO) ENDPNT = A
            ELSE

*              If the interpolation appears to be over-estimating the
*              distance to the minimum,  damp the interpolation step.

               IF (NSAMEA .GE. 3  .OR.   NSAMEB .GE. 3) THEN
                  FACTOR = FACTOR / FIVE
                  S      = FACTOR * S
               ELSE
                  FACTOR = ONE
               END IF

*              The points are configured for an interpolation.  The
*              artificial interval will be just (A,B).  Set ENDPNT so
*              that XTRY lies in the larger of the intervals (A,B) and
*              (0,B).

               ENDPNT = A
               IF (XMIDPT .GT. ZERO) ENDPNT = B

*              If a bound has remained the same for three iterations,
*              set ENDPNT so that  XTRY  is likely to replace the
*              offending bound.

               IF (NSAMEA .GE. 3) ENDPNT = A
               IF (NSAMEB .GE. 3) ENDPNT = B
            END IF

*           Compute the default value of  XTRY.

            DTRY = ABS( ENDPNT )
            DAUX = B - A - DTRY
            IF (DAUX .GE. DTRY) THEN
               XTRY = FIVE*DTRY*(POINT1 + DTRY/DAUX)/ELEVEN
            ELSE
               XTRY = HALF*SQRT( DAUX )*SQRT( DTRY )
            END IF
            IF (ENDPNT .LT. ZERO) XTRY = - XTRY
            IF (DEBUG) WRITE (NOUT, 2500) XTRY, DAUX, DTRY

*           If the points are configured for an extrapolation set the
*           artificial bounds so that the artificial interval lies
*           within (A,B).  If the polynomial fit is rejected,  XTRY will
*           remain at the relevant artificial bound.

            IF (EXTRAP) THEN
               IF (XTRY .LE. ZERO) THEN
                  ARTIFA = XTRY
               ELSE
                  ARTIFB = XTRY
               END IF
            END IF
         ELSE

*           The gradient at the origin is being used for the polynomial
*           fit.  Set the default XTRY to one tenth XW.

            XTRY   = XW/TEN
            IF (EXTRAP) XTRY = - XW
            IF (DEBUG) WRITE (NOUT, 2400) XTRY
         END IF

*        ---------------------------------------------------------------
*        The polynomial fits give (S/Q)*XW as the new step.  Reject this
*        step if it lies outside (ARTIFA, ARTIFB).
*        ---------------------------------------------------------------
         IF (Q .NE. ZERO) THEN
            IF (Q .LT. ZERO) S = - S
            IF (Q .LT. ZERO) Q = - Q
            IF (S*XW .GE. Q*ARTIFA   .AND.   S*XW .LE. Q*ARTIFB) THEN

*              Accept the polynomial fit.

               XTRY = ZERO
               IF (ABS( S*XW ) .GE. Q*TOL) XTRY = (S/Q)*XW
               IF (DEBUG) WRITE (NOUT, 2600) XTRY
            END IF
         END IF
      END IF

*     ==================================================================

      IF (.NOT. DONE) THEN
         ALFA  = ALFBST + XTRY
         IF (BRAKTD  .OR.  ALFA .LT. ALFMAX - TOLMAX) THEN

*           The function must not be evaluated too close to A or B.
*           (It has already been evaluated at both those points.)

            XMIDPT = HALF*(A + B)
            IF (XTRY .LE. A + TOL  .OR.  XTRY .GE. B - TOL) THEN
               XTRY = TOL
               IF (XMIDPT .LE. ZERO) XTRY = - TOL
            END IF

            IF (ABS( XTRY ) .LT. TOL) THEN
               XTRY = TOL
               IF (XMIDPT .LE. ZERO) XTRY = - TOL
            END IF
            ALFA  = ALFBST + XTRY
         ELSE

*           The step is close to or larger than ALFMAX, replace it by
*           ALFMAX to force evaluation of the function at the boundary.

            BRAKTD = .TRUE.
            XTRY   = ALFMAX - ALFBST
            ALFA   = ALFMAX
         END IF
      END IF

*     ------------------------------------------------------------------
*     Exit.
*     ------------------------------------------------------------------
      IF (DONE) THEN
         IF (MOVED) THEN
            IF (CONVRG) THEN
               INFORM = 1
               IF (ALFA .EQ. ALFMAX) INFORM = 2
            ELSE IF (ALFBST + B .LT. ALFSML) THEN
               INFORM = 5
            ELSE
               INFORM = 3
            END IF
         ELSE IF (OLDG .GE. ZERO  .OR.  ALFMAX .LT. TOLTNY) THEN
            INFORM = 7
         ELSE IF (CRAMPD) THEN
            INFORM = 4
         ELSE IF (ALFBST + B .LT. ALFSML) THEN
            INFORM = 5
         ELSE
            INFORM = 6
         END IF
      END IF

      IF (DEBUG) WRITE (NOUT, 3000)
      RETURN

 1000 FORMAT(/' ALFMAX  OLDF    OLDG    TOLABS', 1P2E22.14,   1P2E16.8
     $       /' ALFUZZ  EPSAF           TOLREL', 1P2E22.14,16X,1PE16.8
     $       /' CRAMPD                        ',  L6)
 1100 FORMAT(/' ALFA    FTRY    CTRY          ', 1P2E22.14,   1P1E16.8)
 1200 FORMAT(/' A       B       B - A   TOL   ', 1P2E22.14,   1P2E16.8
     $       /' NSAMEA  NSAMEB  BRAKTD  CLOSEF', 2I3, 2L6
     $       /' IMPRVD  CONVRG  EXTRAP        ',  L6, 3X, 3L1, L6
     $       /' ALFBST  FBEST   CBEST         ', 1P2E22.14,   1P1E16.8
     $       /' ALFAW   FW                    ', 1P2E22.14)
 1300 FORMAT( ' ALFAV   FV                    ', 1P2E22.14 /)
 2100 FORMAT( ' Parabolic fit,    two points. ')
 2200 FORMAT( ' Parabolic fit,  three points. ')
 2400 FORMAT( ' Exponent reduced.  Trial point', 1P1E22.14)
 2500 FORMAT( ' Geo. bisection. XTRY,DAUX,DTRY', 1P3E22.14)
 2600 FORMAT( ' Polynomial fit accepted.  XTRY', 1P1E22.14)
 3000 FORMAT( ' ----------------------------------------------------'/)

*     End of  SRCHQ .

      END

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     derchk.f 
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine derchk()
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

*     Global data.

      include "global.f"

*     Local data

      real*8 vec
      real*8 objf,objgrd,c
      real*8 objsav,vecsav,del,delsav

      integer*4 i,ii,j
      integer*4 lvec
      integer*4 mode,nstate,needc

*     Local parameters

      real*8 delta

      parameter (delta=1.d-8)

      dimension vec(mvec)
      dimension objgrd(mM*mvec),c(mM)
      dimension delsav(mvec)
      dimension needc(mM)

      mode=2
      nstate=1

      j=0
      do i=1,lvsav
        if (ivec(i).eq.0) then
          j=j+1
          vec(j)=vsav(i)
        end if
      end do 
      lvec=j

      if (lvec.ne.nfit) then
        write(3,3999)
        stop
       end if

      write(*,'(1x,''Begin objfun derivative checks'')')

      if (iq.eq.0) then
        write(*,'(1x,''Computed by mcarlo.f'')')
        call mcarlo(mode,lvec,vec,objf,objgrd,nstate)
      else
      write(*,'(1x,''Computed by quad.f'')')
        call quad(mode,lvec,vec,objf,objgrd,nstate)
      end if

      write(*,'(1x,''objf'',d25.16)') objf

      objsav=objf

      do i=1,lvec
        delsav(i)=objgrd(i)
      end do

      do i=1,lvec
        vecsav=vec(i)
        vec(i)=vec(i)+delta
        if (iq.eq.0) then
          call mcarlo(mode,lvec,vec,objf,objgrd,nstate)
        else
          call quad(mode,lvec,vec,objf,objgrd,nstate)
        end if
        vec(i)=vecsav
        del=(objf-objsav)/delta
        write(*,'(1x,''i, objgrd, del'',i5,2d25.16)') i,delsav(i),del
      end do

      write(*,'(1x,''Begin mufun.f derivative checks'')')

      do ii=1,M

        do i=1,M
          needc(i)=0
        end do
        needc(ii)=1

        call mufun(mode,M,lvec,M,needc,vec,c,objgrd,nstate)

*       call dgmpnt(objgrd,M,lvec)

        objf=c(ii)
        do j=1,lvec
          objgrd(j)=objgrd(M*(j-1)+ii)
        end do 

        write(*,'(1x,''Eyl('',i2,'') = '',d25.16)') ii, objf

        objsav=objf

        do i=1,lvec
          delsav(i)=objgrd(i)
        end do

        do i=1,lvec
          vecsav=vec(i)
          vec(i)=vec(i)+delta

          call mufun(mode,M,lvec,M,needc,vec,c,objgrd,nstate)
          objf=c(ii)
          do j=1,lvec
            objgrd(j)=objgrd(M*(j-1)+i)
          end do 

          vec(i)=vecsav
          del=(objf-objsav)/delta
          write(*,'(1x,''i, objgrd, del'',i5,2d25.16)') i,delsav(i),del
        end do

      end do

      write(*,'(1x,''Begin post.f derivative checks'')')

      lvec=M
      id=1

      do i=1,lvec
        vec(i)=Ez(i)+dsqrt(Cz(i*(i+1)/2))
      end do

      call post(mode,lvec,vec,objf,objgrd,nstate)

      write(*,'(1x,''objf'',d25.16)') objf

      objsav=objf

      do i=1,lvec
        delsav(i)=objgrd(i)
      end do

      do i=1,lvec
        vecsav=vec(i)
        vec(i)=vec(i)+delta*dsqrt(Cz(i*(i+1)/2))
        call post(mode,lvec,vec,objf,objgrd,nstate)
        vec(i)=vecsav
        del=(objf-objsav)/(delta*dsqrt(Cz(i*(i+1)/2)))
        write(*,'(1x,''i, objgrd, del'',i5,2d25.16)') i,delsav(i),del
      end do

      write(*,'(1x,''End derivative checks'')')

      return
3999  format(1x,'error, derchk, this should never happen')
      end

C  8 DEC 80 J. F. Monahan changed call to LIBMON
C  1 SEP 91 A. R. Gallant added dgamma and gammln
C  1 SEP 91 A. R. Gallant changed machine epsilon MACHEP in IMTGL2
C                                1/20/75
      SUBROUTINE GAUSSQ(KIND, N, ALPHA, BETA, KPTS, ENDPTS, B, T, W)
C
C           THIS SET OF ROUTINES COMPUTES THE NODES T(J) AND WEIGHTS
C        W(J) FOR GAUSSIAN-TYPE QUADRATURE RULES WITH PRE-ASSIGNED
C        NODES.  THESE ARE USED WHEN ONE WISHES TO APPROXIMATE
C
C                 INTEGRAL (FROM A TO B)  F(X) W(X) DX
C
C                              N
C        BY                   SUM W  F(T )
C                             J=1  J    J
C
C        (NOTE W(X) AND W(J) HAVE NO CONNECTION WITH EACH OTHER.)
C        HERE W(X) IS ONE OF SIX POSSIBLE NON-NEGATIVE WEIGHT
C        FUNCTIONS (LISTED BELOW), AND F(X) IS THE
C        FUNCTION TO BE INTEGRATED.  GAUSSIAN QUADRATURE IS PARTICULARLY
C        USEFUL ON INFINITE INTERVALS (WITH APPROPRIATE WEIGHT
C        FUNCTIONS), SINCE THEN OTHER TECHNIQUES OFTEN FAIL.
C
C           ASSOCIATED WITH EACH WEIGHT FUNCTION W(X) IS A SET OF
C        ORTHOGONAL POLYNOMIALS.  THE NODES T(J) ARE JUST THE ZEROES
C        OF THE PROPER N-TH DEGREE POLYNOMIAL.
C
C     INPUT PARAMETERS (ALL REAL NUMBERS ARE IN DOUBLE PRECISION)
C
C        KIND     AN INTEGER BETWEEN 1 AND 6 GIVING THE TYPE OF
C                 QUADRATURE RULE:
C
C        KIND = 1:  LEGENDRE QUADRATURE, W(X) = 1 ON (-1, 1)
C        KIND = 2:  CHEBYSHEV QUADRATURE OF THE FIRST KIND
C                   W(X) = 1/SQRT(1 - X*X) ON (-1, +1)
C        KIND = 3:  CHEBYSHEV QUADRATURE OF THE SECOND KIND
C                   W(X) = SQRT(1 - X*X) ON (-1, 1)
C        KIND = 4:  HERMITE QUADRATURE, W(X) = EXP(-X*X) ON
C                   (-INFINITY, +INFINITY)
C        KIND = 5:  JACOBI QUADRATURE, W(X) = (1-X)**ALPHA * (1+X)**
C                   BETA ON (-1, 1), ALPHA, BETA .GT. -1.
C                   NOTE: KIND=2 AND 3 ARE A SPECIAL CASE OF THIS.
C        KIND = 6:  GENERALIZED LAGUERRE QUADRATURE, W(X) = EXP(-X)*
C                   X**ALPHA ON (0, +INFINITY), ALPHA .GT. -1
C
C        N        THE NUMBER OF POINTS USED FOR THE QUADRATURE RULE
C        ALPHA    REAL PARAMETER USED ONLY FOR GAUSS-JACOBI AND GAUSS-
C                 LAGUERRE QUADRATURE (OTHERWISE USE 0.D0).
C        BETA     REAL PARAMETER USED ONLY FOR GAUSS-JACOBI QUADRATURE--
C                 (OTHERWISE USE 0.D0)
C        KPTS     (INTEGER) NORMALLY 0, UNLESS THE LEFT OR RIGHT END-
C                 POINT (OR BOTH) OF THE INTERVAL IS REQUIRED TO BE A
C                 NODE (THIS IS CALLED GAUSS-RADAU OR GAUSS-LOBATTO
C                 QUADRATURE).  THEN KPTS IS THE NUMBER OF FIXED
C                 ENDPOINTS (1 OR 2).
C        ENDPTS   REAL ARRAY OF LENGTH 2.  CONTAINS THE VALUES OF
C                 ANY FIXED ENDPOINTS, IF KPTS = 1 OR 2.
C        B        REAL SCRATCH ARRAY OF LENGTH N
C
C     OUTPUT PARAMETERS (BOTH DOUBLE PRECISION ARRAYS OF LENGTH N)
C
C        T        WILL CONTAIN THE DESIRED NODES.
C        W        WILL CONTAIN THE DESIRED WEIGHTS W(J).
C
C     SUBROUTINES REQUIRED
C
C        SOLVE, CLASS, AND IMTQL2 ARE PROVIDED.  UNDERFLOW MAY SOMETIMES
C        OCCUR, BUT IT IS HARMLESS IF THE UNDERFLOW INTERRUPTS ARE
C        TURNED OFF.  TO DO THIS, THE FIRST CALL OF THE MAIN PROGRAM
C        SHOULD BE
C                  CALL TRAPS (0, 0, 10000, 0, 0)    IN WATFIV
C        OR
C                  CALL INIT                         IN FORTRAN G OR H.
C
C     ACCURACY
C
C        THE ROUTINE WAS TESTED UP TO N = 512 FOR LEGENDRE QUADRATURE,
C        UP TO N = 136 FOR HERMITE, UP TO N = 68 FOR LAGUERRE, AND UP
C        TO N = 10 OR 20 IN OTHER CASES.  IN ALL BUT TWO INSTANCES,
C        COMPARISON WITH TABLES IN REF. 3 SHOWED 12 OR MORE SIGNIFICANT
C        DIGITS OF ACCURACY.  THE TWO EXCEPTIONS WERE THE WEIGHTS FOR
C        HERMITE AND LAGUERRE QUADRATURE, WHERE UNDERFLOW CAUSED SOME
C        VERY SMALL WEIGHTS TO BE SET TO ZERO.  THIS IS, OF COURSE,
C        COMPLETELY HARMLESS.
C
C     METHOD
C
C           THE COEFFICIENTS OF THE THREE-TERM RECURRENCE RELATION
C        FOR THE CORRESPONDING SET OF ORTHOGONAL POLYNOMIALS ARE
C        USED TO FORM A SYMMETRIC TRIDIAGONAL MATRIX, WHOSE
C        EIGENVALUES (DETERMINED BY THE IMPLICIT QL-METHOD WITH
C        SHIFTS) ARE JUST THE DESIRED NODES.  THE FIRST COMPONENTS OF
C        THE ORTHONORMALIZED EIGENVECTORS, WHEN PROPERLY SCALED,
C        YIELD THE WEIGHTS.  THIS TECHNIQUE IS MUCH FASTER THAN USING A
C        ROOT-FINDER TO LOCATE THE ZEROES OF THE ORTHOGONAL POLYNOMIAL.
C        FOR FURTHER DETAILS, SEE REF. 1.  REF. 2 CONTAINS DETAILS OF
C        GAUSS-RADAU AND GAUSS-LOBATTO QUADRATURE ONLY.
C
C     REFERENCES
C
C        1.  GOLUB, G. H., AND WELSCH, J. H., "CALCULATION OF GAUSSIAN
C            QUADRATURE RULES," MATHEMATICS OF COMPUTATION 23 (APRIL,
C            1969), PP. 221-230.
C        2.  GOLUB, G. H., "SOME MODIFIED MATRIX EIGENVALUE PROBLEMS,"
C            SIAM REVIEW 15 (APRIL, 1973), PP. 318-334 (SECTION 7).
C        3.  STROUD AND SECREST, GAUSSIAN QUADRATURE FORMULAS, PRENTICE-
C            HALL, ENGLEWOOD CLIFFS, N.J., 1966.
C
C     ..................................................................
C
      DOUBLE PRECISION B(N), T(N), W(N), ENDPTS(2), MUZERO, T1,
     X GAM, SOLVE, DSQRT, ALPHA, BETA
C
C-----------------------------------------------------------------
CALL LIB MONITOR FROM GAUSSQ, MAINTENANCE NUMBER 429, DATE 76170
C       CALL LIBMON(429)  ********** DELETED ******
C***PLEASE DON'T REMOVE OR CHANGE THE ABOVE CALL. IT IS YOUR ONLY
C***PROTECTION AGAINST YOUR USING AN OUT-OF-DATE OF INCORRECT
C***VERSION OF THE ROUTINE. THE LIBRARY MONITOR REMOVES THIS CALL,
C***SO IT ONLY OCCURS ONCE, ON THE FIRST ENTRY TO THIS ROUTINE.
C-----------------------------------------------------------------
      CALL CLASS (KIND, N, ALPHA, BETA, B, T, MUZERO)
C
C           THE MATRIX OF COEFFICIENTS IS ASSUMED TO BE SYMMETRIC.
C           THE ARRAY T CONTAINS THE DIAGONAL ELEMENTS, THE ARRAY
C           B THE OFF-DIAGONAL ELEMENTS.
C           MAKE APPROPRIATE CHANGES IN THE LOWER RIGHT 2 BY 2
C           SUBMATRIX.
C
      IF (KPTS.EQ.0)  GO TO 100
      IF (KPTS.EQ.2)  GO TO  50
C
C           IF KPTS=1, ONLY T(N) MUST BE CHANGED
C
      T(N) = SOLVE(ENDPTS(1), N, T, B)*B(N-1)**2 + ENDPTS(1)
      GO TO 100
C
C           IF KPTS=2, T(N) AND B(N-1) MUST BE RECOMPUTED
C
   50 GAM = SOLVE(ENDPTS(1), N, T, B)
      T1 = ((ENDPTS(1) - ENDPTS(2))/(SOLVE(ENDPTS(2), N, T, B) - GAM))
      B(N-1) = DSQRT(T1)
      T(N) = ENDPTS(1) + GAM*T1
C
C           NOTE THAT THE INDICES OF THE ELEMENTS OF B RUN FROM 1 TO N-1
C           AND THUS THE VALUE OF B(N) IS ARBITRARY.
C           NOW COMPUTE THE EIGENVALUES OF THE SYMMETRIC TRIDIAGONAL
C           MATRIX, WHICH HAS BEEN MODIFIED AS NECESSARY.
C           THE METHOD USED IS A QL-TYPE METHOD WITH ORIGIN SHIFTING
C
  100 W(1) = 1.0D0
      DO 105 I = 2, N
  105    W(I) = 0.0D0
C
      CALL IMTQL2 (N, T, B, W, IERR)
      DO 110 I = 1, N
  110    W(I) = MUZERO * W(I) * W(I)
C
      RETURN
      END
C
C
C
      DOUBLE PRECISION FUNCTION SOLVE(SHIFT, N, A, B)
C
C       THIS PROCEDURE PERFORMS ELIMINATION TO SOLVE FOR THE
C       N-TH COMPONENT OF THE SOLUTION DELTA TO THE EQUATION
C
C             (JN - SHIFT*IDENTITY) * DELTA  = EN,
C
C       WHERE EN IS THE VECTOR OF ALL ZEROES EXCEPT FOR 1 IN
C       THE N-TH POSITION.
C
C       THE MATRIX JN IS SYMMETRIC TRIDIAGONAL, WITH DIAGONAL
C       ELEMENTS A(I), OFF-DIAGONAL ELEMENTS B(I).  THIS EQUATION
C       MUST BE SOLVED TO OBTAIN THE APPROPRIATE CHANGES IN THE LOWER
C       2 BY 2 SUBMATRIX OF COEFFICIENTS FOR ORTHOGONAL POLYNOMIALS.
C
C
      DOUBLE PRECISION SHIFT, A(N), B(N), ALPHA
C
      ALPHA = A(1) - SHIFT
      NM1 = N - 1
      DO 10 I = 2, NM1
   10    ALPHA = A(I) - SHIFT - B(I-1)**2/ALPHA
      SOLVE = 1.0D0/ALPHA
      RETURN
      END
C
C
C
      SUBROUTINE CLASS(KIND, N, ALPHA, BETA, B, A, MUZERO)
C
C           THIS PROCEDURE SUPPLIES THE COEFFICIENTS A(J), B(J) OF THE
C        RECURRENCE RELATION
C
C             B P (X) = (X - A ) P   (X) - B   P   (X)
C              J J            J   J-1       J-1 J-2
C
C        FOR THE VARIOUS CLASSICAL (NORMALIZED) ORTHOGONAL POLYNOMIALS,
C        AND THE ZERO-TH MOMENT
C
C             MUZERO = INTEGRAL W(X) DX
C
C        OF THE GIVEN POLYNOMIAL'S WEIGHT FUNCTION W(X).  SINCE THE
C        POLYNOMIALS ARE ORTHONORMALIZED, THE TRIDIAGONAL MATRIX IS
C        GUARANTEED TO BE SYMMETRIC.
C
C           THE INPUT PARAMETER ALPHA IS USED ONLY FOR LAGUERRE AND
C        JACOBI POLYNOMIALS, AND THE PARAMETER BETA IS USED ONLY FOR
C        JACOBI POLYNOMIALS.  THE LAGUERRE AND JACOBI POLYNOMIALS
C        REQUIRE THE GAMMA FUNCTION.
C
C     ..................................................................
C
      DOUBLE PRECISION A(N), B(N), MUZERO, ALPHA, BETA
      DOUBLE PRECISION ABI, A2B2, DGAMMA, PI, DSQRT, AB
      DATA PI / 3.141592653589793D0/
C
      NM1 = N - 1
      GO TO (10, 20, 30, 40, 50, 60), KIND
C
C              KIND = 1:  LEGENDRE POLYNOMIALS P(X)
C              ON (-1, +1), W(X) = 1.
C
   10 MUZERO = 2.0D0
      DO 11 I = 1, NM1
         A(I) = 0.0D0
         ABI = I
   11    B(I) = ABI/DSQRT(4*ABI*ABI - 1.0D0)
      A(N) = 0.0D0
      RETURN
C
C              KIND = 2:  CHEBYSHEV POLYNOMIALS OF THE FIRST KIND T(X)
C              ON (-1, +1), W(X) = 1 / SQRT(1 - X*X)
C
   20 MUZERO = PI
      DO 21 I = 1, NM1
         A(I) = 0.0D0
   21    B(I) = 0.5D0
      B(1) = DSQRT(0.5D0)
      A(N) = 0.0D0
      RETURN
C
C              KIND = 3:  CHEBYSHEV POLYNOMIALS OF THE SECOND KIND U(X)
C              ON (-1, +1), W(X) = SQRT(1 - X*X)
C
   30 MUZERO = PI/2.0D0
      DO 31 I = 1, NM1
         A(I) = 0.0D0
   31    B(I) = 0.5D0
      A(N) = 0.0D0
      RETURN
C
C              KIND = 4:  HERMITE POLYNOMIALS H(X) ON (-INFINITY,
C              +INFINITY), W(X) = EXP(-X**2)
C
   40 MUZERO = DSQRT(PI)
      DO 41 I = 1, NM1
         A(I) = 0.0D0
   41    B(I) = DSQRT(I/2.0D0)
      A(N) = 0.0D0
      RETURN
C
C              KIND = 5:  JACOBI POLYNOMIALS P(ALPHA, BETA)(X) ON
C              (-1, +1), W(X) = (1-X)**ALPHA + (1+X)**BETA, ALPHA AND
C              BETA GREATER THAN -1
C
   50 AB = ALPHA + BETA
      ABI = 2.0D0 + AB
      MUZERO = 2.0D0 ** (AB + 1.0D0) * DGAMMA(ALPHA + 1.0D0) * DGAMMA(
     X BETA + 1.0D0) / DGAMMA(ABI)
      A(1) = (BETA - ALPHA)/ABI
      B(1) = DSQRT(4.0D0*(1.0D0 + ALPHA)*(1.0D0 + BETA)/((ABI + 1.0D0)*
     1  ABI*ABI))
      A2B2 = BETA*BETA - ALPHA*ALPHA
      DO 51 I = 2, NM1
         ABI = 2.0D0*I + AB
         A(I) = A2B2/((ABI - 2.0D0)*ABI)
   51    B(I) = DSQRT (4.0D0*I*(I + ALPHA)*(I + BETA)*(I + AB)/
     1   ((ABI*ABI - 1)*ABI*ABI))
      ABI = 2.0D0*N + AB
      A(N) = A2B2/((ABI - 2.0D0)*ABI)
      RETURN
C
C              KIND = 6:  LAGUERRE POLYNOMIALS L(ALPHA)(X) ON
C              (0, +INFINITY), W(X) = EXP(-X) * X**ALPHA, ALPHA GREATER
C              THAN -1.
C
   60 MUZERO = DGAMMA(ALPHA + 1.0D0)
      DO 61 I = 1, NM1
         A(I) = 2.0D0*I - 1.0D0 + ALPHA
   61    B(I) = DSQRT(I*(I + ALPHA))
      A(N) = 2.0D0*N - 1 + ALPHA
      RETURN
      END
C
C
      SUBROUTINE IMTQL2(N, D, E, Z, IERR)
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE IMTQL2,
C     NUM. MATH. 12, 377-383(1968) BY MARTIN AND WILKINSON,
C     AS MODIFIED IN NUM. MATH. 15, 450(1970) BY DUBRULLE.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 241-248(1971).
C     THIS IS A MODIFIED VERSION OF THE 'EISPACK' ROUTINE IMTQL2.
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND FIRST COMPONENTS OF THE
C     EIGENVECTORS OF A SYMMETRIC TRIDIAGONAL MATRIX BY THE IMPLICIT QL
C     METHOD.
C
C     ON INPUT:
C
C        N IS THE ORDER OF THE MATRIX;
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX;
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS FIRST N-1 POSITIONS.  E(N) IS ARBITRARY;
C
C        Z CONTAINS THE FIRST ROW OF THE IDENTITY MATRIX.
C
C      ON OUTPUT:
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT BUT
C          UNORDERED FOR INDICES 1, 2, ..., IERR-1;
C
C        E HAS BEEN DESTROYED;
C
C        Z CONTAINS THE FIRST COMPONENTS OF THE ORTHONORMAL EIGENVECTORS
C          OF THE SYMMETRIC TRIDIAGONAL MATRIX.  IF AN ERROR EXIT IS
C          MADE, Z CONTAINS THE EIGENVECTORS ASSOCIATED WITH THE STORED
C          EIGENVALUES;
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     ------------------------------------------------------------------
C
      INTEGER I, J, K, L, M, N, II, MML, IERR
      REAL*8 D(N), E(N), Z(N), B, C, F, G, P, R, S, MACHEP
      REAL*8 DSQRT, DABS, DSIGN
C
C     :::::::::: MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC.
C                MACHEP = 16.0D0**(-13) FOR LONG FORM ARITHMETIC
C                ON S360 ::::::::::
C
C     Modified 9/1/91 by A. R. Gallant
C
C     DATA MACHEP/Z3410000000000000/
C
C     IEEE standard floating-point arithmetic.
C     (Rounded arithmetic is mandated).
 
      integer nbase,ndigit
      real*8  base,eps
      nbase  = 2
      ndigit = 52
      base   = nbase
      eps    = base**(- ndigit)
      
      MACHEP=eps
      
C     End modification.

      IERR = 0
      IF (N .EQ. 1) GO TO 1001
C
      E(N) = 0.0D0
      DO 240 L = 1, N
         J = 0
C     :::::::::: LOOK FOR SMALL SUB-DIAGONAL ELEMENT ::::::::::
  105    DO 110 M = L, N
            IF (M .EQ. N) GO TO 120
            IF (DABS(E(M)) .LE. MACHEP * (DABS(D(M)) + DABS(D(M+1))))
     X         GO TO 120
  110    CONTINUE
C
  120    P = D(L)
         IF (M .EQ. L) GO TO 240
         IF (J .EQ. 30) GO TO 1000
         J = J + 1
C     :::::::::: FORM SHIFT ::::::::::
         G = (D(L+1) - P) / (2.0D0 * E(L))
         R = DSQRT(G*G+1.0D0)
         G = D(M) - P + E(L) / (G + DSIGN(R, G))
         S = 1.0D0
         C = 1.0D0
         P = 0.0D0
         MML = M - L
C
C     :::::::::: FOR I=M-1 STEP -1 UNTIL L DO -- ::::::::::
         DO 200 II = 1, MML
            I = M - II
            F = S * E(I)
            B = C * E(I)
            IF (DABS(F) .LT. DABS(G)) GO TO 150
            C = G / F
            R = DSQRT(C*C+1.0D0)
            E(I+1) = F * R
            S = 1.0D0 / R
            C = C * S
            GO TO 160
  150       S = F / G
            R = DSQRT(S*S+1.0D0)
            E(I+1) = G * R
            C = 1.0D0 / R
            S = S * C
  160       G = D(I+1) - P
            R = (D(I) - G) * S + 2.0D0 * C * B
            P = S * R
            D(I+1) = G + P
            G = C * R - B
C     :::::::::: FORM FIRST COMPONENT OF VECTOR ::::::::::
            F = Z(I+1)
            Z(I+1) = S * Z(I) + C * F
  200       Z(I) = C * Z(I) - S * F
C
         D(L) = D(L) - P
         E(L) = G
         E(M) = 0.0D0
         GO TO 105
  240 CONTINUE
C
C     :::::::::: ORDER EIGENVALUES AND EIGENVECTORS ::::::::::
      DO 300 II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 260 J = II, N
            IF (D(J) .GE. P) GO TO 260
            K = J
            P = D(J)
  260    CONTINUE
C
         IF (K .EQ. I) GO TO 300
         D(K) = D(I)
         D(I) = P
         P = Z(I)
         Z(I) = Z(K)
         Z(K) = P
  300 CONTINUE
C
      GO TO 1001
C     :::::::::: SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS ::::::::::
 1000 IERR = L
 1001 RETURN
C     :::::::::: LAST CARD OF IMTQL2 ::::::::::
      END
C      
C     Code added by A. R. Gallant 9/1/91
C      
C.hr GAMMLN
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
C 
C     THIS IS A MODIFICATION OF THE ROUTINE OF THE SAME NAME IN PRESS, 
C     WILLIAM H., BRIAN P. FLANNERY, SAUL A. TEUKOLSKY, AND WILLIAM T.
C     VETTERLING (1986), NUMERICAL RECIPES, CAMBRIDGE UNIVERSITY PRESS,
C     CAMBRIDGE, U.K., P. 157.
C
*     REAL*8 FUNCTION GAMMLN(XX)
*     IMPLICIT REAL*8 (A-H,O-Z)
*     REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
*     SAVE
*     DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
*    *    -1.231739516D0,.120858003D-2,-.536382D-5,2.50662827465D0/
*     DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
*     X=XX-ONE
*     TMP=X+FPF
*     TMP=(X+HALF)*DLOG(TMP)-TMP
*     SER=ONE
*     DO 11 J=1,6
*       X=X+ONE
*       SER=SER+COF(J)/X
*11   CONTINUE
*     GAMMLN=TMP+DLOG(STP*SER)
*     RETURN
*     END
C.hr dgamma
C@
C....*...1.........2.........3.........4.........5.........6.........7.*
      real*8 function dgamma(x)
      real*8 gammln,x
      dgamma=dexp(gammln(x))
      return
      end 

*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
*    
*     plot.f
*
*     Copyright (C) 1991.
*
*     Marie Davidian and A. Ronald Gallant 
*     P.O. Box 5513, Raleigh NC 27650-5513, USA   
*
*     Permission to use, copy, modify, and distribute this
*     software and its documentation for any purpose and
*     without fee is hereby granted, provided that the
*     above copyright notice appear in all copies and that
*     both that copyright notice and this permission notice
*     appear in supporting documentation.
*
*     This software is provided "as is" without any
*     expressed or implied warranty.
*
*...:....1....:....2....:....3....:....4....:....5....:....6....:....7....:....8
      subroutine plot()
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      integer*4 i,j,ic

      character*1 digit
      character*12 fname


      dimension digit(0:9)

      data digit /'0','1','2','3','4','5','6','7','8','9'/

      integer*4 maxM

      parameter (maxM=99)

*     Compute points for plotting the joint density if jt=1.

      if (jt.eq.1) then
        call plotj()
        return
      end if

*     If M=1 the joint and the marginal are the same; thus, compute
*     the joint density if M=1.

      if (M.eq.1) then
        call plotj()
        return
      end if
       
*     Compute the marginals if jt=0.  Each marginal is put in a 
*     different file.  The names of these files are put in outfil.

      if (M.gt.maxM) then
        write(3,3901) 
        stop
      end if

      fname=outfil//'            '

      j=0
      do i=1,12
        if (fname(i:i).eq.'.') then
          j=i
        end if
        if ((fname(i:i).eq.' ').and.(j.eq.0)) then
          j=i
          fname(j+1:j+1)='p'
        end if
      end do

      if (j.eq.0) then
        fname(9:9)='.'
        j=9
      else 
        fname(j:j)='.'
      end if

      open(unit=19,file=outfil,status='unknown',form='formatted')

      do ic=1,M
        fname(j+2:j+3)=digit(10*(ic/10))//digit(ic-10*(ic/10))
        if (fname.eq.outfil) then
          fname(j+2:j+3)=digit(0)//digit(0)
        end if
        write(19,19001) ic,fname
        write(19,19002)
        write(19,19003)
        write(19,19004)
        write(19,19005)
        write(19,19006)
        write(19,19005)
        write(19,19006)
        write(19,19007)
        write(19,19007)
        write(19,19007)
        open(unit=9,file=fname,status='unknown',form='formatted')
        call plotm(ic)
        close(9)
      end do

      close(19)
      return
3901  format(1x,'error, plot, Can''t handle M that big.')
19001 format(1x,'Plot points for variable',i3,' written to file ',a12)
19002 format(1x,'   Ez    format(e30.18)')
19003 format(1x,'   Cz    format(e30.18)')
19004 format(1x,'   zinc  format(e30.18)')
19005 format(1x,'   z     format(e30.18)')
19006 format(1x,'   hplt  format(e30.18)')
19007 format(1x,'   .')
      end

      subroutine plotj()
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

      integer*4 i,j
      integer*4 lwork
      integer*4 izz

      real*8    zinc
      real*8    h,Eh,del,hplt
      real*8    work

      integer*4 mwork

      parameter (mwork=500)

      dimension zinc(mM)
      dimension del(mtheta)
      dimension work(mwork)
      dimension izz(mM)

      lwork=1+M+M*(M+1)/2+M+M
      if (lwork.gt.mwork) then
        write(3,3001) lwork
        stop
      end if

      lwork=2*ntermz
      if (lwork.gt.mwork) then
        write(3,3001) lwork
        stop
      end if

      open(unit=9,file=outfil,status='unknown',form='formatted')

      do i=1,M
        write(9,9001) Ez(i)
      end do

      do j=1,M
      do i=1,j
        write(9,9001) Cz(j*(j-1)/2+i)
      end do
      end do

      do i=1,M
        zinc(i)=sfac*dsqrt(Cz(i*(i+1)/2))/dfloat(ngrd)
      end do

      do i=1,M
        write(9,9001) zinc(i)
      end do

      do i=1,M
        izz(i)=-ngrd
      end do
      izz(1)=izz(1)-1

      do j=1,(2*ngrd+1)**M

        do i=1,M
          if (izz(i).lt.ngrd) then
            izz(i)=izz(i)+1
            go to 10
          else
            izz(i)=-ngrd
          end if
        end do
10      continue

        do i=1,M
          z(i)=Ez(i)+dfloat(izz(i))*zinc(i)
        end do

        do i=1,M
          write(9,9001) z(i)
        end do

        call hyx(z,x,h,del,
     &    theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &    M,L,ntermz,ntermx,Kz,Kx,
     &    work)

        call ehyx(z,x,Eh,del,
     &    theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &    M,L,ntermz,ntermx,Kz,Kx,
     &    work)

        hplt=h/Eh
        if (hplt.le.1.d-60) hplt=0.d0

        write(9,9001) hplt

      end do

      close(9)
      return
3001  format(1x,'error, plot, increase mwork to at least',i5)
9001  format(e30.18)
      end

      subroutine plotm(ic)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      include "global.f"

*     Local data

      real*8 b0,b,V
      real*8 zinc,zic
      real*8 hplt
      real*8 work
      real*8 T,W,u,Tjj
      real*8 endpts
      real*8 sum
      real*8 fctr
      real*8 P,PwA,Pwz,Eh,Ehdel
      real*8 R0,tQt,uQu,detR,detV
      real*8 weight

      integer*4 ic
      integer*4 igrid,ier
      integer*4 lwork
      integer*4 npoint

      integer*4 i,j,ii,jj
      integer*4 izz

*     Local parameters

      real*8 eps
      real*8 rootpi
      real*8 root2

      integer*4 mwork
      integer*4 mT

      parameter (rootpi=1.7724538509055160272d0)
      parameter (root2 =1.4142135623730950488d0)
      parameter (mT=30)
      parameter (eps=1.d-13)
      parameter (mwork=500)

      dimension b0(mM),b(mM),V(mM*mM)
      dimension T(mT),W(mT),u(mM),work(mwork)
      dimension endpts(2)
      dimension izz(mM)
      dimension PwA(mtheta),Pwz(mM),Ehdel(mtheta)
      dimension R0(mM*mM)

      npoint=min0(npt,mT)

*     Error checks

      lwork=1+M+(M*(M+1))/2+M+M
      if (lwork.gt.mwork) then
        write(3,3901) lwork
        stop
      end if

      lwork=2*ntermz
      if (lwork.gt.mwork) then
        write(3,3901) lwork
        stop
      end if

      lwork=2*(M*M+M+2)
      if (lwork.gt.mwork) then
        write(3,3901) lwork
        stop
      end if

      lwork=((M*(M-1))/2)**2
      if (lwork.gt.mwork) then
        write(3,3901) lwork
        stop
      end if

      lwork=npoint
      if (lwork.gt.mwork) then
        write(3,3901) lwork
        stop
      end if

      lwork=2*ntermz
      if (lwork.gt.mwork) then
        write(3,3901) lwork
        stop
      end if

*     The algorithm is an importance function method with a conditional
*     normal as the importance function using quadrature to integrate 
*     rather than using Monte Carlo.

      write(9,9001) Ez(ic)
      write(9,9001) Cz((ic*(ic+1))/2)
      zinc=sfac*dsqrt(Cz((ic*(ic+1))/2))/dfloat(ngrd)
      write(9,9001) zinc

*     Get the parameters b0, b, and V of the conditional normal.

      call dmcvt(Cz,R0,M,1,0)
      call cndist(Ez,R0,M,ic,b0,b,V,work,mwork)
      call dmcvt(V,V,M-1,0,1)
      call factor(V,work,M-1,eps,ier)
      if (ier.ne.0) write(3,3902) ier

      detV=1.d0
      do i=1,(M-1)
        detV=detV*V((i*(i+1))/2)
      end do 
      detV=dabs(detV)

*     Get Gauss-Hermite quadrature points.

      call gaussq(4,npoint,0.d0,0.d0,0,endpts,work,T,W)

      do i=1,npoint
        T(i)=root2*T(i)
      end do

      fctr=1.d0/(root2*rootpi**M)

      do i=1,lR
        R0(i)=theta(ibR+i)
      end do

      call drinv(R0,M)

      detR=1.d0
      do i=1,M
        detR=detR*theta(ibR+(i*(i+1))/2)
      end do
      detR=dabs(detR)

      do igrid=-ngrd,ngrd

        zic=Ez(ic)+dfloat(igrid)*zinc

        do i=1,(M-1)
          izz(i)=1
        end do
        izz(1)=izz(1)-1

        sum=0.d0

        do j=1,npoint**(M-1)

          do jj=1,(M-1)
            if (izz(jj).lt.npoint) then
              izz(jj)=izz(jj)+1
              go to 10
            else
              izz(jj)=1
            end if
          end do
 10       continue

          do jj=1,(M-1)
            u(jj)=0.d0
          end do

          tQt=0.d0

          do jj=1,(M-1)
            Tjj=T(izz(jj))
            tQt=tQt+Tjj**2
            do ii=1,jj
              u(ii)=u(ii)+V(jj*(jj-1)/2+ii)*Tjj
            end do
          end do

          tQt=-tQt/2.d0

          ii=0
          do jj=1,M
            if (jj.eq.ic) then
              z(jj)=zic
            else 
              ii=ii+1
              z(jj)=b0(ii)+b(ii)*zic+u(ii)
            end if 
          end do

          do ii=1,M
            u(ii)=0.d0
          end do

          do jj=1,M
          do ii=1,jj
           u(ii)=u(ii)+R0(jj*(jj-1)/2+ii)*z(jj)
          end do
          end do

          uQu=0.d0
          do ii=1,M
            uQu=uQu+u(ii)**2
          end do
          uQu=-uQu/2.d0

          call pzx(u,x,P,PwA,Pwz,theta(iaA),
     &      M,L,ntermz,ntermx,work)

          call ehyx(u,x,Eh,Ehdel,
     &      theta(iaA),theta(iaB0),theta(iaB),theta(iaR),
     &      M,L,ntermz,ntermx,Kz,Kx,work)

          weight=1.d0
          do jj=1,(M-1)
            weight=weight*W(izz(jj))
          end do

          sum=sum+weight*(P/Eh)*fctr*(detV/detR)*exp(uQu-tQt)

        end do

        hplt=sum
        if (hplt.le.1.d-60) hplt=0.d0

        write(9,9001) zic
        write(9,9001) hplt

      end do

      return
3901  format(1x,'error, plotm, increase mwork to at least',i5)
3902  format(1x,'error, plotm, error return from factor, ier=',i5)
9001  format(e30.18)
      end
      
*     Given mu and sigma of an M variate multivariate normal X and an
*     index ic, returns b0, b, and V such that the M-1 variate normal
*     with mean b0 + b*X2 and variance V is the conditional distribution
*     of X1 = [X(1),...,X(ic-1),X(ic+1),...,X(M)]' given X2 = X(ic).

*     The formulas for the conditional normal are from p. 37 of
*     T. W. Anderson, An Introduction to Multivariate Statistical
*     Analysis, Second Edition, Wiley, 1984.

      subroutine cndist(mu,sigma,M,ic,b0,b,V,work,lwork)
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      save

      real*8 mu,sigma
      real*8 b0,b,V
      real*8 work

      integer*4 M,ic,lwork
      integer*4 i,j,ii,jj
      integer*4 ibS11,ibS12,ibS22,ibS22inv
      integer*4 ibU1,ibU2
      integer*4 ibW
      integer*4 length
      integer*4 iaS11,iaS12,iaS22,iaS22inv
      integer*4 iaU1,iaU2
      integer*4 iaW

      dimension work(lwork)
      dimension mu(M),sigma(M,M)
      dimension b0(M-1),b(M-1),V((M-1)**2)

      ibS11    = 0
      ibS12    = ibS11    + (M-1)**2
      ibS22    = ibS12    + (M-1)
      ibS22inv = ibS22    + 1
      ibU1     = ibS22inv + 1
      ibU2     = ibU1     + (M-1)
      ibW      = ibU2     + 1
      length   = ibW      + (M-1)**2

      iaS11    = ibS11    + 1
      iaS12    = ibS12    + 1
      iaS22    = ibS22    + 1
      iaS22inv = ibS22inv + 1
      iaU1     = ibU1     + 1
      iaU2     = ibU2     + 1
      iaW      = ibW      + 1

      if (length.gt.lwork) then
        write(3,3901) length
        stop
      end if

      work(iaU2)=mu(ic)

      work(iaS22)=sigma(ic,ic)

      work(iaS22inv)=1.d0/work(iaS22)

      ii=0
      do i=1,M
        if (i.ne.ic) then
          ii=ii+1
          work(ibU1+ii)=mu(i)
          work(ibS12+ii)=sigma(i,ic)
        end if
      jj=0
      do j=1,M
        if ((i.ne.ic).and.(j.ne.ic)) then
          jj=jj+1
          work(ibS11+(M-1)*(jj-1)+ii)=sigma(i,j)
        end if
      end do
      end do

      call dgmprd(work(iaS12),work(iaS22inv),b,M-1,1,1)
      call dgmprd(b,work(iaU2),work(iaW),M-1,1,1)
      call dgmsub(work(iaU1),work(iaW),b0,M-1,1)

      call dgmprd(b,work(iaS12),work(iaW),M-1,1,M-1)
      call dgmsub(work(iaS11),work(iaW),V,M-1,M-1)

      return
3901  format(1x,'error, cndist, increase lwork to at least',i5)
      end

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     File  NPSUBS FORTRAN
*
*     NPALF    NPCHKD   NPCORE   NPCRSH   NPDFLT   NPFD     NPFEAS
*     NPFILE   NPGETR   NPIQP    NPKEY    NPLOC    NPMRT    NPOPTN
*     NPPRT    NPRSET   NPSAVR   NPSETX   NPSRCH   NPUPDT   NPSOL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPALF ( INFORM, N, NCLIN, NCNLN,
     $                   ALFA, ALFMIN, ALFMAX, BIGBND, DXNORM,
     $                   ANORM, ADX, AX, BL, BU,
     $                   DSLK, DX, SLK, X )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      DOUBLE PRECISION   ANORM(*), ADX(*), AX(*), BL(*), BU(*),
     $                   DSLK(*), DX(N), SLK(*), X(N)

************************************************************************
*     NPALF   finds a step ALFA such that the point X + ALFA*P reaches
*     one of the slacks or linear constraints.  The step ALFA is the
*     maximum step that can be taken without violating one of the slacks
*     or linear constraints that is currently satisfied.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original Fortran 77 version written  June 1986.
*     This version of NPALF dated  13-Jun-1987.
************************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      LOGICAL            CMDBG
      INTEGER            LCMDBG
      PARAMETER         (LCMDBG = 5)
      COMMON    /CMDEBG/ ICMDBG(LCMDBG), CMDBG

      INTRINSIC          ABS, MAX, MIN
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      IF (CMDBG  .AND.  ICMDBG(3) .GT. 0) WRITE (NOUT, 1000)

      ALFA   = ALFMAX
      J      = 1

*+    WHILE (J .LE. N+NCLIN+NCNLN .AND. ALFA .GT. ALFMIN) DO
  100 IF    (J .LE. N+NCLIN+NCNLN .AND. ALFA .GT. ALFMIN) THEN

         IF      (J .LE. N      ) THEN
            AXI    =  X(J)
            ADXI   = DX(J)
            ROWNRM = ONE
         ELSE IF (J .LE. N+NCLIN) THEN

            I      = J - N
            AXI    = AX(I)
            ADXI   = ADX(I)
            ROWNRM = ANORM(I) + ONE
         ELSE

            I      = J - N - NCLIN
            AXI    = SLK(I)
            ADXI   = DSLK(I)
            ROWNRM = ONE
         END IF

         RES = - ONE
         IF (     ADXI .LE. - EPSPT9*ROWNRM*DXNORM) THEN

*           Constraint decreasing.

            ADXI = - ADXI
            IF (BL(J) .GT. -BIGBND) RES = AXI   - BL(J)
         ELSE IF (ADXI .GT.   EPSPT9*ROWNRM*DXNORM) THEN

*           Constraint increasing.

            IF (BU(J) .LT.  BIGBND) RES = BU(J) - AXI
         END IF

         IF (RES .GT. ZERO  .AND.  ALFA*ADXI .GT. RES)
     $      ALFA  = RES / ADXI

         IF (CMDBG  .AND.  ICMDBG(3) .GT. 0)
     $      WRITE (NOUT, 1200) J, RES, ADXI, ALFA

         J = J + 1
         GO TO 100
*+    END WHILE
      END IF

*     ==================================================================
*     Determine ALFA, the bound on the step to be taken.
*     ==================================================================
      ALFA   = MAX( ALFA, ALFMIN )

      INFORM = 0
      IF (ALFA .GE. ALFMAX) INFORM = 1

      IF (CMDBG  .AND.  ICMDBG(1) .GT. 0  .AND.  INFORM .GT. 0)
     $   WRITE (NOUT, 9010) ALFA

      RETURN

 1000 FORMAT(/ ' NPALF  entered'
     $       / '    J            RES             AP           ALFA '/)
 1200 FORMAT( I5, 3G15.5 )
 9010 FORMAT(/ ' //NPALF //  No finite step.'
     $       / ' //NPALF //             ALFA'
     $       / ' //NPALF //  ', G15.4 )

*     End of  NPALF .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPCHKD( INFORM, MSGNP, NSTATE, LVLDER, NFUN, NGRAD,
     $                   LDCJ, LDCJU, N, NCNLN,
     $                   CONFUN, OBJFUN, NEEDC,
     $                   BIGBND, EPSRF, CDINT, FDINT,
     $                   FDCHK, FDNORM, OBJF, XNORM,
     $                   BL, BU, C, C1, CJAC, CJACU, CJDX,
     $                   DX, GRAD, GRADU, HFORWD, HCNTRL,
     $                   X, WRK1, WRK2, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            NEEDC(*)
      DOUBLE PRECISION   C(*), C1(*), CJAC(LDCJ,*), CJACU(LDCJU,*),
     $                   CJDX(*)
      DOUBLE PRECISION   BL(N), BU(N), DX(N), GRAD(N), GRADU(N), X(N)
      DOUBLE PRECISION   HFORWD(*), HCNTRL(*)
      DOUBLE PRECISION   WRK1(N), WRK2(*), W(LENW)
      EXTERNAL           CONFUN, OBJFUN

C***********************************************************************
C     NPCHKD  performs the following...
C     (1)  Computes the objective and constraint values OBJF and C.
C     (2)  Evaluates the user-provided gradients in CJACU and GRADU.
C     (3)  Counts the missing gradients.
C     (4)  Loads the known gradients into GRAD and CJAC.
C     (5)  Checks that the known gradients are programmed correctly.
C     (6)  Computes the missing gradient elements.
C
C     Systems Optimization Laboratory, Stanford University, California.
C     Original version written 4-September-1985.
C     This version of NPCHKD dated 26-Nov-1989.
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET
      COMMON    /SOL5NP/ LVRFYC, JVERFY(4)

      LOGICAL            CENTRL, NEEDFD
      PARAMETER        ( RDUMMY =-11111.0)

      INFOG  = 0
      INFOCJ = 0
      NFDIFF = 0
      NCDIFF = 0
      NCSET  = N*NCNLN

      IF (NCNLN .GT. 0) THEN
*        ===============================================================
*        Compute the constraints and Jacobian matrix.
*        ===============================================================
*        If some derivatives are missing, load the Jacobian with dummy
*        values.  Any elements left unaltered after the call to CONFUN
*        must be estimated.  A record of the missing Jacobian elements
*        is stored in  CJACU.

         NEEDFD = LVLDER .EQ. 0  .OR.  LVLDER .EQ. 1

         IF (NEEDFD)
     $      CALL F06QHF( 'General', NCNLN, N, RDUMMY, RDUMMY,
     $                   CJACU, LDCJU )

         CALL ILOAD ( NCNLN, (1), NEEDC, 1 )

         MODE   = 2
         CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                NEEDC, X, C, CJACU, NSTATE )
         IF (MODE .LT. 0) GO TO 9999

         CALL F06QFF( 'General', NCNLN, N, CJACU, LDCJU, CJAC, LDCJ )

         IF (NEEDFD) THEN

*           Count the number of missing Jacobian elements.

            DO 220, J = 1, N
               DO 210, I = 1, NCNLN
                  IF (CJACU(I,J) .EQ. RDUMMY) NCDIFF = NCDIFF + 1
  210          CONTINUE
  220       CONTINUE

            NCSET = NCSET - NCDIFF
            IF (NSTATE .EQ. 1) THEN
               IF (NCDIFF .EQ. 0) THEN
                  IF (LVLDER .EQ. 0) LVLDER = 2
                  IF (LVLDER .EQ. 1) LVLDER = 3
                  IF (MSGNP .GT. 0)
     $               WRITE (NOUT, 1000) LVLDER
               ELSE
                  IF (MSGNP .GT. 0)
     $               WRITE (NOUT, 1100) NCSET, N*NCNLN, NCDIFF
               END IF
            END IF
         END IF
      END IF

*     ==================================================================
*     Repeat the procedure above for the objective function.
*     ==================================================================
      NEEDFD = LVLDER .EQ. 0  .OR.  LVLDER .EQ. 2

      IF (NEEDFD)
     $   CALL DLOAD ( N, RDUMMY, GRADU, 1 )

      MODE  = 2
      CALL OBJFUN( MODE, N, X, OBJF, GRADU, NSTATE )
      IF (MODE .LT. 0) GO TO 9999

      CALL DCOPY ( N, GRADU, 1, GRAD, 1 )

      IF (NEEDFD) THEN                     

*        Count the number of missing gradient elements.

         DO 300, J = 1, N
            IF (GRADU(J) .EQ. RDUMMY) NFDIFF = NFDIFF + 1
  300    CONTINUE

         IF (NSTATE .EQ. 1) THEN
            IF (NFDIFF .EQ. 0) THEN
               IF (LVLDER .EQ. 0) LVLDER = 1
               IF (LVLDER .EQ. 2) LVLDER = 3
               IF (MSGNP .GT. 0)
     $            WRITE (NOUT, 2000) LVLDER
            ELSE
               IF (MSGNP .GT. 0)
     $            WRITE (NOUT, 2100) N - NFDIFF, N, NFDIFF
            END IF
         END IF
      END IF

      NFUN  = NFUN  + 1
      NGRAD = NGRAD + 1

*     ==================================================================
*     Check whatever gradient elements have been provided.
*     ==================================================================
      IF (LVRFYC .GE. 0) THEN
         IF (NCSET .GT. 0) THEN
            CALL CHCJAC( MODE, LVLDER, MSGNP,
     $                   NCSET, N, NCNLN, LDCJ, LDCJU,
     $                   BIGBND, EPSRF, EPSPT3, FDCHK, XNORM,
     $                   CONFUN, NEEDC,
     $                   BL, BU, C, C1, CJAC, CJACU, CJDX,
     $                   DX, WRK2, X, WRK1, W, LENW )
            IF (MODE .LT. 0) GO TO 9999
            INFOCJ = MODE
         END IF

         IF (NFDIFF .LT. N) THEN
            CALL CHFGRD( MODE, MSGNP, N,
     $                   BIGBND, EPSRF, EPSPT3, FDCHK, OBJF, XNORM,
     $                   OBJFUN,
     $                   BL, BU, GRAD, GRADU, DX, X, WRK1, W, LENW )
            IF (MODE .LT. 0) GO TO 9999
            INFOG   = MODE
         END IF
      END IF

      NEEDFD = NCDIFF .GT. 0  .OR.  NFDIFF .GT. 0
      IF (NEEDFD) THEN
*        ===============================================================
*        Compute the missing gradient elements.
*        ===============================================================
*        CHFD computes the finite-difference intervals or checks
*        preassigned (scalar) values.

         CALL CHFD  ( MODE, MSGNP, LVLDER,
     $                N, NCNLN, LDCJ, LDCJU,
     $                BIGBND, EPSRF, FDNORM, OBJF,
     $                OBJFUN, CONFUN, NEEDC,
     $                BL, BU, C, C1, CJDX, CJAC, CJACU,
     $                GRAD, GRADU, HFORWD, HCNTRL, X,
     $                DX, W, LENW )

         IF (MODE .LT. 0) GO TO 9999

         IF (LFDSET .GT. 0) THEN
            CENTRL = LVLDIF .EQ. 2
            CALL NPFD  ( CENTRL, MODE,
     $                   LDCJ, LDCJU, N, NCNLN,
     $                   BIGBND, CDINT, FDINT, FDNORM, OBJF,
     $                   CONFUN, OBJFUN, NEEDC,
     $                   BL, BU, C, C1, CJDX, CJAC, CJACU,
     $                   GRAD, GRADU, HFORWD, HCNTRL, X,
     $                   W, LENW )

            IF (MODE .LT. 0) GO TO 9999
         END IF
      END IF

      INFORM = INFOCJ + INFOG

      RETURN

*     The user requested termination.

 9999 INFORM = MODE
      RETURN

 1000 FORMAT(//' All Jacobian elements have been set.  ',
     $         ' Derivative level increased to ', I4 )
 1100 FORMAT(//' The user sets ', I6, '   out of', I6,
     $         '   Jacobian elements.'
     $       / ' Each iteration, ', I6,
     $         '   Jacobian elements will be estimated numerically.' )
 2000 FORMAT(//' All objective gradient elements have been set.  ',
     $         ' Derivative level increased to ', I4 )
 2100 FORMAT(//' The user sets ', I6, '   out of', I6,
     $         '   objective gradient elements.'
     $       / ' Each iteration, ', I6,
     $         '   gradient elements will be estimated numerically.' )

*     End of  NPCHKD.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPCORE( NAMED, NAMES, UNITQ, INFORM, MAJITS,
     $                   N, NCLIN, NCNLN, NCTOTL, NACTIV, NFREE, NZ,
     $                   LDA, LDCJ, LDCJU, LDAQP, LDR,
     $                   NFUN, NGRAD, ISTATE, KACTIV, KX,
     $                   OBJF, FDNORM, XNORM, CONFUN, OBJFUN,
     $                   AQP, AX, BL, BU, C, CJAC, CJACU, CLAMDA,
     $                   FEATOL, GRAD, GRADU, R, X, IW, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            NAMED
      INTEGER            ISTATE(*), KACTIV(N), KX(N)
      INTEGER            IW(*)
      DOUBLE PRECISION   AQP(LDAQP,*), AX(*), BL(NCTOTL), BU(NCTOTL),
     $                   C(*), CJAC(LDCJ,*), CJACU(LDCJU,*)
      DOUBLE PRECISION   CLAMDA(NCTOTL), FEATOL(NCTOTL), GRAD(N),
     $                   GRADU(N), R(LDR,*), X(N)
      DOUBLE PRECISION   W(LENW)
      EXTERNAL           CONFUN, OBJFUN

      DOUBLE PRECISION   ASIZE, DTMAX, DTMIN
      CHARACTER*8        NAMES(*)
               
************************************************************************
*     NPCORE  is the core routine for  NPSOL,  a sequential quadratic
*     programming (SQP) method for nonlinearly constrained optimization.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version      February-1982.
*     This version of NPCORE dated 26-Nov-1989.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL3CM/ LENNAM, LDT   , NCOLT , LDZY
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
      COMMON    /SOL5CM/ ASIZE , DTMAX , DTMIN
      COMMON    /SOL6CM/ RCNDBD, RFROBN, DRMAX, DRMIN

      PARAMETER         (LENLS = 20)
      COMMON    /SOL1LS/ LOCLS(LENLS)

      PARAMETER         (LENNP = 35)
      COMMON    /SOL1NP/ LOCNP(LENNP)
      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET
      COMMON    /SOL5NP/ LVRFYC, JVERFY(4)
      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      PARAMETER         (LDBG = 5)
      LOGICAL            CMDBG, NPDBG
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG
      COMMON    /CMDEBG/ ICMDBG(LDBG), CMDBG

*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
*-----INCLUDE NPPARM----------------------------------------------------
      INTEGER            IPRMNP(MXPARM), IPSVNP
      DOUBLE PRECISION   RPRMNP(MXPARM), RPSVNP

      COMMON    /NPPAR1/ IPSVNP(MXPARM),
     $                   IDBGNP, ITMXNP, JVRFY1, JVRFY2, JVRFY3, JVRFY4,
     $                   LDBGNP, LFORMH, LVLDER, LVERFY, MSGNP , NLNF  ,
     $                   NLNJ  , NLNX  , NNCNLN, NSAVE , NLOAD , KSAVE ,
     $                   IPADNP(12)

      COMMON    /NPPAR2/ RPSVNP(MXPARM),
     $                   CDINT , CTOL  , DXLIM , EPSRF , ETA   , FDINT ,
     $                   FTOL  , HCNDBD, RPADNP(22)

      EQUIVALENCE       (IPRMNP(1), IDBGNP), (RPRMNP(1), CDINT)

      SAVE      /NPPAR1/, /NPPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE  (IDBGNP, IDBG  ), (ITMXNP, NMAJOR), (ITMAX2, NMINOR)
      EQUIVALENCE  (LDBGLS, MNRDBG), (LDBGNP, MJRDBG), (MSGLS , MSGQP )

      LOGICAL            GOODGQ, NEWGQ
      LOGICAL            CENTRL, CONVRG, CONVPT, DONE  , ERROR , FEASQP
      LOGICAL            INFEAS, NEEDFD, OPTIML, OVERFL, UNITQ
      LOGICAL            KTCOND(2)
      INTRINSIC          ABS   , MAX   , MIN   , MOD   , REAL  , SQRT
      EXTERNAL           DDIV  , DDOT  , DNRM2

      CHARACTER*5        LSUMRY
      CHARACTER*2        JOB
      PARAMETER        ( JOB  = 'NP' )
      PARAMETER        ( ZERO = 0.0D+0, HALF = 0.5D+0, ONE = 1.0D+0 )
      PARAMETER        ( GROWTH=1.0D+2                              )

*     Specify machine-dependent parameters.

      EPSMCH = WMACH(3)
      FLMAX  = WMACH(7)
      RTMAX  = WMACH(8)

      LANORM = LOCLS( 2)
      LRPQ   = LOCLS( 5)
      LQRWRK = LOCLS( 6)
      LHPQ   = LOCLS( 8)
      LGQ    = LOCLS( 9)
      LRLAM  = LOCLS(10)
      LT     = LOCLS(11)
      LZY    = LOCLS(12)
      LWTINF = LOCLS(13)
      LWRK1  = LOCLS(14)
      LQPTOL = LOCLS(15)

      LIPERM = LOCNP( 2)
      LAQP   = LOCNP( 3)
      LADX   = LOCNP( 4)
      LBL    = LOCNP( 5)
      LBU    = LOCNP( 6)
      LDX    = LOCNP( 7)
      LGQ1   = LOCNP( 8)
      LX1    = LOCNP(11)
      LWRK2  = LOCNP(12)
      LCS1   = LOCNP(13)
      LCS2   = LOCNP(14)
      LC1MUL = LOCNP(15)
      LCMUL  = LOCNP(16)
      LCJDX1 = LOCNP(17)
      LDLAM  = LOCNP(18)
      LDSLK  = LOCNP(19)
      LRHO   = LOCNP(20)
      LWRK3  = LOCNP(21)
      LSLK1  = LOCNP(22)
      LSLK   = LOCNP(23)
      LNEEDC = LOCNP(24)
      LHFRWD = LOCNP(25)
      LHCTRL = LOCNP(26)

      LCJAC1 = LAQP   + NCLIN
      LCJDX  = LADX   + NCLIN
      LVIOLN = LWRK3

*     Initialize

      LSUMRY = '     '
      NQPINF = 0

      MAJIT0 = MAJITS
      NPLIN  = N     + NCLIN
      NCQP   = NCLIN + NCNLN
      NL     = MIN( NPLIN + 1, NCTOTL )

      LDCJ1 = MAX( NCQP , 1 )

      NEEDFD = LVLDER .EQ. 0  .OR.  LVLDER .EQ. 2
     $                        .OR. (LVLDER .EQ. 1  .AND.  NCNLN .GT. 0)

      ALFA   = ZERO
      ALFDX  = ZERO
      RTFTOL = SQRT( FTOL )
      ROOTN  = SQRT( REAL(N) )

*     If debug printing is required,  turn off any extensive printing
*     until iteration  IDBG.

      MSGSV1 = MSGNP
      MSGSV2 = MSGQP
      IF (IDBG .LE. NMAJOR  .AND.  IDBG .GT. 0) THEN
         MSGNP = 0
         IF (MSGSV1 .GE. 5) MSGNP = 5
         MSGQP = 0
         IF (MSGSV2 .GE. 5) MSGQP = 5
      END IF

*     ------------------------------------------------------------------
*     Information from the feasibility phase will be used to generate a
*     hot start for the first QP subproblem.
*     ------------------------------------------------------------------
      CALL DCOPY ( NCTOTL, FEATOL, 1, W(LQPTOL), 1 )

      NSTATE = 0

      OBJALF = OBJF
      IF (NCNLN .GT. 0) THEN
         OBJALF = OBJALF - DDOT  ( NCNLN, W(LCMUL), 1, C, 1 )
      END IF

      NEWGQ  = .FALSE.

**    ==================================================================
*+    REPEAT                             (Until converged or error exit)

*        ===============================================================
*        See if we want to save the details of this iteration.
*        ===============================================================
  100    IF (MOD(MAJITS,KSAVE) .EQ. 0 .AND. MAJITS .NE. MAJIT0) THEN
            CALL NPSAVR( UNITQ, N, NCLIN, NCNLN, LDR, LDZY,
     $                   NFREE, NSAVE, MAJITS, ISTATE, KX,
     $                   W(LHFRWD), W(LHCTRL),
     $                   W(LCMUL), R, W(LRHO), X, W(LZY) )
         END IF
         
**       ===============================================================
*+       REPEAT                         (Until a good gradient is found)

  110       CENTRL = LVLDIF .EQ. 2

            IF (NEWGQ) THEN
               IF (NEEDFD) THEN
*                 ------------------------------------------------------
*                 Compute any missing gradient elements and the
*                 transformed gradient of the objective.
*                 ------------------------------------------------------
                  CALL NPFD  ( CENTRL, MODE,
     $                         LDCJ, LDCJU, N, NCNLN,
     $                         BIGBND, CDINT, FDINT, FDNORM, OBJF,
     $                         CONFUN, OBJFUN, IW(LNEEDC),
     $                         BL, BU, C, W(LWRK2), W(LWRK3),CJAC,CJACU,
     $                         GRAD, GRADU, W(LHFRWD), W(LHCTRL), X,
     $                         W, LENW )
                  INFORM = MODE
                  IF (MODE .LT. 0) GO TO 800

               END IF

               CALL DCOPY ( N, GRAD, 1, W(LGQ), 1 )
               CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ,
     $                      KX, W(LGQ), W(LZY), W(LWRK1) )

               NEWGQ  = .FALSE.
            END IF

*           ============================================================
*           (1) Solve an inequality quadratic program (IQP) for the
*               search direction and multiplier estimates.
*           (2) For each nonlinear inequality constraint,  compute
*               the slack variable for which the merit function is
*               minimized.
*           (3) Compute the search direction for the slack variables
*               and multipliers.
*
*           Note that the array VIOLN is WRK3.
*           ============================================================
            CALL NPIQP ( FEASQP, UNITQ, NQPERR, MINITS,
     $                   N, NCLIN, NCNLN, LDA, LDCJ, LDAQP, LDR,
     $                   LINACT, NLNACT, NACTIV, NFREE, NZ, NUMINF,
     $                   ISTATE, KACTIV, KX,
     $                   DXNORM, GDX, QPCURV,
     $                   AQP, W(LADX), W(LANORM), AX, BL, BU,
     $                   C, CJAC, CLAMDA, W(LCMUL), W(LCS1),
     $                   W(LDLAM), W(LDSLK), W(LDX), W(LBL), W(LBU),
     $                   W(LQPTOL), R, W(LRHO), W(LSLK), W(LVIOLN), X,
     $                   W(LWTINF), IW, W )

            IF (FEASQP) THEN
               NQPINF = 0
            ELSE
               NQPINF = NQPINF + 1
               LSUMRY(2:2) = 'Infeasible subproblem'
            END IF

*           ============================================================
*           Compute quantities needed for the convergence test.
*           ============================================================
*           Compute the norms of the projected gradient and the
*           gradient with respect to the free variables.

            GZNORM = ZERO
            IF (NZ .GT. 0)
     $         GZNORM = DNRM2 ( NZ   , W(LGQ), 1 )
            GFNORM = GZNORM
            IF (NFREE .GT. 0  .AND.  NACTIV .GT. 0)
     $         GFNORM = DNRM2 ( NFREE, W(LGQ), 1 )

*           If the forward-difference estimate of the transformed
*           gradient of the Lagrangian function is small,  switch to
*           central differences, recompute the derivatives and re-solve
*           the QP.

            GOODGQ = .TRUE.
            IF (NEEDFD  .AND.  .NOT. CENTRL) THEN

               GLNORM = DNRM2 ( N, W(LHPQ), 1 )
               IF (NCNLN .EQ. 0) THEN
                  CNORM = ZERO
               ELSE
                  CNORM = DNRM2 ( NCNLN, C, 1 )
               END IF

               GLTEST = (ONE + ABS(OBJF) + ABS(CNORM))*EPSRF/FDNORM
               IF (GLNORM .LE. GLTEST) THEN
                  GOODGQ      = .FALSE.
                  LSUMRY(3:3) = 'Central differences'
                  LVLDIF      = 2
                  NEWGQ       = .TRUE.
               END IF

            END IF

*+       UNTIL     (GOODGQ)
         IF (.NOT.  GOODGQ ) GO TO 110

*        ===============================================================
*        (1) Compute the number of constraints that are violated by more
*            than FEATOL.
*        (2) Compute the 2-norm of the residuals of the constraints in
*            the QP working set.
*        ===============================================================
         CALL NPFEAS( N, NCLIN, NCNLN, ISTATE,
     $                BIGBND, CVNORM, ERRMAX, JMAX, NVIOL,
     $                AX, BL, BU, C, FEATOL, X, W(LWRK2) )

*        Define small quantities that reflect the magnitude of OBJF and
*        the norm of GRAD(free).

         OBJSIZ = ONE + ABS( OBJF )
         XSIZE  = ONE +  XNORM
         GTEST  = MAX( OBJSIZ, GFNORM )
         DINKY  = RTFTOL * GTEST

         IF (NACTIV .EQ. 0) THEN
            CONDT = ZERO
         ELSE IF (NACTIV .EQ. 1) THEN
            CONDT = DTMIN
         ELSE
            CONDT = DDIV  ( DTMAX, DTMIN, OVERFL )
         END IF

         CALL DCOND ( N, R, LDR+1, DRMAX, DRMIN )

         CONDH = DDIV  ( DRMAX, DRMIN, OVERFL )
         IF (CONDH .LT. RTMAX) THEN
            CONDH = CONDH*CONDH
         ELSE
            CONDH = FLMAX
         END IF

         IF (NZ .EQ. 0) THEN
            CONDHZ = ONE
         ELSE IF (NZ .EQ. N) THEN
            CONDHZ = CONDH
         ELSE
            CALL DCOND ( NZ, R, LDR+1, DRZMAX, DRZMIN )
            CONDHZ = DDIV  ( DRZMAX, DRZMIN, OVERFL )
            IF (CONDHZ .LT. RTMAX) THEN
               CONDHZ = CONDHZ*CONDHZ
            ELSE
               CONDHZ = FLMAX
            END IF
         END IF

*        ---------------------------------------------------------------
*        Test for convergence.
*        The point test CONVPT checks for a K-T point at the initial
*        point or after a large change in X.
*        ---------------------------------------------------------------
         CONVPT    = GZNORM .LE. EPSPT8*GTEST  .AND.  NVIOL  .EQ. 0

         KTCOND(1) = GZNORM .LT. DINKY
         KTCOND(2) = NVIOL  .EQ. 0
         OPTIML    = KTCOND(1)  .AND.  KTCOND(2)

         CONVRG    = MAJITS .GT. 0  .AND.  ALFDX .LE. RTFTOL*XSIZE

         INFEAS    =       CONVRG         .AND.  .NOT. FEASQP
     $               .OR.  NQPINF .GT. 7

         DONE      = CONVPT  .OR.  (CONVRG  .AND. OPTIML)
     $                       .OR.   INFEAS

         OBJALF = OBJF
         GRDALF = GDX
         GLF1   = GDX
         IF (NCNLN .GT. 0) THEN
            GLF1   = GLF1
     $                 - DDOT( NCNLN, W(LCJDX), 1, CLAMDA(NL), 1 )

*           Compute the value and directional derivative of the
*           augmented Lagrangian merit function.
*           The penalty parameters may be increased or decreased.

            CALL NPMRT ( FEASQP, N, NCLIN, NCNLN,
     $                   OBJALF, GRDALF, QPCURV,
     $                   ISTATE,
     $                   W(LCJDX), W(LCMUL), W(LCS1),
     $                   W(LDLAM), W(LRHO), W(LVIOLN),
     $                   W(LWRK1), W(LWRK2) )
         END IF

*        ===============================================================
*        Print the details of this iteration.
*        ===============================================================
         CALL NPPRT ( KTCOND, CONVRG, LSUMRY, MSGNP, MSGQP,
     $                LDR, LDT, N, NCLIN, NCNLN,
     $                NCTOTL, NACTIV, LINACT, NLNACT, NZ, NFREE,
     $                MAJIT0, MAJITS, MINITS, ISTATE, ALFA, NFUN,
     $                CONDHZ, CONDH, CONDT, OBJALF, OBJF,
     $                GFNORM, GZNORM, CVNORM,
     $                AX, C, R, W(LT), W(LVIOLN), X, W(LWRK1) )

         ALFA  = ZERO
         ERROR = MAJITS .GE. NMAJOR

         IF (.NOT. (DONE  .OR.  ERROR)) THEN
            MAJITS = MAJITS + 1

            IF (MAJITS .EQ. IDBG) THEN
               NPDBG = .TRUE.
               CMDBG =  NPDBG
               MSGNP =  MSGSV1
               MSGQP =  MSGSV2
            END IF

*           Make copies of information needed for the BFGS update.

            CALL DCOPY ( N, X     , 1, W(LX1) , 1 )
            CALL DCOPY ( N, W(LGQ), 1, W(LGQ1), 1 )

            IF (NCNLN .GT. 0) THEN
               CALL DCOPY ( NCNLN, W(LCJDX), 1, W(LCJDX1), 1 )
               CALL DCOPY ( NCNLN, W(LCMUL), 1, W(LC1MUL), 1 )
               CALL DCOPY ( NCNLN, W(LSLK) , 1, W(LSLK1) , 1 )
            END IF

*           ============================================================
*           Compute the parameters for the linesearch.
*           ============================================================
*           ALFMIN is the smallest allowable step predicted by the QP
*           subproblem.

            ALFMIN = ONE
            IF (.NOT. FEASQP) ALFMIN = ZERO

*           ------------------------------------------------------------
*           ALFMAX is the largest feasible steplength subject to a user-
*           defined limit ALFLIM on the change in X.
*           ------------------------------------------------------------
            IF (NCNLN .GT. 0  .AND.  NEEDFD) THEN
               ALFMAX = ONE
            ELSE
               ALFMAX = DDIV  ( BIGDX, DXNORM, OVERFL )
               CALL NPALF ( INFO, N, NCLIN, NCNLN,
     $                      ALFA, ALFMIN, ALFMAX, BIGBND, DXNORM,
     $                      W(LANORM), W(LADX), AX, BL, BU,
     $                      W(LDSLK), W(LDX), W(LSLK), X )
               ALFMAX = ALFA
               IF (ALFMAX .LT. ONE + EPSPT3  .AND.  FEASQP)
     $            ALFMAX = ONE
            END IF

*           ------------------------------------------------------------
*           ALFBND is a tentative upper bound on the steplength.  If the
*           merit function is decreasing at ALFBND and certain
*           conditions hold,  ALFBND will be increased in multiples of
*           two (subject to not being greater than ALFMAX).
*           ------------------------------------------------------------
            IF (NCNLN .EQ. 0) THEN
               ALFBND = ALFMAX
            ELSE
               ALFBND = MIN( ONE, ALFMAX )
            END IF

*           ------------------------------------------------------------
*           ALFSML trips the computation of central differences.  If a
*           trial steplength falls below ALFSML, the linesearch is
*           terminated.
*           ------------------------------------------------------------
            ALFSML = ZERO
            IF (NEEDFD  .AND. .NOT. CENTRL) THEN
               ALFSML = DDIV  ( FDNORM, DXNORM, OVERFL )
               ALFSML = MIN   ( ALFSML, ALFMAX )
            END IF

*           ============================================================
*           Compute the steplength using safeguarded interpolation.
*           ============================================================
            ALFLIM = DDIV ( (ONE+XNORM)*DXLIM, DXNORM, OVERFL )
            ALFA   = MIN  ( ALFLIM, ONE )

            CALL NPSRCH( NEEDFD, NLSERR, N, NCNLN,
     $                   LDCJ, LDCJU, NFUN, NGRAD,
     $                   IW(LNEEDC), CONFUN, OBJFUN,
     $                   ALFA, ALFBND, ALFMAX, ALFSML, DXNORM,
     $                   EPSRF, ETA, GDX, GRDALF, GLF1, GLF2,
     $                   OBJF, OBJALF, QPCURV, XNORM,
     $                   C, W(LWRK1), CJAC, CJACU, W(LCJDX), W(LWRK3),
     $                   W(LC1MUL), W(LCMUL), W(LCS1),
     $                   W(LCS2), W(LDX), W(LDLAM), W(LDSLK), GRAD,
     $                   GRADU, CLAMDA(NL), W(LRHO),
     $                   W(LSLK1), W(LSLK), W(LX1), X, 
     $                   W(LWRK2), W, LENW )

*           ------------------------------------------------------------
*           NPSRCH  sets NLSERR to the following values...
*
*           NLSERR will be negative if the user set MODE LT 0.
*
*           Values of NLSERR occurring with a nonzero value of ALFA.
*           1 -- if the search was successful and ALFA LT ALFMAX.
*           2 -- if the search was successful and ALFA  = ALFMAX.
*           3 -- if the search ended after MFSRCH iterations.
*
*           Values of NLSERR occurring with a zero value of ALFA....
*           4 -- if ALFMAX was too small.
*           6 -- if no improved point could be found.
*           7 -- if the input value of GDX is non-negative.
*           ------------------------------------------------------------
            IF (NLSERR .LT. 0) THEN
               INFORM = NLSERR
               GO TO 800
            END IF

            IF (ALFA .GT. ALFLIM) LSUMRY(4:4) = 'L'

            ERROR  = NLSERR .GE. 4
            IF (ERROR) THEN
*              ---------------------------------------------------------
*              The linesearch failed to find a better point.
*              If exact gradients or central differences are being used,
*              or the KT conditions are satisfied, stop.  Otherwise,
*              switch to central differences and solve the QP again.
*              ---------------------------------------------------------
               IF (NEEDFD  .AND.  .NOT. CENTRL) THEN
                  IF (.NOT. OPTIML) THEN
                     ERROR       = .FALSE.
                     LSUMRY(3:3) = 'Central differences'
                     LVLDIF      = 2
                     NEWGQ       = .TRUE.
                  END IF
               END IF
            ELSE
               IF (NEEDFD) THEN
*                 ======================================================
*                 Compute the missing gradients.
*                 ======================================================
                  MODE  = 1
                  NGRAD = NGRAD + 1

                  IF (NCNLN .GT. 0) THEN
                     CALL ILOAD ( NCNLN, (1), IW(LNEEDC), 1 )

                     CALL CONFUN( MODE, NCNLN, N, LDCJU, IW(LNEEDC),
     $                            X, W(LWRK1), CJACU, NSTATE )
                     INFORM = MODE
                     IF (MODE .LT. 0) GO TO 800

                     CALL F06QFF( 'General', NCNLN, N, CJACU, LDCJU,
     $                            CJAC, LDCJ )
                  END IF

                  CALL OBJFUN( MODE, N, X, OBJ, GRADU, NSTATE )
                  INFORM = MODE
                  IF (MODE .LT. 0) GO TO 800

                  CALL DCOPY ( N, GRADU, 1, GRAD, 1 )

                  CALL NPFD  ( CENTRL, MODE,
     $                         LDCJ, LDCJU, N, NCNLN,
     $                         BIGBND, CDINT, FDINT, FDNORM, OBJF,
     $                         CONFUN, OBJFUN, IW(LNEEDC),
     $                         BL, BU, C, W(LWRK2), W(LWRK3),CJAC,CJACU,
     $                         GRAD, GRADU, W(LHFRWD), W(LHCTRL), X,
     $                         W, LENW )

                  INFORM = MODE
                  IF (MODE .LT. 0) GO TO 800

                  GDX  =  DDOT( N, GRAD, 1, W(LDX), 1 )
                  GLF2 =  GDX
                  IF (NCNLN .GT. 0) THEN
                     CALL DGEMV ( 'N', NCNLN, N, ONE, CJAC, LDCJ,
     $                            W(LDX), 1, ZERO, W(LCJDX), 1 )
                     GLF2 = GLF2 -
     $                      DDOT( NCNLN, W(LCJDX), 1, CLAMDA(NL), 1 )
                  END IF
               END IF

               CALL DCOPY ( N, GRAD, 1, W(LGQ), 1 )
               CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ,
     $                      KX, W(LGQ), W(LZY), W(LWRK1) )

               XNORM  = DNRM2 ( N, X, 1 )

               IF (NCNLN .GT. 0  .AND.  ALFA .GE. ONE)
     $            CALL DCOPY ( NCNLN, CLAMDA(NL), 1, W(LCMUL), 1 )

               IF (NCLIN .GT. 0)
     $            CALL DAXPY ( NCLIN, ALFA, W(LADX), 1, AX, 1 )
               ALFDX   = ALFA * DXNORM

*              =========================================================
*              Update the factors of the approximate Hessian of the
*              Lagrangian function.
*              =========================================================
               CALL NPUPDT( LSUMRY, UNITQ,
     $                      N, NCNLN, NFREE, NZ,
     $                      LDCJ1, LDCJ, LDZY, LDR, KX,
     $                      ALFA, GLF1, GLF2, QPCURV,
     $                      W(LCJAC1), CJAC, W(LCJDX1), W(LCJDX),
     $                      W(LCS1), W(LCS2), W(LGQ1), W(LGQ),
     $                      W(LHPQ), W(LRPQ), CLAMDA(NL), R,
     $                      W(LWRK3), W(LZY), W(LWRK2), W(LWRK1) )

               CALL DCOND ( N, R, LDR+1, DRMAX, DRMIN )
               COND   = DDIV  ( DRMAX, DRMIN, OVERFL )

               IF (      COND   .GT. RCNDBD
     $             .OR.  RFROBN .GT. ROOTN*GROWTH*DRMAX) THEN
*                 ------------------------------------------------------
*                 Reset the condition estimator and range-space
*                 partition of Q'HQ.
*                 ------------------------------------------------------
                  IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $               WRITE (NOUT, 9000) RFROBN, DRMAX, DRMIN,COND,RCNDBD

                  LSUMRY(5:5) = 'Refactorize Hessian'

                  CALL NPRSET( UNITQ,
     $                         N, NFREE, NZ, LDZY, LDR,
     $                         IW(LIPERM), KX,
     $                         W(LGQ), R, W(LZY), W(LWRK1), W(LQRWRK) )
               END IF
            END IF
         END IF

*+    UNTIL     (DONE  .OR.  ERROR)
      IF (.NOT. (DONE  .OR.  ERROR) ) GO TO 100

*     ======================end of main loop============================

      IF (DONE) THEN
         IF (CONVPT  .OR.  OPTIML) THEN
            INFORM = 0
         ELSE IF (INFEAS) THEN
            INFORM = 3
         END IF
      ELSE IF (ERROR) THEN
         IF (MAJITS .GE. NMAJOR) THEN
            INFORM = 4
         ELSE IF (OPTIML) THEN
            INFORM = 1
         ELSE
            INFORM = 6
         END IF
      END IF

*     ------------------------------------------------------------------
*     Set  CLAMDA.  Print the full solution.
*     ------------------------------------------------------------------
  800 MSGNP = MSGSV1
      MSGQP = MSGSV2
      IF (MSGNP .GT. 0)
     $   WRITE (NOUT, 2100) INFORM, MAJITS, NFUN, NGRAD

      CALL CMPRT ( MSGNP, NFREE, LDAQP,
     $             N, NCLIN, NCNLN, NCTOTL, BIGBND,
     $             NAMED, NAMES, LENNAM,
     $             NACTIV, ISTATE, KACTIV, KX,
     $             AQP, BL, BU, C, CLAMDA, W(LRLAM), X )
      IF (NCNLN .GT. 0)
     $CALL DCOPY ( NCNLN, W(LCMUL), 1, CLAMDA(N+NCLIN+1), 1 )

      RETURN

 2100 FORMAT(/ ' Exit  NP phase.  INFORM = ', I2, ' MAJITS = ', I5,
     $         '   NFUN = ', I5, '   NGRAD = ', I5 )

 9000 FORMAT(/ ' //NPCORE//        RFROBN         DRMAX         DRMIN'
     $       / ' //NPCORE//', 1P, 3E14.2
     $       / ' //NPCORE//          COND        RCNDBD'
     $       / ' //NPCORE//', 1P, 2E14.2 )

*     End of  NPCORE.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPCRSH( COLD, N, NCLIN, NCNLN,
     $                   NCTOTL, NACTIV, NFREE, NZ,
     $                   ISTATE, KACTIV, BIGBND, TOLACT,
     $                   BL, BU, C )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            COLD
      INTEGER            ISTATE(NCTOTL), KACTIV(N)
      DOUBLE PRECISION   C(*), BL(NCTOTL), BU(NCTOTL)
************************************************************************
*     NPCRSH  adds indices of nonlinear constraints to the initial
*     working set.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version   14-February 1985.
*     This version of  NPCRSH  dated 14-November-1985.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

      COMMON    /SOL1CM/ NOUT

      LOGICAL            NPDBG
      PARAMETER        ( LDBG = 5 )
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      INTRINSIC          ABS, MIN
      PARAMETER        ( ONE = 1.0D+0 )

      NFIXED = N      - NFREE
      LINACT = NACTIV
      NPLIN  = N      + NCLIN

*     If a cold start is being made, initialize the status of the QP
*     working set.  First,  if  BL(j) = BU(j),  set ISTATE(j)=3.

      IF (COLD) THEN
         DO 130, J = NPLIN+1, NCTOTL
            ISTATE(J) = 0
            IF (BL(J) .EQ. BU(J)) ISTATE(J) = 3
  130    CONTINUE
      END IF

*     Increment NACTIV and KACTIV.
*     Ensure that the number of bounds and general constraints in the
*     QP  working set does not exceed N.

      DO 200, J = NPLIN+1, NCTOTL
         IF (NFIXED + NACTIV .EQ. N) ISTATE(J) = 0
         IF (ISTATE(J) .GT. 0) THEN
            NACTIV = NACTIV + 1
            KACTIV(NACTIV) = J - N
         END IF
  200 CONTINUE

      IF (COLD) THEN

*        ---------------------------------------------------------------
*        If a cold start is required, an attempt is made to add as many
*        nonlinear constraints as possible to the working set.
*        ---------------------------------------------------------------
*        The following loop finds the most violated constraint.  If
*        there is room in KACTIV, it will be added to the working set
*        and the process will be repeated.


         IS     =   1
         BIGLOW = - BIGBND
         BIGUPP =   BIGBND
         TOOBIG =   TOLACT + TOLACT

*        while (is .gt. 0  .and.  nfixed + nactiv .lt. n) do
  500    IF    (IS .GT. 0  .AND.  NFIXED + NACTIV .LT. N) THEN
            IS   = 0
            CMIN = TOLACT

            DO 520, I = 1, NCNLN
               J      = NPLIN + I
               IF (ISTATE(J) .EQ. 0) THEN
                  B1     = BL(J)
                  B2     = BU(J)
                  RESL   = TOOBIG
                  RESU   = TOOBIG
                  IF (B1 .GT. BIGLOW)
     $            RESL   = ABS( C(I) - B1 ) / (ONE + ABS( B1 ))
                  IF (B2 .LT. BIGUPP)
     $            RESU   = ABS( C(I) - B2 ) / (ONE + ABS( B2 ))
                  RES    = MIN( RESL, RESU )
                  IF (RES .LT. CMIN) THEN
                     CMIN = RES
                     IMIN = I
                     IS   = 1
                     IF (RESL .GT. RESU) IS = 2
                  END IF
               END IF
  520       CONTINUE

            IF (IS .GT. 0) THEN
               NACTIV         = NACTIV + 1
               KACTIV(NACTIV) = NCLIN  + IMIN
               J              = NPLIN  + IMIN
               ISTATE(J)      = IS
            END IF
            GO TO 500
*        end while
         END IF
      END IF

*     ------------------------------------------------------------------
*     An initial working set has now been selected.
*     ------------------------------------------------------------------
      NLNACT = NACTIV - LINACT
      NZ     = NFREE  - NACTIV
      IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $   WRITE (NOUT, 1000) NFIXED, LINACT, NLNACT

      RETURN

 1000 FORMAT(/ ' //NPCRSH//  Working set selected....'
     $       / ' //NPCRSH// NFIXED LINACT NLNACT     '
     $       / ' //NPCRSH//', 3I7 )

*     End of  NPCRSH.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPDFLT( N, NCLIN, NCNLN, LENIW, LENW, TITLE )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

      CHARACTER*(*)      TITLE

************************************************************************
*     NPDFLT  loads the default values of parameters not set in the
*     options file.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original Fortran 77 version written 10-September-1985.
*     This version of NPDFLT dated 26-Nov-89.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
                 
      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET
      COMMON    /SOL5NP/ LVRFYC, JVERFY(4)

      LOGICAL            CMDBG, LSDBG, NPDBG
      PARAMETER        ( LDBG = 5 )
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG
      COMMON    /CMDEBG/ ICMDBG(LDBG), CMDBG

      LOGICAL            NEWOPT
      COMMON    /SOL7NP/ NEWOPT
      SAVE      /SOL7NP/

*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
*-----INCLUDE NPPARM----------------------------------------------------
      INTEGER            IPRMNP(MXPARM), IPSVNP
      DOUBLE PRECISION   RPRMNP(MXPARM), RPSVNP

      COMMON    /NPPAR1/ IPSVNP(MXPARM),
     $                   IDBGNP, ITMXNP, JVRFY1, JVRFY2, JVRFY3, JVRFY4,
     $                   LDBGNP, LFORMH, LVLDER, LVERFY, MSGNP , NLNF  ,
     $                   NLNJ  , NLNX  , NNCNLN, NSAVE , NLOAD , KSAVE ,
     $                   IPADNP(12)

      COMMON    /NPPAR2/ RPSVNP(MXPARM),
     $                   CDINT , CTOL  , DXLIM , EPSRF , ETA   , FDINT ,
     $                   FTOL  , HCNDBD, RPADNP(22)

      EQUIVALENCE       (IPRMNP(1), IDBGNP), (RPRMNP(1), CDINT)

      SAVE      /NPPAR1/, /NPPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE  (IDBGNP, IDBG  ), (ITMXNP, NMAJOR), (ITMAX2, NMINOR)
      EQUIVALENCE  (LDBGLS, MNRDBG), (LDBGNP, MJRDBG), (MSGLS , MSGQP )

      INTRINSIC          ABS    , LEN    , MAX   , MOD   , REAL
      PARAMETER        ( ZERO   =  0.0D+0, ONE    =  1.0D+0 )
      PARAMETER        ( POINT3 =  3.3D-1, POINT8 =  0.8D+0 )
      PARAMETER        ( POINT9 =  0.9D+0                   )
      PARAMETER        ( TWO    =  2.0D+0, TEN    = 10.0D+0 )
      PARAMETER        ( TENP6  =  1.0D+6, HUNDRD = 10.0D+1 )
      PARAMETER        ( RDUMMY = -11111., IDUMMY = -11111  )
      PARAMETER        ( GIGANT =  1.0D+20*.99999           )
      PARAMETER        ( WRKTOL =  1.0D-2                   )

      CHARACTER*4        ICRSH(0:2)
      CHARACTER*16       KEY
      DATA                ICRSH(0),  ICRSH(1),  ICRSH(2)
     $                 / 'COLD'   , 'WARM'   , 'HOT '    /

      EPSMCH = WMACH( 3)
      NOUT   = WMACH(11)

      CONDBD = MAX ( ONE/(HUNDRD*EPSMCH*REAL(N)), TENP6 )

      NCQP   = NCLIN + NCNLN
      NPLIN  = N     + NCLIN
      NCTOTL = NPLIN + NCNLN

*     Make a dummy call NPKEY to ensure that the defaults are set.

      CALL NPKEY ( NOUT, '*', KEY )
      NEWOPT = .TRUE.

*     Save the optional parameters set by the user.  The values in
*     IPRMLS, RPRMLS, IPRMNP and RPRMNP may be changed to their
*     default values.

      CALL ICOPY ( MXPARM, IPRMLS, 1, IPSVLS, 1 )
      CALL DCOPY ( MXPARM, RPRMLS, 1, RPSVLS, 1 )
      CALL ICOPY ( MXPARM, IPRMNP, 1, IPSVNP, 1 )
      CALL DCOPY ( MXPARM, RPRMNP, 1, RPSVNP, 1 )

      IF (          LCRASH .LT. 0
     $    .OR.      LCRASH .GT. 2     )   LCRASH  =  0
      IF (          LVLDER .LT. 0
     $    .OR.      LVLDER .GT. 3     )   LVLDER  =  3
      IF (          LFORMH .LT. 0
     $    .OR.      LFORMH .GT. 1     )   LFORMH  =  0

      IF (          NMAJOR .LT. 0     )   NMAJOR  = MAX(50, 3*NPLIN+
     $                                                     10*NCNLN )
      IF (          NMINOR .LT. 1     )   NMINOR  = MAX(50, 3*NCTOTL)
      IF (          MJRDBG .LT. 0     )   MJRDBG  =  0
      IF (          MNRDBG .LT. 0     )   MNRDBG  =  0
      IF (          IDBG   .LT. 0
     $    .OR.      IDBG   .GT. NMAJOR)   IDBG    =  0
      IF (          MJRDBG .EQ. 0
     $    .AND.     MNRDBG .EQ. 0     )   IDBG    = NMAJOR + 1
      IF (          MSGNP  .EQ. IDUMMY)   MSGNP   = 10
      IF (          MSGQP  .EQ. IDUMMY)   MSGQP   =  0
                                          NLNF    =  N
                                          NLNJ    =  N
                                          NLNX    =  N
      IF (          JVRFY2 .LT. 0
     $    .OR.      JVRFY2 .GT. N     )   JVRFY2  =  N
      IF (          JVRFY1 .LT. 0
     $    .OR.      JVRFY1 .GT. JVRFY2)   JVRFY1  =  1
      IF (          JVRFY4 .LT. 0
     $    .OR.      JVRFY4 .GT. N     )   JVRFY4  =  N
      IF (          JVRFY3 .LT. 0
     $    .OR.      JVRFY3 .GT. JVRFY4)   JVRFY3  =  1
      IF (          LVERFY .EQ. IDUMMY
     $    .OR.      LVERFY .GT. 13    )   LVERFY  =  0

      IF (          KSAVE  .LE. 0     )   KSAVE   =  NMAJOR + 1
      IF (          NSAVE  .LT. 0     )   NSAVE   =  0
      IF (          NSAVE  .EQ. 0     )   KSAVE   =  NMAJOR + 1
      IF (          NLOAD  .LT. 0     )   NLOAD   =  0
      IF (          LCRASH .LE. 1     )   NLOAD   =  0
      IF (          NLOAD  .EQ. 0 
     $    .AND.     LCRASH .EQ. 2     )   LCRASH  =  0

      IF (          TOLACT .LT. ZERO
     $    .OR.      TOLACT .GE. ONE   )   TOLACT  =  WRKTOL
      IF (          TOLFEA .LT. EPSMCH
     $    .OR.      TOLFEA .GE. ONE   )   TOLFEA  =  EPSPT5
      IF (          EPSRF  .LT. EPSMCH
     $    .OR.      EPSRF  .GE. ONE   )   EPSRF   =  EPSPT9
                                          LFDSET  =  0
      IF (          FDINT  .LT. ZERO  )   LFDSET  =  2
      IF (          FDINT  .EQ. RDUMMY)   LFDSET  =  0
      IF (          FDINT  .GE. EPSMCH
     $    .AND.     FDINT  .LT. ONE   )   LFDSET  =  1
      IF (          LFDSET .EQ. 1
     $    .AND.    (CDINT  .LT. EPSMCH
     $    .OR.      CDINT  .GE. ONE  ))   CDINT   = EPSRF**POINT3
      IF (          BIGBND .LE. ZERO  )   BIGBND  = GIGANT
      IF (          BIGDX  .LE. ZERO  )   BIGDX   = MAX( GIGANT,BIGBND )
      IF (          DXLIM  .LE. ZERO  )   DXLIM   = TWO
      IF (          ETA    .LT. ZERO
     $    .OR.      ETA    .GE. ONE   )   ETA     = POINT9
      IF (          FTOL   .LT. EPSRF
     $    .OR.      FTOL   .GE. ONE   )   FTOL    = EPSRF**POINT8

      IF (          HCNDBD .LT. ONE   )   HCNDBD  = CONDBD

                                          DCTOL   = EPSPT5
      IF (          LVLDER .LT. 2     )   DCTOL   = EPSPT3
      IF (          CTOL   .LT. EPSMCH
     $    .OR.      CTOL   .GE. ONE   )   CTOL    = DCTOL

      ITMAX1    = MAX( 50, 3*(N + NCLIN + NCNLN) )
      JVERFY(1) = JVRFY1
      JVERFY(2) = JVRFY2
      JVERFY(3) = JVRFY3
      JVERFY(4) = JVRFY4

      NPDBG = IDBG .EQ. 0
      CMDBG = NPDBG

      K     = 1
      MSG1  = MJRDBG
      MSG2  = MNRDBG
      DO 200 I = 1, LDBG
         INPDBG(I) = MOD( MSG1/K, 10 )
         ICMDBG(I) = INPDBG(I)
         ILSDBG(I) = MOD( MSG2/K, 10 )
         K = K*10
  200 CONTINUE

      IF (MSGNP .GT. 0) THEN

*        Print the title.  If no hot start is specified,  the parameters
*        are final and can be printed.

         LENT = LEN( TITLE )
         IF (LENT .GT. 0) THEN
            NSPACE = (81 - LENT)/2 + 1
            WRITE (NOUT, '(///// (80A1) )')
     $         (' ', J=1, NSPACE), (TITLE(J:J), J=1,LENT)
            WRITE (NOUT, '(80A1 //)')
     $         (' ', J=1, NSPACE), ('='       , J=1,LENT)
         END IF


         IF (LCRASH .LE. 1) THEN
            WRITE (NOUT, 2000)
            WRITE (NOUT, 2100) NCLIN , TOLFEA, ICRSH(LCRASH) ,
     $                         N     , BIGBND, TOLACT,
     $                         DXLIM , BIGDX
            WRITE (NOUT, 2200) NCNLN , FTOL  , EPSRF ,
     $                         NLNJ  , CTOL  ,
     $                         NLNF  , ETA   ,
     $                         EPSMCH,
     $                         LVLDER, LVERFY
            WRITE (NOUT, 2300) NMAJOR, MSGNP ,
     $                         NMINOR, MSGQP ,
     $                         NLOAD , NSAVE , KSAVE
            
            IF (LVLDER .LT. 3) THEN
               IF      (LFDSET .EQ. 0) THEN
                  WRITE (NOUT, 2400)
               ELSE IF (LFDSET .EQ. 1) THEN
                  WRITE (NOUT, 2401) FDINT, CDINT
               ELSE IF (LFDSET .EQ. 2) THEN
                  WRITE (NOUT, 2402)
               END IF
            END IF
         END IF
      END IF

      RETURN

 2000 FORMAT(
     $//' Parameters'
     $/ ' ----------' )
 2100 FORMAT(
     $/ ' Linear constraints.....', I10,     6X,
     $  ' Linear feasibility.....', 1PE10.2, 6X,
     $  1X, A4, ' start.............'
     $/ ' Variables..............', I10,     6X,
     $  ' Infinite bound size....', 1PE10.2, 6X,
     $  ' Crash tolerance........', 1PE10.2
     $/ ' Step limit.............', 1PE10.2, 6X,
     $  ' Infinite step size.....', 1PE10.2  )
 2200 FORMAT(
     $/ ' Nonlinear constraints..', I10,     6X,
     $  ' Optimality tolerance...', 1PE10.2, 6X,
     $  ' Function precision.....', 1PE10.2
     $/ ' Nonlinear Jacobian vars', I10,     6X,
     $  ' Nonlinear feasibility..', 1PE10.2
     $/ ' Nonlinear objectiv vars', I10,     6X,
     $  ' Linesearch tolerance...', 1PE10.2
     $/ ' EPS (machine precision)', 1PE10.2, 6X,
     $  ' Derivative level.......', I10,     6X,
     $  ' Verify level...........', I10)
 2300 FORMAT(
     $/ ' Major iterations limit.', I10, 6X,
     $  ' Major print level......', I10
     $/ ' Minor iterations limit.', I10, 6X,
     $  ' Minor print level......', I10
     $/ ' RUN loaded from file...', I10, 6X,
     $  ' RUN to be saved on file', I10, 6X,
     $  ' Save frequency.........', I10)

 2400 FORMAT(/ ' Difference intervals to be computed.' )
 2401 FORMAT(/ ' Difference interval....', 1PE10.2, 6X,
     $         ' Central diffce interval', 1PE10.2 )
 2402 FORMAT(/ ' User-supplied difference intervals.' )

*     End of  NPDFLT.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPFD  ( CENTRL, INFORM,
     $                   LDCJ, LDCJU, N, NCNLN,
     $                   BIGBND, CDINT, FDINT, FDNORM, OBJF,
     $                   CONFUN, OBJFUN, NEEDC,
     $                   BL, BU, C, C1, C2, CJAC, CJACU,
     $                   GRAD, GRADU, HFORWD, HCNTRL, X,
     $                   W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            CENTRL
      INTEGER            NEEDC(*)

      DOUBLE PRECISION   BL(N), BU(N), C(*), C1(*), C2(*),
     $                   CJAC(LDCJ,*), CJACU(LDCJU,*)
      DOUBLE PRECISION   GRAD(N), GRADU(N), HFORWD(N), HCNTRL(N), X(N)
      DOUBLE PRECISION   W(LENW)
      EXTERNAL           CONFUN, OBJFUN

************************************************************************
*     NPFD   evaluates any missing gradients.
*
*     Systems Optimization Laboratory, Stanford University, California.
*     Original version written 3-July-1986.
*     This version of NPFD   dated 14-July-1986.
************************************************************************

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9

      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      INTRINSIC          ABS   , MAX

      PARAMETER         (RDUMMY=-11111.0)
      PARAMETER         (ZERO  = 0.0D+0, HALF  = 0.5D+0, ONE   = 1.0D+0)
      PARAMETER         (TWO   = 2.0D+0, THREE = 3.0D+0, FOUR  = 4.0D+0)

      INFORM = 0

*     ==================================================================
*     Use the pre-assigned difference intervals to approximate the
*     derivatives.
*     ==================================================================
*     Use either the same interval for each component (LFDSET = 1),
*     or the intervals already in HFORWD or HCNTRL (LFDSET = 0 or 2).

      NSTATE =   0
      MODE   =   0

      BIGLOW = - BIGBND
      BIGUPP =   BIGBND

      FDNORM =   ZERO

      DO 340 J  = 1, N

         XJ     = X(J)
         NFOUND = 0
         IF (NCDIFF .GT. 0) THEN
            DO 310 I = 1, NCNLN
               IF (CJACU(I,J) .EQ. RDUMMY) THEN
                  NEEDC(I) = 1
                  NFOUND   = NFOUND + 1
               ELSE
                  NEEDC(I) = 0
               END IF
  310       CONTINUE
         END IF

         IF (NFOUND .GT. 0  .OR.  GRADU(J) .EQ. RDUMMY) THEN
            STEPBL = BIGLOW
            STEPBU = BIGUPP
            IF (BL(J) .GT. BIGLOW) STEPBL = BL(J) - XJ
            IF (BU(J) .LT. BIGUPP) STEPBU = BU(J) - XJ

            IF (CENTRL) THEN
               IF (LFDSET .EQ. 1) THEN
                  DELTA = CDINT
               ELSE
                  DELTA = HCNTRL(J)
               END IF
            ELSE
               IF (LFDSET .EQ. 1) THEN
                  DELTA = FDINT
               ELSE
                  DELTA = HFORWD(J)
               END IF
            END IF

            DELTA  = DELTA*(ONE + ABS(XJ))
            FDNORM = MAX (FDNORM, DELTA)
            IF (HALF*(STEPBL + STEPBU) .LT. ZERO) DELTA =  - DELTA

            X(J) = XJ + DELTA
            IF (NFOUND .GT. 0) THEN
               CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                      NEEDC, X, C1, CJACU, NSTATE )
               IF (MODE .LT. 0) GO TO 999
            END IF

            IF (GRADU(J) .EQ. RDUMMY) THEN
               CALL OBJFUN( MODE, N, X, OBJF1, GRADU, NSTATE )
               IF (MODE .LT. 0) GO TO 999
            END IF

            IF (CENTRL) THEN
*              ---------------------------------------------------------
*              Central differences.
*              ---------------------------------------------------------
               X(J)  = XJ + DELTA + DELTA

               IF (NFOUND .GT. 0) THEN
                  CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                         NEEDC, X, C2, CJACU, NSTATE )
                  IF (MODE .LT. 0) GO TO 999

                  DO 320 I = 1, NCNLN
                     IF (NEEDC(I) .EQ. 1)
     $                  CJAC(I,J) = (FOUR*C1(I) - THREE*C(I) - C2(I))
     $                                  / (DELTA + DELTA)
  320             CONTINUE
               END IF

               IF (GRADU(J) .EQ. RDUMMY) THEN
                  CALL OBJFUN( MODE, N, X, OBJF2, GRADU, NSTATE )
                  IF (MODE .LT. 0) GO TO 999

                  GRAD(J) = (FOUR*OBJF1 - THREE*OBJF - OBJF2)
     $                                  / (DELTA + DELTA)

               END IF
            ELSE
*              ---------------------------------------------------------
*              Forward Differences.
*              ---------------------------------------------------------
               IF (NFOUND .GT. 0) THEN
                  DO 330 I = 1, NCNLN
                     IF (NEEDC(I) .EQ. 1)
     $                  CJAC(I,J) = (C1(I) -  C(I))/  DELTA
  330             CONTINUE
               END IF

               IF (GRADU(J) .EQ. RDUMMY)
     $            GRAD(J) = (OBJF1 - OBJF) /  DELTA

            END IF
         END IF
         X(J) = XJ

  340 CONTINUE

      RETURN

  999 INFORM = MODE
      RETURN

*     End of  NPFD  .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPFEAS( N, NCLIN, NCNLN, ISTATE,
     $                   BIGBND, CVNORM, ERRMAX, JMAX, NVIOL,
     $                   AX, BL, BU, C, FEATOL, X, WORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      INTEGER            ISTATE(N+NCLIN+NCNLN)
      DOUBLE PRECISION   AX(*), BL(N+NCLIN+NCNLN), BU(N+NCLIN+NCNLN)
      DOUBLE PRECISION   C(*), FEATOL(N+NCLIN+NCNLN), X(N)
      DOUBLE PRECISION   WORK(N+NCLIN+NCNLN)
************************************************************************
*     NPFEAS  computes the following...
*     (1)  The number of constraints that are violated by more
*          than  FEATOL  and the 2-norm of the constraint violations.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version      April    1984.
*     This version of  NPFEAS  dated  16-October-1985.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            NPDBG
      PARAMETER        ( LDBG = 5 )
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      EXTERNAL           IDAMAX, DNRM2
      INTRINSIC          ABS
      PARAMETER        ( ZERO = 0.0D+0 )

      BIGLOW = - BIGBND
      BIGUPP =   BIGBND

*     ==================================================================
*     Compute NVIOL, the number of constraints violated by more than
*     FEATOL,  and CVNORM,  the 2-norm of the constraint
*     violations and residuals of the constraints in the QP working set.
*     ==================================================================
      NVIOL  = 0

      DO 200 J = 1, N+NCLIN+NCNLN
         FEASJ  = FEATOL(J)
         RES    = ZERO

         IF (J .LE. N + NCLIN) THEN

*           Bound or general linear constraint.

            IF (J .LE. N) THEN
               CON =  X(J)
            ELSE
               CON = AX(J-N)
            END IF

            TOLJ   = FEASJ
         ELSE

*           Nonlinear constraint.

            CON    = C(J-N-NCLIN)
            TOLJ   = ZERO
         END IF

*        Check for constraint violations.

         IF (BL(J) .GT. BIGLOW) THEN
            RES    = BL(J) - CON
            IF (RES .GT.   FEASJ ) NVIOL = NVIOL + 1
            IF (RES .GT.    TOLJ ) GO TO 190
         END IF

         IF (BU(J) .LT. BIGUPP) THEN
            RES    = BU(J) - CON
            IF (RES .LT. (-FEASJ)) NVIOL = NVIOL + 1
            IF (RES .LT.  (-TOLJ)) GO TO 190
         END IF

*        This constraint is satisfied,  but count the residual as a
*        violation if the constraint is in the working set.

         IS     = ISTATE(J)

         IF (IS .EQ. 0) THEN
            RES = ZERO
         ELSE IF (IS .EQ. 1  .OR.  IS .LE. -2) THEN
            RES = BL(J) - CON
         ELSE IF (IS .GE. 2  .OR.  IS .EQ. -1) THEN
            RES = BU(J) - CON
         END IF

         IF (ABS( RES ) .GT. FEASJ) NVIOL = NVIOL + 1

*        Set the array of violations.

  190    WORK(J) = RES
  200 CONTINUE

      JMAX   = IDAMAX( N+NCLIN+NCNLN, WORK, 1 )
      ERRMAX = ABS ( WORK(JMAX) )

      IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $   WRITE (NOUT, 1000) ERRMAX, JMAX

      CVNORM = DNRM2 ( N+NCLIN+NCNLN, WORK, 1 )

      RETURN

 1000 FORMAT(/ ' //NPFEAS//  The maximum violation is ', 1PE14.2,
     $                     ' in constraint', I5 )

*     End of  NPFEAS.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPFILE( IOPTNS, INFORM )
      INTEGER            IOPTNS, INFORM

************************************************************************
*     NPFILE  reads the options file from unit  IOPTNS  and loads the
*     options into the relevant elements of  IPRMNP  and  RPRMNP.
*
*     If  IOPTNS .lt. 0  or  IOPTNS .gt. 99  then no file is read,
*     otherwise the file associated with unit  IOPTNS  is read.
*
*     Output:
*
*         INFORM = 0  if a complete  OPTIONS  file was found
*                     (starting with  BEGIN  and ending with  END);
*                  1  if  IOPTNS .lt. 0  or  IOPTNS .gt. 99;
*                  2  if  BEGIN  was found, but end-of-file
*                     occurred before  END  was found;
*                  3  if end-of-file occurred before  BEGIN  or
*                     ENDRUN  were found;
*                  4  if  ENDRUN  was found before  BEGIN.
************************************************************************
      LOGICAL             NEWOPT
      COMMON     /SOL7NP/ NEWOPT
      SAVE       /SOL7NP/

      DOUBLE PRECISION    WMACH(15)
      COMMON     /SOLMCH/ WMACH
      SAVE       /SOLMCH/

      EXTERNAL            MCHPAR, NPKEY
      LOGICAL             FIRST
      SAVE                FIRST , NOUT
      DATA                FIRST /.TRUE./

*     If first time in, set  NOUT.
*     NEWOPT is true first time into NPFILE or NPOPTN
*     and just after a call to NPSOL.

      IF (FIRST) THEN
         FIRST  = .FALSE.
         NEWOPT = .TRUE.
         CALL MCHPAR()
         NOUT = WMACH(11)
      END IF

      CALL OPFILE( IOPTNS, NOUT, INFORM, NPKEY )

      RETURN

*     End of  NPFILE.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPGETR( INFORM, UNITQ, N, NCLIN, NCNLN, LDR, LDZY,
     $                   NFREE, ITER, ISTATE, KX,
     $                   HFORWD, HCNTRL,
     $                   CMUL, R, RHO, X, ZY )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            ISTATE(N+NCLIN+NCNLN), KX(N)
      DOUBLE PRECISION   R(LDR,*), X(N), ZY(LDZY,*)
      DOUBLE PRECISION   HFORWD(*), HCNTRL(*)
      DOUBLE PRECISION   CMUL(*), RHO(*)

C***********************************************************************
C     NPGETR  loads details of a previous run from unit NLOAD.
C
C     Original version   24-Nov-89.
C     This version of  NPGETR  dated 26-Nov-89.
C***********************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET
      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
*-----INCLUDE NPPARM----------------------------------------------------
      INTEGER            IPRMNP(MXPARM), IPSVNP
      DOUBLE PRECISION   RPRMNP(MXPARM), RPSVNP

      COMMON    /NPPAR1/ IPSVNP(MXPARM),
     $                   IDBGNP, ITMXNP, JVRFY1, JVRFY2, JVRFY3, JVRFY4,
     $                   LDBGNP, LFORMH, LVLDER, LVERFY, MSGNP , NLNF  ,
     $                   NLNJ  , NLNX  , NNCNLN, NSAVE , NLOAD , KSAVE ,
     $                   IPADNP(12)

      COMMON    /NPPAR2/ RPSVNP(MXPARM),
     $                   CDINT , CTOL  , DXLIM , EPSRF , ETA   , FDINT ,
     $                   FTOL  , HCNDBD, RPADNP(22)

      EQUIVALENCE       (IPRMNP(1), IDBGNP), (RPRMNP(1), CDINT)

      SAVE      /NPPAR1/, /NPPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE  (IDBGNP, IDBG  ), (ITMXNP, NMAJOR), (ITMAX2, NMINOR)
      EQUIVALENCE  (LDBGLS, MNRDBG), (LDBGNP, MJRDBG), (MSGLS , MSGQP )

      CHARACTER*4        ICRSH(0:2)
      DATA                ICRSH(0),  ICRSH(1),  ICRSH(2)
     $                 / 'COLD'   , 'WARM'   , 'HOT '    /

      IF (NLOAD .LE. 0) RETURN

      WRITE( NOUT , 4000 ) NLOAD

      READ ( NLOAD, 1000, END=999 ) ITER, NFREE, LFDSET, LVLDIF, UNITQ
      DO 110, J = 1, N
         READ ( NLOAD, 1010, END=999 ) JOLD, KX(J), ISTATE(J), X(J)
  110 CONTINUE

      IF (JOLD .NE. N) THEN
         WRITE( NOUT, 9000 )
         INFORM = 1
         RETURN
      END IF

      DO 120, J = N+1, N+NCLIN
         READ ( NLOAD, 1020, END=999 ) JOLD, ISTATE(J)
  120 CONTINUE

      IF (JOLD .NE. N+NCLIN) THEN
         WRITE( NOUT, 9000 )
         INFORM = 1
         RETURN
      END IF

      IF (NCNLN .GT. 0) THEN
         K = 1
         DO 130, J = N+NCLIN+1, N+NCLIN+NCNLN
            READ( NLOAD, 1030, END=999 ) JOLD, ISTATE(J), CMUL(K),
     $                                   RHO(K)
            K = K + 1
  130    CONTINUE

         IF (JOLD .NE. N+NCLIN+NCNLN) THEN
            WRITE( NOUT, 9000 )
            INFORM = 1
            RETURN
         END IF
     
         READ( NLOAD, 1040, END=999 ) RHOMAX, RHONRM, RHODMP, SCALE,
     $                                INCRUN
      END IF

*     ------------------------------------------------------------------
*     Read   Q(free)  and the factor of  Q'HQ.
*     ------------------------------------------------------------------
      IF (.NOT. UNITQ) THEN
         DO 160, J = 1, NFREE
            DO 150, I = 1, NFREE
              READ( NLOAD, 1050, END=999 ) IOLD, JOLD, ZY(I,J)
  150       CONTINUE     
  160    CONTINUE
      END IF 

      DO 180, J = 1, N
         DO 170, I = 1, J
           READ ( NLOAD, 1050, END=999 ) IOLD, JOLD, R(I,J)
  170    CONTINUE
  180 CONTINUE

      IF (JOLD .NE. N  .OR. IOLD .NE. N) THEN
         WRITE( NOUT, 9000 )
         INFORM = 1
         RETURN
      END IF

*     ------------------------------------------------------------------
*     Read the finite-difference intervals.  
*     ------------------------------------------------------------------
      IF (LVLDIF .GT. 0) THEN
         IF (LFDSET .EQ. 0  .OR.  LFDSET .EQ. 2) THEN
            DO 190, J = 1, N
               READ( NLOAD, 1090 ) JOLD, HFORWD(J), HCNTRL(J)
  190       CONTINUE
         END IF
      END IF                                            

      WRITE ( NOUT , 4010 ) N, ITER

      CALL MCCLOS( NLOAD )

*     ------------------------------------------------------------------
*     Now that all values have been set, we can print the parameters.
*     ------------------------------------------------------------------
      IF (MSGNP .GT. 0) THEN
         EPSMCH = WMACH( 3)
         WRITE (NOUT, 2000)
         WRITE (NOUT, 2100) NCLIN , TOLFEA, ICRSH(LCRASH) ,
     $                      N     , BIGBND, TOLACT,
     $                      DXLIM , BIGDX
         WRITE (NOUT, 2200) NCNLN , FTOL  , EPSRF ,
     $                      NLNJ  , CTOL  ,
     $                      NLNF  , ETA   ,
     $                      EPSMCH,
     $                      LVLDER, LVERFY
         WRITE (NOUT, 2300) NMAJOR, MSGNP ,
     $                      NMINOR, MSGQP ,
     $                      NLOAD , NSAVE , KSAVE

         IF (LVLDER .LT. 3) THEN
            IF      (LFDSET .EQ. 0) THEN
               WRITE (NOUT, 2400)
            ELSE IF (LFDSET .EQ. 1) THEN
               WRITE (NOUT, 2401) FDINT, CDINT
            ELSE IF (LFDSET .EQ. 2) THEN
               WRITE (NOUT, 2402)
            END IF
         END IF

      END IF

      RETURN
                       
 999  WRITE( NOUT, 9000 )
      INFORM = 1 
      RETURN

 1000 FORMAT(2I8, 1X, 2I2, 1X, L1 )
 1010 FORMAT(2I8, 1X,  I2, 1P, 2E24.14 )
 1020 FORMAT( I8, 1X,  I2 )
 1030 FORMAT( I8, 1X,  I2, 1P, 2E24.14 )
 1040 FORMAT( 1P, 4E24.14, 1X, L1 )
 1050 FORMAT(2I8, 1X, 1P,  E24.14 )
 1090 FORMAT( I8, 1X, 1P, 2E24.14 )

 2000 FORMAT(
     $//' Parameters'
     $/ ' ----------' )
 2100 FORMAT(
     $/ ' Linear constraints.....', I10,     6X,
     $  ' Linear feasibility.....', 1PE10.2, 6X,
     $  1X, A4, ' start.............'
     $/ ' Variables..............', I10,     6X,
     $  ' Infinite bound size....', 1PE10.2, 6X,
     $  ' Crash tolerance........', 1PE10.2
     $/ ' Step limit.............', 1PE10.2, 6X,
     $  ' Infinite step size.....', 1PE10.2  )
 2200 FORMAT(
     $/ ' Nonlinear constraints..', I10,     6X,
     $  ' Optimality tolerance...', 1PE10.2, 6X,
     $  ' Function precision.....', 1PE10.2
     $/ ' Nonlinear Jacobian vars', I10,     6X,
     $  ' Nonlinear feasibility..', 1PE10.2
     $/ ' Nonlinear objectiv vars', I10,     6X,
     $  ' Linesearch tolerance...', 1PE10.2
     $/ ' EPS (machine precision)', 1PE10.2, 6X,
     $  ' Derivative level.......', I10,     6X,
     $  ' Verify level...........', I10)
 2300 FORMAT(
     $/ ' Major iterations limit.', I10, 6X,
     $  ' Major print level......', I10
     $/ ' Minor iterations limit.', I10, 6X,
     $  ' Minor print level......', I10
     $/ ' RUN loaded from file...', I10, 6X,
     $  ' RUN to be saved on file', I10, 6X,
     $  ' Save frequency.........', I10)

 2400 FORMAT(/ ' Difference intervals to be computed.' )
 2401 FORMAT(/ ' Difference interval....', 1PE10.2, 6X,
     $         ' Central diffce interval', 1PE10.2 )
 2402 FORMAT(/ ' User-supplied difference intervals.' )
 4000 FORMAT(/ ' OLD RUN to be loaded from file', I4)
 4010 FORMAT(/ ' Number of variables loaded = ', I5, '    Itn = ', I8)
 9000 FORMAT(/ ' Exit NPSOL - The OLD RUN file dimensions do not match'
     $        ,'  this problem.' )

*     End of  NPGETR.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPIQP ( FEASQP, UNITQ, NQPERR, MINITS,
     $                   N, NCLIN, NCNLN, LDA, LDCJ, LDAQP, LDR,
     $                   LINACT, NLNACT, NACTIV, NFREE, NZ, NUMINF,
     $                   ISTATE, KACTIV, KX,
     $                   DXNORM, GDX, QPCURV,
     $                   AQP, ADX, ANORM, AX, BL, BU,
     $                   C, CJAC, CLAMDA, CMUL, CS,
     $                   DLAM, DSLK, DX, QPBL, QPBU, QPTOL,
     $                   R, RHO, SLK, VIOLN, X,
     $                   WTINF, IW, W )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            FEASQP, UNITQ
      INTEGER            ISTATE(*), KACTIV(N), KX(N)
      INTEGER            IW(*)
      DOUBLE PRECISION   AQP(LDAQP,*), ADX(*), ANORM(*), AX(*),
     $                   BL(*), BU(*),
     $                   C(*), CJAC(LDCJ,*), CLAMDA(*), CMUL(*), CS(*)
      DOUBLE PRECISION   DLAM(*), DSLK(*), DX(N)
      DOUBLE PRECISION   QPBL(*), QPBU(*),
     $                   QPTOL(*), R(LDR,*), RHO(*), SLK(*),
     $                   VIOLN(*), X(N), WTINF(*)
      DOUBLE PRECISION   W(*)

************************************************************************
*     NPIQP   does the following:
*
*     (1)  Generate the upper and lower bounds for the QP  subproblem.
*
*     (2)  Compute the  TQ  factors of the rows of  AQP  specified by
*          the array  ISTATE.  The part of the factorization defined by
*          the first contiguous group of linear constraints does not
*          need to be recomputed.  The remaining rows (which could be
*          comprised of both linear and nonlinear constraints) are
*          included as new rows of the  TQ  factorization stored in
*          T and ZY.  Note that if there are no nonlinear constraints,
*          no factorization is required.
*
*     (3)  Solve the  QP  subproblem.
*                 minimize     1/2 (W p - d)'(Wp - d) + g'p
*
*                 subject to   qpbl .le. (  p ) .le. qpbu,
*                                        ( Ap )
*
*          where  W  is a matrix (not stored) such that  W'W = H  and
*          WQ = R,  d  is the zero vector,  and  g  is the gradient.
*          If the subproblem is infeasible, compute the point which
*          minimizes the sum of infeasibilities.
*
*    (4)   Find the value of each slack variable for which the merit
*          function is minimized.
*
*    (5)   Compute  DSLK,  DLAM  and  DX,  the search directions for
*          the slack variables, the multipliers and the variables.
*
*     Systems Optimization Laboratory, Stanford University.
*     Fortran 66 version written 10-January-1983.
*     This version of NPIQP dated 10-May-90.
************************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL3CM/ LENNAM, LDT   , NCOLT , LDZY
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
      COMMON    /SOL5CM/ ASIZE , DTMAX , DTMIN
      COMMON    /SOL6CM/ RCNDBD, RFROBN, DRMAX , DRMIN
      
      INTEGER            LOCLS
      PARAMETER         (LENLS = 20)
      COMMON    /SOL1LS/ LOCLS(LENLS)

      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      LOGICAL            CMDBG, LSDBG, NPDBG
      PARAMETER        ( LDBG = 5 )
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG
      COMMON    /CMDEBG/ ICMDBG(LDBG), CMDBG

*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
*-----INCLUDE NPPARM----------------------------------------------------
      INTEGER            IPRMNP(MXPARM), IPSVNP
      DOUBLE PRECISION   RPRMNP(MXPARM), RPSVNP

      COMMON    /NPPAR1/ IPSVNP(MXPARM),
     $                   IDBGNP, ITMXNP, JVRFY1, JVRFY2, JVRFY3, JVRFY4,
     $                   LDBGNP, LFORMH, LVLDER, LVERFY, MSGNP , NLNF  ,
     $                   NLNJ  , NLNX  , NNCNLN, NSAVE , NLOAD , KSAVE ,
     $                   IPADNP(12)

      COMMON    /NPPAR2/ RPSVNP(MXPARM),
     $                   CDINT , CTOL  , DXLIM , EPSRF , ETA   , FDINT ,
     $                   FTOL  , HCNDBD, RPADNP(22)

      EQUIVALENCE       (IPRMNP(1), IDBGNP), (RPRMNP(1), CDINT)

      SAVE      /NPPAR1/, /NPPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE  (IDBGNP, IDBG  ), (ITMXNP, NMAJOR), (ITMAX2, NMINOR)
      EQUIVALENCE  (LDBGLS, MNRDBG), (LDBGNP, MJRDBG), (MSGLS , MSGQP )

      CHARACTER*8        NAMES(1)
      LOGICAL            LINOBJ, OVERFL, QPNAMD, VERTEX
      INTRINSIC          ABS   , MIN   , MAX
      EXTERNAL           DDIV  , DDOT  , DNRM2
      PARAMETER        ( QPNAMD =.FALSE.,VERTEX =.FALSE. )
      PARAMETER        ( ZERO   =0.0D+0, ONE    =1.0D+0, TWO   =2.0D+0 )
      PARAMETER        ( HUNDRD =1.0D+2                                )

      IDBGSV = IDBG
      IF (NPDBG) THEN
         IDBG   = 0
      ELSE
         IDBG = NMINOR + 1
      END IF
      LSDBG  = NPDBG
      CMDBG  = NPDBG
      CALL ICOPY ( LDBG, ILSDBG, 1, ICMDBG, 1 )

      LRPQ   = LOCLS( 5)
      LRPQ0  = LOCLS( 6)
      LHPQ   = LOCLS( 8)
      LGQ    = LOCLS( 9)
      LRLAM  = LOCLS(10)
      LT     = LOCLS(11)
      LZY    = LOCLS(12)
      LWRK1  = LOCLS(14)

      NRPQ   = 0
      NGQ    = 1

      FEASQP =  .TRUE.
      LINOBJ =  .TRUE.

      BIGLOW = - BIGBND
      BIGUPP =   BIGBND
      SSQ1   =   ZERO

      NPLIN  = N     + NCLIN
      NCTOTL = NPLIN + NCNLN
      NCQP   = NCLIN + NCNLN
      NRANK  = N
      NREJTD = 0                           

*     ==================================================================
*     Generate the upper and lower bounds upon the search direction, the
*     weights on the sum of infeasibilities and the nonlinear constraint
*     violations.
*     ==================================================================
      WSCALE = - ONE
      DO 170 J = 1, NCTOTL

         IF (J .LE. N) THEN                
            CON = X(J)
         ELSE IF (J .LE. NPLIN) THEN
            CON = AX(J-N)
         ELSE
            CON = C(J-NPLIN)
         END IF

         BLJ = BL(J)
         BUJ = BU(J)
         IF (BLJ .GT. BIGLOW) BLJ = BLJ - CON
         IF (BUJ .LT. BIGUPP) BUJ = BUJ - CON

         WEIGHT = ONE
         IF (J .LE. NPLIN) THEN
            IF (ABS(BLJ) .LE. QPTOL(J)) BLJ = ZERO
            IF (ABS(BUJ) .LE. QPTOL(J)) BUJ = ZERO
         ELSE
            I    = J - NPLIN
            VIOL = ZERO
            IF (BL(J) .GT. BIGLOW) THEN
               IF (BLJ .GT. ZERO) THEN
                  VIOL   = BLJ
                  IF (RHO(I) .GT. ZERO) THEN
                     WEIGHT =   VIOL*RHO(I)
                  ELSE
                     WEIGHT =   VIOL
                  END IF
                  WSCALE = MAX( WSCALE,   WEIGHT )
                  GO TO 160
               END IF
            END IF

            IF (BU(J) .LT. BIGUPP) THEN
               IF (BUJ .LT. ZERO) THEN
                  VIOL   =   BUJ
                  IF (RHO(I) .GT. ZERO) THEN
                     WEIGHT = - VIOL*RHO(I)
                  ELSE
                     WEIGHT = - VIOL
                  END IF
                  WSCALE = MAX( WSCALE, WEIGHT )
               END IF
            END IF

*           Set the vector of nonlinear constraint violations.

  160       VIOLN(I) = VIOL
         END IF

         WTINF(J) = WEIGHT
         QPBL(J)  = BLJ
         QPBU(J)  = BUJ
  170 CONTINUE

      IF (WSCALE .GT. ZERO) THEN
         WSCALE = ONE/WSCALE
         CALL DSCAL ( NCTOTL, (WSCALE), WTINF, 1 )
      END IF

      CALL DCOND ( NCTOTL, WTINF, 1, WTMAX, WTMIN )
      WTMIN  = EPSPT9*WTMAX
      DO 180, J = 1, NCTOTL
         WTINF(J) = MAX( WTINF(J), WTMIN )
  180 CONTINUE

*     Set the maximum allowable condition estimator of the constraints
*     in the working set.  Note that a relatively well-conditioned
*     working set is used to start the QP iterations.

      CONDMX = MAX( ONE/EPSPT3, HUNDRD )

      IF (NCNLN .GT. 0) THEN
*        ===============================================================
*        Refactorize part of the  QP  constraint matrix.
*        ===============================================================
*        Load the new Jacobian into the  QP  matrix  A.  Compute the
*        2-norms of the rows of the Jacobian.

         CALL F06QFF( 'General', NCNLN, N, CJAC, LDCJ,
     $                AQP(NCLIN+1,1), LDAQP )

         DO 190 J = NCLIN+1, NCQP
            ANORM(J) = DNRM2 ( N, AQP(J,1), LDAQP )
  190    CONTINUE

*        Count the number of linear constraints in the working set and
*        move them to the front of KACTIV.  Compute the norm of the
*        matrix of constraints in the working set.
*        Let K1  point to the first nonlinear constraint.  Constraints
*        with indices KACTIV(K1),..., KACTIV(NACTIV)  must be
*        refactorized.

         ASIZE  = ZERO
         LINACT = 0
         K1     = NACTIV + 1
         DO 200 K = 1, NACTIV
            I     = KACTIV(K)
            ASIZE = MAX( ASIZE, ANORM(I) )

            IF (I .LE. NCLIN) THEN
               LINACT = LINACT + 1
               IF (LINACT .NE. K) THEN
                  ISWAP  = KACTIV(LINACT)
                  KACTIV(LINACT) = I
                  KACTIV(K)      = ISWAP
               END IF
            ELSE

*              Record the old position of the 1st. nonlinear constraint.

               IF (K1 .GT. NACTIV) K1 = K
            END IF
  200    CONTINUE

         IF (NACTIV .LE. 1 )
     $      CALL DCOND ( NCQP, ANORM, 1, ASIZE, AMIN )

*        Compute the absolute values of the nonlinear constraints in
*        the working set.  Use DX as workspace.

         DO 210 K = LINACT+1, NACTIV
            J = N + KACTIV(K)
            IF (ISTATE(J) .EQ. 1) DX(K) = ABS( QPBL(J) )
            IF (ISTATE(J) .GE. 2) DX(K) = ABS( QPBU(J) )
  210    CONTINUE

*        Sort the elements of KACTIV corresponding to nonlinear
*        constraints in descending order of violation (i.e.,
*        the first element of KACTIV for a nonlinear constraint
*        is associated with the most violated constraint.)
*        In this way, the rows of the Jacobian corresponding
*        to the more violated constraints tend to be included
*        in the  TQ  factorization.

*        The sorting procedure is taken from the simple insertion
*        sort in D. Knuth, ACP Volume 3, Sorting and Searching,
*        Page 81.  It should be replaced by a faster sort if the
*        number of active nonlinear constraints becomes large.

         DO 230 K = LINACT+2, NACTIV
            L     = K
            VIOL  = DX(L)
            KVIOL = KACTIV(L)
*           WHILE (L .GT. LINACT+1  .AND.  DX(L-1) .LT. VIOL) DO
  220       IF    (L .GT. LINACT+1                          ) THEN
               IF (                        DX(L-1) .LT. VIOL) THEN
                  DX(L)     = DX(L-1)
                  KACTIV(L) = KACTIV(L-1)
                  L         = L - 1
                  GO TO 220
               END IF
*           END WHILE
            END IF
            DX(L)     = VIOL
            KACTIV(L) = KVIOL
  230    CONTINUE

         K2     = NACTIV
         NACTIV = K1     - 1
         NZ     = NFREE  - NACTIV

*        Update the factors  R,  T  and  Q  to include constraints
*        K1  through  K2.

         IF (K1 .LE. K2)
     $      CALL LSADDS( UNITQ, VERTEX,
     $                   INFORM, K1, K2, NACTIV, NARTIF, NZ, NFREE,
     $                   NRANK, NREJTD, NRPQ, NGQ,
     $                   N, LDZY, LDAQP, LDR, LDT,
     $                   ISTATE, KACTIV, KX, CONDMX,
     $                   AQP, R, W(LT), W(LRPQ), W(LGQ), W(LZY),
     $                   W(LWRK1), DX, W(LRLAM) )
      END IF

*     ==================================================================
*     Solve for DX, the vector of minimum two-norm that satisfies the
*     constraints in the working set.
*     ==================================================================
      CALL NPSETX( UNITQ,
     $             NCQP, NACTIV, NFREE, NZ,
     $             N, NLNX, NCTOTL, LDZY, LDAQP, LDR, LDT,
     $             ISTATE, KACTIV, KX,
     $             DXNORM, GDX,
     $             AQP, ADX, QPBL, QPBU, W(LRPQ), W(LRPQ0), DX, W(LGQ),
     $             R, W(LT), W(LZY), W(LWRK1) )

*     ==================================================================
*     Solve a quadratic program for the search direction  DX  and
*     multiplier estimates  CLAMDA.
*     ==================================================================
*     If there is no feasible point for the subproblem,  the sum of
*     infeasibilities is minimized subject to the linear constraints
*     (1  thru  JINF)  being satisfied.

      JINF  = N + NCLIN

      NTRY  = 1
*+    REPEAT
  450    CALL LSCORE( 'QP subproblem', QPNAMD, NAMES, LINOBJ, UNITQ,
     $                NQPERR, MINITS, JINF, NCQP, NCTOTL,
     $                NACTIV, NFREE, NRANK, NZ, NZ1,
     $                N, LDAQP, LDR,
     $                ISTATE, KACTIV, KX,
     $                GDX, SSQ, SSQ1, SUMINF, NUMINF, DXNORM,
     $                QPBL, QPBU, AQP, CLAMDA, ADX,
     $                QPTOL, R, DX, IW, W )

         IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $      WRITE (NOUT, 8000) NQPERR

         NVIOL = 0
         IF (NUMINF .GT. 0) THEN

*           Count the violated linear constraints.

            DO 460 J = 1, NPLIN
               IF (ISTATE(J) .LT. 0) NVIOL = NVIOL + 1
  460       CONTINUE

            IF (NVIOL .GT. 0) THEN
               NTRY   = NTRY + 1
               UNITQ  = .TRUE.
               NACTIV = 0
               NFREE  = N
               NZ     = N
               CALL ILOAD ( NCTOTL, (0), ISTATE, 1 )

               CALL NPSETX( UNITQ,
     $                      NCQP, NACTIV, NFREE, NZ,
     $                      N, NLNX, NCTOTL, LDZY, LDAQP, LDR, LDT,
     $                      ISTATE, KACTIV, KX,
     $                      DXNORM, GDX,
     $                      AQP, ADX, QPBL, QPBU, W(LRPQ), W(LRPQ0),
     $                      DX, W(LGQ), R, W(LT), W(LZY), W(LWRK1) )
            END IF
         END IF
      IF (.NOT. (NVIOL .EQ. 0  .OR.  NTRY .GT. 2)) GO TO 450
*+    UNTIL (    NVIOL .EQ. 0  .OR.  NTRY .GT. 2)

*     ==================================================================
*     Count the number of nonlinear constraint gradients in the  QP
*     working set.  Make sure that all small  QP  multipliers associated
*     with nonlinear inequality constraints have the correct sign.
*     ==================================================================
      NLNACT  = 0
      IF (NACTIV .GT. 0  .AND.  NCNLN .GT. 0) THEN
         DO 500 K = 1, NACTIV
            L     = KACTIV(K)
            IF (L .GT. NCLIN) THEN
               NLNACT = NLNACT + 1
               J      = N      + L
               IF (ISTATE(J) .EQ. 1) CLAMDA(J) = MAX( ZERO, CLAMDA(J) )
               IF (ISTATE(J) .EQ. 2) CLAMDA(J) = MIN( ZERO, CLAMDA(J) )
            END IF
  500    CONTINUE
      END IF

      LINACT = NACTIV - NLNACT

*     ------------------------------------------------------------------
*     Extract various useful quantities from the QP solution.
*     ------------------------------------------------------------------
*     Compute  HPQ = R'R(pq)  from the transformed gradient of the QP
*     objective function and  R(pq)  from the transformed residual.

      CALL DSCAL ( N, (-ONE), W(LRPQ), 1 )
      CALL DAXPY ( N, (-ONE), W(LGQ) , 1, W(LHPQ), 1 )
      QPCURV = TWO*SSQ

      IF (NCNLN .GT. 0) THEN
         IF (NUMINF .GT. 0) THEN
            FEASQP = .FALSE.
            CALL DLOAD ( NCTOTL, (ZERO), CLAMDA, 1 )

            IF (NZ .GT. 0) THEN
*              ---------------------------------------------------------
*              Compute a null space component for the search direction
*              as the solution of  Z'HZ(pz) = -Z'g - Z'HY(py).
*              ---------------------------------------------------------
*              Overwrite DX with the transformed search direction
*              Q'(dx).  The first NZ components of DX are zero.

               CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ,
     $                      KX, DX, W(LZY), W(LWRK1) )

*              Overwrite the first NZ components of DX with the solution
*              of  (Rz)u = -(v + w),  where  (Rz)'w = Z'g  and  v  is
*              vector of first NZ components of  R(pq).

               CALL DCOPY ( NZ, W(LGQ), 1, DX, 1 )
               CALL DTRSV ( 'U', 'T', 'N', NZ, R, LDR, DX, 1 )

               CALL DAXPY ( NZ, (ONE), W(LRPQ), 1, DX, 1 )

               CALL DTRSV ( 'U', 'N', 'N', NZ, R, LDR, DX, 1 )
               CALL DSCAL ( NZ, (-ONE), DX, 1 )

*              Recompute RPQ, HPQ, GDX and QPCURV.

               CALL DCOPY ( NLNX, DX, 1, W(LRPQ), 1 )
               CALL DTRMV ( 'U', 'N', 'N', NLNX, R, LDR, W(LRPQ), 1 )
               IF (NLNX .LT. N)
     $            CALL DGEMV( 'N', NLNX, N-NLNX, ONE, R(1,NLNX+1), LDR,
     $                        DX(NLNX+1), 1, ONE, W(LRPQ), 1 )

               GDX    = DDOT  ( N, W(LGQ) , 1, DX     , 1 )
               QPCURV = DDOT  ( N, W(LRPQ), 1, W(LRPQ), 1 )

               CALL CMQMUL( 3, N, NZ, NFREE, LDZY, UNITQ,
     $                      KX, DX, W(LZY), W(LWRK1) )

*              ---------------------------------------------------------
*              Recompute ADX and the 2-norm of DX.
*              ---------------------------------------------------------
               DXNORM  = DNRM2 ( N, DX, 1 )
               IF (NCQP .GT. 0)
     $            CALL DGEMV ( 'N', NCQP, N, ONE, AQP, LDAQP,
     $                         DX, 1, ZERO, ADX, 1 )

               IF (NPDBG  .AND.  INPDBG(2) .GT. 0)
     $            WRITE (NOUT, 8100) (DX(J), J = 1, N)
            END IF

            CALL DCOPY ( NLNX, W(LRPQ), 1, W(LHPQ), 1 )
            CALL DTRMV ( 'U', 'T', 'N', NLNX, R, LDR, W(LHPQ), 1 )
            IF (NLNX .LT. N)
     $         CALL DGEMV ( 'T', NLNX, N-NLNX, ONE, R(1,NLNX+1), LDR,
     $                      W(LRPQ), 1, ZERO, W(LHPQ+NLNX), 1 )
         END IF

*        ===============================================================
*        For given values of the objective function and constraints,
*        attempt to minimize the merit function with respect to each
*        slack variable.
*        ===============================================================
         DO 600 I = 1, NCNLN
            J      = NPLIN + I
            CON    = C(I)

            IF (      .NOT. FEASQP  .AND.
     $          VIOLN(I) .NE. ZERO  .AND.  RHO(I) .LE. ZERO )
     $         RHO(I) = ONE

            QUOTNT = DDIV  ( CMUL(I), SCALE*RHO(I), OVERFL )

*           Define the slack variable to be  CON - MULT / RHO.
*           Force each slack to lie within its upper and lower bounds.

            IF (BL(J) .GT. BIGLOW) THEN
               IF (QPBL(J) .GE. - QUOTNT) THEN
                  SLK(I) = BL(J)
                  GO TO 550
               END IF
            END IF

            IF (BU(J) .LT. BIGUPP) THEN
               IF (QPBU(J) .LE. - QUOTNT) THEN
                  SLK(I) = BU(J)
                  GO TO 550
               END IF
            END IF

            SLK(I) = CON - QUOTNT

*           The slack has been set within its bounds.

  550       CS(I)  = CON - SLK(I)

*           ------------------------------------------------------------
*           Compute the search direction for the slacks and multipliers.
*           ------------------------------------------------------------
            DSLK(I) = ADX(NCLIN+I) + CS(I)

            IF (FEASQP) THEN
*
*              If any constraint is such that  (DLAM)*(C - S)  is
*              positive,  the merit function may be reduced immediately
*              by substituting the QP multiplier.
*
               DLAM(I)  = CLAMDA(J) - CMUL(I)
               IF (DLAM(I) * CS(I) .GE. ZERO) THEN
                  CMUL(I) = CLAMDA(J)
                  DLAM(I) = ZERO
               END IF
            ELSE

*              The  QP  subproblem was infeasible.

               DLAM(I) = ZERO

               IF (ISTATE(J) .LT. 0  .OR.  VIOLN(I) .NE. ZERO)
     $            DSLK(I)  = ZERO

            END IF
  600    CONTINUE

         IF (.NOT. FEASQP)
     $      RHONRM = DNRM2 ( NCNLN, RHO, 1 )

         IF (NPDBG  .AND.  INPDBG(2) .GT. 0) THEN
            WRITE (NOUT, 8200) (VIOLN(I), I=1,NCNLN)
            WRITE (NOUT, 8300) (SLK(I)  , I=1,NCNLN)
         END IF
      END IF

      CALL ICOPY ( LDBG, INPDBG, 1, ICMDBG, 1 )
      IDBG   = IDBGSV

      RETURN

 8000 FORMAT(/ ' //NPIQP // NQPERR'
     $       / ' //NPIQP // ',  I6 )
 8100 FORMAT(/ ' //NPIQP // DX recomputed with null space portion...'
     $       / (5G12.3))
 8200 FORMAT(/ ' //NPIQP // Violations = '/ (1P, 5E15.6))
 8300 FORMAT(/ ' //NPIQP // Slacks     = '/ (1P, 5E15.6))

*     End of  NPIQP .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPKEY ( NOUT, BUFFER, KEY )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*(*)      BUFFER

************************************************************************
*     NPKEY   decodes the option contained in  BUFFER  in order to set
*     a parameter value in the relevant element of the parameter arrays.
*
*
*     Input:
*
*     NOUT   A unit number for printing error messages.
*            NOUT  must be a valid unit.
*
*     Output:
*
*     KEY    The first keyword contained in BUFFER.
*
*
*     NPKEY  calls OPNUMB and the subprograms
*                 LOOKUP, SCANNR, TOKENS, UPCASE
*     (now called OPLOOK, OPSCAN, OPTOKN, OPUPPR)
*     supplied by Informatics General, Inc., Palo Alto, California.
*
*     Systems Optimization Laboratory, Stanford University.
*     This version of NPKEY  dated 24-Nov-89.
************************************************************************
*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
*-----INCLUDE NPPARM----------------------------------------------------
      INTEGER            IPRMNP(MXPARM), IPSVNP
      DOUBLE PRECISION   RPRMNP(MXPARM), RPSVNP

      COMMON    /NPPAR1/ IPSVNP(MXPARM),
     $                   IDBGNP, ITMXNP, JVRFY1, JVRFY2, JVRFY3, JVRFY4,
     $                   LDBGNP, LFORMH, LVLDER, LVERFY, MSGNP , NLNF  ,
     $                   NLNJ  , NLNX  , NNCNLN, NSAVE , NLOAD , KSAVE ,
     $                   IPADNP(12)

      COMMON    /NPPAR2/ RPSVNP(MXPARM),
     $                   CDINT , CTOL  , DXLIM , EPSRF , ETA   , FDINT ,
     $                   FTOL  , HCNDBD, RPADNP(22)

      EQUIVALENCE       (IPRMNP(1), IDBGNP), (RPRMNP(1), CDINT)

      SAVE      /NPPAR1/, /NPPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE  (IDBGNP, IDBG  ), (ITMXNP, NMAJOR), (ITMAX2, NMINOR)
      EQUIVALENCE  (LDBGLS, MNRDBG), (LDBGNP, MJRDBG), (MSGLS , MSGQP )

      EXTERNAL           OPNUMB
      LOGICAL            FIRST , MORE  , NUMBER, OPNUMB, SORTED
      SAVE               FIRST

      PARAMETER         (     MAXKEY = 42,  MAXTIE = 21,   MAXTOK = 10)
      CHARACTER*16       KEYS(MAXKEY), TIES(MAXTIE), TOKEN(MAXTOK)
      CHARACTER*16       KEY, KEY2, KEY3, VALUE

      PARAMETER         (IDUMMY = -11111,  RDUMMY = -11111.0,
     $                   SORTED = .TRUE.,  ZERO   =  0.0     )

      DATA                FIRST
     $                  /.TRUE./
      DATA   KEYS
     $ / 'BEGIN           ',
     $   'CENTRAL         ', 'COLD            ', 'CONDITION       ',
     $   'CONSTRAINTS     ',
     $   'CRASH           ', 'DEBUG           ', 'DEFAULTS        ',
     $   'DERIVATIVE      ', 'DIFFERENCE      ', 'END             ',
     $   'FEASIBILITY     ', 'FUNCTION        ', 'HESSIAN         ',
     $   'HOT             ', 'INFINITE        ', 'IPRMLS          ',
     $   'ITERATIONS      ', 'ITERS:ITERATIONS', 'ITNS :ITERATIONS',
     $   'LINEAR          ', 'LINESEARCH      ', 'LIST            ',
     $   'LOAD            ',
     $   'LOWER           ', 'MAJOR           ', 'MINOR           ',
     $   'NOLIST          ', 'NONLINEAR       ', 'OPTIMALITY      ',
     $   'PRINT           ', 'PROBLEM         ', 'ROW             ',
     $   'RPRMLS          ', 'SAVE            ', 'START           ',
     $   'STEP            ',
     $   'STOP            ', 'UPPER           ', 'VARIABLES       ',
     $   'VERIFY          ', 'WARM            '/

      DATA   TIES
     $ / 'BOUND           ', 'CONSTRAINTS     ', 'DEBUG           ',
     $   'FEASIBILITY     ', 'FREQUENCY       ', 'GRADIENTS       ',
     $   'ITERATIONS      ', 'ITERS:ITERATIONS',
     $   'ITNS :ITERATIONS', 'JACOBIAN        ', 'LEVEL           ',
     $   'NO              ',
     $   'NO.      :NUMBER',
     $   'NUMBER          ', 'OBJECTIVE       ', 'PRINT           ',
     $   'RUN             ', 'STEP            ', 'TOLERANCE       ',
     $   'VARIABLES       ', 'YES             '/
*-----------------------------------------------------------------------

      IF (FIRST) THEN
         FIRST  = .FALSE.
         DO 10 I = 1, MXPARM
            RPRMLS(I) = RDUMMY
            IPRMLS(I) = IDUMMY
            RPRMNP(I) = RDUMMY
            IPRMNP(I) = IDUMMY
   10    CONTINUE
      END IF

*     Eliminate comments and empty lines.
*     A '*' appearing anywhere in BUFFER terminates the string.

      I      = INDEX( BUFFER, '*' )
      IF (I .EQ. 0) THEN
         LENBUF = LEN( BUFFER )
      ELSE
         LENBUF = I - 1
      END IF
      IF (LENBUF .LE. 0) THEN
         KEY = '*'
         GO TO 900
      END IF

*     ------------------------------------------------------------------
*     Extract up to MAXTOK tokens from the record.
*     NTOKEN returns how many were actually found.
*     KEY, KEY2, KEY3 are the first tokens if any, otherwise blank.
*     ------------------------------------------------------------------
      NTOKEN = MAXTOK
      CALL OPTOKN( BUFFER(1:LENBUF), NTOKEN, TOKEN )
      KEY    = TOKEN(1)
      KEY2   = TOKEN(2)
      KEY3   = TOKEN(3)

*     Certain keywords require no action.

      IF (KEY .EQ. ' '     .OR.  KEY .EQ. 'BEGIN' ) GO TO 900
      IF (KEY .EQ. 'LIST'  .OR.  KEY .EQ. 'NOLIST') GO TO 900
      IF (KEY .EQ. 'END'                          ) GO TO 900

*     Most keywords will have an associated integer or real value,
*     so look for it no matter what the keyword.

      I      = 1
      NUMBER = .FALSE.

   50 IF (I .LT. NTOKEN  .AND.  .NOT. NUMBER) THEN
         I      = I + 1
         VALUE  = TOKEN(I)
         NUMBER = OPNUMB( VALUE )
         GO TO 50
      END IF

      IF (NUMBER) THEN
         READ (VALUE, '(BN, E16.0)') RVALUE
      ELSE
         RVALUE = ZERO
      END IF

*     Convert the keywords to their most fundamental form
*     (upper case, no abbreviations).
*     SORTED says whether the dictionaries are in alphabetic order.
*     LOCi   says where the keywords are in the dictionaries.
*     LOCi = 0 signals that the keyword wasn't there.

      CALL OPLOOK( MAXKEY, KEYS, SORTED, KEY , LOC1 )
      CALL OPLOOK( MAXTIE, TIES, SORTED, KEY2, LOC2 )

*     ------------------------------------------------------------------
*     Decide what to do about each keyword.
*     The second keyword (if any) might be needed to break ties.
*     Some seemingly redundant testing of MORE is used
*     to avoid compiler limits on the number of consecutive ELSE IFs.
*     ------------------------------------------------------------------
      MORE   = .TRUE.
      IF (MORE) THEN
         MORE   = .FALSE.
         IF      (KEY .EQ. 'CENTRAL     ') THEN
            CDINT  = RVALUE
         ELSE IF (KEY .EQ. 'COLD        ') THEN
            LCRASH = 0
         ELSE IF (KEY .EQ. 'CONDITION   ') THEN
            HCNDBD = RVALUE
         ELSE IF (KEY .EQ. 'CONSTRAINTS ') THEN
            NNCLIN = RVALUE
         ELSE IF (KEY .EQ. 'CRASH       ') THEN
            TOLACT = RVALUE
         ELSE IF (KEY .EQ. 'DEBUG       ') THEN
            IDBG   = RVALUE
         ELSE IF (KEY .EQ. 'DEFAULTS    ') THEN
            DO 20 I = 1, MXPARM
               IPRMLS(I) = IDUMMY
               RPRMLS(I) = RDUMMY
               IPRMNP(I) = IDUMMY
               RPRMNP(I) = RDUMMY
   20       CONTINUE
         ELSE IF (KEY .EQ. 'DERIVATIVE  ') THEN
            LVLDER = RVALUE
         ELSE IF (KEY .EQ. 'DIFFERENCE  ') THEN
            FDINT  = RVALUE
         ELSE IF (KEY .EQ. 'FEASIBILITY ') THEN
            TOLFEA = RVALUE
            CTOL   = RVALUE
         ELSE IF (KEY .EQ. 'FUNCTION    ') THEN
            EPSRF  = RVALUE
         ELSE
            MORE   = .TRUE.
         END IF
      END IF

      IF (MORE) THEN
         MORE   = .FALSE.
         IF      (KEY .EQ. 'HESSIAN     ') THEN
            LFORMH = 1
            IF   (KEY2.EQ. 'NO          ') LFORMH = 0
         ELSE IF (KEY .EQ. 'HOT         ') THEN
            LCRASH = 2
         ELSE IF (KEY .EQ. 'INFINITE    ') THEN
              IF (KEY2.EQ. 'BOUND       ') BIGBND = RVALUE * 0.99999
              IF (KEY2.EQ. 'STEP        ') BIGDX  = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'IPRMLS      ') THEN
*           Allow things like  IPRMLS 21 = 100  to set IPRMLS(21) = 100
            IVALUE = RVALUE
            IF (IVALUE .GE. 1  .AND. IVALUE .LE. MXPARM) THEN
               READ (KEY3, '(BN, I16)') IPRMLS(IVALUE)
            ELSE
               WRITE(NOUT, 2400) IVALUE
            END IF
         ELSE IF (KEY .EQ. 'ITERATIONS  ') THEN
            NMAJOR = RVALUE
         ELSE IF (KEY .EQ. 'LINEAR      ') THEN
            IF (KEY2  .EQ. 'CONSTRAINTS ') NNCLIN = RVALUE
            IF (KEY2  .EQ. 'FEASIBILITY ') TOLFEA = RVALUE
            IF (LOC2 .EQ.  0             ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'LINESEARCH  ') THEN
            ETA    = RVALUE
         ELSE IF (KEY .EQ. 'LOWER       ') THEN
            BNDLOW = RVALUE
         ELSE IF (KEY .EQ. 'LOAD        ') THEN
            NLOAD  = RVALUE
         ELSE
            MORE   = .TRUE.
         END IF
      END IF

      IF (MORE) THEN
         MORE   = .FALSE.
         IF      (KEY .EQ. 'MAJOR       ') THEN
              IF (KEY2.EQ. 'DEBUG       ') MJRDBG = RVALUE
              IF (KEY2.EQ. 'ITERATIONS  ') NMAJOR = RVALUE
              IF (KEY2.EQ. 'PRINT       ') MSGNP  = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'MINOR       ') THEN
              IF (KEY2.EQ. 'DEBUG       ') MNRDBG = RVALUE
              IF (KEY2.EQ. 'ITERATIONS  ') NMINOR = RVALUE
              IF (KEY2.EQ. 'PRINT       ') MSGQP  = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'NONLINEAR   ') THEN
              IF (KEY2.EQ. 'CONSTRAINTS ') NNCNLN = RVALUE
              IF (KEY2.EQ. 'FEASIBILITY ') CTOL   = RVALUE
              IF (KEY2.EQ. 'JACOBIAN    ') NLNJ   = RVALUE
              IF (KEY2.EQ. 'OBJECTIVE   ') NLNF   = RVALUE
              IF (KEY2.EQ. 'VARIABLES   ') NLNX   = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'OPTIMALITY  ') THEN
            FTOL   = RVALUE
         ELSE
            MORE   = .TRUE.
         END IF
      END IF

      IF (MORE) THEN
         MORE   = .FALSE.
         IF      (KEY .EQ. 'PRINT       ') THEN
            MSGNP  = RVALUE
         ELSE IF (KEY .EQ. 'PROBLEM     ') THEN
              IF (KEY2.EQ. 'NUMBER      ') NPROB  = RVALUE
         ELSE IF (KEY .EQ. 'ROW         ') THEN
              IF (KEY2.EQ. 'TOLERANCE   ') CTOL   = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'RPRMLS      ') THEN
*           Allow things like  RPRMLS 21 = 2  to set RPRMLS(21) = 2.0
            IVALUE = RVALUE
            IF (IVALUE .GE. 1  .AND. IVALUE .LE. MXPARM) THEN
               READ (KEY3, '(BN, E16.0)') RPRMLS(IVALUE)
            ELSE
               WRITE(NOUT, 2400) IVALUE
            END IF
         ELSE IF (KEY .EQ. 'SAVE        ') THEN
              IF (KEY2.EQ. 'RUN         ') NSAVE  = RVALUE
              IF (KEY2.EQ. 'FREQUENCY   ') KSAVE  = RVALUE
         ELSE IF (KEY .EQ. 'START       ') THEN
              IF (KEY2.EQ. 'CONSTRAINTS ') JVRFY3 = RVALUE
              IF (KEY2.EQ. 'OBJECTIVE   ') JVRFY1 = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'STEP        ') THEN
            DXLIM  = RVALUE
         ELSE IF (KEY .EQ. 'STOP        ') THEN
              IF (KEY2.EQ. 'CONSTRAINTS ') JVRFY4 = RVALUE
              IF (KEY2.EQ. 'OBJECTIVE   ') JVRFY2 = RVALUE
              IF (LOC2.EQ.  0            ) WRITE(NOUT, 2320) KEY2
         ELSE IF (KEY .EQ. 'UPPER       ') THEN
            BNDUPP = RVALUE
         ELSE IF (KEY .EQ. 'VARIABLES   ') THEN
            NN     = RVALUE
         ELSE IF (KEY .EQ. 'VERIFY      ') THEN
              IF (KEY2.EQ. 'OBJECTIVE   ') LVERFY =  1
              IF (KEY2.EQ. 'CONSTRAINTS ') LVERFY =  2
              IF (KEY2.EQ. 'NO          ') LVERFY = -1
              IF (KEY2.EQ. 'YES         ') LVERFY =  3
              IF (KEY2.EQ. 'GRADIENTS   ') LVERFY =  3
              IF (KEY2.EQ. 'LEVEL       ') LVERFY =  RVALUE
              IF (LOC2.EQ.  0            ) LVERFY =  3
         ELSE IF (KEY .EQ. 'WARM        ') THEN
            LCRASH = 1
         ELSE
            WRITE(NOUT, 2300) KEY
         END IF
      END IF

  900 RETURN

 2300 FORMAT(' XXX  Keyword not recognized:         ', A)
 2320 FORMAT(' XXX  Second keyword not recognized:  ', A)
 2330 FORMAT(' XXX  Third  keyword not recognized:  ', A)
 2400 FORMAT(' XXX  The PARM subscript is out of range:', I10)

*     End of NPKEY

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPLOC ( N, NCLIN, NCNLN, NCTOTL, LITOTL, LWTOTL)

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

************************************************************************
*     NPLOC   allocates the addresses of the work arrays for NPCORE and
*     LSCORE.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version   14-February-1985.
*     This version of  NPLOC  dated 12-July-1986.
************************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL3CM/ LENNAM, LDT   , NCOLT , LDZY

      PARAMETER         (LENLS = 20)
      COMMON    /SOL1LS/ LOCLS(LENLS)

      PARAMETER         (LENNP = 35)
      COMMON    /SOL1NP/ LOCNP(LENNP)

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      MINIW     = LITOTL + 1
      MINW      = LWTOTL + 1

*     Assign array lengths that depend upon the problem dimensions.

      IF (NCLIN + NCNLN .EQ. 0) THEN
         LENT      = 0
         LENZY     = 0
      ELSE
         LENT  = LDT *NCOLT
         LENZY = LDZY*LDZY
      END IF

      IF (NCNLN .EQ. 0) THEN
         LENAQP = 0
      ELSE
         LENAQP = (NCLIN + NCNLN)*N
      END IF

      LKACTV    = MINIW
      LKX       = LKACTV + N
      LNEEDC    = LKX    + N
      LIPERM    = LNEEDC + NCNLN
      MINIW     = LIPERM + NCTOTL

      LHFRWD    = MINW
      LHCTRL    = LHFRWD + N
      LANORM    = LHCTRL + N
      LQPGQ     = LANORM + NCLIN + NCNLN
      LGQ       = LQPGQ  + N
      LRLAM     = LGQ    + N
      LT        = LRLAM  + N
      LZY       = LT     + LENT
      MINW      = LZY    + LENZY

      LOCLS( 1) = LKACTV
      LOCLS( 2) = LANORM
      LOCLS( 8) = LQPGQ
      LOCLS( 9) = LGQ
      LOCLS(10) = LRLAM
      LOCLS(11) = LT
      LOCLS(12) = LZY

*     Assign the addresses for the workspace arrays used by  NPIQP.

      LQPADX    = MINW
      LQPDX     = LQPADX + NCLIN + NCNLN
      LRPQ      = LQPDX  + N
      LRPQ0     = LRPQ   + N
      LQPHZ     = LRPQ0  + N
      LWTINF    = LQPHZ  + N
      LWRK1     = LWTINF + NCTOTL
      LQPTOL    = LWRK1  + NCTOTL
      MINW      = LQPTOL + NCTOTL

      LOCLS( 3) = LQPADX
      LOCLS( 4) = LQPDX
      LOCLS( 5) = LRPQ
      LOCLS( 6) = LRPQ0
      LOCLS( 7) = LQPHZ
      LOCLS(13) = LWTINF
      LOCLS(14) = LWRK1
      LOCLS(15) = LQPTOL

*     Assign the addresses for arrays used in NPCORE.

      LAQP      = MINW
      LADX      = LAQP   + LENAQP
      LBL       = LADX   + NCLIN  + NCNLN
      LBU       = LBL    + NCTOTL
      LDX       = LBU    + NCTOTL
      LGQ1      = LDX    + N
      LFEATL    = LGQ1   + N
      LX1       = LFEATL + NCTOTL
      LWRK2     = LX1    + N
      MINW      = LWRK2  + NCTOTL

      LOCNP( 1) = LKX
      LOCNP( 2) = LIPERM
      LOCNP( 3) = LAQP
      LOCNP( 4) = LADX
      LOCNP( 5) = LBL
      LOCNP( 6) = LBU
      LOCNP( 7) = LDX
      LOCNP( 8) = LGQ1
      LOCNP(10) = LFEATL
      LOCNP(11) = LX1
      LOCNP(12) = LWRK2

      LCS1      = MINW
      LCS2      = LCS1   + NCNLN
      LC1MUL    = LCS2   + NCNLN
      LCMUL     = LC1MUL + NCNLN
      LCJDX     = LCMUL  + NCNLN
      LDLAM     = LCJDX  + NCNLN
      LDSLK     = LDLAM  + NCNLN
      LRHO      = LDSLK  + NCNLN
      LWRK3     = LRHO   + NCNLN
      LSLK1     = LWRK3  + NCNLN
      LSLK      = LSLK1  + NCNLN
      MINW      = LSLK   + NCNLN

      LOCNP(13) = LCS1
      LOCNP(14) = LCS2
      LOCNP(15) = LC1MUL
      LOCNP(16) = LCMUL
      LOCNP(17) = LCJDX
      LOCNP(18) = LDLAM
      LOCNP(19) = LDSLK
      LOCNP(20) = LRHO
      LOCNP(21) = LWRK3
      LOCNP(22) = LSLK1
      LOCNP(23) = LSLK
      LOCNP(24) = LNEEDC

      LCJAC     = MINW
      LGRAD     = LCJAC  + NCNLN*N
      MINW      = LGRAD  + N

      LOCNP(25) = LHFRWD
      LOCNP(26) = LHCTRL
      LOCNP(27) = LCJAC
      LOCNP(28) = LGRAD

      LITOTL    = MINIW - 1
      LWTOTL    = MINW  - 1

      RETURN

*     End of  NPLOC .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPMRT ( FEASQP, N, NCLIN, NCNLN,
     $                   OBJALF, GRDALF, QPCURV,
     $                   ISTATE,
     $                   CJDX, CMUL, CS,
     $                   DLAM, RHO, VIOLN,
     $                   WORK1, WORK2 )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)

      LOGICAL            FEASQP

      INTEGER            ISTATE(*)

      DOUBLE PRECISION   CJDX(*), CMUL(*), CS(*),
     $                   DLAM(*), RHO(*), VIOLN(*)
      DOUBLE PRECISION   WORK1(*), WORK2(*)

************************************************************************
*     NPMRT   computes the value and directional derivative of the
*     augmented Lagrangian merit function.  The penalty parameters
*     RHO(j) are boosted if the directional derivative of the resulting
*     augmented Lagrangian function is not sufficiently negative.  If
*     RHO needs to be increased,  the perturbation with minimum two-norm
*     is found that gives a directional derivative equal to  - p'Hp.
*
*     Systems Optimization Laboratory, Stanford University, California.
*     Original version written  27-May-1985.
*     This version of  NPMRT  dated 14-November-1985.
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

      COMMON    /SOL1CM/ NOUT

      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            BOOST , OVERFL
      EXTERNAL           DDIV  , DDOT  , DNRM2
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      PARAMETER        ( ZERO   = 0.0D+0, HALF = 0.5D+0, ONE = 1.0D+0 )
      PARAMETER        ( TWO    = 2.0D+0                              )

      IF (NCNLN .EQ. 0) RETURN

      RTMIN  = WMACH(6)

      OBJALF = OBJALF - DDOT  ( NCNLN, CMUL, 1, CS, 1 )
      GRDALF = GRDALF - DDOT  ( NCNLN, DLAM, 1, CS, 1 )

      CALL DCOPY ( NCNLN, CS, 1, WORK1, 1 )

      IF (.NOT. FEASQP) THEN
         NPLIN  = N + NCLIN

         DO 100 I = 1, NCNLN
            IF (ISTATE(NPLIN+I) .LT. 0  .OR.  VIOLN(I) .NE. ZERO)
     $         WORK1(I) = - CJDX(I)
  100    CONTINUE
      END IF

      GRDALF = GRDALF + DDOT  ( NCNLN, WORK1, 1, CMUL, 1 )

      IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $   WRITE (NOUT, 1000) QPCURV, GRDALF

      IF (FEASQP) THEN

*        Find the quantities that define  rhomin, the vector of minimum
*        two-norm such that the directional derivative is one half of
*        approximate curvature   - (dx)'H(dx).

         DO 350 I = 1, NCNLN
            IF (ABS( CS(I) ) .LE. RTMIN) THEN
               WORK2(I) = ZERO
            ELSE
               WORK2(I) = CS(I)**2
            END IF
  350    CONTINUE

         QNORM  = DNRM2 ( NCNLN, WORK2, 1 )
         TSCL   = DDIV  ( GRDALF + HALF*QPCURV, QNORM, OVERFL )
         IF (ABS( TSCL ) .LE. RHOMAX  .AND.  .NOT. OVERFL) THEN
*           ------------------------------------------------------------
*           Bounded  RHOMIN  found.  The final value of  RHO(J)  will
*           never be less than  RHOMIN(j).  If the  QP  was feasible,  a
*           trial value  RHONEW  is computed that is equal to the
*           geometric mean of the previous  RHO  and a damped value of
*           RHOMIN.  The new  RHO  is defined as  RHONEW  if it is less
*           than half the previous  RHO  and greater than  RHOMIN.
*           ------------------------------------------------------------
            SCALE  = ONE
            DO 400 I = 1, NCNLN
               RHOMIN = MAX(  (WORK2(I)/QNORM)*TSCL, ZERO )
               RHOI   = RHO(I)

               RHONEW = SQRT( RHOI*(RHODMP + RHOMIN) )
               IF (RHONEW .LT. HALF*RHOI  ) RHOI = RHONEW
               IF (RHOI   .LT.      RHOMIN) RHOI = RHOMIN
               RHO(I) = RHOI
  400       CONTINUE

            RHO1   = RHONRM
            RHONRM = DNRM2 ( NCNLN, RHO, 1 )

*           ------------------------------------------------------------
*           If  INCRUN = true,  there has been a run of iterations in
*           which the norm of  RHO  has not decreased.  Conversely,
*           INCRUN = false  implies that there has been a run of
*           iterations in which the norm of RHO has not increased.  If
*           INCRUN changes during this iteration the damping parameter
*           RHODMP is increased by a factor of two.  This ensures that
*           RHO(j) will oscillate only a finite number of times.
*           ------------------------------------------------------------
            BOOST  = .FALSE.
            IF (      INCRUN  .AND.  RHONRM .LT. RHO1) BOOST = .TRUE.
            IF (.NOT. INCRUN  .AND.  RHONRM .GT. RHO1) BOOST = .TRUE.
            IF (BOOST) THEN
               RHODMP = TWO*RHODMP
               INCRUN = .NOT. INCRUN
            END IF
         END IF

         IF (NPDBG  .AND.  INPDBG(2) .GT. 0)
     $      WRITE (NOUT, 1200) (RHO(L), L=1,NCNLN)

      ELSE

*        The  QP  was infeasible.  Do not alter the penalty parameters,
*        but compute the scale factor so that the constraint violations
*        are reduced.

         CALL DDSCL ( NCNLN, RHO, 1, WORK1, 1 )
         PTERM2 = DDOT  ( NCNLN, WORK1, 1, CS, 1 )

         SCALE  = RHOMAX
         TSCL   = DDIV  ( GRDALF, PTERM2, OVERFL )
         IF (TSCL .GT. SCALE  .AND.  TSCL .LE. RHOMAX/(ONE+RHONRM)
     $                        .AND.  .NOT. OVERFL)
     $      SCALE = TSCL

         CALL DCOPY ( NCNLN, CS, 1, WORK1, 1 )
      END IF

*     ------------------------------------------------------------------
*     Compute the new value and directional derivative of the
*     merit function.
*     ------------------------------------------------------------------
      CALL DDSCL ( NCNLN, RHO, 1, WORK1, 1 )

      PTERM  = DDOT  ( NCNLN, WORK1, 1, CS, 1 )
      OBJALF = OBJALF + HALF*SCALE*PTERM

      IF (FEASQP)
     $  PTERM2 = PTERM

      GRDALF = GRDALF -      SCALE*PTERM2

      IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $   WRITE (NOUT, 1100) SCALE, RHONRM, GRDALF

      RETURN

 1000 FORMAT(/ ' //NPMRT //        QPCURV        GRDALF '
     $       / ' //NPMRT //', 1P, 2E14.2 )
 1100 FORMAT(/ ' //NPMRT //         SCALE        RHONRM        GRDALF '
     $       / ' //NPMRT //', 1P, 3E14.2 )
 1200 FORMAT(/ ' //NPMRT //  Penalty parameters =       '/ (1P, 5E15.6))

*     End of  NPMRT .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPOPTN( STRING )
      CHARACTER*(*)      STRING

************************************************************************
*     NPOPTN  loads the option supplied in STRING into the relevant
*     element of IPRMLS, RPRMLS, IPRMNP or RPRMNP.
************************************************************************

      LOGICAL             NEWOPT
      COMMON     /SOL7NP/ NEWOPT
      SAVE       /SOL7NP/

      DOUBLE PRECISION    WMACH(15)
      COMMON     /SOLMCH/ WMACH
      SAVE       /SOLMCH/

      EXTERNAL            MCHPAR
      CHARACTER*16        KEY
      CHARACTER*72        BUFFER
      LOGICAL             FIRST , PRNT
      SAVE                FIRST , NOUT  , PRNT
      DATA                FIRST /.TRUE./

*     If first time in, set NOUT.
*     NEWOPT is true first time into NPFILE or NPOPTN
*     and just after a call to an optimization routine.
*     PRNT is set to true whenever NEWOPT is true.

      IF (FIRST) THEN
         FIRST  = .FALSE.
         NEWOPT = .TRUE.
         CALL MCHPAR()
         NOUT   =  WMACH(11)
      END IF
      BUFFER = STRING

*     Call NPKEY to decode the option and set the parameter value.
*     If NEWOPT is true, reset PRNT and test specially for NOLIST.

      IF (NEWOPT) THEN
         NEWOPT = .FALSE.
         PRNT   = .TRUE.
         CALL NPKEY ( NOUT, BUFFER, KEY )

         IF (KEY .EQ. 'NOLIST') THEN
            PRNT   = .FALSE.
         ELSE
            WRITE (NOUT, '(// A / A /)')
     $         ' Calls to NPOPTN',
     $         ' ---------------'
            WRITE (NOUT, '( 6X, A )') BUFFER
         END IF
      ELSE
         IF (PRNT)
     $      WRITE (NOUT, '( 6X, A )') BUFFER
         CALL NPKEY ( NOUT, BUFFER, KEY )

         IF (KEY .EQ.   'LIST') PRNT = .TRUE.
         IF (KEY .EQ. 'NOLIST') PRNT = .FALSE.
      END IF

      RETURN

*     End of  NPOPTN.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPPRT ( KTCOND, CONVRG, LSUMRY, MSGNP, MSGQP,
     $                   LDR, LDT, N, NCLIN, NCNLN,
     $                   NCTOTL, NACTIV, LINACT, NLNACT, NZ, NFREE,
     $                   MAJIT0, MAJITS, MINITS, ISTATE, ALFA, NFUN,
     $                   CONDHZ, CONDH, CONDT, OBJALF, OBJF,
     $                   GFNORM, GZNORM, CVNORM,
     $                   AX, C, R, T, VIOLN, X, WORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*5        LSUMRY
      LOGICAL            KTCOND(2), CONVRG
      INTEGER            ISTATE(NCTOTL)
      DOUBLE PRECISION   AX(*), C(*), R(LDR,*), T(LDT,*), VIOLN(*)
      DOUBLE PRECISION   X(N)
      DOUBLE PRECISION   WORK(N)

************************************************************************
*     NPPRT  prints various levels of output for NPCORE.
*
*           Msg        Cumulative result
*           ---        -----------------
*
*        le   0        no output.
*
*        eq   1        nothing now (but full output later).
*
*        eq   5        one terse line of output.
*
*        ge  10        same as 5 (but full output later).
*
*        ge  20        objective function,  x,  Ax  and  c.
*
*        ge  30        diagonals of  T  and  R.
*
*     Debug print is performed depending on the logical variable NPDBG.
*     NPDBG is set true when IDBG major iterations have been performed.
*     At this point,  printing is done according to a string of binary
*     digits of the form CLSVT (stored in the integer array INPDBG).
*
*     C  set 'on' gives detailed information from the checking routines.
*     L  set 'on' gives information from the linesearch.
*     S  set 'on' gives information from the maximum step routine NPALF.
*     V  set 'on' gives various vectors in  NPCORE  and its auxiliaries.
*     T  set 'on' gives a trace of which routine was called and an
*                 indication of the progress of the run.
*
*
*     Systems Optimization Laboratory, Stanford University.
*     Original Fortran 66 version written November-1982.
*     This version of  NPPRT  dated  25-Nov-1989.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            PHEAD
      EXTERNAL           DNRM2

      IF (MSGNP .GE. 20) WRITE (NOUT, 1000) MAJITS

      IF (MSGNP  .GE. 5) THEN
*        ---------------------------------------------------------------
*        Print heading and terse line.
*        ---------------------------------------------------------------
         PHEAD = MSGQP .GT. 0  .OR.  MAJITS .EQ. MAJIT0

         IF (NCNLN .EQ. 0) THEN
            IF (PHEAD) WRITE (NOUT, 1100)
            WRITE (NOUT, 1300) MAJITS, MINITS, ALFA, NFUN, OBJALF,
     $                         N-NFREE, LINACT, NZ,
     $                         GFNORM, GZNORM, CONDH, CONDHZ, CONDT,
     $                         CONVRG, KTCOND(1), KTCOND(2), LSUMRY

         ELSE
            IF (PHEAD) WRITE (NOUT, 1110)
            WRITE (NOUT, 1310) MAJITS, MINITS, ALFA, NFUN, OBJALF,
     $                         N-NFREE, LINACT, NLNACT, NZ,
     $                         GFNORM, GZNORM, CONDH, CONDHZ, CONDT,
     $                         CVNORM, SCALE*RHONRM,
     $                         CONVRG, KTCOND(1), KTCOND(2), LSUMRY
         END IF

         IF (MSGNP .GE. 20) THEN
            IF (NCNLN .EQ. 0) THEN
               WRITE (NOUT, 1400) OBJF
            ELSE
               CVIOLS = DNRM2 ( NCNLN, VIOLN, 1 )
               WRITE (NOUT, 1410) OBJF, CVIOLS
            END IF

*           ------------------------------------------------------------
*           Print the constraint values.
*           ------------------------------------------------------------
            WRITE (NOUT, 2000)
            WRITE (NOUT, 2100) (X(J), ISTATE(J), J=1,N)
            IF (NCLIN .GT. 0)
     $         WRITE (NOUT, 2200) (AX(K), ISTATE(N+K),       K=1,NCLIN )
            IF (NCNLN .GT. 0)
     $         WRITE (NOUT, 2300) (C(K) , ISTATE(N+NCLIN+K), K=1,NCNLN )

            IF (MSGNP .GE. 30) THEN
*              ---------------------------------------------------------
*              Print the diagonals of  T  and  R.
*              ---------------------------------------------------------
               INCT   = LDT - 1
               IF (NACTIV .GT. 0) THEN
                  CALL DCOPY( NACTIV, T(NACTIV,NZ+1), INCT, WORK, 1 )
                  WRITE (NOUT, 3000) (WORK(J), J=1,NACTIV)
               END IF
               WRITE (NOUT, 3100) (R(J,J), J=1,N)
            END IF
         END IF
      END IF

      IF (MSGNP .GE. 20) WRITE (NOUT, 5000)

      LSUMRY(1:2) = '  '
      LSUMRY(4:5) = '  '

      RETURN

 1000 FORMAT(/// ' Major iteration', I5
     $       /   ' ====================' )
 1100 FORMAT(//  '  Itn', ' ItQP', '     Step',
     $           '  Nfun', '     Objective', ' Bnd', ' Lin', '  Nz',
     $           '  Norm Gf', '  Norm Gz', '  Cond H', ' Cond Hz',
     $           '  Cond T', ' Conv' )
 1110 FORMAT(//  '  Itn', ' ItQP', '     Step',
     $           '  Nfun', '         Merit', ' Bnd', ' Lin',
     $           ' Nln', '  Nz',
     $           '  Norm Gf', '  Norm Gz', '  Cond H', ' Cond Hz',
     $           '  Cond T' , '   Norm C', '  Penalty', ' Conv' )
 1300 FORMAT(2I5, 1PE9.1, I6, 1PE14.6, 3I4, 1P, 2E9.1, 1P, 3E8.0,
     $                        1X, L1, 1X, 2L1, A5 )
 1310 FORMAT(2I5, 1PE9.1, I6, 1PE14.6, 4I4, 1P, 2E9.1, 1P, 3E8.0,
     $            1P, 2E9.1,    1X, L1, 1X, 2L1, A5 )
 1400 FORMAT(/ ' Nonlinear objective value = ', 1PE15.6 )
 1410 FORMAT(/ ' Nonlinear objective value = ', 1PE15.6, '   Norm of',
     $         ' the nonlinear constraint violations = ', 1PE15.6 )
 2000 FORMAT(/ ' Values of the constraints and their predicted status'
     $       / ' ----------------------------------------------------')
 2100 FORMAT(/ ' Variables                  '/ (1X, 5(1PE15.6, I4)))
 2200 FORMAT(/ ' General linear constraints '/ (1X, 5(1PE15.6, I4)))
 2300 FORMAT(/ ' Nonlinear constraints      '/ (1X, 5(1PE15.6, I4)))
 3000 FORMAT(/ ' Diagonals of  T  =         '
     $       /   (1P, 5E15.6))
 3100 FORMAT(/ ' Diagonals of  R  =         '
     $       /   (1P, 5E15.6))
 5000 FORMAT(  ' ==================================================',
     $         '======================================='///)

*     End of  NPPRT .

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPRSET( UNITQ,
     $                   N, NFREE, NZ, LDZY, LDR,
     $                   IPERM, KX,
     $                   GQ, R, ZY, WORK, QRWORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            IPERM(N), KX(N)
      DOUBLE PRECISION   GQ(N), R(LDR,*), ZY(LDZY,*)
      DOUBLE PRECISION   WORK(N), QRWORK(2*N)

************************************************************************
*     NPRSET  bounds the condition estimator of the transformed Hessian.
*     On exit, R is of the form
*                  ( DRz   0     )
*                  (  0  sigma*I )
*     where D is a diagonal matrix such that DRz has a bounded condition
*     number,  I is the identity matrix and sigma  is the geometric mean
*     of the largest and smallest elements of DRz. The QR factorization
*     with interchanges is used to give diagonals of DRz that are
*     decreasing in modulus.
*
*     Systems Optimization Laboratory, Stanford University.
*
*     Original version of NPRSET dated  4-August-1986.
*     This version dated  26-Jun-1987.
************************************************************************

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL6CM/ RCNDBD, RFROBN, DRMAX, DRMIN

      LOGICAL            NPDBG
      PARAMETER         (LDBG   = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      INTRINSIC          MAX   , MIN   , LOG   , REAL  , SQRT
      EXTERNAL           DDIV  , DDOT  , DNORM , DNRM2 , IDRANK
      PARAMETER        ( ZERO   =0.0D+0, HALF =0.5D+0, ONE    =1.0D+0 )

*     ==================================================================
*     Bound the condition estimator of Q'HQ.
*     The scheme used here reduces the modulus of the larger
*     diagonals while increasing the modulus of the smaller ones.
*     ==================================================================
      IF (NZ .GT. 1) THEN
*        ---------------------------------------------------------------
*        Refactorize Rz.  Interchanges are used to give diagonals
*        of decreasing magnitude.
*        ---------------------------------------------------------------
         DO 100, J = 1, NZ-1
            CALL DLOAD ( NZ-J, ZERO, R(J+1,J), 1 )
  100    CONTINUE

         CALL DGEQRP( 'Column iterchanges', NZ, NZ, R, LDR,
     $                WORK, IPERM, QRWORK, INFO )

         DO 110, J = 1, NZ
            JMAX = IPERM(J)
            IF (JMAX .GT. J) THEN
               IF (UNITQ) THEN
                  JSAVE    = KX(JMAX)
                  KX(JMAX) = KX(J)
                  KX(J)    = JSAVE
               ELSE
                  CALL DSWAP ( NFREE, ZY(1,JMAX), 1, ZY(1,J), 1 )
               END IF

               GJMAX    = GQ(JMAX)
               GQ(JMAX) = GQ(J)
               GQ(J)    = GJMAX
            END IF
  110    CONTINUE
      END IF

      DRGM  = ONE

      IF (NZ .GT. 0) THEN
         NRANK = IDRANK( NZ, R, LDR+1, ONE/RCNDBD )
         DRGM  = HALF*SQRT(ABS( R(1,1)*R(NRANK,NRANK) ))
         DRGS  = ABS( R(1,1) ) / RCNDBD

         IF (NZ .GT. NRANK) THEN
            DO 120, J = NRANK+1, NZ
               CALL DLOAD ( J-1, ZERO, R(1,J), 1 )
  120       CONTINUE
            CALL DLOAD ( NZ-NRANK, DRGS, R(NRANK+1,NRANK+1), LDR+1 )
         END IF
      END IF

*     ------------------------------------------------------------------
*     Reset the range-space partition of the Hessian.
*     ------------------------------------------------------------------
      IF (NZ .LT. N) THEN
         DO 130, J = NZ+1, N
            CALL DLOAD ( J, ZERO, R(1,J), 1 )
  130    CONTINUE
         CALL DLOAD ( N-NZ, DRGM, R(NZ+1,NZ+1), LDR+1 )
      END IF

*     Recompute the Frobenius norm of R.

      SCLE  = SQRT(REAL(N - NZ))*DRGM
      SUMSQ = ONE
      DO 140, J = 1, NZ
         CALL DSSQ  ( J, R(1,J), 1, SCLE, SUMSQ )
  140 CONTINUE
      RFROBN = DNORM( SCLE, SUMSQ )

      RETURN

*     End of  NPRSET.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPSAVR( UNITQ, N, NCLIN, NCNLN, LDR, LDZY,
     $                   NFREE, NSAVE, ITER, ISTATE, KX,
     $                   HFORWD, HCNTRL,
     $                   CMUL, R, RHO, X, ZY )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            ISTATE(N+NCLIN+NCNLN), KX(N)
      DOUBLE PRECISION   R(LDR,*), X(N), ZY(LDZY,*)
      DOUBLE PRECISION   HFORWD(*), HCNTRL(*)
      DOUBLE PRECISION   CMUL(*), RHO(*)

C***********************************************************************
C     NPSAVR  saves the details of this run on unit NSAVE.
C
C     Original version   24-Nov-89.
C     This version of  NPSAVR  dated  1-Dec-89.
C***********************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET
      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      IF (NSAVE .LE. 0) RETURN

*     We always save the computed difference intervals, if defined.

      IF (LVLDIF .GT. 0  .AND.  LFDSET .EQ. 0) THEN
         LFDNEW = 2
      ELSE 
         LFDNEW = LFDSET
      END IF
 
      WRITE( NSAVE, 1000 ) ITER, NFREE, LFDNEW, LVLDIF, UNITQ
      DO 110, J = 1, N
         WRITE( NSAVE, 1010 ) J, KX(J), ISTATE(J), X(J)
  110 CONTINUE

      DO 120, J = N+1, N+NCLIN
         WRITE( NSAVE, 1020 ) J, ISTATE(J)
  120 CONTINUE

      IF (NCNLN .GT. 0) THEN
         K = 1
         DO 130, J = N+NCLIN+1, N+NCLIN+NCNLN
            WRITE( NSAVE, 1030 ) J, ISTATE(J), CMUL(K), RHO(K)
            K = K + 1
  130    CONTINUE

         WRITE( NSAVE, 1040 ) RHOMAX, RHONRM, RHODMP, SCALE, INCRUN
      END IF

*     ------------------------------------------------------------------
*     Write  Q(free)  and the factor of  Q'HQ.
*     ------------------------------------------------------------------
      IF (.NOT. UNITQ) THEN
         DO 210, J = 1, NFREE
            DO 200, I = 1, NFREE
              WRITE( NSAVE, 2000 ) I, J, ZY(I,J)
  200       CONTINUE
  210    CONTINUE
      END IF

      DO 240, J = 1, N
         DO 230, I = 1, J
           WRITE( NSAVE, 2000 ) I, J, R(I,J)
  230    CONTINUE
  240 CONTINUE

*     ------------------------------------------------------------------
*     Read the finite-difference intervals.  
*     ------------------------------------------------------------------
      IF (LVLDIF .GT. 0) THEN
         IF (LFDNEW .NE. 1) THEN
            DO 250, J = 1, N
               WRITE( NSAVE, 1050 ) J, HFORWD(J), HCNTRL(J)
  250       CONTINUE
         END IF
      END IF                                            
             
      WRITE( NOUT, 4000 ) NSAVE, ITER
      IF (NSAVE .NE. NOUT) REWIND NSAVE
      RETURN

 1000 FORMAT(2I8, 1X, 2I2, 1X, L1 )
 1010 FORMAT(2I8, 1X,  I2, 1P, 2E24.14 )
 1020 FORMAT( I8, 1X,  I2 )
 1030 FORMAT( I8, 1X,  I2, 1P, 2E24.14 )
 1040 FORMAT( 1P, 4E24.14, 1X, L1 )
 1050 FORMAT( I8, 1X, 1P, 2E24.14 )
 2000 FORMAT(2I8, 1X, 1P,  E24.14 )
 4000 FORMAT(  ' CURRENT RUN saved on file', I4, '    Itn = ', I7 )

*     End of  NPSAVR.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPSETX( UNITQ,
     $                   NCQP, NACTIV, NFREE, NZ,
     $                   N, NLNX, NCTOTL, LDZY, LDAQP, LDR, LDT,
     $                   ISTATE, KACTIV, KX,
     $                   DXNORM, GDX,
     $                   AQP, ADX, BL, BU, RPQ, RPQ0, DX, GQ,
     $                   R, T, ZY, WORK )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            UNITQ
      INTEGER            ISTATE(NCTOTL), KACTIV(N), KX(N)
      DOUBLE PRECISION   AQP(LDAQP,*), ADX(*), BL(NCTOTL), BU(NCTOTL),
     $                   RPQ(NLNX), RPQ0(NLNX), GQ(N), R(LDR,*),
     $                   T(LDT,*), ZY(LDZY,*), DX(N), WORK(N)

************************************************************************
*     NPSETX   defines a point which lies on the initial working set for
*     the QP subproblem.  This routine is a similar to LSSETX except
*     that advantage is taken of the fact that the initial estimate of
*     the solution of the least-squares subproblem is zero.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original version written 31-October-1984.
*     Level 2 BLAS added 12-June-1986.
*     This version of NPSETX dated 11-June-1986.
************************************************************************
      COMMON    /SOL1CM/ NOUT

      LOGICAL            NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      EXTERNAL           DDOT, DNRM2
      INTRINSIC          ABS , MIN
      PARAMETER        ( ZERO = 0.0D+0, ONE = 1.0D+0 )

      NFIXED = N - NFREE

      GDX    = ZERO
      CALL DLOAD ( N   , ZERO, DX  , 1 )
      CALL DLOAD ( NLNX, ZERO, RPQ , 1 )
      CALL DLOAD ( NLNX, ZERO, RPQ0, 1 )

      IF (NACTIV + NFIXED .GT. 0) THEN

*        Set  work = residuals for constraints in the working set.
*        Solve for  dx,  the smallest correction to  x  that gives a
*        point on the constraints in the working set.
*        Set the fixed variables on their bounds,  solve the triangular
*        system  T*(dxy) = residuals,  and define  dx = Y*(dxy).
*        Use  (dxy)  to update  d(=Pr)  as  d = d - R'(  0  ).
*                                                     ( dxy )

         DO 100 I = 1, NFIXED
            J   = KX(NFREE+I)
            IF (ISTATE(J) .LE. 3) THEN
               BND   = BL(J)
               IF (ISTATE(J) .EQ. 2) BND = BU(J)
               DX(J) = BND
               WORK(NFREE+I) = BND
            ELSE
               WORK(NFREE+I) = ZERO
            END IF
  100    CONTINUE

         DO 110 I = 1, NACTIV
            K   = KACTIV(I)
            J   = N + K
            BND = BL(J)
            IF (ISTATE(J) .EQ. 2) BND = BU(J)
            WORK(NZ+I) = BND - DDOT  ( N, AQP(K,1), LDAQP, DX, 1 )
  110    CONTINUE

         IF (NACTIV .GT. 0)
     $      CALL CMTSOL( 1, LDT, NACTIV, T(1,NZ+1), WORK(NZ+1) )
         CALL DCOPY ( NACTIV+NFIXED, WORK(NZ+1), 1, DX(NZ+1), 1 )
         IF (NZ .GT. 0)
     $      CALL DLOAD ( NZ, ZERO, DX, 1 )

         GDX  = DDOT  ( NACTIV+NFIXED, GQ(NZ+1), 1, DX(NZ+1), 1 )

         IF (NZ .LT. N) THEN
            CALL DGEMV ('N', NZ, N-NZ, -ONE, R(1,NZ+1), LDR,
     $                  DX(NZ+1), 1, ONE, RPQ, 1 )
            IF (NZ .LT. NLNX) THEN
               NR  = LDR
               IF (NZ+1 .EQ. N) NR = 1
               CALL DCOPY ( NLNX-NZ, DX(NZ+1), 1, RPQ(NZ+1), 1 )
               CALL DSCAL ( NLNX-NZ, (-ONE),      RPQ(NZ+1), 1 )
               CALL DTRMV ( 'U', 'N', 'N', NLNX-NZ, R(NZ+1,NZ+1), NR,
     $                      RPQ(NZ+1), 1 )
               IF (NLNX .LT. N) THEN
                  NR = LDR
                  IF (NLNX+1 .EQ. N) NR = N - NZ
                  CALL DGEMV( 'N', NLNX-NZ, N-NLNX, -ONE,R(NZ+1,NLNX+1),
     $                        NR, DX(NLNX+1), 1, ONE, RPQ(NZ+1), 1 )
               END IF
            END IF
         END IF

         CALL CMQMUL( 2, N, NZ, NFREE, LDZY, UNITQ, KX, DX, ZY, WORK )
      END IF

*     ------------------------------------------------------------------
*     Compute the 2-norm of  DX.
*     Initialize  A*DX.
*     ------------------------------------------------------------------
      DXNORM  = DNRM2 ( N, DX, 1 )
      IF (NCQP .GT. 0)
     $   CALL DGEMV ( 'N', NCQP, N, ONE, AQP, LDAQP, DX, 1, ZERO,ADX,1)

      IF (NPDBG  .AND.  INPDBG(2) .GT. 0)
     $   WRITE (NOUT, 1200) (DX(J), J = 1, N)

      RETURN

 1200 FORMAT(/ ' //NPSETX// Variables after NPSETX ... '/ (5G12.3))

*     End of  NPSETX.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPSRCH( NEEDFD, INFORM, N, NCNLN,
     $                   LDCJ, LDCJU, NFUN, NGRAD,
     $                   NEEDC, CONFUN, OBJFUN,
     $                   ALFA, ALFBND, ALFMAX, ALFSML, DXNORM,
     $                   EPSRF, ETA, GDX, GRDALF, GLF1, GLF,
     $                   OBJF, OBJALF, QPCURV, XNORM,
     $                   C, C2, CJAC, CJACU, CJDX, CJDX2, 
     $                   CMUL1, CMUL, CS1, CS, DX, DLAM, DSLK, 
     $                   GRAD, GRADU, QPMUL, RHO, SLK1, SLK, X1, X, 
     $                   WORK, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      LOGICAL            NEEDFD
      INTEGER            NEEDC(*)
      DOUBLE PRECISION   DX(N), GRAD(N), GRADU(N), X1(N), X(N)
      DOUBLE PRECISION   C(*), C2(*), CJAC(LDCJ,*), CJACU(LDCJU,*), 
     $                   CJDX(*), CJDX2(*), CMUL1(*), CMUL(*)
      DOUBLE PRECISION   CS1(*), CS(*), DLAM(*), DSLK(*), QPMUL(*),
     $                   RHO(*), SLK1(*), SLK(*),  WORK(*)
      DOUBLE PRECISION   W(LENW)
      EXTERNAL           OBJFUN, CONFUN
                 
************************************************************************
*     NPSRCH finds the steplength ALFA that gives sufficient decrease in
*     the augmented Lagrangian merit function.
*
*     On exit,  if INFORM = 1, 2 or 3,  ALFA will be a nonzero steplength
*     with an associated merit function value  OBJALF  which is lower
*     than that at the base point. If  INFORM = 4, 5, 6 or 7,  ALFA  is
*     zero and  OBJALF will be the merit value at the base point.
*
*     Original version written  27-May-1985.
*     Level 2 BLAS added 12-June-1986.
*     This version of NPSRCH dated  10-May-1990. 
************************************************************************
      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET
      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      LOGICAL            NPDBG
      PARAMETER        ( LDBG = 5 )
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            DEBUG , DONE  , FIRST , IMPRVD
      EXTERNAL           DDOT  , DNRM2
      INTRINSIC          ABS   , MAX   , MIN   , SQRT
      PARAMETER        ( ZERO   =0.0D+0, HALF   =0.5D+0, ONE   =1.0D+0 )
      PARAMETER        ( TWO    =2.0D+0                                )
      PARAMETER        ( TOLG   =1.0D-1                                )

      EPSMCH = WMACH(3)

      IF (.NOT. NEEDFD  .AND.  NCNLN .GT. 0)
     $   CS1JDX = DDOT( NCNLN, CS1, 1, CJDX, 1 )

*     ------------------------------------------------------------------
*     Set the input parameters and tolerances for SRCHC and SRCHQ.
*
*     TOLRX   is the tolerance on relative changes in DX resulting from
*             changes in ALFA.
*
*     TOLAX   is the tolerance on absolute changes in DX resulting from
*             changes in ALFA.
*
*     TOLABS  is the tolerance on absolute changes in ALFA.
*
*     TOLREL  is the tolerance on relative changes in ALFA.
*
*     TOLTNY  is the magnitude of the smallest allowable value of ALFA.
*             If  M(TOLABS) - M(0) .gt. EPSAF,  the linesearch tries
*             steps in the range  TOLTNY .LE. ALFA .LE. TOLABS.
*     ------------------------------------------------------------------
      NSTATE = 0
      DEBUG  = NPDBG  .AND.  INPDBG(4) .GT. 0

      EPSAF  = EPSRF*(ONE + ABS( OBJALF ))

      TOLAX  = EPSPT8
      TOLRX  = EPSPT8

      TOLABS = ALFMAX
      IF (TOLRX*XNORM + TOLAX .LT. DXNORM*ALFMAX)
     $   TOLABS = (TOLRX*XNORM + TOLAX) /  DXNORM
      TOLREL = MAX( TOLRX , EPSMCH )

      T      = ZERO
      DO 10 J = 1, N
         S = ABS( DX(J) )
         Q = ABS( X(J) )*TOLRX + TOLAX
         IF (S .GT. T*Q) T = S / Q
   10 CONTINUE                                 

      TOLTNY = TOLABS
      IF (T*TOLABS .GT. ONE) TOLTNY = ONE / T

      OLDF   = OBJALF
      OLDG   = GRDALF

      IF (NCNLN .GT. 0) CALL ILOAD ( NCNLN, (1), NEEDC, 1 )

      MODE  = 2
      IF (NEEDFD) MODE = 0

      FIRST  = .TRUE.

*     ------------------------------------------------------------------
*     Commence main loop, entering SRCHC or SRCHQ two or more times.
*     FIRST = true for the first entry,  false for subsequent entries.
*     DONE  = true indicates termination, in which case the value of
*     INFORM gives the result of the search.
*     ------------------------------------------------------------------
*+    REPEAT
  100    IF (NEEDFD) THEN
            CALL SRCHQ ( DEBUG, DONE, FIRST, IMPRVD, INFORM,
     $                   ALFMAX, ALFSML, EPSAF, ETA,
     $                   XTRY, FTRY,       OLDF, OLDG,
     $                   TOLABS, TOLREL, TOLTNY,
     $                   ALFA, ALFBST, FBEST        )
         ELSE
            CALL SRCHC ( DEBUG, DONE, FIRST, IMPRVD, INFORM,
     $                   ALFMAX,         EPSAF, ETA,
     $                   XTRY, FTRY, GTRY, OLDF, OLDG,
     $                   TOLABS, TOLREL, TOLTNY,
     $                   ALFA, ALFBST, FBEST, GBEST )
         END IF

         IF (IMPRVD) THEN
            OBJF   = TOBJ
            OBJALF = FTRY

            IF (NCNLN .GT. 0)
     $         CALL DCOPY ( NCNLN, C2, 1, C, 1 )

            IF (.NOT. NEEDFD) THEN
               CALL DCOPY ( N, GRADU, 1, GRAD, 1 )
               GDX    = TGDX
               GLF    = TGLF

               IF (NCNLN .GT. 0) THEN
                  CALL DCOPY ( NCNLN, CJDX2, 1, CJDX, 1 )
                  CALL F06QFF( 'General', NCNLN, N, CJACU, LDCJU,
     $                         CJAC, LDCJ )
               END IF
            END IF
         END IF

*        ---------------------------------------------------------------
*        If DONE = FALSE,  the problem functions must be computed for
*        the next entry to SRCHC or SRCHQ.
*        If DONE = TRUE,   this is the last time through.
*        ---------------------------------------------------------------
         IF (.NOT. DONE) THEN

            NFUN  = NFUN  + 1
            IF (.NOT. NEEDFD) NGRAD = NGRAD + 1

            CALL DCOPY ( N,       X1, 1, X, 1 )
            CALL DAXPY ( N, ALFA, DX, 1, X, 1 )
            IF (NCNLN .GT. 0) THEN

*              Compute the new estimates of the multipliers and slacks.
*              If the step length is greater than one,  the multipliers
*              are fixed as the QP-multipliers.

               IF (ALFA .LE. ONE) THEN
                  CALL DCOPY ( NCNLN,       CMUL1, 1, CMUL, 1 )
                  CALL DAXPY ( NCNLN, ALFA, DLAM , 1, CMUL, 1 )
               END IF
               CALL DCOPY ( NCNLN,       SLK1, 1, SLK, 1 )
               CALL DAXPY ( NCNLN, ALFA, DSLK, 1, SLK, 1 )

*              ---------------------------------------------------------
*              Compute the new constraint vector and Jacobian.
*              ---------------------------------------------------------
               CALL CONFUN( MODE, NCNLN, N, LDCJU,
     $                      NEEDC, X, C2, CJACU, NSTATE )
               IF (MODE .LT. 0) GO TO 999

               CALL DCOPY ( NCNLN,         C2 , 1, CS, 1 )
               CALL DAXPY ( NCNLN, (-ONE), SLK, 1, CS, 1 )

               CALL DCOPY ( NCNLN, CS , 1,  WORK, 1 )
               CALL DDSCL ( NCNLN, RHO, 1,  WORK, 1 )

               FTERM  =            DDOT( NCNLN, CMUL, 1, CS, 1 ) -
     $                  HALF*SCALE*DDOT( NCNLN, WORK, 1, CS, 1 )
            END IF

*           ------------------------------------------------------------
*           Compute the value and gradient of the objective function.
*           ------------------------------------------------------------
            CALL OBJFUN( MODE, N, X, TOBJ, GRADU, NSTATE )
            IF (MODE .LT. 0) GO TO 999

            FTRY   = TOBJ
            IF (NCNLN .GT. 0) FTRY = TOBJ  - FTERM

*           ------------------------------------------------------------
*           Compute auxiliary gradient information.
*           ------------------------------------------------------------
            IF (.NOT. NEEDFD) THEN
               GTRY   = DDOT( N, GRADU, 1, DX, 1 )
               TGDX   = GTRY
               TGLF   = GTRY
               IF (NCNLN .GT. 0) THEN

*                 Compute the Jacobian times the search direction.

                  CALL DGEMV ( 'N', NCNLN, N, ONE, CJACU, LDCJU, DX, 1,
     $                         ZERO, CJDX2, 1 )

                  CALL DCOPY ( NCNLN,         CJDX2, 1, WORK, 1 )
                  CALL DAXPY ( NCNLN, (-ONE), DSLK , 1, WORK, 1 )

                  GTRY   = GTRY - DDOT( NCNLN, CMUL, 1, WORK, 1 )
                  IF (ALFA .LE. ONE)
     $               GTRY   = GTRY - DDOT( NCNLN, DLAM, 1, CS      , 1 )

                  CALL DDSCL ( NCNLN, RHO , 1, WORK, 1 )
                  GTRY = GTRY  +
     $                     SCALE*DDOT( NCNLN, WORK, 1, CS   , 1 )

                  TGLF = TGDX  - DDOT( NCNLN, CJDX2, 1, QPMUL, 1 )

*                 ------------------------------------------------------
*                 If ALFBND .LE. ALFA .LT. ALFMAX and the norm of the
*                 quasi-Newton update is bounded, set ALFMAX to be ALFA.
*                 This will cause the linesearch to stop if the merit
*                 function is decreasing at the boundary.
*                 ------------------------------------------------------
                  IF (ALFBND .LE. ALFA  .AND.  ALFA .LT. ALFMAX) THEN

                     CSJDX  = DDOT   ( NCNLN, CS, 1, CJDX2, 1 )

                     IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $                  WRITE (NOUT, 1400) CSJDX, CS1JDX, CURVLF

                     CURVLF = TGLF  - GLF1
                     CURVC  = ABS( CSJDX - CS1JDX )
                     RHOBFS = MAX( QPCURV*TOLG - CURVLF, ZERO )
                     IF (RHOBFS .LE. CURVC*RHOMAX) THEN
                        ALFMAX = ALFA
                     ELSE
                        ALFBND = MIN( TWO*ALFA, ALFMAX )
                     END IF
                     IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $                  WRITE(NOUT,1300) ALFBND, ALFA, ALFMAX
                  END IF
               END IF
            END IF
         END IF
*+    UNTIL (      DONE)
      IF    (.NOT. DONE) GO TO 100

      ALFA = ALFBST
      IF (.NOT. IMPRVD) THEN
         CALL DCOPY ( N,       X1, 1, X, 1 )
         CALL DAXPY ( N, ALFA, DX, 1, X, 1 )
         IF (NCNLN .GT. 0) THEN
            IF (ALFA .LE. ONE) THEN
               CALL DCOPY ( NCNLN,       CMUL1, 1, CMUL, 1 )
               CALL DAXPY ( NCNLN, ALFA, DLAM , 1, CMUL, 1 )
            END IF
            CALL DCOPY ( NCNLN,         SLK1 , 1, SLK, 1 )
            CALL DAXPY ( NCNLN,   ALFA, DSLK , 1, SLK, 1 )
            CALL DCOPY ( NCNLN,         C    , 1, CS , 1 )
            CALL DAXPY ( NCNLN, (-ONE), SLK  , 1, CS , 1 )
         END IF
      END IF

      IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $   WRITE (NOUT, 1200) INFORM

      RETURN

*     The user wants to stop.

  999 INFORM = MODE
      RETURN

 1200 FORMAT(/ ' //NPSRCH// INFORM  = ', I4 )
 1300 FORMAT(/ ' //NPSRCH//        ALFBND          ALFA        ALFMAX'
     $       / ' //NPSRCH//', 1P, 3E14.2 )
 1400 FORMAT(/ ' //NPSRCH//         CSJDX        CS1JDX        CURVLF'
     $       / ' //NPSRCH//', 1P, 3E14.2 )

*     End of  NPSRCH.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPUPDT( LSUMRY, UNITQ,
     $                   N, NCNLN, NFREE, NZ,
     $                   LDCJ1, LDCJ2, LDZY, LDR, KX,
     $                   ALFA, GLF1, GLF2, QPCURV,
     $                   CJAC1, CJAC2, CJDX1, CJDX2,
     $                   CS1, CS2, GQ1, GQ2, HPQ, RPQ,
     $                   QPMUL, R, OMEGA, ZY, WRK1, WRK2 )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      CHARACTER*5        LSUMRY
      LOGICAL            UNITQ
      INTEGER            KX(N)
      DOUBLE PRECISION   CJAC1(LDCJ1,*), CJAC2(LDCJ2,*),
     $                   CJDX1(*), CJDX2(*), CS1(*), CS2(*),
     $                   GQ1(N), GQ2(N), HPQ(N), RPQ(N), QPMUL(*),
     $                   R(LDR,*), OMEGA(*), ZY(LDZY,*)
      DOUBLE PRECISION   WRK1(N+NCNLN), WRK2(N)

************************************************************************
*     NPUPDT  computes the BFGS update for the approximate Hessian of
*     the Lagrangian.  If the approximate curvature of the Lagrangian
*     function is negative,  a nonnegative penalty vector OMEGA(i) of
*     minimum two norm is computed such that the approximate curvature
*     of the augmented Lagrangian will be positive. If no finite penalty
*     vector exists,  the BFGS update is performed with the approximate
*     curvature modified to be a small positive value.
*
*     On entry,  GQ1 and GQ2 contain the transformed objective gradients
*     at X1 and X2,  HPQ contains  R'R(pq), the transformed Hessian
*     times the transformed search direction.  The vectors GQ1 and HPQ
*     are not saved.  If the regular BFGS quasi-Newton update could not
*     be performed, the first character of LSUMRY is loaded with 'M'.
*
*     Systems Optimization Laboratory, Stanford University.
*     Original Fortran 66 version written April 1984.
*     Level 2 BLAS added 12-June-1986.
*     Level 2 matrix routines added 22-Apr-1988.
*     This version of NPUPTD dated  22-Apr-1988.
************************************************************************
      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL6CM/ RCNDBD, RFROBN, DRMAX, DRMIN

      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      LOGICAL            NPDBG
      PARAMETER        ( LDBG   = 5 )
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG

      LOGICAL            OVERFL, SSBFGS
      INTRINSIC          MAX   , MIN   , SQRT
      EXTERNAL           IDAMAX, DDIV  , DDOT  , DNRM2
      PARAMETER        ( ZERO   = 0.0D+0, ONE    = 1.0D+0 )
      PARAMETER        ( TOLG   = 1.0D-1                  )

      IF (NCNLN .GT. 0) CALL DLOAD ( NCNLN, ZERO, OMEGA, 1 )

*     ------------------------------------------------------------------
*     Set CURVL = (G2 - G1)'DX,  the approximate curvature along DX of
*     the (augmented) Lagrangian.  At first, the curvature is not scaled
*     by the steplength ALFA.
*     ------------------------------------------------------------------
      CURVL  = GLF2 -   GLF1
      TINYCL =        QPCURV * TOLG
      SSBFGS = CURVL .LE. ALFA*TINYCL
      IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $   WRITE (NOUT, 1000) SSBFGS, TINYCL, CURVL

*     ------------------------------------------------------------------
*     Test if CURVL is sufficiently positive.  If there are no nonlinear
*     constraints,  no update can be performed.
*     ------------------------------------------------------------------
      IF (CURVL  .LT. TINYCL) THEN
         LSUMRY(1:1) = 'Modified BFGS'
         IF (NCNLN .GT. 0) THEN
            QMAX = ZERO
            DO 200 I = 1, NCNLN
               QI  = CJDX2(I)*CS2(I) - CJDX1(I)*CS1(I)
               QMAX = MAX( QMAX, QI )
               IF (QI .LE. ZERO) WRK1(I) = ZERO
               IF (QI .GT. ZERO) WRK1(I) = QI
  200       CONTINUE

            QNORM = DNRM2 ( NCNLN, WRK1, 1 )

            TEST  = MAX( TINYCL - CURVL, ZERO )
            BETA  = DDIV  ( QMAX*TEST, QNORM*QNORM, OVERFL )
            IF (BETA .LT. RHOMAX  .AND.  .NOT. OVERFL) THEN
               LSUMRY(1:1) = ' '
               BETA  = TEST/(QNORM*QNORM)
               DO 210 I = 1, NCNLN
                  QI       = WRK1(I)
                  OMEGA(I) =            BETA*QI
                  CURVL    = CURVL    + BETA*QI*QI
  210          CONTINUE

               IF (NPDBG) THEN
                  IMAX = IDAMAX( NCNLN, OMEGA, 1 )
                  IF (INPDBG(1) .GT. 0)
     $               WRITE (NOUT, 1250) OMEGA(IMAX)

                  IF (INPDBG(2) .GT. 0)
     $               WRITE (NOUT, 1300) (OMEGA(I), I=1,NCNLN)
               END IF
            END IF
         END IF
      END IF

*     ------------------------------------------------------------------
*     Compute the difference in the augmented Lagrangian gradient.
*     ------------------------------------------------------------------
*     Update GQ1 to include the augmented Lagrangian terms.

      IF (NCNLN .GT. 0) THEN

         DO 310 I = 1, NCNLN
            WRK1(I) = - QPMUL(I) + OMEGA(I) * CS1(I)
  310    CONTINUE
         CALL DGEMV ( 'T', NCNLN, N, ONE, CJAC1, LDCJ1, WRK1, 1,
     $                ZERO, WRK2, 1 )

         DO 320 I = 1, NCNLN
            WRK1(I) =   QPMUL(I) - OMEGA(I) * CS2(I)
  320    CONTINUE
         CALL DGEMV ( 'T', NCNLN, N, ONE, CJAC2, LDCJ2, WRK1, 1,
     $                ONE, WRK2, 1 )

         CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ, KX, WRK2, ZY, WRK1 )
         CALL DAXPY ( N, ONE, WRK2, 1, GQ1, 1 )
      END IF

      IF (NPDBG  .AND.  INPDBG(1) .GT. 0)
     $   WRITE (NOUT, 1100) ALFA  , CURVL

      IF (CURVL .LT. TINYCL) CURVL  = TINYCL

      DO 330 J = 1, N
         WRK2(J) = GQ2(J) - GQ1(J)
  330 CONTINUE

      RTGTP  = SQRT(QPCURV)
      RTYTS  = SQRT(ALFA*CURVL)
      ETA    = ONE
      IF (SSBFGS)
     $   ETA = RTYTS / (RTGTP*ALFA)

      TRACE1 = DNRM2 ( N,  HPQ, 1 ) /  RTGTP
      TRACE2 = DNRM2 ( N, WRK2, 1 ) / (RTYTS*ETA)
      RFROBN = ETA*SQRT( ABS(  (RFROBN - TRACE1)*(RFROBN + TRACE1)
     $                                 + TRACE2**2) )

*     ==================================================================
*     Update the Cholesky factor of  Q'HQ.
*     ==================================================================
*     Normalize the vector  RPQ ( = R(pq) ).

      CALL DSCAL ( N, (ONE / RTGTP), RPQ, 1 )

*     Do the self-scaled or regular BFGS update.
*     Form the vector WRK1 = gamma * (GQ2 - GQ1) - beta * R'R*PQ,
*     where  gamma = 1/SQRT( CURV ) = 1/SQRT( (GQ2 - GQ1)'SQ )

      CALL DSCAL ( N, (ONE / RTGTP), HPQ, 1 )

      IF (SSBFGS) THEN
         DO 410 J   = 1, N
            CALL DSCAL ( J, ETA, R(1,J), 1 )
            WRK1(J) = WRK2(J)/RTYTS  -  ETA * HPQ(J)
  410    CONTINUE
      ELSE
         DO 420 J   = 1, N
            WRK1(J) = WRK2(J)/RTYTS  -        HPQ(J)
  420    CONTINUE
      END IF

*     Perform the update to  R = R + RPQ*WRK1'.
*     RPQ is overwritten. Arrays  GQ1  and  HPQ  are used to store the
*     sines and cosines defined by the plane rotations.

      CALL CMR1MD( N, 0, N, LDR, N, N, R, HPQ, RPQ, WRK1, GQ1, HPQ )

      RETURN

 1000 FORMAT(/ ' //NPUPDT// SSBFGS    min. CURVL         CURVL '
     $       / ' //NPUPDT//   ', L4, 1P, 2E14.2 )
 1100 FORMAT(/ ' //NPUPDT//          ALFA         CURVL '
     $       / ' //NPUPDT//', 1P, 2E14.2 )
 1250 FORMAT(/ ' //NPUPDT//   OMEGA(IMAX)'
     $       / ' //NPUPDT//', 1PE14.2 )
 1300 FORMAT(/ ' //NPUPDT//  Penalty parameters = '  / (1P, 5E15.6))

*     End of  NPUPDT.

      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      SUBROUTINE NPSOL ( N, NCLIN, NCNLN, LDA, LDCJU, LDR,
     $                   A, BL, BU,
     $                   CONFUN, OBJFUN,
     $                   INFORM, ITER, ISTATE,
     $                   C, CJACU, CLAMDA, OBJF, GRADU, R, X,
     $                   IW, LENIW, W, LENW )

      IMPLICIT           DOUBLE PRECISION(A-H,O-Z)
      EXTERNAL           CONFUN, OBJFUN
      INTEGER            ISTATE(N+NCLIN+NCNLN)
      INTEGER            IW(LENIW)
      DOUBLE PRECISION   A(LDA,*), BL(N+NCLIN+NCNLN),
     $                   BU(N+NCLIN+NCNLN)
      DOUBLE PRECISION   C(*), CJACU(LDCJU,*), CLAMDA(N+NCLIN+NCNLN)
      DOUBLE PRECISION   GRADU(N), R(LDR,*), X(N)
      DOUBLE PRECISION   W(LENW)

*-----------------------------------------------------------------------
*
*  NPSOL   solves the nonlinear programming problem
*
*            minimize                   F(x)
*
*                                    (    x  )
*            subject to    bl  .le.  (  A*x  )  .le.  bu
*                                    (  c(x) )
*
*  where  F(x)  is a smooth scalar function,  A  is a constant matrix
*  and  c(x)  is a vector of smooth nonlinear functions.  The feasible
*  region is defined by a mixture of linear and nonlinear equality or
*  inequality constraints on  x.
*
*  The dimensions of the problem are...
*
*  N        the number of variables (dimension of  x),
*
*  NCLIN    the number of linear constraints (rows of the matrix  A),
*
*  NCNLN    the number of nonlinear constraints (dimension of  c(x)),
*
*
*  NPSOL   uses a sequential quadratic programming algorithm, with a
*  positive-definite quasi-Newton approximation to the transformed
*  Hessian  Q'HQ  of the Lagrangian function (which will be stored in
*  the array  R).
*
*
*  Complete documentation for  NPSOL  is contained in Report
*  SOL 86-2, Users guide for NPSOL (Version 4.0), by P.E. Gill,
*  W. Murray, M.A. Saunders and M.H. Wright, Department of Operations
*  Research,  Stanford University, Stanford, California 94305.
*
*  Systems Optimization Laboratory, Stanford University.
*  Version 1.1,  April     12, 1983. (The less said about this one.....)
*  Version 2.0,  April     30, 1984.
*  Version 3.0,  March     20, 1985. (First Fortran 77 version).
*  Version 3.2,  August    20, 1985.
*  Version 4.0,  April     16, 1986. (First version with differences).
*  Version 4.01, June      30, 1986. (Level 2 BLAS + F77 linesearch).
*  Version 4.02, August     5, 1986. (Reset SSBFGS. One call to CHFD).
*  Version 4.03, June      14, 1987. (Step limit).
*  Version 4.04, June      28, 1989. (Vectorizable BLAS).
*  Version 4.05, November  28, 1989. (Load and save files added).
*
*  Copyright  1983  Stanford University.
*
*  This material may be reproduced by or for the U.S. Government pursu-
*  ant to the copyright license under DAR Clause 7-104.9(a) (1979 Mar).
*
*  This material is based upon work partially supported by the National
*  Science Foundation under Grants MCS-7926009 and ECS-8312142; the
*  Department of Energy Contract AM03-76SF00326, PA No. DE-AT03-
*  76ER72018; the Army Research Office Contract DAA29-84-K-0156;
*  and the Office of Naval Research Grant N00014-75-C-0267.
*  ---------------------------------------------------------------------

*  Common blocks.

*-----------------------------------------------------------------------
      PARAMETER         (MXPARM = 30)
      INTEGER            IPRMLS(MXPARM), IPSVLS
      DOUBLE PRECISION   RPRMLS(MXPARM), RPSVLS

      COMMON    /LSPAR1/ IPSVLS(MXPARM),
     $                   IDBGLS, ITMAX1, ITMAX2, LCRASH, LDBGLS, LPROB ,
     $                   MSGLS , NN    , NNCLIN, NPROB , IPADLS(20)

      COMMON    /LSPAR2/ RPSVLS(MXPARM),
     $                   BIGBND, BIGDX , BNDLOW, BNDUPP, TOLACT, TOLFEA,
     $                   TOLRNK, RPADLS(23)

      EQUIVALENCE       (IPRMLS(1), IDBGLS), (RPRMLS(1), BIGBND)

      SAVE      /LSPAR1/, /LSPAR2/
*-----------------------------------------------------------------------
*-----INCLUDE NPPARM----------------------------------------------------
      INTEGER            IPRMNP(MXPARM), IPSVNP
      DOUBLE PRECISION   RPRMNP(MXPARM), RPSVNP

      COMMON    /NPPAR1/ IPSVNP(MXPARM),
     $                   IDBGNP, ITMXNP, JVRFY1, JVRFY2, JVRFY3, JVRFY4,
     $                   LDBGNP, LFORMH, LVLDER, LVERFY, MSGNP , NLNF  ,
     $                   NLNJ  , NLNX  , NNCNLN, NSAVE , NLOAD , KSAVE ,
     $                   IPADNP(12)

      COMMON    /NPPAR2/ RPSVNP(MXPARM),
     $                   CDINT , CTOL  , DXLIM , EPSRF , ETA   , FDINT ,
     $                   FTOL  , HCNDBD, RPADNP(22)

      EQUIVALENCE       (IPRMNP(1), IDBGNP), (RPRMNP(1), CDINT)

      SAVE      /NPPAR1/, /NPPAR2/
*-----------------------------------------------------------------------
      EQUIVALENCE  (IDBGNP, IDBG  ), (ITMXNP, NMAJOR), (ITMAX2, NMINOR)
      EQUIVALENCE  (LDBGLS, MNRDBG), (LDBGNP, MJRDBG), (MSGLS , MSGQP )

      DOUBLE PRECISION   WMACH
      COMMON    /SOLMCH/ WMACH(15)
      SAVE      /SOLMCH/

      COMMON    /SOL1CM/ NOUT
      COMMON    /SOL3CM/ LENNAM, LDT   , NCOLT , LDZY
      COMMON    /SOL4CM/ EPSPT3, EPSPT5, EPSPT8, EPSPT9
      COMMON    /SOL5CM/ ASIZE , DTMAX , DTMIN
      COMMON    /SOL6CM/ RCNDBD, RFROBN, DRMAX , DRMIN

      LOGICAL            UNITQ
      COMMON    /SOL1SV/ NACTIV, NFREE , NZ   , UNITQ
      SAVE      /SOL1SV/

      PARAMETER         (LENLS = 20)
      COMMON    /SOL1LS/ LOCLS(LENLS)

      PARAMETER         (LENNP = 35)
      COMMON    /SOL1NP/ LOCNP(LENNP)
      COMMON    /SOL4NP/ LVLDIF, NCDIFF, NFDIFF, LFDSET
      COMMON    /SOL5NP/ LVRFYC, JVERFY(4)
      LOGICAL            INCRUN
      COMMON    /SOL6NP/ RHOMAX, RHONRM, RHODMP, SCALE, INCRUN

      LOGICAL            CMDBG, LSDBG, NPDBG
      PARAMETER         (LDBG = 5)
      COMMON    /NPDEBG/ INPDBG(LDBG), NPDBG
      COMMON    /LSDEBG/ ILSDBG(LDBG), LSDBG
      COMMON    /CMDEBG/ ICMDBG(LDBG), CMDBG

      INTRINSIC          ABS   , MAX   , MIN   , MOD   , SQRT  , REAL

*     Local variables.

      EXTERNAL           DDIV  , DDOT  , DNORM , DNRM2
      CHARACTER*8        NAMES(1)
      LOGICAL            COLD  , LINOBJ, NAMED , OVERFL, ROWERR, VERTEX
      LOGICAL            NEEDFD
      PARAMETER         (ZERO   =0.0D+0, POINT1 =0.1D+0, POINT3 =3.3D-1)
      PARAMETER         (POINT8 =0.8D+0, POINT9 =0.9D+0, ONE    =1.0D+0)
      PARAMETER         (GROWTH =1.0D+2                                )

      CHARACTER*36       TITLE
      DATA               TITLE
     $                 / 'NPSOL  ---  Version 4.05   Nov  1989' /

*     Set the machine-dependent constants.

      CALL MCHPAR()

      EPSMCH = WMACH( 3)
      RTEPS  = WMACH( 4)
      NOUT   = WMACH(11)

      EPSPT3 = EPSMCH**POINT3
      EPSPT5 = RTEPS
      EPSPT8 = EPSMCH**POINT8
      EPSPT9 = EPSMCH**POINT9

      RHOMAX = ONE/EPSMCH
      ROOTN  = SQRT(REAL(N))

*     Default names will be provided for variables during printing.

      NAMED  = .FALSE.
      INFORM = 0

*     Set the default values for the parameters.

      CALL NPDFLT( N, NCLIN, NCNLN, LENIW, LENW, TITLE )

      NEEDFD = LVLDER .EQ. 0  .OR.  LVLDER .EQ. 2
     $                        .OR. (LVLDER .EQ. 1  .AND.  NCNLN .GT. 0)
      COLD   = LCRASH .EQ. 0
      LVLDIF = 0
      IF (NEEDFD) LVLDIF = 1

      NPLIN  = N     + NCLIN
      NCTOTL = NPLIN + NCNLN

*     Assign the dimensions of arrays in the parameter list of NPCORE.
*     Economies of storage are possible if the minimum number of active
*     constraints and the minimum number of fixed variables are known in
*     advance.  The expert user should alter MINACT and MINFXD
*     accordingly.

      MINACT = 0
      MINFXD = 0

      MXFREE = N - MINFXD
      MAXACT = MAX( 1, MIN( N, NCLIN ) )
      MAXNZ  = N - ( MINFXD + MINACT )

      IF (NCLIN + NCNLN .EQ. 0) THEN
         LDZY  = 1
         LDT   = 1
         NCOLT = 1
      ELSE
         LDZY  = MAX( 1, MXFREE )
         LDT   = MAX( MAXNZ, MAXACT )
         NCOLT = MXFREE
      END IF

      LENNAM = 1

      LDAQP = MAX( NCLIN+NCNLN, 1 )
      IF (NCNLN .EQ. 0  .AND.  NCLIN .GT. 0) LDAQP = LDA

*     NPLOC  defines the arrays that contain the locations of various
*     work arrays within  W  and  IW.

      LITOTL = 0
      LWTOTL = 0
      CALL NPLOC( N, NCLIN, NCNLN, NCTOTL, LITOTL, LWTOTL)

*     Allocate certain addresses that are not allocated in NPLOC.

      LAX    = LWTOTL + 1
      LWTOTL = LAX    + NCLIN - 1
      LAX    = MIN( LAX, LWTOTL )

*     Check input parameters and storage limits.

      CALL CMCHK ( NERROR, MSGNP, LCRASH, .FALSE.,
     $             LENIW, LENW, LITOTL, LWTOTL,
     $             N, NCLIN, NCNLN,
     $             ISTATE, IW, NAMED, NAMES, LENNAM,
     $             BL, BU, X )

      IF (NERROR .GT. 0) THEN
         INFORM = 9
         GO TO 800
      END IF

      LKACTV = LOCLS( 1)
      LANORM = LOCLS( 2)
      LCJDX  = LOCLS( 3)
      LRES   = LOCLS( 5)
      LRES0  = LOCLS( 6)
      LGQ    = LOCLS( 9)
      LRLAM  = LOCLS(10)
      LT     = LOCLS(11)
      LZY    = LOCLS(12)
      LWTINF = LOCLS(13)
      LWRK1  = LOCLS(14)

      LKX    = LOCNP( 1)
      LIPERM = LOCNP( 2)
      LAQP   = LOCNP( 3)
      LDX    = LOCNP( 7)
      LFEATL = LOCNP(10)
      LWRK2  = LOCNP(12)

      LCMUL  = LOCNP(16)
      LRHO   = LOCNP(20)
      LWRK3  = LOCNP(21)
      LNEEDC = LOCNP(24)
      LHFRWD = LOCNP(25)
      LHCTRL = LOCNP(26)
      LCJAC  = LOCNP(27)
      LGRAD  = LOCNP(28)

      LDCJ  = MAX ( NCNLN, 1 )

      TOLRNK = ZERO
      RCNDBD = SQRT( HCNDBD )

*     ==================================================================
*     If a unit number for a load file has been set, read initial values
*     from an old run.  These values override existing settings. 
*     ==================================================================
      IF (NLOAD .GT. 0) THEN
         CALL NPGETR( NERROR, UNITQ, N, NCLIN, NCNLN, LDR, LDZY,
     $                NFREE0, ITER, ISTATE, IW(LKX),
     $                W(LHFRWD), W(LHCTRL),
     $                W(LCMUL), R, W(LRHO), X, W(LZY) )

         IF (NERROR .GT. 0) THEN
            INFORM = 9
            GO TO 800
         END IF
      END IF

*     ==================================================================
*     Load the arrays of feasibility tolerances.
*     ==================================================================
      IF (TOLFEA .GT. ZERO)
     $   CALL DLOAD ( NPLIN, TOLFEA, W(LFEATL), 1 )

      IF (NCNLN .GT. 0  .AND.  CTOL .GT. ZERO)
     $   CALL DLOAD ( NCNLN, CTOL, W(LFEATL+NPLIN), 1 )

      IF (LFDSET .EQ. 0) THEN
         FDCHK = SQRT( EPSRF )
      ELSE IF (LFDSET .EQ. 1) THEN
         FDCHK = FDINT
      ELSE
         FDCHK = W(LHFRWD)
      END IF

      NFUN   = 0
      NGRAD  = 0
      NSTATE = 1

*     ------------------------------------------------------------------
*     If required,  compute the problem functions.
*     If the constraints are nonlinear,  the first call of CONFUN
*     sets up any constant elements in the Jacobian matrix.  A copy of
*     the Jacobian (with constant elements set) is placed in  CJACU.
*     ------------------------------------------------------------------
      IF (LVERFY .GE. 10) THEN
         XNORM  = DNRM2 ( N, X, 1 )
         LVRFYC = LVERFY - 10

         CALL NPCHKD( INFO, MSGNP, NSTATE, LVLDER, NFUN, NGRAD,
     $                LDCJ, LDCJU, N, NCNLN,
     $                CONFUN, OBJFUN, IW(LNEEDC),
     $                BIGBND, EPSRF, CDINT, FDINT,
     $                FDCHK, FDNORM, OBJF, XNORM,
     $                BL, BU, C, W(LWRK3), W(LCJAC), CJACU, W(LCJDX),
     $                W(LDX), W(LGRAD), GRADU, W(LHFRWD), W(LHCTRL),
     $                X, W(LWRK1), W(LWRK2), W, LENW )

         IF (INFO .NE. 0) THEN
            IF (INFO .GT. 0) INFORM = 7
            IF (INFO .LT. 0) INFORM = INFO
            GO TO 800
         END IF
         NSTATE = 0
      END IF

      CALL ICOPY ( LDBG, ILSDBG, 1, ICMDBG, 1 )

      IF (NCLIN .GT. 0) THEN
         IANRMJ = LANORM
         DO 110, J = 1, NCLIN
            W(IANRMJ) = DNRM2 ( N, A(J,1), LDA )
            IANRMJ    = IANRMJ + 1
  110    CONTINUE
         CALL DCOND ( NCLIN, W(LANORM), 1, ASIZE, AMIN )
      END IF

      CALL DCOND ( NPLIN, W(LFEATL), 1, FEAMAX, FEAMIN )
      CALL DCOPY ( NPLIN, W(LFEATL), 1, W(LWTINF), 1 )
      CALL DSCAL ( NPLIN, (ONE/FEAMIN), W(LWTINF), 1 )

*     ==================================================================
*     The input values of X and (optionally)  ISTATE are used by
*     LSCRSH  to define an initial working set.
*     ==================================================================
      VERTEX = .FALSE.
      CALL LSCRSH( COLD, VERTEX,
     $             NCLIN, NPLIN, NACTIV, NARTIF,
     $             NFREE, N, LDA,
     $             ISTATE, IW(LKACTV),
     $             BIGBND, TOLACT,
     $             A, W(LAX), BL, BU, X, W(LWRK1), W(LWRK2) )

      NRES   = 0
      NGQ    = 0
      CONDMX = ONE / EPSPT5

      IF (LCRASH .LE. 1) THEN
*        ===============================================================
*        Cold or warm start. The upper-triangular matrix R is the factor
*        of an approximate Lagrangian Hessian.
*        ===============================================================
         UNITQ  = .TRUE.
         ITER   = 0

         IKX    = LKX
         DO 120, I = 1, N
            IW(IKX) = I
            IKX     = IKX + 1
  120    CONTINUE

         IF (COLD) THEN
            CALL F06QHF( 'Upper-triangular', N, N, ZERO, ONE, R, LDR )
            RFROBN = ROOTN

            NRANK  = 0
            IF (NCNLN .GT. 0) CALL DLOAD ( NCNLN, (ZERO), W(LCMUL), 1 )
         ELSE

*           R will be updated while finding a feasible x.

            NRANK  = NLNX
            CALL DLOAD ( NLNX, (ZERO), W(LRES0), 1 )
            IF (NCNLN .GT. 0)
     $         CALL DCOPY ( NCNLN, CLAMDA(NPLIN+1), 1, W(LCMUL), 1 )

         END IF

         INCRUN = .TRUE.
         RHONRM =  ZERO
         RHODMP =  ONE
         SCALE  =  ONE
         CALL DLOAD ( NCNLN, (ZERO), W(LRHO), 1 )

*        ---------------------------------------------------------------
*        Re-order KX so that the free variables come first.
*        If a warm start is required, NRANK will be nonzero and the
*        factor R will be updated.
*        ---------------------------------------------------------------
         CALL LSBNDS( UNITQ,
     $                INFORM, NZ, NFREE, NRANK, NRES, NGQ,
     $                N, LDZY, LDA, LDR, LDT,
     $                ISTATE, IW(LKX), CONDMX,
     $                A, R, W(LT), W(LRES0), W(LGQ), W(LZY),
     $                W(LWRK1), W(LWRK2), W(LRLAM) )             

      ELSE
*        ===============================================================
*        Hot start.
*        Stop if the computed and input values of nfree don't match.
*        ===============================================================
         IF (NFREE0 .NE. NFREE) THEN
            NERROR = 1
            INFORM = 9
            GO TO 800
         END IF
      END IF

*     ------------------------------------------------------------------
*     Factorize the linear constraints in the initial working set.
*     ------------------------------------------------------------------
      IF (NACTIV .GT. 0) THEN
         NACT1  = NACTIV
         NACTIV = 0

         CALL LSADDS( UNITQ, VERTEX,
     $                INFORM, 1, NACT1, NACTIV, NARTIF, NZ, NFREE,
     $                NRANK, NREJTD, NRES, NGQ,
     $                N, LDZY, LDA, LDR, LDT,
     $                ISTATE, IW(LKACTV), IW(LKX), CONDMX,
     $                A, R, W(LT), W(LRES0), W(LGQ), W(LZY),
     $                W(LWRK1), W(LWRK2), W(LRLAM) )
      END IF

      IF (LCRASH .LE. 1) THEN
*        ===============================================================
*        Cold or warm start.  Move  x  on to the linear constraints and
*        find a feasible point.
*        ===============================================================
         SSQ1   =  ZERO
         LINOBJ = .FALSE.
         CALL LSSETX( LINOBJ, ROWERR, UNITQ,
     $                NCLIN, NACTIV, NFREE, NRANK, NZ,
     $                N, NPLIN, LDZY, LDA, LDR, LDT,
     $                ISTATE, IW(LKACTV), IW(LKX),
     $                JMAX, ERRMAX, CTX, XNORM,
     $                A, W(LAX), BL, BU, W(LGQ), W(LRES), W(LRES0),
     $                W(LFEATL), R, W(LT), X, W(LZY),W(LWRK1),W(LWRK2) )

*        ---------------------------------------------------------------
*        Call  LSCORE  to find a feasible  x.
*        ---------------------------------------------------------------
*        Use  WORK2  as the multiplier vector.

         JINF   = 0
         LCLAM  = LWRK2

         IDBGSV = IDBG
         IF (IDBG .GT. 0) THEN
            IDBG = NMINOR + 1
         END IF

         CALL LSCORE( 'FP problem', NAMED, NAMES, LINOBJ, UNITQ,
     $                NLPERR, ITNS, JINF, NCLIN, NPLIN,
     $                NACTIV, NFREE, NRANK, NZ, NZ1,
     $                N, LDA, LDR,
     $                ISTATE, IW(LKACTV), IW(LKX),
     $                CTX, OBJ, SSQ1, SUMINF, NUMINF, XNORM,
     $                BL, BU, A, W(LCLAM), W(LAX),
     $                W(LFEATL), R, X, IW, W )

         IF (NLPERR .GT. 0) THEN
            INFORM = 2
            GO TO 800
         END IF

         IDBG  = IDBGSV
         CALL ICOPY ( LDBG, INPDBG, 1, ICMDBG, 1 )
      ELSE
*        ---------------------------------------------------------------
*        Hot start.
*        The point  x  is preassigned.  Compute the 2-norm of  x.
*        Initialize  Ax  for the linear constraints.
*        ---------------------------------------------------------------
         NRANK  = NLNX
         XNORM  = DNRM2 ( N, X, 1 )
         IF (NCLIN .GT. 0)
     $      CALL DGEMV ( 'N', NCLIN, N, ONE, A, LDA,
     $                   X, 1, ZERO, W(LAX), 1 )
      END IF

      IF (LCRASH .GT. 0) THEN

*        Check for a bad R.

         RFROBN = F06QGF( 'Frobenius norm', 'Upper', N, N, R, LDR )
         CALL DCOND ( N, R, LDR+1, DRMAX, DRMIN )
         COND   = DDIV  ( DRMAX, DRMIN, OVERFL )

         IF (      COND   .GT. RCNDBD
     $       .OR.  RFROBN .GT. ROOTN*GROWTH*DRMAX) THEN
*           ------------------------------------------------------------
*           Refactorize the Hessian and bound the condition estimator.
*           ------------------------------------------------------------
            WRITE( NOUT, 9000 )
            CALL NPRSET( UNITQ,
     $                   N, NFREE, NZ, LDZY, LDR,
     $                   IW(LIPERM), IW(LKX),
     $                   W(LGQ), R, W(LZY), W(LWRK1), W(LRES0) )
         END IF
      END IF

*     ==================================================================
*     Now we can check the gradients at a feasible x.
*     ==================================================================
      LVRFYC = LVERFY
      IF (LVERFY .GE. 10) LVRFYC = -1

      CALL NPCHKD( INFO, MSGNP, NSTATE, LVLDER, NFUN, NGRAD,
     $             LDCJ, LDCJU, N, NCNLN,
     $             CONFUN, OBJFUN, IW(LNEEDC),
     $             BIGBND, EPSRF, CDINT, FDINT,
     $             FDCHK, FDNORM, OBJF, XNORM,
     $             BL, BU, C, W(LWRK3), W(LCJAC), CJACU, W(LCJDX),
     $             W(LDX), W(LGRAD), GRADU, W(LHFRWD), W(LHCTRL),
     $             X, W(LWRK1), W(LWRK2), W, LENW )

      IF (INFO .NE. 0) THEN
         IF (INFO .GT. 0) INFORM = 7
         IF (INFO .LT. 0) INFORM = INFO
         GO TO 800
      END IF

      CALL DCOPY ( N, W(LGRAD), 1, W(LGQ), 1 )
      CALL CMQMUL( 6, N, NZ, NFREE, LDZY, UNITQ,
     $             IW(LKX), W(LGQ), W(LZY), W(LWRK1) )

*     ==================================================================
*     Solve the problem.
*     ==================================================================
      IF (NCNLN .EQ. 0) THEN
*        ---------------------------------------------------------------
*        The problem has only linear constraints and bounds.
*        ---------------------------------------------------------------
         CALL NPCORE( NAMED, NAMES, UNITQ, INFORM, ITER,
     $                N, NCLIN, NCNLN, NCTOTL, NACTIV, NFREE, NZ,
     $                LDA, LDCJ, LDCJU, LDAQP, LDR,
     $                NFUN, NGRAD, ISTATE, IW(LKACTV), IW(LKX),
     $                OBJF, FDNORM, XNORM, CONFUN, OBJFUN,
     $                A, W(LAX), BL, BU, C, W(LCJAC), CJACU, CLAMDA,
     $                W(LFEATL), W(LGRAD), GRADU, R, X, IW, W, LENW )
      ELSE
*        ---------------------------------------------------------------
*        The problem has some nonlinear constraints.
*        ---------------------------------------------------------------
         IF (NCLIN .GT. 0)
     $      CALL F06QFF( 'General', NCLIN, N, A, LDA, W(LAQP), LDAQP )

*        Try and add some nonlinear constraint indices to KACTIV.
*
         CALL NPCRSH( COLD, N, NCLIN, NCNLN,
     $                NCTOTL, NACTIV, NFREE, NZ,
     $                ISTATE, IW(LKACTV), BIGBND, TOLACT,
     $                BL, BU, C )

         CALL NPCORE( NAMED, NAMES, UNITQ, INFORM, ITER,
     $                N, NCLIN, NCNLN, NCTOTL, NACTIV, NFREE, NZ,
     $                LDA, LDCJ, LDCJU, LDAQP, LDR,
     $                NFUN, NGRAD, ISTATE, IW(LKACTV),IW(LKX),
     $                OBJF, FDNORM, XNORM, CONFUN, OBJFUN,
     $                W(LAQP), W(LAX), BL, BU, C, W(LCJAC),CJACU,CLAMDA,
     $                W(LFEATL), W(LGRAD), GRADU, R, X, IW, W, LENW )

      END IF

*     ==================================================================
*     If a unit number for a save file has been set, save the details of
*     this run.
*     ==================================================================
      IF (NSAVE .GT. 0  .AND.  KSAVE .GT. NMAJOR) THEN
         CALL NPSAVR( UNITQ, N, NCLIN, NCNLN, LDR, LDZY,
     $                NFREE, NSAVE, ITER, ISTATE, IW(LKX),
     $                W(LHFRWD), W(LHCTRL),
     $                W(LCMUL), R, W(LRHO), X, W(LZY) )
      END IF

*     ------------------------------------------------------------------
*     If required, form the triangular factor of the Hessian.
*     ------------------------------------------------------------------
*     First,  form the square matrix  R  such that  H = R'R.
*     Compute the  QR  factorization of  R.

      IF (LFORMH .GT. 0) THEN
         LV     = LWRK2
         DO 400 J = 1, N
            IF (J .GT. 1)
     $         CALL DLOAD ( J-1, ZERO, W(LV), 1 )

            LVJ = LV + J - 1
            CALL DCOPY ( N-J+1, R(J,J), LDR, W(LVJ), 1     )
            CALL CMQMUL( 3, N, NZ, NFREE, LDZY, UNITQ,
     $                   IW(LKX), W(LV), W(LZY), W(LWRK1) )
            CALL DCOPY ( N    , W(LV) , 1    , R(J,1), LDR )
  400    CONTINUE

         CALL DGEQR ( N, N, R, LDR, W(LWRK1), INFO )
      END IF

*     ==================================================================
*     Print messages if required.
*     ==================================================================
  800 IF (MSGNP .GT.   0) THEN
         IF (INFORM .LT.   0) WRITE (NOUT, 3000)
         IF (INFORM .EQ.   0) WRITE (NOUT, 4000)
         IF (INFORM .EQ.   1) WRITE (NOUT, 4100)
         IF (INFORM .EQ.   2) WRITE (NOUT, 4200)
         IF (INFORM .EQ.   3) WRITE (NOUT, 4300)
         IF (INFORM .EQ.   4) WRITE (NOUT, 4400)
         IF (INFORM .EQ.   5) WRITE (NOUT, 4500)
         IF (INFORM .EQ.   6) WRITE (NOUT, 4600)
         IF (INFORM .EQ.   7) WRITE (NOUT, 4700)
         IF (INFORM .EQ.   9) WRITE (NOUT, 4900) NERROR

         IF (INFORM .GE. 0  .AND.  INFORM .LT. 7) THEN
            IF (NLPERR .EQ. 0) THEN
               WRITE (NOUT, 5000) OBJF
            ELSE
               IF (NLPERR .EQ. 3) THEN
                  WRITE (NOUT, 5010) SUMINF
               ELSE
                  WRITE (NOUT, 5020) SUMINF
               END IF
            END IF
         END IF
      END IF

*     Recover the optional parameters set by the user.
*     Load the final constraint and objective gradients.

      CALL ICOPY ( MXPARM, IPSVLS, 1, IPRMLS, 1 )
      CALL DCOPY ( MXPARM, RPSVLS, 1, RPRMLS, 1 )
      CALL ICOPY ( MXPARM, IPSVNP, 1, IPRMNP, 1 )
      CALL DCOPY ( MXPARM, RPSVNP, 1, RPRMNP, 1 )

      IF (NCNLN .GT. 0) THEN
         CALL F06QFF( 'General', NCNLN, N, W(LCJAC), LDCJ, CJACU, LDCJU)
      END IF
      CALL DCOPY ( N, W(LGRAD), 1, GRADU, 1 )

      RETURN

 3000 FORMAT(/ ' Exit NPSOL - User requested termination.'          )
 4000 FORMAT(/ ' Exit NPSOL - Optimal solution found.'              )
 4100 FORMAT(/ ' Exit NPSOL - Optimal solution found, ',
     $         ' but the requested accuracy could not be achieved.' )
 4200 FORMAT(/ ' Exit NPSOL - No feasible point for the linear',
     $         ' constraints.')
 4300 FORMAT(/ ' Exit NPSOL - No feasible point for the nonlinear',
     $         ' constraints.')
 4400 FORMAT(/ ' Exit NPSOL - Too many major iterations.             ')
 4500 FORMAT(/ ' Exit NPSOL - Problem is unbounded (or badly scaled).')
 4600 FORMAT(/ ' Exit NPSOL - Current point cannot be improved upon. ')
 4700 FORMAT(/ ' Exit NPSOL - Large errors found in the derivatives. ')

 4900 FORMAT(/ ' Exit NPSOL - ', I10, ' errors found in the input',
     $         ' parameters.  Problem abandoned.')
 5000 FORMAT(/ ' Final nonlinear objective value =', G16.7 )
 5010 FORMAT(/ ' Minimum sum of infeasibilities =',  G16.7 )
 5020 FORMAT(/ ' Final sum of infeasibilities =',    G16.7 )

 9000 FORMAT(  ' XXX  Bad initial Hessian,   R  refactorized.' )

*     End of  NPSOL .

      END

#! /bin/sh
#set -v
test -f detail.dat   && mv -f detail.dat    detail.bak
test -f summary.dat  && mv -f summary.dat   summary.bak
test -f error        && mv -f error         error.bak
test -f output       && mv -f output        output.bak
cp null.dat    detail.dat
cp null.dat    summary.dat
nlmix >output 2>error
grep -i error detail.dat >> error
